#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 3400
#define LARGE_STATE_COUNT 681
#define SYMBOL_COUNT 324
#define ALIAS_COUNT 8
#define TOKEN_COUNT 150
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 36
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 203

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_typeof = 12,
  anon_sym_type = 13,
  anon_sym_interface = 14,
  anon_sym_declare = 15,
  anon_sym_global = 16,
  anon_sym_module = 17,
  anon_sym_DOT = 18,
  anon_sym_COLON = 19,
  anon_sym_import = 20,
  anon_sym_const = 21,
  anon_sym_enum = 22,
  anon_sym_from = 23,
  anon_sym_var = 24,
  anon_sym_let = 25,
  anon_sym_BANG = 26,
  anon_sym_else = 27,
  anon_sym_if = 28,
  anon_sym_switch = 29,
  anon_sym_for = 30,
  anon_sym_LPAREN = 31,
  anon_sym_RPAREN = 32,
  anon_sym_await = 33,
  anon_sym_in = 34,
  anon_sym_of = 35,
  anon_sym_while = 36,
  anon_sym_do = 37,
  anon_sym_try = 38,
  anon_sym_with = 39,
  anon_sym_break = 40,
  anon_sym_continue = 41,
  anon_sym_debugger = 42,
  anon_sym_return = 43,
  anon_sym_throw = 44,
  anon_sym_SEMI = 45,
  anon_sym_case = 46,
  anon_sym_catch = 47,
  anon_sym_finally = 48,
  anon_sym_yield = 49,
  anon_sym_LBRACK = 50,
  anon_sym_RBRACK = 51,
  anon_sym_class = 52,
  anon_sym_async = 53,
  anon_sym_function = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_abstract = 56,
  anon_sym_get = 57,
  anon_sym_set = 58,
  anon_sym_QMARK = 59,
  anon_sym_implements = 60,
  anon_sym_extends = 61,
  anon_sym_QMARK_DOT = 62,
  anon_sym_new = 63,
  anon_sym_PLUS_EQ = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_STAR_EQ = 66,
  anon_sym_SLASH_EQ = 67,
  anon_sym_PERCENT_EQ = 68,
  anon_sym_CARET_EQ = 69,
  anon_sym_AMP_EQ = 70,
  anon_sym_PIPE_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_GT_GT_GT_EQ = 73,
  anon_sym_LT_LT_EQ = 74,
  anon_sym_STAR_STAR_EQ = 75,
  anon_sym_AMP_AMP_EQ = 76,
  anon_sym_PIPE_PIPE_EQ = 77,
  anon_sym_QMARK_QMARK_EQ = 78,
  anon_sym_DOT_DOT_DOT = 79,
  anon_sym_AMP_AMP = 80,
  anon_sym_PIPE_PIPE = 81,
  anon_sym_GT_GT = 82,
  anon_sym_GT_GT_GT = 83,
  anon_sym_LT_LT = 84,
  anon_sym_AMP = 85,
  anon_sym_CARET = 86,
  anon_sym_PIPE = 87,
  anon_sym_PLUS = 88,
  anon_sym_DASH = 89,
  anon_sym_SLASH = 90,
  anon_sym_PERCENT = 91,
  anon_sym_STAR_STAR = 92,
  anon_sym_LT = 93,
  anon_sym_LT_EQ = 94,
  anon_sym_EQ_EQ = 95,
  anon_sym_BANG_EQ = 96,
  anon_sym_GT_EQ = 97,
  anon_sym_GT = 98,
  anon_sym_QMARK_QMARK = 99,
  anon_sym_instanceof = 100,
  anon_sym_TILDE = 101,
  anon_sym_void = 102,
  anon_sym_delete = 103,
  anon_sym_PLUS_PLUS = 104,
  anon_sym_DASH_DASH = 105,
  anon_sym_DQUOTE = 106,
  aux_sym_string_token1 = 107,
  anon_sym_SQUOTE = 108,
  aux_sym_char_token1 = 109,
  sym_escape_sequence = 110,
  sym_comment = 111,
  anon_sym_BQUOTE = 112,
  anon_sym_DOLLAR_LBRACE = 113,
  anon_sym_SLASH2 = 114,
  sym_regex_pattern = 115,
  sym_regex_flags = 116,
  sym_float_literal = 117,
  sym_hex_literal = 118,
  sym_int_literal = 119,
  sym_binary_literal = 120,
  sym_octal_literal = 121,
  sym_bigint_literal = 122,
  anon_sym_target = 123,
  sym_this = 124,
  sym_super = 125,
  sym_true = 126,
  sym_false = 127,
  sym_null = 128,
  anon_sym_AT = 129,
  anon_sym_static = 130,
  anon_sym_require = 131,
  anon_sym_public = 132,
  anon_sym_private = 133,
  anon_sym_protected = 134,
  anon_sym_boolean = 135,
  anon_sym_string = 136,
  anon_sym_symbol = 137,
  anon_sym_int = 138,
  anon_sym_float = 139,
  anon_sym_LBRACE_PIPE = 140,
  anon_sym_PIPE_RBRACE = 141,
  anon_sym_DASH_QMARK_COLON = 142,
  anon_sym_QMARK_COLON = 143,
  anon_sym_is = 144,
  anon_sym_asserts = 145,
  sym_readonly = 146,
  anon_sym_keyof = 147,
  sym__automatic_semicolon = 148,
  sym__template_chars = 149,
  sym_program = 150,
  sym_export_statement = 151,
  sym_export_clause = 152,
  sym__import_export_specifier = 153,
  sym__declaration = 154,
  sym_type_alias_declaration = 155,
  sym_interface_declaration = 156,
  sym_ambient_declaration = 157,
  sym_import_alias = 158,
  sym_enum_declaration = 159,
  sym_enum_body = 160,
  sym_enum_assignment = 161,
  sym_import = 162,
  sym_import_statement = 163,
  sym_import_clause = 164,
  sym__from_clause = 165,
  sym_namespace_import = 166,
  sym_named_imports = 167,
  sym_expression_statement = 168,
  sym_variable_declaration = 169,
  sym_lexical_declaration = 170,
  sym_variable_declarator = 171,
  sym_statement_block = 172,
  sym_else_clause = 173,
  sym_if_statement = 174,
  sym_switch_statement = 175,
  sym_for_statement = 176,
  sym_for_in_statement = 177,
  sym__for_header = 178,
  sym_while_statement = 179,
  sym_do_statement = 180,
  sym_try_statement = 181,
  sym_with_statement = 182,
  sym_break_statement = 183,
  sym_continue_statement = 184,
  sym_debugger_statement = 185,
  sym_return_statement = 186,
  sym_throw_statement = 187,
  sym_empty_statement = 188,
  sym_labeled_statement = 189,
  sym_switch_body = 190,
  sym_switch_case = 191,
  sym_switch_default = 192,
  sym_catch_clause = 193,
  sym_finally_clause = 194,
  sym_parenthesized_expression = 195,
  sym__expression = 196,
  sym_yield_expression = 197,
  sym_object = 198,
  sym_assignment_pattern = 199,
  sym_array = 200,
  sym_nested_identifier = 201,
  sym_class = 202,
  sym_class_declaration = 203,
  sym_class_heritage = 204,
  sym_function = 205,
  sym_function_declaration = 206,
  sym_generator_function = 207,
  sym_generator_function_declaration = 208,
  sym_arrow_function = 209,
  sym_as_expression = 210,
  sym_non_null_expression = 211,
  sym_module = 212,
  sym_internal_module = 213,
  sym__module = 214,
  sym_abstract_class_declaration = 215,
  sym_abstract_method_signature = 216,
  sym_implements_clause = 217,
  sym_extends_clause = 218,
  sym_function_signature = 219,
  sym__call_signature = 220,
  sym_call_expression = 221,
  sym_new_expression = 222,
  sym_await_expression = 223,
  sym_member_expression = 224,
  sym_subscript_expression = 225,
  sym_assignment_expression = 226,
  sym__augmented_assignment_lhs = 227,
  sym_augmented_assignment_expression = 228,
  sym__initializer = 229,
  sym_spread_element = 230,
  sym_ternary_expression = 231,
  sym_binary_expression = 232,
  sym_unary_expression = 233,
  sym_update_expression = 234,
  sym_sequence_expression = 235,
  sym_string = 236,
  sym_char = 237,
  sym_template_string = 238,
  sym_template_substitution = 239,
  sym_regex = 240,
  sym__number_lit = 241,
  sym_meta_property = 242,
  sym_arguments = 243,
  sym_decorator = 244,
  sym_decorator_member_expression = 245,
  sym_decorator_call_expression = 246,
  sym_class_body = 247,
  sym_public_field_definition = 248,
  sym_import_require_clause = 249,
  sym_labeled_tuple_type_member = 250,
  sym__number = 251,
  sym_optional_parameter = 252,
  sym_formal_parameters = 253,
  sym_rest_parameter = 254,
  sym_method_definition = 255,
  sym_pair = 256,
  sym__property_name = 257,
  sym_computed_property_name = 258,
  sym_required_parameter = 259,
  sym__parameter_name = 260,
  sym_type_assertion = 261,
  sym_type_arguments = 262,
  sym__type = 263,
  sym_type_annotation = 264,
  sym__primary_type = 265,
  sym_parenthesized_type = 266,
  sym_predefined_type = 267,
  sym_nested_type_identifier = 268,
  sym_generic_type = 269,
  sym_object_type = 270,
  sym_call_signature = 271,
  sym__rest_identifier = 272,
  sym_rest_identifier = 273,
  sym_index_signature = 274,
  sym_omitting_type_annotation = 275,
  sym_opting_type_annotation = 276,
  sym_mapped_type_clause = 277,
  sym_construct_signature = 278,
  sym_method_signature = 279,
  sym_type_predicate = 280,
  sym_type_predicate_annotation = 281,
  sym_asserts = 282,
  sym_property_signature = 283,
  sym_accessibility_modifier = 284,
  sym_array_type = 285,
  sym_tuple_type = 286,
  sym__tuple_type_body = 287,
  sym__tuple_type_member = 288,
  sym__tuple_type_identifier = 289,
  sym_optional_identifier = 290,
  sym_flow_maybe_type = 291,
  sym_type_query = 292,
  sym_index_type_query = 293,
  sym_existential_type = 294,
  sym_literal_type = 295,
  sym_lookup_type = 296,
  sym_conditional_type = 297,
  sym_union_type = 298,
  sym_intersection_type = 299,
  sym_function_type = 300,
  sym_type_parameters = 301,
  sym_type_parameter = 302,
  sym_constraint = 303,
  sym_default_type = 304,
  sym_constructor_type = 305,
  aux_sym_program_repeat1 = 306,
  aux_sym_export_statement_repeat1 = 307,
  aux_sym_export_clause_repeat1 = 308,
  aux_sym_enum_body_repeat1 = 309,
  aux_sym_named_imports_repeat1 = 310,
  aux_sym_variable_declaration_repeat1 = 311,
  aux_sym_switch_body_repeat1 = 312,
  aux_sym_object_repeat1 = 313,
  aux_sym_array_repeat1 = 314,
  aux_sym_implements_clause_repeat1 = 315,
  aux_sym_extends_clause_repeat1 = 316,
  aux_sym_string_repeat1 = 317,
  aux_sym_template_string_repeat1 = 318,
  aux_sym_class_body_repeat1 = 319,
  aux_sym_formal_parameters_repeat1 = 320,
  aux_sym_object_type_repeat1 = 321,
  aux_sym__tuple_type_body_repeat1 = 322,
  aux_sym_type_parameters_repeat1 = 323,
  alias_sym_array_pattern = 324,
  alias_sym_import_specifier = 325,
  alias_sym_number = 326,
  alias_sym_object_pattern = 327,
  alias_sym_property_identifier = 328,
  alias_sym_shorthand_property_identifier = 329,
  alias_sym_statement_identifier = 330,
  alias_sym_type_identifier = 331,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_type] = "type",
  [anon_sym_interface] = "interface",
  [anon_sym_declare] = "declare",
  [anon_sym_global] = "global",
  [anon_sym_module] = "module",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [anon_sym_import] = "import",
  [anon_sym_const] = "const",
  [anon_sym_enum] = "enum",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_implements] = "implements",
  [anon_sym_extends] = "extends",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_token1] = "char_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_float_literal] = "float_literal",
  [sym_hex_literal] = "hex_literal",
  [sym_int_literal] = "int_literal",
  [sym_binary_literal] = "binary_literal",
  [sym_octal_literal] = "octal_literal",
  [sym_bigint_literal] = "bigint_literal",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_require] = "require",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_int] = "int",
  [anon_sym_float] = "float",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_is] = "is",
  [anon_sym_asserts] = "asserts",
  [sym_readonly] = "readonly",
  [anon_sym_keyof] = "keyof",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym__declaration] = "_declaration",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_import_alias] = "import_alias",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym_as_expression] = "as_expression",
  [sym_non_null_expression] = "non_null_expression",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_implements_clause] = "implements_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_function_signature] = "function_signature",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_char] = "char",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym__number_lit] = "_number_lit",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_import_require_clause] = "import_require_clause",
  [sym_labeled_tuple_type_member] = "labeled_tuple_type_member",
  [sym__number] = "unary_expression",
  [sym_optional_parameter] = "optional_parameter",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_required_parameter] = "required_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_assertion] = "type_assertion",
  [sym_type_arguments] = "type_arguments",
  [sym__type] = "_type",
  [sym_type_annotation] = "type_annotation",
  [sym__primary_type] = "_primary_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_generic_type] = "generic_type",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym__rest_identifier] = "_rest_identifier",
  [sym_rest_identifier] = "rest_identifier",
  [sym_index_signature] = "index_signature",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_construct_signature] = "construct_signature",
  [sym_method_signature] = "method_signature",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym_asserts] = "asserts",
  [sym_property_signature] = "property_signature",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym__tuple_type_body] = "_tuple_type_body",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym__tuple_type_identifier] = "_tuple_type_identifier",
  [sym_optional_identifier] = "optional_identifier",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_existential_type] = "existential_type",
  [sym_literal_type] = "literal_type",
  [sym_lookup_type] = "lookup_type",
  [sym_conditional_type] = "conditional_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_constraint] = "constraint",
  [sym_default_type] = "default_type",
  [sym_constructor_type] = "constructor_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym__tuple_type_body_repeat1] = "_tuple_type_body_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_number] = "number",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_token1] = aux_sym_char_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_float_literal] = sym_float_literal,
  [sym_hex_literal] = sym_hex_literal,
  [sym_int_literal] = sym_int_literal,
  [sym_binary_literal] = sym_binary_literal,
  [sym_octal_literal] = sym_octal_literal,
  [sym_bigint_literal] = sym_bigint_literal,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_asserts] = anon_sym_asserts,
  [sym_readonly] = sym_readonly,
  [anon_sym_keyof] = anon_sym_keyof,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_import_alias] = sym_import_alias,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym_as_expression] = sym_as_expression,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_implements_clause] = sym_implements_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_function_signature] = sym_function_signature,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_char] = sym_char,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym__number_lit] = sym__number_lit,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_labeled_tuple_type_member] = sym_labeled_tuple_type_member,
  [sym__number] = sym_unary_expression,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_required_parameter] = sym_required_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_type_assertion] = sym_type_assertion,
  [sym_type_arguments] = sym_type_arguments,
  [sym__type] = sym__type,
  [sym_type_annotation] = sym_type_annotation,
  [sym__primary_type] = sym__primary_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_generic_type] = sym_generic_type,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym__rest_identifier] = sym__rest_identifier,
  [sym_rest_identifier] = sym_rest_identifier,
  [sym_index_signature] = sym_index_signature,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_construct_signature] = sym_construct_signature,
  [sym_method_signature] = sym_method_signature,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym_asserts] = sym_asserts,
  [sym_property_signature] = sym_property_signature,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym__tuple_type_body] = sym__tuple_type_body,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym__tuple_type_identifier] = sym__tuple_type_identifier,
  [sym_optional_identifier] = sym_optional_identifier,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_existential_type] = sym_existential_type,
  [sym_literal_type] = sym_literal_type,
  [sym_lookup_type] = sym_lookup_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_constraint] = sym_constraint,
  [sym_default_type] = sym_default_type,
  [sym_constructor_type] = sym_constructor_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym__tuple_type_body_repeat1] = aux_sym__tuple_type_body_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_number] = alias_sym_number,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bigint_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym__number_lit] = {
    .visible = false,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_tuple_type_member] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__rest_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_rest_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_body] = {
    .visible = false,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym__tuple_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tuple_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_number] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_sign = 31,
  field_source = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_value = 36,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [9] = {.index = 6, .length = 2},
  [10] = {.index = 3, .length = 1},
  [11] = {.index = 3, .length = 1},
  [14] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [18] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 2},
  [26] = {.index = 26, .length = 1},
  [27] = {.index = 27, .length = 2},
  [28] = {.index = 29, .length = 2},
  [29] = {.index = 31, .length = 2},
  [31] = {.index = 33, .length = 2},
  [32] = {.index = 35, .length = 2},
  [33] = {.index = 37, .length = 2},
  [34] = {.index = 35, .length = 2},
  [35] = {.index = 37, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 2},
  [38] = {.index = 33, .length = 2},
  [39] = {.index = 39, .length = 2},
  [40] = {.index = 41, .length = 2},
  [41] = {.index = 43, .length = 3},
  [45] = {.index = 46, .length = 1},
  [46] = {.index = 47, .length = 2},
  [47] = {.index = 49, .length = 2},
  [48] = {.index = 51, .length = 2},
  [49] = {.index = 53, .length = 2},
  [50] = {.index = 55, .length = 1},
  [52] = {.index = 56, .length = 1},
  [53] = {.index = 57, .length = 2},
  [54] = {.index = 59, .length = 4},
  [55] = {.index = 63, .length = 2},
  [56] = {.index = 65, .length = 2},
  [57] = {.index = 63, .length = 2},
  [58] = {.index = 65, .length = 2},
  [59] = {.index = 67, .length = 1},
  [60] = {.index = 68, .length = 3},
  [61] = {.index = 24, .length = 2},
  [62] = {.index = 29, .length = 2},
  [63] = {.index = 22, .length = 2},
  [64] = {.index = 27, .length = 2},
  [65] = {.index = 71, .length = 3},
  [66] = {.index = 74, .length = 3},
  [67] = {.index = 22, .length = 2},
  [68] = {.index = 22, .length = 2},
  [69] = {.index = 77, .length = 4},
  [70] = {.index = 81, .length = 3},
  [71] = {.index = 84, .length = 2},
  [72] = {.index = 86, .length = 2},
  [73] = {.index = 88, .length = 1},
  [74] = {.index = 89, .length = 1},
  [75] = {.index = 90, .length = 1},
  [76] = {.index = 91, .length = 1},
  [77] = {.index = 92, .length = 2},
  [78] = {.index = 94, .length = 2},
  [79] = {.index = 96, .length = 3},
  [80] = {.index = 22, .length = 2},
  [81] = {.index = 99, .length = 2},
  [82] = {.index = 101, .length = 5},
  [83] = {.index = 106, .length = 2},
  [84] = {.index = 108, .length = 3},
  [85] = {.index = 92, .length = 2},
  [86] = {.index = 111, .length = 2},
  [87] = {.index = 113, .length = 1},
  [88] = {.index = 114, .length = 2},
  [89] = {.index = 116, .length = 3},
  [90] = {.index = 116, .length = 3},
  [91] = {.index = 116, .length = 3},
  [92] = {.index = 119, .length = 3},
  [93] = {.index = 122, .length = 3},
  [94] = {.index = 125, .length = 1},
  [95] = {.index = 126, .length = 1},
  [99] = {.index = 127, .length = 1},
  [100] = {.index = 128, .length = 3},
  [101] = {.index = 131, .length = 4},
  [102] = {.index = 135, .length = 2},
  [103] = {.index = 137, .length = 2},
  [104] = {.index = 139, .length = 4},
  [105] = {.index = 137, .length = 2},
  [106] = {.index = 143, .length = 4},
  [107] = {.index = 147, .length = 4},
  [108] = {.index = 151, .length = 5},
  [109] = {.index = 111, .length = 2},
  [110] = {.index = 156, .length = 3},
  [111] = {.index = 156, .length = 3},
  [112] = {.index = 159, .length = 2},
  [113] = {.index = 161, .length = 2},
  [114] = {.index = 94, .length = 2},
  [115] = {.index = 96, .length = 3},
  [116] = {.index = 163, .length = 3},
  [117] = {.index = 166, .length = 2},
  [118] = {.index = 168, .length = 3},
  [119] = {.index = 171, .length = 2},
  [120] = {.index = 173, .length = 2},
  [121] = {.index = 175, .length = 5},
  [122] = {.index = 180, .length = 2},
  [123] = {.index = 182, .length = 3},
  [124] = {.index = 185, .length = 1},
  [125] = {.index = 186, .length = 1},
  [126] = {.index = 187, .length = 2},
  [127] = {.index = 189, .length = 2},
  [128] = {.index = 191, .length = 1},
  [129] = {.index = 192, .length = 2},
  [130] = {.index = 194, .length = 2},
  [131] = {.index = 196, .length = 2},
  [132] = {.index = 198, .length = 4},
  [133] = {.index = 202, .length = 4},
  [134] = {.index = 206, .length = 4},
  [135] = {.index = 210, .length = 5},
  [136] = {.index = 215, .length = 2},
  [137] = {.index = 217, .length = 3},
  [138] = {.index = 173, .length = 2},
  [139] = {.index = 220, .length = 3},
  [140] = {.index = 223, .length = 2},
  [141] = {.index = 225, .length = 3},
  [142] = {.index = 228, .length = 4},
  [143] = {.index = 232, .length = 3},
  [144] = {.index = 235, .length = 3},
  [145] = {.index = 238, .length = 2},
  [146] = {.index = 240, .length = 5},
  [147] = {.index = 245, .length = 3},
  [149] = {.index = 248, .length = 2},
  [150] = {.index = 248, .length = 2},
  [151] = {.index = 250, .length = 3},
  [152] = {.index = 248, .length = 2},
  [153] = {.index = 248, .length = 2},
  [154] = {.index = 253, .length = 4},
  [155] = {.index = 257, .length = 2},
  [156] = {.index = 259, .length = 2},
  [157] = {.index = 261, .length = 2},
  [158] = {.index = 263, .length = 2},
  [159] = {.index = 265, .length = 3},
  [160] = {.index = 268, .length = 3},
  [161] = {.index = 271, .length = 1},
  [162] = {.index = 272, .length = 5},
  [163] = {.index = 277, .length = 3},
  [164] = {.index = 280, .length = 4},
  [165] = {.index = 284, .length = 3},
  [166] = {.index = 287, .length = 4},
  [167] = {.index = 291, .length = 5},
  [168] = {.index = 296, .length = 2},
  [169] = {.index = 296, .length = 2},
  [170] = {.index = 296, .length = 2},
  [171] = {.index = 296, .length = 2},
  [172] = {.index = 298, .length = 4},
  [173] = {.index = 302, .length = 2},
  [174] = {.index = 302, .length = 2},
  [175] = {.index = 302, .length = 2},
  [176] = {.index = 304, .length = 4},
  [177] = {.index = 308, .length = 2},
  [178] = {.index = 310, .length = 2},
  [179] = {.index = 312, .length = 3},
  [180] = {.index = 315, .length = 3},
  [181] = {.index = 318, .length = 4},
  [182] = {.index = 322, .length = 2},
  [183] = {.index = 324, .length = 2},
  [184] = {.index = 326, .length = 4},
  [185] = {.index = 330, .length = 5},
  [186] = {.index = 335, .length = 5},
  [187] = {.index = 340, .length = 3},
  [188] = {.index = 343, .length = 1},
  [189] = {.index = 344, .length = 4},
  [190] = {.index = 348, .length = 4},
  [191] = {.index = 352, .length = 2},
  [192] = {.index = 354, .length = 2},
  [193] = {.index = 356, .length = 3},
  [194] = {.index = 359, .length = 4},
  [195] = {.index = 363, .length = 5},
  [196] = {.index = 368, .length = 5},
  [197] = {.index = 373, .length = 4},
  [198] = {.index = 377, .length = 3},
  [199] = {.index = 380, .length = 4},
  [200] = {.index = 384, .length = 5},
  [201] = {.index = 343, .length = 1},
  [202] = {.index = 389, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_arguments, 1},
    {field_function, 0},
  [16] =
    {field_parameters, 0},
    {field_return_type, 1},
  [18] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [20] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_object, 0},
    {field_property, 2},
  [26] =
    {field_label, 0},
  [27] =
    {field_body, 2},
    {field_parameter, 0},
  [29] =
    {field_arguments, 2},
    {field_function, 0},
  [31] =
    {field_body, 1},
    {field_name, 0},
  [33] =
    {field_body, 2},
    {field_name, 1},
  [35] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [37] =
    {field_name, 0},
    {field_type, 1},
  [39] =
    {field_condition, 1},
    {field_consequence, 2},
  [41] =
    {field_body, 2},
    {field_value, 1},
  [43] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [46] =
    {field_value, 1, .inherited = true},
  [47] =
    {field_body, 2},
    {field_condition, 1},
  [49] =
    {field_body, 1},
    {field_handler, 2},
  [51] =
    {field_body, 1},
    {field_finalizer, 2},
  [53] =
    {field_body, 2},
    {field_object, 1},
  [55] =
    {field_label, 1},
  [56] =
    {field_body, 2},
  [57] =
    {field_body, 2},
    {field_type_parameters, 1},
  [59] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [63] =
    {field_arguments, 2},
    {field_constructor, 1},
  [65] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [67] =
    {field_pattern, 1},
  [68] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [71] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [74] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [77] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [81] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [84] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [86] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [88] =
    {field_source, 1},
  [89] =
    {field_source, 2, .inherited = true},
  [90] =
    {field_value, 2},
  [91] =
    {field_name, 1},
  [92] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [94] =
    {field_index, 2},
    {field_object, 0},
  [96] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [99] =
    {field_key, 0},
    {field_value, 2},
  [101] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [106] =
    {field_body, 3},
    {field_name, 1},
  [108] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [111] =
    {field_body, 3},
    {field_name, 2},
  [113] =
    {field_value, 1},
  [114] =
    {field_name, 0},
    {field_type, 2},
  [116] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [119] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [122] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [125] =
    {field_decorator, 2, .inherited = true},
  [126] =
    {field_value, 2, .inherited = true},
  [127] =
    {field_decorator, 1, .inherited = true},
  [128] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [131] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [135] =
    {field_body, 3},
    {field_type_parameters, 1},
  [137] =
    {field_body, 3},
    {field_parameter, 1},
  [139] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [143] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [147] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [151] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [156] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [159] =
    {field_flags, 3},
    {field_pattern, 1},
  [161] =
    {field_module, 0},
    {field_name, 2},
  [163] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [166] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [168] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [171] =
    {field_alias, 2},
    {field_name, 0},
  [173] =
    {field_index, 3},
    {field_object, 0},
  [175] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [180] =
    {field_name, 1},
    {field_value, 3},
  [182] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [185] =
    {field_source, 3, .inherited = true},
  [186] =
    {field_value, 3, .inherited = true},
  [187] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [189] =
    {field_body, 1},
    {field_condition, 3},
  [191] =
    {field_name, 2},
  [192] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [194] =
    {field_name, 1},
    {field_type, 2},
  [196] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [198] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [202] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [206] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [210] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [215] =
    {field_body, 4},
    {field_name, 2},
  [217] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [220] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [223] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [225] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [228] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [232] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [235] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [238] =
    {field_alias, 3},
    {field_name, 1},
  [240] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [245] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [248] =
    {field_left, 1},
    {field_right, 3},
  [250] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [253] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [257] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [259] =
    {field_name, 2},
    {field_type, 3},
  [261] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [263] =
    {field_name, 1},
    {field_type, 3},
  [265] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [268] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [271] =
    {field_name, 3},
  [272] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [277] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [280] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [284] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [287] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [291] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [296] =
    {field_left, 2},
    {field_right, 4},
  [298] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [302] =
    {field_body, 4},
    {field_parameter, 2},
  [304] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [308] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [310] =
    {field_name, 2},
    {field_type, 4},
  [312] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [315] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [318] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [322] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [324] =
    {field_name, 3},
    {field_type, 4},
  [326] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [330] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [335] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [340] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [343] =
    {field_sign, 0},
  [344] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [348] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [352] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [354] =
    {field_name, 3},
    {field_type, 5},
  [356] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [359] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [363] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [368] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [373] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [377] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [380] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [384] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [389] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [8] = {
    [0] = alias_sym_number,
  },
  [10] = {
    [0] = alias_sym_object_pattern,
  },
  [11] = {
    [0] = alias_sym_array_pattern,
  },
  [12] = {
    [0] = alias_sym_object_pattern,
  },
  [13] = {
    [0] = alias_sym_array_pattern,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [17] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [0] = sym_identifier,
  },
  [25] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [26] = {
    [0] = alias_sym_statement_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [30] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [31] = {
    [1] = alias_sym_type_identifier,
  },
  [34] = {
    [0] = alias_sym_object_pattern,
  },
  [35] = {
    [0] = alias_sym_object_pattern,
  },
  [36] = {
    [0] = alias_sym_array_pattern,
  },
  [37] = {
    [0] = alias_sym_array_pattern,
  },
  [42] = {
    [1] = sym_identifier,
  },
  [43] = {
    [1] = alias_sym_object_pattern,
  },
  [44] = {
    [1] = alias_sym_array_pattern,
  },
  [50] = {
    [1] = alias_sym_statement_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [55] = {
    [1] = sym_identifier,
  },
  [56] = {
    [1] = sym_identifier,
  },
  [61] = {
    [2] = alias_sym_property_identifier,
  },
  [67] = {
    [0] = alias_sym_object_pattern,
  },
  [68] = {
    [0] = alias_sym_array_pattern,
  },
  [78] = {
    [0] = sym_identifier,
  },
  [79] = {
    [0] = sym_identifier,
  },
  [80] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [83] = {
    [1] = alias_sym_type_identifier,
  },
  [84] = {
    [1] = alias_sym_type_identifier,
  },
  [85] = {
    [1] = alias_sym_import_specifier,
  },
  [90] = {
    [0] = alias_sym_object_pattern,
  },
  [91] = {
    [0] = alias_sym_array_pattern,
  },
  [96] = {
    [2] = sym_identifier,
  },
  [97] = {
    [2] = alias_sym_object_pattern,
  },
  [98] = {
    [2] = alias_sym_array_pattern,
  },
  [103] = {
    [1] = sym_identifier,
  },
  [109] = {
    [2] = alias_sym_type_identifier,
  },
  [110] = {
    [1] = sym_identifier,
  },
  [113] = {
    [2] = alias_sym_type_identifier,
  },
  [116] = {
    [2] = alias_sym_type_identifier,
  },
  [120] = {
    [0] = sym_identifier,
  },
  [122] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [1] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [141] = {
    [2] = alias_sym_type_identifier,
  },
  [142] = {
    [2] = alias_sym_type_identifier,
  },
  [144] = {
    [3] = alias_sym_type_identifier,
  },
  [147] = {
    [1] = alias_sym_type_identifier,
  },
  [148] = {
    [3] = alias_sym_property_identifier,
  },
  [149] = {
    [1] = sym_identifier,
  },
  [152] = {
    [1] = alias_sym_object_pattern,
  },
  [153] = {
    [1] = alias_sym_array_pattern,
  },
  [163] = {
    [2] = alias_sym_type_identifier,
  },
  [164] = {
    [2] = alias_sym_type_identifier,
  },
  [165] = {
    [3] = alias_sym_type_identifier,
  },
  [166] = {
    [3] = alias_sym_type_identifier,
  },
  [168] = {
    [2] = sym_identifier,
  },
  [170] = {
    [2] = alias_sym_object_pattern,
  },
  [171] = {
    [2] = alias_sym_array_pattern,
  },
  [174] = {
    [2] = alias_sym_object_pattern,
  },
  [175] = {
    [2] = alias_sym_array_pattern,
  },
  [184] = {
    [3] = alias_sym_type_identifier,
  },
  [201] = {
    [3] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_object, 2,
    sym_object,
    alias_sym_object_pattern,
  sym_array, 2,
    sym_array,
    alias_sym_array_pattern,
  sym__number_lit, 2,
    sym__number_lit,
    alias_sym_number,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < '`'
    ? (c < '%'
      ? (c < 0
        ? c == 0
        : c <= '#')
      : (c <= '/' || (c < '['
        ? (c >= ':' && c <= '@')
        : c <= '^')))
    : (c <= '`' || (c < 8203
      ? (c < 160
        ? (c >= '{' && c <= '~')
        : c <= 160)
      : (c <= 8203 || (c < 65279
        ? c == 8288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < '`'
    ? (c < '%'
      ? (c < 0
        ? c == 0
        : c <= '#')
      : (c <= '/' || (c < '['
        ? (c >= ':' && c <= '@')
        : c <= '^')))
    : (c <= '~' || (c < 8288
      ? (c < 8203
        ? c == 160
        : c <= 8203)
      : (c <= 8288 || c == 65279))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < '`'
    ? (c < '%'
      ? (c < 0
        ? c == 0
        : c <= '#')
      : (c <= '/' || (c < '['
        ? (c >= ':' && c <= '@')
        : c <= '^')))
    : (c <= '`' || (c < 8203
      ? (c < 160
        ? (c >= '|' && c <= '~')
        : c <= 160)
      : (c <= 8203 || (c < 65279
        ? c == 8288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '#') ADVANCE(17);
      if (lookahead == '$') ADVANCE(203);
      if (lookahead == '%') ADVANCE(152);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(131);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(204);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(175);
      if (lookahead != 0) ADVANCE(176);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(171);
      if (lookahead == '\r') ADVANCE(181);
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(184);
      if (lookahead != 0) ADVANCE(180);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(3)
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(179);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(178);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(178);
      if (lookahead == '\r') ADVANCE(4);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(30)
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '[') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(190);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '%') ADVANCE(152);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(131);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '%') ADVANCE(152);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(131);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '%') ADVANCE(152);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(131);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '~') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(204);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(85);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(73);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '?') ADVANCE(97);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '~') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(204);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(162);
      if (lookahead == '?') ADVANCE(97);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '\'' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(162);
      if (lookahead == '?') ADVANCE(97);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '\'' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(51);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(45);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(204);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '$') ADVANCE(39);
      if (lookahead == '-') ADVANCE(34);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == '?') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(38);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(24)
      END_STATE();
    case 24:
      if (lookahead == '$') ADVANCE(39);
      if (lookahead == '-') ADVANCE(34);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == '?') ADVANCE(32);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(24)
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(186);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(185);
      if (lookahead != 0) ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead != 0) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(116);
      END_STATE();
    case 30:
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(30)
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(208);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(209);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 34:
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 35:
      if (lookahead == '\\') ADVANCE(67);
      if (lookahead == ']') ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(40);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(184);
      if (lookahead != 0) ADVANCE(180);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(184);
      if (lookahead != 0) ADVANCE(180);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(188);
      END_STATE();
    case 40:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 41:
      if (lookahead == '{') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 42:
      if (lookahead == '{') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(207);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 48:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(200);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(201);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(204);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(196);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 67:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(35);
      END_STATE();
    case 68:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(191);
      END_STATE();
    case 69:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '#') ADVANCE(17);
      if (lookahead == '$') ADVANCE(203);
      if (lookahead == '%') ADVANCE(152);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(140);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(131);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(82);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(204);
      END_STATE();
    case 70:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(90);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '%') ADVANCE(151);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(70)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(204);
      END_STATE();
    case 71:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '#') ADVANCE(17);
      if (lookahead == '&') ADVANCE(127);
      if (lookahead == '\'') ADVANCE(177);
      if (lookahead == '(') ADVANCE(91);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(141);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '0') ADVANCE(197);
      if (lookahead == ':') ADVANCE(88);
      if (lookahead == ';') ADVANCE(93);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(162);
      if (lookahead == '?') ADVANCE(97);
      if (lookahead == '@') ADVANCE(205);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(187);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(71)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(204);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(154);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(153);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(159);
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(206);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(160);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '?') ADVANCE(166);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '?') ADVANCE(165);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '>') ADVANCE(124);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(117);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '|') ADVANCE(120);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '}') ADVANCE(207);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(119);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(119);
      if (lookahead == '}') ADVANCE(207);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(207);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(168);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(168);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(168);
      if (lookahead == '=') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(169);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '?') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '=') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(186);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(161);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(161);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(176);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_char_token1);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym_char_token1);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(178);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(171);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(37);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(204);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(186);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '[') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(37);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(204);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == '_') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_hex_literal);
      if (lookahead == '_') ADVANCE(56);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '0') ADVANCE(199);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(48);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(49);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(56);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(202);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_binary_literal);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(202);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_octal_literal);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_bigint_literal);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '{') ADVANCE(188);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(204);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(37);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'v') ADVANCE(18);
      if (lookahead == 'w') ADVANCE(19);
      if (lookahead == 'y') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(21);
      if (lookahead == 's') ADVANCE(22);
      if (lookahead == 'w') ADVANCE(23);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'n') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'u') ADVANCE(51);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(53);
      if (lookahead == 'u') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == 't') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(58);
      if (lookahead == 'w') ADVANCE(59);
      if (lookahead == 'y') ADVANCE(60);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'h') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'y') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(70);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'b') ADVANCE(80);
      if (lookahead == 'c') ADVANCE(81);
      if (lookahead == 'f') ADVANCE(82);
      if (lookahead == 'l') ADVANCE(83);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 33:
      if (lookahead == 'p') ADVANCE(86);
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'o') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(95);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 46:
      if (lookahead == 'y') ADVANCE(99);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 'd') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'm') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'w') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(104);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(105);
      if (lookahead == 'o') ADVANCE(106);
      END_STATE();
    case 54:
      if (lookahead == 'b') ADVANCE(107);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(108);
      if (lookahead == 'q') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'p') ADVANCE(114);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(115);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(116);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(118);
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(120);
      if (lookahead == 'y') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'p') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(131);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'a') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'c') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 's') ADVANCE(137);
      if (lookahead == 't') ADVANCE(138);
      END_STATE();
    case 80:
      if (lookahead == 'u') ADVANCE(139);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'm') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 92:
      if (lookahead == 'm') ADVANCE(150);
      END_STATE();
    case 93:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 95:
      if (lookahead == 'b') ADVANCE(152);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(154);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'o') ADVANCE(157);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 105:
      if (lookahead == 'v') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 'd') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'u') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(166);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 113:
      if (lookahead == 'i') ADVANCE(168);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'b') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 'g') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 124:
      if (lookahead == 'd') ADVANCE(177);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 126:
      if (lookahead == 'h') ADVANCE(179);
      END_STATE();
    case 127:
      if (lookahead == 'l') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'r') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'c') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 'k') ADVANCE(186);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 135:
      if (lookahead == 'h') ADVANCE(187);
      END_STATE();
    case 136:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 'i') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 'g') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'a') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 146:
      if (lookahead == 'n') ADVANCE(196);
      END_STATE();
    case 147:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 152:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'f') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 's') ADVANCE(208);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(209);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'i') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'o') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'r') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'n') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'c') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 174:
      if (lookahead == 'w') ADVANCE(221);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(222);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 180:
      if (lookahead == 'd') ADVANCE(224);
      END_STATE();
    case 181:
      if (lookahead == 'a') ADVANCE(225);
      END_STATE();
    case 182:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 185:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(228);
      END_STATE();
    case 191:
      if (lookahead == 'g') ADVANCE(229);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'd') ADVANCE(234);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 198:
      if (lookahead == 'l') ADVANCE(235);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(236);
      END_STATE();
    case 201:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 202:
      if (lookahead == 'm') ADVANCE(238);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(239);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 205:
      if (lookahead == 'f') ADVANCE(241);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 208:
      if (lookahead == 'p') ADVANCE(243);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(244);
      END_STATE();
    case 210:
      if (lookahead == 'c') ADVANCE(245);
      END_STATE();
    case 211:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 212:
      if (lookahead == 'n') ADVANCE(247);
      END_STATE();
    case 213:
      if (lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 215:
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 216:
      if (lookahead == 'g') ADVANCE(251);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 218:
      if (lookahead == 'h') ADVANCE(252);
      END_STATE();
    case 219:
      if (lookahead == 'l') ADVANCE(253);
      END_STATE();
    case 220:
      if (lookahead == 't') ADVANCE(254);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 222:
      if (lookahead == 'f') ADVANCE(255);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 225:
      if (lookahead == 'c') ADVANCE(256);
      END_STATE();
    case 226:
      if (lookahead == 's') ADVANCE(257);
      END_STATE();
    case 227:
      if (lookahead == 'n') ADVANCE(258);
      END_STATE();
    case 228:
      if (lookahead == 'u') ADVANCE(259);
      END_STATE();
    case 229:
      if (lookahead == 'e') ADVANCE(260);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 234:
      if (lookahead == 's') ADVANCE(263);
      END_STATE();
    case 235:
      if (lookahead == 'y') ADVANCE(264);
      END_STATE();
    case 236:
      if (lookahead == 'o') ADVANCE(265);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 240:
      if (lookahead == 'c') ADVANCE(267);
      END_STATE();
    case 241:
      if (lookahead == 'a') ADVANCE(268);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 244:
      if (lookahead == 'e') ADVANCE(270);
      END_STATE();
    case 245:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 247:
      if (lookahead == 'l') ADVANCE(272);
      END_STATE();
    case 248:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 260:
      if (lookahead == 'r') ADVANCE(276);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(278);
      END_STATE();
    case 267:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 268:
      if (lookahead == 'c') ADVANCE(280);
      END_STATE();
    case 269:
      if (lookahead == 'c') ADVANCE(281);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 271:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 272:
      if (lookahead == 'y') ADVANCE(283);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 278:
      if (lookahead == 't') ADVANCE(284);
      END_STATE();
    case 279:
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 282:
      if (lookahead == 'd') ADVANCE(288);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 284:
      if (lookahead == 's') ADVANCE(289);
      END_STATE();
    case 285:
      if (lookahead == 'f') ADVANCE(290);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 71},
  [2] = {.lex_state = 71},
  [3] = {.lex_state = 71},
  [4] = {.lex_state = 71},
  [5] = {.lex_state = 71},
  [6] = {.lex_state = 71},
  [7] = {.lex_state = 71},
  [8] = {.lex_state = 71},
  [9] = {.lex_state = 71},
  [10] = {.lex_state = 71},
  [11] = {.lex_state = 71},
  [12] = {.lex_state = 71},
  [13] = {.lex_state = 71},
  [14] = {.lex_state = 71},
  [15] = {.lex_state = 71},
  [16] = {.lex_state = 71},
  [17] = {.lex_state = 71},
  [18] = {.lex_state = 71},
  [19] = {.lex_state = 71},
  [20] = {.lex_state = 71},
  [21] = {.lex_state = 71},
  [22] = {.lex_state = 71},
  [23] = {.lex_state = 71},
  [24] = {.lex_state = 71},
  [25] = {.lex_state = 71},
  [26] = {.lex_state = 71},
  [27] = {.lex_state = 71},
  [28] = {.lex_state = 71},
  [29] = {.lex_state = 71},
  [30] = {.lex_state = 71},
  [31] = {.lex_state = 71},
  [32] = {.lex_state = 71},
  [33] = {.lex_state = 71},
  [34] = {.lex_state = 71},
  [35] = {.lex_state = 71},
  [36] = {.lex_state = 71},
  [37] = {.lex_state = 71},
  [38] = {.lex_state = 71},
  [39] = {.lex_state = 71},
  [40] = {.lex_state = 71},
  [41] = {.lex_state = 71},
  [42] = {.lex_state = 71},
  [43] = {.lex_state = 71},
  [44] = {.lex_state = 71},
  [45] = {.lex_state = 71},
  [46] = {.lex_state = 71},
  [47] = {.lex_state = 71},
  [48] = {.lex_state = 18},
  [49] = {.lex_state = 18},
  [50] = {.lex_state = 18},
  [51] = {.lex_state = 18},
  [52] = {.lex_state = 18},
  [53] = {.lex_state = 18},
  [54] = {.lex_state = 18},
  [55] = {.lex_state = 18},
  [56] = {.lex_state = 18},
  [57] = {.lex_state = 18},
  [58] = {.lex_state = 18},
  [59] = {.lex_state = 70, .external_lex_state = 2},
  [60] = {.lex_state = 7, .external_lex_state = 2},
  [61] = {.lex_state = 70, .external_lex_state = 3},
  [62] = {.lex_state = 10, .external_lex_state = 2},
  [63] = {.lex_state = 70, .external_lex_state = 2},
  [64] = {.lex_state = 70, .external_lex_state = 3},
  [65] = {.lex_state = 70, .external_lex_state = 2},
  [66] = {.lex_state = 7, .external_lex_state = 2},
  [67] = {.lex_state = 7, .external_lex_state = 3},
  [68] = {.lex_state = 70, .external_lex_state = 3},
  [69] = {.lex_state = 70, .external_lex_state = 3},
  [70] = {.lex_state = 70, .external_lex_state = 3},
  [71] = {.lex_state = 7, .external_lex_state = 2},
  [72] = {.lex_state = 70, .external_lex_state = 3},
  [73] = {.lex_state = 70, .external_lex_state = 3},
  [74] = {.lex_state = 70, .external_lex_state = 3},
  [75] = {.lex_state = 70, .external_lex_state = 3},
  [76] = {.lex_state = 70, .external_lex_state = 3},
  [77] = {.lex_state = 70, .external_lex_state = 3},
  [78] = {.lex_state = 70, .external_lex_state = 3},
  [79] = {.lex_state = 70, .external_lex_state = 3},
  [80] = {.lex_state = 70, .external_lex_state = 3},
  [81] = {.lex_state = 70, .external_lex_state = 3},
  [82] = {.lex_state = 7, .external_lex_state = 3},
  [83] = {.lex_state = 70, .external_lex_state = 3},
  [84] = {.lex_state = 70, .external_lex_state = 3},
  [85] = {.lex_state = 70, .external_lex_state = 3},
  [86] = {.lex_state = 70, .external_lex_state = 3},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 3},
  [89] = {.lex_state = 70, .external_lex_state = 3},
  [90] = {.lex_state = 70, .external_lex_state = 3},
  [91] = {.lex_state = 70, .external_lex_state = 3},
  [92] = {.lex_state = 7, .external_lex_state = 2},
  [93] = {.lex_state = 70, .external_lex_state = 3},
  [94] = {.lex_state = 70, .external_lex_state = 3},
  [95] = {.lex_state = 70, .external_lex_state = 3},
  [96] = {.lex_state = 7, .external_lex_state = 2},
  [97] = {.lex_state = 70, .external_lex_state = 3},
  [98] = {.lex_state = 70, .external_lex_state = 3},
  [99] = {.lex_state = 71},
  [100] = {.lex_state = 7, .external_lex_state = 2},
  [101] = {.lex_state = 71},
  [102] = {.lex_state = 71},
  [103] = {.lex_state = 71},
  [104] = {.lex_state = 71},
  [105] = {.lex_state = 71},
  [106] = {.lex_state = 71},
  [107] = {.lex_state = 71},
  [108] = {.lex_state = 71},
  [109] = {.lex_state = 71},
  [110] = {.lex_state = 71},
  [111] = {.lex_state = 71},
  [112] = {.lex_state = 71},
  [113] = {.lex_state = 71},
  [114] = {.lex_state = 71},
  [115] = {.lex_state = 71},
  [116] = {.lex_state = 71},
  [117] = {.lex_state = 71},
  [118] = {.lex_state = 71, .external_lex_state = 4},
  [119] = {.lex_state = 71},
  [120] = {.lex_state = 71},
  [121] = {.lex_state = 71},
  [122] = {.lex_state = 71},
  [123] = {.lex_state = 71},
  [124] = {.lex_state = 71},
  [125] = {.lex_state = 71},
  [126] = {.lex_state = 71},
  [127] = {.lex_state = 71},
  [128] = {.lex_state = 71},
  [129] = {.lex_state = 71},
  [130] = {.lex_state = 71},
  [131] = {.lex_state = 71},
  [132] = {.lex_state = 71},
  [133] = {.lex_state = 71},
  [134] = {.lex_state = 71},
  [135] = {.lex_state = 71},
  [136] = {.lex_state = 71},
  [137] = {.lex_state = 71},
  [138] = {.lex_state = 71},
  [139] = {.lex_state = 71},
  [140] = {.lex_state = 71},
  [141] = {.lex_state = 71},
  [142] = {.lex_state = 71},
  [143] = {.lex_state = 71},
  [144] = {.lex_state = 71},
  [145] = {.lex_state = 71},
  [146] = {.lex_state = 71},
  [147] = {.lex_state = 8, .external_lex_state = 3},
  [148] = {.lex_state = 71},
  [149] = {.lex_state = 71},
  [150] = {.lex_state = 71},
  [151] = {.lex_state = 71, .external_lex_state = 4},
  [152] = {.lex_state = 8, .external_lex_state = 3},
  [153] = {.lex_state = 71},
  [154] = {.lex_state = 71},
  [155] = {.lex_state = 71},
  [156] = {.lex_state = 71},
  [157] = {.lex_state = 71},
  [158] = {.lex_state = 8, .external_lex_state = 3},
  [159] = {.lex_state = 71},
  [160] = {.lex_state = 71},
  [161] = {.lex_state = 71},
  [162] = {.lex_state = 71},
  [163] = {.lex_state = 71},
  [164] = {.lex_state = 71},
  [165] = {.lex_state = 71},
  [166] = {.lex_state = 71},
  [167] = {.lex_state = 71},
  [168] = {.lex_state = 71},
  [169] = {.lex_state = 71},
  [170] = {.lex_state = 71},
  [171] = {.lex_state = 71},
  [172] = {.lex_state = 71},
  [173] = {.lex_state = 8, .external_lex_state = 3},
  [174] = {.lex_state = 71},
  [175] = {.lex_state = 71},
  [176] = {.lex_state = 71},
  [177] = {.lex_state = 71},
  [178] = {.lex_state = 71},
  [179] = {.lex_state = 71},
  [180] = {.lex_state = 71},
  [181] = {.lex_state = 71},
  [182] = {.lex_state = 71},
  [183] = {.lex_state = 71},
  [184] = {.lex_state = 71},
  [185] = {.lex_state = 71},
  [186] = {.lex_state = 71},
  [187] = {.lex_state = 71},
  [188] = {.lex_state = 71},
  [189] = {.lex_state = 71},
  [190] = {.lex_state = 71},
  [191] = {.lex_state = 71},
  [192] = {.lex_state = 71},
  [193] = {.lex_state = 71},
  [194] = {.lex_state = 71},
  [195] = {.lex_state = 71},
  [196] = {.lex_state = 71},
  [197] = {.lex_state = 71},
  [198] = {.lex_state = 71},
  [199] = {.lex_state = 71},
  [200] = {.lex_state = 71},
  [201] = {.lex_state = 71},
  [202] = {.lex_state = 71},
  [203] = {.lex_state = 71},
  [204] = {.lex_state = 71},
  [205] = {.lex_state = 71},
  [206] = {.lex_state = 71},
  [207] = {.lex_state = 71},
  [208] = {.lex_state = 71},
  [209] = {.lex_state = 71},
  [210] = {.lex_state = 71},
  [211] = {.lex_state = 71},
  [212] = {.lex_state = 8, .external_lex_state = 3},
  [213] = {.lex_state = 71},
  [214] = {.lex_state = 71},
  [215] = {.lex_state = 71},
  [216] = {.lex_state = 71},
  [217] = {.lex_state = 71},
  [218] = {.lex_state = 8, .external_lex_state = 3},
  [219] = {.lex_state = 71},
  [220] = {.lex_state = 71},
  [221] = {.lex_state = 71},
  [222] = {.lex_state = 71},
  [223] = {.lex_state = 71},
  [224] = {.lex_state = 71},
  [225] = {.lex_state = 71},
  [226] = {.lex_state = 8, .external_lex_state = 3},
  [227] = {.lex_state = 71},
  [228] = {.lex_state = 71},
  [229] = {.lex_state = 71},
  [230] = {.lex_state = 71},
  [231] = {.lex_state = 71},
  [232] = {.lex_state = 71},
  [233] = {.lex_state = 71},
  [234] = {.lex_state = 71},
  [235] = {.lex_state = 71},
  [236] = {.lex_state = 71},
  [237] = {.lex_state = 71},
  [238] = {.lex_state = 71},
  [239] = {.lex_state = 71},
  [240] = {.lex_state = 71},
  [241] = {.lex_state = 71},
  [242] = {.lex_state = 71},
  [243] = {.lex_state = 71},
  [244] = {.lex_state = 71},
  [245] = {.lex_state = 71},
  [246] = {.lex_state = 71},
  [247] = {.lex_state = 71},
  [248] = {.lex_state = 71},
  [249] = {.lex_state = 8, .external_lex_state = 3},
  [250] = {.lex_state = 71},
  [251] = {.lex_state = 71},
  [252] = {.lex_state = 71},
  [253] = {.lex_state = 71},
  [254] = {.lex_state = 71},
  [255] = {.lex_state = 71},
  [256] = {.lex_state = 71},
  [257] = {.lex_state = 71},
  [258] = {.lex_state = 71},
  [259] = {.lex_state = 71},
  [260] = {.lex_state = 71},
  [261] = {.lex_state = 71},
  [262] = {.lex_state = 71},
  [263] = {.lex_state = 71},
  [264] = {.lex_state = 71},
  [265] = {.lex_state = 71},
  [266] = {.lex_state = 71},
  [267] = {.lex_state = 71},
  [268] = {.lex_state = 71},
  [269] = {.lex_state = 71},
  [270] = {.lex_state = 71},
  [271] = {.lex_state = 71},
  [272] = {.lex_state = 71},
  [273] = {.lex_state = 71},
  [274] = {.lex_state = 71},
  [275] = {.lex_state = 71},
  [276] = {.lex_state = 71},
  [277] = {.lex_state = 71},
  [278] = {.lex_state = 71},
  [279] = {.lex_state = 71},
  [280] = {.lex_state = 71},
  [281] = {.lex_state = 71},
  [282] = {.lex_state = 71},
  [283] = {.lex_state = 71},
  [284] = {.lex_state = 71},
  [285] = {.lex_state = 71},
  [286] = {.lex_state = 71},
  [287] = {.lex_state = 71},
  [288] = {.lex_state = 71},
  [289] = {.lex_state = 71},
  [290] = {.lex_state = 71},
  [291] = {.lex_state = 71},
  [292] = {.lex_state = 71},
  [293] = {.lex_state = 7, .external_lex_state = 3},
  [294] = {.lex_state = 7, .external_lex_state = 3},
  [295] = {.lex_state = 71},
  [296] = {.lex_state = 71},
  [297] = {.lex_state = 71},
  [298] = {.lex_state = 71},
  [299] = {.lex_state = 71},
  [300] = {.lex_state = 71},
  [301] = {.lex_state = 71},
  [302] = {.lex_state = 71},
  [303] = {.lex_state = 71},
  [304] = {.lex_state = 71},
  [305] = {.lex_state = 71},
  [306] = {.lex_state = 71},
  [307] = {.lex_state = 71},
  [308] = {.lex_state = 71},
  [309] = {.lex_state = 71},
  [310] = {.lex_state = 71},
  [311] = {.lex_state = 71},
  [312] = {.lex_state = 71},
  [313] = {.lex_state = 71},
  [314] = {.lex_state = 71},
  [315] = {.lex_state = 71},
  [316] = {.lex_state = 71},
  [317] = {.lex_state = 71},
  [318] = {.lex_state = 71},
  [319] = {.lex_state = 71},
  [320] = {.lex_state = 71},
  [321] = {.lex_state = 71},
  [322] = {.lex_state = 71},
  [323] = {.lex_state = 71},
  [324] = {.lex_state = 71},
  [325] = {.lex_state = 71},
  [326] = {.lex_state = 71},
  [327] = {.lex_state = 71},
  [328] = {.lex_state = 71},
  [329] = {.lex_state = 71},
  [330] = {.lex_state = 71},
  [331] = {.lex_state = 71},
  [332] = {.lex_state = 71},
  [333] = {.lex_state = 71},
  [334] = {.lex_state = 71},
  [335] = {.lex_state = 71},
  [336] = {.lex_state = 71},
  [337] = {.lex_state = 71},
  [338] = {.lex_state = 71},
  [339] = {.lex_state = 71},
  [340] = {.lex_state = 71},
  [341] = {.lex_state = 71},
  [342] = {.lex_state = 71},
  [343] = {.lex_state = 71},
  [344] = {.lex_state = 71},
  [345] = {.lex_state = 71},
  [346] = {.lex_state = 71},
  [347] = {.lex_state = 71},
  [348] = {.lex_state = 71},
  [349] = {.lex_state = 71},
  [350] = {.lex_state = 71},
  [351] = {.lex_state = 71},
  [352] = {.lex_state = 71},
  [353] = {.lex_state = 71},
  [354] = {.lex_state = 71},
  [355] = {.lex_state = 71},
  [356] = {.lex_state = 71},
  [357] = {.lex_state = 71},
  [358] = {.lex_state = 71},
  [359] = {.lex_state = 71},
  [360] = {.lex_state = 71},
  [361] = {.lex_state = 71},
  [362] = {.lex_state = 71},
  [363] = {.lex_state = 71},
  [364] = {.lex_state = 71},
  [365] = {.lex_state = 71},
  [366] = {.lex_state = 71},
  [367] = {.lex_state = 7, .external_lex_state = 3},
  [368] = {.lex_state = 71},
  [369] = {.lex_state = 71},
  [370] = {.lex_state = 71},
  [371] = {.lex_state = 71},
  [372] = {.lex_state = 71},
  [373] = {.lex_state = 71},
  [374] = {.lex_state = 71},
  [375] = {.lex_state = 71},
  [376] = {.lex_state = 71},
  [377] = {.lex_state = 71},
  [378] = {.lex_state = 71},
  [379] = {.lex_state = 71},
  [380] = {.lex_state = 71},
  [381] = {.lex_state = 71},
  [382] = {.lex_state = 71},
  [383] = {.lex_state = 71},
  [384] = {.lex_state = 71},
  [385] = {.lex_state = 71},
  [386] = {.lex_state = 71},
  [387] = {.lex_state = 71},
  [388] = {.lex_state = 71},
  [389] = {.lex_state = 71},
  [390] = {.lex_state = 71},
  [391] = {.lex_state = 71},
  [392] = {.lex_state = 71},
  [393] = {.lex_state = 71},
  [394] = {.lex_state = 71},
  [395] = {.lex_state = 71},
  [396] = {.lex_state = 71},
  [397] = {.lex_state = 71},
  [398] = {.lex_state = 71},
  [399] = {.lex_state = 71},
  [400] = {.lex_state = 71},
  [401] = {.lex_state = 71},
  [402] = {.lex_state = 71},
  [403] = {.lex_state = 71},
  [404] = {.lex_state = 71},
  [405] = {.lex_state = 71},
  [406] = {.lex_state = 71},
  [407] = {.lex_state = 71},
  [408] = {.lex_state = 71},
  [409] = {.lex_state = 71},
  [410] = {.lex_state = 71},
  [411] = {.lex_state = 71},
  [412] = {.lex_state = 71},
  [413] = {.lex_state = 8, .external_lex_state = 3},
  [414] = {.lex_state = 71},
  [415] = {.lex_state = 71},
  [416] = {.lex_state = 71},
  [417] = {.lex_state = 71},
  [418] = {.lex_state = 71},
  [419] = {.lex_state = 8, .external_lex_state = 3},
  [420] = {.lex_state = 71},
  [421] = {.lex_state = 71},
  [422] = {.lex_state = 71},
  [423] = {.lex_state = 71},
  [424] = {.lex_state = 71},
  [425] = {.lex_state = 71},
  [426] = {.lex_state = 71},
  [427] = {.lex_state = 71},
  [428] = {.lex_state = 71},
  [429] = {.lex_state = 71},
  [430] = {.lex_state = 71},
  [431] = {.lex_state = 71},
  [432] = {.lex_state = 71},
  [433] = {.lex_state = 71},
  [434] = {.lex_state = 71},
  [435] = {.lex_state = 71},
  [436] = {.lex_state = 71},
  [437] = {.lex_state = 71},
  [438] = {.lex_state = 71},
  [439] = {.lex_state = 71},
  [440] = {.lex_state = 71},
  [441] = {.lex_state = 71},
  [442] = {.lex_state = 71},
  [443] = {.lex_state = 71},
  [444] = {.lex_state = 71},
  [445] = {.lex_state = 71},
  [446] = {.lex_state = 71},
  [447] = {.lex_state = 71},
  [448] = {.lex_state = 71},
  [449] = {.lex_state = 71},
  [450] = {.lex_state = 71},
  [451] = {.lex_state = 71},
  [452] = {.lex_state = 7, .external_lex_state = 3},
  [453] = {.lex_state = 7, .external_lex_state = 3},
  [454] = {.lex_state = 7, .external_lex_state = 3},
  [455] = {.lex_state = 7, .external_lex_state = 3},
  [456] = {.lex_state = 7, .external_lex_state = 3},
  [457] = {.lex_state = 7, .external_lex_state = 3},
  [458] = {.lex_state = 7, .external_lex_state = 3},
  [459] = {.lex_state = 7, .external_lex_state = 3},
  [460] = {.lex_state = 7, .external_lex_state = 3},
  [461] = {.lex_state = 19},
  [462] = {.lex_state = 19},
  [463] = {.lex_state = 19},
  [464] = {.lex_state = 19},
  [465] = {.lex_state = 19},
  [466] = {.lex_state = 71},
  [467] = {.lex_state = 7, .external_lex_state = 3},
  [468] = {.lex_state = 7, .external_lex_state = 3},
  [469] = {.lex_state = 71},
  [470] = {.lex_state = 71},
  [471] = {.lex_state = 7, .external_lex_state = 3},
  [472] = {.lex_state = 71},
  [473] = {.lex_state = 71},
  [474] = {.lex_state = 71},
  [475] = {.lex_state = 71, .external_lex_state = 4},
  [476] = {.lex_state = 71, .external_lex_state = 4},
  [477] = {.lex_state = 71},
  [478] = {.lex_state = 71},
  [479] = {.lex_state = 71, .external_lex_state = 4},
  [480] = {.lex_state = 71, .external_lex_state = 4},
  [481] = {.lex_state = 71},
  [482] = {.lex_state = 71, .external_lex_state = 4},
  [483] = {.lex_state = 71, .external_lex_state = 4},
  [484] = {.lex_state = 71},
  [485] = {.lex_state = 71},
  [486] = {.lex_state = 71, .external_lex_state = 4},
  [487] = {.lex_state = 71},
  [488] = {.lex_state = 71},
  [489] = {.lex_state = 71},
  [490] = {.lex_state = 71, .external_lex_state = 4},
  [491] = {.lex_state = 8, .external_lex_state = 2},
  [492] = {.lex_state = 71},
  [493] = {.lex_state = 71},
  [494] = {.lex_state = 8, .external_lex_state = 3},
  [495] = {.lex_state = 71},
  [496] = {.lex_state = 71},
  [497] = {.lex_state = 71, .external_lex_state = 4},
  [498] = {.lex_state = 71, .external_lex_state = 4},
  [499] = {.lex_state = 71, .external_lex_state = 4},
  [500] = {.lex_state = 8, .external_lex_state = 2},
  [501] = {.lex_state = 71},
  [502] = {.lex_state = 71, .external_lex_state = 4},
  [503] = {.lex_state = 71, .external_lex_state = 4},
  [504] = {.lex_state = 71, .external_lex_state = 4},
  [505] = {.lex_state = 71},
  [506] = {.lex_state = 71},
  [507] = {.lex_state = 71, .external_lex_state = 4},
  [508] = {.lex_state = 71, .external_lex_state = 4},
  [509] = {.lex_state = 71, .external_lex_state = 4},
  [510] = {.lex_state = 71},
  [511] = {.lex_state = 71},
  [512] = {.lex_state = 71},
  [513] = {.lex_state = 71},
  [514] = {.lex_state = 71, .external_lex_state = 4},
  [515] = {.lex_state = 9, .external_lex_state = 2},
  [516] = {.lex_state = 71, .external_lex_state = 4},
  [517] = {.lex_state = 8, .external_lex_state = 2},
  [518] = {.lex_state = 71, .external_lex_state = 4},
  [519] = {.lex_state = 71},
  [520] = {.lex_state = 8, .external_lex_state = 3},
  [521] = {.lex_state = 71},
  [522] = {.lex_state = 71},
  [523] = {.lex_state = 71},
  [524] = {.lex_state = 71},
  [525] = {.lex_state = 71},
  [526] = {.lex_state = 71},
  [527] = {.lex_state = 71},
  [528] = {.lex_state = 71},
  [529] = {.lex_state = 71},
  [530] = {.lex_state = 71},
  [531] = {.lex_state = 8, .external_lex_state = 3},
  [532] = {.lex_state = 71},
  [533] = {.lex_state = 71},
  [534] = {.lex_state = 71},
  [535] = {.lex_state = 71},
  [536] = {.lex_state = 71},
  [537] = {.lex_state = 8, .external_lex_state = 2},
  [538] = {.lex_state = 71},
  [539] = {.lex_state = 71},
  [540] = {.lex_state = 71},
  [541] = {.lex_state = 71},
  [542] = {.lex_state = 71},
  [543] = {.lex_state = 71},
  [544] = {.lex_state = 71},
  [545] = {.lex_state = 71},
  [546] = {.lex_state = 71},
  [547] = {.lex_state = 71},
  [548] = {.lex_state = 71},
  [549] = {.lex_state = 71},
  [550] = {.lex_state = 71},
  [551] = {.lex_state = 71},
  [552] = {.lex_state = 71},
  [553] = {.lex_state = 71},
  [554] = {.lex_state = 71},
  [555] = {.lex_state = 71},
  [556] = {.lex_state = 71},
  [557] = {.lex_state = 71},
  [558] = {.lex_state = 71},
  [559] = {.lex_state = 71},
  [560] = {.lex_state = 71},
  [561] = {.lex_state = 71},
  [562] = {.lex_state = 71},
  [563] = {.lex_state = 71},
  [564] = {.lex_state = 71},
  [565] = {.lex_state = 71},
  [566] = {.lex_state = 71},
  [567] = {.lex_state = 19},
  [568] = {.lex_state = 71},
  [569] = {.lex_state = 71},
  [570] = {.lex_state = 71},
  [571] = {.lex_state = 71},
  [572] = {.lex_state = 71},
  [573] = {.lex_state = 71},
  [574] = {.lex_state = 71},
  [575] = {.lex_state = 71},
  [576] = {.lex_state = 71},
  [577] = {.lex_state = 71},
  [578] = {.lex_state = 71},
  [579] = {.lex_state = 71},
  [580] = {.lex_state = 71},
  [581] = {.lex_state = 71},
  [582] = {.lex_state = 71},
  [583] = {.lex_state = 71},
  [584] = {.lex_state = 71},
  [585] = {.lex_state = 71},
  [586] = {.lex_state = 71},
  [587] = {.lex_state = 71},
  [588] = {.lex_state = 71},
  [589] = {.lex_state = 71},
  [590] = {.lex_state = 71},
  [591] = {.lex_state = 71},
  [592] = {.lex_state = 71},
  [593] = {.lex_state = 71},
  [594] = {.lex_state = 71},
  [595] = {.lex_state = 71},
  [596] = {.lex_state = 71},
  [597] = {.lex_state = 71},
  [598] = {.lex_state = 71},
  [599] = {.lex_state = 71},
  [600] = {.lex_state = 71},
  [601] = {.lex_state = 71},
  [602] = {.lex_state = 71},
  [603] = {.lex_state = 71},
  [604] = {.lex_state = 71},
  [605] = {.lex_state = 71},
  [606] = {.lex_state = 71},
  [607] = {.lex_state = 71},
  [608] = {.lex_state = 71},
  [609] = {.lex_state = 71},
  [610] = {.lex_state = 71},
  [611] = {.lex_state = 8, .external_lex_state = 3},
  [612] = {.lex_state = 71},
  [613] = {.lex_state = 71},
  [614] = {.lex_state = 71},
  [615] = {.lex_state = 71},
  [616] = {.lex_state = 71},
  [617] = {.lex_state = 71},
  [618] = {.lex_state = 71},
  [619] = {.lex_state = 71},
  [620] = {.lex_state = 71},
  [621] = {.lex_state = 71},
  [622] = {.lex_state = 71},
  [623] = {.lex_state = 71},
  [624] = {.lex_state = 71},
  [625] = {.lex_state = 71},
  [626] = {.lex_state = 71},
  [627] = {.lex_state = 71},
  [628] = {.lex_state = 71},
  [629] = {.lex_state = 71},
  [630] = {.lex_state = 71},
  [631] = {.lex_state = 71},
  [632] = {.lex_state = 71},
  [633] = {.lex_state = 71},
  [634] = {.lex_state = 71},
  [635] = {.lex_state = 71},
  [636] = {.lex_state = 71},
  [637] = {.lex_state = 71},
  [638] = {.lex_state = 71},
  [639] = {.lex_state = 71},
  [640] = {.lex_state = 71},
  [641] = {.lex_state = 71},
  [642] = {.lex_state = 71},
  [643] = {.lex_state = 71},
  [644] = {.lex_state = 71},
  [645] = {.lex_state = 71},
  [646] = {.lex_state = 71},
  [647] = {.lex_state = 71},
  [648] = {.lex_state = 71},
  [649] = {.lex_state = 71},
  [650] = {.lex_state = 8, .external_lex_state = 3},
  [651] = {.lex_state = 71},
  [652] = {.lex_state = 71},
  [653] = {.lex_state = 71},
  [654] = {.lex_state = 71},
  [655] = {.lex_state = 8, .external_lex_state = 2},
  [656] = {.lex_state = 8, .external_lex_state = 2},
  [657] = {.lex_state = 8, .external_lex_state = 2},
  [658] = {.lex_state = 8, .external_lex_state = 2},
  [659] = {.lex_state = 9, .external_lex_state = 2},
  [660] = {.lex_state = 8, .external_lex_state = 2},
  [661] = {.lex_state = 8, .external_lex_state = 3},
  [662] = {.lex_state = 8, .external_lex_state = 2},
  [663] = {.lex_state = 8, .external_lex_state = 3},
  [664] = {.lex_state = 8, .external_lex_state = 2},
  [665] = {.lex_state = 8, .external_lex_state = 2},
  [666] = {.lex_state = 8, .external_lex_state = 2},
  [667] = {.lex_state = 8, .external_lex_state = 2},
  [668] = {.lex_state = 8, .external_lex_state = 2},
  [669] = {.lex_state = 8, .external_lex_state = 2},
  [670] = {.lex_state = 8, .external_lex_state = 2},
  [671] = {.lex_state = 71},
  [672] = {.lex_state = 71},
  [673] = {.lex_state = 71},
  [674] = {.lex_state = 71},
  [675] = {.lex_state = 71},
  [676] = {.lex_state = 71},
  [677] = {.lex_state = 71},
  [678] = {.lex_state = 71},
  [679] = {.lex_state = 71},
  [680] = {.lex_state = 71},
  [681] = {.lex_state = 8, .external_lex_state = 2},
  [682] = {.lex_state = 8, .external_lex_state = 3},
  [683] = {.lex_state = 8, .external_lex_state = 3},
  [684] = {.lex_state = 8, .external_lex_state = 3},
  [685] = {.lex_state = 8, .external_lex_state = 3},
  [686] = {.lex_state = 8, .external_lex_state = 3},
  [687] = {.lex_state = 19},
  [688] = {.lex_state = 8, .external_lex_state = 3},
  [689] = {.lex_state = 8, .external_lex_state = 3},
  [690] = {.lex_state = 9, .external_lex_state = 2},
  [691] = {.lex_state = 8, .external_lex_state = 2},
  [692] = {.lex_state = 8, .external_lex_state = 2},
  [693] = {.lex_state = 8, .external_lex_state = 3},
  [694] = {.lex_state = 21},
  [695] = {.lex_state = 19},
  [696] = {.lex_state = 8, .external_lex_state = 3},
  [697] = {.lex_state = 8, .external_lex_state = 3},
  [698] = {.lex_state = 8, .external_lex_state = 3},
  [699] = {.lex_state = 8, .external_lex_state = 3},
  [700] = {.lex_state = 19},
  [701] = {.lex_state = 21},
  [702] = {.lex_state = 19},
  [703] = {.lex_state = 21},
  [704] = {.lex_state = 19},
  [705] = {.lex_state = 21},
  [706] = {.lex_state = 21},
  [707] = {.lex_state = 19},
  [708] = {.lex_state = 8, .external_lex_state = 3},
  [709] = {.lex_state = 21},
  [710] = {.lex_state = 21},
  [711] = {.lex_state = 8, .external_lex_state = 2},
  [712] = {.lex_state = 19},
  [713] = {.lex_state = 8, .external_lex_state = 2},
  [714] = {.lex_state = 19},
  [715] = {.lex_state = 19},
  [716] = {.lex_state = 19},
  [717] = {.lex_state = 19},
  [718] = {.lex_state = 8, .external_lex_state = 2},
  [719] = {.lex_state = 8, .external_lex_state = 2},
  [720] = {.lex_state = 19},
  [721] = {.lex_state = 19},
  [722] = {.lex_state = 19},
  [723] = {.lex_state = 19},
  [724] = {.lex_state = 8, .external_lex_state = 3},
  [725] = {.lex_state = 19},
  [726] = {.lex_state = 19},
  [727] = {.lex_state = 19},
  [728] = {.lex_state = 19},
  [729] = {.lex_state = 19},
  [730] = {.lex_state = 19},
  [731] = {.lex_state = 19},
  [732] = {.lex_state = 19},
  [733] = {.lex_state = 19},
  [734] = {.lex_state = 9, .external_lex_state = 2},
  [735] = {.lex_state = 19},
  [736] = {.lex_state = 19},
  [737] = {.lex_state = 19},
  [738] = {.lex_state = 19},
  [739] = {.lex_state = 8, .external_lex_state = 2},
  [740] = {.lex_state = 19},
  [741] = {.lex_state = 8, .external_lex_state = 2},
  [742] = {.lex_state = 19},
  [743] = {.lex_state = 19},
  [744] = {.lex_state = 19},
  [745] = {.lex_state = 19},
  [746] = {.lex_state = 8, .external_lex_state = 2},
  [747] = {.lex_state = 19},
  [748] = {.lex_state = 19},
  [749] = {.lex_state = 19},
  [750] = {.lex_state = 19},
  [751] = {.lex_state = 19},
  [752] = {.lex_state = 19},
  [753] = {.lex_state = 8, .external_lex_state = 2},
  [754] = {.lex_state = 19},
  [755] = {.lex_state = 19},
  [756] = {.lex_state = 19},
  [757] = {.lex_state = 19},
  [758] = {.lex_state = 19},
  [759] = {.lex_state = 19},
  [760] = {.lex_state = 19},
  [761] = {.lex_state = 19},
  [762] = {.lex_state = 19},
  [763] = {.lex_state = 19},
  [764] = {.lex_state = 19},
  [765] = {.lex_state = 19},
  [766] = {.lex_state = 19},
  [767] = {.lex_state = 19},
  [768] = {.lex_state = 19},
  [769] = {.lex_state = 19},
  [770] = {.lex_state = 8, .external_lex_state = 2},
  [771] = {.lex_state = 19},
  [772] = {.lex_state = 19},
  [773] = {.lex_state = 19},
  [774] = {.lex_state = 19},
  [775] = {.lex_state = 19},
  [776] = {.lex_state = 19},
  [777] = {.lex_state = 19},
  [778] = {.lex_state = 19},
  [779] = {.lex_state = 19},
  [780] = {.lex_state = 8, .external_lex_state = 3},
  [781] = {.lex_state = 19},
  [782] = {.lex_state = 19},
  [783] = {.lex_state = 19},
  [784] = {.lex_state = 19},
  [785] = {.lex_state = 19},
  [786] = {.lex_state = 19},
  [787] = {.lex_state = 8, .external_lex_state = 3},
  [788] = {.lex_state = 19},
  [789] = {.lex_state = 19},
  [790] = {.lex_state = 19},
  [791] = {.lex_state = 8, .external_lex_state = 2},
  [792] = {.lex_state = 19},
  [793] = {.lex_state = 19},
  [794] = {.lex_state = 19},
  [795] = {.lex_state = 19},
  [796] = {.lex_state = 19},
  [797] = {.lex_state = 19},
  [798] = {.lex_state = 19},
  [799] = {.lex_state = 19},
  [800] = {.lex_state = 19},
  [801] = {.lex_state = 19},
  [802] = {.lex_state = 19},
  [803] = {.lex_state = 8, .external_lex_state = 3},
  [804] = {.lex_state = 8, .external_lex_state = 3},
  [805] = {.lex_state = 19},
  [806] = {.lex_state = 19},
  [807] = {.lex_state = 19},
  [808] = {.lex_state = 19},
  [809] = {.lex_state = 19},
  [810] = {.lex_state = 19},
  [811] = {.lex_state = 19},
  [812] = {.lex_state = 19},
  [813] = {.lex_state = 19},
  [814] = {.lex_state = 19},
  [815] = {.lex_state = 19},
  [816] = {.lex_state = 8, .external_lex_state = 2},
  [817] = {.lex_state = 8, .external_lex_state = 2},
  [818] = {.lex_state = 19},
  [819] = {.lex_state = 8, .external_lex_state = 3},
  [820] = {.lex_state = 19},
  [821] = {.lex_state = 19},
  [822] = {.lex_state = 19},
  [823] = {.lex_state = 19},
  [824] = {.lex_state = 19},
  [825] = {.lex_state = 19},
  [826] = {.lex_state = 19},
  [827] = {.lex_state = 19},
  [828] = {.lex_state = 19},
  [829] = {.lex_state = 19},
  [830] = {.lex_state = 19},
  [831] = {.lex_state = 19},
  [832] = {.lex_state = 8, .external_lex_state = 2},
  [833] = {.lex_state = 8, .external_lex_state = 2},
  [834] = {.lex_state = 19},
  [835] = {.lex_state = 19},
  [836] = {.lex_state = 19},
  [837] = {.lex_state = 19},
  [838] = {.lex_state = 19},
  [839] = {.lex_state = 19},
  [840] = {.lex_state = 8, .external_lex_state = 2},
  [841] = {.lex_state = 19},
  [842] = {.lex_state = 19},
  [843] = {.lex_state = 8, .external_lex_state = 3},
  [844] = {.lex_state = 19},
  [845] = {.lex_state = 19},
  [846] = {.lex_state = 19},
  [847] = {.lex_state = 19},
  [848] = {.lex_state = 19},
  [849] = {.lex_state = 19},
  [850] = {.lex_state = 19},
  [851] = {.lex_state = 19},
  [852] = {.lex_state = 19},
  [853] = {.lex_state = 19},
  [854] = {.lex_state = 19},
  [855] = {.lex_state = 19},
  [856] = {.lex_state = 19},
  [857] = {.lex_state = 19},
  [858] = {.lex_state = 19},
  [859] = {.lex_state = 19},
  [860] = {.lex_state = 19},
  [861] = {.lex_state = 19},
  [862] = {.lex_state = 19},
  [863] = {.lex_state = 19},
  [864] = {.lex_state = 8, .external_lex_state = 3},
  [865] = {.lex_state = 8, .external_lex_state = 3},
  [866] = {.lex_state = 8, .external_lex_state = 3},
  [867] = {.lex_state = 8, .external_lex_state = 3},
  [868] = {.lex_state = 8, .external_lex_state = 3},
  [869] = {.lex_state = 8, .external_lex_state = 2},
  [870] = {.lex_state = 8, .external_lex_state = 3},
  [871] = {.lex_state = 8, .external_lex_state = 2},
  [872] = {.lex_state = 8, .external_lex_state = 3},
  [873] = {.lex_state = 8, .external_lex_state = 2},
  [874] = {.lex_state = 8, .external_lex_state = 2},
  [875] = {.lex_state = 8, .external_lex_state = 2},
  [876] = {.lex_state = 8, .external_lex_state = 2},
  [877] = {.lex_state = 21},
  [878] = {.lex_state = 21},
  [879] = {.lex_state = 8, .external_lex_state = 2},
  [880] = {.lex_state = 8, .external_lex_state = 2},
  [881] = {.lex_state = 8, .external_lex_state = 2},
  [882] = {.lex_state = 8, .external_lex_state = 3},
  [883] = {.lex_state = 8, .external_lex_state = 3},
  [884] = {.lex_state = 8, .external_lex_state = 3},
  [885] = {.lex_state = 8, .external_lex_state = 3},
  [886] = {.lex_state = 8, .external_lex_state = 2},
  [887] = {.lex_state = 8, .external_lex_state = 3},
  [888] = {.lex_state = 9, .external_lex_state = 2},
  [889] = {.lex_state = 9, .external_lex_state = 2},
  [890] = {.lex_state = 8, .external_lex_state = 2},
  [891] = {.lex_state = 9, .external_lex_state = 2},
  [892] = {.lex_state = 8, .external_lex_state = 2},
  [893] = {.lex_state = 8, .external_lex_state = 3},
  [894] = {.lex_state = 8, .external_lex_state = 3},
  [895] = {.lex_state = 8, .external_lex_state = 3},
  [896] = {.lex_state = 8, .external_lex_state = 3},
  [897] = {.lex_state = 8, .external_lex_state = 2},
  [898] = {.lex_state = 8, .external_lex_state = 3},
  [899] = {.lex_state = 8, .external_lex_state = 2},
  [900] = {.lex_state = 8, .external_lex_state = 3},
  [901] = {.lex_state = 8, .external_lex_state = 2},
  [902] = {.lex_state = 9, .external_lex_state = 2},
  [903] = {.lex_state = 8, .external_lex_state = 3},
  [904] = {.lex_state = 8, .external_lex_state = 2},
  [905] = {.lex_state = 8, .external_lex_state = 2},
  [906] = {.lex_state = 8, .external_lex_state = 2},
  [907] = {.lex_state = 8, .external_lex_state = 2},
  [908] = {.lex_state = 8, .external_lex_state = 2},
  [909] = {.lex_state = 8, .external_lex_state = 3},
  [910] = {.lex_state = 8, .external_lex_state = 2},
  [911] = {.lex_state = 8, .external_lex_state = 2},
  [912] = {.lex_state = 8, .external_lex_state = 2},
  [913] = {.lex_state = 9, .external_lex_state = 2},
  [914] = {.lex_state = 9, .external_lex_state = 2},
  [915] = {.lex_state = 8, .external_lex_state = 3},
  [916] = {.lex_state = 9, .external_lex_state = 2},
  [917] = {.lex_state = 8, .external_lex_state = 3},
  [918] = {.lex_state = 9, .external_lex_state = 2},
  [919] = {.lex_state = 8, .external_lex_state = 2},
  [920] = {.lex_state = 8, .external_lex_state = 2},
  [921] = {.lex_state = 8, .external_lex_state = 2},
  [922] = {.lex_state = 8, .external_lex_state = 3},
  [923] = {.lex_state = 8, .external_lex_state = 3},
  [924] = {.lex_state = 8, .external_lex_state = 2},
  [925] = {.lex_state = 8, .external_lex_state = 3},
  [926] = {.lex_state = 8, .external_lex_state = 3},
  [927] = {.lex_state = 8, .external_lex_state = 3},
  [928] = {.lex_state = 8, .external_lex_state = 3},
  [929] = {.lex_state = 8, .external_lex_state = 2},
  [930] = {.lex_state = 8, .external_lex_state = 2},
  [931] = {.lex_state = 8, .external_lex_state = 3},
  [932] = {.lex_state = 8, .external_lex_state = 3},
  [933] = {.lex_state = 8, .external_lex_state = 2},
  [934] = {.lex_state = 8, .external_lex_state = 3},
  [935] = {.lex_state = 8, .external_lex_state = 2},
  [936] = {.lex_state = 8, .external_lex_state = 3},
  [937] = {.lex_state = 8, .external_lex_state = 3},
  [938] = {.lex_state = 8, .external_lex_state = 2},
  [939] = {.lex_state = 8, .external_lex_state = 2},
  [940] = {.lex_state = 8, .external_lex_state = 2},
  [941] = {.lex_state = 8, .external_lex_state = 3},
  [942] = {.lex_state = 8, .external_lex_state = 2},
  [943] = {.lex_state = 8, .external_lex_state = 3},
  [944] = {.lex_state = 8, .external_lex_state = 3},
  [945] = {.lex_state = 8, .external_lex_state = 3},
  [946] = {.lex_state = 8, .external_lex_state = 3},
  [947] = {.lex_state = 8, .external_lex_state = 3},
  [948] = {.lex_state = 9, .external_lex_state = 2},
  [949] = {.lex_state = 8, .external_lex_state = 2},
  [950] = {.lex_state = 8, .external_lex_state = 3},
  [951] = {.lex_state = 8, .external_lex_state = 3},
  [952] = {.lex_state = 9, .external_lex_state = 2},
  [953] = {.lex_state = 8, .external_lex_state = 2},
  [954] = {.lex_state = 8, .external_lex_state = 3},
  [955] = {.lex_state = 8, .external_lex_state = 3},
  [956] = {.lex_state = 8, .external_lex_state = 2},
  [957] = {.lex_state = 8, .external_lex_state = 2},
  [958] = {.lex_state = 8, .external_lex_state = 2},
  [959] = {.lex_state = 8, .external_lex_state = 2},
  [960] = {.lex_state = 8, .external_lex_state = 3},
  [961] = {.lex_state = 9, .external_lex_state = 2},
  [962] = {.lex_state = 9, .external_lex_state = 2},
  [963] = {.lex_state = 8, .external_lex_state = 3},
  [964] = {.lex_state = 8, .external_lex_state = 2},
  [965] = {.lex_state = 8, .external_lex_state = 3},
  [966] = {.lex_state = 8, .external_lex_state = 2},
  [967] = {.lex_state = 8, .external_lex_state = 3},
  [968] = {.lex_state = 8, .external_lex_state = 2},
  [969] = {.lex_state = 8, .external_lex_state = 3},
  [970] = {.lex_state = 8, .external_lex_state = 2},
  [971] = {.lex_state = 8, .external_lex_state = 2},
  [972] = {.lex_state = 8, .external_lex_state = 2},
  [973] = {.lex_state = 8, .external_lex_state = 2},
  [974] = {.lex_state = 8, .external_lex_state = 2},
  [975] = {.lex_state = 8, .external_lex_state = 2},
  [976] = {.lex_state = 9, .external_lex_state = 2},
  [977] = {.lex_state = 9, .external_lex_state = 2},
  [978] = {.lex_state = 9, .external_lex_state = 2},
  [979] = {.lex_state = 9, .external_lex_state = 2},
  [980] = {.lex_state = 8, .external_lex_state = 2},
  [981] = {.lex_state = 8, .external_lex_state = 2},
  [982] = {.lex_state = 9, .external_lex_state = 2},
  [983] = {.lex_state = 8, .external_lex_state = 2},
  [984] = {.lex_state = 8, .external_lex_state = 3},
  [985] = {.lex_state = 8, .external_lex_state = 3},
  [986] = {.lex_state = 9, .external_lex_state = 2},
  [987] = {.lex_state = 9, .external_lex_state = 2},
  [988] = {.lex_state = 9, .external_lex_state = 2},
  [989] = {.lex_state = 9, .external_lex_state = 2},
  [990] = {.lex_state = 8, .external_lex_state = 3},
  [991] = {.lex_state = 9, .external_lex_state = 2},
  [992] = {.lex_state = 8, .external_lex_state = 3},
  [993] = {.lex_state = 9, .external_lex_state = 2},
  [994] = {.lex_state = 8, .external_lex_state = 2},
  [995] = {.lex_state = 8, .external_lex_state = 2},
  [996] = {.lex_state = 8, .external_lex_state = 3},
  [997] = {.lex_state = 9, .external_lex_state = 2},
  [998] = {.lex_state = 8, .external_lex_state = 2},
  [999] = {.lex_state = 8, .external_lex_state = 2},
  [1000] = {.lex_state = 8, .external_lex_state = 3},
  [1001] = {.lex_state = 8, .external_lex_state = 2},
  [1002] = {.lex_state = 8, .external_lex_state = 3},
  [1003] = {.lex_state = 19},
  [1004] = {.lex_state = 8, .external_lex_state = 2},
  [1005] = {.lex_state = 8, .external_lex_state = 2},
  [1006] = {.lex_state = 19},
  [1007] = {.lex_state = 8, .external_lex_state = 2},
  [1008] = {.lex_state = 19},
  [1009] = {.lex_state = 19},
  [1010] = {.lex_state = 8, .external_lex_state = 2},
  [1011] = {.lex_state = 19},
  [1012] = {.lex_state = 8, .external_lex_state = 2},
  [1013] = {.lex_state = 8, .external_lex_state = 2},
  [1014] = {.lex_state = 8, .external_lex_state = 2},
  [1015] = {.lex_state = 8, .external_lex_state = 2},
  [1016] = {.lex_state = 19},
  [1017] = {.lex_state = 19},
  [1018] = {.lex_state = 19},
  [1019] = {.lex_state = 19},
  [1020] = {.lex_state = 19},
  [1021] = {.lex_state = 19},
  [1022] = {.lex_state = 19},
  [1023] = {.lex_state = 19},
  [1024] = {.lex_state = 19},
  [1025] = {.lex_state = 19},
  [1026] = {.lex_state = 19},
  [1027] = {.lex_state = 19},
  [1028] = {.lex_state = 19},
  [1029] = {.lex_state = 19},
  [1030] = {.lex_state = 19},
  [1031] = {.lex_state = 71, .external_lex_state = 4},
  [1032] = {.lex_state = 71, .external_lex_state = 4},
  [1033] = {.lex_state = 71, .external_lex_state = 4},
  [1034] = {.lex_state = 71, .external_lex_state = 4},
  [1035] = {.lex_state = 11, .external_lex_state = 3},
  [1036] = {.lex_state = 19},
  [1037] = {.lex_state = 71, .external_lex_state = 4},
  [1038] = {.lex_state = 71, .external_lex_state = 4},
  [1039] = {.lex_state = 19},
  [1040] = {.lex_state = 19},
  [1041] = {.lex_state = 19},
  [1042] = {.lex_state = 19},
  [1043] = {.lex_state = 19},
  [1044] = {.lex_state = 11, .external_lex_state = 2},
  [1045] = {.lex_state = 11, .external_lex_state = 2},
  [1046] = {.lex_state = 11, .external_lex_state = 3},
  [1047] = {.lex_state = 11, .external_lex_state = 2},
  [1048] = {.lex_state = 11, .external_lex_state = 2},
  [1049] = {.lex_state = 11, .external_lex_state = 3},
  [1050] = {.lex_state = 11, .external_lex_state = 2},
  [1051] = {.lex_state = 11, .external_lex_state = 3},
  [1052] = {.lex_state = 11, .external_lex_state = 2},
  [1053] = {.lex_state = 11, .external_lex_state = 2},
  [1054] = {.lex_state = 11, .external_lex_state = 2},
  [1055] = {.lex_state = 11, .external_lex_state = 2},
  [1056] = {.lex_state = 11, .external_lex_state = 2},
  [1057] = {.lex_state = 11, .external_lex_state = 2},
  [1058] = {.lex_state = 11, .external_lex_state = 2},
  [1059] = {.lex_state = 11, .external_lex_state = 2},
  [1060] = {.lex_state = 11, .external_lex_state = 2},
  [1061] = {.lex_state = 11, .external_lex_state = 2},
  [1062] = {.lex_state = 11, .external_lex_state = 2},
  [1063] = {.lex_state = 11, .external_lex_state = 2},
  [1064] = {.lex_state = 11, .external_lex_state = 2},
  [1065] = {.lex_state = 11, .external_lex_state = 2},
  [1066] = {.lex_state = 11, .external_lex_state = 2},
  [1067] = {.lex_state = 11, .external_lex_state = 2},
  [1068] = {.lex_state = 11, .external_lex_state = 2},
  [1069] = {.lex_state = 11, .external_lex_state = 2},
  [1070] = {.lex_state = 11, .external_lex_state = 2},
  [1071] = {.lex_state = 71},
  [1072] = {.lex_state = 11, .external_lex_state = 2},
  [1073] = {.lex_state = 19},
  [1074] = {.lex_state = 11, .external_lex_state = 2},
  [1075] = {.lex_state = 11, .external_lex_state = 2},
  [1076] = {.lex_state = 11, .external_lex_state = 3},
  [1077] = {.lex_state = 11, .external_lex_state = 2},
  [1078] = {.lex_state = 11, .external_lex_state = 2},
  [1079] = {.lex_state = 11, .external_lex_state = 2},
  [1080] = {.lex_state = 11, .external_lex_state = 2},
  [1081] = {.lex_state = 11, .external_lex_state = 2},
  [1082] = {.lex_state = 11, .external_lex_state = 2},
  [1083] = {.lex_state = 19},
  [1084] = {.lex_state = 11, .external_lex_state = 2},
  [1085] = {.lex_state = 11, .external_lex_state = 2},
  [1086] = {.lex_state = 11, .external_lex_state = 2},
  [1087] = {.lex_state = 11, .external_lex_state = 2},
  [1088] = {.lex_state = 11, .external_lex_state = 2},
  [1089] = {.lex_state = 11, .external_lex_state = 2},
  [1090] = {.lex_state = 11, .external_lex_state = 2},
  [1091] = {.lex_state = 11, .external_lex_state = 2},
  [1092] = {.lex_state = 11, .external_lex_state = 2},
  [1093] = {.lex_state = 11, .external_lex_state = 2},
  [1094] = {.lex_state = 11, .external_lex_state = 2},
  [1095] = {.lex_state = 11, .external_lex_state = 2},
  [1096] = {.lex_state = 71},
  [1097] = {.lex_state = 11, .external_lex_state = 2},
  [1098] = {.lex_state = 11, .external_lex_state = 2},
  [1099] = {.lex_state = 11, .external_lex_state = 2},
  [1100] = {.lex_state = 11, .external_lex_state = 2},
  [1101] = {.lex_state = 11, .external_lex_state = 2},
  [1102] = {.lex_state = 71},
  [1103] = {.lex_state = 11, .external_lex_state = 2},
  [1104] = {.lex_state = 11, .external_lex_state = 2},
  [1105] = {.lex_state = 11, .external_lex_state = 2},
  [1106] = {.lex_state = 11, .external_lex_state = 2},
  [1107] = {.lex_state = 11, .external_lex_state = 2},
  [1108] = {.lex_state = 11, .external_lex_state = 2},
  [1109] = {.lex_state = 11, .external_lex_state = 2},
  [1110] = {.lex_state = 11, .external_lex_state = 2},
  [1111] = {.lex_state = 11, .external_lex_state = 2},
  [1112] = {.lex_state = 19},
  [1113] = {.lex_state = 11, .external_lex_state = 2},
  [1114] = {.lex_state = 19},
  [1115] = {.lex_state = 11, .external_lex_state = 2},
  [1116] = {.lex_state = 11, .external_lex_state = 2},
  [1117] = {.lex_state = 19},
  [1118] = {.lex_state = 11, .external_lex_state = 2},
  [1119] = {.lex_state = 11, .external_lex_state = 3},
  [1120] = {.lex_state = 11, .external_lex_state = 2},
  [1121] = {.lex_state = 11, .external_lex_state = 2},
  [1122] = {.lex_state = 11, .external_lex_state = 2},
  [1123] = {.lex_state = 11, .external_lex_state = 2},
  [1124] = {.lex_state = 19},
  [1125] = {.lex_state = 11, .external_lex_state = 2},
  [1126] = {.lex_state = 11, .external_lex_state = 2},
  [1127] = {.lex_state = 11, .external_lex_state = 2},
  [1128] = {.lex_state = 11, .external_lex_state = 2},
  [1129] = {.lex_state = 11, .external_lex_state = 2},
  [1130] = {.lex_state = 11, .external_lex_state = 2},
  [1131] = {.lex_state = 19},
  [1132] = {.lex_state = 11, .external_lex_state = 2},
  [1133] = {.lex_state = 11, .external_lex_state = 2},
  [1134] = {.lex_state = 11, .external_lex_state = 2},
  [1135] = {.lex_state = 11, .external_lex_state = 2},
  [1136] = {.lex_state = 11, .external_lex_state = 2},
  [1137] = {.lex_state = 11, .external_lex_state = 2},
  [1138] = {.lex_state = 11, .external_lex_state = 2},
  [1139] = {.lex_state = 11, .external_lex_state = 2},
  [1140] = {.lex_state = 11, .external_lex_state = 2},
  [1141] = {.lex_state = 19},
  [1142] = {.lex_state = 11, .external_lex_state = 2},
  [1143] = {.lex_state = 11, .external_lex_state = 2},
  [1144] = {.lex_state = 11, .external_lex_state = 2},
  [1145] = {.lex_state = 11, .external_lex_state = 2},
  [1146] = {.lex_state = 11, .external_lex_state = 2},
  [1147] = {.lex_state = 11, .external_lex_state = 2},
  [1148] = {.lex_state = 71},
  [1149] = {.lex_state = 19},
  [1150] = {.lex_state = 11, .external_lex_state = 2},
  [1151] = {.lex_state = 11, .external_lex_state = 2},
  [1152] = {.lex_state = 19},
  [1153] = {.lex_state = 11, .external_lex_state = 2},
  [1154] = {.lex_state = 19},
  [1155] = {.lex_state = 11, .external_lex_state = 3},
  [1156] = {.lex_state = 11, .external_lex_state = 2},
  [1157] = {.lex_state = 19},
  [1158] = {.lex_state = 71},
  [1159] = {.lex_state = 11, .external_lex_state = 2},
  [1160] = {.lex_state = 11, .external_lex_state = 2},
  [1161] = {.lex_state = 11, .external_lex_state = 2},
  [1162] = {.lex_state = 11, .external_lex_state = 3},
  [1163] = {.lex_state = 11, .external_lex_state = 2},
  [1164] = {.lex_state = 11, .external_lex_state = 2},
  [1165] = {.lex_state = 11, .external_lex_state = 2},
  [1166] = {.lex_state = 19},
  [1167] = {.lex_state = 11, .external_lex_state = 3},
  [1168] = {.lex_state = 11, .external_lex_state = 2},
  [1169] = {.lex_state = 11, .external_lex_state = 2},
  [1170] = {.lex_state = 11, .external_lex_state = 3},
  [1171] = {.lex_state = 11, .external_lex_state = 3},
  [1172] = {.lex_state = 11, .external_lex_state = 3},
  [1173] = {.lex_state = 11, .external_lex_state = 3},
  [1174] = {.lex_state = 11, .external_lex_state = 3},
  [1175] = {.lex_state = 11, .external_lex_state = 3},
  [1176] = {.lex_state = 11, .external_lex_state = 3},
  [1177] = {.lex_state = 11, .external_lex_state = 2},
  [1178] = {.lex_state = 11, .external_lex_state = 2},
  [1179] = {.lex_state = 11, .external_lex_state = 2},
  [1180] = {.lex_state = 11, .external_lex_state = 2},
  [1181] = {.lex_state = 11, .external_lex_state = 2},
  [1182] = {.lex_state = 11, .external_lex_state = 2},
  [1183] = {.lex_state = 11, .external_lex_state = 3},
  [1184] = {.lex_state = 11, .external_lex_state = 3},
  [1185] = {.lex_state = 11, .external_lex_state = 3},
  [1186] = {.lex_state = 11, .external_lex_state = 3},
  [1187] = {.lex_state = 11, .external_lex_state = 3},
  [1188] = {.lex_state = 11, .external_lex_state = 2},
  [1189] = {.lex_state = 11, .external_lex_state = 2},
  [1190] = {.lex_state = 11, .external_lex_state = 2},
  [1191] = {.lex_state = 11, .external_lex_state = 3},
  [1192] = {.lex_state = 11, .external_lex_state = 3},
  [1193] = {.lex_state = 11, .external_lex_state = 3},
  [1194] = {.lex_state = 11, .external_lex_state = 3},
  [1195] = {.lex_state = 11, .external_lex_state = 3},
  [1196] = {.lex_state = 11, .external_lex_state = 3},
  [1197] = {.lex_state = 11, .external_lex_state = 3},
  [1198] = {.lex_state = 11, .external_lex_state = 3},
  [1199] = {.lex_state = 11, .external_lex_state = 2},
  [1200] = {.lex_state = 14, .external_lex_state = 2},
  [1201] = {.lex_state = 11, .external_lex_state = 2},
  [1202] = {.lex_state = 11, .external_lex_state = 3},
  [1203] = {.lex_state = 11, .external_lex_state = 2},
  [1204] = {.lex_state = 11, .external_lex_state = 2},
  [1205] = {.lex_state = 11, .external_lex_state = 2},
  [1206] = {.lex_state = 11, .external_lex_state = 3},
  [1207] = {.lex_state = 11, .external_lex_state = 3},
  [1208] = {.lex_state = 11, .external_lex_state = 2},
  [1209] = {.lex_state = 11, .external_lex_state = 3},
  [1210] = {.lex_state = 11, .external_lex_state = 3},
  [1211] = {.lex_state = 71},
  [1212] = {.lex_state = 11, .external_lex_state = 2},
  [1213] = {.lex_state = 11, .external_lex_state = 2},
  [1214] = {.lex_state = 11, .external_lex_state = 2},
  [1215] = {.lex_state = 11, .external_lex_state = 2},
  [1216] = {.lex_state = 11, .external_lex_state = 3},
  [1217] = {.lex_state = 11, .external_lex_state = 2},
  [1218] = {.lex_state = 11, .external_lex_state = 2},
  [1219] = {.lex_state = 11, .external_lex_state = 2},
  [1220] = {.lex_state = 11, .external_lex_state = 2},
  [1221] = {.lex_state = 11, .external_lex_state = 2},
  [1222] = {.lex_state = 11, .external_lex_state = 2},
  [1223] = {.lex_state = 11, .external_lex_state = 2},
  [1224] = {.lex_state = 11, .external_lex_state = 2},
  [1225] = {.lex_state = 11, .external_lex_state = 2},
  [1226] = {.lex_state = 71, .external_lex_state = 4},
  [1227] = {.lex_state = 71, .external_lex_state = 4},
  [1228] = {.lex_state = 11, .external_lex_state = 2},
  [1229] = {.lex_state = 11, .external_lex_state = 2},
  [1230] = {.lex_state = 11, .external_lex_state = 2},
  [1231] = {.lex_state = 11, .external_lex_state = 2},
  [1232] = {.lex_state = 11, .external_lex_state = 2},
  [1233] = {.lex_state = 11, .external_lex_state = 2},
  [1234] = {.lex_state = 11, .external_lex_state = 2},
  [1235] = {.lex_state = 11, .external_lex_state = 2},
  [1236] = {.lex_state = 11, .external_lex_state = 2},
  [1237] = {.lex_state = 11, .external_lex_state = 2},
  [1238] = {.lex_state = 11, .external_lex_state = 2},
  [1239] = {.lex_state = 71, .external_lex_state = 4},
  [1240] = {.lex_state = 71, .external_lex_state = 4},
  [1241] = {.lex_state = 11, .external_lex_state = 2},
  [1242] = {.lex_state = 11, .external_lex_state = 2},
  [1243] = {.lex_state = 11, .external_lex_state = 2},
  [1244] = {.lex_state = 11, .external_lex_state = 2},
  [1245] = {.lex_state = 11, .external_lex_state = 2},
  [1246] = {.lex_state = 11, .external_lex_state = 3},
  [1247] = {.lex_state = 11, .external_lex_state = 2},
  [1248] = {.lex_state = 11, .external_lex_state = 2},
  [1249] = {.lex_state = 11, .external_lex_state = 2},
  [1250] = {.lex_state = 11, .external_lex_state = 2},
  [1251] = {.lex_state = 71, .external_lex_state = 4},
  [1252] = {.lex_state = 11, .external_lex_state = 3},
  [1253] = {.lex_state = 71, .external_lex_state = 4},
  [1254] = {.lex_state = 11, .external_lex_state = 2},
  [1255] = {.lex_state = 11, .external_lex_state = 2},
  [1256] = {.lex_state = 11, .external_lex_state = 2},
  [1257] = {.lex_state = 11, .external_lex_state = 3},
  [1258] = {.lex_state = 11, .external_lex_state = 2},
  [1259] = {.lex_state = 71, .external_lex_state = 4},
  [1260] = {.lex_state = 11, .external_lex_state = 2},
  [1261] = {.lex_state = 11, .external_lex_state = 2},
  [1262] = {.lex_state = 11, .external_lex_state = 2},
  [1263] = {.lex_state = 11, .external_lex_state = 3},
  [1264] = {.lex_state = 11, .external_lex_state = 2},
  [1265] = {.lex_state = 11, .external_lex_state = 3},
  [1266] = {.lex_state = 11, .external_lex_state = 3},
  [1267] = {.lex_state = 71, .external_lex_state = 4},
  [1268] = {.lex_state = 71, .external_lex_state = 4},
  [1269] = {.lex_state = 11, .external_lex_state = 2},
  [1270] = {.lex_state = 11, .external_lex_state = 3},
  [1271] = {.lex_state = 11, .external_lex_state = 2},
  [1272] = {.lex_state = 11, .external_lex_state = 2},
  [1273] = {.lex_state = 11, .external_lex_state = 3},
  [1274] = {.lex_state = 11, .external_lex_state = 2},
  [1275] = {.lex_state = 11, .external_lex_state = 2},
  [1276] = {.lex_state = 11, .external_lex_state = 2},
  [1277] = {.lex_state = 71, .external_lex_state = 4},
  [1278] = {.lex_state = 11, .external_lex_state = 3},
  [1279] = {.lex_state = 71, .external_lex_state = 4},
  [1280] = {.lex_state = 71, .external_lex_state = 4},
  [1281] = {.lex_state = 11, .external_lex_state = 2},
  [1282] = {.lex_state = 11, .external_lex_state = 3},
  [1283] = {.lex_state = 11, .external_lex_state = 3},
  [1284] = {.lex_state = 11, .external_lex_state = 2},
  [1285] = {.lex_state = 11, .external_lex_state = 2},
  [1286] = {.lex_state = 11, .external_lex_state = 2},
  [1287] = {.lex_state = 14, .external_lex_state = 2},
  [1288] = {.lex_state = 11, .external_lex_state = 3},
  [1289] = {.lex_state = 14, .external_lex_state = 2},
  [1290] = {.lex_state = 11, .external_lex_state = 2},
  [1291] = {.lex_state = 11, .external_lex_state = 3},
  [1292] = {.lex_state = 11, .external_lex_state = 3},
  [1293] = {.lex_state = 14, .external_lex_state = 2},
  [1294] = {.lex_state = 14, .external_lex_state = 2},
  [1295] = {.lex_state = 11, .external_lex_state = 3},
  [1296] = {.lex_state = 11, .external_lex_state = 3},
  [1297] = {.lex_state = 11, .external_lex_state = 3},
  [1298] = {.lex_state = 11, .external_lex_state = 2},
  [1299] = {.lex_state = 14, .external_lex_state = 2},
  [1300] = {.lex_state = 11, .external_lex_state = 3},
  [1301] = {.lex_state = 14, .external_lex_state = 2},
  [1302] = {.lex_state = 11, .external_lex_state = 3},
  [1303] = {.lex_state = 11, .external_lex_state = 2},
  [1304] = {.lex_state = 14, .external_lex_state = 2},
  [1305] = {.lex_state = 71, .external_lex_state = 4},
  [1306] = {.lex_state = 11, .external_lex_state = 3},
  [1307] = {.lex_state = 11, .external_lex_state = 2},
  [1308] = {.lex_state = 14, .external_lex_state = 2},
  [1309] = {.lex_state = 14, .external_lex_state = 2},
  [1310] = {.lex_state = 11, .external_lex_state = 3},
  [1311] = {.lex_state = 11, .external_lex_state = 2},
  [1312] = {.lex_state = 14, .external_lex_state = 2},
  [1313] = {.lex_state = 14, .external_lex_state = 2},
  [1314] = {.lex_state = 11, .external_lex_state = 2},
  [1315] = {.lex_state = 11, .external_lex_state = 2},
  [1316] = {.lex_state = 11, .external_lex_state = 3},
  [1317] = {.lex_state = 11, .external_lex_state = 2},
  [1318] = {.lex_state = 14, .external_lex_state = 2},
  [1319] = {.lex_state = 14, .external_lex_state = 2},
  [1320] = {.lex_state = 14, .external_lex_state = 2},
  [1321] = {.lex_state = 11, .external_lex_state = 2},
  [1322] = {.lex_state = 11, .external_lex_state = 2},
  [1323] = {.lex_state = 11, .external_lex_state = 2},
  [1324] = {.lex_state = 71, .external_lex_state = 4},
  [1325] = {.lex_state = 71, .external_lex_state = 4},
  [1326] = {.lex_state = 11, .external_lex_state = 3},
  [1327] = {.lex_state = 11, .external_lex_state = 3},
  [1328] = {.lex_state = 71, .external_lex_state = 4},
  [1329] = {.lex_state = 11, .external_lex_state = 2},
  [1330] = {.lex_state = 11, .external_lex_state = 3},
  [1331] = {.lex_state = 11, .external_lex_state = 2},
  [1332] = {.lex_state = 14, .external_lex_state = 2},
  [1333] = {.lex_state = 11, .external_lex_state = 3},
  [1334] = {.lex_state = 11, .external_lex_state = 2},
  [1335] = {.lex_state = 11, .external_lex_state = 3},
  [1336] = {.lex_state = 11, .external_lex_state = 3},
  [1337] = {.lex_state = 11, .external_lex_state = 3},
  [1338] = {.lex_state = 11, .external_lex_state = 3},
  [1339] = {.lex_state = 11, .external_lex_state = 2},
  [1340] = {.lex_state = 11, .external_lex_state = 3},
  [1341] = {.lex_state = 11, .external_lex_state = 3},
  [1342] = {.lex_state = 14, .external_lex_state = 2},
  [1343] = {.lex_state = 11, .external_lex_state = 2},
  [1344] = {.lex_state = 71, .external_lex_state = 4},
  [1345] = {.lex_state = 14, .external_lex_state = 2},
  [1346] = {.lex_state = 11, .external_lex_state = 3},
  [1347] = {.lex_state = 11, .external_lex_state = 2},
  [1348] = {.lex_state = 14, .external_lex_state = 2},
  [1349] = {.lex_state = 14, .external_lex_state = 2},
  [1350] = {.lex_state = 11, .external_lex_state = 2},
  [1351] = {.lex_state = 11, .external_lex_state = 3},
  [1352] = {.lex_state = 11, .external_lex_state = 2},
  [1353] = {.lex_state = 11, .external_lex_state = 2},
  [1354] = {.lex_state = 11, .external_lex_state = 2},
  [1355] = {.lex_state = 11, .external_lex_state = 2},
  [1356] = {.lex_state = 14, .external_lex_state = 2},
  [1357] = {.lex_state = 11, .external_lex_state = 2},
  [1358] = {.lex_state = 71, .external_lex_state = 4},
  [1359] = {.lex_state = 11, .external_lex_state = 2},
  [1360] = {.lex_state = 11, .external_lex_state = 2},
  [1361] = {.lex_state = 11, .external_lex_state = 2},
  [1362] = {.lex_state = 11, .external_lex_state = 2},
  [1363] = {.lex_state = 11, .external_lex_state = 2},
  [1364] = {.lex_state = 11, .external_lex_state = 2},
  [1365] = {.lex_state = 11, .external_lex_state = 2},
  [1366] = {.lex_state = 11, .external_lex_state = 2},
  [1367] = {.lex_state = 11, .external_lex_state = 2},
  [1368] = {.lex_state = 11, .external_lex_state = 3},
  [1369] = {.lex_state = 11, .external_lex_state = 2},
  [1370] = {.lex_state = 11, .external_lex_state = 2},
  [1371] = {.lex_state = 11, .external_lex_state = 3},
  [1372] = {.lex_state = 11, .external_lex_state = 2},
  [1373] = {.lex_state = 11, .external_lex_state = 3},
  [1374] = {.lex_state = 11, .external_lex_state = 2},
  [1375] = {.lex_state = 14, .external_lex_state = 2},
  [1376] = {.lex_state = 11, .external_lex_state = 3},
  [1377] = {.lex_state = 14, .external_lex_state = 2},
  [1378] = {.lex_state = 71, .external_lex_state = 4},
  [1379] = {.lex_state = 11, .external_lex_state = 3},
  [1380] = {.lex_state = 14, .external_lex_state = 2},
  [1381] = {.lex_state = 14, .external_lex_state = 2},
  [1382] = {.lex_state = 14, .external_lex_state = 2},
  [1383] = {.lex_state = 14, .external_lex_state = 2},
  [1384] = {.lex_state = 11, .external_lex_state = 2},
  [1385] = {.lex_state = 14, .external_lex_state = 2},
  [1386] = {.lex_state = 12, .external_lex_state = 2},
  [1387] = {.lex_state = 11, .external_lex_state = 3},
  [1388] = {.lex_state = 14, .external_lex_state = 2},
  [1389] = {.lex_state = 11, .external_lex_state = 3},
  [1390] = {.lex_state = 14, .external_lex_state = 2},
  [1391] = {.lex_state = 11, .external_lex_state = 2},
  [1392] = {.lex_state = 11, .external_lex_state = 2},
  [1393] = {.lex_state = 11, .external_lex_state = 3},
  [1394] = {.lex_state = 11, .external_lex_state = 3},
  [1395] = {.lex_state = 11, .external_lex_state = 3},
  [1396] = {.lex_state = 71, .external_lex_state = 4},
  [1397] = {.lex_state = 11, .external_lex_state = 3},
  [1398] = {.lex_state = 11, .external_lex_state = 2},
  [1399] = {.lex_state = 14, .external_lex_state = 2},
  [1400] = {.lex_state = 11, .external_lex_state = 2},
  [1401] = {.lex_state = 11, .external_lex_state = 3},
  [1402] = {.lex_state = 11, .external_lex_state = 2},
  [1403] = {.lex_state = 11, .external_lex_state = 3},
  [1404] = {.lex_state = 11, .external_lex_state = 2},
  [1405] = {.lex_state = 71, .external_lex_state = 4},
  [1406] = {.lex_state = 11, .external_lex_state = 2},
  [1407] = {.lex_state = 11, .external_lex_state = 3},
  [1408] = {.lex_state = 11, .external_lex_state = 3},
  [1409] = {.lex_state = 11, .external_lex_state = 2},
  [1410] = {.lex_state = 11, .external_lex_state = 2},
  [1411] = {.lex_state = 11, .external_lex_state = 3},
  [1412] = {.lex_state = 11, .external_lex_state = 3},
  [1413] = {.lex_state = 11, .external_lex_state = 2},
  [1414] = {.lex_state = 11, .external_lex_state = 2},
  [1415] = {.lex_state = 11, .external_lex_state = 2},
  [1416] = {.lex_state = 12, .external_lex_state = 3},
  [1417] = {.lex_state = 11, .external_lex_state = 3},
  [1418] = {.lex_state = 11, .external_lex_state = 2},
  [1419] = {.lex_state = 11, .external_lex_state = 3},
  [1420] = {.lex_state = 71, .external_lex_state = 4},
  [1421] = {.lex_state = 11, .external_lex_state = 3},
  [1422] = {.lex_state = 11, .external_lex_state = 3},
  [1423] = {.lex_state = 11, .external_lex_state = 2},
  [1424] = {.lex_state = 11, .external_lex_state = 3},
  [1425] = {.lex_state = 71, .external_lex_state = 4},
  [1426] = {.lex_state = 11, .external_lex_state = 3},
  [1427] = {.lex_state = 11, .external_lex_state = 3},
  [1428] = {.lex_state = 11, .external_lex_state = 3},
  [1429] = {.lex_state = 14, .external_lex_state = 2},
  [1430] = {.lex_state = 14, .external_lex_state = 2},
  [1431] = {.lex_state = 11, .external_lex_state = 2},
  [1432] = {.lex_state = 14, .external_lex_state = 2},
  [1433] = {.lex_state = 14, .external_lex_state = 2},
  [1434] = {.lex_state = 11, .external_lex_state = 2},
  [1435] = {.lex_state = 11, .external_lex_state = 2},
  [1436] = {.lex_state = 11, .external_lex_state = 3},
  [1437] = {.lex_state = 71, .external_lex_state = 4},
  [1438] = {.lex_state = 11, .external_lex_state = 3},
  [1439] = {.lex_state = 11, .external_lex_state = 3},
  [1440] = {.lex_state = 11, .external_lex_state = 3},
  [1441] = {.lex_state = 11, .external_lex_state = 3},
  [1442] = {.lex_state = 14, .external_lex_state = 2},
  [1443] = {.lex_state = 11, .external_lex_state = 2},
  [1444] = {.lex_state = 14, .external_lex_state = 2},
  [1445] = {.lex_state = 11, .external_lex_state = 3},
  [1446] = {.lex_state = 11, .external_lex_state = 2},
  [1447] = {.lex_state = 11, .external_lex_state = 2},
  [1448] = {.lex_state = 71, .external_lex_state = 4},
  [1449] = {.lex_state = 11, .external_lex_state = 3},
  [1450] = {.lex_state = 11, .external_lex_state = 3},
  [1451] = {.lex_state = 11, .external_lex_state = 3},
  [1452] = {.lex_state = 11, .external_lex_state = 3},
  [1453] = {.lex_state = 11, .external_lex_state = 3},
  [1454] = {.lex_state = 11, .external_lex_state = 3},
  [1455] = {.lex_state = 11, .external_lex_state = 3},
  [1456] = {.lex_state = 11, .external_lex_state = 2},
  [1457] = {.lex_state = 11, .external_lex_state = 2},
  [1458] = {.lex_state = 11, .external_lex_state = 3},
  [1459] = {.lex_state = 11, .external_lex_state = 3},
  [1460] = {.lex_state = 71, .external_lex_state = 4},
  [1461] = {.lex_state = 71, .external_lex_state = 4},
  [1462] = {.lex_state = 11, .external_lex_state = 3},
  [1463] = {.lex_state = 71, .external_lex_state = 4},
  [1464] = {.lex_state = 11, .external_lex_state = 3},
  [1465] = {.lex_state = 11, .external_lex_state = 3},
  [1466] = {.lex_state = 11, .external_lex_state = 2},
  [1467] = {.lex_state = 11, .external_lex_state = 3},
  [1468] = {.lex_state = 71, .external_lex_state = 4},
  [1469] = {.lex_state = 11, .external_lex_state = 3},
  [1470] = {.lex_state = 71, .external_lex_state = 4},
  [1471] = {.lex_state = 11, .external_lex_state = 2},
  [1472] = {.lex_state = 11, .external_lex_state = 3},
  [1473] = {.lex_state = 11, .external_lex_state = 2},
  [1474] = {.lex_state = 14, .external_lex_state = 2},
  [1475] = {.lex_state = 11, .external_lex_state = 3},
  [1476] = {.lex_state = 11, .external_lex_state = 3},
  [1477] = {.lex_state = 11, .external_lex_state = 3},
  [1478] = {.lex_state = 11, .external_lex_state = 2},
  [1479] = {.lex_state = 11, .external_lex_state = 2},
  [1480] = {.lex_state = 11, .external_lex_state = 2},
  [1481] = {.lex_state = 14, .external_lex_state = 2},
  [1482] = {.lex_state = 71, .external_lex_state = 4},
  [1483] = {.lex_state = 71, .external_lex_state = 4},
  [1484] = {.lex_state = 11, .external_lex_state = 3},
  [1485] = {.lex_state = 11, .external_lex_state = 3},
  [1486] = {.lex_state = 11, .external_lex_state = 3},
  [1487] = {.lex_state = 11, .external_lex_state = 3},
  [1488] = {.lex_state = 11, .external_lex_state = 3},
  [1489] = {.lex_state = 11, .external_lex_state = 3},
  [1490] = {.lex_state = 11, .external_lex_state = 2},
  [1491] = {.lex_state = 71, .external_lex_state = 4},
  [1492] = {.lex_state = 11, .external_lex_state = 3},
  [1493] = {.lex_state = 11, .external_lex_state = 2},
  [1494] = {.lex_state = 11, .external_lex_state = 2},
  [1495] = {.lex_state = 11, .external_lex_state = 2},
  [1496] = {.lex_state = 11, .external_lex_state = 3},
  [1497] = {.lex_state = 11, .external_lex_state = 3},
  [1498] = {.lex_state = 11, .external_lex_state = 2},
  [1499] = {.lex_state = 11, .external_lex_state = 2},
  [1500] = {.lex_state = 71, .external_lex_state = 4},
  [1501] = {.lex_state = 11, .external_lex_state = 3},
  [1502] = {.lex_state = 11, .external_lex_state = 3},
  [1503] = {.lex_state = 11, .external_lex_state = 3},
  [1504] = {.lex_state = 11, .external_lex_state = 2},
  [1505] = {.lex_state = 11, .external_lex_state = 2},
  [1506] = {.lex_state = 11, .external_lex_state = 3},
  [1507] = {.lex_state = 11, .external_lex_state = 3},
  [1508] = {.lex_state = 11, .external_lex_state = 3},
  [1509] = {.lex_state = 11, .external_lex_state = 3},
  [1510] = {.lex_state = 11, .external_lex_state = 2},
  [1511] = {.lex_state = 11, .external_lex_state = 3},
  [1512] = {.lex_state = 11, .external_lex_state = 2},
  [1513] = {.lex_state = 11, .external_lex_state = 3},
  [1514] = {.lex_state = 11, .external_lex_state = 3},
  [1515] = {.lex_state = 11, .external_lex_state = 3},
  [1516] = {.lex_state = 11, .external_lex_state = 3},
  [1517] = {.lex_state = 11, .external_lex_state = 3},
  [1518] = {.lex_state = 11, .external_lex_state = 2},
  [1519] = {.lex_state = 11, .external_lex_state = 2},
  [1520] = {.lex_state = 11, .external_lex_state = 3},
  [1521] = {.lex_state = 11, .external_lex_state = 3},
  [1522] = {.lex_state = 71, .external_lex_state = 4},
  [1523] = {.lex_state = 71, .external_lex_state = 4},
  [1524] = {.lex_state = 11, .external_lex_state = 3},
  [1525] = {.lex_state = 11, .external_lex_state = 3},
  [1526] = {.lex_state = 11, .external_lex_state = 3},
  [1527] = {.lex_state = 11, .external_lex_state = 3},
  [1528] = {.lex_state = 11, .external_lex_state = 2},
  [1529] = {.lex_state = 11, .external_lex_state = 3},
  [1530] = {.lex_state = 14, .external_lex_state = 2},
  [1531] = {.lex_state = 71, .external_lex_state = 4},
  [1532] = {.lex_state = 11, .external_lex_state = 3},
  [1533] = {.lex_state = 11, .external_lex_state = 3},
  [1534] = {.lex_state = 11, .external_lex_state = 3},
  [1535] = {.lex_state = 11, .external_lex_state = 3},
  [1536] = {.lex_state = 11, .external_lex_state = 3},
  [1537] = {.lex_state = 11, .external_lex_state = 3},
  [1538] = {.lex_state = 11, .external_lex_state = 3},
  [1539] = {.lex_state = 11, .external_lex_state = 3},
  [1540] = {.lex_state = 71, .external_lex_state = 4},
  [1541] = {.lex_state = 11, .external_lex_state = 3},
  [1542] = {.lex_state = 71, .external_lex_state = 4},
  [1543] = {.lex_state = 11, .external_lex_state = 2},
  [1544] = {.lex_state = 11, .external_lex_state = 3},
  [1545] = {.lex_state = 71, .external_lex_state = 4},
  [1546] = {.lex_state = 11, .external_lex_state = 2},
  [1547] = {.lex_state = 11, .external_lex_state = 3},
  [1548] = {.lex_state = 11, .external_lex_state = 3},
  [1549] = {.lex_state = 11, .external_lex_state = 3},
  [1550] = {.lex_state = 14, .external_lex_state = 3},
  [1551] = {.lex_state = 71, .external_lex_state = 4},
  [1552] = {.lex_state = 11, .external_lex_state = 2},
  [1553] = {.lex_state = 11, .external_lex_state = 2},
  [1554] = {.lex_state = 11, .external_lex_state = 2},
  [1555] = {.lex_state = 71, .external_lex_state = 4},
  [1556] = {.lex_state = 11, .external_lex_state = 3},
  [1557] = {.lex_state = 11, .external_lex_state = 2},
  [1558] = {.lex_state = 11, .external_lex_state = 3},
  [1559] = {.lex_state = 11, .external_lex_state = 3},
  [1560] = {.lex_state = 11, .external_lex_state = 2},
  [1561] = {.lex_state = 11, .external_lex_state = 2},
  [1562] = {.lex_state = 11, .external_lex_state = 2},
  [1563] = {.lex_state = 71, .external_lex_state = 4},
  [1564] = {.lex_state = 11, .external_lex_state = 3},
  [1565] = {.lex_state = 11, .external_lex_state = 3},
  [1566] = {.lex_state = 11, .external_lex_state = 2},
  [1567] = {.lex_state = 11, .external_lex_state = 2},
  [1568] = {.lex_state = 11, .external_lex_state = 3},
  [1569] = {.lex_state = 11, .external_lex_state = 3},
  [1570] = {.lex_state = 11, .external_lex_state = 3},
  [1571] = {.lex_state = 11, .external_lex_state = 3},
  [1572] = {.lex_state = 11, .external_lex_state = 3},
  [1573] = {.lex_state = 11, .external_lex_state = 2},
  [1574] = {.lex_state = 71, .external_lex_state = 4},
  [1575] = {.lex_state = 11, .external_lex_state = 3},
  [1576] = {.lex_state = 11, .external_lex_state = 3},
  [1577] = {.lex_state = 11, .external_lex_state = 2},
  [1578] = {.lex_state = 11, .external_lex_state = 2},
  [1579] = {.lex_state = 11, .external_lex_state = 2},
  [1580] = {.lex_state = 11, .external_lex_state = 2},
  [1581] = {.lex_state = 71, .external_lex_state = 4},
  [1582] = {.lex_state = 11, .external_lex_state = 2},
  [1583] = {.lex_state = 11, .external_lex_state = 3},
  [1584] = {.lex_state = 11, .external_lex_state = 3},
  [1585] = {.lex_state = 11, .external_lex_state = 3},
  [1586] = {.lex_state = 11, .external_lex_state = 2},
  [1587] = {.lex_state = 11, .external_lex_state = 2},
  [1588] = {.lex_state = 11, .external_lex_state = 2},
  [1589] = {.lex_state = 11, .external_lex_state = 3},
  [1590] = {.lex_state = 11, .external_lex_state = 2},
  [1591] = {.lex_state = 11, .external_lex_state = 2},
  [1592] = {.lex_state = 11, .external_lex_state = 2},
  [1593] = {.lex_state = 11, .external_lex_state = 2},
  [1594] = {.lex_state = 11, .external_lex_state = 2},
  [1595] = {.lex_state = 11, .external_lex_state = 3},
  [1596] = {.lex_state = 11, .external_lex_state = 3},
  [1597] = {.lex_state = 14, .external_lex_state = 2},
  [1598] = {.lex_state = 11, .external_lex_state = 2},
  [1599] = {.lex_state = 11, .external_lex_state = 3},
  [1600] = {.lex_state = 71},
  [1601] = {.lex_state = 11, .external_lex_state = 3},
  [1602] = {.lex_state = 71},
  [1603] = {.lex_state = 11, .external_lex_state = 3},
  [1604] = {.lex_state = 11, .external_lex_state = 2},
  [1605] = {.lex_state = 11, .external_lex_state = 3},
  [1606] = {.lex_state = 71},
  [1607] = {.lex_state = 71},
  [1608] = {.lex_state = 71},
  [1609] = {.lex_state = 71},
  [1610] = {.lex_state = 11, .external_lex_state = 3},
  [1611] = {.lex_state = 14, .external_lex_state = 2},
  [1612] = {.lex_state = 11, .external_lex_state = 3},
  [1613] = {.lex_state = 11, .external_lex_state = 3},
  [1614] = {.lex_state = 11, .external_lex_state = 3},
  [1615] = {.lex_state = 14, .external_lex_state = 2},
  [1616] = {.lex_state = 14, .external_lex_state = 2},
  [1617] = {.lex_state = 14, .external_lex_state = 2},
  [1618] = {.lex_state = 11, .external_lex_state = 2},
  [1619] = {.lex_state = 11, .external_lex_state = 2},
  [1620] = {.lex_state = 11, .external_lex_state = 2},
  [1621] = {.lex_state = 14, .external_lex_state = 2},
  [1622] = {.lex_state = 11, .external_lex_state = 2},
  [1623] = {.lex_state = 14, .external_lex_state = 2},
  [1624] = {.lex_state = 11, .external_lex_state = 2},
  [1625] = {.lex_state = 14, .external_lex_state = 2},
  [1626] = {.lex_state = 14, .external_lex_state = 2},
  [1627] = {.lex_state = 14, .external_lex_state = 2},
  [1628] = {.lex_state = 14, .external_lex_state = 2},
  [1629] = {.lex_state = 14, .external_lex_state = 2},
  [1630] = {.lex_state = 11, .external_lex_state = 2},
  [1631] = {.lex_state = 14, .external_lex_state = 2},
  [1632] = {.lex_state = 14, .external_lex_state = 2},
  [1633] = {.lex_state = 14, .external_lex_state = 2},
  [1634] = {.lex_state = 14, .external_lex_state = 2},
  [1635] = {.lex_state = 14, .external_lex_state = 2},
  [1636] = {.lex_state = 14, .external_lex_state = 2},
  [1637] = {.lex_state = 14, .external_lex_state = 2},
  [1638] = {.lex_state = 11, .external_lex_state = 2},
  [1639] = {.lex_state = 11, .external_lex_state = 3},
  [1640] = {.lex_state = 14, .external_lex_state = 2},
  [1641] = {.lex_state = 14, .external_lex_state = 2},
  [1642] = {.lex_state = 14, .external_lex_state = 2},
  [1643] = {.lex_state = 14, .external_lex_state = 2},
  [1644] = {.lex_state = 11, .external_lex_state = 3},
  [1645] = {.lex_state = 11, .external_lex_state = 3},
  [1646] = {.lex_state = 11, .external_lex_state = 2},
  [1647] = {.lex_state = 11, .external_lex_state = 3},
  [1648] = {.lex_state = 14, .external_lex_state = 2},
  [1649] = {.lex_state = 11, .external_lex_state = 3},
  [1650] = {.lex_state = 14, .external_lex_state = 2},
  [1651] = {.lex_state = 11, .external_lex_state = 2},
  [1652] = {.lex_state = 11, .external_lex_state = 3},
  [1653] = {.lex_state = 11, .external_lex_state = 3},
  [1654] = {.lex_state = 11, .external_lex_state = 2},
  [1655] = {.lex_state = 11, .external_lex_state = 3},
  [1656] = {.lex_state = 11, .external_lex_state = 2},
  [1657] = {.lex_state = 14, .external_lex_state = 2},
  [1658] = {.lex_state = 14, .external_lex_state = 2},
  [1659] = {.lex_state = 14, .external_lex_state = 2},
  [1660] = {.lex_state = 14, .external_lex_state = 2},
  [1661] = {.lex_state = 71},
  [1662] = {.lex_state = 14, .external_lex_state = 2},
  [1663] = {.lex_state = 14, .external_lex_state = 2},
  [1664] = {.lex_state = 14, .external_lex_state = 2},
  [1665] = {.lex_state = 71},
  [1666] = {.lex_state = 14, .external_lex_state = 2},
  [1667] = {.lex_state = 71},
  [1668] = {.lex_state = 11, .external_lex_state = 2},
  [1669] = {.lex_state = 12, .external_lex_state = 2},
  [1670] = {.lex_state = 14, .external_lex_state = 2},
  [1671] = {.lex_state = 14, .external_lex_state = 2},
  [1672] = {.lex_state = 71, .external_lex_state = 4},
  [1673] = {.lex_state = 71, .external_lex_state = 4},
  [1674] = {.lex_state = 14, .external_lex_state = 2},
  [1675] = {.lex_state = 14, .external_lex_state = 2},
  [1676] = {.lex_state = 11, .external_lex_state = 3},
  [1677] = {.lex_state = 11, .external_lex_state = 3},
  [1678] = {.lex_state = 14, .external_lex_state = 2},
  [1679] = {.lex_state = 71},
  [1680] = {.lex_state = 14, .external_lex_state = 3},
  [1681] = {.lex_state = 14, .external_lex_state = 2},
  [1682] = {.lex_state = 71},
  [1683] = {.lex_state = 71},
  [1684] = {.lex_state = 14, .external_lex_state = 2},
  [1685] = {.lex_state = 71, .external_lex_state = 4},
  [1686] = {.lex_state = 71, .external_lex_state = 4},
  [1687] = {.lex_state = 11, .external_lex_state = 3},
  [1688] = {.lex_state = 11, .external_lex_state = 3},
  [1689] = {.lex_state = 14, .external_lex_state = 2},
  [1690] = {.lex_state = 14, .external_lex_state = 2},
  [1691] = {.lex_state = 14, .external_lex_state = 2},
  [1692] = {.lex_state = 11, .external_lex_state = 3},
  [1693] = {.lex_state = 11, .external_lex_state = 3},
  [1694] = {.lex_state = 14, .external_lex_state = 2},
  [1695] = {.lex_state = 14, .external_lex_state = 2},
  [1696] = {.lex_state = 11, .external_lex_state = 3},
  [1697] = {.lex_state = 11, .external_lex_state = 3},
  [1698] = {.lex_state = 14, .external_lex_state = 2},
  [1699] = {.lex_state = 14, .external_lex_state = 2},
  [1700] = {.lex_state = 71, .external_lex_state = 4},
  [1701] = {.lex_state = 71, .external_lex_state = 4},
  [1702] = {.lex_state = 11, .external_lex_state = 3},
  [1703] = {.lex_state = 71},
  [1704] = {.lex_state = 11, .external_lex_state = 3},
  [1705] = {.lex_state = 71},
  [1706] = {.lex_state = 11, .external_lex_state = 3},
  [1707] = {.lex_state = 11, .external_lex_state = 3},
  [1708] = {.lex_state = 11, .external_lex_state = 3},
  [1709] = {.lex_state = 11, .external_lex_state = 3},
  [1710] = {.lex_state = 71},
  [1711] = {.lex_state = 14, .external_lex_state = 2},
  [1712] = {.lex_state = 11, .external_lex_state = 2},
  [1713] = {.lex_state = 11, .external_lex_state = 3},
  [1714] = {.lex_state = 14, .external_lex_state = 3},
  [1715] = {.lex_state = 14, .external_lex_state = 2},
  [1716] = {.lex_state = 11, .external_lex_state = 3},
  [1717] = {.lex_state = 11, .external_lex_state = 3},
  [1718] = {.lex_state = 14, .external_lex_state = 2},
  [1719] = {.lex_state = 14, .external_lex_state = 2},
  [1720] = {.lex_state = 11, .external_lex_state = 3},
  [1721] = {.lex_state = 14, .external_lex_state = 2},
  [1722] = {.lex_state = 11, .external_lex_state = 2},
  [1723] = {.lex_state = 71, .external_lex_state = 4},
  [1724] = {.lex_state = 11, .external_lex_state = 3},
  [1725] = {.lex_state = 14, .external_lex_state = 2},
  [1726] = {.lex_state = 14, .external_lex_state = 2},
  [1727] = {.lex_state = 11, .external_lex_state = 3},
  [1728] = {.lex_state = 14, .external_lex_state = 2},
  [1729] = {.lex_state = 14, .external_lex_state = 2},
  [1730] = {.lex_state = 71, .external_lex_state = 4},
  [1731] = {.lex_state = 71, .external_lex_state = 4},
  [1732] = {.lex_state = 11, .external_lex_state = 3},
  [1733] = {.lex_state = 11, .external_lex_state = 3},
  [1734] = {.lex_state = 11, .external_lex_state = 3},
  [1735] = {.lex_state = 11, .external_lex_state = 3},
  [1736] = {.lex_state = 11, .external_lex_state = 3},
  [1737] = {.lex_state = 11, .external_lex_state = 3},
  [1738] = {.lex_state = 14, .external_lex_state = 2},
  [1739] = {.lex_state = 14, .external_lex_state = 2},
  [1740] = {.lex_state = 11, .external_lex_state = 3},
  [1741] = {.lex_state = 11, .external_lex_state = 3},
  [1742] = {.lex_state = 71, .external_lex_state = 4},
  [1743] = {.lex_state = 11, .external_lex_state = 2},
  [1744] = {.lex_state = 11, .external_lex_state = 3},
  [1745] = {.lex_state = 11, .external_lex_state = 3},
  [1746] = {.lex_state = 71, .external_lex_state = 4},
  [1747] = {.lex_state = 11, .external_lex_state = 3},
  [1748] = {.lex_state = 11, .external_lex_state = 3},
  [1749] = {.lex_state = 11, .external_lex_state = 3},
  [1750] = {.lex_state = 11, .external_lex_state = 2},
  [1751] = {.lex_state = 11, .external_lex_state = 3},
  [1752] = {.lex_state = 11, .external_lex_state = 3},
  [1753] = {.lex_state = 71, .external_lex_state = 4},
  [1754] = {.lex_state = 11, .external_lex_state = 2},
  [1755] = {.lex_state = 11, .external_lex_state = 3},
  [1756] = {.lex_state = 11, .external_lex_state = 3},
  [1757] = {.lex_state = 11, .external_lex_state = 3},
  [1758] = {.lex_state = 11, .external_lex_state = 2},
  [1759] = {.lex_state = 11, .external_lex_state = 3},
  [1760] = {.lex_state = 11, .external_lex_state = 3},
  [1761] = {.lex_state = 11, .external_lex_state = 3},
  [1762] = {.lex_state = 71, .external_lex_state = 4},
  [1763] = {.lex_state = 11, .external_lex_state = 3},
  [1764] = {.lex_state = 11, .external_lex_state = 3},
  [1765] = {.lex_state = 15, .external_lex_state = 2},
  [1766] = {.lex_state = 71, .external_lex_state = 4},
  [1767] = {.lex_state = 71, .external_lex_state = 4},
  [1768] = {.lex_state = 14, .external_lex_state = 2},
  [1769] = {.lex_state = 11, .external_lex_state = 2},
  [1770] = {.lex_state = 14, .external_lex_state = 2},
  [1771] = {.lex_state = 11, .external_lex_state = 2},
  [1772] = {.lex_state = 71, .external_lex_state = 4},
  [1773] = {.lex_state = 11, .external_lex_state = 3},
  [1774] = {.lex_state = 11, .external_lex_state = 3},
  [1775] = {.lex_state = 11, .external_lex_state = 3},
  [1776] = {.lex_state = 14, .external_lex_state = 2},
  [1777] = {.lex_state = 14, .external_lex_state = 2},
  [1778] = {.lex_state = 14, .external_lex_state = 2},
  [1779] = {.lex_state = 71},
  [1780] = {.lex_state = 14, .external_lex_state = 2},
  [1781] = {.lex_state = 14, .external_lex_state = 2},
  [1782] = {.lex_state = 14, .external_lex_state = 2},
  [1783] = {.lex_state = 14, .external_lex_state = 2},
  [1784] = {.lex_state = 14, .external_lex_state = 2},
  [1785] = {.lex_state = 14, .external_lex_state = 2},
  [1786] = {.lex_state = 71},
  [1787] = {.lex_state = 14, .external_lex_state = 2},
  [1788] = {.lex_state = 14, .external_lex_state = 2},
  [1789] = {.lex_state = 71},
  [1790] = {.lex_state = 14, .external_lex_state = 2},
  [1791] = {.lex_state = 14, .external_lex_state = 2},
  [1792] = {.lex_state = 14, .external_lex_state = 2},
  [1793] = {.lex_state = 14, .external_lex_state = 2},
  [1794] = {.lex_state = 71},
  [1795] = {.lex_state = 14, .external_lex_state = 2},
  [1796] = {.lex_state = 14, .external_lex_state = 2},
  [1797] = {.lex_state = 14, .external_lex_state = 2},
  [1798] = {.lex_state = 71},
  [1799] = {.lex_state = 14, .external_lex_state = 2},
  [1800] = {.lex_state = 14, .external_lex_state = 2},
  [1801] = {.lex_state = 14, .external_lex_state = 2},
  [1802] = {.lex_state = 14, .external_lex_state = 2},
  [1803] = {.lex_state = 11, .external_lex_state = 3},
  [1804] = {.lex_state = 11, .external_lex_state = 3},
  [1805] = {.lex_state = 14, .external_lex_state = 2},
  [1806] = {.lex_state = 14, .external_lex_state = 2},
  [1807] = {.lex_state = 14, .external_lex_state = 2},
  [1808] = {.lex_state = 14, .external_lex_state = 2},
  [1809] = {.lex_state = 71, .external_lex_state = 4},
  [1810] = {.lex_state = 14, .external_lex_state = 2},
  [1811] = {.lex_state = 14, .external_lex_state = 2},
  [1812] = {.lex_state = 14, .external_lex_state = 2},
  [1813] = {.lex_state = 11, .external_lex_state = 2},
  [1814] = {.lex_state = 71, .external_lex_state = 4},
  [1815] = {.lex_state = 14, .external_lex_state = 2},
  [1816] = {.lex_state = 11, .external_lex_state = 2},
  [1817] = {.lex_state = 14, .external_lex_state = 2},
  [1818] = {.lex_state = 11, .external_lex_state = 2},
  [1819] = {.lex_state = 14, .external_lex_state = 2},
  [1820] = {.lex_state = 71, .external_lex_state = 4},
  [1821] = {.lex_state = 14, .external_lex_state = 2},
  [1822] = {.lex_state = 14, .external_lex_state = 2},
  [1823] = {.lex_state = 14, .external_lex_state = 2},
  [1824] = {.lex_state = 14, .external_lex_state = 2},
  [1825] = {.lex_state = 14, .external_lex_state = 2},
  [1826] = {.lex_state = 14, .external_lex_state = 2},
  [1827] = {.lex_state = 14, .external_lex_state = 2},
  [1828] = {.lex_state = 14, .external_lex_state = 2},
  [1829] = {.lex_state = 11, .external_lex_state = 2},
  [1830] = {.lex_state = 14, .external_lex_state = 2},
  [1831] = {.lex_state = 11, .external_lex_state = 2},
  [1832] = {.lex_state = 71},
  [1833] = {.lex_state = 14, .external_lex_state = 2},
  [1834] = {.lex_state = 14, .external_lex_state = 2},
  [1835] = {.lex_state = 14, .external_lex_state = 2},
  [1836] = {.lex_state = 14, .external_lex_state = 2},
  [1837] = {.lex_state = 14, .external_lex_state = 2},
  [1838] = {.lex_state = 14, .external_lex_state = 2},
  [1839] = {.lex_state = 14, .external_lex_state = 2},
  [1840] = {.lex_state = 14, .external_lex_state = 2},
  [1841] = {.lex_state = 14, .external_lex_state = 2},
  [1842] = {.lex_state = 14, .external_lex_state = 2},
  [1843] = {.lex_state = 14, .external_lex_state = 2},
  [1844] = {.lex_state = 14, .external_lex_state = 2},
  [1845] = {.lex_state = 14, .external_lex_state = 2},
  [1846] = {.lex_state = 14, .external_lex_state = 2},
  [1847] = {.lex_state = 14, .external_lex_state = 2},
  [1848] = {.lex_state = 14, .external_lex_state = 2},
  [1849] = {.lex_state = 14, .external_lex_state = 2},
  [1850] = {.lex_state = 14, .external_lex_state = 2},
  [1851] = {.lex_state = 14, .external_lex_state = 2},
  [1852] = {.lex_state = 71},
  [1853] = {.lex_state = 21},
  [1854] = {.lex_state = 71},
  [1855] = {.lex_state = 71, .external_lex_state = 4},
  [1856] = {.lex_state = 14, .external_lex_state = 2},
  [1857] = {.lex_state = 14, .external_lex_state = 2},
  [1858] = {.lex_state = 21},
  [1859] = {.lex_state = 71},
  [1860] = {.lex_state = 71, .external_lex_state = 4},
  [1861] = {.lex_state = 11, .external_lex_state = 2},
  [1862] = {.lex_state = 11, .external_lex_state = 2},
  [1863] = {.lex_state = 11, .external_lex_state = 2},
  [1864] = {.lex_state = 11, .external_lex_state = 2},
  [1865] = {.lex_state = 21},
  [1866] = {.lex_state = 71},
  [1867] = {.lex_state = 71},
  [1868] = {.lex_state = 21},
  [1869] = {.lex_state = 21},
  [1870] = {.lex_state = 21},
  [1871] = {.lex_state = 21},
  [1872] = {.lex_state = 71},
  [1873] = {.lex_state = 71},
  [1874] = {.lex_state = 71},
  [1875] = {.lex_state = 71},
  [1876] = {.lex_state = 71},
  [1877] = {.lex_state = 71},
  [1878] = {.lex_state = 71},
  [1879] = {.lex_state = 71},
  [1880] = {.lex_state = 71},
  [1881] = {.lex_state = 71},
  [1882] = {.lex_state = 71},
  [1883] = {.lex_state = 71},
  [1884] = {.lex_state = 71},
  [1885] = {.lex_state = 71},
  [1886] = {.lex_state = 71},
  [1887] = {.lex_state = 71},
  [1888] = {.lex_state = 71},
  [1889] = {.lex_state = 71},
  [1890] = {.lex_state = 71},
  [1891] = {.lex_state = 71},
  [1892] = {.lex_state = 71},
  [1893] = {.lex_state = 71},
  [1894] = {.lex_state = 71},
  [1895] = {.lex_state = 71},
  [1896] = {.lex_state = 71},
  [1897] = {.lex_state = 71},
  [1898] = {.lex_state = 71},
  [1899] = {.lex_state = 71},
  [1900] = {.lex_state = 71},
  [1901] = {.lex_state = 71},
  [1902] = {.lex_state = 71},
  [1903] = {.lex_state = 71},
  [1904] = {.lex_state = 71},
  [1905] = {.lex_state = 71},
  [1906] = {.lex_state = 71},
  [1907] = {.lex_state = 71},
  [1908] = {.lex_state = 19, .external_lex_state = 4},
  [1909] = {.lex_state = 71},
  [1910] = {.lex_state = 19, .external_lex_state = 4},
  [1911] = {.lex_state = 71},
  [1912] = {.lex_state = 19, .external_lex_state = 4},
  [1913] = {.lex_state = 71},
  [1914] = {.lex_state = 71},
  [1915] = {.lex_state = 19, .external_lex_state = 4},
  [1916] = {.lex_state = 71},
  [1917] = {.lex_state = 19, .external_lex_state = 4},
  [1918] = {.lex_state = 19, .external_lex_state = 4},
  [1919] = {.lex_state = 19, .external_lex_state = 4},
  [1920] = {.lex_state = 19, .external_lex_state = 4},
  [1921] = {.lex_state = 19, .external_lex_state = 4},
  [1922] = {.lex_state = 19, .external_lex_state = 4},
  [1923] = {.lex_state = 71},
  [1924] = {.lex_state = 19, .external_lex_state = 4},
  [1925] = {.lex_state = 19, .external_lex_state = 4},
  [1926] = {.lex_state = 19, .external_lex_state = 4},
  [1927] = {.lex_state = 71},
  [1928] = {.lex_state = 71},
  [1929] = {.lex_state = 71},
  [1930] = {.lex_state = 71},
  [1931] = {.lex_state = 71},
  [1932] = {.lex_state = 71},
  [1933] = {.lex_state = 19, .external_lex_state = 4},
  [1934] = {.lex_state = 19, .external_lex_state = 4},
  [1935] = {.lex_state = 19, .external_lex_state = 4},
  [1936] = {.lex_state = 19, .external_lex_state = 4},
  [1937] = {.lex_state = 71},
  [1938] = {.lex_state = 71},
  [1939] = {.lex_state = 71},
  [1940] = {.lex_state = 19, .external_lex_state = 4},
  [1941] = {.lex_state = 19, .external_lex_state = 4},
  [1942] = {.lex_state = 71},
  [1943] = {.lex_state = 71},
  [1944] = {.lex_state = 71},
  [1945] = {.lex_state = 19, .external_lex_state = 4},
  [1946] = {.lex_state = 19, .external_lex_state = 4},
  [1947] = {.lex_state = 71},
  [1948] = {.lex_state = 19, .external_lex_state = 4},
  [1949] = {.lex_state = 71},
  [1950] = {.lex_state = 19, .external_lex_state = 4},
  [1951] = {.lex_state = 71},
  [1952] = {.lex_state = 71},
  [1953] = {.lex_state = 71},
  [1954] = {.lex_state = 71},
  [1955] = {.lex_state = 71},
  [1956] = {.lex_state = 71},
  [1957] = {.lex_state = 71},
  [1958] = {.lex_state = 71},
  [1959] = {.lex_state = 71},
  [1960] = {.lex_state = 71},
  [1961] = {.lex_state = 71},
  [1962] = {.lex_state = 71},
  [1963] = {.lex_state = 71},
  [1964] = {.lex_state = 19},
  [1965] = {.lex_state = 71},
  [1966] = {.lex_state = 71},
  [1967] = {.lex_state = 71},
  [1968] = {.lex_state = 71},
  [1969] = {.lex_state = 71},
  [1970] = {.lex_state = 71},
  [1971] = {.lex_state = 71},
  [1972] = {.lex_state = 71},
  [1973] = {.lex_state = 71},
  [1974] = {.lex_state = 71},
  [1975] = {.lex_state = 71},
  [1976] = {.lex_state = 71},
  [1977] = {.lex_state = 71},
  [1978] = {.lex_state = 71},
  [1979] = {.lex_state = 71},
  [1980] = {.lex_state = 71},
  [1981] = {.lex_state = 71},
  [1982] = {.lex_state = 71},
  [1983] = {.lex_state = 71},
  [1984] = {.lex_state = 71},
  [1985] = {.lex_state = 71},
  [1986] = {.lex_state = 71},
  [1987] = {.lex_state = 71},
  [1988] = {.lex_state = 71},
  [1989] = {.lex_state = 71},
  [1990] = {.lex_state = 71},
  [1991] = {.lex_state = 71},
  [1992] = {.lex_state = 71},
  [1993] = {.lex_state = 71},
  [1994] = {.lex_state = 71},
  [1995] = {.lex_state = 71},
  [1996] = {.lex_state = 71},
  [1997] = {.lex_state = 71},
  [1998] = {.lex_state = 71},
  [1999] = {.lex_state = 71},
  [2000] = {.lex_state = 71},
  [2001] = {.lex_state = 71},
  [2002] = {.lex_state = 71, .external_lex_state = 4},
  [2003] = {.lex_state = 71, .external_lex_state = 4},
  [2004] = {.lex_state = 71, .external_lex_state = 4},
  [2005] = {.lex_state = 71},
  [2006] = {.lex_state = 7},
  [2007] = {.lex_state = 71},
  [2008] = {.lex_state = 7},
  [2009] = {.lex_state = 7},
  [2010] = {.lex_state = 7},
  [2011] = {.lex_state = 7},
  [2012] = {.lex_state = 71},
  [2013] = {.lex_state = 71},
  [2014] = {.lex_state = 7},
  [2015] = {.lex_state = 71, .external_lex_state = 4},
  [2016] = {.lex_state = 71, .external_lex_state = 4},
  [2017] = {.lex_state = 71, .external_lex_state = 4},
  [2018] = {.lex_state = 71, .external_lex_state = 4},
  [2019] = {.lex_state = 71, .external_lex_state = 4},
  [2020] = {.lex_state = 71, .external_lex_state = 4},
  [2021] = {.lex_state = 71, .external_lex_state = 4},
  [2022] = {.lex_state = 71, .external_lex_state = 4},
  [2023] = {.lex_state = 71, .external_lex_state = 4},
  [2024] = {.lex_state = 71, .external_lex_state = 4},
  [2025] = {.lex_state = 71, .external_lex_state = 4},
  [2026] = {.lex_state = 71, .external_lex_state = 4},
  [2027] = {.lex_state = 71, .external_lex_state = 4},
  [2028] = {.lex_state = 71, .external_lex_state = 4},
  [2029] = {.lex_state = 71, .external_lex_state = 4},
  [2030] = {.lex_state = 71, .external_lex_state = 4},
  [2031] = {.lex_state = 71, .external_lex_state = 4},
  [2032] = {.lex_state = 71, .external_lex_state = 4},
  [2033] = {.lex_state = 71, .external_lex_state = 4},
  [2034] = {.lex_state = 71},
  [2035] = {.lex_state = 71, .external_lex_state = 4},
  [2036] = {.lex_state = 71, .external_lex_state = 4},
  [2037] = {.lex_state = 71, .external_lex_state = 4},
  [2038] = {.lex_state = 71, .external_lex_state = 4},
  [2039] = {.lex_state = 71, .external_lex_state = 4},
  [2040] = {.lex_state = 71, .external_lex_state = 4},
  [2041] = {.lex_state = 71, .external_lex_state = 4},
  [2042] = {.lex_state = 71, .external_lex_state = 4},
  [2043] = {.lex_state = 71, .external_lex_state = 4},
  [2044] = {.lex_state = 71, .external_lex_state = 4},
  [2045] = {.lex_state = 71, .external_lex_state = 4},
  [2046] = {.lex_state = 71, .external_lex_state = 4},
  [2047] = {.lex_state = 71, .external_lex_state = 4},
  [2048] = {.lex_state = 71, .external_lex_state = 4},
  [2049] = {.lex_state = 71, .external_lex_state = 4},
  [2050] = {.lex_state = 71, .external_lex_state = 4},
  [2051] = {.lex_state = 71, .external_lex_state = 4},
  [2052] = {.lex_state = 71},
  [2053] = {.lex_state = 71, .external_lex_state = 4},
  [2054] = {.lex_state = 71},
  [2055] = {.lex_state = 71, .external_lex_state = 4},
  [2056] = {.lex_state = 71, .external_lex_state = 4},
  [2057] = {.lex_state = 71, .external_lex_state = 4},
  [2058] = {.lex_state = 71, .external_lex_state = 4},
  [2059] = {.lex_state = 71, .external_lex_state = 4},
  [2060] = {.lex_state = 71, .external_lex_state = 4},
  [2061] = {.lex_state = 71, .external_lex_state = 4},
  [2062] = {.lex_state = 71, .external_lex_state = 4},
  [2063] = {.lex_state = 71, .external_lex_state = 4},
  [2064] = {.lex_state = 71, .external_lex_state = 4},
  [2065] = {.lex_state = 71, .external_lex_state = 4},
  [2066] = {.lex_state = 71, .external_lex_state = 4},
  [2067] = {.lex_state = 71, .external_lex_state = 4},
  [2068] = {.lex_state = 71, .external_lex_state = 4},
  [2069] = {.lex_state = 71, .external_lex_state = 4},
  [2070] = {.lex_state = 71, .external_lex_state = 4},
  [2071] = {.lex_state = 71, .external_lex_state = 4},
  [2072] = {.lex_state = 71, .external_lex_state = 4},
  [2073] = {.lex_state = 71, .external_lex_state = 4},
  [2074] = {.lex_state = 71, .external_lex_state = 4},
  [2075] = {.lex_state = 71, .external_lex_state = 4},
  [2076] = {.lex_state = 71, .external_lex_state = 4},
  [2077] = {.lex_state = 71, .external_lex_state = 4},
  [2078] = {.lex_state = 71, .external_lex_state = 4},
  [2079] = {.lex_state = 71, .external_lex_state = 4},
  [2080] = {.lex_state = 71, .external_lex_state = 4},
  [2081] = {.lex_state = 71, .external_lex_state = 4},
  [2082] = {.lex_state = 71, .external_lex_state = 4},
  [2083] = {.lex_state = 71, .external_lex_state = 4},
  [2084] = {.lex_state = 71, .external_lex_state = 4},
  [2085] = {.lex_state = 71, .external_lex_state = 4},
  [2086] = {.lex_state = 71, .external_lex_state = 4},
  [2087] = {.lex_state = 71, .external_lex_state = 4},
  [2088] = {.lex_state = 71, .external_lex_state = 4},
  [2089] = {.lex_state = 71, .external_lex_state = 4},
  [2090] = {.lex_state = 71, .external_lex_state = 4},
  [2091] = {.lex_state = 71, .external_lex_state = 4},
  [2092] = {.lex_state = 71, .external_lex_state = 4},
  [2093] = {.lex_state = 71, .external_lex_state = 4},
  [2094] = {.lex_state = 71, .external_lex_state = 4},
  [2095] = {.lex_state = 71, .external_lex_state = 4},
  [2096] = {.lex_state = 71, .external_lex_state = 4},
  [2097] = {.lex_state = 71, .external_lex_state = 4},
  [2098] = {.lex_state = 71, .external_lex_state = 4},
  [2099] = {.lex_state = 71, .external_lex_state = 4},
  [2100] = {.lex_state = 71},
  [2101] = {.lex_state = 71},
  [2102] = {.lex_state = 71, .external_lex_state = 4},
  [2103] = {.lex_state = 71},
  [2104] = {.lex_state = 71},
  [2105] = {.lex_state = 71},
  [2106] = {.lex_state = 71, .external_lex_state = 4},
  [2107] = {.lex_state = 71},
  [2108] = {.lex_state = 71},
  [2109] = {.lex_state = 71, .external_lex_state = 4},
  [2110] = {.lex_state = 71},
  [2111] = {.lex_state = 71},
  [2112] = {.lex_state = 71, .external_lex_state = 4},
  [2113] = {.lex_state = 71},
  [2114] = {.lex_state = 71},
  [2115] = {.lex_state = 71, .external_lex_state = 4},
  [2116] = {.lex_state = 71},
  [2117] = {.lex_state = 71},
  [2118] = {.lex_state = 71},
  [2119] = {.lex_state = 71},
  [2120] = {.lex_state = 71},
  [2121] = {.lex_state = 71, .external_lex_state = 4},
  [2122] = {.lex_state = 71},
  [2123] = {.lex_state = 71},
  [2124] = {.lex_state = 71},
  [2125] = {.lex_state = 71},
  [2126] = {.lex_state = 71},
  [2127] = {.lex_state = 71},
  [2128] = {.lex_state = 71},
  [2129] = {.lex_state = 71},
  [2130] = {.lex_state = 71},
  [2131] = {.lex_state = 71},
  [2132] = {.lex_state = 71},
  [2133] = {.lex_state = 71},
  [2134] = {.lex_state = 71},
  [2135] = {.lex_state = 71},
  [2136] = {.lex_state = 71},
  [2137] = {.lex_state = 71},
  [2138] = {.lex_state = 71},
  [2139] = {.lex_state = 71},
  [2140] = {.lex_state = 71, .external_lex_state = 4},
  [2141] = {.lex_state = 71},
  [2142] = {.lex_state = 71},
  [2143] = {.lex_state = 71},
  [2144] = {.lex_state = 71},
  [2145] = {.lex_state = 71, .external_lex_state = 4},
  [2146] = {.lex_state = 71},
  [2147] = {.lex_state = 71},
  [2148] = {.lex_state = 71},
  [2149] = {.lex_state = 71},
  [2150] = {.lex_state = 71},
  [2151] = {.lex_state = 71},
  [2152] = {.lex_state = 71, .external_lex_state = 4},
  [2153] = {.lex_state = 71},
  [2154] = {.lex_state = 71, .external_lex_state = 4},
  [2155] = {.lex_state = 71},
  [2156] = {.lex_state = 71},
  [2157] = {.lex_state = 71, .external_lex_state = 4},
  [2158] = {.lex_state = 71},
  [2159] = {.lex_state = 71, .external_lex_state = 4},
  [2160] = {.lex_state = 71, .external_lex_state = 4},
  [2161] = {.lex_state = 71},
  [2162] = {.lex_state = 0, .external_lex_state = 4},
  [2163] = {.lex_state = 71},
  [2164] = {.lex_state = 71},
  [2165] = {.lex_state = 71},
  [2166] = {.lex_state = 0},
  [2167] = {.lex_state = 0},
  [2168] = {.lex_state = 71},
  [2169] = {.lex_state = 71, .external_lex_state = 4},
  [2170] = {.lex_state = 0, .external_lex_state = 4},
  [2171] = {.lex_state = 71},
  [2172] = {.lex_state = 71},
  [2173] = {.lex_state = 71},
  [2174] = {.lex_state = 71},
  [2175] = {.lex_state = 71},
  [2176] = {.lex_state = 18},
  [2177] = {.lex_state = 71},
  [2178] = {.lex_state = 71},
  [2179] = {.lex_state = 71},
  [2180] = {.lex_state = 0, .external_lex_state = 4},
  [2181] = {.lex_state = 71},
  [2182] = {.lex_state = 71},
  [2183] = {.lex_state = 71},
  [2184] = {.lex_state = 0, .external_lex_state = 4},
  [2185] = {.lex_state = 71, .external_lex_state = 4},
  [2186] = {.lex_state = 71},
  [2187] = {.lex_state = 71},
  [2188] = {.lex_state = 71, .external_lex_state = 4},
  [2189] = {.lex_state = 71},
  [2190] = {.lex_state = 71},
  [2191] = {.lex_state = 71, .external_lex_state = 4},
  [2192] = {.lex_state = 0, .external_lex_state = 4},
  [2193] = {.lex_state = 0, .external_lex_state = 4},
  [2194] = {.lex_state = 0},
  [2195] = {.lex_state = 71, .external_lex_state = 4},
  [2196] = {.lex_state = 71},
  [2197] = {.lex_state = 18},
  [2198] = {.lex_state = 71},
  [2199] = {.lex_state = 71},
  [2200] = {.lex_state = 71, .external_lex_state = 4},
  [2201] = {.lex_state = 71, .external_lex_state = 4},
  [2202] = {.lex_state = 71, .external_lex_state = 4},
  [2203] = {.lex_state = 71, .external_lex_state = 4},
  [2204] = {.lex_state = 71, .external_lex_state = 4},
  [2205] = {.lex_state = 71, .external_lex_state = 4},
  [2206] = {.lex_state = 71, .external_lex_state = 4},
  [2207] = {.lex_state = 71, .external_lex_state = 4},
  [2208] = {.lex_state = 71, .external_lex_state = 4},
  [2209] = {.lex_state = 71},
  [2210] = {.lex_state = 71, .external_lex_state = 4},
  [2211] = {.lex_state = 71, .external_lex_state = 4},
  [2212] = {.lex_state = 71, .external_lex_state = 4},
  [2213] = {.lex_state = 71, .external_lex_state = 4},
  [2214] = {.lex_state = 71, .external_lex_state = 4},
  [2215] = {.lex_state = 71, .external_lex_state = 4},
  [2216] = {.lex_state = 71, .external_lex_state = 4},
  [2217] = {.lex_state = 71, .external_lex_state = 4},
  [2218] = {.lex_state = 71, .external_lex_state = 4},
  [2219] = {.lex_state = 71, .external_lex_state = 4},
  [2220] = {.lex_state = 71, .external_lex_state = 4},
  [2221] = {.lex_state = 71, .external_lex_state = 4},
  [2222] = {.lex_state = 0},
  [2223] = {.lex_state = 71},
  [2224] = {.lex_state = 71},
  [2225] = {.lex_state = 71},
  [2226] = {.lex_state = 71},
  [2227] = {.lex_state = 71},
  [2228] = {.lex_state = 71},
  [2229] = {.lex_state = 71, .external_lex_state = 4},
  [2230] = {.lex_state = 71},
  [2231] = {.lex_state = 71},
  [2232] = {.lex_state = 71, .external_lex_state = 4},
  [2233] = {.lex_state = 71},
  [2234] = {.lex_state = 71, .external_lex_state = 4},
  [2235] = {.lex_state = 71, .external_lex_state = 4},
  [2236] = {.lex_state = 71, .external_lex_state = 4},
  [2237] = {.lex_state = 0, .external_lex_state = 4},
  [2238] = {.lex_state = 71},
  [2239] = {.lex_state = 71, .external_lex_state = 4},
  [2240] = {.lex_state = 71, .external_lex_state = 4},
  [2241] = {.lex_state = 71, .external_lex_state = 4},
  [2242] = {.lex_state = 71, .external_lex_state = 4},
  [2243] = {.lex_state = 71},
  [2244] = {.lex_state = 71, .external_lex_state = 4},
  [2245] = {.lex_state = 0},
  [2246] = {.lex_state = 71},
  [2247] = {.lex_state = 71},
  [2248] = {.lex_state = 71},
  [2249] = {.lex_state = 71},
  [2250] = {.lex_state = 71},
  [2251] = {.lex_state = 71},
  [2252] = {.lex_state = 71, .external_lex_state = 4},
  [2253] = {.lex_state = 0, .external_lex_state = 4},
  [2254] = {.lex_state = 71},
  [2255] = {.lex_state = 71, .external_lex_state = 4},
  [2256] = {.lex_state = 71},
  [2257] = {.lex_state = 0, .external_lex_state = 4},
  [2258] = {.lex_state = 0, .external_lex_state = 4},
  [2259] = {.lex_state = 0, .external_lex_state = 4},
  [2260] = {.lex_state = 71},
  [2261] = {.lex_state = 71},
  [2262] = {.lex_state = 71, .external_lex_state = 4},
  [2263] = {.lex_state = 71, .external_lex_state = 4},
  [2264] = {.lex_state = 71, .external_lex_state = 4},
  [2265] = {.lex_state = 0, .external_lex_state = 4},
  [2266] = {.lex_state = 71},
  [2267] = {.lex_state = 0, .external_lex_state = 4},
  [2268] = {.lex_state = 71},
  [2269] = {.lex_state = 18},
  [2270] = {.lex_state = 71},
  [2271] = {.lex_state = 71},
  [2272] = {.lex_state = 71},
  [2273] = {.lex_state = 71},
  [2274] = {.lex_state = 0, .external_lex_state = 4},
  [2275] = {.lex_state = 71},
  [2276] = {.lex_state = 71},
  [2277] = {.lex_state = 0, .external_lex_state = 4},
  [2278] = {.lex_state = 71},
  [2279] = {.lex_state = 71},
  [2280] = {.lex_state = 23},
  [2281] = {.lex_state = 71},
  [2282] = {.lex_state = 71},
  [2283] = {.lex_state = 0, .external_lex_state = 4},
  [2284] = {.lex_state = 0, .external_lex_state = 4},
  [2285] = {.lex_state = 0, .external_lex_state = 4},
  [2286] = {.lex_state = 0, .external_lex_state = 4},
  [2287] = {.lex_state = 0, .external_lex_state = 4},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 23, .external_lex_state = 5},
  [2290] = {.lex_state = 71},
  [2291] = {.lex_state = 71, .external_lex_state = 4},
  [2292] = {.lex_state = 71},
  [2293] = {.lex_state = 71},
  [2294] = {.lex_state = 0, .external_lex_state = 4},
  [2295] = {.lex_state = 71},
  [2296] = {.lex_state = 0, .external_lex_state = 4},
  [2297] = {.lex_state = 71},
  [2298] = {.lex_state = 71},
  [2299] = {.lex_state = 71},
  [2300] = {.lex_state = 71},
  [2301] = {.lex_state = 71},
  [2302] = {.lex_state = 71},
  [2303] = {.lex_state = 71},
  [2304] = {.lex_state = 71},
  [2305] = {.lex_state = 71},
  [2306] = {.lex_state = 71},
  [2307] = {.lex_state = 23},
  [2308] = {.lex_state = 23},
  [2309] = {.lex_state = 0, .external_lex_state = 4},
  [2310] = {.lex_state = 71},
  [2311] = {.lex_state = 71},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 71},
  [2314] = {.lex_state = 71},
  [2315] = {.lex_state = 71},
  [2316] = {.lex_state = 23, .external_lex_state = 5},
  [2317] = {.lex_state = 71},
  [2318] = {.lex_state = 71},
  [2319] = {.lex_state = 71},
  [2320] = {.lex_state = 71},
  [2321] = {.lex_state = 0, .external_lex_state = 4},
  [2322] = {.lex_state = 71},
  [2323] = {.lex_state = 0, .external_lex_state = 4},
  [2324] = {.lex_state = 0, .external_lex_state = 4},
  [2325] = {.lex_state = 71},
  [2326] = {.lex_state = 71},
  [2327] = {.lex_state = 23},
  [2328] = {.lex_state = 23},
  [2329] = {.lex_state = 71},
  [2330] = {.lex_state = 71},
  [2331] = {.lex_state = 0, .external_lex_state = 4},
  [2332] = {.lex_state = 71},
  [2333] = {.lex_state = 23, .external_lex_state = 5},
  [2334] = {.lex_state = 71},
  [2335] = {.lex_state = 71},
  [2336] = {.lex_state = 71},
  [2337] = {.lex_state = 71},
  [2338] = {.lex_state = 23, .external_lex_state = 5},
  [2339] = {.lex_state = 71},
  [2340] = {.lex_state = 0, .external_lex_state = 4},
  [2341] = {.lex_state = 71},
  [2342] = {.lex_state = 71},
  [2343] = {.lex_state = 23, .external_lex_state = 5},
  [2344] = {.lex_state = 23, .external_lex_state = 5},
  [2345] = {.lex_state = 71},
  [2346] = {.lex_state = 23},
  [2347] = {.lex_state = 71},
  [2348] = {.lex_state = 23},
  [2349] = {.lex_state = 71},
  [2350] = {.lex_state = 71},
  [2351] = {.lex_state = 71},
  [2352] = {.lex_state = 71},
  [2353] = {.lex_state = 71},
  [2354] = {.lex_state = 71},
  [2355] = {.lex_state = 23, .external_lex_state = 5},
  [2356] = {.lex_state = 71},
  [2357] = {.lex_state = 71},
  [2358] = {.lex_state = 71},
  [2359] = {.lex_state = 71},
  [2360] = {.lex_state = 71},
  [2361] = {.lex_state = 23},
  [2362] = {.lex_state = 71},
  [2363] = {.lex_state = 71},
  [2364] = {.lex_state = 71},
  [2365] = {.lex_state = 71},
  [2366] = {.lex_state = 71},
  [2367] = {.lex_state = 71},
  [2368] = {.lex_state = 23},
  [2369] = {.lex_state = 71},
  [2370] = {.lex_state = 71},
  [2371] = {.lex_state = 71},
  [2372] = {.lex_state = 0, .external_lex_state = 4},
  [2373] = {.lex_state = 0, .external_lex_state = 4},
  [2374] = {.lex_state = 0, .external_lex_state = 4},
  [2375] = {.lex_state = 0, .external_lex_state = 4},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 0, .external_lex_state = 4},
  [2378] = {.lex_state = 71},
  [2379] = {.lex_state = 0, .external_lex_state = 4},
  [2380] = {.lex_state = 71, .external_lex_state = 4},
  [2381] = {.lex_state = 71},
  [2382] = {.lex_state = 71},
  [2383] = {.lex_state = 0, .external_lex_state = 4},
  [2384] = {.lex_state = 0},
  [2385] = {.lex_state = 71},
  [2386] = {.lex_state = 0, .external_lex_state = 4},
  [2387] = {.lex_state = 71},
  [2388] = {.lex_state = 71},
  [2389] = {.lex_state = 71, .external_lex_state = 4},
  [2390] = {.lex_state = 71, .external_lex_state = 4},
  [2391] = {.lex_state = 71},
  [2392] = {.lex_state = 0},
  [2393] = {.lex_state = 71},
  [2394] = {.lex_state = 0, .external_lex_state = 4},
  [2395] = {.lex_state = 71, .external_lex_state = 4},
  [2396] = {.lex_state = 18},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 71},
  [2399] = {.lex_state = 71},
  [2400] = {.lex_state = 71},
  [2401] = {.lex_state = 0, .external_lex_state = 4},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 0, .external_lex_state = 4},
  [2404] = {.lex_state = 0, .external_lex_state = 4},
  [2405] = {.lex_state = 0, .external_lex_state = 4},
  [2406] = {.lex_state = 0, .external_lex_state = 4},
  [2407] = {.lex_state = 71},
  [2408] = {.lex_state = 0, .external_lex_state = 4},
  [2409] = {.lex_state = 71},
  [2410] = {.lex_state = 71},
  [2411] = {.lex_state = 71},
  [2412] = {.lex_state = 0, .external_lex_state = 4},
  [2413] = {.lex_state = 0, .external_lex_state = 4},
  [2414] = {.lex_state = 71},
  [2415] = {.lex_state = 71, .external_lex_state = 4},
  [2416] = {.lex_state = 71, .external_lex_state = 4},
  [2417] = {.lex_state = 0, .external_lex_state = 4},
  [2418] = {.lex_state = 0, .external_lex_state = 4},
  [2419] = {.lex_state = 71},
  [2420] = {.lex_state = 0, .external_lex_state = 4},
  [2421] = {.lex_state = 0, .external_lex_state = 4},
  [2422] = {.lex_state = 0, .external_lex_state = 4},
  [2423] = {.lex_state = 71},
  [2424] = {.lex_state = 71},
  [2425] = {.lex_state = 0, .external_lex_state = 4},
  [2426] = {.lex_state = 71},
  [2427] = {.lex_state = 71},
  [2428] = {.lex_state = 71},
  [2429] = {.lex_state = 71},
  [2430] = {.lex_state = 0, .external_lex_state = 4},
  [2431] = {.lex_state = 0, .external_lex_state = 4},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 71},
  [2434] = {.lex_state = 0, .external_lex_state = 4},
  [2435] = {.lex_state = 71},
  [2436] = {.lex_state = 71},
  [2437] = {.lex_state = 18},
  [2438] = {.lex_state = 71},
  [2439] = {.lex_state = 71},
  [2440] = {.lex_state = 71},
  [2441] = {.lex_state = 71, .external_lex_state = 4},
  [2442] = {.lex_state = 71},
  [2443] = {.lex_state = 71, .external_lex_state = 4},
  [2444] = {.lex_state = 0, .external_lex_state = 4},
  [2445] = {.lex_state = 71},
  [2446] = {.lex_state = 71, .external_lex_state = 4},
  [2447] = {.lex_state = 71},
  [2448] = {.lex_state = 71, .external_lex_state = 4},
  [2449] = {.lex_state = 0, .external_lex_state = 4},
  [2450] = {.lex_state = 0, .external_lex_state = 4},
  [2451] = {.lex_state = 0, .external_lex_state = 4},
  [2452] = {.lex_state = 0, .external_lex_state = 4},
  [2453] = {.lex_state = 71},
  [2454] = {.lex_state = 0, .external_lex_state = 4},
  [2455] = {.lex_state = 0, .external_lex_state = 4},
  [2456] = {.lex_state = 71, .external_lex_state = 4},
  [2457] = {.lex_state = 0, .external_lex_state = 4},
  [2458] = {.lex_state = 0, .external_lex_state = 4},
  [2459] = {.lex_state = 0, .external_lex_state = 4},
  [2460] = {.lex_state = 71, .external_lex_state = 4},
  [2461] = {.lex_state = 0, .external_lex_state = 4},
  [2462] = {.lex_state = 0, .external_lex_state = 4},
  [2463] = {.lex_state = 0, .external_lex_state = 4},
  [2464] = {.lex_state = 0, .external_lex_state = 4},
  [2465] = {.lex_state = 0, .external_lex_state = 4},
  [2466] = {.lex_state = 71},
  [2467] = {.lex_state = 0, .external_lex_state = 4},
  [2468] = {.lex_state = 0, .external_lex_state = 4},
  [2469] = {.lex_state = 0, .external_lex_state = 4},
  [2470] = {.lex_state = 71},
  [2471] = {.lex_state = 0, .external_lex_state = 4},
  [2472] = {.lex_state = 71},
  [2473] = {.lex_state = 0},
  [2474] = {.lex_state = 0, .external_lex_state = 4},
  [2475] = {.lex_state = 71},
  [2476] = {.lex_state = 71},
  [2477] = {.lex_state = 71},
  [2478] = {.lex_state = 71},
  [2479] = {.lex_state = 0, .external_lex_state = 4},
  [2480] = {.lex_state = 0, .external_lex_state = 4},
  [2481] = {.lex_state = 71},
  [2482] = {.lex_state = 0, .external_lex_state = 4},
  [2483] = {.lex_state = 71},
  [2484] = {.lex_state = 71},
  [2485] = {.lex_state = 0, .external_lex_state = 4},
  [2486] = {.lex_state = 71},
  [2487] = {.lex_state = 0, .external_lex_state = 4},
  [2488] = {.lex_state = 18},
  [2489] = {.lex_state = 71, .external_lex_state = 4},
  [2490] = {.lex_state = 71},
  [2491] = {.lex_state = 0, .external_lex_state = 4},
  [2492] = {.lex_state = 71},
  [2493] = {.lex_state = 18},
  [2494] = {.lex_state = 0, .external_lex_state = 4},
  [2495] = {.lex_state = 0, .external_lex_state = 4},
  [2496] = {.lex_state = 71},
  [2497] = {.lex_state = 0, .external_lex_state = 4},
  [2498] = {.lex_state = 71},
  [2499] = {.lex_state = 71},
  [2500] = {.lex_state = 0, .external_lex_state = 4},
  [2501] = {.lex_state = 71, .external_lex_state = 4},
  [2502] = {.lex_state = 0, .external_lex_state = 4},
  [2503] = {.lex_state = 71},
  [2504] = {.lex_state = 71},
  [2505] = {.lex_state = 71},
  [2506] = {.lex_state = 71},
  [2507] = {.lex_state = 71},
  [2508] = {.lex_state = 0, .external_lex_state = 4},
  [2509] = {.lex_state = 71},
  [2510] = {.lex_state = 0, .external_lex_state = 4},
  [2511] = {.lex_state = 0, .external_lex_state = 4},
  [2512] = {.lex_state = 0, .external_lex_state = 4},
  [2513] = {.lex_state = 71},
  [2514] = {.lex_state = 0, .external_lex_state = 4},
  [2515] = {.lex_state = 71},
  [2516] = {.lex_state = 0, .external_lex_state = 4},
  [2517] = {.lex_state = 0, .external_lex_state = 4},
  [2518] = {.lex_state = 71},
  [2519] = {.lex_state = 71},
  [2520] = {.lex_state = 0, .external_lex_state = 4},
  [2521] = {.lex_state = 0, .external_lex_state = 4},
  [2522] = {.lex_state = 71},
  [2523] = {.lex_state = 0, .external_lex_state = 4},
  [2524] = {.lex_state = 71, .external_lex_state = 4},
  [2525] = {.lex_state = 0, .external_lex_state = 4},
  [2526] = {.lex_state = 0, .external_lex_state = 4},
  [2527] = {.lex_state = 71},
  [2528] = {.lex_state = 0, .external_lex_state = 4},
  [2529] = {.lex_state = 71},
  [2530] = {.lex_state = 0, .external_lex_state = 4},
  [2531] = {.lex_state = 71},
  [2532] = {.lex_state = 71, .external_lex_state = 4},
  [2533] = {.lex_state = 0, .external_lex_state = 4},
  [2534] = {.lex_state = 0, .external_lex_state = 4},
  [2535] = {.lex_state = 71},
  [2536] = {.lex_state = 71},
  [2537] = {.lex_state = 0, .external_lex_state = 4},
  [2538] = {.lex_state = 0, .external_lex_state = 4},
  [2539] = {.lex_state = 71},
  [2540] = {.lex_state = 0},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 71},
  [2543] = {.lex_state = 0, .external_lex_state = 4},
  [2544] = {.lex_state = 0, .external_lex_state = 4},
  [2545] = {.lex_state = 0, .external_lex_state = 4},
  [2546] = {.lex_state = 0},
  [2547] = {.lex_state = 0, .external_lex_state = 4},
  [2548] = {.lex_state = 0, .external_lex_state = 4},
  [2549] = {.lex_state = 0, .external_lex_state = 4},
  [2550] = {.lex_state = 0, .external_lex_state = 4},
  [2551] = {.lex_state = 71},
  [2552] = {.lex_state = 0, .external_lex_state = 4},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 71},
  [2555] = {.lex_state = 0, .external_lex_state = 4},
  [2556] = {.lex_state = 71},
  [2557] = {.lex_state = 0, .external_lex_state = 4},
  [2558] = {.lex_state = 0, .external_lex_state = 4},
  [2559] = {.lex_state = 0, .external_lex_state = 4},
  [2560] = {.lex_state = 0, .external_lex_state = 4},
  [2561] = {.lex_state = 0, .external_lex_state = 4},
  [2562] = {.lex_state = 0, .external_lex_state = 4},
  [2563] = {.lex_state = 0, .external_lex_state = 4},
  [2564] = {.lex_state = 0, .external_lex_state = 4},
  [2565] = {.lex_state = 71},
  [2566] = {.lex_state = 71},
  [2567] = {.lex_state = 0, .external_lex_state = 4},
  [2568] = {.lex_state = 71, .external_lex_state = 4},
  [2569] = {.lex_state = 71},
  [2570] = {.lex_state = 0, .external_lex_state = 4},
  [2571] = {.lex_state = 71},
  [2572] = {.lex_state = 0, .external_lex_state = 4},
  [2573] = {.lex_state = 0},
  [2574] = {.lex_state = 71},
  [2575] = {.lex_state = 0, .external_lex_state = 4},
  [2576] = {.lex_state = 0, .external_lex_state = 4},
  [2577] = {.lex_state = 0, .external_lex_state = 4},
  [2578] = {.lex_state = 71},
  [2579] = {.lex_state = 0, .external_lex_state = 4},
  [2580] = {.lex_state = 71},
  [2581] = {.lex_state = 71},
  [2582] = {.lex_state = 71},
  [2583] = {.lex_state = 71},
  [2584] = {.lex_state = 71},
  [2585] = {.lex_state = 71},
  [2586] = {.lex_state = 71, .external_lex_state = 4},
  [2587] = {.lex_state = 71},
  [2588] = {.lex_state = 71, .external_lex_state = 4},
  [2589] = {.lex_state = 0, .external_lex_state = 4},
  [2590] = {.lex_state = 71},
  [2591] = {.lex_state = 71, .external_lex_state = 4},
  [2592] = {.lex_state = 0, .external_lex_state = 4},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0, .external_lex_state = 4},
  [2595] = {.lex_state = 0, .external_lex_state = 4},
  [2596] = {.lex_state = 0, .external_lex_state = 4},
  [2597] = {.lex_state = 0, .external_lex_state = 4},
  [2598] = {.lex_state = 0, .external_lex_state = 4},
  [2599] = {.lex_state = 0, .external_lex_state = 4},
  [2600] = {.lex_state = 0, .external_lex_state = 4},
  [2601] = {.lex_state = 71, .external_lex_state = 4},
  [2602] = {.lex_state = 0, .external_lex_state = 4},
  [2603] = {.lex_state = 0, .external_lex_state = 4},
  [2604] = {.lex_state = 71},
  [2605] = {.lex_state = 0, .external_lex_state = 4},
  [2606] = {.lex_state = 71, .external_lex_state = 4},
  [2607] = {.lex_state = 0, .external_lex_state = 4},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 0, .external_lex_state = 4},
  [2610] = {.lex_state = 0, .external_lex_state = 4},
  [2611] = {.lex_state = 71},
  [2612] = {.lex_state = 0, .external_lex_state = 4},
  [2613] = {.lex_state = 0, .external_lex_state = 4},
  [2614] = {.lex_state = 0, .external_lex_state = 4},
  [2615] = {.lex_state = 0, .external_lex_state = 4},
  [2616] = {.lex_state = 0},
  [2617] = {.lex_state = 71},
  [2618] = {.lex_state = 71},
  [2619] = {.lex_state = 71},
  [2620] = {.lex_state = 71},
  [2621] = {.lex_state = 71, .external_lex_state = 4},
  [2622] = {.lex_state = 71},
  [2623] = {.lex_state = 71},
  [2624] = {.lex_state = 1},
  [2625] = {.lex_state = 71},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 1},
  [2628] = {.lex_state = 0},
  [2629] = {.lex_state = 71, .external_lex_state = 4},
  [2630] = {.lex_state = 1},
  [2631] = {.lex_state = 71},
  [2632] = {.lex_state = 71},
  [2633] = {.lex_state = 71},
  [2634] = {.lex_state = 71},
  [2635] = {.lex_state = 0},
  [2636] = {.lex_state = 71},
  [2637] = {.lex_state = 0},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 71, .external_lex_state = 4},
  [2640] = {.lex_state = 71, .external_lex_state = 4},
  [2641] = {.lex_state = 71},
  [2642] = {.lex_state = 71},
  [2643] = {.lex_state = 71},
  [2644] = {.lex_state = 71},
  [2645] = {.lex_state = 71, .external_lex_state = 4},
  [2646] = {.lex_state = 71},
  [2647] = {.lex_state = 1},
  [2648] = {.lex_state = 71},
  [2649] = {.lex_state = 71},
  [2650] = {.lex_state = 1},
  [2651] = {.lex_state = 71},
  [2652] = {.lex_state = 0},
  [2653] = {.lex_state = 71},
  [2654] = {.lex_state = 71},
  [2655] = {.lex_state = 71},
  [2656] = {.lex_state = 71},
  [2657] = {.lex_state = 71, .external_lex_state = 4},
  [2658] = {.lex_state = 71},
  [2659] = {.lex_state = 71},
  [2660] = {.lex_state = 71},
  [2661] = {.lex_state = 71, .external_lex_state = 4},
  [2662] = {.lex_state = 0, .external_lex_state = 4},
  [2663] = {.lex_state = 0, .external_lex_state = 4},
  [2664] = {.lex_state = 71},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 71},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 0},
  [2669] = {.lex_state = 0},
  [2670] = {.lex_state = 0},
  [2671] = {.lex_state = 71},
  [2672] = {.lex_state = 71},
  [2673] = {.lex_state = 0, .external_lex_state = 4},
  [2674] = {.lex_state = 1},
  [2675] = {.lex_state = 0, .external_lex_state = 4},
  [2676] = {.lex_state = 1},
  [2677] = {.lex_state = 71, .external_lex_state = 4},
  [2678] = {.lex_state = 0, .external_lex_state = 4},
  [2679] = {.lex_state = 71},
  [2680] = {.lex_state = 1},
  [2681] = {.lex_state = 0, .external_lex_state = 4},
  [2682] = {.lex_state = 71},
  [2683] = {.lex_state = 0, .external_lex_state = 4},
  [2684] = {.lex_state = 71},
  [2685] = {.lex_state = 71},
  [2686] = {.lex_state = 71},
  [2687] = {.lex_state = 71},
  [2688] = {.lex_state = 71},
  [2689] = {.lex_state = 71},
  [2690] = {.lex_state = 71},
  [2691] = {.lex_state = 71},
  [2692] = {.lex_state = 71},
  [2693] = {.lex_state = 71},
  [2694] = {.lex_state = 71},
  [2695] = {.lex_state = 71},
  [2696] = {.lex_state = 0, .external_lex_state = 4},
  [2697] = {.lex_state = 71},
  [2698] = {.lex_state = 0, .external_lex_state = 4},
  [2699] = {.lex_state = 71},
  [2700] = {.lex_state = 71},
  [2701] = {.lex_state = 0},
  [2702] = {.lex_state = 71},
  [2703] = {.lex_state = 71},
  [2704] = {.lex_state = 71},
  [2705] = {.lex_state = 71},
  [2706] = {.lex_state = 1},
  [2707] = {.lex_state = 71},
  [2708] = {.lex_state = 71},
  [2709] = {.lex_state = 71},
  [2710] = {.lex_state = 71},
  [2711] = {.lex_state = 0},
  [2712] = {.lex_state = 71},
  [2713] = {.lex_state = 71, .external_lex_state = 4},
  [2714] = {.lex_state = 23, .external_lex_state = 5},
  [2715] = {.lex_state = 1},
  [2716] = {.lex_state = 71, .external_lex_state = 4},
  [2717] = {.lex_state = 71},
  [2718] = {.lex_state = 1},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 71},
  [2721] = {.lex_state = 71},
  [2722] = {.lex_state = 1},
  [2723] = {.lex_state = 71},
  [2724] = {.lex_state = 1},
  [2725] = {.lex_state = 71},
  [2726] = {.lex_state = 71},
  [2727] = {.lex_state = 71},
  [2728] = {.lex_state = 71},
  [2729] = {.lex_state = 71},
  [2730] = {.lex_state = 0, .external_lex_state = 4},
  [2731] = {.lex_state = 71},
  [2732] = {.lex_state = 71, .external_lex_state = 4},
  [2733] = {.lex_state = 71},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 71},
  [2736] = {.lex_state = 0},
  [2737] = {.lex_state = 71},
  [2738] = {.lex_state = 71},
  [2739] = {.lex_state = 71},
  [2740] = {.lex_state = 71, .external_lex_state = 4},
  [2741] = {.lex_state = 71, .external_lex_state = 4},
  [2742] = {.lex_state = 0},
  [2743] = {.lex_state = 0},
  [2744] = {.lex_state = 71},
  [2745] = {.lex_state = 71},
  [2746] = {.lex_state = 18},
  [2747] = {.lex_state = 0},
  [2748] = {.lex_state = 18},
  [2749] = {.lex_state = 18},
  [2750] = {.lex_state = 0},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 0},
  [2755] = {.lex_state = 0},
  [2756] = {.lex_state = 0, .external_lex_state = 4},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 0},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 71},
  [2761] = {.lex_state = 0, .external_lex_state = 4},
  [2762] = {.lex_state = 71},
  [2763] = {.lex_state = 71},
  [2764] = {.lex_state = 0, .external_lex_state = 4},
  [2765] = {.lex_state = 71},
  [2766] = {.lex_state = 0, .external_lex_state = 4},
  [2767] = {.lex_state = 0, .external_lex_state = 4},
  [2768] = {.lex_state = 0},
  [2769] = {.lex_state = 0, .external_lex_state = 4},
  [2770] = {.lex_state = 0},
  [2771] = {.lex_state = 71},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 0},
  [2776] = {.lex_state = 71},
  [2777] = {.lex_state = 0, .external_lex_state = 4},
  [2778] = {.lex_state = 0, .external_lex_state = 4},
  [2779] = {.lex_state = 0, .external_lex_state = 4},
  [2780] = {.lex_state = 0, .external_lex_state = 4},
  [2781] = {.lex_state = 0, .external_lex_state = 4},
  [2782] = {.lex_state = 0, .external_lex_state = 4},
  [2783] = {.lex_state = 0, .external_lex_state = 4},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 0, .external_lex_state = 4},
  [2786] = {.lex_state = 71},
  [2787] = {.lex_state = 0, .external_lex_state = 4},
  [2788] = {.lex_state = 71},
  [2789] = {.lex_state = 0, .external_lex_state = 4},
  [2790] = {.lex_state = 0, .external_lex_state = 4},
  [2791] = {.lex_state = 71, .external_lex_state = 4},
  [2792] = {.lex_state = 71},
  [2793] = {.lex_state = 0, .external_lex_state = 4},
  [2794] = {.lex_state = 0, .external_lex_state = 4},
  [2795] = {.lex_state = 0},
  [2796] = {.lex_state = 0},
  [2797] = {.lex_state = 71},
  [2798] = {.lex_state = 0},
  [2799] = {.lex_state = 0},
  [2800] = {.lex_state = 0, .external_lex_state = 4},
  [2801] = {.lex_state = 0},
  [2802] = {.lex_state = 0, .external_lex_state = 4},
  [2803] = {.lex_state = 0},
  [2804] = {.lex_state = 0, .external_lex_state = 4},
  [2805] = {.lex_state = 0},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 0, .external_lex_state = 4},
  [2809] = {.lex_state = 0, .external_lex_state = 4},
  [2810] = {.lex_state = 0},
  [2811] = {.lex_state = 0},
  [2812] = {.lex_state = 0},
  [2813] = {.lex_state = 0},
  [2814] = {.lex_state = 0, .external_lex_state = 4},
  [2815] = {.lex_state = 71},
  [2816] = {.lex_state = 0, .external_lex_state = 4},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 0},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 0},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 71},
  [2824] = {.lex_state = 71},
  [2825] = {.lex_state = 0, .external_lex_state = 4},
  [2826] = {.lex_state = 71},
  [2827] = {.lex_state = 0, .external_lex_state = 4},
  [2828] = {.lex_state = 0, .external_lex_state = 4},
  [2829] = {.lex_state = 71},
  [2830] = {.lex_state = 71},
  [2831] = {.lex_state = 71},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 0},
  [2834] = {.lex_state = 0, .external_lex_state = 4},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 71},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 71},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 0},
  [2842] = {.lex_state = 0},
  [2843] = {.lex_state = 0},
  [2844] = {.lex_state = 0, .external_lex_state = 4},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 71},
  [2847] = {.lex_state = 71},
  [2848] = {.lex_state = 0},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 71},
  [2851] = {.lex_state = 0},
  [2852] = {.lex_state = 0},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 0, .external_lex_state = 4},
  [2855] = {.lex_state = 71},
  [2856] = {.lex_state = 71},
  [2857] = {.lex_state = 71},
  [2858] = {.lex_state = 0},
  [2859] = {.lex_state = 0},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 0},
  [2862] = {.lex_state = 0},
  [2863] = {.lex_state = 71},
  [2864] = {.lex_state = 0},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 0},
  [2867] = {.lex_state = 0},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 71},
  [2870] = {.lex_state = 71},
  [2871] = {.lex_state = 71},
  [2872] = {.lex_state = 71},
  [2873] = {.lex_state = 71},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 71, .external_lex_state = 4},
  [2876] = {.lex_state = 71},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 71},
  [2879] = {.lex_state = 71},
  [2880] = {.lex_state = 71},
  [2881] = {.lex_state = 0},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 71},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 71},
  [2887] = {.lex_state = 71, .external_lex_state = 4},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 71},
  [2892] = {.lex_state = 71},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 71},
  [2895] = {.lex_state = 0},
  [2896] = {.lex_state = 0},
  [2897] = {.lex_state = 0},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 0},
  [2900] = {.lex_state = 71},
  [2901] = {.lex_state = 71, .external_lex_state = 4},
  [2902] = {.lex_state = 0},
  [2903] = {.lex_state = 71},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 71, .external_lex_state = 4},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 71},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 0, .external_lex_state = 4},
  [2913] = {.lex_state = 71},
  [2914] = {.lex_state = 71},
  [2915] = {.lex_state = 0},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 71},
  [2918] = {.lex_state = 0},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 71},
  [2921] = {.lex_state = 0, .external_lex_state = 4},
  [2922] = {.lex_state = 0},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 0, .external_lex_state = 4},
  [2929] = {.lex_state = 0},
  [2930] = {.lex_state = 0, .external_lex_state = 4},
  [2931] = {.lex_state = 0, .external_lex_state = 4},
  [2932] = {.lex_state = 0, .external_lex_state = 4},
  [2933] = {.lex_state = 71},
  [2934] = {.lex_state = 0},
  [2935] = {.lex_state = 0, .external_lex_state = 4},
  [2936] = {.lex_state = 0, .external_lex_state = 4},
  [2937] = {.lex_state = 0, .external_lex_state = 4},
  [2938] = {.lex_state = 71},
  [2939] = {.lex_state = 0, .external_lex_state = 4},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 0, .external_lex_state = 4},
  [2942] = {.lex_state = 0, .external_lex_state = 4},
  [2943] = {.lex_state = 71},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 71},
  [2947] = {.lex_state = 0},
  [2948] = {.lex_state = 71},
  [2949] = {.lex_state = 71},
  [2950] = {.lex_state = 71},
  [2951] = {.lex_state = 0},
  [2952] = {.lex_state = 0},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 0},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 71},
  [2957] = {.lex_state = 0},
  [2958] = {.lex_state = 71},
  [2959] = {.lex_state = 0},
  [2960] = {.lex_state = 0, .external_lex_state = 4},
  [2961] = {.lex_state = 71},
  [2962] = {.lex_state = 0, .external_lex_state = 4},
  [2963] = {.lex_state = 0},
  [2964] = {.lex_state = 71},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 71},
  [2967] = {.lex_state = 71},
  [2968] = {.lex_state = 3},
  [2969] = {.lex_state = 0},
  [2970] = {.lex_state = 0, .external_lex_state = 4},
  [2971] = {.lex_state = 0, .external_lex_state = 4},
  [2972] = {.lex_state = 0},
  [2973] = {.lex_state = 71},
  [2974] = {.lex_state = 71},
  [2975] = {.lex_state = 0},
  [2976] = {.lex_state = 71},
  [2977] = {.lex_state = 71},
  [2978] = {.lex_state = 71},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 0, .external_lex_state = 4},
  [2981] = {.lex_state = 0},
  [2982] = {.lex_state = 71},
  [2983] = {.lex_state = 71},
  [2984] = {.lex_state = 0},
  [2985] = {.lex_state = 71},
  [2986] = {.lex_state = 71},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 71},
  [2989] = {.lex_state = 71},
  [2990] = {.lex_state = 71},
  [2991] = {.lex_state = 0, .external_lex_state = 4},
  [2992] = {.lex_state = 0},
  [2993] = {.lex_state = 71},
  [2994] = {.lex_state = 71},
  [2995] = {.lex_state = 71},
  [2996] = {.lex_state = 71},
  [2997] = {.lex_state = 71},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 71},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 71},
  [3002] = {.lex_state = 71},
  [3003] = {.lex_state = 71},
  [3004] = {.lex_state = 71},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 71},
  [3008] = {.lex_state = 0},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 0, .external_lex_state = 4},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 71},
  [3013] = {.lex_state = 0, .external_lex_state = 4},
  [3014] = {.lex_state = 0, .external_lex_state = 4},
  [3015] = {.lex_state = 71},
  [3016] = {.lex_state = 71},
  [3017] = {.lex_state = 0, .external_lex_state = 4},
  [3018] = {.lex_state = 0, .external_lex_state = 4},
  [3019] = {.lex_state = 71},
  [3020] = {.lex_state = 3},
  [3021] = {.lex_state = 71},
  [3022] = {.lex_state = 71},
  [3023] = {.lex_state = 71},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 71},
  [3026] = {.lex_state = 71},
  [3027] = {.lex_state = 71},
  [3028] = {.lex_state = 71},
  [3029] = {.lex_state = 71},
  [3030] = {.lex_state = 71},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 71},
  [3034] = {.lex_state = 0, .external_lex_state = 4},
  [3035] = {.lex_state = 71},
  [3036] = {.lex_state = 0, .external_lex_state = 4},
  [3037] = {.lex_state = 71},
  [3038] = {.lex_state = 0, .external_lex_state = 4},
  [3039] = {.lex_state = 71},
  [3040] = {.lex_state = 71},
  [3041] = {.lex_state = 71},
  [3042] = {.lex_state = 71},
  [3043] = {.lex_state = 71},
  [3044] = {.lex_state = 71},
  [3045] = {.lex_state = 0},
  [3046] = {.lex_state = 71},
  [3047] = {.lex_state = 71},
  [3048] = {.lex_state = 0},
  [3049] = {.lex_state = 0},
  [3050] = {.lex_state = 0},
  [3051] = {.lex_state = 0},
  [3052] = {.lex_state = 71},
  [3053] = {.lex_state = 0, .external_lex_state = 4},
  [3054] = {.lex_state = 0},
  [3055] = {.lex_state = 0},
  [3056] = {.lex_state = 71},
  [3057] = {.lex_state = 71},
  [3058] = {.lex_state = 71},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 71},
  [3061] = {.lex_state = 71},
  [3062] = {.lex_state = 71},
  [3063] = {.lex_state = 71},
  [3064] = {.lex_state = 71},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0, .external_lex_state = 4},
  [3067] = {.lex_state = 71},
  [3068] = {.lex_state = 0},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 71},
  [3071] = {.lex_state = 71},
  [3072] = {.lex_state = 0},
  [3073] = {.lex_state = 71},
  [3074] = {.lex_state = 71},
  [3075] = {.lex_state = 71},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 0},
  [3078] = {.lex_state = 0, .external_lex_state = 4},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 0, .external_lex_state = 4},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 3},
  [3083] = {.lex_state = 71},
  [3084] = {.lex_state = 71},
  [3085] = {.lex_state = 71},
  [3086] = {.lex_state = 71},
  [3087] = {.lex_state = 71},
  [3088] = {.lex_state = 71},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 71},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 71},
  [3093] = {.lex_state = 0},
  [3094] = {.lex_state = 71},
  [3095] = {.lex_state = 71},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 71},
  [3098] = {.lex_state = 71},
  [3099] = {.lex_state = 71},
  [3100] = {.lex_state = 71},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 71},
  [3103] = {.lex_state = 71},
  [3104] = {.lex_state = 71},
  [3105] = {.lex_state = 71},
  [3106] = {.lex_state = 71},
  [3107] = {.lex_state = 71},
  [3108] = {.lex_state = 71},
  [3109] = {.lex_state = 71},
  [3110] = {.lex_state = 71},
  [3111] = {.lex_state = 71},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 71},
  [3114] = {.lex_state = 0, .external_lex_state = 4},
  [3115] = {.lex_state = 71},
  [3116] = {.lex_state = 71},
  [3117] = {.lex_state = 71},
  [3118] = {.lex_state = 71},
  [3119] = {.lex_state = 71},
  [3120] = {.lex_state = 71},
  [3121] = {.lex_state = 71},
  [3122] = {.lex_state = 71},
  [3123] = {.lex_state = 0},
  [3124] = {.lex_state = 71},
  [3125] = {.lex_state = 71},
  [3126] = {.lex_state = 0},
  [3127] = {.lex_state = 0},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 0},
  [3130] = {.lex_state = 0},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 71},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 71},
  [3135] = {.lex_state = 71},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 0},
  [3138] = {.lex_state = 71},
  [3139] = {.lex_state = 71},
  [3140] = {.lex_state = 71},
  [3141] = {.lex_state = 0, .external_lex_state = 4},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 0},
  [3144] = {.lex_state = 71},
  [3145] = {.lex_state = 0},
  [3146] = {.lex_state = 71},
  [3147] = {.lex_state = 0},
  [3148] = {.lex_state = 71},
  [3149] = {.lex_state = 0},
  [3150] = {.lex_state = 71},
  [3151] = {.lex_state = 71},
  [3152] = {.lex_state = 0},
  [3153] = {.lex_state = 0},
  [3154] = {.lex_state = 0, .external_lex_state = 4},
  [3155] = {.lex_state = 71},
  [3156] = {.lex_state = 71},
  [3157] = {.lex_state = 71},
  [3158] = {.lex_state = 0},
  [3159] = {.lex_state = 71},
  [3160] = {.lex_state = 71},
  [3161] = {.lex_state = 71},
  [3162] = {.lex_state = 0},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 71},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 71},
  [3167] = {.lex_state = 71},
  [3168] = {.lex_state = 71},
  [3169] = {.lex_state = 71},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 0, .external_lex_state = 4},
  [3172] = {.lex_state = 71},
  [3173] = {.lex_state = 0, .external_lex_state = 4},
  [3174] = {.lex_state = 71},
  [3175] = {.lex_state = 71},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 6},
  [3179] = {.lex_state = 19},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 0},
  [3182] = {.lex_state = 0},
  [3183] = {.lex_state = 0},
  [3184] = {.lex_state = 71},
  [3185] = {.lex_state = 71},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 0},
  [3188] = {.lex_state = 71},
  [3189] = {.lex_state = 0},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 0},
  [3192] = {.lex_state = 71},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 0},
  [3195] = {.lex_state = 71},
  [3196] = {.lex_state = 71},
  [3197] = {.lex_state = 0},
  [3198] = {.lex_state = 0},
  [3199] = {.lex_state = 0},
  [3200] = {.lex_state = 0},
  [3201] = {.lex_state = 0},
  [3202] = {.lex_state = 0},
  [3203] = {.lex_state = 0},
  [3204] = {.lex_state = 71},
  [3205] = {.lex_state = 0},
  [3206] = {.lex_state = 6},
  [3207] = {.lex_state = 0},
  [3208] = {.lex_state = 0},
  [3209] = {.lex_state = 0},
  [3210] = {.lex_state = 0},
  [3211] = {.lex_state = 71},
  [3212] = {.lex_state = 0},
  [3213] = {.lex_state = 71},
  [3214] = {.lex_state = 0},
  [3215] = {.lex_state = 0},
  [3216] = {.lex_state = 0},
  [3217] = {.lex_state = 0},
  [3218] = {.lex_state = 0},
  [3219] = {.lex_state = 0},
  [3220] = {.lex_state = 0},
  [3221] = {.lex_state = 71},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 0},
  [3224] = {.lex_state = 71},
  [3225] = {.lex_state = 0},
  [3226] = {.lex_state = 0},
  [3227] = {.lex_state = 71},
  [3228] = {.lex_state = 0},
  [3229] = {.lex_state = 0},
  [3230] = {.lex_state = 19},
  [3231] = {.lex_state = 71},
  [3232] = {.lex_state = 71},
  [3233] = {.lex_state = 71},
  [3234] = {.lex_state = 71},
  [3235] = {.lex_state = 71},
  [3236] = {.lex_state = 0},
  [3237] = {.lex_state = 0},
  [3238] = {.lex_state = 0},
  [3239] = {.lex_state = 71},
  [3240] = {.lex_state = 0},
  [3241] = {.lex_state = 0},
  [3242] = {.lex_state = 0},
  [3243] = {.lex_state = 0},
  [3244] = {.lex_state = 0},
  [3245] = {.lex_state = 0},
  [3246] = {.lex_state = 0},
  [3247] = {.lex_state = 71},
  [3248] = {.lex_state = 71},
  [3249] = {.lex_state = 0},
  [3250] = {.lex_state = 71},
  [3251] = {.lex_state = 0},
  [3252] = {.lex_state = 71},
  [3253] = {.lex_state = 0},
  [3254] = {.lex_state = 71},
  [3255] = {.lex_state = 0},
  [3256] = {.lex_state = 0},
  [3257] = {.lex_state = 0},
  [3258] = {.lex_state = 0},
  [3259] = {.lex_state = 71},
  [3260] = {.lex_state = 0},
  [3261] = {.lex_state = 71},
  [3262] = {.lex_state = 0},
  [3263] = {.lex_state = 0},
  [3264] = {.lex_state = 71},
  [3265] = {.lex_state = 0},
  [3266] = {.lex_state = 0},
  [3267] = {.lex_state = 0},
  [3268] = {.lex_state = 71},
  [3269] = {.lex_state = 71},
  [3270] = {.lex_state = 0},
  [3271] = {.lex_state = 71},
  [3272] = {.lex_state = 0},
  [3273] = {.lex_state = 0},
  [3274] = {.lex_state = 71},
  [3275] = {.lex_state = 71},
  [3276] = {.lex_state = 0},
  [3277] = {.lex_state = 71},
  [3278] = {.lex_state = 0},
  [3279] = {.lex_state = 0},
  [3280] = {.lex_state = 71},
  [3281] = {.lex_state = 0},
  [3282] = {.lex_state = 71},
  [3283] = {.lex_state = 71},
  [3284] = {.lex_state = 0},
  [3285] = {.lex_state = 0},
  [3286] = {.lex_state = 0},
  [3287] = {.lex_state = 0},
  [3288] = {.lex_state = 0},
  [3289] = {.lex_state = 0},
  [3290] = {.lex_state = 19},
  [3291] = {.lex_state = 71},
  [3292] = {.lex_state = 71},
  [3293] = {.lex_state = 71},
  [3294] = {.lex_state = 0},
  [3295] = {.lex_state = 0},
  [3296] = {.lex_state = 0},
  [3297] = {.lex_state = 0},
  [3298] = {.lex_state = 71},
  [3299] = {.lex_state = 0},
  [3300] = {.lex_state = 71},
  [3301] = {.lex_state = 71},
  [3302] = {.lex_state = 71},
  [3303] = {.lex_state = 71},
  [3304] = {.lex_state = 71},
  [3305] = {.lex_state = 0},
  [3306] = {.lex_state = 0},
  [3307] = {.lex_state = 71},
  [3308] = {.lex_state = 71},
  [3309] = {.lex_state = 0},
  [3310] = {.lex_state = 0},
  [3311] = {.lex_state = 71},
  [3312] = {.lex_state = 6},
  [3313] = {.lex_state = 0},
  [3314] = {.lex_state = 0},
  [3315] = {.lex_state = 0},
  [3316] = {.lex_state = 71},
  [3317] = {.lex_state = 0},
  [3318] = {.lex_state = 71},
  [3319] = {.lex_state = 71},
  [3320] = {.lex_state = 71},
  [3321] = {.lex_state = 71},
  [3322] = {.lex_state = 71},
  [3323] = {.lex_state = 71},
  [3324] = {.lex_state = 71},
  [3325] = {.lex_state = 71},
  [3326] = {.lex_state = 71},
  [3327] = {.lex_state = 71},
  [3328] = {.lex_state = 71},
  [3329] = {.lex_state = 0},
  [3330] = {.lex_state = 71},
  [3331] = {.lex_state = 71},
  [3332] = {.lex_state = 71},
  [3333] = {.lex_state = 71},
  [3334] = {.lex_state = 71},
  [3335] = {.lex_state = 71},
  [3336] = {.lex_state = 71},
  [3337] = {.lex_state = 71},
  [3338] = {.lex_state = 71},
  [3339] = {.lex_state = 71},
  [3340] = {.lex_state = 71},
  [3341] = {.lex_state = 71},
  [3342] = {.lex_state = 0},
  [3343] = {.lex_state = 71},
  [3344] = {.lex_state = 71},
  [3345] = {.lex_state = 71},
  [3346] = {.lex_state = 71},
  [3347] = {.lex_state = 71},
  [3348] = {.lex_state = 71},
  [3349] = {.lex_state = 71},
  [3350] = {.lex_state = 0},
  [3351] = {.lex_state = 71},
  [3352] = {.lex_state = 0},
  [3353] = {.lex_state = 0},
  [3354] = {.lex_state = 19},
  [3355] = {.lex_state = 0},
  [3356] = {.lex_state = 0},
  [3357] = {.lex_state = 0},
  [3358] = {.lex_state = 71},
  [3359] = {.lex_state = 71},
  [3360] = {.lex_state = 71},
  [3361] = {.lex_state = 0},
  [3362] = {.lex_state = 71},
  [3363] = {.lex_state = 71},
  [3364] = {.lex_state = 0},
  [3365] = {.lex_state = 0},
  [3366] = {.lex_state = 0},
  [3367] = {.lex_state = 0},
  [3368] = {.lex_state = 0},
  [3369] = {.lex_state = 71},
  [3370] = {.lex_state = 0},
  [3371] = {.lex_state = 71},
  [3372] = {.lex_state = 71},
  [3373] = {.lex_state = 0},
  [3374] = {.lex_state = 71},
  [3375] = {.lex_state = 71},
  [3376] = {.lex_state = 71},
  [3377] = {.lex_state = 71},
  [3378] = {.lex_state = 71},
  [3379] = {.lex_state = 6},
  [3380] = {.lex_state = 71},
  [3381] = {.lex_state = 0},
  [3382] = {.lex_state = 71},
  [3383] = {.lex_state = 71},
  [3384] = {.lex_state = 71},
  [3385] = {.lex_state = 0},
  [3386] = {.lex_state = 0},
  [3387] = {.lex_state = 71},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 0},
  [3390] = {.lex_state = 71},
  [3391] = {.lex_state = 0},
  [3392] = {.lex_state = 71},
  [3393] = {.lex_state = 71},
  [3394] = {.lex_state = 0},
  [3395] = {.lex_state = 0},
  [3396] = {.lex_state = 0},
  [3397] = {.lex_state = 0},
  [3398] = {.lex_state = 71},
  [3399] = {.lex_state = 71},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_hex_literal] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_binary_literal] = ACTIONS(1),
    [sym_octal_literal] = ACTIONS(1),
    [sym_bigint_literal] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3370),
    [sym_export_statement] = STATE(26),
    [sym__declaration] = STATE(26),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(26),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [2] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1610),
    [sym_assignment_pattern] = STATE(2902),
    [sym_array] = STATE(1612),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_spread_element] = STATE(2902),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1613),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(2226),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_method_definition] = STATE(2902),
    [sym_pair] = STATE(2902),
    [sym__property_name] = STATE(2223),
    [sym_computed_property_name] = STATE(2223),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_accessibility_modifier] = STATE(1960),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [aux_sym_object_repeat1] = STATE(2904),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(119),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(127),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(133),
    [sym_hex_literal] = ACTIONS(135),
    [sym_int_literal] = ACTIONS(135),
    [sym_binary_literal] = ACTIONS(135),
    [sym_octal_literal] = ACTIONS(135),
    [sym_bigint_literal] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(141),
    [anon_sym_string] = ACTIONS(141),
    [anon_sym_symbol] = ACTIONS(141),
    [sym_readonly] = ACTIONS(143),
  },
  [3] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1610),
    [sym_assignment_pattern] = STATE(2755),
    [sym_array] = STATE(1612),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_spread_element] = STATE(2755),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1613),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(2226),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_method_definition] = STATE(2755),
    [sym_pair] = STATE(2755),
    [sym__property_name] = STATE(2223),
    [sym_computed_property_name] = STATE(2223),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_accessibility_modifier] = STATE(1960),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [aux_sym_object_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(153),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(155),
    [anon_sym_module] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(133),
    [sym_hex_literal] = ACTIONS(135),
    [sym_int_literal] = ACTIONS(135),
    [sym_binary_literal] = ACTIONS(135),
    [sym_octal_literal] = ACTIONS(135),
    [sym_bigint_literal] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(165),
    [anon_sym_private] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(165),
    [anon_sym_boolean] = ACTIONS(167),
    [anon_sym_string] = ACTIONS(167),
    [anon_sym_symbol] = ACTIONS(167),
    [sym_readonly] = ACTIONS(169),
  },
  [4] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1610),
    [sym_assignment_pattern] = STATE(2755),
    [sym_array] = STATE(1612),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_spread_element] = STATE(2755),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1613),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(2226),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_method_definition] = STATE(2755),
    [sym_pair] = STATE(2755),
    [sym__property_name] = STATE(2223),
    [sym_computed_property_name] = STATE(2223),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_accessibility_modifier] = STATE(1960),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [aux_sym_object_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(153),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(155),
    [anon_sym_module] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(133),
    [sym_hex_literal] = ACTIONS(135),
    [sym_int_literal] = ACTIONS(135),
    [sym_binary_literal] = ACTIONS(135),
    [sym_octal_literal] = ACTIONS(135),
    [sym_bigint_literal] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(165),
    [anon_sym_private] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(165),
    [anon_sym_boolean] = ACTIONS(167),
    [anon_sym_string] = ACTIONS(167),
    [anon_sym_symbol] = ACTIONS(167),
    [sym_readonly] = ACTIONS(169),
  },
  [5] = {
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1610),
    [sym_assignment_pattern] = STATE(2755),
    [sym_array] = STATE(1612),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_spread_element] = STATE(2755),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1613),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(2226),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_method_definition] = STATE(2755),
    [sym_pair] = STATE(2755),
    [sym__property_name] = STATE(2223),
    [sym_computed_property_name] = STATE(2223),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_accessibility_modifier] = STATE(1960),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [aux_sym_object_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(173),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(153),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(155),
    [anon_sym_module] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(133),
    [sym_hex_literal] = ACTIONS(135),
    [sym_int_literal] = ACTIONS(135),
    [sym_binary_literal] = ACTIONS(135),
    [sym_octal_literal] = ACTIONS(135),
    [sym_bigint_literal] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(165),
    [anon_sym_private] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(165),
    [anon_sym_boolean] = ACTIONS(167),
    [anon_sym_string] = ACTIONS(167),
    [anon_sym_symbol] = ACTIONS(167),
    [sym_readonly] = ACTIONS(169),
  },
  [6] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1610),
    [sym_assignment_pattern] = STATE(2734),
    [sym_array] = STATE(1612),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_spread_element] = STATE(2734),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1613),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(2226),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_method_definition] = STATE(2734),
    [sym_pair] = STATE(2734),
    [sym__property_name] = STATE(2223),
    [sym_computed_property_name] = STATE(2223),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_accessibility_modifier] = STATE(1960),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [aux_sym_object_repeat1] = STATE(2736),
    [sym_identifier] = ACTIONS(175),
    [anon_sym_export] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(181),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(183),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(185),
    [anon_sym_module] = ACTIONS(187),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(189),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(191),
    [anon_sym_set] = ACTIONS(191),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(133),
    [sym_hex_literal] = ACTIONS(135),
    [sym_int_literal] = ACTIONS(135),
    [sym_binary_literal] = ACTIONS(135),
    [sym_octal_literal] = ACTIONS(135),
    [sym_bigint_literal] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(193),
    [anon_sym_public] = ACTIONS(195),
    [anon_sym_private] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(195),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [sym_readonly] = ACTIONS(199),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [ts_builtin_sym_end] = ACTIONS(201),
    [sym_identifier] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(206),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_namespace] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(214),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_typeof] = ACTIONS(217),
    [anon_sym_type] = ACTIONS(220),
    [anon_sym_interface] = ACTIONS(223),
    [anon_sym_declare] = ACTIONS(226),
    [anon_sym_module] = ACTIONS(229),
    [anon_sym_import] = ACTIONS(232),
    [anon_sym_const] = ACTIONS(235),
    [anon_sym_enum] = ACTIONS(238),
    [anon_sym_var] = ACTIONS(241),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(250),
    [anon_sym_switch] = ACTIONS(253),
    [anon_sym_for] = ACTIONS(256),
    [anon_sym_LPAREN] = ACTIONS(259),
    [anon_sym_await] = ACTIONS(262),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_do] = ACTIONS(268),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_with] = ACTIONS(274),
    [anon_sym_break] = ACTIONS(277),
    [anon_sym_continue] = ACTIONS(280),
    [anon_sym_debugger] = ACTIONS(283),
    [anon_sym_return] = ACTIONS(286),
    [anon_sym_throw] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_case] = ACTIONS(209),
    [anon_sym_yield] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_class] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_abstract] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(313),
    [anon_sym_set] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(319),
    [anon_sym_DASH] = ACTIONS(319),
    [anon_sym_SLASH] = ACTIONS(322),
    [anon_sym_LT] = ACTIONS(325),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_void] = ACTIONS(328),
    [anon_sym_delete] = ACTIONS(328),
    [anon_sym_PLUS_PLUS] = ACTIONS(331),
    [anon_sym_DASH_DASH] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(340),
    [sym_float_literal] = ACTIONS(343),
    [sym_hex_literal] = ACTIONS(346),
    [sym_int_literal] = ACTIONS(346),
    [sym_binary_literal] = ACTIONS(346),
    [sym_octal_literal] = ACTIONS(346),
    [sym_bigint_literal] = ACTIONS(343),
    [sym_this] = ACTIONS(346),
    [sym_super] = ACTIONS(346),
    [sym_true] = ACTIONS(346),
    [sym_false] = ACTIONS(346),
    [sym_null] = ACTIONS(346),
    [anon_sym_AT] = ACTIONS(349),
    [anon_sym_static] = ACTIONS(313),
    [anon_sym_public] = ACTIONS(313),
    [anon_sym_private] = ACTIONS(313),
    [anon_sym_protected] = ACTIONS(313),
    [anon_sym_boolean] = ACTIONS(313),
    [anon_sym_string] = ACTIONS(313),
    [anon_sym_symbol] = ACTIONS(313),
    [sym_readonly] = ACTIONS(313),
  },
  [8] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(352),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(352),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(356),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(358),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(356),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [10] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(360),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(360),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(364),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [13] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [14] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [15] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [16] = {
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [17] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [ts_builtin_sym_end] = ACTIONS(378),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [18] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(382),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [21] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(386),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [22] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [23] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(390),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [25] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [ts_builtin_sym_end] = ACTIONS(394),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [26] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [ts_builtin_sym_end] = ACTIONS(394),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [27] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [28] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(398),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [29] = {
    [sym_export_statement] = STATE(505),
    [sym__declaration] = STATE(505),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_for_in_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_try_statement] = STATE(505),
    [sym_with_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_debugger_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_throw_statement] = STATE(505),
    [sym_empty_statement] = STATE(505),
    [sym_labeled_statement] = STATE(505),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [30] = {
    [sym_export_statement] = STATE(579),
    [sym__declaration] = STATE(579),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(579),
    [sym_expression_statement] = STATE(579),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(579),
    [sym_if_statement] = STATE(579),
    [sym_switch_statement] = STATE(579),
    [sym_for_statement] = STATE(579),
    [sym_for_in_statement] = STATE(579),
    [sym_while_statement] = STATE(579),
    [sym_do_statement] = STATE(579),
    [sym_try_statement] = STATE(579),
    [sym_with_statement] = STATE(579),
    [sym_break_statement] = STATE(579),
    [sym_continue_statement] = STATE(579),
    [sym_debugger_statement] = STATE(579),
    [sym_return_statement] = STATE(579),
    [sym_throw_statement] = STATE(579),
    [sym_empty_statement] = STATE(579),
    [sym_labeled_statement] = STATE(579),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [31] = {
    [sym_export_statement] = STATE(538),
    [sym__declaration] = STATE(538),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(538),
    [sym_expression_statement] = STATE(538),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(538),
    [sym_if_statement] = STATE(538),
    [sym_switch_statement] = STATE(538),
    [sym_for_statement] = STATE(538),
    [sym_for_in_statement] = STATE(538),
    [sym_while_statement] = STATE(538),
    [sym_do_statement] = STATE(538),
    [sym_try_statement] = STATE(538),
    [sym_with_statement] = STATE(538),
    [sym_break_statement] = STATE(538),
    [sym_continue_statement] = STATE(538),
    [sym_debugger_statement] = STATE(538),
    [sym_return_statement] = STATE(538),
    [sym_throw_statement] = STATE(538),
    [sym_empty_statement] = STATE(538),
    [sym_labeled_statement] = STATE(538),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [32] = {
    [sym_export_statement] = STATE(616),
    [sym__declaration] = STATE(616),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(616),
    [sym_expression_statement] = STATE(616),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(616),
    [sym_if_statement] = STATE(616),
    [sym_switch_statement] = STATE(616),
    [sym_for_statement] = STATE(616),
    [sym_for_in_statement] = STATE(616),
    [sym_while_statement] = STATE(616),
    [sym_do_statement] = STATE(616),
    [sym_try_statement] = STATE(616),
    [sym_with_statement] = STATE(616),
    [sym_break_statement] = STATE(616),
    [sym_continue_statement] = STATE(616),
    [sym_debugger_statement] = STATE(616),
    [sym_return_statement] = STATE(616),
    [sym_throw_statement] = STATE(616),
    [sym_empty_statement] = STATE(616),
    [sym_labeled_statement] = STATE(616),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [33] = {
    [sym_export_statement] = STATE(2876),
    [sym__declaration] = STATE(2876),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(2876),
    [sym_expression_statement] = STATE(2876),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(2876),
    [sym_if_statement] = STATE(2876),
    [sym_switch_statement] = STATE(2876),
    [sym_for_statement] = STATE(2876),
    [sym_for_in_statement] = STATE(2876),
    [sym_while_statement] = STATE(2876),
    [sym_do_statement] = STATE(2876),
    [sym_try_statement] = STATE(2876),
    [sym_with_statement] = STATE(2876),
    [sym_break_statement] = STATE(2876),
    [sym_continue_statement] = STATE(2876),
    [sym_debugger_statement] = STATE(2876),
    [sym_return_statement] = STATE(2876),
    [sym_throw_statement] = STATE(2876),
    [sym_empty_statement] = STATE(2876),
    [sym_labeled_statement] = STATE(2876),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [34] = {
    [sym_export_statement] = STATE(604),
    [sym__declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(607),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(617),
    [sym_if_statement] = STATE(618),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(620),
    [sym_for_in_statement] = STATE(621),
    [sym_while_statement] = STATE(625),
    [sym_do_statement] = STATE(653),
    [sym_try_statement] = STATE(652),
    [sym_with_statement] = STATE(651),
    [sym_break_statement] = STATE(649),
    [sym_continue_statement] = STATE(647),
    [sym_debugger_statement] = STATE(646),
    [sym_return_statement] = STATE(644),
    [sym_throw_statement] = STATE(643),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(641),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [35] = {
    [sym_export_statement] = STATE(563),
    [sym__declaration] = STATE(561),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(559),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(558),
    [sym_if_statement] = STATE(557),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(555),
    [sym_for_in_statement] = STATE(554),
    [sym_while_statement] = STATE(551),
    [sym_do_statement] = STATE(550),
    [sym_try_statement] = STATE(549),
    [sym_with_statement] = STATE(548),
    [sym_break_statement] = STATE(547),
    [sym_continue_statement] = STATE(545),
    [sym_debugger_statement] = STATE(544),
    [sym_return_statement] = STATE(543),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(541),
    [sym_labeled_statement] = STATE(539),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [36] = {
    [sym_export_statement] = STATE(622),
    [sym__declaration] = STATE(622),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(622),
    [sym_expression_statement] = STATE(622),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(622),
    [sym_if_statement] = STATE(622),
    [sym_switch_statement] = STATE(622),
    [sym_for_statement] = STATE(622),
    [sym_for_in_statement] = STATE(622),
    [sym_while_statement] = STATE(622),
    [sym_do_statement] = STATE(622),
    [sym_try_statement] = STATE(622),
    [sym_with_statement] = STATE(622),
    [sym_break_statement] = STATE(622),
    [sym_continue_statement] = STATE(622),
    [sym_debugger_statement] = STATE(622),
    [sym_return_statement] = STATE(622),
    [sym_throw_statement] = STATE(622),
    [sym_empty_statement] = STATE(622),
    [sym_labeled_statement] = STATE(622),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [37] = {
    [sym_export_statement] = STATE(3311),
    [sym__declaration] = STATE(3311),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(3311),
    [sym_expression_statement] = STATE(3311),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(3311),
    [sym_if_statement] = STATE(3311),
    [sym_switch_statement] = STATE(3311),
    [sym_for_statement] = STATE(3311),
    [sym_for_in_statement] = STATE(3311),
    [sym_while_statement] = STATE(3311),
    [sym_do_statement] = STATE(3311),
    [sym_try_statement] = STATE(3311),
    [sym_with_statement] = STATE(3311),
    [sym_break_statement] = STATE(3311),
    [sym_continue_statement] = STATE(3311),
    [sym_debugger_statement] = STATE(3311),
    [sym_return_statement] = STATE(3311),
    [sym_throw_statement] = STATE(3311),
    [sym_empty_statement] = STATE(3311),
    [sym_labeled_statement] = STATE(3311),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [38] = {
    [sym_export_statement] = STATE(631),
    [sym__declaration] = STATE(631),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(631),
    [sym_expression_statement] = STATE(631),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_switch_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_for_in_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_do_statement] = STATE(631),
    [sym_try_statement] = STATE(631),
    [sym_with_statement] = STATE(631),
    [sym_break_statement] = STATE(631),
    [sym_continue_statement] = STATE(631),
    [sym_debugger_statement] = STATE(631),
    [sym_return_statement] = STATE(631),
    [sym_throw_statement] = STATE(631),
    [sym_empty_statement] = STATE(631),
    [sym_labeled_statement] = STATE(631),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [39] = {
    [sym_export_statement] = STATE(598),
    [sym__declaration] = STATE(598),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(598),
    [sym_expression_statement] = STATE(598),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_switch_statement] = STATE(598),
    [sym_for_statement] = STATE(598),
    [sym_for_in_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(598),
    [sym_try_statement] = STATE(598),
    [sym_with_statement] = STATE(598),
    [sym_break_statement] = STATE(598),
    [sym_continue_statement] = STATE(598),
    [sym_debugger_statement] = STATE(598),
    [sym_return_statement] = STATE(598),
    [sym_throw_statement] = STATE(598),
    [sym_empty_statement] = STATE(598),
    [sym_labeled_statement] = STATE(598),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [40] = {
    [sym_export_statement] = STATE(538),
    [sym__declaration] = STATE(538),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(538),
    [sym_expression_statement] = STATE(538),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(538),
    [sym_if_statement] = STATE(538),
    [sym_switch_statement] = STATE(538),
    [sym_for_statement] = STATE(538),
    [sym_for_in_statement] = STATE(538),
    [sym_while_statement] = STATE(538),
    [sym_do_statement] = STATE(538),
    [sym_try_statement] = STATE(538),
    [sym_with_statement] = STATE(538),
    [sym_break_statement] = STATE(538),
    [sym_continue_statement] = STATE(538),
    [sym_debugger_statement] = STATE(538),
    [sym_return_statement] = STATE(538),
    [sym_throw_statement] = STATE(538),
    [sym_empty_statement] = STATE(538),
    [sym_labeled_statement] = STATE(538),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [41] = {
    [sym_export_statement] = STATE(563),
    [sym__declaration] = STATE(561),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(559),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(558),
    [sym_if_statement] = STATE(557),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(555),
    [sym_for_in_statement] = STATE(554),
    [sym_while_statement] = STATE(551),
    [sym_do_statement] = STATE(550),
    [sym_try_statement] = STATE(549),
    [sym_with_statement] = STATE(548),
    [sym_break_statement] = STATE(547),
    [sym_continue_statement] = STATE(545),
    [sym_debugger_statement] = STATE(544),
    [sym_return_statement] = STATE(543),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(541),
    [sym_labeled_statement] = STATE(539),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [42] = {
    [sym_export_statement] = STATE(579),
    [sym__declaration] = STATE(579),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(579),
    [sym_expression_statement] = STATE(579),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(579),
    [sym_if_statement] = STATE(579),
    [sym_switch_statement] = STATE(579),
    [sym_for_statement] = STATE(579),
    [sym_for_in_statement] = STATE(579),
    [sym_while_statement] = STATE(579),
    [sym_do_statement] = STATE(579),
    [sym_try_statement] = STATE(579),
    [sym_with_statement] = STATE(579),
    [sym_break_statement] = STATE(579),
    [sym_continue_statement] = STATE(579),
    [sym_debugger_statement] = STATE(579),
    [sym_return_statement] = STATE(579),
    [sym_throw_statement] = STATE(579),
    [sym_empty_statement] = STATE(579),
    [sym_labeled_statement] = STATE(579),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [43] = {
    [sym_export_statement] = STATE(622),
    [sym__declaration] = STATE(622),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(622),
    [sym_expression_statement] = STATE(622),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(622),
    [sym_if_statement] = STATE(622),
    [sym_switch_statement] = STATE(622),
    [sym_for_statement] = STATE(622),
    [sym_for_in_statement] = STATE(622),
    [sym_while_statement] = STATE(622),
    [sym_do_statement] = STATE(622),
    [sym_try_statement] = STATE(622),
    [sym_with_statement] = STATE(622),
    [sym_break_statement] = STATE(622),
    [sym_continue_statement] = STATE(622),
    [sym_debugger_statement] = STATE(622),
    [sym_return_statement] = STATE(622),
    [sym_throw_statement] = STATE(622),
    [sym_empty_statement] = STATE(622),
    [sym_labeled_statement] = STATE(622),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [44] = {
    [sym_export_statement] = STATE(598),
    [sym__declaration] = STATE(598),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(598),
    [sym_expression_statement] = STATE(598),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(598),
    [sym_if_statement] = STATE(598),
    [sym_switch_statement] = STATE(598),
    [sym_for_statement] = STATE(598),
    [sym_for_in_statement] = STATE(598),
    [sym_while_statement] = STATE(598),
    [sym_do_statement] = STATE(598),
    [sym_try_statement] = STATE(598),
    [sym_with_statement] = STATE(598),
    [sym_break_statement] = STATE(598),
    [sym_continue_statement] = STATE(598),
    [sym_debugger_statement] = STATE(598),
    [sym_return_statement] = STATE(598),
    [sym_throw_statement] = STATE(598),
    [sym_empty_statement] = STATE(598),
    [sym_labeled_statement] = STATE(598),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [45] = {
    [sym_export_statement] = STATE(631),
    [sym__declaration] = STATE(631),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(631),
    [sym_expression_statement] = STATE(631),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_switch_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_for_in_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_do_statement] = STATE(631),
    [sym_try_statement] = STATE(631),
    [sym_with_statement] = STATE(631),
    [sym_break_statement] = STATE(631),
    [sym_continue_statement] = STATE(631),
    [sym_debugger_statement] = STATE(631),
    [sym_return_statement] = STATE(631),
    [sym_throw_statement] = STATE(631),
    [sym_empty_statement] = STATE(631),
    [sym_labeled_statement] = STATE(631),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [46] = {
    [sym_export_statement] = STATE(616),
    [sym__declaration] = STATE(616),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(616),
    [sym_expression_statement] = STATE(616),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(616),
    [sym_if_statement] = STATE(616),
    [sym_switch_statement] = STATE(616),
    [sym_for_statement] = STATE(616),
    [sym_for_in_statement] = STATE(616),
    [sym_while_statement] = STATE(616),
    [sym_do_statement] = STATE(616),
    [sym_try_statement] = STATE(616),
    [sym_with_statement] = STATE(616),
    [sym_break_statement] = STATE(616),
    [sym_continue_statement] = STATE(616),
    [sym_debugger_statement] = STATE(616),
    [sym_return_statement] = STATE(616),
    [sym_throw_statement] = STATE(616),
    [sym_empty_statement] = STATE(616),
    [sym_labeled_statement] = STATE(616),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(93),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [47] = {
    [sym_export_statement] = STATE(604),
    [sym__declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_import] = STATE(1601),
    [sym_import_statement] = STATE(607),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_statement_block] = STATE(617),
    [sym_if_statement] = STATE(618),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(620),
    [sym_for_in_statement] = STATE(621),
    [sym_while_statement] = STATE(625),
    [sym_do_statement] = STATE(653),
    [sym_try_statement] = STATE(652),
    [sym_with_statement] = STATE(651),
    [sym_break_statement] = STATE(649),
    [sym_continue_statement] = STATE(647),
    [sym_debugger_statement] = STATE(646),
    [sym_return_statement] = STATE(644),
    [sym_throw_statement] = STATE(643),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(641),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_class_declaration] = STATE(553),
    [sym_function] = STATE(1601),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function] = STATE(1601),
    [sym_generator_function_declaration] = STATE(553),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(1485),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(400),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_namespace] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(406),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_module] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(420),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(428),
    [anon_sym_set] = ACTIONS(428),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(428),
    [anon_sym_public] = ACTIONS(428),
    [anon_sym_private] = ACTIONS(428),
    [anon_sym_protected] = ACTIONS(428),
    [anon_sym_boolean] = ACTIONS(428),
    [anon_sym_string] = ACTIONS(428),
    [anon_sym_symbol] = ACTIONS(428),
    [sym_readonly] = ACTIONS(428),
  },
  [48] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3395),
    [sym_string] = STATE(1750),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2541),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__type] = STATE(2699),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2699),
    [sym_intersection_type] = STATE(2699),
    [sym_function_type] = STATE(2699),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2699),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_typeof] = ACTIONS(440),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(488),
    [sym_hex_literal] = ACTIONS(490),
    [sym_int_literal] = ACTIONS(490),
    [sym_binary_literal] = ACTIONS(490),
    [sym_octal_literal] = ACTIONS(490),
    [sym_bigint_literal] = ACTIONS(488),
    [sym_this] = ACTIONS(492),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(498),
    [anon_sym_string] = ACTIONS(498),
    [anon_sym_symbol] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(504),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [49] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3226),
    [sym_string] = STATE(1750),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2541),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__type] = STATE(2654),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_typeof] = ACTIONS(440),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(488),
    [sym_hex_literal] = ACTIONS(490),
    [sym_int_literal] = ACTIONS(490),
    [sym_binary_literal] = ACTIONS(490),
    [sym_octal_literal] = ACTIONS(490),
    [sym_bigint_literal] = ACTIONS(488),
    [sym_this] = ACTIONS(492),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(498),
    [anon_sym_string] = ACTIONS(498),
    [anon_sym_symbol] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(504),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [50] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3395),
    [sym_string] = STATE(1750),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2541),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__type] = STATE(2654),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_typeof] = ACTIONS(440),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(488),
    [sym_hex_literal] = ACTIONS(490),
    [sym_int_literal] = ACTIONS(490),
    [sym_binary_literal] = ACTIONS(490),
    [sym_octal_literal] = ACTIONS(490),
    [sym_bigint_literal] = ACTIONS(488),
    [sym_this] = ACTIONS(492),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(498),
    [anon_sym_string] = ACTIONS(498),
    [anon_sym_symbol] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(504),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [51] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3315),
    [sym_string] = STATE(1750),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2541),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__type] = STATE(2654),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_typeof] = ACTIONS(440),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(488),
    [sym_hex_literal] = ACTIONS(490),
    [sym_int_literal] = ACTIONS(490),
    [sym_binary_literal] = ACTIONS(490),
    [sym_octal_literal] = ACTIONS(490),
    [sym_bigint_literal] = ACTIONS(488),
    [sym_this] = ACTIONS(492),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(498),
    [anon_sym_string] = ACTIONS(498),
    [anon_sym_symbol] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(504),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [52] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1515),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1599),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(2541),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym__type] = STATE(2369),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2369),
    [sym_intersection_type] = STATE(2369),
    [sym_function_type] = STATE(2369),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(516),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(528),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(540),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(546),
    [sym_hex_literal] = ACTIONS(548),
    [sym_int_literal] = ACTIONS(548),
    [sym_binary_literal] = ACTIONS(548),
    [sym_octal_literal] = ACTIONS(548),
    [sym_bigint_literal] = ACTIONS(546),
    [sym_this] = ACTIONS(550),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(548),
    [sym_false] = ACTIONS(548),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_symbol] = ACTIONS(552),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(554),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [53] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1547),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(2541),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym__type] = STATE(2369),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2369),
    [sym_intersection_type] = STATE(2369),
    [sym_function_type] = STATE(2369),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(556),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(562),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(572),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(574),
    [sym_hex_literal] = ACTIONS(576),
    [sym_int_literal] = ACTIONS(576),
    [sym_binary_literal] = ACTIONS(576),
    [sym_octal_literal] = ACTIONS(576),
    [sym_bigint_literal] = ACTIONS(574),
    [sym_this] = ACTIONS(578),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(576),
    [sym_false] = ACTIONS(576),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(580),
    [anon_sym_string] = ACTIONS(580),
    [anon_sym_symbol] = ACTIONS(580),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(582),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [54] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1145),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(2541),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym__type] = STATE(2369),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2369),
    [sym_intersection_type] = STATE(2369),
    [sym_function_type] = STATE(2369),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(590),
    [anon_sym_typeof] = ACTIONS(592),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(604),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(610),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(616),
    [sym_hex_literal] = ACTIONS(618),
    [sym_int_literal] = ACTIONS(618),
    [sym_binary_literal] = ACTIONS(618),
    [sym_octal_literal] = ACTIONS(618),
    [sym_bigint_literal] = ACTIONS(616),
    [sym_this] = ACTIONS(620),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(618),
    [sym_false] = ACTIONS(618),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(624),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [55] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1590),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1401),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(2062),
    [sym_formal_parameters] = STATE(2593),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__type] = STATE(2112),
    [sym__primary_type] = STATE(2064),
    [sym_parenthesized_type] = STATE(2064),
    [sym_predefined_type] = STATE(2064),
    [sym_nested_type_identifier] = STATE(2036),
    [sym_generic_type] = STATE(2064),
    [sym_object_type] = STATE(2064),
    [sym_array_type] = STATE(2064),
    [sym_tuple_type] = STATE(2064),
    [sym__tuple_type_body] = STATE(2065),
    [sym_flow_maybe_type] = STATE(2064),
    [sym_type_query] = STATE(2064),
    [sym_index_type_query] = STATE(2064),
    [sym_existential_type] = STATE(2064),
    [sym_literal_type] = STATE(2064),
    [sym_lookup_type] = STATE(2064),
    [sym_conditional_type] = STATE(2064),
    [sym_union_type] = STATE(2112),
    [sym_intersection_type] = STATE(2112),
    [sym_function_type] = STATE(2112),
    [sym_type_parameters] = STATE(3048),
    [sym_constructor_type] = STATE(2112),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(636),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(640),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(648),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(654),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(656),
    [sym_hex_literal] = ACTIONS(658),
    [sym_int_literal] = ACTIONS(658),
    [sym_binary_literal] = ACTIONS(658),
    [sym_octal_literal] = ACTIONS(658),
    [sym_bigint_literal] = ACTIONS(656),
    [sym_this] = ACTIONS(660),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(658),
    [sym_false] = ACTIONS(658),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(662),
    [anon_sym_string] = ACTIONS(662),
    [anon_sym_symbol] = ACTIONS(662),
    [anon_sym_int] = ACTIONS(664),
    [anon_sym_float] = ACTIONS(664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(666),
    [sym_readonly] = ACTIONS(668),
    [anon_sym_keyof] = ACTIONS(670),
  },
  [56] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1566),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1656),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(2541),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym__type] = STATE(2369),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2369),
    [sym_intersection_type] = STATE(2369),
    [sym_function_type] = STATE(2369),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(672),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(590),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(694),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(700),
    [sym_hex_literal] = ACTIONS(702),
    [sym_int_literal] = ACTIONS(702),
    [sym_binary_literal] = ACTIONS(702),
    [sym_octal_literal] = ACTIONS(702),
    [sym_bigint_literal] = ACTIONS(700),
    [sym_this] = ACTIONS(704),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(702),
    [sym_false] = ACTIONS(702),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(706),
    [anon_sym_string] = ACTIONS(706),
    [anon_sym_symbol] = ACTIONS(706),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(708),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [57] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1145),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(2541),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__type] = STATE(2369),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2369),
    [sym_intersection_type] = STATE(2369),
    [sym_function_type] = STATE(2369),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(710),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(590),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(600),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(616),
    [sym_hex_literal] = ACTIONS(618),
    [sym_int_literal] = ACTIONS(618),
    [sym_binary_literal] = ACTIONS(618),
    [sym_octal_literal] = ACTIONS(618),
    [sym_bigint_literal] = ACTIONS(616),
    [sym_this] = ACTIONS(620),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(618),
    [sym_false] = ACTIONS(618),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(716),
    [anon_sym_string] = ACTIONS(716),
    [anon_sym_symbol] = ACTIONS(716),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(718),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [58] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1681),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(2541),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym__type] = STATE(2369),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2369),
    [sym_intersection_type] = STATE(2369),
    [sym_function_type] = STATE(2369),
    [sym_type_parameters] = STATE(3011),
    [sym_constructor_type] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(726),
    [anon_sym_typeof] = ACTIONS(728),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(754),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(766),
    [sym_hex_literal] = ACTIONS(768),
    [sym_int_literal] = ACTIONS(768),
    [sym_binary_literal] = ACTIONS(768),
    [sym_octal_literal] = ACTIONS(768),
    [sym_bigint_literal] = ACTIONS(766),
    [sym_this] = ACTIONS(770),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(774),
    [anon_sym_string] = ACTIONS(774),
    [anon_sym_symbol] = ACTIONS(774),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(776),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [59] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1065),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_COLON] = ACTIONS(786),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_of] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_QMARK_DOT] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(800),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_QMARK_QMARK] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [60] = {
    [sym_object] = STATE(2477),
    [sym_array] = STATE(2478),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(804),
    [anon_sym_export] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_declare] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(826),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(806),
    [anon_sym_set] = ACTIONS(806),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(854),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_boolean] = ACTIONS(856),
    [anon_sym_string] = ACTIONS(856),
    [anon_sym_symbol] = ACTIONS(856),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(858),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [61] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1273),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_of] = ACTIONS(782),
    [anon_sym_SEMI] = ACTIONS(786),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_QMARK_DOT] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(800),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_QMARK_QMARK] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
    [sym__automatic_semicolon] = ACTIONS(786),
  },
  [62] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1318),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(870),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(876),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_of] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_QMARK_DOT] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(800),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_QMARK_QMARK] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [anon_sym_LBRACE_PIPE] = ACTIONS(786),
    [sym_readonly] = ACTIONS(722),
  },
  [63] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1490),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_STAR] = ACTIONS(890),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_COLON] = ACTIONS(786),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_of] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_QMARK_DOT] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(800),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_QMARK_QMARK] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [64] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1568),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_STAR] = ACTIONS(902),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_of] = ACTIONS(782),
    [anon_sym_SEMI] = ACTIONS(786),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_QMARK_DOT] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(800),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_QMARK_QMARK] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
    [sym__automatic_semicolon] = ACTIONS(786),
  },
  [65] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(914),
    [anon_sym_as] = ACTIONS(782),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_of] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_implements] = ACTIONS(782),
    [anon_sym_QMARK_DOT] = ACTIONS(786),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(800),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_QMARK_QMARK] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [66] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(926),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(932),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [67] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(932),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_export] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_EQ] = ACTIONS(950),
    [anon_sym_as] = ACTIONS(950),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_COMMA] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_typeof] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(948),
    [anon_sym_declare] = ACTIONS(948),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_DOT] = ACTIONS(950),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(948),
    [anon_sym_let] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_await] = ACTIONS(948),
    [anon_sym_in] = ACTIONS(950),
    [anon_sym_of] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_with] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_debugger] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_throw] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_yield] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_function] = ACTIONS(948),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_get] = ACTIONS(948),
    [anon_sym_set] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(950),
    [anon_sym_QMARK_DOT] = ACTIONS(952),
    [anon_sym_new] = ACTIONS(948),
    [anon_sym_AMP_AMP] = ACTIONS(952),
    [anon_sym_PIPE_PIPE] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_GT_GT_GT] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_CARET] = ACTIONS(952),
    [anon_sym_PIPE] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_PERCENT] = ACTIONS(952),
    [anon_sym_STAR_STAR] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_LT_EQ] = ACTIONS(952),
    [anon_sym_EQ_EQ] = ACTIONS(952),
    [anon_sym_BANG_EQ] = ACTIONS(952),
    [anon_sym_GT_EQ] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(950),
    [anon_sym_QMARK_QMARK] = ACTIONS(952),
    [anon_sym_instanceof] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(948),
    [anon_sym_delete] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(946),
    [sym_float_literal] = ACTIONS(946),
    [sym_hex_literal] = ACTIONS(948),
    [sym_int_literal] = ACTIONS(948),
    [sym_binary_literal] = ACTIONS(948),
    [sym_octal_literal] = ACTIONS(948),
    [sym_bigint_literal] = ACTIONS(946),
    [sym_this] = ACTIONS(948),
    [sym_super] = ACTIONS(948),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_public] = ACTIONS(948),
    [anon_sym_private] = ACTIONS(948),
    [anon_sym_protected] = ACTIONS(948),
    [anon_sym_boolean] = ACTIONS(948),
    [anon_sym_string] = ACTIONS(948),
    [anon_sym_symbol] = ACTIONS(948),
    [sym_readonly] = ACTIONS(948),
    [sym__automatic_semicolon] = ACTIONS(954),
  },
  [69] = {
    [sym_statement_block] = STATE(83),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(958),
    [anon_sym_namespace] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_interface] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_DOT] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_var] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_await] = ACTIONS(958),
    [anon_sym_in] = ACTIONS(958),
    [anon_sym_of] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_with] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_debugger] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_throw] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_function] = ACTIONS(958),
    [anon_sym_abstract] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_QMARK] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(956),
    [anon_sym_new] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(956),
    [anon_sym_PIPE_PIPE] = ACTIONS(956),
    [anon_sym_GT_GT] = ACTIONS(958),
    [anon_sym_GT_GT_GT] = ACTIONS(956),
    [anon_sym_LT_LT] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_CARET] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(958),
    [anon_sym_PERCENT] = ACTIONS(956),
    [anon_sym_STAR_STAR] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(958),
    [anon_sym_LT_EQ] = ACTIONS(956),
    [anon_sym_EQ_EQ] = ACTIONS(956),
    [anon_sym_BANG_EQ] = ACTIONS(956),
    [anon_sym_GT_EQ] = ACTIONS(956),
    [anon_sym_GT] = ACTIONS(958),
    [anon_sym_QMARK_QMARK] = ACTIONS(956),
    [anon_sym_instanceof] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
    [sym_hex_literal] = ACTIONS(958),
    [sym_int_literal] = ACTIONS(958),
    [sym_binary_literal] = ACTIONS(958),
    [sym_octal_literal] = ACTIONS(958),
    [sym_bigint_literal] = ACTIONS(956),
    [sym_this] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [sym_readonly] = ACTIONS(958),
    [sym__automatic_semicolon] = ACTIONS(956),
  },
  [70] = {
    [sym_statement_block] = STATE(83),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(958),
    [anon_sym_namespace] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_interface] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_DOT] = ACTIONS(962),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_var] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_await] = ACTIONS(958),
    [anon_sym_in] = ACTIONS(958),
    [anon_sym_of] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_with] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_debugger] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_throw] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_function] = ACTIONS(958),
    [anon_sym_abstract] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_QMARK] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(956),
    [anon_sym_new] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(956),
    [anon_sym_PIPE_PIPE] = ACTIONS(956),
    [anon_sym_GT_GT] = ACTIONS(958),
    [anon_sym_GT_GT_GT] = ACTIONS(956),
    [anon_sym_LT_LT] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_CARET] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(958),
    [anon_sym_PERCENT] = ACTIONS(956),
    [anon_sym_STAR_STAR] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(958),
    [anon_sym_LT_EQ] = ACTIONS(956),
    [anon_sym_EQ_EQ] = ACTIONS(956),
    [anon_sym_BANG_EQ] = ACTIONS(956),
    [anon_sym_GT_EQ] = ACTIONS(956),
    [anon_sym_GT] = ACTIONS(958),
    [anon_sym_QMARK_QMARK] = ACTIONS(956),
    [anon_sym_instanceof] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
    [sym_hex_literal] = ACTIONS(958),
    [sym_int_literal] = ACTIONS(958),
    [sym_binary_literal] = ACTIONS(958),
    [sym_octal_literal] = ACTIONS(958),
    [sym_bigint_literal] = ACTIONS(956),
    [sym_this] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [sym_readonly] = ACTIONS(958),
    [sym__automatic_semicolon] = ACTIONS(956),
  },
  [71] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(932),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_export] = ACTIONS(970),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_as] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_declare] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_DOT] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_var] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(970),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(970),
    [anon_sym_in] = ACTIONS(970),
    [anon_sym_of] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_debugger] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_function] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(970),
    [anon_sym_set] = ACTIONS(970),
    [anon_sym_QMARK] = ACTIONS(970),
    [anon_sym_QMARK_DOT] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_AMP_AMP] = ACTIONS(968),
    [anon_sym_PIPE_PIPE] = ACTIONS(968),
    [anon_sym_GT_GT] = ACTIONS(970),
    [anon_sym_GT_GT_GT] = ACTIONS(968),
    [anon_sym_LT_LT] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(970),
    [anon_sym_CARET] = ACTIONS(968),
    [anon_sym_PIPE] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(970),
    [anon_sym_PERCENT] = ACTIONS(968),
    [anon_sym_STAR_STAR] = ACTIONS(968),
    [anon_sym_LT] = ACTIONS(970),
    [anon_sym_LT_EQ] = ACTIONS(968),
    [anon_sym_EQ_EQ] = ACTIONS(968),
    [anon_sym_BANG_EQ] = ACTIONS(968),
    [anon_sym_GT_EQ] = ACTIONS(968),
    [anon_sym_GT] = ACTIONS(970),
    [anon_sym_QMARK_QMARK] = ACTIONS(968),
    [anon_sym_instanceof] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_void] = ACTIONS(970),
    [anon_sym_delete] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(968),
    [sym_float_literal] = ACTIONS(968),
    [sym_hex_literal] = ACTIONS(970),
    [sym_int_literal] = ACTIONS(970),
    [sym_binary_literal] = ACTIONS(970),
    [sym_octal_literal] = ACTIONS(970),
    [sym_bigint_literal] = ACTIONS(968),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [sym_readonly] = ACTIONS(970),
    [sym__automatic_semicolon] = ACTIONS(972),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_export] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_as] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_COMMA] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_typeof] = ACTIONS(976),
    [anon_sym_type] = ACTIONS(976),
    [anon_sym_interface] = ACTIONS(976),
    [anon_sym_declare] = ACTIONS(976),
    [anon_sym_module] = ACTIONS(976),
    [anon_sym_DOT] = ACTIONS(978),
    [anon_sym_import] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_var] = ACTIONS(976),
    [anon_sym_let] = ACTIONS(976),
    [anon_sym_BANG] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_LPAREN] = ACTIONS(974),
    [anon_sym_await] = ACTIONS(976),
    [anon_sym_in] = ACTIONS(978),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_try] = ACTIONS(976),
    [anon_sym_with] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_debugger] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_throw] = ACTIONS(976),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_yield] = ACTIONS(976),
    [anon_sym_LBRACK] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(976),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_function] = ACTIONS(976),
    [anon_sym_abstract] = ACTIONS(976),
    [anon_sym_get] = ACTIONS(976),
    [anon_sym_set] = ACTIONS(976),
    [anon_sym_QMARK] = ACTIONS(978),
    [anon_sym_QMARK_DOT] = ACTIONS(980),
    [anon_sym_new] = ACTIONS(976),
    [anon_sym_AMP_AMP] = ACTIONS(980),
    [anon_sym_PIPE_PIPE] = ACTIONS(980),
    [anon_sym_GT_GT] = ACTIONS(978),
    [anon_sym_GT_GT_GT] = ACTIONS(980),
    [anon_sym_LT_LT] = ACTIONS(980),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_CARET] = ACTIONS(980),
    [anon_sym_PIPE] = ACTIONS(978),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_SLASH] = ACTIONS(976),
    [anon_sym_PERCENT] = ACTIONS(980),
    [anon_sym_STAR_STAR] = ACTIONS(980),
    [anon_sym_LT] = ACTIONS(976),
    [anon_sym_LT_EQ] = ACTIONS(980),
    [anon_sym_EQ_EQ] = ACTIONS(980),
    [anon_sym_BANG_EQ] = ACTIONS(980),
    [anon_sym_GT_EQ] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(978),
    [anon_sym_QMARK_QMARK] = ACTIONS(980),
    [anon_sym_instanceof] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_void] = ACTIONS(976),
    [anon_sym_delete] = ACTIONS(976),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(974),
    [sym_float_literal] = ACTIONS(974),
    [sym_hex_literal] = ACTIONS(976),
    [sym_int_literal] = ACTIONS(976),
    [sym_binary_literal] = ACTIONS(976),
    [sym_octal_literal] = ACTIONS(976),
    [sym_bigint_literal] = ACTIONS(974),
    [sym_this] = ACTIONS(976),
    [sym_super] = ACTIONS(976),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [anon_sym_AT] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_public] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym_protected] = ACTIONS(976),
    [anon_sym_boolean] = ACTIONS(976),
    [anon_sym_string] = ACTIONS(976),
    [anon_sym_symbol] = ACTIONS(976),
    [sym_readonly] = ACTIONS(976),
    [sym__automatic_semicolon] = ACTIONS(982),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(984),
    [sym_identifier] = ACTIONS(986),
    [anon_sym_export] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(986),
    [anon_sym_as] = ACTIONS(988),
    [anon_sym_namespace] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_COMMA] = ACTIONS(990),
    [anon_sym_RBRACE] = ACTIONS(984),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(986),
    [anon_sym_DOT] = ACTIONS(988),
    [anon_sym_import] = ACTIONS(986),
    [anon_sym_const] = ACTIONS(986),
    [anon_sym_enum] = ACTIONS(986),
    [anon_sym_var] = ACTIONS(986),
    [anon_sym_let] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_switch] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_await] = ACTIONS(986),
    [anon_sym_in] = ACTIONS(988),
    [anon_sym_of] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_try] = ACTIONS(986),
    [anon_sym_with] = ACTIONS(986),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(986),
    [anon_sym_debugger] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_throw] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(986),
    [anon_sym_yield] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(984),
    [anon_sym_class] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(986),
    [anon_sym_abstract] = ACTIONS(986),
    [anon_sym_get] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_QMARK_DOT] = ACTIONS(990),
    [anon_sym_new] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(990),
    [anon_sym_PIPE_PIPE] = ACTIONS(990),
    [anon_sym_GT_GT] = ACTIONS(988),
    [anon_sym_GT_GT_GT] = ACTIONS(990),
    [anon_sym_LT_LT] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(988),
    [anon_sym_CARET] = ACTIONS(990),
    [anon_sym_PIPE] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_SLASH] = ACTIONS(986),
    [anon_sym_PERCENT] = ACTIONS(990),
    [anon_sym_STAR_STAR] = ACTIONS(990),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_LT_EQ] = ACTIONS(990),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_GT_EQ] = ACTIONS(990),
    [anon_sym_GT] = ACTIONS(988),
    [anon_sym_QMARK_QMARK] = ACTIONS(990),
    [anon_sym_instanceof] = ACTIONS(988),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(984),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(984),
    [sym_float_literal] = ACTIONS(984),
    [sym_hex_literal] = ACTIONS(986),
    [sym_int_literal] = ACTIONS(986),
    [sym_binary_literal] = ACTIONS(986),
    [sym_octal_literal] = ACTIONS(986),
    [sym_bigint_literal] = ACTIONS(984),
    [sym_this] = ACTIONS(986),
    [sym_super] = ACTIONS(986),
    [sym_true] = ACTIONS(986),
    [sym_false] = ACTIONS(986),
    [sym_null] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_static] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(986),
    [anon_sym_private] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(986),
    [anon_sym_boolean] = ACTIONS(986),
    [anon_sym_string] = ACTIONS(986),
    [anon_sym_symbol] = ACTIONS(986),
    [sym_readonly] = ACTIONS(986),
    [sym__automatic_semicolon] = ACTIONS(992),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(994),
    [sym_identifier] = ACTIONS(996),
    [anon_sym_export] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_as] = ACTIONS(996),
    [anon_sym_namespace] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_typeof] = ACTIONS(996),
    [anon_sym_type] = ACTIONS(996),
    [anon_sym_interface] = ACTIONS(996),
    [anon_sym_declare] = ACTIONS(996),
    [anon_sym_module] = ACTIONS(996),
    [anon_sym_DOT] = ACTIONS(996),
    [anon_sym_import] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_var] = ACTIONS(996),
    [anon_sym_let] = ACTIONS(996),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_await] = ACTIONS(996),
    [anon_sym_in] = ACTIONS(996),
    [anon_sym_of] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_try] = ACTIONS(996),
    [anon_sym_with] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_debugger] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_throw] = ACTIONS(996),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_yield] = ACTIONS(996),
    [anon_sym_LBRACK] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(996),
    [anon_sym_function] = ACTIONS(996),
    [anon_sym_abstract] = ACTIONS(996),
    [anon_sym_get] = ACTIONS(996),
    [anon_sym_set] = ACTIONS(996),
    [anon_sym_QMARK] = ACTIONS(996),
    [anon_sym_QMARK_DOT] = ACTIONS(994),
    [anon_sym_new] = ACTIONS(996),
    [anon_sym_AMP_AMP] = ACTIONS(994),
    [anon_sym_PIPE_PIPE] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(996),
    [anon_sym_GT_GT_GT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(996),
    [anon_sym_CARET] = ACTIONS(994),
    [anon_sym_PIPE] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_STAR_STAR] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(996),
    [anon_sym_QMARK_QMARK] = ACTIONS(994),
    [anon_sym_instanceof] = ACTIONS(996),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_void] = ACTIONS(996),
    [anon_sym_delete] = ACTIONS(996),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(994),
    [sym_float_literal] = ACTIONS(994),
    [sym_hex_literal] = ACTIONS(996),
    [sym_int_literal] = ACTIONS(996),
    [sym_binary_literal] = ACTIONS(996),
    [sym_octal_literal] = ACTIONS(996),
    [sym_bigint_literal] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(996),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_public] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym_protected] = ACTIONS(996),
    [anon_sym_boolean] = ACTIONS(996),
    [anon_sym_string] = ACTIONS(996),
    [anon_sym_symbol] = ACTIONS(996),
    [sym_readonly] = ACTIONS(996),
    [sym__automatic_semicolon] = ACTIONS(994),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(998),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_export] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_as] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(1004),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_typeof] = ACTIONS(1000),
    [anon_sym_type] = ACTIONS(1000),
    [anon_sym_interface] = ACTIONS(1000),
    [anon_sym_declare] = ACTIONS(1000),
    [anon_sym_module] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_var] = ACTIONS(1000),
    [anon_sym_let] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_LPAREN] = ACTIONS(998),
    [anon_sym_await] = ACTIONS(1000),
    [anon_sym_in] = ACTIONS(1002),
    [anon_sym_of] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_try] = ACTIONS(1000),
    [anon_sym_with] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_debugger] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_throw] = ACTIONS(1000),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(998),
    [anon_sym_class] = ACTIONS(1000),
    [anon_sym_async] = ACTIONS(1000),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_abstract] = ACTIONS(1000),
    [anon_sym_get] = ACTIONS(1000),
    [anon_sym_set] = ACTIONS(1000),
    [anon_sym_QMARK] = ACTIONS(1002),
    [anon_sym_QMARK_DOT] = ACTIONS(1004),
    [anon_sym_new] = ACTIONS(1000),
    [anon_sym_AMP_AMP] = ACTIONS(1004),
    [anon_sym_PIPE_PIPE] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1002),
    [anon_sym_GT_GT_GT] = ACTIONS(1004),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_CARET] = ACTIONS(1004),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1000),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_STAR_STAR] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1000),
    [anon_sym_LT_EQ] = ACTIONS(1004),
    [anon_sym_EQ_EQ] = ACTIONS(1004),
    [anon_sym_BANG_EQ] = ACTIONS(1004),
    [anon_sym_GT_EQ] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1002),
    [anon_sym_QMARK_QMARK] = ACTIONS(1004),
    [anon_sym_instanceof] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_void] = ACTIONS(1000),
    [anon_sym_delete] = ACTIONS(1000),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(998),
    [sym_float_literal] = ACTIONS(998),
    [sym_hex_literal] = ACTIONS(1000),
    [sym_int_literal] = ACTIONS(1000),
    [sym_binary_literal] = ACTIONS(1000),
    [sym_octal_literal] = ACTIONS(1000),
    [sym_bigint_literal] = ACTIONS(998),
    [sym_this] = ACTIONS(1000),
    [sym_super] = ACTIONS(1000),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_public] = ACTIONS(1000),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym_protected] = ACTIONS(1000),
    [anon_sym_boolean] = ACTIONS(1000),
    [anon_sym_string] = ACTIONS(1000),
    [anon_sym_symbol] = ACTIONS(1000),
    [sym_readonly] = ACTIONS(1000),
    [sym__automatic_semicolon] = ACTIONS(1006),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(1008),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_export] = ACTIONS(1010),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1010),
    [anon_sym_as] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1008),
    [anon_sym_COMMA] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1008),
    [anon_sym_typeof] = ACTIONS(1010),
    [anon_sym_type] = ACTIONS(1010),
    [anon_sym_interface] = ACTIONS(1010),
    [anon_sym_declare] = ACTIONS(1010),
    [anon_sym_module] = ACTIONS(1010),
    [anon_sym_DOT] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1010),
    [anon_sym_const] = ACTIONS(1010),
    [anon_sym_enum] = ACTIONS(1010),
    [anon_sym_var] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1010),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_in] = ACTIONS(1012),
    [anon_sym_of] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_do] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_with] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_debugger] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_throw] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_class] = ACTIONS(1010),
    [anon_sym_async] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_abstract] = ACTIONS(1010),
    [anon_sym_get] = ACTIONS(1010),
    [anon_sym_set] = ACTIONS(1010),
    [anon_sym_QMARK] = ACTIONS(1012),
    [anon_sym_QMARK_DOT] = ACTIONS(1014),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_AMP_AMP] = ACTIONS(1014),
    [anon_sym_PIPE_PIPE] = ACTIONS(1014),
    [anon_sym_GT_GT] = ACTIONS(1012),
    [anon_sym_GT_GT_GT] = ACTIONS(1014),
    [anon_sym_LT_LT] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(1014),
    [anon_sym_PIPE] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1010),
    [anon_sym_SLASH] = ACTIONS(1010),
    [anon_sym_PERCENT] = ACTIONS(1014),
    [anon_sym_STAR_STAR] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_EQ] = ACTIONS(1014),
    [anon_sym_EQ_EQ] = ACTIONS(1014),
    [anon_sym_BANG_EQ] = ACTIONS(1014),
    [anon_sym_GT_EQ] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1012),
    [anon_sym_QMARK_QMARK] = ACTIONS(1014),
    [anon_sym_instanceof] = ACTIONS(1012),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1010),
    [anon_sym_delete] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_SQUOTE] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1008),
    [sym_float_literal] = ACTIONS(1008),
    [sym_hex_literal] = ACTIONS(1010),
    [sym_int_literal] = ACTIONS(1010),
    [sym_binary_literal] = ACTIONS(1010),
    [sym_octal_literal] = ACTIONS(1010),
    [sym_bigint_literal] = ACTIONS(1008),
    [sym_this] = ACTIONS(1010),
    [sym_super] = ACTIONS(1010),
    [sym_true] = ACTIONS(1010),
    [sym_false] = ACTIONS(1010),
    [sym_null] = ACTIONS(1010),
    [anon_sym_AT] = ACTIONS(1008),
    [anon_sym_static] = ACTIONS(1010),
    [anon_sym_public] = ACTIONS(1010),
    [anon_sym_private] = ACTIONS(1010),
    [anon_sym_protected] = ACTIONS(1010),
    [anon_sym_boolean] = ACTIONS(1010),
    [anon_sym_string] = ACTIONS(1010),
    [anon_sym_symbol] = ACTIONS(1010),
    [sym_readonly] = ACTIONS(1010),
    [sym__automatic_semicolon] = ACTIONS(1016),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(1018),
    [sym_identifier] = ACTIONS(1020),
    [anon_sym_export] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_namespace] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_COMMA] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_typeof] = ACTIONS(1020),
    [anon_sym_type] = ACTIONS(1020),
    [anon_sym_interface] = ACTIONS(1020),
    [anon_sym_declare] = ACTIONS(1020),
    [anon_sym_module] = ACTIONS(1020),
    [anon_sym_DOT] = ACTIONS(1020),
    [anon_sym_import] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_BANG] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1020),
    [anon_sym_in] = ACTIONS(1020),
    [anon_sym_of] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_debugger] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_throw] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [anon_sym_class] = ACTIONS(1020),
    [anon_sym_async] = ACTIONS(1020),
    [anon_sym_function] = ACTIONS(1020),
    [anon_sym_abstract] = ACTIONS(1020),
    [anon_sym_get] = ACTIONS(1020),
    [anon_sym_set] = ACTIONS(1020),
    [anon_sym_QMARK] = ACTIONS(1020),
    [anon_sym_QMARK_DOT] = ACTIONS(1018),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_AMP_AMP] = ACTIONS(1018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1020),
    [anon_sym_GT_GT_GT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1020),
    [anon_sym_CARET] = ACTIONS(1018),
    [anon_sym_PIPE] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_SLASH] = ACTIONS(1020),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_STAR_STAR] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1020),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1020),
    [anon_sym_QMARK_QMARK] = ACTIONS(1018),
    [anon_sym_instanceof] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_void] = ACTIONS(1020),
    [anon_sym_delete] = ACTIONS(1020),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [sym_float_literal] = ACTIONS(1018),
    [sym_hex_literal] = ACTIONS(1020),
    [sym_int_literal] = ACTIONS(1020),
    [sym_binary_literal] = ACTIONS(1020),
    [sym_octal_literal] = ACTIONS(1020),
    [sym_bigint_literal] = ACTIONS(1018),
    [sym_this] = ACTIONS(1020),
    [sym_super] = ACTIONS(1020),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_public] = ACTIONS(1020),
    [anon_sym_private] = ACTIONS(1020),
    [anon_sym_protected] = ACTIONS(1020),
    [anon_sym_boolean] = ACTIONS(1020),
    [anon_sym_string] = ACTIONS(1020),
    [anon_sym_symbol] = ACTIONS(1020),
    [sym_readonly] = ACTIONS(1020),
    [sym__automatic_semicolon] = ACTIONS(1018),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_export] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_as] = ACTIONS(948),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_COMMA] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_typeof] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(948),
    [anon_sym_declare] = ACTIONS(948),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_DOT] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(948),
    [anon_sym_let] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_await] = ACTIONS(948),
    [anon_sym_in] = ACTIONS(948),
    [anon_sym_of] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_with] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_debugger] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_throw] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_yield] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_function] = ACTIONS(948),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_get] = ACTIONS(948),
    [anon_sym_set] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(948),
    [anon_sym_QMARK_DOT] = ACTIONS(946),
    [anon_sym_new] = ACTIONS(948),
    [anon_sym_AMP_AMP] = ACTIONS(946),
    [anon_sym_PIPE_PIPE] = ACTIONS(946),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_GT_GT_GT] = ACTIONS(946),
    [anon_sym_LT_LT] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(946),
    [anon_sym_PIPE] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_PERCENT] = ACTIONS(946),
    [anon_sym_STAR_STAR] = ACTIONS(946),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_LT_EQ] = ACTIONS(946),
    [anon_sym_EQ_EQ] = ACTIONS(946),
    [anon_sym_BANG_EQ] = ACTIONS(946),
    [anon_sym_GT_EQ] = ACTIONS(946),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_QMARK_QMARK] = ACTIONS(946),
    [anon_sym_instanceof] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(948),
    [anon_sym_delete] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(946),
    [sym_float_literal] = ACTIONS(946),
    [sym_hex_literal] = ACTIONS(948),
    [sym_int_literal] = ACTIONS(948),
    [sym_binary_literal] = ACTIONS(948),
    [sym_octal_literal] = ACTIONS(948),
    [sym_bigint_literal] = ACTIONS(946),
    [sym_this] = ACTIONS(948),
    [sym_super] = ACTIONS(948),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_public] = ACTIONS(948),
    [anon_sym_private] = ACTIONS(948),
    [anon_sym_protected] = ACTIONS(948),
    [anon_sym_boolean] = ACTIONS(948),
    [anon_sym_string] = ACTIONS(948),
    [anon_sym_symbol] = ACTIONS(948),
    [sym_readonly] = ACTIONS(948),
    [sym__automatic_semicolon] = ACTIONS(1022),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1026),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_COMMA] = ACTIONS(1030),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_typeof] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_interface] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_DOT] = ACTIONS(1028),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1026),
    [anon_sym_enum] = ACTIONS(1026),
    [anon_sym_var] = ACTIONS(1026),
    [anon_sym_let] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_switch] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1024),
    [anon_sym_await] = ACTIONS(1026),
    [anon_sym_in] = ACTIONS(1028),
    [anon_sym_of] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_with] = ACTIONS(1026),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_debugger] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_throw] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1026),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_async] = ACTIONS(1026),
    [anon_sym_function] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_QMARK] = ACTIONS(1028),
    [anon_sym_QMARK_DOT] = ACTIONS(1030),
    [anon_sym_new] = ACTIONS(1026),
    [anon_sym_AMP_AMP] = ACTIONS(1030),
    [anon_sym_PIPE_PIPE] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1028),
    [anon_sym_GT_GT_GT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1028),
    [anon_sym_CARET] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_STAR_STAR] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_QMARK_QMARK] = ACTIONS(1030),
    [anon_sym_instanceof] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(1026),
    [anon_sym_delete] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1024),
    [sym_float_literal] = ACTIONS(1024),
    [sym_hex_literal] = ACTIONS(1026),
    [sym_int_literal] = ACTIONS(1026),
    [sym_binary_literal] = ACTIONS(1026),
    [sym_octal_literal] = ACTIONS(1026),
    [sym_bigint_literal] = ACTIONS(1024),
    [sym_this] = ACTIONS(1026),
    [sym_super] = ACTIONS(1026),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_null] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [sym_readonly] = ACTIONS(1026),
    [sym__automatic_semicolon] = ACTIONS(1032),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(1034),
    [sym_identifier] = ACTIONS(1036),
    [anon_sym_export] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_as] = ACTIONS(1038),
    [anon_sym_namespace] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_COMMA] = ACTIONS(1040),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(1036),
    [anon_sym_type] = ACTIONS(1036),
    [anon_sym_interface] = ACTIONS(1036),
    [anon_sym_declare] = ACTIONS(1036),
    [anon_sym_module] = ACTIONS(1036),
    [anon_sym_DOT] = ACTIONS(1038),
    [anon_sym_import] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_var] = ACTIONS(1036),
    [anon_sym_let] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_in] = ACTIONS(1038),
    [anon_sym_of] = ACTIONS(1038),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_with] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_debugger] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_throw] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1034),
    [anon_sym_class] = ACTIONS(1036),
    [anon_sym_async] = ACTIONS(1036),
    [anon_sym_function] = ACTIONS(1036),
    [anon_sym_abstract] = ACTIONS(1036),
    [anon_sym_get] = ACTIONS(1036),
    [anon_sym_set] = ACTIONS(1036),
    [anon_sym_QMARK] = ACTIONS(1038),
    [anon_sym_QMARK_DOT] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1040),
    [anon_sym_PIPE_PIPE] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_GT_GT_GT] = ACTIONS(1040),
    [anon_sym_LT_LT] = ACTIONS(1040),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_SLASH] = ACTIONS(1036),
    [anon_sym_PERCENT] = ACTIONS(1040),
    [anon_sym_STAR_STAR] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_EQ] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1040),
    [anon_sym_BANG_EQ] = ACTIONS(1040),
    [anon_sym_GT_EQ] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_QMARK_QMARK] = ACTIONS(1040),
    [anon_sym_instanceof] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1036),
    [anon_sym_delete] = ACTIONS(1036),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1034),
    [sym_float_literal] = ACTIONS(1034),
    [sym_hex_literal] = ACTIONS(1036),
    [sym_int_literal] = ACTIONS(1036),
    [sym_binary_literal] = ACTIONS(1036),
    [sym_octal_literal] = ACTIONS(1036),
    [sym_bigint_literal] = ACTIONS(1034),
    [sym_this] = ACTIONS(1036),
    [sym_super] = ACTIONS(1036),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_public] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym_protected] = ACTIONS(1036),
    [anon_sym_boolean] = ACTIONS(1036),
    [anon_sym_string] = ACTIONS(1036),
    [anon_sym_symbol] = ACTIONS(1036),
    [sym_readonly] = ACTIONS(1036),
    [sym__automatic_semicolon] = ACTIONS(1042),
  },
  [82] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(1044),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_EQ_GT] = ACTIONS(1046),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(932),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_export] = ACTIONS(1050),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_as] = ACTIONS(1050),
    [anon_sym_namespace] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_COMMA] = ACTIONS(1048),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_type] = ACTIONS(1050),
    [anon_sym_interface] = ACTIONS(1050),
    [anon_sym_declare] = ACTIONS(1050),
    [anon_sym_module] = ACTIONS(1050),
    [anon_sym_DOT] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1050),
    [anon_sym_const] = ACTIONS(1050),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_var] = ACTIONS(1050),
    [anon_sym_let] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_else] = ACTIONS(1050),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_switch] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1050),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_in] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1050),
    [anon_sym_while] = ACTIONS(1050),
    [anon_sym_do] = ACTIONS(1050),
    [anon_sym_try] = ACTIONS(1050),
    [anon_sym_with] = ACTIONS(1050),
    [anon_sym_break] = ACTIONS(1050),
    [anon_sym_continue] = ACTIONS(1050),
    [anon_sym_debugger] = ACTIONS(1050),
    [anon_sym_return] = ACTIONS(1050),
    [anon_sym_throw] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1050),
    [anon_sym_yield] = ACTIONS(1050),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_class] = ACTIONS(1050),
    [anon_sym_async] = ACTIONS(1050),
    [anon_sym_function] = ACTIONS(1050),
    [anon_sym_abstract] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(1050),
    [anon_sym_set] = ACTIONS(1050),
    [anon_sym_QMARK] = ACTIONS(1050),
    [anon_sym_QMARK_DOT] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP_AMP] = ACTIONS(1048),
    [anon_sym_PIPE_PIPE] = ACTIONS(1048),
    [anon_sym_GT_GT] = ACTIONS(1050),
    [anon_sym_GT_GT_GT] = ACTIONS(1048),
    [anon_sym_LT_LT] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_CARET] = ACTIONS(1048),
    [anon_sym_PIPE] = ACTIONS(1050),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(1050),
    [anon_sym_PERCENT] = ACTIONS(1048),
    [anon_sym_STAR_STAR] = ACTIONS(1048),
    [anon_sym_LT] = ACTIONS(1050),
    [anon_sym_LT_EQ] = ACTIONS(1048),
    [anon_sym_EQ_EQ] = ACTIONS(1048),
    [anon_sym_BANG_EQ] = ACTIONS(1048),
    [anon_sym_GT_EQ] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(1050),
    [anon_sym_QMARK_QMARK] = ACTIONS(1048),
    [anon_sym_instanceof] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [anon_sym_SQUOTE] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1048),
    [sym_float_literal] = ACTIONS(1048),
    [sym_hex_literal] = ACTIONS(1050),
    [sym_int_literal] = ACTIONS(1050),
    [sym_binary_literal] = ACTIONS(1050),
    [sym_octal_literal] = ACTIONS(1050),
    [sym_bigint_literal] = ACTIONS(1048),
    [sym_this] = ACTIONS(1050),
    [sym_super] = ACTIONS(1050),
    [sym_true] = ACTIONS(1050),
    [sym_false] = ACTIONS(1050),
    [sym_null] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_static] = ACTIONS(1050),
    [anon_sym_public] = ACTIONS(1050),
    [anon_sym_private] = ACTIONS(1050),
    [anon_sym_protected] = ACTIONS(1050),
    [anon_sym_boolean] = ACTIONS(1050),
    [anon_sym_string] = ACTIONS(1050),
    [anon_sym_symbol] = ACTIONS(1050),
    [sym_readonly] = ACTIONS(1050),
    [sym__automatic_semicolon] = ACTIONS(1048),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_export] = ACTIONS(970),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_as] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_declare] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_DOT] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_var] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(970),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(970),
    [anon_sym_in] = ACTIONS(970),
    [anon_sym_of] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_debugger] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_function] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(970),
    [anon_sym_set] = ACTIONS(970),
    [anon_sym_QMARK] = ACTIONS(970),
    [anon_sym_QMARK_DOT] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_AMP_AMP] = ACTIONS(968),
    [anon_sym_PIPE_PIPE] = ACTIONS(968),
    [anon_sym_GT_GT] = ACTIONS(970),
    [anon_sym_GT_GT_GT] = ACTIONS(968),
    [anon_sym_LT_LT] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(970),
    [anon_sym_CARET] = ACTIONS(968),
    [anon_sym_PIPE] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(970),
    [anon_sym_PERCENT] = ACTIONS(968),
    [anon_sym_STAR_STAR] = ACTIONS(968),
    [anon_sym_LT] = ACTIONS(970),
    [anon_sym_LT_EQ] = ACTIONS(968),
    [anon_sym_EQ_EQ] = ACTIONS(968),
    [anon_sym_BANG_EQ] = ACTIONS(968),
    [anon_sym_GT_EQ] = ACTIONS(968),
    [anon_sym_GT] = ACTIONS(970),
    [anon_sym_QMARK_QMARK] = ACTIONS(968),
    [anon_sym_instanceof] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_void] = ACTIONS(970),
    [anon_sym_delete] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(968),
    [sym_float_literal] = ACTIONS(968),
    [sym_hex_literal] = ACTIONS(970),
    [sym_int_literal] = ACTIONS(970),
    [sym_binary_literal] = ACTIONS(970),
    [sym_octal_literal] = ACTIONS(970),
    [sym_bigint_literal] = ACTIONS(968),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [sym_readonly] = ACTIONS(970),
    [sym__automatic_semicolon] = ACTIONS(968),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(1052),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1054),
    [anon_sym_STAR] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1054),
    [anon_sym_as] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_COMMA] = ACTIONS(1058),
    [anon_sym_RBRACE] = ACTIONS(1052),
    [anon_sym_typeof] = ACTIONS(1054),
    [anon_sym_type] = ACTIONS(1054),
    [anon_sym_interface] = ACTIONS(1054),
    [anon_sym_declare] = ACTIONS(1054),
    [anon_sym_module] = ACTIONS(1054),
    [anon_sym_DOT] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1054),
    [anon_sym_const] = ACTIONS(1054),
    [anon_sym_enum] = ACTIONS(1054),
    [anon_sym_var] = ACTIONS(1054),
    [anon_sym_let] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_else] = ACTIONS(1054),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_switch] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1052),
    [anon_sym_await] = ACTIONS(1054),
    [anon_sym_in] = ACTIONS(1056),
    [anon_sym_of] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1054),
    [anon_sym_do] = ACTIONS(1054),
    [anon_sym_try] = ACTIONS(1054),
    [anon_sym_with] = ACTIONS(1054),
    [anon_sym_break] = ACTIONS(1054),
    [anon_sym_continue] = ACTIONS(1054),
    [anon_sym_debugger] = ACTIONS(1054),
    [anon_sym_return] = ACTIONS(1054),
    [anon_sym_throw] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1054),
    [anon_sym_yield] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_class] = ACTIONS(1054),
    [anon_sym_async] = ACTIONS(1054),
    [anon_sym_function] = ACTIONS(1054),
    [anon_sym_abstract] = ACTIONS(1054),
    [anon_sym_get] = ACTIONS(1054),
    [anon_sym_set] = ACTIONS(1054),
    [anon_sym_QMARK] = ACTIONS(1056),
    [anon_sym_QMARK_DOT] = ACTIONS(1058),
    [anon_sym_new] = ACTIONS(1054),
    [anon_sym_AMP_AMP] = ACTIONS(1058),
    [anon_sym_PIPE_PIPE] = ACTIONS(1058),
    [anon_sym_GT_GT] = ACTIONS(1056),
    [anon_sym_GT_GT_GT] = ACTIONS(1058),
    [anon_sym_LT_LT] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1056),
    [anon_sym_CARET] = ACTIONS(1058),
    [anon_sym_PIPE] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_PERCENT] = ACTIONS(1058),
    [anon_sym_STAR_STAR] = ACTIONS(1058),
    [anon_sym_LT] = ACTIONS(1054),
    [anon_sym_LT_EQ] = ACTIONS(1058),
    [anon_sym_EQ_EQ] = ACTIONS(1058),
    [anon_sym_BANG_EQ] = ACTIONS(1058),
    [anon_sym_GT_EQ] = ACTIONS(1058),
    [anon_sym_GT] = ACTIONS(1056),
    [anon_sym_QMARK_QMARK] = ACTIONS(1058),
    [anon_sym_instanceof] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_void] = ACTIONS(1054),
    [anon_sym_delete] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1052),
    [anon_sym_DQUOTE] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [sym_float_literal] = ACTIONS(1052),
    [sym_hex_literal] = ACTIONS(1054),
    [sym_int_literal] = ACTIONS(1054),
    [sym_binary_literal] = ACTIONS(1054),
    [sym_octal_literal] = ACTIONS(1054),
    [sym_bigint_literal] = ACTIONS(1052),
    [sym_this] = ACTIONS(1054),
    [sym_super] = ACTIONS(1054),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_null] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_static] = ACTIONS(1054),
    [anon_sym_public] = ACTIONS(1054),
    [anon_sym_private] = ACTIONS(1054),
    [anon_sym_protected] = ACTIONS(1054),
    [anon_sym_boolean] = ACTIONS(1054),
    [anon_sym_string] = ACTIONS(1054),
    [anon_sym_symbol] = ACTIONS(1054),
    [sym_readonly] = ACTIONS(1054),
    [sym__automatic_semicolon] = ACTIONS(1060),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_as] = ACTIONS(1066),
    [anon_sym_namespace] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_COMMA] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_interface] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_DOT] = ACTIONS(1066),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_var] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1064),
    [anon_sym_in] = ACTIONS(1066),
    [anon_sym_of] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_debugger] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_throw] = ACTIONS(1064),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_QMARK] = ACTIONS(1066),
    [anon_sym_QMARK_DOT] = ACTIONS(1068),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1066),
    [anon_sym_GT_GT_GT] = ACTIONS(1068),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_CARET] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_SLASH] = ACTIONS(1064),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_STAR_STAR] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1064),
    [anon_sym_LT_EQ] = ACTIONS(1068),
    [anon_sym_EQ_EQ] = ACTIONS(1068),
    [anon_sym_BANG_EQ] = ACTIONS(1068),
    [anon_sym_GT_EQ] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1066),
    [anon_sym_QMARK_QMARK] = ACTIONS(1068),
    [anon_sym_instanceof] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_float_literal] = ACTIONS(1062),
    [sym_hex_literal] = ACTIONS(1064),
    [sym_int_literal] = ACTIONS(1064),
    [sym_binary_literal] = ACTIONS(1064),
    [sym_octal_literal] = ACTIONS(1064),
    [sym_bigint_literal] = ACTIONS(1062),
    [sym_this] = ACTIONS(1064),
    [sym_super] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [sym_readonly] = ACTIONS(1064),
    [sym__automatic_semicolon] = ACTIONS(1070),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(1074),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1074),
    [anon_sym_type] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_declare] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1074),
    [anon_sym_import] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_in] = ACTIONS(1074),
    [anon_sym_of] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_debugger] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_throw] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_abstract] = ACTIONS(1074),
    [anon_sym_get] = ACTIONS(1074),
    [anon_sym_set] = ACTIONS(1074),
    [anon_sym_QMARK] = ACTIONS(1074),
    [anon_sym_QMARK_DOT] = ACTIONS(1072),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_GT_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR_STAR] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_QMARK_QMARK] = ACTIONS(1072),
    [anon_sym_instanceof] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1074),
    [anon_sym_delete] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
    [sym_hex_literal] = ACTIONS(1074),
    [sym_int_literal] = ACTIONS(1074),
    [sym_binary_literal] = ACTIONS(1074),
    [sym_octal_literal] = ACTIONS(1074),
    [sym_bigint_literal] = ACTIONS(1072),
    [sym_this] = ACTIONS(1074),
    [sym_super] = ACTIONS(1074),
    [sym_true] = ACTIONS(1074),
    [sym_false] = ACTIONS(1074),
    [sym_null] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1074),
    [anon_sym_public] = ACTIONS(1074),
    [anon_sym_private] = ACTIONS(1074),
    [anon_sym_protected] = ACTIONS(1074),
    [anon_sym_boolean] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [anon_sym_symbol] = ACTIONS(1074),
    [sym_readonly] = ACTIONS(1074),
    [sym__automatic_semicolon] = ACTIONS(1072),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1078),
    [anon_sym_as] = ACTIONS(1080),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_typeof] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_interface] = ACTIONS(1078),
    [anon_sym_declare] = ACTIONS(1078),
    [anon_sym_module] = ACTIONS(1078),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_const] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_await] = ACTIONS(1078),
    [anon_sym_in] = ACTIONS(1080),
    [anon_sym_of] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_debugger] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_throw] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1078),
    [anon_sym_yield] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_function] = ACTIONS(1078),
    [anon_sym_abstract] = ACTIONS(1078),
    [anon_sym_get] = ACTIONS(1078),
    [anon_sym_set] = ACTIONS(1078),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_QMARK_DOT] = ACTIONS(1082),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP_AMP] = ACTIONS(1082),
    [anon_sym_PIPE_PIPE] = ACTIONS(1082),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_GT_GT_GT] = ACTIONS(1082),
    [anon_sym_LT_LT] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1080),
    [anon_sym_CARET] = ACTIONS(1082),
    [anon_sym_PIPE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1078),
    [anon_sym_SLASH] = ACTIONS(1078),
    [anon_sym_PERCENT] = ACTIONS(1082),
    [anon_sym_STAR_STAR] = ACTIONS(1082),
    [anon_sym_LT] = ACTIONS(1078),
    [anon_sym_LT_EQ] = ACTIONS(1082),
    [anon_sym_EQ_EQ] = ACTIONS(1082),
    [anon_sym_BANG_EQ] = ACTIONS(1082),
    [anon_sym_GT_EQ] = ACTIONS(1082),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_QMARK_QMARK] = ACTIONS(1082),
    [anon_sym_instanceof] = ACTIONS(1080),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1078),
    [anon_sym_delete] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1076),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_float_literal] = ACTIONS(1076),
    [sym_hex_literal] = ACTIONS(1078),
    [sym_int_literal] = ACTIONS(1078),
    [sym_binary_literal] = ACTIONS(1078),
    [sym_octal_literal] = ACTIONS(1078),
    [sym_bigint_literal] = ACTIONS(1076),
    [sym_this] = ACTIONS(1078),
    [sym_super] = ACTIONS(1078),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_null] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_static] = ACTIONS(1078),
    [anon_sym_public] = ACTIONS(1078),
    [anon_sym_private] = ACTIONS(1078),
    [anon_sym_protected] = ACTIONS(1078),
    [anon_sym_boolean] = ACTIONS(1078),
    [anon_sym_string] = ACTIONS(1078),
    [anon_sym_symbol] = ACTIONS(1078),
    [sym_readonly] = ACTIONS(1078),
    [sym__automatic_semicolon] = ACTIONS(1084),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_export] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(1090),
    [anon_sym_namespace] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_COMMA] = ACTIONS(1092),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_type] = ACTIONS(1088),
    [anon_sym_interface] = ACTIONS(1088),
    [anon_sym_declare] = ACTIONS(1088),
    [anon_sym_module] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_var] = ACTIONS(1088),
    [anon_sym_let] = ACTIONS(1088),
    [anon_sym_BANG] = ACTIONS(1088),
    [anon_sym_else] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_await] = ACTIONS(1088),
    [anon_sym_in] = ACTIONS(1090),
    [anon_sym_of] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_try] = ACTIONS(1088),
    [anon_sym_with] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_debugger] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_throw] = ACTIONS(1088),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_yield] = ACTIONS(1088),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1088),
    [anon_sym_async] = ACTIONS(1088),
    [anon_sym_function] = ACTIONS(1088),
    [anon_sym_abstract] = ACTIONS(1088),
    [anon_sym_get] = ACTIONS(1088),
    [anon_sym_set] = ACTIONS(1088),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_QMARK_DOT] = ACTIONS(1092),
    [anon_sym_new] = ACTIONS(1088),
    [anon_sym_AMP_AMP] = ACTIONS(1092),
    [anon_sym_PIPE_PIPE] = ACTIONS(1092),
    [anon_sym_GT_GT] = ACTIONS(1090),
    [anon_sym_GT_GT_GT] = ACTIONS(1092),
    [anon_sym_LT_LT] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_CARET] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1090),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_STAR_STAR] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1088),
    [anon_sym_LT_EQ] = ACTIONS(1092),
    [anon_sym_EQ_EQ] = ACTIONS(1092),
    [anon_sym_BANG_EQ] = ACTIONS(1092),
    [anon_sym_GT_EQ] = ACTIONS(1092),
    [anon_sym_GT] = ACTIONS(1090),
    [anon_sym_QMARK_QMARK] = ACTIONS(1092),
    [anon_sym_instanceof] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [sym_float_literal] = ACTIONS(1086),
    [sym_hex_literal] = ACTIONS(1088),
    [sym_int_literal] = ACTIONS(1088),
    [sym_binary_literal] = ACTIONS(1088),
    [sym_octal_literal] = ACTIONS(1088),
    [sym_bigint_literal] = ACTIONS(1086),
    [sym_this] = ACTIONS(1088),
    [sym_super] = ACTIONS(1088),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [anon_sym_AT] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_public] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym_protected] = ACTIONS(1088),
    [anon_sym_boolean] = ACTIONS(1088),
    [anon_sym_string] = ACTIONS(1088),
    [anon_sym_symbol] = ACTIONS(1088),
    [sym_readonly] = ACTIONS(1088),
    [sym__automatic_semicolon] = ACTIONS(1094),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(1096),
    [sym_identifier] = ACTIONS(1098),
    [anon_sym_export] = ACTIONS(1098),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1098),
    [anon_sym_as] = ACTIONS(1098),
    [anon_sym_namespace] = ACTIONS(1098),
    [anon_sym_LBRACE] = ACTIONS(1096),
    [anon_sym_COMMA] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1096),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1098),
    [anon_sym_interface] = ACTIONS(1098),
    [anon_sym_declare] = ACTIONS(1098),
    [anon_sym_module] = ACTIONS(1098),
    [anon_sym_DOT] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(1098),
    [anon_sym_const] = ACTIONS(1098),
    [anon_sym_enum] = ACTIONS(1098),
    [anon_sym_var] = ACTIONS(1098),
    [anon_sym_let] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_else] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1098),
    [anon_sym_switch] = ACTIONS(1098),
    [anon_sym_for] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [anon_sym_await] = ACTIONS(1098),
    [anon_sym_in] = ACTIONS(1098),
    [anon_sym_of] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1098),
    [anon_sym_do] = ACTIONS(1098),
    [anon_sym_try] = ACTIONS(1098),
    [anon_sym_with] = ACTIONS(1098),
    [anon_sym_break] = ACTIONS(1098),
    [anon_sym_continue] = ACTIONS(1098),
    [anon_sym_debugger] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_throw] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_yield] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1096),
    [anon_sym_class] = ACTIONS(1098),
    [anon_sym_async] = ACTIONS(1098),
    [anon_sym_function] = ACTIONS(1098),
    [anon_sym_abstract] = ACTIONS(1098),
    [anon_sym_get] = ACTIONS(1098),
    [anon_sym_set] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(1098),
    [anon_sym_QMARK_DOT] = ACTIONS(1096),
    [anon_sym_new] = ACTIONS(1098),
    [anon_sym_AMP_AMP] = ACTIONS(1096),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1098),
    [anon_sym_GT_GT_GT] = ACTIONS(1096),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_CARET] = ACTIONS(1096),
    [anon_sym_PIPE] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_SLASH] = ACTIONS(1098),
    [anon_sym_PERCENT] = ACTIONS(1096),
    [anon_sym_STAR_STAR] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1098),
    [anon_sym_LT_EQ] = ACTIONS(1096),
    [anon_sym_EQ_EQ] = ACTIONS(1096),
    [anon_sym_BANG_EQ] = ACTIONS(1096),
    [anon_sym_GT_EQ] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1098),
    [anon_sym_QMARK_QMARK] = ACTIONS(1096),
    [anon_sym_instanceof] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [anon_sym_SQUOTE] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [sym_float_literal] = ACTIONS(1096),
    [sym_hex_literal] = ACTIONS(1098),
    [sym_int_literal] = ACTIONS(1098),
    [sym_binary_literal] = ACTIONS(1098),
    [sym_octal_literal] = ACTIONS(1098),
    [sym_bigint_literal] = ACTIONS(1096),
    [sym_this] = ACTIONS(1098),
    [sym_super] = ACTIONS(1098),
    [sym_true] = ACTIONS(1098),
    [sym_false] = ACTIONS(1098),
    [sym_null] = ACTIONS(1098),
    [anon_sym_AT] = ACTIONS(1096),
    [anon_sym_static] = ACTIONS(1098),
    [anon_sym_public] = ACTIONS(1098),
    [anon_sym_private] = ACTIONS(1098),
    [anon_sym_protected] = ACTIONS(1098),
    [anon_sym_boolean] = ACTIONS(1098),
    [anon_sym_string] = ACTIONS(1098),
    [anon_sym_symbol] = ACTIONS(1098),
    [sym_readonly] = ACTIONS(1098),
    [sym__automatic_semicolon] = ACTIONS(1096),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(1100),
    [sym_identifier] = ACTIONS(1102),
    [anon_sym_export] = ACTIONS(1102),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1102),
    [anon_sym_interface] = ACTIONS(1102),
    [anon_sym_declare] = ACTIONS(1102),
    [anon_sym_module] = ACTIONS(1102),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_const] = ACTIONS(1102),
    [anon_sym_enum] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_else] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_switch] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_await] = ACTIONS(1102),
    [anon_sym_in] = ACTIONS(1104),
    [anon_sym_of] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_debugger] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_throw] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1102),
    [anon_sym_yield] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_async] = ACTIONS(1102),
    [anon_sym_function] = ACTIONS(1102),
    [anon_sym_abstract] = ACTIONS(1102),
    [anon_sym_get] = ACTIONS(1102),
    [anon_sym_set] = ACTIONS(1102),
    [anon_sym_QMARK] = ACTIONS(1104),
    [anon_sym_QMARK_DOT] = ACTIONS(1106),
    [anon_sym_new] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1106),
    [anon_sym_PIPE_PIPE] = ACTIONS(1106),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_GT_GT_GT] = ACTIONS(1106),
    [anon_sym_LT_LT] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1104),
    [anon_sym_CARET] = ACTIONS(1106),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1102),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_STAR_STAR] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_LT_EQ] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1106),
    [anon_sym_BANG_EQ] = ACTIONS(1106),
    [anon_sym_GT_EQ] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_QMARK_QMARK] = ACTIONS(1106),
    [anon_sym_instanceof] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1102),
    [anon_sym_delete] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_SQUOTE] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_float_literal] = ACTIONS(1100),
    [sym_hex_literal] = ACTIONS(1102),
    [sym_int_literal] = ACTIONS(1102),
    [sym_binary_literal] = ACTIONS(1102),
    [sym_octal_literal] = ACTIONS(1102),
    [sym_bigint_literal] = ACTIONS(1100),
    [sym_this] = ACTIONS(1102),
    [sym_super] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_null] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1102),
    [anon_sym_public] = ACTIONS(1102),
    [anon_sym_private] = ACTIONS(1102),
    [anon_sym_protected] = ACTIONS(1102),
    [anon_sym_boolean] = ACTIONS(1102),
    [anon_sym_string] = ACTIONS(1102),
    [anon_sym_symbol] = ACTIONS(1102),
    [sym_readonly] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1108),
  },
  [92] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2692),
    [sym_parenthesized_type] = STATE(2692),
    [sym_predefined_type] = STATE(2692),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2692),
    [sym_object_type] = STATE(2692),
    [sym_array_type] = STATE(2692),
    [sym_tuple_type] = STATE(2692),
    [sym__tuple_type_body] = STATE(2095),
    [sym_flow_maybe_type] = STATE(2692),
    [sym_type_query] = STATE(2692),
    [sym_index_type_query] = STATE(2692),
    [sym_existential_type] = STATE(2692),
    [sym_literal_type] = STATE(2692),
    [sym_lookup_type] = STATE(2692),
    [sym_conditional_type] = STATE(2692),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(926),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(1112),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_as] = ACTIONS(1118),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_COMMA] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_DOT] = ACTIONS(1118),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_in] = ACTIONS(1118),
    [anon_sym_of] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_QMARK] = ACTIONS(1118),
    [anon_sym_QMARK_DOT] = ACTIONS(1120),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_AMP_AMP] = ACTIONS(1120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1120),
    [anon_sym_GT_GT] = ACTIONS(1118),
    [anon_sym_GT_GT_GT] = ACTIONS(1120),
    [anon_sym_LT_LT] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1120),
    [anon_sym_PIPE] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_PERCENT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(1120),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_EQ_EQ] = ACTIONS(1120),
    [anon_sym_BANG_EQ] = ACTIONS(1120),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_GT] = ACTIONS(1118),
    [anon_sym_QMARK_QMARK] = ACTIONS(1120),
    [anon_sym_instanceof] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_float_literal] = ACTIONS(1114),
    [sym_hex_literal] = ACTIONS(1116),
    [sym_int_literal] = ACTIONS(1116),
    [sym_binary_literal] = ACTIONS(1116),
    [sym_octal_literal] = ACTIONS(1116),
    [sym_bigint_literal] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
    [sym__automatic_semicolon] = ACTIONS(1120),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_export] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_as] = ACTIONS(1124),
    [anon_sym_namespace] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1122),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_typeof] = ACTIONS(1124),
    [anon_sym_type] = ACTIONS(1124),
    [anon_sym_interface] = ACTIONS(1124),
    [anon_sym_declare] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(1124),
    [anon_sym_DOT] = ACTIONS(1124),
    [anon_sym_import] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_var] = ACTIONS(1124),
    [anon_sym_let] = ACTIONS(1124),
    [anon_sym_BANG] = ACTIONS(1124),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_await] = ACTIONS(1124),
    [anon_sym_in] = ACTIONS(1124),
    [anon_sym_of] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_try] = ACTIONS(1124),
    [anon_sym_with] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_debugger] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_throw] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(1124),
    [anon_sym_abstract] = ACTIONS(1124),
    [anon_sym_get] = ACTIONS(1124),
    [anon_sym_set] = ACTIONS(1124),
    [anon_sym_QMARK] = ACTIONS(1124),
    [anon_sym_QMARK_DOT] = ACTIONS(1122),
    [anon_sym_new] = ACTIONS(1124),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_GT_GT_GT] = ACTIONS(1122),
    [anon_sym_LT_LT] = ACTIONS(1122),
    [anon_sym_AMP] = ACTIONS(1124),
    [anon_sym_CARET] = ACTIONS(1122),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1124),
    [anon_sym_PERCENT] = ACTIONS(1122),
    [anon_sym_STAR_STAR] = ACTIONS(1122),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_LT_EQ] = ACTIONS(1122),
    [anon_sym_EQ_EQ] = ACTIONS(1122),
    [anon_sym_BANG_EQ] = ACTIONS(1122),
    [anon_sym_GT_EQ] = ACTIONS(1122),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_QMARK_QMARK] = ACTIONS(1122),
    [anon_sym_instanceof] = ACTIONS(1124),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_void] = ACTIONS(1124),
    [anon_sym_delete] = ACTIONS(1124),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_float_literal] = ACTIONS(1122),
    [sym_hex_literal] = ACTIONS(1124),
    [sym_int_literal] = ACTIONS(1124),
    [sym_binary_literal] = ACTIONS(1124),
    [sym_octal_literal] = ACTIONS(1124),
    [sym_bigint_literal] = ACTIONS(1122),
    [sym_this] = ACTIONS(1124),
    [sym_super] = ACTIONS(1124),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_null] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_public] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(1124),
    [anon_sym_boolean] = ACTIONS(1124),
    [anon_sym_string] = ACTIONS(1124),
    [anon_sym_symbol] = ACTIONS(1124),
    [sym_readonly] = ACTIONS(1124),
    [sym__automatic_semicolon] = ACTIONS(1122),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_as] = ACTIONS(1130),
    [anon_sym_namespace] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_COMMA] = ACTIONS(1132),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [anon_sym_typeof] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1128),
    [anon_sym_interface] = ACTIONS(1128),
    [anon_sym_declare] = ACTIONS(1128),
    [anon_sym_module] = ACTIONS(1128),
    [anon_sym_DOT] = ACTIONS(1130),
    [anon_sym_import] = ACTIONS(1128),
    [anon_sym_const] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_var] = ACTIONS(1128),
    [anon_sym_let] = ACTIONS(1128),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_else] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [anon_sym_await] = ACTIONS(1128),
    [anon_sym_in] = ACTIONS(1130),
    [anon_sym_of] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_try] = ACTIONS(1128),
    [anon_sym_with] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_debugger] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_throw] = ACTIONS(1128),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_yield] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_class] = ACTIONS(1128),
    [anon_sym_async] = ACTIONS(1128),
    [anon_sym_function] = ACTIONS(1128),
    [anon_sym_abstract] = ACTIONS(1128),
    [anon_sym_get] = ACTIONS(1128),
    [anon_sym_set] = ACTIONS(1128),
    [anon_sym_QMARK] = ACTIONS(1130),
    [anon_sym_QMARK_DOT] = ACTIONS(1132),
    [anon_sym_new] = ACTIONS(1128),
    [anon_sym_AMP_AMP] = ACTIONS(1132),
    [anon_sym_PIPE_PIPE] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1130),
    [anon_sym_GT_GT_GT] = ACTIONS(1132),
    [anon_sym_LT_LT] = ACTIONS(1132),
    [anon_sym_AMP] = ACTIONS(1130),
    [anon_sym_CARET] = ACTIONS(1132),
    [anon_sym_PIPE] = ACTIONS(1130),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_PERCENT] = ACTIONS(1132),
    [anon_sym_STAR_STAR] = ACTIONS(1132),
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_LT_EQ] = ACTIONS(1132),
    [anon_sym_EQ_EQ] = ACTIONS(1132),
    [anon_sym_BANG_EQ] = ACTIONS(1132),
    [anon_sym_GT_EQ] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1130),
    [anon_sym_QMARK_QMARK] = ACTIONS(1132),
    [anon_sym_instanceof] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_void] = ACTIONS(1128),
    [anon_sym_delete] = ACTIONS(1128),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1126),
    [sym_float_literal] = ACTIONS(1126),
    [sym_hex_literal] = ACTIONS(1128),
    [sym_int_literal] = ACTIONS(1128),
    [sym_binary_literal] = ACTIONS(1128),
    [sym_octal_literal] = ACTIONS(1128),
    [sym_bigint_literal] = ACTIONS(1126),
    [sym_this] = ACTIONS(1128),
    [sym_super] = ACTIONS(1128),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_public] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym_protected] = ACTIONS(1128),
    [anon_sym_boolean] = ACTIONS(1128),
    [anon_sym_string] = ACTIONS(1128),
    [anon_sym_symbol] = ACTIONS(1128),
    [sym_readonly] = ACTIONS(1128),
    [sym__automatic_semicolon] = ACTIONS(1134),
  },
  [96] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(1136),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_implements] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(932),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(1140),
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_export] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_as] = ACTIONS(1142),
    [anon_sym_namespace] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RBRACE] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1142),
    [anon_sym_interface] = ACTIONS(1142),
    [anon_sym_declare] = ACTIONS(1142),
    [anon_sym_module] = ACTIONS(1142),
    [anon_sym_DOT] = ACTIONS(1142),
    [anon_sym_import] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_enum] = ACTIONS(1142),
    [anon_sym_var] = ACTIONS(1142),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(1142),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_await] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(1142),
    [anon_sym_of] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_do] = ACTIONS(1142),
    [anon_sym_try] = ACTIONS(1142),
    [anon_sym_with] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_debugger] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_throw] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_yield] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1142),
    [anon_sym_async] = ACTIONS(1142),
    [anon_sym_function] = ACTIONS(1142),
    [anon_sym_abstract] = ACTIONS(1142),
    [anon_sym_get] = ACTIONS(1142),
    [anon_sym_set] = ACTIONS(1142),
    [anon_sym_QMARK] = ACTIONS(1142),
    [anon_sym_QMARK_DOT] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1140),
    [anon_sym_PIPE_PIPE] = ACTIONS(1140),
    [anon_sym_GT_GT] = ACTIONS(1142),
    [anon_sym_GT_GT_GT] = ACTIONS(1140),
    [anon_sym_LT_LT] = ACTIONS(1140),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_CARET] = ACTIONS(1140),
    [anon_sym_PIPE] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1142),
    [anon_sym_PERCENT] = ACTIONS(1140),
    [anon_sym_STAR_STAR] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1142),
    [anon_sym_LT_EQ] = ACTIONS(1140),
    [anon_sym_EQ_EQ] = ACTIONS(1140),
    [anon_sym_BANG_EQ] = ACTIONS(1140),
    [anon_sym_GT_EQ] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1142),
    [anon_sym_QMARK_QMARK] = ACTIONS(1140),
    [anon_sym_instanceof] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_void] = ACTIONS(1142),
    [anon_sym_delete] = ACTIONS(1142),
    [anon_sym_PLUS_PLUS] = ACTIONS(1140),
    [anon_sym_DASH_DASH] = ACTIONS(1140),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_SQUOTE] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1140),
    [sym_float_literal] = ACTIONS(1140),
    [sym_hex_literal] = ACTIONS(1142),
    [sym_int_literal] = ACTIONS(1142),
    [sym_binary_literal] = ACTIONS(1142),
    [sym_octal_literal] = ACTIONS(1142),
    [sym_bigint_literal] = ACTIONS(1140),
    [sym_this] = ACTIONS(1142),
    [sym_super] = ACTIONS(1142),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [anon_sym_AT] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_public] = ACTIONS(1142),
    [anon_sym_private] = ACTIONS(1142),
    [anon_sym_protected] = ACTIONS(1142),
    [anon_sym_boolean] = ACTIONS(1142),
    [anon_sym_string] = ACTIONS(1142),
    [anon_sym_symbol] = ACTIONS(1142),
    [sym_readonly] = ACTIONS(1142),
    [sym__automatic_semicolon] = ACTIONS(1140),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(1144),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_export] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1146),
    [anon_sym_default] = ACTIONS(1146),
    [anon_sym_as] = ACTIONS(1146),
    [anon_sym_namespace] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_COMMA] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1146),
    [anon_sym_type] = ACTIONS(1146),
    [anon_sym_interface] = ACTIONS(1146),
    [anon_sym_declare] = ACTIONS(1146),
    [anon_sym_module] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1146),
    [anon_sym_import] = ACTIONS(1146),
    [anon_sym_const] = ACTIONS(1146),
    [anon_sym_enum] = ACTIONS(1146),
    [anon_sym_var] = ACTIONS(1146),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_BANG] = ACTIONS(1146),
    [anon_sym_else] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1146),
    [anon_sym_switch] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [anon_sym_await] = ACTIONS(1146),
    [anon_sym_in] = ACTIONS(1146),
    [anon_sym_of] = ACTIONS(1146),
    [anon_sym_while] = ACTIONS(1146),
    [anon_sym_do] = ACTIONS(1146),
    [anon_sym_try] = ACTIONS(1146),
    [anon_sym_with] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [anon_sym_debugger] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_throw] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1144),
    [anon_sym_case] = ACTIONS(1146),
    [anon_sym_yield] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1146),
    [anon_sym_async] = ACTIONS(1146),
    [anon_sym_function] = ACTIONS(1146),
    [anon_sym_abstract] = ACTIONS(1146),
    [anon_sym_get] = ACTIONS(1146),
    [anon_sym_set] = ACTIONS(1146),
    [anon_sym_QMARK] = ACTIONS(1146),
    [anon_sym_QMARK_DOT] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1144),
    [anon_sym_GT_GT] = ACTIONS(1146),
    [anon_sym_GT_GT_GT] = ACTIONS(1144),
    [anon_sym_LT_LT] = ACTIONS(1144),
    [anon_sym_AMP] = ACTIONS(1146),
    [anon_sym_CARET] = ACTIONS(1144),
    [anon_sym_PIPE] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_SLASH] = ACTIONS(1146),
    [anon_sym_PERCENT] = ACTIONS(1144),
    [anon_sym_STAR_STAR] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_LT_EQ] = ACTIONS(1144),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_GT_EQ] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1146),
    [anon_sym_QMARK_QMARK] = ACTIONS(1144),
    [anon_sym_instanceof] = ACTIONS(1146),
    [anon_sym_TILDE] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1146),
    [anon_sym_delete] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1144),
    [anon_sym_DASH_DASH] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1144),
    [sym_float_literal] = ACTIONS(1144),
    [sym_hex_literal] = ACTIONS(1146),
    [sym_int_literal] = ACTIONS(1146),
    [sym_binary_literal] = ACTIONS(1146),
    [sym_octal_literal] = ACTIONS(1146),
    [sym_bigint_literal] = ACTIONS(1144),
    [sym_this] = ACTIONS(1146),
    [sym_super] = ACTIONS(1146),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_null] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1144),
    [anon_sym_static] = ACTIONS(1146),
    [anon_sym_public] = ACTIONS(1146),
    [anon_sym_private] = ACTIONS(1146),
    [anon_sym_protected] = ACTIONS(1146),
    [anon_sym_boolean] = ACTIONS(1146),
    [anon_sym_string] = ACTIONS(1146),
    [anon_sym_symbol] = ACTIONS(1146),
    [sym_readonly] = ACTIONS(1146),
    [sym__automatic_semicolon] = ACTIONS(1144),
  },
  [99] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1321),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [100] = {
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_STAR] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(1156),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(1158),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1160),
    [anon_sym_EQ_GT] = ACTIONS(1162),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_QMARK_DOT] = ACTIONS(1164),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(932),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(500),
    [anon_sym_string] = ACTIONS(500),
    [anon_sym_symbol] = ACTIONS(500),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(934),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [101] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2773),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2775),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1166),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [102] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2784),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2784),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1168),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [103] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [104] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1170),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [105] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1172),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [106] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2910),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2911),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1174),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [107] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1176),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [108] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2773),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2775),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1178),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [109] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3315),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2305),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(1180),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(1182),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_symbol] = ACTIONS(432),
    [sym_readonly] = ACTIONS(1184),
  },
  [110] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1528),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3241),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1186),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [111] = {
    [sym_import] = STATE(1601),
    [sym_expression_statement] = STATE(141),
    [sym_variable_declaration] = STATE(141),
    [sym_lexical_declaration] = STATE(141),
    [sym_empty_statement] = STATE(141),
    [sym_parenthesized_expression] = STATE(984),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1676),
    [sym_array] = STATE(1677),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(990),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(984),
    [sym_subscript_expression] = STATE(984),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1188),
    [anon_sym_export] = ACTIONS(1190),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1190),
    [anon_sym_declare] = ACTIONS(1190),
    [anon_sym_module] = ACTIONS(1190),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_const] = ACTIONS(1194),
    [anon_sym_var] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(1190),
    [anon_sym_set] = ACTIONS(1190),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1190),
    [anon_sym_public] = ACTIONS(1190),
    [anon_sym_private] = ACTIONS(1190),
    [anon_sym_protected] = ACTIONS(1190),
    [anon_sym_boolean] = ACTIONS(1190),
    [anon_sym_string] = ACTIONS(1190),
    [anon_sym_symbol] = ACTIONS(1190),
    [sym_readonly] = ACTIONS(1190),
  },
  [112] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1409),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2784),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2784),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1200),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [113] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1409),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1186),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [114] = {
    [sym_import] = STATE(1601),
    [sym_expression_statement] = STATE(142),
    [sym_variable_declaration] = STATE(142),
    [sym_lexical_declaration] = STATE(142),
    [sym_empty_statement] = STATE(142),
    [sym_parenthesized_expression] = STATE(984),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1676),
    [sym_array] = STATE(1677),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(990),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(984),
    [sym_subscript_expression] = STATE(984),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1188),
    [anon_sym_export] = ACTIONS(1190),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1190),
    [anon_sym_declare] = ACTIONS(1190),
    [anon_sym_module] = ACTIONS(1190),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_const] = ACTIONS(1194),
    [anon_sym_var] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1198),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(1190),
    [anon_sym_set] = ACTIONS(1190),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1190),
    [anon_sym_public] = ACTIONS(1190),
    [anon_sym_private] = ACTIONS(1190),
    [anon_sym_protected] = ACTIONS(1190),
    [anon_sym_boolean] = ACTIONS(1190),
    [anon_sym_string] = ACTIONS(1190),
    [anon_sym_symbol] = ACTIONS(1190),
    [sym_readonly] = ACTIONS(1190),
  },
  [115] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3226),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2305),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(1180),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(1182),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_symbol] = ACTIONS(432),
    [sym_readonly] = ACTIONS(1184),
  },
  [116] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1431),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3329),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_labeled_tuple_type_member] = STATE(2868),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2866),
    [sym_rest_identifier] = STATE(2652),
    [sym__tuple_type_member] = STATE(2868),
    [sym__tuple_type_identifier] = STATE(2652),
    [sym_optional_identifier] = STATE(2652),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1186),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [117] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1624),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3395),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(2305),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(1883),
    [sym_identifier] = ACTIONS(1180),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(1182),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_symbol] = ACTIONS(432),
    [sym_readonly] = ACTIONS(1184),
  },
  [118] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_SEMI] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1202),
    [sym_readonly] = ACTIONS(628),
    [sym__automatic_semicolon] = ACTIONS(1202),
  },
  [119] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1202),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [120] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1290),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [121] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1321),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [122] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1400),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_mapped_type_clause] = STATE(3246),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_export] = ACTIONS(1210),
    [anon_sym_namespace] = ACTIONS(1212),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(1210),
    [anon_sym_declare] = ACTIONS(1210),
    [anon_sym_module] = ACTIONS(1210),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1210),
    [anon_sym_set] = ACTIONS(1210),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1210),
    [anon_sym_public] = ACTIONS(1210),
    [anon_sym_private] = ACTIONS(1210),
    [anon_sym_protected] = ACTIONS(1210),
    [anon_sym_boolean] = ACTIONS(1210),
    [anon_sym_string] = ACTIONS(1210),
    [anon_sym_symbol] = ACTIONS(1210),
    [sym_readonly] = ACTIONS(1210),
  },
  [123] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1494),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [124] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2910),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2911),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1216),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [125] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2882),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1218),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [126] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1384),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2773),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2775),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1220),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [127] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [128] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2795),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2796),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1222),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [129] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2773),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2775),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1220),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [130] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2819),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2821),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1224),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [131] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1366),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2838),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1226),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1226),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [132] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [133] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [134] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1564),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [135] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1398),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2848),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [136] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2896),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2897),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [137] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2889),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2895),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [138] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1232),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [139] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1381),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [140] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1480),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2838),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(2628),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(1226),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [141] = {
    [sym_import] = STATE(1601),
    [sym_expression_statement] = STATE(160),
    [sym_empty_statement] = STATE(160),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [142] = {
    [sym_import] = STATE(1601),
    [sym_expression_statement] = STATE(161),
    [sym_empty_statement] = STATE(161),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(2971),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [143] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [144] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_nested_identifier] = STATE(2053),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_nested_type_identifier] = STATE(3044),
    [sym_generic_type] = STATE(2078),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [145] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [146] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_nested_identifier] = STATE(3209),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_nested_type_identifier] = STATE(2488),
    [sym_generic_type] = STATE(2747),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [147] = {
    [sym_export_clause] = STATE(2645),
    [sym__declaration] = STATE(581),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [aux_sym_object_repeat1] = STATE(2924),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [148] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1576),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [149] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(1299),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [150] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [151] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(3017),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
    [sym__automatic_semicolon] = ACTIONS(1303),
  },
  [152] = {
    [sym_export_clause] = STATE(2645),
    [sym__declaration] = STATE(581),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [aux_sym_object_repeat1] = STATE(2803),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [153] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1255),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_nested_type_identifier] = STATE(2306),
    [sym_generic_type] = STATE(2617),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1307),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [154] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1309),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [155] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1014),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1862),
    [sym_array] = STATE(1863),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1015),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(1014),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1313),
    [anon_sym_namespace] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1313),
    [anon_sym_declare] = ACTIONS(1313),
    [anon_sym_module] = ACTIONS(1313),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_var] = ACTIONS(1317),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1313),
    [anon_sym_set] = ACTIONS(1313),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_public] = ACTIONS(1313),
    [anon_sym_private] = ACTIONS(1313),
    [anon_sym_protected] = ACTIONS(1313),
    [anon_sym_boolean] = ACTIONS(1313),
    [anon_sym_string] = ACTIONS(1313),
    [anon_sym_symbol] = ACTIONS(1313),
    [sym_readonly] = ACTIONS(1313),
  },
  [156] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1434),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_nested_identifier] = STATE(2005),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_nested_type_identifier] = STATE(3095),
    [sym_generic_type] = STATE(435),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [157] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_nested_identifier] = STATE(3285),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_nested_type_identifier] = STATE(2584),
    [sym_generic_type] = STATE(2917),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [158] = {
    [sym_export_clause] = STATE(2645),
    [sym__declaration] = STATE(581),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [aux_sym_object_repeat1] = STATE(2768),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [159] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_nested_identifier] = STATE(3209),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_nested_type_identifier] = STATE(2269),
    [sym_generic_type] = STATE(2635),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [160] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1415),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3245),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1329),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [161] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1587),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3214),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1331),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [162] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1423),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3215),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [163] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1707),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [164] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1735),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [165] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1733),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [166] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1180),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1443),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [167] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1707),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1408),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [168] = {
    [sym_import] = STATE(1792),
    [sym_statement_block] = STATE(1790),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [169] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1580),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3200),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [170] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1567),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3197),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [171] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1561),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3190),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [172] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1769),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_mapped_type_clause] = STATE(3246),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_export] = ACTIONS(1341),
    [anon_sym_namespace] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1341),
    [anon_sym_declare] = ACTIONS(1341),
    [anon_sym_module] = ACTIONS(1341),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1345),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1341),
    [anon_sym_set] = ACTIONS(1341),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_public] = ACTIONS(1341),
    [anon_sym_private] = ACTIONS(1341),
    [anon_sym_protected] = ACTIONS(1341),
    [anon_sym_boolean] = ACTIONS(1341),
    [anon_sym_string] = ACTIONS(1341),
    [anon_sym_symbol] = ACTIONS(1341),
    [sym_readonly] = ACTIONS(1341),
  },
  [173] = {
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [aux_sym_object_repeat1] = STATE(2924),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [174] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1353),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_declare] = ACTIONS(1355),
    [anon_sym_module] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1355),
    [anon_sym_set] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_public] = ACTIONS(1355),
    [anon_sym_private] = ACTIONS(1355),
    [anon_sym_protected] = ACTIONS(1355),
    [anon_sym_boolean] = ACTIONS(1355),
    [anon_sym_string] = ACTIONS(1355),
    [anon_sym_symbol] = ACTIONS(1355),
    [sym_readonly] = ACTIONS(1355),
  },
  [175] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1243),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1582),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [176] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym__number_lit] = STATE(2092),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1367),
    [sym_hex_literal] = ACTIONS(1369),
    [sym_int_literal] = ACTIONS(1369),
    [sym_binary_literal] = ACTIONS(1369),
    [sym_octal_literal] = ACTIONS(1369),
    [sym_bigint_literal] = ACTIONS(1367),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [177] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1498),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3181),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [178] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1262),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1081),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [179] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2392),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2975),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1373),
    [anon_sym_namespace] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1373),
    [anon_sym_declare] = ACTIONS(1373),
    [anon_sym_module] = ACTIONS(1373),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1379),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1373),
    [anon_sym_set] = ACTIONS(1373),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_public] = ACTIONS(1373),
    [anon_sym_private] = ACTIONS(1373),
    [anon_sym_protected] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [sym_readonly] = ACTIONS(1373),
  },
  [180] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1262),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1546),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [181] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1244),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [182] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1168),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1466),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [183] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1272),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [184] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1168),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [185] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1272),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1519),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [186] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(1381),
    [sym_hex_literal] = ACTIONS(1383),
    [sym_int_literal] = ACTIONS(1383),
    [sym_binary_literal] = ACTIONS(1383),
    [sym_octal_literal] = ACTIONS(1383),
    [sym_bigint_literal] = ACTIONS(1381),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [187] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1244),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1512),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [188] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(903),
    [sym__expression] = STATE(1831),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1278),
    [sym_array] = STATE(1282),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(903),
    [sym_subscript_expression] = STATE(903),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1310),
    [sym_char] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2392),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2975),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_export] = ACTIONS(1387),
    [anon_sym_namespace] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1387),
    [anon_sym_declare] = ACTIONS(1387),
    [anon_sym_module] = ACTIONS(1387),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(1387),
    [anon_sym_set] = ACTIONS(1387),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(1395),
    [sym_hex_literal] = ACTIONS(1397),
    [sym_int_literal] = ACTIONS(1397),
    [sym_binary_literal] = ACTIONS(1397),
    [sym_octal_literal] = ACTIONS(1397),
    [sym_bigint_literal] = ACTIONS(1395),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1387),
    [anon_sym_public] = ACTIONS(1387),
    [anon_sym_private] = ACTIONS(1387),
    [anon_sym_protected] = ACTIONS(1387),
    [anon_sym_boolean] = ACTIONS(1387),
    [anon_sym_string] = ACTIONS(1387),
    [anon_sym_symbol] = ACTIONS(1387),
    [sym_readonly] = ACTIONS(1387),
  },
  [189] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2392),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2975),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1353),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_declare] = ACTIONS(1355),
    [anon_sym_module] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1355),
    [anon_sym_set] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_public] = ACTIONS(1355),
    [anon_sym_private] = ACTIONS(1355),
    [anon_sym_protected] = ACTIONS(1355),
    [anon_sym_boolean] = ACTIONS(1355),
    [anon_sym_string] = ACTIONS(1355),
    [anon_sym_symbol] = ACTIONS(1355),
    [sym_readonly] = ACTIONS(1355),
  },
  [190] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(3018),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [191] = {
    [sym_import] = STATE(1792),
    [sym_statement_block] = STATE(1777),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1313),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [192] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(2628),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [193] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1243),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [194] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(903),
    [sym__expression] = STATE(1831),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1278),
    [sym_array] = STATE(1282),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(903),
    [sym_subscript_expression] = STATE(903),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1310),
    [sym_char] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_export] = ACTIONS(1387),
    [anon_sym_namespace] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1387),
    [anon_sym_declare] = ACTIONS(1387),
    [anon_sym_module] = ACTIONS(1387),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(1387),
    [anon_sym_set] = ACTIONS(1387),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(1395),
    [sym_hex_literal] = ACTIONS(1397),
    [sym_int_literal] = ACTIONS(1397),
    [sym_binary_literal] = ACTIONS(1397),
    [sym_octal_literal] = ACTIONS(1397),
    [sym_bigint_literal] = ACTIONS(1395),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1387),
    [anon_sym_public] = ACTIONS(1387),
    [anon_sym_private] = ACTIONS(1387),
    [anon_sym_protected] = ACTIONS(1387),
    [anon_sym_boolean] = ACTIONS(1387),
    [anon_sym_string] = ACTIONS(1387),
    [anon_sym_symbol] = ACTIONS(1387),
    [sym_readonly] = ACTIONS(1387),
  },
  [195] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1493),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1399),
    [sym_hex_literal] = ACTIONS(1401),
    [sym_int_literal] = ACTIONS(1401),
    [sym_binary_literal] = ACTIONS(1401),
    [sym_octal_literal] = ACTIONS(1401),
    [sym_bigint_literal] = ACTIONS(1399),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [196] = {
    [sym_import] = STATE(1215),
    [sym_variable_declarator] = STATE(2683),
    [sym_parenthesized_expression] = STATE(1013),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1012),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_export] = ACTIONS(1405),
    [anon_sym_namespace] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1405),
    [anon_sym_declare] = ACTIONS(1405),
    [anon_sym_module] = ACTIONS(1405),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1405),
    [anon_sym_set] = ACTIONS(1405),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_public] = ACTIONS(1405),
    [anon_sym_private] = ACTIONS(1405),
    [anon_sym_protected] = ACTIONS(1405),
    [anon_sym_boolean] = ACTIONS(1405),
    [anon_sym_string] = ACTIONS(1405),
    [anon_sym_symbol] = ACTIONS(1405),
    [sym_readonly] = ACTIONS(1405),
  },
  [197] = {
    [sym_import] = STATE(1215),
    [sym_variable_declarator] = STATE(2681),
    [sym_parenthesized_expression] = STATE(1013),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1012),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_export] = ACTIONS(1405),
    [anon_sym_namespace] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1405),
    [anon_sym_declare] = ACTIONS(1405),
    [anon_sym_module] = ACTIONS(1405),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1405),
    [anon_sym_set] = ACTIONS(1405),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_public] = ACTIONS(1405),
    [anon_sym_private] = ACTIONS(1405),
    [anon_sym_protected] = ACTIONS(1405),
    [anon_sym_boolean] = ACTIONS(1405),
    [anon_sym_string] = ACTIONS(1405),
    [anon_sym_symbol] = ACTIONS(1405),
    [sym_readonly] = ACTIONS(1405),
  },
  [198] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1243),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [199] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2553),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2947),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1413),
    [anon_sym_namespace] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1413),
    [anon_sym_declare] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1413),
    [anon_sym_set] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_public] = ACTIONS(1413),
    [anon_sym_private] = ACTIONS(1413),
    [anon_sym_protected] = ACTIONS(1413),
    [anon_sym_boolean] = ACTIONS(1413),
    [anon_sym_string] = ACTIONS(1413),
    [anon_sym_symbol] = ACTIONS(1413),
    [sym_readonly] = ACTIONS(1413),
  },
  [200] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(903),
    [sym__expression] = STATE(1831),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1278),
    [sym_array] = STATE(1282),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(903),
    [sym_subscript_expression] = STATE(903),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1310),
    [sym_char] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2392),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2975),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1419),
    [anon_sym_export] = ACTIONS(1421),
    [anon_sym_namespace] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_declare] = ACTIONS(1421),
    [anon_sym_module] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1425),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(1421),
    [anon_sym_set] = ACTIONS(1421),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(1395),
    [sym_hex_literal] = ACTIONS(1397),
    [sym_int_literal] = ACTIONS(1397),
    [sym_binary_literal] = ACTIONS(1397),
    [sym_octal_literal] = ACTIONS(1397),
    [sym_bigint_literal] = ACTIONS(1395),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_public] = ACTIONS(1421),
    [anon_sym_private] = ACTIONS(1421),
    [anon_sym_protected] = ACTIONS(1421),
    [anon_sym_boolean] = ACTIONS(1421),
    [anon_sym_string] = ACTIONS(1421),
    [anon_sym_symbol] = ACTIONS(1421),
    [sym_readonly] = ACTIONS(1421),
  },
  [201] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3203),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [202] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1413),
    [anon_sym_namespace] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1413),
    [anon_sym_declare] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1413),
    [anon_sym_set] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_public] = ACTIONS(1413),
    [anon_sym_private] = ACTIONS(1413),
    [anon_sym_protected] = ACTIONS(1413),
    [anon_sym_boolean] = ACTIONS(1413),
    [anon_sym_string] = ACTIONS(1413),
    [anon_sym_symbol] = ACTIONS(1413),
    [sym_readonly] = ACTIONS(1413),
  },
  [203] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1427),
    [sym_hex_literal] = ACTIONS(1429),
    [sym_int_literal] = ACTIONS(1429),
    [sym_binary_literal] = ACTIONS(1429),
    [sym_octal_literal] = ACTIONS(1429),
    [sym_bigint_literal] = ACTIONS(1427),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [204] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1579),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3396),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [205] = {
    [sym_import] = STATE(1792),
    [sym_statement_block] = STATE(1783),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [206] = {
    [sym_import] = STATE(1792),
    [sym_statement_block] = STATE(1808),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [207] = {
    [sym_import] = STATE(1792),
    [sym_statement_block] = STATE(1778),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1380),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [208] = {
    [sym_import] = STATE(1792),
    [sym_statement_block] = STATE(1815),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1383),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [209] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3306),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [210] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1353),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_declare] = ACTIONS(1355),
    [anon_sym_module] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1355),
    [anon_sym_set] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_public] = ACTIONS(1355),
    [anon_sym_private] = ACTIONS(1355),
    [anon_sym_protected] = ACTIONS(1355),
    [anon_sym_boolean] = ACTIONS(1355),
    [anon_sym_string] = ACTIONS(1355),
    [anon_sym_symbol] = ACTIONS(1355),
    [sym_readonly] = ACTIONS(1355),
  },
  [211] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1736),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1424),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [212] = {
    [sym_export_clause] = STATE(2645),
    [sym__declaration] = STATE(581),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1433),
    [anon_sym_module] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1435),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [213] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1431),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3329),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [214] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1414),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3258),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [215] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3238),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [216] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1180),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1357),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [217] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1471),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3198),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [218] = {
    [sym_export_clause] = STATE(2645),
    [sym__declaration] = STATE(581),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [219] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1736),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [220] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1413),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3208),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [221] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1410),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3205),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [222] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1456),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3201),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [223] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1168),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1084),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [224] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1735),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1426),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [225] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1733),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1428),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [226] = {
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [aux_sym_object_repeat1] = STATE(2768),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [227] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1353),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_declare] = ACTIONS(1355),
    [anon_sym_module] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1361),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1355),
    [anon_sym_set] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_public] = ACTIONS(1355),
    [anon_sym_private] = ACTIONS(1355),
    [anon_sym_protected] = ACTIONS(1355),
    [anon_sym_boolean] = ACTIONS(1355),
    [anon_sym_string] = ACTIONS(1355),
    [anon_sym_symbol] = ACTIONS(1355),
    [sym_readonly] = ACTIONS(1355),
  },
  [228] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1262),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [229] = {
    [sym_import] = STATE(1530),
    [sym_parenthesized_expression] = STATE(916),
    [sym__expression] = STATE(1829),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1342),
    [sym_array] = STATE(1348),
    [sym_class] = STATE(1530),
    [sym_function] = STATE(1530),
    [sym_generator_function] = STATE(1530),
    [sym_arrow_function] = STATE(1530),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1530),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(916),
    [sym_subscript_expression] = STATE(916),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1530),
    [sym_char] = STATE(1530),
    [sym_template_string] = STATE(1530),
    [sym_regex] = STATE(1530),
    [sym_meta_property] = STATE(1530),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2392),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2975),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(1441),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1443),
    [anon_sym_declare] = ACTIONS(1443),
    [anon_sym_module] = ACTIONS(1443),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(1443),
    [anon_sym_set] = ACTIONS(1443),
    [anon_sym_new] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(1451),
    [sym_hex_literal] = ACTIONS(1453),
    [sym_int_literal] = ACTIONS(1453),
    [sym_binary_literal] = ACTIONS(1453),
    [sym_octal_literal] = ACTIONS(1453),
    [sym_bigint_literal] = ACTIONS(1451),
    [sym_this] = ACTIONS(1453),
    [sym_super] = ACTIONS(1453),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1443),
    [anon_sym_public] = ACTIONS(1443),
    [anon_sym_private] = ACTIONS(1443),
    [anon_sym_protected] = ACTIONS(1443),
    [anon_sym_boolean] = ACTIONS(1443),
    [anon_sym_string] = ACTIONS(1443),
    [anon_sym_symbol] = ACTIONS(1443),
    [sym_readonly] = ACTIONS(1443),
  },
  [230] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(1455),
    [sym_hex_literal] = ACTIONS(1457),
    [sym_int_literal] = ACTIONS(1457),
    [sym_binary_literal] = ACTIONS(1457),
    [sym_octal_literal] = ACTIONS(1457),
    [sym_bigint_literal] = ACTIONS(1455),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [231] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1588),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3241),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [232] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1373),
    [anon_sym_namespace] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1373),
    [anon_sym_declare] = ACTIONS(1373),
    [anon_sym_module] = ACTIONS(1373),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1379),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1373),
    [anon_sym_set] = ACTIONS(1373),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_public] = ACTIONS(1373),
    [anon_sym_private] = ACTIONS(1373),
    [anon_sym_protected] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [sym_readonly] = ACTIONS(1373),
  },
  [233] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1459),
    [sym_hex_literal] = ACTIONS(1461),
    [sym_int_literal] = ACTIONS(1461),
    [sym_binary_literal] = ACTIONS(1461),
    [sym_octal_literal] = ACTIONS(1461),
    [sym_bigint_literal] = ACTIONS(1459),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [234] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1272),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1060),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [235] = {
    [sym_import] = STATE(1530),
    [sym_parenthesized_expression] = STATE(916),
    [sym__expression] = STATE(1829),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1342),
    [sym_array] = STATE(1348),
    [sym_class] = STATE(1530),
    [sym_function] = STATE(1530),
    [sym_generator_function] = STATE(1530),
    [sym_arrow_function] = STATE(1530),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1530),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(916),
    [sym_subscript_expression] = STATE(916),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1530),
    [sym_char] = STATE(1530),
    [sym_template_string] = STATE(1530),
    [sym_regex] = STATE(1530),
    [sym_meta_property] = STATE(1530),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(1441),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_namespace] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1443),
    [anon_sym_declare] = ACTIONS(1443),
    [anon_sym_module] = ACTIONS(1443),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(1443),
    [anon_sym_set] = ACTIONS(1443),
    [anon_sym_new] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(1451),
    [sym_hex_literal] = ACTIONS(1453),
    [sym_int_literal] = ACTIONS(1453),
    [sym_binary_literal] = ACTIONS(1453),
    [sym_octal_literal] = ACTIONS(1453),
    [sym_bigint_literal] = ACTIONS(1451),
    [sym_this] = ACTIONS(1453),
    [sym_super] = ACTIONS(1453),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1443),
    [anon_sym_public] = ACTIONS(1443),
    [anon_sym_private] = ACTIONS(1443),
    [anon_sym_protected] = ACTIONS(1443),
    [anon_sym_boolean] = ACTIONS(1443),
    [anon_sym_string] = ACTIONS(1443),
    [anon_sym_symbol] = ACTIONS(1443),
    [sym_readonly] = ACTIONS(1443),
  },
  [236] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1528),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3241),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [237] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(903),
    [sym__expression] = STATE(1831),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1278),
    [sym_array] = STATE(1282),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(903),
    [sym_subscript_expression] = STATE(903),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1310),
    [sym_char] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1419),
    [anon_sym_export] = ACTIONS(1421),
    [anon_sym_namespace] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_declare] = ACTIONS(1421),
    [anon_sym_module] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(1425),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(1421),
    [anon_sym_set] = ACTIONS(1421),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(1395),
    [sym_hex_literal] = ACTIONS(1397),
    [sym_int_literal] = ACTIONS(1397),
    [sym_binary_literal] = ACTIONS(1397),
    [sym_octal_literal] = ACTIONS(1397),
    [sym_bigint_literal] = ACTIONS(1395),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_public] = ACTIONS(1421),
    [anon_sym_private] = ACTIONS(1421),
    [anon_sym_protected] = ACTIONS(1421),
    [anon_sym_boolean] = ACTIONS(1421),
    [anon_sym_string] = ACTIONS(1421),
    [anon_sym_symbol] = ACTIONS(1421),
    [sym_readonly] = ACTIONS(1421),
  },
  [238] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1652),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [239] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1565),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(1463),
    [sym_hex_literal] = ACTIONS(1465),
    [sym_int_literal] = ACTIONS(1465),
    [sym_binary_literal] = ACTIONS(1465),
    [sym_octal_literal] = ACTIONS(1465),
    [sym_bigint_literal] = ACTIONS(1463),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [240] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1578),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3310),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [241] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1592),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3240),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [242] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1244),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [243] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1586),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3305),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [244] = {
    [sym_import] = STATE(1215),
    [sym_statement_block] = STATE(1180),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [245] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym__number_lit] = STATE(429),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1427),
    [sym_hex_literal] = ACTIONS(1429),
    [sym_int_literal] = ACTIONS(1429),
    [sym_binary_literal] = ACTIONS(1429),
    [sym_octal_literal] = ACTIONS(1429),
    [sym_bigint_literal] = ACTIONS(1427),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [246] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(719),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1047),
    [sym_array] = STATE(1044),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(719),
    [sym_subscript_expression] = STATE(719),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1053),
    [sym_char] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2392),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2975),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1413),
    [anon_sym_namespace] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1413),
    [anon_sym_declare] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1377),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1413),
    [anon_sym_set] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(1363),
    [sym_hex_literal] = ACTIONS(1365),
    [sym_int_literal] = ACTIONS(1365),
    [sym_binary_literal] = ACTIONS(1365),
    [sym_octal_literal] = ACTIONS(1365),
    [sym_bigint_literal] = ACTIONS(1363),
    [sym_this] = ACTIONS(1365),
    [sym_super] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_public] = ACTIONS(1413),
    [anon_sym_private] = ACTIONS(1413),
    [anon_sym_protected] = ACTIONS(1413),
    [anon_sym_boolean] = ACTIONS(1413),
    [anon_sym_string] = ACTIONS(1413),
    [anon_sym_symbol] = ACTIONS(1413),
    [sym_readonly] = ACTIONS(1413),
  },
  [247] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1593),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3220),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [248] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1716),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1571),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [249] = {
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [aux_sym_object_repeat1] = STATE(2803),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [250] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1435),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [251] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1518),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3289),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [252] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1652),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1427),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [253] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1769),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_mapped_type_clause] = STATE(3385),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1467),
    [anon_sym_export] = ACTIONS(1469),
    [anon_sym_namespace] = ACTIONS(1471),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1469),
    [anon_sym_declare] = ACTIONS(1469),
    [anon_sym_module] = ACTIONS(1469),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1469),
    [anon_sym_set] = ACTIONS(1469),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_public] = ACTIONS(1469),
    [anon_sym_private] = ACTIONS(1469),
    [anon_sym_protected] = ACTIONS(1469),
    [anon_sym_boolean] = ACTIONS(1469),
    [anon_sym_string] = ACTIONS(1469),
    [anon_sym_symbol] = ACTIONS(1469),
    [sym_readonly] = ACTIONS(1469),
  },
  [254] = {
    [sym_import] = STATE(1601),
    [sym_statement_block] = STATE(1716),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1184),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [255] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1505),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3176),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [256] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_sequence_expression] = STATE(3053),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [257] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1409),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_sequence_expression] = STATE(3210),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [258] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1066),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [259] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1399),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [260] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1575),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [261] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [262] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1511),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [263] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [264] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1534),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [265] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1502),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [266] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1535),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [267] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1013),
    [sym__expression] = STATE(1813),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1864),
    [sym_array] = STATE(1861),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1012),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1475),
    [anon_sym_export] = ACTIONS(1405),
    [anon_sym_namespace] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(1405),
    [anon_sym_declare] = ACTIONS(1405),
    [anon_sym_module] = ACTIONS(1405),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(1409),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(1405),
    [anon_sym_set] = ACTIONS(1405),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_public] = ACTIONS(1405),
    [anon_sym_private] = ACTIONS(1405),
    [anon_sym_protected] = ACTIONS(1405),
    [anon_sym_boolean] = ACTIONS(1405),
    [anon_sym_string] = ACTIONS(1405),
    [anon_sym_symbol] = ACTIONS(1405),
    [sym_readonly] = ACTIONS(1405),
  },
  [268] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [269] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1529),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [270] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1577),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [271] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1198),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [272] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1465),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [273] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1558),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [274] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [275] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [276] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [277] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [278] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [279] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [280] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1712),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [281] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [282] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [283] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1192),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [284] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [285] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [286] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1175),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [287] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1559),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [288] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1402),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [289] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1594),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [290] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [291] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [292] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [293] = {
    [sym__call_signature] = STATE(3296),
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym_formal_parameters] = STATE(2305),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_object_repeat1] = STATE(2924),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1479),
    [anon_sym_declare] = ACTIONS(1479),
    [anon_sym_module] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(1490),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1479),
    [anon_sym_public] = ACTIONS(1479),
    [anon_sym_private] = ACTIONS(1479),
    [anon_sym_protected] = ACTIONS(1479),
    [anon_sym_boolean] = ACTIONS(1479),
    [anon_sym_string] = ACTIONS(1479),
    [anon_sym_symbol] = ACTIONS(1479),
    [sym_readonly] = ACTIONS(1479),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [294] = {
    [sym__call_signature] = STATE(3296),
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym_formal_parameters] = STATE(2305),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_object_repeat1] = STATE(2803),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1479),
    [anon_sym_declare] = ACTIONS(1479),
    [anon_sym_module] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(1490),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1479),
    [anon_sym_public] = ACTIONS(1479),
    [anon_sym_private] = ACTIONS(1479),
    [anon_sym_protected] = ACTIONS(1479),
    [anon_sym_boolean] = ACTIONS(1479),
    [anon_sym_string] = ACTIONS(1479),
    [anon_sym_symbol] = ACTIONS(1479),
    [sym_readonly] = ACTIONS(1479),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [295] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1406),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [296] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1569),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [297] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1045),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [298] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [299] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1045),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [300] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [301] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [302] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1585),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [303] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1385),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [304] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1501),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [305] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [306] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [307] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [308] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [309] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [310] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [311] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1769),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [312] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1495),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [313] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1573),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [314] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1566),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [315] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1562),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [316] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1080),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [317] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [318] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1560),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [319] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1499),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [320] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [321] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1564),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [322] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1495),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1502),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [323] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [324] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1493),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [325] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [326] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [327] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1565),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [328] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1557),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [329] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1494),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [330] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1554),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [331] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1570),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [332] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1504),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [333] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [334] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1553),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [335] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1572),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [336] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1576),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [337] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1722),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [338] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1552),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [339] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [340] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [341] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1543),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [342] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [343] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [344] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [345] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [346] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [347] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [348] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1059),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [349] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [350] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1111),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [351] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [352] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [353] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_export] = ACTIONS(1508),
    [anon_sym_default] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_namespace] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_COMMA] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1506),
    [anon_sym_typeof] = ACTIONS(1508),
    [anon_sym_type] = ACTIONS(1508),
    [anon_sym_interface] = ACTIONS(1508),
    [anon_sym_declare] = ACTIONS(1508),
    [anon_sym_module] = ACTIONS(1508),
    [anon_sym_DOT] = ACTIONS(1074),
    [anon_sym_COLON] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(1508),
    [anon_sym_const] = ACTIONS(1508),
    [anon_sym_enum] = ACTIONS(1508),
    [anon_sym_var] = ACTIONS(1508),
    [anon_sym_let] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_switch] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1506),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_do] = ACTIONS(1508),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1508),
    [anon_sym_break] = ACTIONS(1508),
    [anon_sym_continue] = ACTIONS(1508),
    [anon_sym_debugger] = ACTIONS(1508),
    [anon_sym_return] = ACTIONS(1508),
    [anon_sym_throw] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [anon_sym_RBRACK] = ACTIONS(1506),
    [anon_sym_class] = ACTIONS(1508),
    [anon_sym_async] = ACTIONS(1508),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ_GT] = ACTIONS(1506),
    [anon_sym_abstract] = ACTIONS(1508),
    [anon_sym_get] = ACTIONS(1508),
    [anon_sym_set] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_implements] = ACTIONS(1508),
    [anon_sym_extends] = ACTIONS(1508),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1508),
    [anon_sym_delete] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [sym_float_literal] = ACTIONS(1506),
    [sym_hex_literal] = ACTIONS(1508),
    [sym_int_literal] = ACTIONS(1508),
    [sym_binary_literal] = ACTIONS(1508),
    [sym_octal_literal] = ACTIONS(1508),
    [sym_bigint_literal] = ACTIONS(1506),
    [sym_this] = ACTIONS(1508),
    [sym_super] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [anon_sym_AT] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1508),
    [anon_sym_public] = ACTIONS(1508),
    [anon_sym_private] = ACTIONS(1508),
    [anon_sym_protected] = ACTIONS(1508),
    [anon_sym_boolean] = ACTIONS(1508),
    [anon_sym_string] = ACTIONS(1508),
    [anon_sym_symbol] = ACTIONS(1508),
    [sym_readonly] = ACTIONS(1508),
  },
  [355] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [356] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1754),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [357] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [358] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1172),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [359] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1126),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [360] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [361] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1556),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [362] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1170),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [363] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [364] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [365] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1171),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [366] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1590),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [367] = {
    [sym__call_signature] = STATE(3296),
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym_formal_parameters] = STATE(2305),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_object_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1479),
    [anon_sym_declare] = ACTIONS(1479),
    [anon_sym_module] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(1490),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1479),
    [anon_sym_public] = ACTIONS(1479),
    [anon_sym_private] = ACTIONS(1479),
    [anon_sym_protected] = ACTIONS(1479),
    [anon_sym_boolean] = ACTIONS(1479),
    [anon_sym_string] = ACTIONS(1479),
    [anon_sym_symbol] = ACTIONS(1479),
    [sym_readonly] = ACTIONS(1479),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [368] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1604),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [369] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1381),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [370] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [371] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [372] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [373] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [374] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1136),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [375] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1388),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [376] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [377] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [378] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1544),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [379] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [380] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [381] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [382] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [383] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1407),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [384] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1526),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [385] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1403),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [386] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [387] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [388] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [389] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [390] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [391] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [392] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [393] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1668),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [394] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [395] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [396] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1758),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [397] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [398] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1164),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [399] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [400] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [401] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1045),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [402] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1515),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [403] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(950),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1513),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(944),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3365),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(950),
    [sym_subscript_expression] = STATE(950),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2008),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(372),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_namespace] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(558),
    [anon_sym_declare] = ACTIONS(558),
    [anon_sym_module] = ACTIONS(558),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(558),
    [anon_sym_set] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(558),
    [anon_sym_public] = ACTIONS(558),
    [anon_sym_private] = ACTIONS(558),
    [anon_sym_protected] = ACTIONS(558),
    [anon_sym_boolean] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_symbol] = ACTIONS(558),
    [sym_readonly] = ACTIONS(558),
  },
  [404] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(935),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1374),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(924),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3257),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(935),
    [sym_subscript_expression] = STATE(935),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(299),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(628),
    [anon_sym_namespace] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_module] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_yield] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(628),
    [anon_sym_set] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_protected] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [sym_readonly] = ACTIONS(628),
  },
  [405] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1478),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [406] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1447),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [407] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1434),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [408] = {
    [sym_import] = STATE(1792),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1382),
    [sym_yield_expression] = STATE(1791),
    [sym_object] = STATE(1729),
    [sym_array] = STATE(1728),
    [sym_class] = STATE(1792),
    [sym_function] = STATE(1792),
    [sym_generator_function] = STATE(1792),
    [sym_arrow_function] = STATE(1792),
    [sym_as_expression] = STATE(1791),
    [sym_non_null_expression] = STATE(987),
    [sym_internal_module] = STATE(1791),
    [sym__call_signature] = STATE(3317),
    [sym_call_expression] = STATE(1792),
    [sym_new_expression] = STATE(1791),
    [sym_await_expression] = STATE(1791),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1791),
    [sym__augmented_assignment_lhs] = STATE(2011),
    [sym_augmented_assignment_expression] = STATE(1791),
    [sym_ternary_expression] = STATE(1791),
    [sym_binary_expression] = STATE(1791),
    [sym_unary_expression] = STATE(1791),
    [sym_update_expression] = STATE(1791),
    [sym_string] = STATE(1792),
    [sym_char] = STATE(1792),
    [sym_template_string] = STATE(1792),
    [sym_regex] = STATE(1792),
    [sym_meta_property] = STATE(1792),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1791),
    [sym_type_arguments] = STATE(375),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2689),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_namespace] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_typeof] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_declare] = ACTIONS(722),
    [anon_sym_module] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_await] = ACTIONS(736),
    [anon_sym_yield] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(742),
    [anon_sym_async] = ACTIONS(744),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(884),
    [anon_sym_DASH] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(756),
    [anon_sym_PLUS_PLUS] = ACTIONS(758),
    [anon_sym_DASH_DASH] = ACTIONS(758),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(764),
    [sym_float_literal] = ACTIONS(886),
    [sym_hex_literal] = ACTIONS(772),
    [sym_int_literal] = ACTIONS(772),
    [sym_binary_literal] = ACTIONS(772),
    [sym_octal_literal] = ACTIONS(772),
    [sym_bigint_literal] = ACTIONS(886),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(772),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_protected] = ACTIONS(722),
    [anon_sym_boolean] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_symbol] = ACTIONS(722),
    [sym_readonly] = ACTIONS(722),
  },
  [409] = {
    [sym_import] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1803),
    [sym_array] = STATE(1804),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_arrow_function] = STATE(1601),
    [sym_as_expression] = STATE(1603),
    [sym_non_null_expression] = STATE(1002),
    [sym_internal_module] = STATE(1603),
    [sym__call_signature] = STATE(3243),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1000),
    [sym_subscript_expression] = STATE(1000),
    [sym_assignment_expression] = STATE(1603),
    [sym__augmented_assignment_lhs] = STATE(2006),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1601),
    [sym_char] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1603),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_declare] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(524),
    [anon_sym_yield] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_void] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_float_literal] = ACTIONS(101),
    [sym_hex_literal] = ACTIONS(103),
    [sym_int_literal] = ACTIONS(103),
    [sym_binary_literal] = ACTIONS(103),
    [sym_octal_literal] = ACTIONS(103),
    [sym_bigint_literal] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_public] = ACTIONS(510),
    [anon_sym_private] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(510),
    [anon_sym_boolean] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_symbol] = ACTIONS(510),
    [sym_readonly] = ACTIONS(510),
  },
  [410] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(981),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1598),
    [sym_array] = STATE(1622),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(975),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3353),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(981),
    [sym_subscript_expression] = STATE(981),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2010),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(401),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_namespace] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(916),
    [anon_sym_type] = ACTIONS(586),
    [anon_sym_declare] = ACTIONS(586),
    [anon_sym_module] = ACTIONS(586),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(586),
    [anon_sym_set] = ACTIONS(586),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(612),
    [anon_sym_PLUS_PLUS] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(586),
    [anon_sym_public] = ACTIONS(586),
    [anon_sym_private] = ACTIONS(586),
    [anon_sym_protected] = ACTIONS(586),
    [anon_sym_boolean] = ACTIONS(586),
    [anon_sym_string] = ACTIONS(586),
    [anon_sym_symbol] = ACTIONS(586),
    [sym_readonly] = ACTIONS(586),
  },
  [411] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1510),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [412] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(999),
    [sym__expression] = STATE(1651),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1818),
    [sym_array] = STATE(1816),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1215),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym_as_expression] = STATE(1213),
    [sym_non_null_expression] = STATE(1001),
    [sym_internal_module] = STATE(1213),
    [sym__call_signature] = STATE(3189),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(999),
    [sym_subscript_expression] = STATE(999),
    [sym_assignment_expression] = STATE(1213),
    [sym__augmented_assignment_lhs] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1215),
    [sym_char] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1993),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_assertion] = STATE(1213),
    [sym_type_arguments] = STATE(297),
    [sym_type_parameters] = STATE(2972),
    [aux_sym_export_statement_repeat1] = STATE(2641),
    [sym_identifier] = ACTIONS(888),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_typeof] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(674),
    [anon_sym_module] = ACTIONS(674),
    [anon_sym_import] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_class] = ACTIONS(456),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_get] = ACTIONS(674),
    [anon_sym_set] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_void] = ACTIONS(696),
    [anon_sym_delete] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(486),
    [sym_float_literal] = ACTIONS(802),
    [sym_hex_literal] = ACTIONS(494),
    [sym_int_literal] = ACTIONS(494),
    [sym_binary_literal] = ACTIONS(494),
    [sym_octal_literal] = ACTIONS(494),
    [sym_bigint_literal] = ACTIONS(802),
    [sym_this] = ACTIONS(494),
    [sym_super] = ACTIONS(494),
    [sym_true] = ACTIONS(494),
    [sym_false] = ACTIONS(494),
    [sym_null] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(674),
    [anon_sym_public] = ACTIONS(674),
    [anon_sym_private] = ACTIONS(674),
    [anon_sym_protected] = ACTIONS(674),
    [anon_sym_boolean] = ACTIONS(674),
    [anon_sym_string] = ACTIONS(674),
    [anon_sym_symbol] = ACTIONS(674),
    [sym_readonly] = ACTIONS(674),
  },
  [413] = {
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(1512),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_export] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(1514),
    [anon_sym_namespace] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_COMMA] = ACTIONS(1512),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [anon_sym_typeof] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_interface] = ACTIONS(1514),
    [anon_sym_declare] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [anon_sym_COLON] = ACTIONS(1512),
    [anon_sym_import] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_var] = ACTIONS(1514),
    [anon_sym_let] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_else] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [anon_sym_RPAREN] = ACTIONS(1512),
    [anon_sym_await] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_try] = ACTIONS(1514),
    [anon_sym_with] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_debugger] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_throw] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_yield] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_function] = ACTIONS(1514),
    [anon_sym_EQ_GT] = ACTIONS(1512),
    [anon_sym_abstract] = ACTIONS(1514),
    [anon_sym_get] = ACTIONS(1514),
    [anon_sym_set] = ACTIONS(1514),
    [anon_sym_QMARK] = ACTIONS(1512),
    [anon_sym_implements] = ACTIONS(1514),
    [anon_sym_extends] = ACTIONS(1514),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_void] = ACTIONS(1514),
    [anon_sym_delete] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1512),
    [sym_float_literal] = ACTIONS(1512),
    [sym_hex_literal] = ACTIONS(1514),
    [sym_int_literal] = ACTIONS(1514),
    [sym_binary_literal] = ACTIONS(1514),
    [sym_octal_literal] = ACTIONS(1514),
    [sym_bigint_literal] = ACTIONS(1512),
    [sym_this] = ACTIONS(1514),
    [sym_super] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_null] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_public] = ACTIONS(1514),
    [anon_sym_private] = ACTIONS(1514),
    [anon_sym_protected] = ACTIONS(1514),
    [anon_sym_boolean] = ACTIONS(1514),
    [anon_sym_string] = ACTIONS(1514),
    [anon_sym_symbol] = ACTIONS(1514),
    [sym_readonly] = ACTIONS(1514),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(1516),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_export] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_EQ] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_COMMA] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_typeof] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_interface] = ACTIONS(1518),
    [anon_sym_declare] = ACTIONS(1518),
    [anon_sym_module] = ACTIONS(1518),
    [anon_sym_COLON] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_var] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_else] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [anon_sym_RPAREN] = ACTIONS(1516),
    [anon_sym_await] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_try] = ACTIONS(1518),
    [anon_sym_with] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_debugger] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_throw] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_yield] = ACTIONS(1518),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [anon_sym_RBRACK] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1518),
    [anon_sym_async] = ACTIONS(1518),
    [anon_sym_function] = ACTIONS(1518),
    [anon_sym_EQ_GT] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1518),
    [anon_sym_get] = ACTIONS(1518),
    [anon_sym_set] = ACTIONS(1518),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_implements] = ACTIONS(1518),
    [anon_sym_extends] = ACTIONS(1518),
    [anon_sym_new] = ACTIONS(1518),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_void] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1516),
    [sym_float_literal] = ACTIONS(1516),
    [sym_hex_literal] = ACTIONS(1518),
    [sym_int_literal] = ACTIONS(1518),
    [sym_binary_literal] = ACTIONS(1518),
    [sym_octal_literal] = ACTIONS(1518),
    [sym_bigint_literal] = ACTIONS(1516),
    [sym_this] = ACTIONS(1518),
    [sym_super] = ACTIONS(1518),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [sym_null] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_public] = ACTIONS(1518),
    [anon_sym_private] = ACTIONS(1518),
    [anon_sym_protected] = ACTIONS(1518),
    [anon_sym_boolean] = ACTIONS(1518),
    [anon_sym_string] = ACTIONS(1518),
    [anon_sym_symbol] = ACTIONS(1518),
    [sym_readonly] = ACTIONS(1518),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(1520),
    [sym_identifier] = ACTIONS(1522),
    [anon_sym_export] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(1522),
    [anon_sym_namespace] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_typeof] = ACTIONS(1522),
    [anon_sym_type] = ACTIONS(1522),
    [anon_sym_interface] = ACTIONS(1522),
    [anon_sym_declare] = ACTIONS(1522),
    [anon_sym_module] = ACTIONS(1522),
    [anon_sym_COLON] = ACTIONS(1520),
    [anon_sym_import] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_var] = ACTIONS(1522),
    [anon_sym_let] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_else] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_RPAREN] = ACTIONS(1520),
    [anon_sym_await] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_try] = ACTIONS(1522),
    [anon_sym_with] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_debugger] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_throw] = ACTIONS(1522),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_yield] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1520),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_class] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_function] = ACTIONS(1522),
    [anon_sym_EQ_GT] = ACTIONS(1520),
    [anon_sym_abstract] = ACTIONS(1522),
    [anon_sym_get] = ACTIONS(1522),
    [anon_sym_set] = ACTIONS(1522),
    [anon_sym_QMARK] = ACTIONS(1520),
    [anon_sym_implements] = ACTIONS(1522),
    [anon_sym_extends] = ACTIONS(1522),
    [anon_sym_new] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1520),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_void] = ACTIONS(1522),
    [anon_sym_delete] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [sym_float_literal] = ACTIONS(1520),
    [sym_hex_literal] = ACTIONS(1522),
    [sym_int_literal] = ACTIONS(1522),
    [sym_binary_literal] = ACTIONS(1522),
    [sym_octal_literal] = ACTIONS(1522),
    [sym_bigint_literal] = ACTIONS(1520),
    [sym_this] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [sym_null] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1520),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_public] = ACTIONS(1522),
    [anon_sym_private] = ACTIONS(1522),
    [anon_sym_protected] = ACTIONS(1522),
    [anon_sym_boolean] = ACTIONS(1522),
    [anon_sym_string] = ACTIONS(1522),
    [anon_sym_symbol] = ACTIONS(1522),
    [sym_readonly] = ACTIONS(1522),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(1524),
    [sym_identifier] = ACTIONS(1526),
    [anon_sym_export] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_namespace] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_COMMA] = ACTIONS(1524),
    [anon_sym_RBRACE] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1526),
    [anon_sym_interface] = ACTIONS(1526),
    [anon_sym_declare] = ACTIONS(1526),
    [anon_sym_module] = ACTIONS(1526),
    [anon_sym_COLON] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_var] = ACTIONS(1526),
    [anon_sym_let] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_await] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_try] = ACTIONS(1526),
    [anon_sym_with] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_debugger] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_throw] = ACTIONS(1526),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_yield] = ACTIONS(1526),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_function] = ACTIONS(1526),
    [anon_sym_EQ_GT] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1526),
    [anon_sym_get] = ACTIONS(1526),
    [anon_sym_set] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1524),
    [anon_sym_implements] = ACTIONS(1526),
    [anon_sym_extends] = ACTIONS(1526),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_SLASH] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_void] = ACTIONS(1526),
    [anon_sym_delete] = ACTIONS(1526),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [sym_float_literal] = ACTIONS(1524),
    [sym_hex_literal] = ACTIONS(1526),
    [sym_int_literal] = ACTIONS(1526),
    [sym_binary_literal] = ACTIONS(1526),
    [sym_octal_literal] = ACTIONS(1526),
    [sym_bigint_literal] = ACTIONS(1524),
    [sym_this] = ACTIONS(1526),
    [sym_super] = ACTIONS(1526),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [sym_null] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(1524),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_public] = ACTIONS(1526),
    [anon_sym_private] = ACTIONS(1526),
    [anon_sym_protected] = ACTIONS(1526),
    [anon_sym_boolean] = ACTIONS(1526),
    [anon_sym_string] = ACTIONS(1526),
    [anon_sym_symbol] = ACTIONS(1526),
    [sym_readonly] = ACTIONS(1526),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(1528),
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_export] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_EQ] = ACTIONS(1530),
    [anon_sym_namespace] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_COMMA] = ACTIONS(1528),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_typeof] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_interface] = ACTIONS(1530),
    [anon_sym_declare] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [anon_sym_COLON] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_var] = ACTIONS(1530),
    [anon_sym_let] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_else] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_RPAREN] = ACTIONS(1528),
    [anon_sym_await] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_debugger] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_throw] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(1528),
    [anon_sym_abstract] = ACTIONS(1530),
    [anon_sym_get] = ACTIONS(1530),
    [anon_sym_set] = ACTIONS(1530),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_implements] = ACTIONS(1530),
    [anon_sym_extends] = ACTIONS(1530),
    [anon_sym_new] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1530),
    [anon_sym_LT] = ACTIONS(1528),
    [anon_sym_GT] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_void] = ACTIONS(1530),
    [anon_sym_delete] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1528),
    [sym_float_literal] = ACTIONS(1528),
    [sym_hex_literal] = ACTIONS(1530),
    [sym_int_literal] = ACTIONS(1530),
    [sym_binary_literal] = ACTIONS(1530),
    [sym_octal_literal] = ACTIONS(1530),
    [sym_bigint_literal] = ACTIONS(1528),
    [sym_this] = ACTIONS(1530),
    [sym_super] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_null] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_public] = ACTIONS(1530),
    [anon_sym_private] = ACTIONS(1530),
    [anon_sym_protected] = ACTIONS(1530),
    [anon_sym_boolean] = ACTIONS(1530),
    [anon_sym_string] = ACTIONS(1530),
    [anon_sym_symbol] = ACTIONS(1530),
    [sym_readonly] = ACTIONS(1530),
  },
  [419] = {
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_ambient_declaration] = STATE(553),
    [sym_import_alias] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_lexical_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_generator_function_declaration] = STATE(553),
    [sym_module] = STATE(553),
    [sym_internal_module] = STATE(585),
    [sym_abstract_class_declaration] = STATE(553),
    [sym_function_signature] = STATE(553),
    [sym_decorator] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(2515),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_declare] = ACTIONS(1433),
    [anon_sym_global] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1435),
    [anon_sym_import] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1534),
    [sym_identifier] = ACTIONS(1536),
    [anon_sym_export] = ACTIONS(1536),
    [anon_sym_default] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1536),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_COMMA] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [anon_sym_typeof] = ACTIONS(1536),
    [anon_sym_type] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1536),
    [anon_sym_declare] = ACTIONS(1536),
    [anon_sym_module] = ACTIONS(1536),
    [anon_sym_COLON] = ACTIONS(1534),
    [anon_sym_import] = ACTIONS(1536),
    [anon_sym_const] = ACTIONS(1536),
    [anon_sym_enum] = ACTIONS(1536),
    [anon_sym_var] = ACTIONS(1536),
    [anon_sym_let] = ACTIONS(1536),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_else] = ACTIONS(1536),
    [anon_sym_if] = ACTIONS(1536),
    [anon_sym_switch] = ACTIONS(1536),
    [anon_sym_for] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_await] = ACTIONS(1536),
    [anon_sym_while] = ACTIONS(1536),
    [anon_sym_do] = ACTIONS(1536),
    [anon_sym_try] = ACTIONS(1536),
    [anon_sym_with] = ACTIONS(1536),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1536),
    [anon_sym_debugger] = ACTIONS(1536),
    [anon_sym_return] = ACTIONS(1536),
    [anon_sym_throw] = ACTIONS(1536),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_case] = ACTIONS(1536),
    [anon_sym_yield] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_RBRACK] = ACTIONS(1534),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_async] = ACTIONS(1536),
    [anon_sym_function] = ACTIONS(1536),
    [anon_sym_EQ_GT] = ACTIONS(1534),
    [anon_sym_abstract] = ACTIONS(1536),
    [anon_sym_get] = ACTIONS(1536),
    [anon_sym_set] = ACTIONS(1536),
    [anon_sym_QMARK] = ACTIONS(1534),
    [anon_sym_extends] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1534),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_void] = ACTIONS(1536),
    [anon_sym_delete] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [sym_float_literal] = ACTIONS(1534),
    [sym_hex_literal] = ACTIONS(1536),
    [sym_int_literal] = ACTIONS(1536),
    [sym_binary_literal] = ACTIONS(1536),
    [sym_octal_literal] = ACTIONS(1536),
    [sym_bigint_literal] = ACTIONS(1534),
    [sym_this] = ACTIONS(1536),
    [sym_super] = ACTIONS(1536),
    [sym_true] = ACTIONS(1536),
    [sym_false] = ACTIONS(1536),
    [sym_null] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(1534),
    [anon_sym_static] = ACTIONS(1536),
    [anon_sym_public] = ACTIONS(1536),
    [anon_sym_private] = ACTIONS(1536),
    [anon_sym_protected] = ACTIONS(1536),
    [anon_sym_boolean] = ACTIONS(1536),
    [anon_sym_string] = ACTIONS(1536),
    [anon_sym_symbol] = ACTIONS(1536),
    [sym_readonly] = ACTIONS(1536),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(1538),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_export] = ACTIONS(1540),
    [anon_sym_default] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_namespace] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1538),
    [anon_sym_COMMA] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_type] = ACTIONS(1540),
    [anon_sym_interface] = ACTIONS(1540),
    [anon_sym_declare] = ACTIONS(1540),
    [anon_sym_module] = ACTIONS(1540),
    [anon_sym_COLON] = ACTIONS(1538),
    [anon_sym_import] = ACTIONS(1540),
    [anon_sym_const] = ACTIONS(1540),
    [anon_sym_enum] = ACTIONS(1540),
    [anon_sym_var] = ACTIONS(1540),
    [anon_sym_let] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1538),
    [anon_sym_else] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1540),
    [anon_sym_switch] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_await] = ACTIONS(1540),
    [anon_sym_while] = ACTIONS(1540),
    [anon_sym_do] = ACTIONS(1540),
    [anon_sym_try] = ACTIONS(1540),
    [anon_sym_with] = ACTIONS(1540),
    [anon_sym_break] = ACTIONS(1540),
    [anon_sym_continue] = ACTIONS(1540),
    [anon_sym_debugger] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1540),
    [anon_sym_throw] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1538),
    [anon_sym_case] = ACTIONS(1540),
    [anon_sym_yield] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_class] = ACTIONS(1540),
    [anon_sym_async] = ACTIONS(1540),
    [anon_sym_function] = ACTIONS(1540),
    [anon_sym_EQ_GT] = ACTIONS(1538),
    [anon_sym_abstract] = ACTIONS(1540),
    [anon_sym_get] = ACTIONS(1540),
    [anon_sym_set] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1538),
    [anon_sym_extends] = ACTIONS(1540),
    [anon_sym_new] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_TILDE] = ACTIONS(1538),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1538),
    [anon_sym_DASH_DASH] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [anon_sym_SQUOTE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [sym_float_literal] = ACTIONS(1538),
    [sym_hex_literal] = ACTIONS(1540),
    [sym_int_literal] = ACTIONS(1540),
    [sym_binary_literal] = ACTIONS(1540),
    [sym_octal_literal] = ACTIONS(1540),
    [sym_bigint_literal] = ACTIONS(1538),
    [sym_this] = ACTIONS(1540),
    [sym_super] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_null] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1538),
    [anon_sym_static] = ACTIONS(1540),
    [anon_sym_public] = ACTIONS(1540),
    [anon_sym_private] = ACTIONS(1540),
    [anon_sym_protected] = ACTIONS(1540),
    [anon_sym_boolean] = ACTIONS(1540),
    [anon_sym_string] = ACTIONS(1540),
    [anon_sym_symbol] = ACTIONS(1540),
    [sym_readonly] = ACTIONS(1540),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_export] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1544),
    [anon_sym_EQ] = ACTIONS(1544),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_typeof] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1544),
    [anon_sym_declare] = ACTIONS(1544),
    [anon_sym_module] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_import] = ACTIONS(1544),
    [anon_sym_const] = ACTIONS(1544),
    [anon_sym_enum] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1544),
    [anon_sym_with] = ACTIONS(1544),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1544),
    [anon_sym_debugger] = ACTIONS(1544),
    [anon_sym_return] = ACTIONS(1544),
    [anon_sym_throw] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_case] = ACTIONS(1544),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_RBRACK] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(1544),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_abstract] = ACTIONS(1544),
    [anon_sym_get] = ACTIONS(1544),
    [anon_sym_set] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1542),
    [anon_sym_extends] = ACTIONS(1544),
    [anon_sym_new] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_void] = ACTIONS(1544),
    [anon_sym_delete] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_float_literal] = ACTIONS(1542),
    [sym_hex_literal] = ACTIONS(1544),
    [sym_int_literal] = ACTIONS(1544),
    [sym_binary_literal] = ACTIONS(1544),
    [sym_octal_literal] = ACTIONS(1544),
    [sym_bigint_literal] = ACTIONS(1542),
    [sym_this] = ACTIONS(1544),
    [sym_super] = ACTIONS(1544),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_static] = ACTIONS(1544),
    [anon_sym_public] = ACTIONS(1544),
    [anon_sym_private] = ACTIONS(1544),
    [anon_sym_protected] = ACTIONS(1544),
    [anon_sym_boolean] = ACTIONS(1544),
    [anon_sym_string] = ACTIONS(1544),
    [anon_sym_symbol] = ACTIONS(1544),
    [sym_readonly] = ACTIONS(1544),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(1546),
    [sym_identifier] = ACTIONS(1548),
    [anon_sym_export] = ACTIONS(1548),
    [anon_sym_default] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1548),
    [anon_sym_namespace] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1546),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [anon_sym_typeof] = ACTIONS(1548),
    [anon_sym_type] = ACTIONS(1548),
    [anon_sym_interface] = ACTIONS(1548),
    [anon_sym_declare] = ACTIONS(1548),
    [anon_sym_module] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_import] = ACTIONS(1548),
    [anon_sym_const] = ACTIONS(1548),
    [anon_sym_enum] = ACTIONS(1548),
    [anon_sym_var] = ACTIONS(1548),
    [anon_sym_let] = ACTIONS(1548),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_else] = ACTIONS(1548),
    [anon_sym_if] = ACTIONS(1548),
    [anon_sym_switch] = ACTIONS(1548),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_RPAREN] = ACTIONS(1546),
    [anon_sym_await] = ACTIONS(1548),
    [anon_sym_while] = ACTIONS(1548),
    [anon_sym_do] = ACTIONS(1548),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_with] = ACTIONS(1548),
    [anon_sym_break] = ACTIONS(1548),
    [anon_sym_continue] = ACTIONS(1548),
    [anon_sym_debugger] = ACTIONS(1548),
    [anon_sym_return] = ACTIONS(1548),
    [anon_sym_throw] = ACTIONS(1548),
    [anon_sym_SEMI] = ACTIONS(1546),
    [anon_sym_case] = ACTIONS(1548),
    [anon_sym_yield] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_RBRACK] = ACTIONS(1546),
    [anon_sym_class] = ACTIONS(1548),
    [anon_sym_async] = ACTIONS(1548),
    [anon_sym_function] = ACTIONS(1548),
    [anon_sym_EQ_GT] = ACTIONS(1546),
    [anon_sym_abstract] = ACTIONS(1548),
    [anon_sym_get] = ACTIONS(1548),
    [anon_sym_set] = ACTIONS(1548),
    [anon_sym_QMARK] = ACTIONS(1546),
    [anon_sym_extends] = ACTIONS(1548),
    [anon_sym_new] = ACTIONS(1548),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_TILDE] = ACTIONS(1546),
    [anon_sym_void] = ACTIONS(1548),
    [anon_sym_delete] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1546),
    [anon_sym_DASH_DASH] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(1546),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1546),
    [sym_float_literal] = ACTIONS(1546),
    [sym_hex_literal] = ACTIONS(1548),
    [sym_int_literal] = ACTIONS(1548),
    [sym_binary_literal] = ACTIONS(1548),
    [sym_octal_literal] = ACTIONS(1548),
    [sym_bigint_literal] = ACTIONS(1546),
    [sym_this] = ACTIONS(1548),
    [sym_super] = ACTIONS(1548),
    [sym_true] = ACTIONS(1548),
    [sym_false] = ACTIONS(1548),
    [sym_null] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1548),
    [anon_sym_public] = ACTIONS(1548),
    [anon_sym_private] = ACTIONS(1548),
    [anon_sym_protected] = ACTIONS(1548),
    [anon_sym_boolean] = ACTIONS(1548),
    [anon_sym_string] = ACTIONS(1548),
    [anon_sym_symbol] = ACTIONS(1548),
    [sym_readonly] = ACTIONS(1548),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1550),
    [sym_identifier] = ACTIONS(1552),
    [anon_sym_export] = ACTIONS(1552),
    [anon_sym_default] = ACTIONS(1552),
    [anon_sym_EQ] = ACTIONS(1552),
    [anon_sym_namespace] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1550),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(1552),
    [anon_sym_type] = ACTIONS(1552),
    [anon_sym_interface] = ACTIONS(1552),
    [anon_sym_declare] = ACTIONS(1552),
    [anon_sym_module] = ACTIONS(1552),
    [anon_sym_COLON] = ACTIONS(1550),
    [anon_sym_import] = ACTIONS(1552),
    [anon_sym_const] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(1552),
    [anon_sym_var] = ACTIONS(1552),
    [anon_sym_let] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1550),
    [anon_sym_else] = ACTIONS(1552),
    [anon_sym_if] = ACTIONS(1552),
    [anon_sym_switch] = ACTIONS(1552),
    [anon_sym_for] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_await] = ACTIONS(1552),
    [anon_sym_while] = ACTIONS(1552),
    [anon_sym_do] = ACTIONS(1552),
    [anon_sym_try] = ACTIONS(1552),
    [anon_sym_with] = ACTIONS(1552),
    [anon_sym_break] = ACTIONS(1552),
    [anon_sym_continue] = ACTIONS(1552),
    [anon_sym_debugger] = ACTIONS(1552),
    [anon_sym_return] = ACTIONS(1552),
    [anon_sym_throw] = ACTIONS(1552),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_case] = ACTIONS(1552),
    [anon_sym_yield] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_class] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1552),
    [anon_sym_EQ_GT] = ACTIONS(1550),
    [anon_sym_abstract] = ACTIONS(1552),
    [anon_sym_get] = ACTIONS(1552),
    [anon_sym_set] = ACTIONS(1552),
    [anon_sym_QMARK] = ACTIONS(1550),
    [anon_sym_extends] = ACTIONS(1552),
    [anon_sym_new] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_TILDE] = ACTIONS(1550),
    [anon_sym_void] = ACTIONS(1552),
    [anon_sym_delete] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1550),
    [anon_sym_DASH_DASH] = ACTIONS(1550),
    [anon_sym_DQUOTE] = ACTIONS(1550),
    [anon_sym_SQUOTE] = ACTIONS(1550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [sym_float_literal] = ACTIONS(1550),
    [sym_hex_literal] = ACTIONS(1552),
    [sym_int_literal] = ACTIONS(1552),
    [sym_binary_literal] = ACTIONS(1552),
    [sym_octal_literal] = ACTIONS(1552),
    [sym_bigint_literal] = ACTIONS(1550),
    [sym_this] = ACTIONS(1552),
    [sym_super] = ACTIONS(1552),
    [sym_true] = ACTIONS(1552),
    [sym_false] = ACTIONS(1552),
    [sym_null] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(1550),
    [anon_sym_static] = ACTIONS(1552),
    [anon_sym_public] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1552),
    [anon_sym_protected] = ACTIONS(1552),
    [anon_sym_boolean] = ACTIONS(1552),
    [anon_sym_string] = ACTIONS(1552),
    [anon_sym_symbol] = ACTIONS(1552),
    [sym_readonly] = ACTIONS(1552),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_export] = ACTIONS(1556),
    [anon_sym_default] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1556),
    [anon_sym_namespace] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_COMMA] = ACTIONS(1554),
    [anon_sym_RBRACE] = ACTIONS(1554),
    [anon_sym_typeof] = ACTIONS(1556),
    [anon_sym_type] = ACTIONS(1556),
    [anon_sym_interface] = ACTIONS(1556),
    [anon_sym_declare] = ACTIONS(1556),
    [anon_sym_module] = ACTIONS(1556),
    [anon_sym_COLON] = ACTIONS(1554),
    [anon_sym_import] = ACTIONS(1556),
    [anon_sym_const] = ACTIONS(1556),
    [anon_sym_enum] = ACTIONS(1556),
    [anon_sym_var] = ACTIONS(1556),
    [anon_sym_let] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1554),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_if] = ACTIONS(1556),
    [anon_sym_switch] = ACTIONS(1556),
    [anon_sym_for] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_RPAREN] = ACTIONS(1554),
    [anon_sym_await] = ACTIONS(1556),
    [anon_sym_while] = ACTIONS(1556),
    [anon_sym_do] = ACTIONS(1556),
    [anon_sym_try] = ACTIONS(1556),
    [anon_sym_with] = ACTIONS(1556),
    [anon_sym_break] = ACTIONS(1556),
    [anon_sym_continue] = ACTIONS(1556),
    [anon_sym_debugger] = ACTIONS(1556),
    [anon_sym_return] = ACTIONS(1556),
    [anon_sym_throw] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1554),
    [anon_sym_case] = ACTIONS(1556),
    [anon_sym_yield] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_RBRACK] = ACTIONS(1554),
    [anon_sym_class] = ACTIONS(1556),
    [anon_sym_async] = ACTIONS(1556),
    [anon_sym_function] = ACTIONS(1556),
    [anon_sym_EQ_GT] = ACTIONS(1554),
    [anon_sym_abstract] = ACTIONS(1556),
    [anon_sym_get] = ACTIONS(1556),
    [anon_sym_set] = ACTIONS(1556),
    [anon_sym_QMARK] = ACTIONS(1554),
    [anon_sym_extends] = ACTIONS(1556),
    [anon_sym_new] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1554),
    [anon_sym_PIPE] = ACTIONS(1554),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1554),
    [anon_sym_GT] = ACTIONS(1554),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1556),
    [anon_sym_delete] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1554),
    [anon_sym_DASH_DASH] = ACTIONS(1554),
    [anon_sym_DQUOTE] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1554),
    [sym_float_literal] = ACTIONS(1554),
    [sym_hex_literal] = ACTIONS(1556),
    [sym_int_literal] = ACTIONS(1556),
    [sym_binary_literal] = ACTIONS(1556),
    [sym_octal_literal] = ACTIONS(1556),
    [sym_bigint_literal] = ACTIONS(1554),
    [sym_this] = ACTIONS(1556),
    [sym_super] = ACTIONS(1556),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1556),
    [anon_sym_public] = ACTIONS(1556),
    [anon_sym_private] = ACTIONS(1556),
    [anon_sym_protected] = ACTIONS(1556),
    [anon_sym_boolean] = ACTIONS(1556),
    [anon_sym_string] = ACTIONS(1556),
    [anon_sym_symbol] = ACTIONS(1556),
    [sym_readonly] = ACTIONS(1556),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_default] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1560),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_typeof] = ACTIONS(1560),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_interface] = ACTIONS(1560),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_COLON] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1560),
    [anon_sym_const] = ACTIONS(1560),
    [anon_sym_enum] = ACTIONS(1560),
    [anon_sym_var] = ACTIONS(1560),
    [anon_sym_let] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_else] = ACTIONS(1560),
    [anon_sym_if] = ACTIONS(1560),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_for] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1558),
    [anon_sym_RPAREN] = ACTIONS(1558),
    [anon_sym_await] = ACTIONS(1560),
    [anon_sym_while] = ACTIONS(1560),
    [anon_sym_do] = ACTIONS(1560),
    [anon_sym_try] = ACTIONS(1560),
    [anon_sym_with] = ACTIONS(1560),
    [anon_sym_break] = ACTIONS(1560),
    [anon_sym_continue] = ACTIONS(1560),
    [anon_sym_debugger] = ACTIONS(1560),
    [anon_sym_return] = ACTIONS(1560),
    [anon_sym_throw] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1558),
    [anon_sym_case] = ACTIONS(1560),
    [anon_sym_yield] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_RBRACK] = ACTIONS(1558),
    [anon_sym_class] = ACTIONS(1560),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_function] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(1558),
    [anon_sym_abstract] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1558),
    [anon_sym_extends] = ACTIONS(1560),
    [anon_sym_new] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_TILDE] = ACTIONS(1558),
    [anon_sym_void] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(1560),
    [anon_sym_PLUS_PLUS] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1558),
    [anon_sym_DQUOTE] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [sym_float_literal] = ACTIONS(1558),
    [sym_hex_literal] = ACTIONS(1560),
    [sym_int_literal] = ACTIONS(1560),
    [sym_binary_literal] = ACTIONS(1560),
    [sym_octal_literal] = ACTIONS(1560),
    [sym_bigint_literal] = ACTIONS(1558),
    [sym_this] = ACTIONS(1560),
    [sym_super] = ACTIONS(1560),
    [sym_true] = ACTIONS(1560),
    [sym_false] = ACTIONS(1560),
    [sym_null] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1558),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [sym_readonly] = ACTIONS(1560),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1562),
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_export] = ACTIONS(1564),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_EQ] = ACTIONS(1564),
    [anon_sym_namespace] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1562),
    [anon_sym_COMMA] = ACTIONS(1562),
    [anon_sym_RBRACE] = ACTIONS(1562),
    [anon_sym_typeof] = ACTIONS(1564),
    [anon_sym_type] = ACTIONS(1564),
    [anon_sym_interface] = ACTIONS(1564),
    [anon_sym_declare] = ACTIONS(1564),
    [anon_sym_module] = ACTIONS(1564),
    [anon_sym_COLON] = ACTIONS(1562),
    [anon_sym_import] = ACTIONS(1564),
    [anon_sym_const] = ACTIONS(1564),
    [anon_sym_enum] = ACTIONS(1564),
    [anon_sym_var] = ACTIONS(1564),
    [anon_sym_let] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1562),
    [anon_sym_else] = ACTIONS(1564),
    [anon_sym_if] = ACTIONS(1564),
    [anon_sym_switch] = ACTIONS(1564),
    [anon_sym_for] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1562),
    [anon_sym_RPAREN] = ACTIONS(1562),
    [anon_sym_await] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1564),
    [anon_sym_do] = ACTIONS(1564),
    [anon_sym_try] = ACTIONS(1564),
    [anon_sym_with] = ACTIONS(1564),
    [anon_sym_break] = ACTIONS(1564),
    [anon_sym_continue] = ACTIONS(1564),
    [anon_sym_debugger] = ACTIONS(1564),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_throw] = ACTIONS(1564),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_case] = ACTIONS(1564),
    [anon_sym_yield] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_RBRACK] = ACTIONS(1562),
    [anon_sym_class] = ACTIONS(1564),
    [anon_sym_async] = ACTIONS(1564),
    [anon_sym_function] = ACTIONS(1564),
    [anon_sym_EQ_GT] = ACTIONS(1562),
    [anon_sym_abstract] = ACTIONS(1564),
    [anon_sym_get] = ACTIONS(1564),
    [anon_sym_set] = ACTIONS(1564),
    [anon_sym_QMARK] = ACTIONS(1562),
    [anon_sym_extends] = ACTIONS(1564),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1562),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [anon_sym_SLASH] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(1562),
    [anon_sym_GT] = ACTIONS(1562),
    [anon_sym_TILDE] = ACTIONS(1562),
    [anon_sym_void] = ACTIONS(1564),
    [anon_sym_delete] = ACTIONS(1564),
    [anon_sym_PLUS_PLUS] = ACTIONS(1562),
    [anon_sym_DASH_DASH] = ACTIONS(1562),
    [anon_sym_DQUOTE] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1562),
    [sym_float_literal] = ACTIONS(1562),
    [sym_hex_literal] = ACTIONS(1564),
    [sym_int_literal] = ACTIONS(1564),
    [sym_binary_literal] = ACTIONS(1564),
    [sym_octal_literal] = ACTIONS(1564),
    [sym_bigint_literal] = ACTIONS(1562),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1562),
    [anon_sym_static] = ACTIONS(1564),
    [anon_sym_public] = ACTIONS(1564),
    [anon_sym_private] = ACTIONS(1564),
    [anon_sym_protected] = ACTIONS(1564),
    [anon_sym_boolean] = ACTIONS(1564),
    [anon_sym_string] = ACTIONS(1564),
    [anon_sym_symbol] = ACTIONS(1564),
    [sym_readonly] = ACTIONS(1564),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1566),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1568),
    [anon_sym_EQ] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1568),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_typeof] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_interface] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_COLON] = ACTIONS(1566),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_const] = ACTIONS(1568),
    [anon_sym_enum] = ACTIONS(1568),
    [anon_sym_var] = ACTIONS(1568),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_else] = ACTIONS(1568),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_switch] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1566),
    [anon_sym_await] = ACTIONS(1568),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_do] = ACTIONS(1568),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_with] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_debugger] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_throw] = ACTIONS(1568),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_function] = ACTIONS(1568),
    [anon_sym_EQ_GT] = ACTIONS(1566),
    [anon_sym_abstract] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_QMARK] = ACTIONS(1566),
    [anon_sym_extends] = ACTIONS(1568),
    [anon_sym_new] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1568),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_SLASH] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_void] = ACTIONS(1568),
    [anon_sym_delete] = ACTIONS(1568),
    [anon_sym_PLUS_PLUS] = ACTIONS(1566),
    [anon_sym_DASH_DASH] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1566),
    [sym_float_literal] = ACTIONS(1566),
    [sym_hex_literal] = ACTIONS(1568),
    [sym_int_literal] = ACTIONS(1568),
    [sym_binary_literal] = ACTIONS(1568),
    [sym_octal_literal] = ACTIONS(1568),
    [sym_bigint_literal] = ACTIONS(1566),
    [sym_this] = ACTIONS(1568),
    [sym_super] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_null] = ACTIONS(1568),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [sym_readonly] = ACTIONS(1568),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1570),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_export] = ACTIONS(1572),
    [anon_sym_default] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(1572),
    [anon_sym_namespace] = ACTIONS(1572),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(1570),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_typeof] = ACTIONS(1572),
    [anon_sym_type] = ACTIONS(1572),
    [anon_sym_interface] = ACTIONS(1572),
    [anon_sym_declare] = ACTIONS(1572),
    [anon_sym_module] = ACTIONS(1572),
    [anon_sym_COLON] = ACTIONS(1570),
    [anon_sym_import] = ACTIONS(1572),
    [anon_sym_const] = ACTIONS(1572),
    [anon_sym_enum] = ACTIONS(1572),
    [anon_sym_var] = ACTIONS(1572),
    [anon_sym_let] = ACTIONS(1572),
    [anon_sym_BANG] = ACTIONS(1570),
    [anon_sym_else] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(1572),
    [anon_sym_switch] = ACTIONS(1572),
    [anon_sym_for] = ACTIONS(1572),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [anon_sym_await] = ACTIONS(1572),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_do] = ACTIONS(1572),
    [anon_sym_try] = ACTIONS(1572),
    [anon_sym_with] = ACTIONS(1572),
    [anon_sym_break] = ACTIONS(1572),
    [anon_sym_continue] = ACTIONS(1572),
    [anon_sym_debugger] = ACTIONS(1572),
    [anon_sym_return] = ACTIONS(1572),
    [anon_sym_throw] = ACTIONS(1572),
    [anon_sym_SEMI] = ACTIONS(1570),
    [anon_sym_case] = ACTIONS(1572),
    [anon_sym_yield] = ACTIONS(1572),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_class] = ACTIONS(1572),
    [anon_sym_async] = ACTIONS(1572),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ_GT] = ACTIONS(1570),
    [anon_sym_abstract] = ACTIONS(1572),
    [anon_sym_get] = ACTIONS(1572),
    [anon_sym_set] = ACTIONS(1572),
    [anon_sym_QMARK] = ACTIONS(1570),
    [anon_sym_extends] = ACTIONS(1572),
    [anon_sym_new] = ACTIONS(1572),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1572),
    [anon_sym_SLASH] = ACTIONS(1572),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_void] = ACTIONS(1572),
    [anon_sym_delete] = ACTIONS(1572),
    [anon_sym_PLUS_PLUS] = ACTIONS(1570),
    [anon_sym_DASH_DASH] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1570),
    [sym_float_literal] = ACTIONS(1570),
    [sym_hex_literal] = ACTIONS(1572),
    [sym_int_literal] = ACTIONS(1572),
    [sym_binary_literal] = ACTIONS(1572),
    [sym_octal_literal] = ACTIONS(1572),
    [sym_bigint_literal] = ACTIONS(1570),
    [sym_this] = ACTIONS(1572),
    [sym_super] = ACTIONS(1572),
    [sym_true] = ACTIONS(1572),
    [sym_false] = ACTIONS(1572),
    [sym_null] = ACTIONS(1572),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_static] = ACTIONS(1572),
    [anon_sym_public] = ACTIONS(1572),
    [anon_sym_private] = ACTIONS(1572),
    [anon_sym_protected] = ACTIONS(1572),
    [anon_sym_boolean] = ACTIONS(1572),
    [anon_sym_string] = ACTIONS(1572),
    [anon_sym_symbol] = ACTIONS(1572),
    [sym_readonly] = ACTIONS(1572),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1018),
    [sym_identifier] = ACTIONS(1020),
    [anon_sym_export] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1020),
    [anon_sym_namespace] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_COMMA] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_typeof] = ACTIONS(1020),
    [anon_sym_type] = ACTIONS(1020),
    [anon_sym_interface] = ACTIONS(1020),
    [anon_sym_declare] = ACTIONS(1020),
    [anon_sym_module] = ACTIONS(1020),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_import] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_debugger] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_throw] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [anon_sym_RBRACK] = ACTIONS(1018),
    [anon_sym_class] = ACTIONS(1020),
    [anon_sym_async] = ACTIONS(1020),
    [anon_sym_function] = ACTIONS(1020),
    [anon_sym_EQ_GT] = ACTIONS(1018),
    [anon_sym_abstract] = ACTIONS(1020),
    [anon_sym_get] = ACTIONS(1020),
    [anon_sym_set] = ACTIONS(1020),
    [anon_sym_QMARK] = ACTIONS(1018),
    [anon_sym_extends] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_PIPE] = ACTIONS(1018),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_SLASH] = ACTIONS(1020),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_void] = ACTIONS(1020),
    [anon_sym_delete] = ACTIONS(1020),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [sym_float_literal] = ACTIONS(1018),
    [sym_hex_literal] = ACTIONS(1020),
    [sym_int_literal] = ACTIONS(1020),
    [sym_binary_literal] = ACTIONS(1020),
    [sym_octal_literal] = ACTIONS(1020),
    [sym_bigint_literal] = ACTIONS(1018),
    [sym_this] = ACTIONS(1020),
    [sym_super] = ACTIONS(1020),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_public] = ACTIONS(1020),
    [anon_sym_private] = ACTIONS(1020),
    [anon_sym_protected] = ACTIONS(1020),
    [anon_sym_boolean] = ACTIONS(1020),
    [anon_sym_string] = ACTIONS(1020),
    [anon_sym_symbol] = ACTIONS(1020),
    [sym_readonly] = ACTIONS(1020),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1574),
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_export] = ACTIONS(1576),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_EQ] = ACTIONS(1576),
    [anon_sym_namespace] = ACTIONS(1576),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1574),
    [anon_sym_RBRACE] = ACTIONS(1574),
    [anon_sym_typeof] = ACTIONS(1576),
    [anon_sym_type] = ACTIONS(1576),
    [anon_sym_interface] = ACTIONS(1576),
    [anon_sym_declare] = ACTIONS(1576),
    [anon_sym_module] = ACTIONS(1576),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(1576),
    [anon_sym_const] = ACTIONS(1576),
    [anon_sym_enum] = ACTIONS(1576),
    [anon_sym_var] = ACTIONS(1576),
    [anon_sym_let] = ACTIONS(1576),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_else] = ACTIONS(1576),
    [anon_sym_if] = ACTIONS(1576),
    [anon_sym_switch] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_LPAREN] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1574),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1576),
    [anon_sym_do] = ACTIONS(1576),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_with] = ACTIONS(1576),
    [anon_sym_break] = ACTIONS(1576),
    [anon_sym_continue] = ACTIONS(1576),
    [anon_sym_debugger] = ACTIONS(1576),
    [anon_sym_return] = ACTIONS(1576),
    [anon_sym_throw] = ACTIONS(1576),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_case] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_RBRACK] = ACTIONS(1574),
    [anon_sym_class] = ACTIONS(1576),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_function] = ACTIONS(1576),
    [anon_sym_EQ_GT] = ACTIONS(1574),
    [anon_sym_abstract] = ACTIONS(1576),
    [anon_sym_get] = ACTIONS(1576),
    [anon_sym_set] = ACTIONS(1576),
    [anon_sym_QMARK] = ACTIONS(1574),
    [anon_sym_extends] = ACTIONS(1576),
    [anon_sym_new] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_PLUS] = ACTIONS(1576),
    [anon_sym_DASH] = ACTIONS(1576),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1576),
    [anon_sym_delete] = ACTIONS(1576),
    [anon_sym_PLUS_PLUS] = ACTIONS(1574),
    [anon_sym_DASH_DASH] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1574),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1574),
    [sym_float_literal] = ACTIONS(1574),
    [sym_hex_literal] = ACTIONS(1576),
    [sym_int_literal] = ACTIONS(1576),
    [sym_binary_literal] = ACTIONS(1576),
    [sym_octal_literal] = ACTIONS(1576),
    [sym_bigint_literal] = ACTIONS(1574),
    [sym_this] = ACTIONS(1576),
    [sym_super] = ACTIONS(1576),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_null] = ACTIONS(1576),
    [anon_sym_AT] = ACTIONS(1574),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_public] = ACTIONS(1576),
    [anon_sym_private] = ACTIONS(1576),
    [anon_sym_protected] = ACTIONS(1576),
    [anon_sym_boolean] = ACTIONS(1576),
    [anon_sym_string] = ACTIONS(1576),
    [anon_sym_symbol] = ACTIONS(1576),
    [sym_readonly] = ACTIONS(1576),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1578),
    [sym_identifier] = ACTIONS(1580),
    [anon_sym_export] = ACTIONS(1580),
    [anon_sym_default] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_typeof] = ACTIONS(1580),
    [anon_sym_type] = ACTIONS(1580),
    [anon_sym_interface] = ACTIONS(1580),
    [anon_sym_declare] = ACTIONS(1580),
    [anon_sym_module] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1578),
    [anon_sym_import] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_enum] = ACTIONS(1580),
    [anon_sym_var] = ACTIONS(1580),
    [anon_sym_let] = ACTIONS(1580),
    [anon_sym_BANG] = ACTIONS(1578),
    [anon_sym_else] = ACTIONS(1580),
    [anon_sym_if] = ACTIONS(1580),
    [anon_sym_switch] = ACTIONS(1580),
    [anon_sym_for] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [anon_sym_await] = ACTIONS(1580),
    [anon_sym_while] = ACTIONS(1580),
    [anon_sym_do] = ACTIONS(1580),
    [anon_sym_try] = ACTIONS(1580),
    [anon_sym_with] = ACTIONS(1580),
    [anon_sym_break] = ACTIONS(1580),
    [anon_sym_continue] = ACTIONS(1580),
    [anon_sym_debugger] = ACTIONS(1580),
    [anon_sym_return] = ACTIONS(1580),
    [anon_sym_throw] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_case] = ACTIONS(1580),
    [anon_sym_yield] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1578),
    [anon_sym_class] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1578),
    [anon_sym_abstract] = ACTIONS(1580),
    [anon_sym_get] = ACTIONS(1580),
    [anon_sym_set] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1578),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_new] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1578),
    [anon_sym_PIPE] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1578),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_void] = ACTIONS(1580),
    [anon_sym_delete] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1578),
    [anon_sym_DASH_DASH] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1578),
    [anon_sym_SQUOTE] = ACTIONS(1578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [sym_float_literal] = ACTIONS(1578),
    [sym_hex_literal] = ACTIONS(1580),
    [sym_int_literal] = ACTIONS(1580),
    [sym_binary_literal] = ACTIONS(1580),
    [sym_octal_literal] = ACTIONS(1580),
    [sym_bigint_literal] = ACTIONS(1578),
    [sym_this] = ACTIONS(1580),
    [sym_super] = ACTIONS(1580),
    [sym_true] = ACTIONS(1580),
    [sym_false] = ACTIONS(1580),
    [sym_null] = ACTIONS(1580),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_public] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1580),
    [anon_sym_protected] = ACTIONS(1580),
    [anon_sym_boolean] = ACTIONS(1580),
    [anon_sym_string] = ACTIONS(1580),
    [anon_sym_symbol] = ACTIONS(1580),
    [sym_readonly] = ACTIONS(1580),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1582),
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_namespace] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1582),
    [anon_sym_typeof] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(1584),
    [anon_sym_interface] = ACTIONS(1584),
    [anon_sym_declare] = ACTIONS(1584),
    [anon_sym_module] = ACTIONS(1584),
    [anon_sym_COLON] = ACTIONS(1582),
    [anon_sym_import] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_var] = ACTIONS(1584),
    [anon_sym_let] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_else] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_LPAREN] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_await] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_try] = ACTIONS(1584),
    [anon_sym_with] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_debugger] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_throw] = ACTIONS(1584),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_yield] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_RBRACK] = ACTIONS(1582),
    [anon_sym_class] = ACTIONS(1584),
    [anon_sym_async] = ACTIONS(1584),
    [anon_sym_function] = ACTIONS(1584),
    [anon_sym_EQ_GT] = ACTIONS(1582),
    [anon_sym_abstract] = ACTIONS(1584),
    [anon_sym_get] = ACTIONS(1584),
    [anon_sym_set] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_extends] = ACTIONS(1560),
    [anon_sym_new] = ACTIONS(1584),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_SLASH] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1582),
    [anon_sym_GT] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_void] = ACTIONS(1584),
    [anon_sym_delete] = ACTIONS(1584),
    [anon_sym_PLUS_PLUS] = ACTIONS(1582),
    [anon_sym_DASH_DASH] = ACTIONS(1582),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [anon_sym_SQUOTE] = ACTIONS(1582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [sym_float_literal] = ACTIONS(1582),
    [sym_hex_literal] = ACTIONS(1584),
    [sym_int_literal] = ACTIONS(1584),
    [sym_binary_literal] = ACTIONS(1584),
    [sym_octal_literal] = ACTIONS(1584),
    [sym_bigint_literal] = ACTIONS(1582),
    [sym_this] = ACTIONS(1584),
    [sym_super] = ACTIONS(1584),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [sym_null] = ACTIONS(1584),
    [anon_sym_AT] = ACTIONS(1582),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_public] = ACTIONS(1584),
    [anon_sym_private] = ACTIONS(1584),
    [anon_sym_protected] = ACTIONS(1584),
    [anon_sym_boolean] = ACTIONS(1584),
    [anon_sym_string] = ACTIONS(1584),
    [anon_sym_symbol] = ACTIONS(1584),
    [sym_readonly] = ACTIONS(1584),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_COLON] = ACTIONS(1586),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_RBRACK] = ACTIONS(1586),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_EQ_GT] = ACTIONS(1586),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_extends] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1586),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_float_literal] = ACTIONS(1586),
    [sym_hex_literal] = ACTIONS(1588),
    [sym_int_literal] = ACTIONS(1588),
    [sym_binary_literal] = ACTIONS(1588),
    [sym_octal_literal] = ACTIONS(1588),
    [sym_bigint_literal] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [sym_readonly] = ACTIONS(1588),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1590),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1592),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_interface] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1590),
    [anon_sym_import] = ACTIONS(1592),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_enum] = ACTIONS(1592),
    [anon_sym_var] = ACTIONS(1592),
    [anon_sym_let] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1590),
    [anon_sym_else] = ACTIONS(1592),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_switch] = ACTIONS(1592),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1590),
    [anon_sym_await] = ACTIONS(1592),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1592),
    [anon_sym_try] = ACTIONS(1592),
    [anon_sym_with] = ACTIONS(1592),
    [anon_sym_break] = ACTIONS(1592),
    [anon_sym_continue] = ACTIONS(1592),
    [anon_sym_debugger] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_throw] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_RBRACK] = ACTIONS(1590),
    [anon_sym_class] = ACTIONS(1592),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1592),
    [anon_sym_EQ_GT] = ACTIONS(1590),
    [anon_sym_abstract] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_QMARK] = ACTIONS(1590),
    [anon_sym_extends] = ACTIONS(1592),
    [anon_sym_new] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_void] = ACTIONS(1592),
    [anon_sym_delete] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_float_literal] = ACTIONS(1590),
    [sym_hex_literal] = ACTIONS(1592),
    [sym_int_literal] = ACTIONS(1592),
    [sym_binary_literal] = ACTIONS(1592),
    [sym_octal_literal] = ACTIONS(1592),
    [sym_bigint_literal] = ACTIONS(1590),
    [sym_this] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
    [sym_readonly] = ACTIONS(1592),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1096),
    [sym_identifier] = ACTIONS(1098),
    [anon_sym_export] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1098),
    [anon_sym_EQ] = ACTIONS(1098),
    [anon_sym_namespace] = ACTIONS(1098),
    [anon_sym_LBRACE] = ACTIONS(1096),
    [anon_sym_COMMA] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1096),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1098),
    [anon_sym_interface] = ACTIONS(1098),
    [anon_sym_declare] = ACTIONS(1098),
    [anon_sym_module] = ACTIONS(1098),
    [anon_sym_COLON] = ACTIONS(1096),
    [anon_sym_import] = ACTIONS(1098),
    [anon_sym_const] = ACTIONS(1098),
    [anon_sym_enum] = ACTIONS(1098),
    [anon_sym_var] = ACTIONS(1098),
    [anon_sym_let] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1096),
    [anon_sym_else] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1098),
    [anon_sym_switch] = ACTIONS(1098),
    [anon_sym_for] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [anon_sym_RPAREN] = ACTIONS(1096),
    [anon_sym_await] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1098),
    [anon_sym_do] = ACTIONS(1098),
    [anon_sym_try] = ACTIONS(1098),
    [anon_sym_with] = ACTIONS(1098),
    [anon_sym_break] = ACTIONS(1098),
    [anon_sym_continue] = ACTIONS(1098),
    [anon_sym_debugger] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_throw] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_yield] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1096),
    [anon_sym_RBRACK] = ACTIONS(1096),
    [anon_sym_class] = ACTIONS(1098),
    [anon_sym_async] = ACTIONS(1098),
    [anon_sym_function] = ACTIONS(1098),
    [anon_sym_EQ_GT] = ACTIONS(1096),
    [anon_sym_abstract] = ACTIONS(1098),
    [anon_sym_get] = ACTIONS(1098),
    [anon_sym_set] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(1096),
    [anon_sym_extends] = ACTIONS(1098),
    [anon_sym_new] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1096),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_SLASH] = ACTIONS(1098),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_TILDE] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [anon_sym_SQUOTE] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [sym_float_literal] = ACTIONS(1096),
    [sym_hex_literal] = ACTIONS(1098),
    [sym_int_literal] = ACTIONS(1098),
    [sym_binary_literal] = ACTIONS(1098),
    [sym_octal_literal] = ACTIONS(1098),
    [sym_bigint_literal] = ACTIONS(1096),
    [sym_this] = ACTIONS(1098),
    [sym_super] = ACTIONS(1098),
    [sym_true] = ACTIONS(1098),
    [sym_false] = ACTIONS(1098),
    [sym_null] = ACTIONS(1098),
    [anon_sym_AT] = ACTIONS(1096),
    [anon_sym_static] = ACTIONS(1098),
    [anon_sym_public] = ACTIONS(1098),
    [anon_sym_private] = ACTIONS(1098),
    [anon_sym_protected] = ACTIONS(1098),
    [anon_sym_boolean] = ACTIONS(1098),
    [anon_sym_string] = ACTIONS(1098),
    [anon_sym_symbol] = ACTIONS(1098),
    [sym_readonly] = ACTIONS(1098),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1594),
    [sym_identifier] = ACTIONS(1596),
    [anon_sym_export] = ACTIONS(1596),
    [anon_sym_default] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_namespace] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1594),
    [anon_sym_COMMA] = ACTIONS(1594),
    [anon_sym_RBRACE] = ACTIONS(1594),
    [anon_sym_typeof] = ACTIONS(1596),
    [anon_sym_type] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1596),
    [anon_sym_declare] = ACTIONS(1596),
    [anon_sym_module] = ACTIONS(1596),
    [anon_sym_COLON] = ACTIONS(1594),
    [anon_sym_import] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(1596),
    [anon_sym_enum] = ACTIONS(1596),
    [anon_sym_var] = ACTIONS(1596),
    [anon_sym_let] = ACTIONS(1596),
    [anon_sym_BANG] = ACTIONS(1594),
    [anon_sym_else] = ACTIONS(1596),
    [anon_sym_if] = ACTIONS(1596),
    [anon_sym_switch] = ACTIONS(1596),
    [anon_sym_for] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1594),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_await] = ACTIONS(1596),
    [anon_sym_while] = ACTIONS(1596),
    [anon_sym_do] = ACTIONS(1596),
    [anon_sym_try] = ACTIONS(1596),
    [anon_sym_with] = ACTIONS(1596),
    [anon_sym_break] = ACTIONS(1596),
    [anon_sym_continue] = ACTIONS(1596),
    [anon_sym_debugger] = ACTIONS(1596),
    [anon_sym_return] = ACTIONS(1596),
    [anon_sym_throw] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [anon_sym_case] = ACTIONS(1596),
    [anon_sym_yield] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_RBRACK] = ACTIONS(1594),
    [anon_sym_class] = ACTIONS(1596),
    [anon_sym_async] = ACTIONS(1596),
    [anon_sym_function] = ACTIONS(1596),
    [anon_sym_EQ_GT] = ACTIONS(1594),
    [anon_sym_abstract] = ACTIONS(1596),
    [anon_sym_get] = ACTIONS(1596),
    [anon_sym_set] = ACTIONS(1596),
    [anon_sym_QMARK] = ACTIONS(1594),
    [anon_sym_extends] = ACTIONS(1596),
    [anon_sym_new] = ACTIONS(1596),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1596),
    [anon_sym_DASH] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_TILDE] = ACTIONS(1594),
    [anon_sym_void] = ACTIONS(1596),
    [anon_sym_delete] = ACTIONS(1596),
    [anon_sym_PLUS_PLUS] = ACTIONS(1594),
    [anon_sym_DASH_DASH] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [sym_float_literal] = ACTIONS(1594),
    [sym_hex_literal] = ACTIONS(1596),
    [sym_int_literal] = ACTIONS(1596),
    [sym_binary_literal] = ACTIONS(1596),
    [sym_octal_literal] = ACTIONS(1596),
    [sym_bigint_literal] = ACTIONS(1594),
    [sym_this] = ACTIONS(1596),
    [sym_super] = ACTIONS(1596),
    [sym_true] = ACTIONS(1596),
    [sym_false] = ACTIONS(1596),
    [sym_null] = ACTIONS(1596),
    [anon_sym_AT] = ACTIONS(1594),
    [anon_sym_static] = ACTIONS(1596),
    [anon_sym_public] = ACTIONS(1596),
    [anon_sym_private] = ACTIONS(1596),
    [anon_sym_protected] = ACTIONS(1596),
    [anon_sym_boolean] = ACTIONS(1596),
    [anon_sym_string] = ACTIONS(1596),
    [anon_sym_symbol] = ACTIONS(1596),
    [sym_readonly] = ACTIONS(1596),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1598),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_export] = ACTIONS(1600),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_EQ] = ACTIONS(1600),
    [anon_sym_namespace] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_typeof] = ACTIONS(1600),
    [anon_sym_type] = ACTIONS(1600),
    [anon_sym_interface] = ACTIONS(1600),
    [anon_sym_declare] = ACTIONS(1600),
    [anon_sym_module] = ACTIONS(1600),
    [anon_sym_COLON] = ACTIONS(1598),
    [anon_sym_import] = ACTIONS(1600),
    [anon_sym_const] = ACTIONS(1600),
    [anon_sym_enum] = ACTIONS(1600),
    [anon_sym_var] = ACTIONS(1600),
    [anon_sym_let] = ACTIONS(1600),
    [anon_sym_BANG] = ACTIONS(1598),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1600),
    [anon_sym_for] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_await] = ACTIONS(1600),
    [anon_sym_while] = ACTIONS(1600),
    [anon_sym_do] = ACTIONS(1600),
    [anon_sym_try] = ACTIONS(1600),
    [anon_sym_with] = ACTIONS(1600),
    [anon_sym_break] = ACTIONS(1600),
    [anon_sym_continue] = ACTIONS(1600),
    [anon_sym_debugger] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1600),
    [anon_sym_throw] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_yield] = ACTIONS(1600),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1598),
    [anon_sym_class] = ACTIONS(1600),
    [anon_sym_async] = ACTIONS(1600),
    [anon_sym_function] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1598),
    [anon_sym_abstract] = ACTIONS(1600),
    [anon_sym_get] = ACTIONS(1600),
    [anon_sym_set] = ACTIONS(1600),
    [anon_sym_QMARK] = ACTIONS(1598),
    [anon_sym_extends] = ACTIONS(1600),
    [anon_sym_new] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1598),
    [anon_sym_PLUS] = ACTIONS(1600),
    [anon_sym_DASH] = ACTIONS(1600),
    [anon_sym_SLASH] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1598),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_void] = ACTIONS(1600),
    [anon_sym_delete] = ACTIONS(1600),
    [anon_sym_PLUS_PLUS] = ACTIONS(1598),
    [anon_sym_DASH_DASH] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [sym_float_literal] = ACTIONS(1598),
    [sym_hex_literal] = ACTIONS(1600),
    [sym_int_literal] = ACTIONS(1600),
    [sym_binary_literal] = ACTIONS(1600),
    [sym_octal_literal] = ACTIONS(1600),
    [sym_bigint_literal] = ACTIONS(1598),
    [sym_this] = ACTIONS(1600),
    [sym_super] = ACTIONS(1600),
    [sym_true] = ACTIONS(1600),
    [sym_false] = ACTIONS(1600),
    [sym_null] = ACTIONS(1600),
    [anon_sym_AT] = ACTIONS(1598),
    [anon_sym_static] = ACTIONS(1600),
    [anon_sym_public] = ACTIONS(1600),
    [anon_sym_private] = ACTIONS(1600),
    [anon_sym_protected] = ACTIONS(1600),
    [anon_sym_boolean] = ACTIONS(1600),
    [anon_sym_string] = ACTIONS(1600),
    [anon_sym_symbol] = ACTIONS(1600),
    [sym_readonly] = ACTIONS(1600),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1604),
    [sym_identifier] = ACTIONS(1606),
    [anon_sym_export] = ACTIONS(1606),
    [anon_sym_default] = ACTIONS(1606),
    [anon_sym_EQ] = ACTIONS(1606),
    [anon_sym_namespace] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(1604),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_RBRACE] = ACTIONS(1604),
    [anon_sym_typeof] = ACTIONS(1606),
    [anon_sym_type] = ACTIONS(1606),
    [anon_sym_interface] = ACTIONS(1606),
    [anon_sym_declare] = ACTIONS(1606),
    [anon_sym_module] = ACTIONS(1606),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_import] = ACTIONS(1606),
    [anon_sym_const] = ACTIONS(1606),
    [anon_sym_enum] = ACTIONS(1606),
    [anon_sym_var] = ACTIONS(1606),
    [anon_sym_let] = ACTIONS(1606),
    [anon_sym_BANG] = ACTIONS(1604),
    [anon_sym_else] = ACTIONS(1606),
    [anon_sym_if] = ACTIONS(1606),
    [anon_sym_switch] = ACTIONS(1606),
    [anon_sym_for] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1604),
    [anon_sym_RPAREN] = ACTIONS(1604),
    [anon_sym_await] = ACTIONS(1606),
    [anon_sym_while] = ACTIONS(1606),
    [anon_sym_do] = ACTIONS(1606),
    [anon_sym_try] = ACTIONS(1606),
    [anon_sym_with] = ACTIONS(1606),
    [anon_sym_break] = ACTIONS(1606),
    [anon_sym_continue] = ACTIONS(1606),
    [anon_sym_debugger] = ACTIONS(1606),
    [anon_sym_return] = ACTIONS(1606),
    [anon_sym_throw] = ACTIONS(1606),
    [anon_sym_SEMI] = ACTIONS(1604),
    [anon_sym_case] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_RBRACK] = ACTIONS(1604),
    [anon_sym_class] = ACTIONS(1606),
    [anon_sym_async] = ACTIONS(1606),
    [anon_sym_function] = ACTIONS(1606),
    [anon_sym_EQ_GT] = ACTIONS(1604),
    [anon_sym_abstract] = ACTIONS(1606),
    [anon_sym_get] = ACTIONS(1606),
    [anon_sym_set] = ACTIONS(1606),
    [anon_sym_QMARK] = ACTIONS(1604),
    [anon_sym_extends] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1606),
    [anon_sym_AMP] = ACTIONS(1604),
    [anon_sym_PIPE] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(1606),
    [anon_sym_DASH] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1606),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_GT] = ACTIONS(1604),
    [anon_sym_TILDE] = ACTIONS(1604),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_delete] = ACTIONS(1606),
    [anon_sym_PLUS_PLUS] = ACTIONS(1604),
    [anon_sym_DASH_DASH] = ACTIONS(1604),
    [anon_sym_DQUOTE] = ACTIONS(1604),
    [anon_sym_SQUOTE] = ACTIONS(1604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1604),
    [sym_float_literal] = ACTIONS(1604),
    [sym_hex_literal] = ACTIONS(1606),
    [sym_int_literal] = ACTIONS(1606),
    [sym_binary_literal] = ACTIONS(1606),
    [sym_octal_literal] = ACTIONS(1606),
    [sym_bigint_literal] = ACTIONS(1604),
    [sym_this] = ACTIONS(1606),
    [sym_super] = ACTIONS(1606),
    [sym_true] = ACTIONS(1606),
    [sym_false] = ACTIONS(1606),
    [sym_null] = ACTIONS(1606),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_static] = ACTIONS(1606),
    [anon_sym_public] = ACTIONS(1606),
    [anon_sym_private] = ACTIONS(1606),
    [anon_sym_protected] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_symbol] = ACTIONS(1606),
    [sym_readonly] = ACTIONS(1606),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(1608),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_default] = ACTIONS(1610),
    [anon_sym_EQ] = ACTIONS(1610),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_LBRACE] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_interface] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1608),
    [anon_sym_import] = ACTIONS(1610),
    [anon_sym_const] = ACTIONS(1610),
    [anon_sym_enum] = ACTIONS(1610),
    [anon_sym_var] = ACTIONS(1610),
    [anon_sym_let] = ACTIONS(1610),
    [anon_sym_BANG] = ACTIONS(1608),
    [anon_sym_else] = ACTIONS(1610),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_switch] = ACTIONS(1610),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_RPAREN] = ACTIONS(1608),
    [anon_sym_await] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1610),
    [anon_sym_do] = ACTIONS(1610),
    [anon_sym_try] = ACTIONS(1610),
    [anon_sym_with] = ACTIONS(1610),
    [anon_sym_break] = ACTIONS(1610),
    [anon_sym_continue] = ACTIONS(1610),
    [anon_sym_debugger] = ACTIONS(1610),
    [anon_sym_return] = ACTIONS(1610),
    [anon_sym_throw] = ACTIONS(1610),
    [anon_sym_SEMI] = ACTIONS(1608),
    [anon_sym_case] = ACTIONS(1610),
    [anon_sym_yield] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(1610),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_function] = ACTIONS(1610),
    [anon_sym_EQ_GT] = ACTIONS(1608),
    [anon_sym_abstract] = ACTIONS(1610),
    [anon_sym_get] = ACTIONS(1610),
    [anon_sym_set] = ACTIONS(1610),
    [anon_sym_QMARK] = ACTIONS(1608),
    [anon_sym_extends] = ACTIONS(1610),
    [anon_sym_new] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_PIPE] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(1610),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_GT] = ACTIONS(1608),
    [anon_sym_TILDE] = ACTIONS(1608),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1608),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [anon_sym_SQUOTE] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1608),
    [sym_float_literal] = ACTIONS(1608),
    [sym_hex_literal] = ACTIONS(1610),
    [sym_int_literal] = ACTIONS(1610),
    [sym_binary_literal] = ACTIONS(1610),
    [sym_octal_literal] = ACTIONS(1610),
    [sym_bigint_literal] = ACTIONS(1608),
    [sym_this] = ACTIONS(1610),
    [sym_super] = ACTIONS(1610),
    [sym_true] = ACTIONS(1610),
    [sym_false] = ACTIONS(1610),
    [sym_null] = ACTIONS(1610),
    [anon_sym_AT] = ACTIONS(1608),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(1612),
    [sym_identifier] = ACTIONS(1614),
    [anon_sym_export] = ACTIONS(1614),
    [anon_sym_default] = ACTIONS(1614),
    [anon_sym_EQ] = ACTIONS(1614),
    [anon_sym_namespace] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1612),
    [anon_sym_COMMA] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1612),
    [anon_sym_typeof] = ACTIONS(1614),
    [anon_sym_type] = ACTIONS(1614),
    [anon_sym_interface] = ACTIONS(1614),
    [anon_sym_declare] = ACTIONS(1614),
    [anon_sym_module] = ACTIONS(1614),
    [anon_sym_COLON] = ACTIONS(1612),
    [anon_sym_import] = ACTIONS(1614),
    [anon_sym_const] = ACTIONS(1614),
    [anon_sym_enum] = ACTIONS(1614),
    [anon_sym_var] = ACTIONS(1614),
    [anon_sym_let] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_else] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(1614),
    [anon_sym_switch] = ACTIONS(1614),
    [anon_sym_for] = ACTIONS(1614),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_RPAREN] = ACTIONS(1612),
    [anon_sym_await] = ACTIONS(1614),
    [anon_sym_while] = ACTIONS(1614),
    [anon_sym_do] = ACTIONS(1614),
    [anon_sym_try] = ACTIONS(1614),
    [anon_sym_with] = ACTIONS(1614),
    [anon_sym_break] = ACTIONS(1614),
    [anon_sym_continue] = ACTIONS(1614),
    [anon_sym_debugger] = ACTIONS(1614),
    [anon_sym_return] = ACTIONS(1614),
    [anon_sym_throw] = ACTIONS(1614),
    [anon_sym_SEMI] = ACTIONS(1612),
    [anon_sym_case] = ACTIONS(1614),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [anon_sym_class] = ACTIONS(1614),
    [anon_sym_async] = ACTIONS(1614),
    [anon_sym_function] = ACTIONS(1614),
    [anon_sym_EQ_GT] = ACTIONS(1612),
    [anon_sym_abstract] = ACTIONS(1614),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1612),
    [anon_sym_extends] = ACTIONS(1614),
    [anon_sym_new] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_PIPE] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_DASH] = ACTIONS(1614),
    [anon_sym_SLASH] = ACTIONS(1614),
    [anon_sym_LT] = ACTIONS(1612),
    [anon_sym_GT] = ACTIONS(1612),
    [anon_sym_TILDE] = ACTIONS(1612),
    [anon_sym_void] = ACTIONS(1614),
    [anon_sym_delete] = ACTIONS(1614),
    [anon_sym_PLUS_PLUS] = ACTIONS(1612),
    [anon_sym_DASH_DASH] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(1612),
    [anon_sym_SQUOTE] = ACTIONS(1612),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [sym_float_literal] = ACTIONS(1612),
    [sym_hex_literal] = ACTIONS(1614),
    [sym_int_literal] = ACTIONS(1614),
    [sym_binary_literal] = ACTIONS(1614),
    [sym_octal_literal] = ACTIONS(1614),
    [sym_bigint_literal] = ACTIONS(1612),
    [sym_this] = ACTIONS(1614),
    [sym_super] = ACTIONS(1614),
    [sym_true] = ACTIONS(1614),
    [sym_false] = ACTIONS(1614),
    [sym_null] = ACTIONS(1614),
    [anon_sym_AT] = ACTIONS(1612),
    [anon_sym_static] = ACTIONS(1614),
    [anon_sym_public] = ACTIONS(1614),
    [anon_sym_private] = ACTIONS(1614),
    [anon_sym_protected] = ACTIONS(1614),
    [anon_sym_boolean] = ACTIONS(1614),
    [anon_sym_string] = ACTIONS(1614),
    [anon_sym_symbol] = ACTIONS(1614),
    [sym_readonly] = ACTIONS(1614),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1202),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_export] = ACTIONS(1204),
    [anon_sym_default] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(1204),
    [anon_sym_namespace] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_COMMA] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_type] = ACTIONS(1204),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1204),
    [anon_sym_module] = ACTIONS(1204),
    [anon_sym_COLON] = ACTIONS(1202),
    [anon_sym_import] = ACTIONS(1204),
    [anon_sym_const] = ACTIONS(1204),
    [anon_sym_enum] = ACTIONS(1204),
    [anon_sym_var] = ACTIONS(1204),
    [anon_sym_let] = ACTIONS(1204),
    [anon_sym_BANG] = ACTIONS(1202),
    [anon_sym_else] = ACTIONS(1204),
    [anon_sym_if] = ACTIONS(1204),
    [anon_sym_switch] = ACTIONS(1204),
    [anon_sym_for] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [anon_sym_RPAREN] = ACTIONS(1202),
    [anon_sym_await] = ACTIONS(1204),
    [anon_sym_while] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_try] = ACTIONS(1204),
    [anon_sym_with] = ACTIONS(1204),
    [anon_sym_break] = ACTIONS(1204),
    [anon_sym_continue] = ACTIONS(1204),
    [anon_sym_debugger] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1204),
    [anon_sym_throw] = ACTIONS(1204),
    [anon_sym_SEMI] = ACTIONS(1202),
    [anon_sym_case] = ACTIONS(1204),
    [anon_sym_yield] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1202),
    [anon_sym_RBRACK] = ACTIONS(1202),
    [anon_sym_class] = ACTIONS(1204),
    [anon_sym_async] = ACTIONS(1204),
    [anon_sym_function] = ACTIONS(1204),
    [anon_sym_EQ_GT] = ACTIONS(1202),
    [anon_sym_abstract] = ACTIONS(1204),
    [anon_sym_get] = ACTIONS(1204),
    [anon_sym_set] = ACTIONS(1204),
    [anon_sym_QMARK] = ACTIONS(1202),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1202),
    [anon_sym_DASH_DASH] = ACTIONS(1202),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [anon_sym_SQUOTE] = ACTIONS(1202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [sym_float_literal] = ACTIONS(1202),
    [sym_hex_literal] = ACTIONS(1204),
    [sym_int_literal] = ACTIONS(1204),
    [sym_binary_literal] = ACTIONS(1204),
    [sym_octal_literal] = ACTIONS(1204),
    [sym_bigint_literal] = ACTIONS(1202),
    [sym_this] = ACTIONS(1204),
    [sym_super] = ACTIONS(1204),
    [sym_true] = ACTIONS(1204),
    [sym_false] = ACTIONS(1204),
    [sym_null] = ACTIONS(1204),
    [anon_sym_AT] = ACTIONS(1202),
    [anon_sym_static] = ACTIONS(1204),
    [anon_sym_public] = ACTIONS(1204),
    [anon_sym_private] = ACTIONS(1204),
    [anon_sym_protected] = ACTIONS(1204),
    [anon_sym_boolean] = ACTIONS(1204),
    [anon_sym_string] = ACTIONS(1204),
    [anon_sym_symbol] = ACTIONS(1204),
    [sym_readonly] = ACTIONS(1204),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(1616),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1618),
    [anon_sym_default] = ACTIONS(1618),
    [anon_sym_EQ] = ACTIONS(1618),
    [anon_sym_namespace] = ACTIONS(1618),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_COMMA] = ACTIONS(1616),
    [anon_sym_RBRACE] = ACTIONS(1616),
    [anon_sym_typeof] = ACTIONS(1618),
    [anon_sym_type] = ACTIONS(1618),
    [anon_sym_interface] = ACTIONS(1618),
    [anon_sym_declare] = ACTIONS(1618),
    [anon_sym_module] = ACTIONS(1618),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_import] = ACTIONS(1618),
    [anon_sym_const] = ACTIONS(1618),
    [anon_sym_enum] = ACTIONS(1618),
    [anon_sym_var] = ACTIONS(1618),
    [anon_sym_let] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1616),
    [anon_sym_else] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(1618),
    [anon_sym_switch] = ACTIONS(1618),
    [anon_sym_for] = ACTIONS(1618),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1616),
    [anon_sym_await] = ACTIONS(1618),
    [anon_sym_while] = ACTIONS(1618),
    [anon_sym_do] = ACTIONS(1618),
    [anon_sym_try] = ACTIONS(1618),
    [anon_sym_with] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1618),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_debugger] = ACTIONS(1618),
    [anon_sym_return] = ACTIONS(1618),
    [anon_sym_throw] = ACTIONS(1618),
    [anon_sym_SEMI] = ACTIONS(1616),
    [anon_sym_case] = ACTIONS(1618),
    [anon_sym_yield] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1616),
    [anon_sym_RBRACK] = ACTIONS(1616),
    [anon_sym_class] = ACTIONS(1618),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(1618),
    [anon_sym_EQ_GT] = ACTIONS(1616),
    [anon_sym_abstract] = ACTIONS(1618),
    [anon_sym_get] = ACTIONS(1618),
    [anon_sym_set] = ACTIONS(1618),
    [anon_sym_QMARK] = ACTIONS(1616),
    [anon_sym_extends] = ACTIONS(1618),
    [anon_sym_new] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1616),
    [anon_sym_PLUS] = ACTIONS(1618),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_SLASH] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(1616),
    [anon_sym_GT] = ACTIONS(1616),
    [anon_sym_TILDE] = ACTIONS(1616),
    [anon_sym_void] = ACTIONS(1618),
    [anon_sym_delete] = ACTIONS(1618),
    [anon_sym_PLUS_PLUS] = ACTIONS(1616),
    [anon_sym_DASH_DASH] = ACTIONS(1616),
    [anon_sym_DQUOTE] = ACTIONS(1616),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1616),
    [sym_float_literal] = ACTIONS(1616),
    [sym_hex_literal] = ACTIONS(1618),
    [sym_int_literal] = ACTIONS(1618),
    [sym_binary_literal] = ACTIONS(1618),
    [sym_octal_literal] = ACTIONS(1618),
    [sym_bigint_literal] = ACTIONS(1616),
    [sym_this] = ACTIONS(1618),
    [sym_super] = ACTIONS(1618),
    [sym_true] = ACTIONS(1618),
    [sym_false] = ACTIONS(1618),
    [sym_null] = ACTIONS(1618),
    [anon_sym_AT] = ACTIONS(1616),
    [anon_sym_static] = ACTIONS(1618),
    [anon_sym_public] = ACTIONS(1618),
    [anon_sym_private] = ACTIONS(1618),
    [anon_sym_protected] = ACTIONS(1618),
    [anon_sym_boolean] = ACTIONS(1618),
    [anon_sym_string] = ACTIONS(1618),
    [anon_sym_symbol] = ACTIONS(1618),
    [sym_readonly] = ACTIONS(1618),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1620),
    [sym_identifier] = ACTIONS(1622),
    [anon_sym_export] = ACTIONS(1622),
    [anon_sym_default] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1622),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_typeof] = ACTIONS(1622),
    [anon_sym_type] = ACTIONS(1622),
    [anon_sym_interface] = ACTIONS(1622),
    [anon_sym_declare] = ACTIONS(1622),
    [anon_sym_module] = ACTIONS(1622),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_import] = ACTIONS(1622),
    [anon_sym_const] = ACTIONS(1622),
    [anon_sym_enum] = ACTIONS(1622),
    [anon_sym_var] = ACTIONS(1622),
    [anon_sym_let] = ACTIONS(1622),
    [anon_sym_BANG] = ACTIONS(1620),
    [anon_sym_else] = ACTIONS(1622),
    [anon_sym_if] = ACTIONS(1622),
    [anon_sym_switch] = ACTIONS(1622),
    [anon_sym_for] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_RPAREN] = ACTIONS(1620),
    [anon_sym_await] = ACTIONS(1622),
    [anon_sym_while] = ACTIONS(1622),
    [anon_sym_do] = ACTIONS(1622),
    [anon_sym_try] = ACTIONS(1622),
    [anon_sym_with] = ACTIONS(1622),
    [anon_sym_break] = ACTIONS(1622),
    [anon_sym_continue] = ACTIONS(1622),
    [anon_sym_debugger] = ACTIONS(1622),
    [anon_sym_return] = ACTIONS(1622),
    [anon_sym_throw] = ACTIONS(1622),
    [anon_sym_SEMI] = ACTIONS(1620),
    [anon_sym_case] = ACTIONS(1622),
    [anon_sym_yield] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_RBRACK] = ACTIONS(1620),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1622),
    [anon_sym_function] = ACTIONS(1622),
    [anon_sym_EQ_GT] = ACTIONS(1620),
    [anon_sym_abstract] = ACTIONS(1622),
    [anon_sym_get] = ACTIONS(1622),
    [anon_sym_set] = ACTIONS(1622),
    [anon_sym_QMARK] = ACTIONS(1620),
    [anon_sym_extends] = ACTIONS(1622),
    [anon_sym_new] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1620),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1620),
    [anon_sym_GT] = ACTIONS(1620),
    [anon_sym_TILDE] = ACTIONS(1620),
    [anon_sym_void] = ACTIONS(1622),
    [anon_sym_delete] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1620),
    [anon_sym_DASH_DASH] = ACTIONS(1620),
    [anon_sym_DQUOTE] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(1620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_hex_literal] = ACTIONS(1622),
    [sym_int_literal] = ACTIONS(1622),
    [sym_binary_literal] = ACTIONS(1622),
    [sym_octal_literal] = ACTIONS(1622),
    [sym_bigint_literal] = ACTIONS(1620),
    [sym_this] = ACTIONS(1622),
    [sym_super] = ACTIONS(1622),
    [sym_true] = ACTIONS(1622),
    [sym_false] = ACTIONS(1622),
    [sym_null] = ACTIONS(1622),
    [anon_sym_AT] = ACTIONS(1620),
    [anon_sym_static] = ACTIONS(1622),
    [anon_sym_public] = ACTIONS(1622),
    [anon_sym_private] = ACTIONS(1622),
    [anon_sym_protected] = ACTIONS(1622),
    [anon_sym_boolean] = ACTIONS(1622),
    [anon_sym_string] = ACTIONS(1622),
    [anon_sym_symbol] = ACTIONS(1622),
    [sym_readonly] = ACTIONS(1622),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1624),
    [sym_identifier] = ACTIONS(1626),
    [anon_sym_export] = ACTIONS(1626),
    [anon_sym_default] = ACTIONS(1626),
    [anon_sym_EQ] = ACTIONS(1626),
    [anon_sym_namespace] = ACTIONS(1626),
    [anon_sym_LBRACE] = ACTIONS(1624),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_typeof] = ACTIONS(1626),
    [anon_sym_type] = ACTIONS(1626),
    [anon_sym_interface] = ACTIONS(1626),
    [anon_sym_declare] = ACTIONS(1626),
    [anon_sym_module] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_import] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1626),
    [anon_sym_enum] = ACTIONS(1626),
    [anon_sym_var] = ACTIONS(1626),
    [anon_sym_let] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1626),
    [anon_sym_if] = ACTIONS(1626),
    [anon_sym_switch] = ACTIONS(1626),
    [anon_sym_for] = ACTIONS(1626),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_await] = ACTIONS(1626),
    [anon_sym_while] = ACTIONS(1626),
    [anon_sym_do] = ACTIONS(1626),
    [anon_sym_try] = ACTIONS(1626),
    [anon_sym_with] = ACTIONS(1626),
    [anon_sym_break] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1626),
    [anon_sym_debugger] = ACTIONS(1626),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_throw] = ACTIONS(1626),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_case] = ACTIONS(1626),
    [anon_sym_yield] = ACTIONS(1626),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1626),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1624),
    [anon_sym_abstract] = ACTIONS(1626),
    [anon_sym_get] = ACTIONS(1626),
    [anon_sym_set] = ACTIONS(1626),
    [anon_sym_QMARK] = ACTIONS(1624),
    [anon_sym_extends] = ACTIONS(1626),
    [anon_sym_new] = ACTIONS(1626),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_PIPE] = ACTIONS(1624),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1626),
    [anon_sym_LT] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1624),
    [anon_sym_TILDE] = ACTIONS(1624),
    [anon_sym_void] = ACTIONS(1626),
    [anon_sym_delete] = ACTIONS(1626),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(1624),
    [anon_sym_SQUOTE] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [sym_float_literal] = ACTIONS(1624),
    [sym_hex_literal] = ACTIONS(1626),
    [sym_int_literal] = ACTIONS(1626),
    [sym_binary_literal] = ACTIONS(1626),
    [sym_octal_literal] = ACTIONS(1626),
    [sym_bigint_literal] = ACTIONS(1624),
    [sym_this] = ACTIONS(1626),
    [sym_super] = ACTIONS(1626),
    [sym_true] = ACTIONS(1626),
    [sym_false] = ACTIONS(1626),
    [sym_null] = ACTIONS(1626),
    [anon_sym_AT] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1626),
    [anon_sym_public] = ACTIONS(1626),
    [anon_sym_private] = ACTIONS(1626),
    [anon_sym_protected] = ACTIONS(1626),
    [anon_sym_boolean] = ACTIONS(1626),
    [anon_sym_string] = ACTIONS(1626),
    [anon_sym_symbol] = ACTIONS(1626),
    [sym_readonly] = ACTIONS(1626),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1628),
    [sym_identifier] = ACTIONS(1630),
    [anon_sym_export] = ACTIONS(1630),
    [anon_sym_default] = ACTIONS(1630),
    [anon_sym_EQ] = ACTIONS(1630),
    [anon_sym_namespace] = ACTIONS(1630),
    [anon_sym_LBRACE] = ACTIONS(1628),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_typeof] = ACTIONS(1630),
    [anon_sym_type] = ACTIONS(1630),
    [anon_sym_interface] = ACTIONS(1630),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1630),
    [anon_sym_COLON] = ACTIONS(1628),
    [anon_sym_import] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1630),
    [anon_sym_enum] = ACTIONS(1630),
    [anon_sym_var] = ACTIONS(1630),
    [anon_sym_let] = ACTIONS(1630),
    [anon_sym_BANG] = ACTIONS(1628),
    [anon_sym_else] = ACTIONS(1630),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_switch] = ACTIONS(1630),
    [anon_sym_for] = ACTIONS(1630),
    [anon_sym_LPAREN] = ACTIONS(1628),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_await] = ACTIONS(1630),
    [anon_sym_while] = ACTIONS(1630),
    [anon_sym_do] = ACTIONS(1630),
    [anon_sym_try] = ACTIONS(1630),
    [anon_sym_with] = ACTIONS(1630),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_continue] = ACTIONS(1630),
    [anon_sym_debugger] = ACTIONS(1630),
    [anon_sym_return] = ACTIONS(1630),
    [anon_sym_throw] = ACTIONS(1630),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_case] = ACTIONS(1630),
    [anon_sym_yield] = ACTIONS(1630),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(1628),
    [anon_sym_class] = ACTIONS(1630),
    [anon_sym_async] = ACTIONS(1630),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1628),
    [anon_sym_abstract] = ACTIONS(1630),
    [anon_sym_get] = ACTIONS(1630),
    [anon_sym_set] = ACTIONS(1630),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_extends] = ACTIONS(1630),
    [anon_sym_new] = ACTIONS(1630),
    [anon_sym_AMP] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1630),
    [anon_sym_SLASH] = ACTIONS(1630),
    [anon_sym_LT] = ACTIONS(1628),
    [anon_sym_GT] = ACTIONS(1628),
    [anon_sym_TILDE] = ACTIONS(1628),
    [anon_sym_void] = ACTIONS(1630),
    [anon_sym_delete] = ACTIONS(1630),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [anon_sym_DQUOTE] = ACTIONS(1628),
    [anon_sym_SQUOTE] = ACTIONS(1628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [sym_float_literal] = ACTIONS(1628),
    [sym_hex_literal] = ACTIONS(1630),
    [sym_int_literal] = ACTIONS(1630),
    [sym_binary_literal] = ACTIONS(1630),
    [sym_octal_literal] = ACTIONS(1630),
    [sym_bigint_literal] = ACTIONS(1628),
    [sym_this] = ACTIONS(1630),
    [sym_super] = ACTIONS(1630),
    [sym_true] = ACTIONS(1630),
    [sym_false] = ACTIONS(1630),
    [sym_null] = ACTIONS(1630),
    [anon_sym_AT] = ACTIONS(1628),
    [anon_sym_static] = ACTIONS(1630),
    [anon_sym_public] = ACTIONS(1630),
    [anon_sym_private] = ACTIONS(1630),
    [anon_sym_protected] = ACTIONS(1630),
    [anon_sym_boolean] = ACTIONS(1630),
    [anon_sym_string] = ACTIONS(1630),
    [anon_sym_symbol] = ACTIONS(1630),
    [sym_readonly] = ACTIONS(1630),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1632),
    [sym_identifier] = ACTIONS(1634),
    [anon_sym_export] = ACTIONS(1634),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_EQ] = ACTIONS(1634),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_COMMA] = ACTIONS(1632),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_typeof] = ACTIONS(1634),
    [anon_sym_type] = ACTIONS(1634),
    [anon_sym_interface] = ACTIONS(1634),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1634),
    [anon_sym_COLON] = ACTIONS(1632),
    [anon_sym_import] = ACTIONS(1634),
    [anon_sym_const] = ACTIONS(1634),
    [anon_sym_enum] = ACTIONS(1634),
    [anon_sym_var] = ACTIONS(1634),
    [anon_sym_let] = ACTIONS(1634),
    [anon_sym_BANG] = ACTIONS(1632),
    [anon_sym_else] = ACTIONS(1634),
    [anon_sym_if] = ACTIONS(1634),
    [anon_sym_switch] = ACTIONS(1634),
    [anon_sym_for] = ACTIONS(1634),
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_RPAREN] = ACTIONS(1632),
    [anon_sym_await] = ACTIONS(1634),
    [anon_sym_while] = ACTIONS(1634),
    [anon_sym_do] = ACTIONS(1634),
    [anon_sym_try] = ACTIONS(1634),
    [anon_sym_with] = ACTIONS(1634),
    [anon_sym_break] = ACTIONS(1634),
    [anon_sym_continue] = ACTIONS(1634),
    [anon_sym_debugger] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1634),
    [anon_sym_throw] = ACTIONS(1634),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_case] = ACTIONS(1634),
    [anon_sym_yield] = ACTIONS(1634),
    [anon_sym_LBRACK] = ACTIONS(1632),
    [anon_sym_RBRACK] = ACTIONS(1632),
    [anon_sym_class] = ACTIONS(1634),
    [anon_sym_async] = ACTIONS(1634),
    [anon_sym_function] = ACTIONS(1634),
    [anon_sym_EQ_GT] = ACTIONS(1632),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_get] = ACTIONS(1634),
    [anon_sym_set] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(1632),
    [anon_sym_extends] = ACTIONS(1634),
    [anon_sym_new] = ACTIONS(1634),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1634),
    [anon_sym_SLASH] = ACTIONS(1634),
    [anon_sym_LT] = ACTIONS(1632),
    [anon_sym_GT] = ACTIONS(1632),
    [anon_sym_TILDE] = ACTIONS(1632),
    [anon_sym_void] = ACTIONS(1634),
    [anon_sym_delete] = ACTIONS(1634),
    [anon_sym_PLUS_PLUS] = ACTIONS(1632),
    [anon_sym_DASH_DASH] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1632),
    [sym_float_literal] = ACTIONS(1632),
    [sym_hex_literal] = ACTIONS(1634),
    [sym_int_literal] = ACTIONS(1634),
    [sym_binary_literal] = ACTIONS(1634),
    [sym_octal_literal] = ACTIONS(1634),
    [sym_bigint_literal] = ACTIONS(1632),
    [sym_this] = ACTIONS(1634),
    [sym_super] = ACTIONS(1634),
    [sym_true] = ACTIONS(1634),
    [sym_false] = ACTIONS(1634),
    [sym_null] = ACTIONS(1634),
    [anon_sym_AT] = ACTIONS(1632),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_public] = ACTIONS(1634),
    [anon_sym_private] = ACTIONS(1634),
    [anon_sym_protected] = ACTIONS(1634),
    [anon_sym_boolean] = ACTIONS(1634),
    [anon_sym_string] = ACTIONS(1634),
    [anon_sym_symbol] = ACTIONS(1634),
    [sym_readonly] = ACTIONS(1634),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1636),
    [sym_identifier] = ACTIONS(1638),
    [anon_sym_export] = ACTIONS(1638),
    [anon_sym_default] = ACTIONS(1638),
    [anon_sym_EQ] = ACTIONS(1638),
    [anon_sym_namespace] = ACTIONS(1638),
    [anon_sym_LBRACE] = ACTIONS(1636),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_typeof] = ACTIONS(1638),
    [anon_sym_type] = ACTIONS(1638),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_declare] = ACTIONS(1638),
    [anon_sym_module] = ACTIONS(1638),
    [anon_sym_COLON] = ACTIONS(1636),
    [anon_sym_import] = ACTIONS(1638),
    [anon_sym_const] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1638),
    [anon_sym_var] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(1638),
    [anon_sym_BANG] = ACTIONS(1636),
    [anon_sym_else] = ACTIONS(1638),
    [anon_sym_if] = ACTIONS(1638),
    [anon_sym_switch] = ACTIONS(1638),
    [anon_sym_for] = ACTIONS(1638),
    [anon_sym_LPAREN] = ACTIONS(1636),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_await] = ACTIONS(1638),
    [anon_sym_while] = ACTIONS(1638),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_try] = ACTIONS(1638),
    [anon_sym_with] = ACTIONS(1638),
    [anon_sym_break] = ACTIONS(1638),
    [anon_sym_continue] = ACTIONS(1638),
    [anon_sym_debugger] = ACTIONS(1638),
    [anon_sym_return] = ACTIONS(1638),
    [anon_sym_throw] = ACTIONS(1638),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_case] = ACTIONS(1638),
    [anon_sym_yield] = ACTIONS(1638),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(1638),
    [anon_sym_async] = ACTIONS(1638),
    [anon_sym_function] = ACTIONS(1638),
    [anon_sym_EQ_GT] = ACTIONS(1636),
    [anon_sym_abstract] = ACTIONS(1638),
    [anon_sym_get] = ACTIONS(1638),
    [anon_sym_set] = ACTIONS(1638),
    [anon_sym_QMARK] = ACTIONS(1636),
    [anon_sym_extends] = ACTIONS(1638),
    [anon_sym_new] = ACTIONS(1638),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_DASH] = ACTIONS(1638),
    [anon_sym_SLASH] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_TILDE] = ACTIONS(1636),
    [anon_sym_void] = ACTIONS(1638),
    [anon_sym_delete] = ACTIONS(1638),
    [anon_sym_PLUS_PLUS] = ACTIONS(1636),
    [anon_sym_DASH_DASH] = ACTIONS(1636),
    [anon_sym_DQUOTE] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_float_literal] = ACTIONS(1636),
    [sym_hex_literal] = ACTIONS(1638),
    [sym_int_literal] = ACTIONS(1638),
    [sym_binary_literal] = ACTIONS(1638),
    [sym_octal_literal] = ACTIONS(1638),
    [sym_bigint_literal] = ACTIONS(1636),
    [sym_this] = ACTIONS(1638),
    [sym_super] = ACTIONS(1638),
    [sym_true] = ACTIONS(1638),
    [sym_false] = ACTIONS(1638),
    [sym_null] = ACTIONS(1638),
    [anon_sym_AT] = ACTIONS(1636),
    [anon_sym_static] = ACTIONS(1638),
    [anon_sym_public] = ACTIONS(1638),
    [anon_sym_private] = ACTIONS(1638),
    [anon_sym_protected] = ACTIONS(1638),
    [anon_sym_boolean] = ACTIONS(1638),
    [anon_sym_string] = ACTIONS(1638),
    [anon_sym_symbol] = ACTIONS(1638),
    [sym_readonly] = ACTIONS(1638),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1642),
    [anon_sym_export] = ACTIONS(1642),
    [anon_sym_default] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1642),
    [anon_sym_namespace] = ACTIONS(1642),
    [anon_sym_LBRACE] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(1642),
    [anon_sym_type] = ACTIONS(1642),
    [anon_sym_interface] = ACTIONS(1642),
    [anon_sym_declare] = ACTIONS(1642),
    [anon_sym_module] = ACTIONS(1642),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_import] = ACTIONS(1642),
    [anon_sym_const] = ACTIONS(1642),
    [anon_sym_enum] = ACTIONS(1642),
    [anon_sym_var] = ACTIONS(1642),
    [anon_sym_let] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1640),
    [anon_sym_else] = ACTIONS(1642),
    [anon_sym_if] = ACTIONS(1642),
    [anon_sym_switch] = ACTIONS(1642),
    [anon_sym_for] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_await] = ACTIONS(1642),
    [anon_sym_while] = ACTIONS(1642),
    [anon_sym_do] = ACTIONS(1642),
    [anon_sym_try] = ACTIONS(1642),
    [anon_sym_with] = ACTIONS(1642),
    [anon_sym_break] = ACTIONS(1642),
    [anon_sym_continue] = ACTIONS(1642),
    [anon_sym_debugger] = ACTIONS(1642),
    [anon_sym_return] = ACTIONS(1642),
    [anon_sym_throw] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1640),
    [anon_sym_case] = ACTIONS(1642),
    [anon_sym_yield] = ACTIONS(1642),
    [anon_sym_LBRACK] = ACTIONS(1640),
    [anon_sym_RBRACK] = ACTIONS(1640),
    [anon_sym_class] = ACTIONS(1642),
    [anon_sym_async] = ACTIONS(1642),
    [anon_sym_function] = ACTIONS(1642),
    [anon_sym_EQ_GT] = ACTIONS(1640),
    [anon_sym_abstract] = ACTIONS(1642),
    [anon_sym_get] = ACTIONS(1642),
    [anon_sym_set] = ACTIONS(1642),
    [anon_sym_QMARK] = ACTIONS(1640),
    [anon_sym_extends] = ACTIONS(1642),
    [anon_sym_new] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1640),
    [anon_sym_PIPE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_SLASH] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1640),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_void] = ACTIONS(1642),
    [anon_sym_delete] = ACTIONS(1642),
    [anon_sym_PLUS_PLUS] = ACTIONS(1640),
    [anon_sym_DASH_DASH] = ACTIONS(1640),
    [anon_sym_DQUOTE] = ACTIONS(1640),
    [anon_sym_SQUOTE] = ACTIONS(1640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1640),
    [sym_float_literal] = ACTIONS(1640),
    [sym_hex_literal] = ACTIONS(1642),
    [sym_int_literal] = ACTIONS(1642),
    [sym_binary_literal] = ACTIONS(1642),
    [sym_octal_literal] = ACTIONS(1642),
    [sym_bigint_literal] = ACTIONS(1640),
    [sym_this] = ACTIONS(1642),
    [sym_super] = ACTIONS(1642),
    [sym_true] = ACTIONS(1642),
    [sym_false] = ACTIONS(1642),
    [sym_null] = ACTIONS(1642),
    [anon_sym_AT] = ACTIONS(1640),
    [anon_sym_static] = ACTIONS(1642),
    [anon_sym_public] = ACTIONS(1642),
    [anon_sym_private] = ACTIONS(1642),
    [anon_sym_protected] = ACTIONS(1642),
    [anon_sym_boolean] = ACTIONS(1642),
    [anon_sym_string] = ACTIONS(1642),
    [anon_sym_symbol] = ACTIONS(1642),
    [sym_readonly] = ACTIONS(1642),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(1646),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_default] = ACTIONS(1646),
    [anon_sym_EQ] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_typeof] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_interface] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_import] = ACTIONS(1646),
    [anon_sym_const] = ACTIONS(1646),
    [anon_sym_enum] = ACTIONS(1646),
    [anon_sym_var] = ACTIONS(1646),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1646),
    [anon_sym_if] = ACTIONS(1646),
    [anon_sym_switch] = ACTIONS(1646),
    [anon_sym_for] = ACTIONS(1646),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_await] = ACTIONS(1646),
    [anon_sym_while] = ACTIONS(1646),
    [anon_sym_do] = ACTIONS(1646),
    [anon_sym_try] = ACTIONS(1646),
    [anon_sym_with] = ACTIONS(1646),
    [anon_sym_break] = ACTIONS(1646),
    [anon_sym_continue] = ACTIONS(1646),
    [anon_sym_debugger] = ACTIONS(1646),
    [anon_sym_return] = ACTIONS(1646),
    [anon_sym_throw] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_case] = ACTIONS(1646),
    [anon_sym_yield] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1644),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [anon_sym_class] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_function] = ACTIONS(1646),
    [anon_sym_EQ_GT] = ACTIONS(1644),
    [anon_sym_abstract] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(1644),
    [anon_sym_extends] = ACTIONS(1646),
    [anon_sym_new] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1646),
    [anon_sym_SLASH] = ACTIONS(1646),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_TILDE] = ACTIONS(1644),
    [anon_sym_void] = ACTIONS(1646),
    [anon_sym_delete] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1644),
    [anon_sym_DASH_DASH] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_SQUOTE] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [sym_float_literal] = ACTIONS(1644),
    [sym_hex_literal] = ACTIONS(1646),
    [sym_int_literal] = ACTIONS(1646),
    [sym_binary_literal] = ACTIONS(1646),
    [sym_octal_literal] = ACTIONS(1646),
    [sym_bigint_literal] = ACTIONS(1644),
    [sym_this] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_true] = ACTIONS(1646),
    [sym_false] = ACTIONS(1646),
    [sym_null] = ACTIONS(1646),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [sym_readonly] = ACTIONS(1646),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(1648),
    [sym_identifier] = ACTIONS(1650),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_default] = ACTIONS(1650),
    [anon_sym_EQ] = ACTIONS(1650),
    [anon_sym_namespace] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_typeof] = ACTIONS(1650),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_interface] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_COLON] = ACTIONS(1648),
    [anon_sym_import] = ACTIONS(1650),
    [anon_sym_const] = ACTIONS(1650),
    [anon_sym_enum] = ACTIONS(1650),
    [anon_sym_var] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_else] = ACTIONS(1650),
    [anon_sym_if] = ACTIONS(1650),
    [anon_sym_switch] = ACTIONS(1650),
    [anon_sym_for] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(1650),
    [anon_sym_while] = ACTIONS(1650),
    [anon_sym_do] = ACTIONS(1650),
    [anon_sym_try] = ACTIONS(1650),
    [anon_sym_with] = ACTIONS(1650),
    [anon_sym_break] = ACTIONS(1650),
    [anon_sym_continue] = ACTIONS(1650),
    [anon_sym_debugger] = ACTIONS(1650),
    [anon_sym_return] = ACTIONS(1650),
    [anon_sym_throw] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1650),
    [anon_sym_yield] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_async] = ACTIONS(1650),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1648),
    [anon_sym_abstract] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_QMARK] = ACTIONS(1648),
    [anon_sym_extends] = ACTIONS(1650),
    [anon_sym_new] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_SLASH] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1648),
    [anon_sym_GT] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_void] = ACTIONS(1650),
    [anon_sym_delete] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_float_literal] = ACTIONS(1648),
    [sym_hex_literal] = ACTIONS(1650),
    [sym_int_literal] = ACTIONS(1650),
    [sym_binary_literal] = ACTIONS(1650),
    [sym_octal_literal] = ACTIONS(1650),
    [sym_bigint_literal] = ACTIONS(1648),
    [sym_this] = ACTIONS(1650),
    [sym_super] = ACTIONS(1650),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [sym_readonly] = ACTIONS(1650),
  },
  [452] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1658),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [453] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1652),
    [anon_sym_set] = ACTIONS(1652),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [454] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2803),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [455] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2803),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1652),
    [anon_sym_set] = ACTIONS(1652),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [456] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2924),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1652),
    [anon_sym_set] = ACTIONS(1652),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [457] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2924),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1658),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [458] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2924),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [459] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1652),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [460] = {
    [sym_string] = STATE(2370),
    [sym__number_lit] = STATE(2226),
    [sym__property_name] = STATE(2370),
    [sym_computed_property_name] = STATE(2370),
    [aux_sym_object_repeat1] = STATE(2803),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1652),
    [anon_sym_declare] = ACTIONS(1652),
    [anon_sym_module] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1498),
    [sym_hex_literal] = ACTIONS(1500),
    [sym_int_literal] = ACTIONS(1500),
    [sym_binary_literal] = ACTIONS(1500),
    [sym_octal_literal] = ACTIONS(1500),
    [sym_bigint_literal] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1652),
    [anon_sym_public] = ACTIONS(1652),
    [anon_sym_private] = ACTIONS(1652),
    [anon_sym_protected] = ACTIONS(1652),
    [anon_sym_boolean] = ACTIONS(1652),
    [anon_sym_string] = ACTIONS(1652),
    [anon_sym_symbol] = ACTIONS(1652),
    [sym_readonly] = ACTIONS(1658),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [461] = {
    [sym_object] = STATE(2483),
    [sym_array] = STATE(2484),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(3284),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym__type] = STATE(2642),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2642),
    [sym_intersection_type] = STATE(2642),
    [sym_function_type] = STATE(2642),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2642),
    [aux_sym_export_statement_repeat1] = STATE(1938),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(1670),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1672),
    [anon_sym_private] = ACTIONS(1672),
    [anon_sym_protected] = ACTIONS(1672),
    [anon_sym_boolean] = ACTIONS(1674),
    [anon_sym_string] = ACTIONS(1674),
    [anon_sym_symbol] = ACTIONS(1674),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(1676),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [462] = {
    [sym_object] = STATE(2483),
    [sym_array] = STATE(2484),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(3284),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym__type] = STATE(2619),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2619),
    [sym_intersection_type] = STATE(2619),
    [sym_function_type] = STATE(2619),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2619),
    [aux_sym_export_statement_repeat1] = STATE(1938),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(1670),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1672),
    [anon_sym_private] = ACTIONS(1672),
    [anon_sym_protected] = ACTIONS(1672),
    [anon_sym_boolean] = ACTIONS(1674),
    [anon_sym_string] = ACTIONS(1674),
    [anon_sym_symbol] = ACTIONS(1674),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(1676),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [463] = {
    [sym_object] = STATE(2483),
    [sym_array] = STATE(2484),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(3284),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym__type] = STATE(2654),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1938),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(1670),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1672),
    [anon_sym_private] = ACTIONS(1672),
    [anon_sym_protected] = ACTIONS(1672),
    [anon_sym_boolean] = ACTIONS(1674),
    [anon_sym_string] = ACTIONS(1674),
    [anon_sym_symbol] = ACTIONS(1674),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(1676),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [464] = {
    [sym_object] = STATE(2483),
    [sym_array] = STATE(2484),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(3284),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym__type] = STATE(2655),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2655),
    [sym_intersection_type] = STATE(2655),
    [sym_function_type] = STATE(2655),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2655),
    [aux_sym_export_statement_repeat1] = STATE(1938),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(1670),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1672),
    [anon_sym_private] = ACTIONS(1672),
    [anon_sym_protected] = ACTIONS(1672),
    [anon_sym_boolean] = ACTIONS(1674),
    [anon_sym_string] = ACTIONS(1674),
    [anon_sym_symbol] = ACTIONS(1674),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(1676),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [465] = {
    [sym_object] = STATE(2483),
    [sym_array] = STATE(2484),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym_decorator] = STATE(1993),
    [sym__number] = STATE(420),
    [sym_optional_parameter] = STATE(2772),
    [sym_formal_parameters] = STATE(3284),
    [sym_rest_parameter] = STATE(2772),
    [sym_required_parameter] = STATE(2772),
    [sym__parameter_name] = STATE(2179),
    [sym__type] = STATE(2699),
    [sym__primary_type] = STATE(445),
    [sym_parenthesized_type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(445),
    [sym_object_type] = STATE(445),
    [sym__rest_identifier] = STATE(2701),
    [sym_accessibility_modifier] = STATE(1994),
    [sym_array_type] = STATE(445),
    [sym_tuple_type] = STATE(445),
    [sym__tuple_type_body] = STATE(440),
    [sym_flow_maybe_type] = STATE(445),
    [sym_type_query] = STATE(445),
    [sym_index_type_query] = STATE(445),
    [sym_existential_type] = STATE(445),
    [sym_literal_type] = STATE(445),
    [sym_lookup_type] = STATE(445),
    [sym_conditional_type] = STATE(445),
    [sym_union_type] = STATE(2699),
    [sym_intersection_type] = STATE(2699),
    [sym_function_type] = STATE(2699),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2699),
    [aux_sym_export_statement_repeat1] = STATE(1938),
    [sym_identifier] = ACTIONS(1660),
    [anon_sym_export] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(1662),
    [anon_sym_declare] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1662),
    [anon_sym_get] = ACTIONS(1662),
    [anon_sym_set] = ACTIONS(1662),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(1670),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1662),
    [anon_sym_public] = ACTIONS(1672),
    [anon_sym_private] = ACTIONS(1672),
    [anon_sym_protected] = ACTIONS(1672),
    [anon_sym_boolean] = ACTIONS(1674),
    [anon_sym_string] = ACTIONS(1674),
    [anon_sym_symbol] = ACTIONS(1674),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(1676),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [466] = {
    [sym_type_arguments] = STATE(418),
    [ts_builtin_sym_end] = ACTIONS(1590),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1592),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_interface] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_DOT] = ACTIONS(1678),
    [anon_sym_import] = ACTIONS(1592),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_enum] = ACTIONS(1592),
    [anon_sym_var] = ACTIONS(1592),
    [anon_sym_let] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1590),
    [anon_sym_else] = ACTIONS(1592),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_switch] = ACTIONS(1592),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_await] = ACTIONS(1592),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1592),
    [anon_sym_try] = ACTIONS(1592),
    [anon_sym_with] = ACTIONS(1592),
    [anon_sym_break] = ACTIONS(1592),
    [anon_sym_continue] = ACTIONS(1592),
    [anon_sym_debugger] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_throw] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_class] = ACTIONS(1592),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1592),
    [anon_sym_abstract] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_extends] = ACTIONS(1592),
    [anon_sym_new] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_void] = ACTIONS(1592),
    [anon_sym_delete] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_float_literal] = ACTIONS(1590),
    [sym_hex_literal] = ACTIONS(1592),
    [sym_int_literal] = ACTIONS(1592),
    [sym_binary_literal] = ACTIONS(1592),
    [sym_octal_literal] = ACTIONS(1592),
    [sym_bigint_literal] = ACTIONS(1590),
    [sym_this] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
    [sym_readonly] = ACTIONS(1592),
  },
  [467] = {
    [aux_sym_object_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_declare] = ACTIONS(1680),
    [anon_sym_module] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1682),
    [sym_hex_literal] = ACTIONS(1680),
    [sym_int_literal] = ACTIONS(1680),
    [sym_binary_literal] = ACTIONS(1680),
    [sym_octal_literal] = ACTIONS(1680),
    [sym_bigint_literal] = ACTIONS(1682),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_symbol] = ACTIONS(1680),
    [sym_readonly] = ACTIONS(1680),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [468] = {
    [aux_sym_object_repeat1] = STATE(2803),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_declare] = ACTIONS(1680),
    [anon_sym_module] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1682),
    [sym_hex_literal] = ACTIONS(1680),
    [sym_int_literal] = ACTIONS(1680),
    [sym_binary_literal] = ACTIONS(1680),
    [sym_octal_literal] = ACTIONS(1680),
    [sym_bigint_literal] = ACTIONS(1682),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_symbol] = ACTIONS(1680),
    [sym_readonly] = ACTIONS(1680),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [469] = {
    [sym_type_arguments] = STATE(418),
    [ts_builtin_sym_end] = ACTIONS(1684),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1686),
    [anon_sym_default] = ACTIONS(1686),
    [anon_sym_namespace] = ACTIONS(1686),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_RBRACE] = ACTIONS(1684),
    [anon_sym_typeof] = ACTIONS(1686),
    [anon_sym_type] = ACTIONS(1686),
    [anon_sym_interface] = ACTIONS(1686),
    [anon_sym_declare] = ACTIONS(1686),
    [anon_sym_module] = ACTIONS(1686),
    [anon_sym_DOT] = ACTIONS(1688),
    [anon_sym_import] = ACTIONS(1686),
    [anon_sym_const] = ACTIONS(1686),
    [anon_sym_enum] = ACTIONS(1686),
    [anon_sym_var] = ACTIONS(1686),
    [anon_sym_let] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1684),
    [anon_sym_else] = ACTIONS(1686),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_switch] = ACTIONS(1686),
    [anon_sym_for] = ACTIONS(1686),
    [anon_sym_LPAREN] = ACTIONS(1684),
    [anon_sym_await] = ACTIONS(1686),
    [anon_sym_while] = ACTIONS(1686),
    [anon_sym_do] = ACTIONS(1686),
    [anon_sym_try] = ACTIONS(1686),
    [anon_sym_with] = ACTIONS(1686),
    [anon_sym_break] = ACTIONS(1686),
    [anon_sym_continue] = ACTIONS(1686),
    [anon_sym_debugger] = ACTIONS(1686),
    [anon_sym_return] = ACTIONS(1686),
    [anon_sym_throw] = ACTIONS(1686),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1686),
    [anon_sym_yield] = ACTIONS(1686),
    [anon_sym_LBRACK] = ACTIONS(1684),
    [anon_sym_class] = ACTIONS(1686),
    [anon_sym_async] = ACTIONS(1686),
    [anon_sym_function] = ACTIONS(1686),
    [anon_sym_abstract] = ACTIONS(1686),
    [anon_sym_get] = ACTIONS(1686),
    [anon_sym_set] = ACTIONS(1686),
    [anon_sym_extends] = ACTIONS(1686),
    [anon_sym_new] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1684),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_SLASH] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1690),
    [anon_sym_TILDE] = ACTIONS(1684),
    [anon_sym_void] = ACTIONS(1686),
    [anon_sym_delete] = ACTIONS(1686),
    [anon_sym_PLUS_PLUS] = ACTIONS(1684),
    [anon_sym_DASH_DASH] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [anon_sym_SQUOTE] = ACTIONS(1684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [sym_float_literal] = ACTIONS(1684),
    [sym_hex_literal] = ACTIONS(1686),
    [sym_int_literal] = ACTIONS(1686),
    [sym_binary_literal] = ACTIONS(1686),
    [sym_octal_literal] = ACTIONS(1686),
    [sym_bigint_literal] = ACTIONS(1684),
    [sym_this] = ACTIONS(1686),
    [sym_super] = ACTIONS(1686),
    [sym_true] = ACTIONS(1686),
    [sym_false] = ACTIONS(1686),
    [sym_null] = ACTIONS(1686),
    [anon_sym_AT] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1686),
    [anon_sym_public] = ACTIONS(1686),
    [anon_sym_private] = ACTIONS(1686),
    [anon_sym_protected] = ACTIONS(1686),
    [anon_sym_boolean] = ACTIONS(1686),
    [anon_sym_string] = ACTIONS(1686),
    [anon_sym_symbol] = ACTIONS(1686),
    [sym_readonly] = ACTIONS(1686),
  },
  [470] = {
    [sym_type_arguments] = STATE(418),
    [ts_builtin_sym_end] = ACTIONS(1693),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_export] = ACTIONS(1695),
    [anon_sym_default] = ACTIONS(1695),
    [anon_sym_namespace] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1693),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_typeof] = ACTIONS(1695),
    [anon_sym_type] = ACTIONS(1695),
    [anon_sym_interface] = ACTIONS(1695),
    [anon_sym_declare] = ACTIONS(1695),
    [anon_sym_module] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(1688),
    [anon_sym_import] = ACTIONS(1695),
    [anon_sym_const] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(1695),
    [anon_sym_var] = ACTIONS(1695),
    [anon_sym_let] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_else] = ACTIONS(1695),
    [anon_sym_if] = ACTIONS(1695),
    [anon_sym_switch] = ACTIONS(1695),
    [anon_sym_for] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_await] = ACTIONS(1695),
    [anon_sym_while] = ACTIONS(1695),
    [anon_sym_do] = ACTIONS(1695),
    [anon_sym_try] = ACTIONS(1695),
    [anon_sym_with] = ACTIONS(1695),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_continue] = ACTIONS(1695),
    [anon_sym_debugger] = ACTIONS(1695),
    [anon_sym_return] = ACTIONS(1695),
    [anon_sym_throw] = ACTIONS(1695),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(1695),
    [anon_sym_yield] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1693),
    [anon_sym_class] = ACTIONS(1695),
    [anon_sym_async] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(1695),
    [anon_sym_abstract] = ACTIONS(1695),
    [anon_sym_get] = ACTIONS(1695),
    [anon_sym_set] = ACTIONS(1695),
    [anon_sym_extends] = ACTIONS(1695),
    [anon_sym_new] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1695),
    [anon_sym_SLASH] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_TILDE] = ACTIONS(1693),
    [anon_sym_void] = ACTIONS(1695),
    [anon_sym_delete] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1693),
    [anon_sym_DASH_DASH] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [sym_float_literal] = ACTIONS(1693),
    [sym_hex_literal] = ACTIONS(1695),
    [sym_int_literal] = ACTIONS(1695),
    [sym_binary_literal] = ACTIONS(1695),
    [sym_octal_literal] = ACTIONS(1695),
    [sym_bigint_literal] = ACTIONS(1693),
    [sym_this] = ACTIONS(1695),
    [sym_super] = ACTIONS(1695),
    [sym_true] = ACTIONS(1695),
    [sym_false] = ACTIONS(1695),
    [sym_null] = ACTIONS(1695),
    [anon_sym_AT] = ACTIONS(1693),
    [anon_sym_static] = ACTIONS(1695),
    [anon_sym_public] = ACTIONS(1695),
    [anon_sym_private] = ACTIONS(1695),
    [anon_sym_protected] = ACTIONS(1695),
    [anon_sym_boolean] = ACTIONS(1695),
    [anon_sym_string] = ACTIONS(1695),
    [anon_sym_symbol] = ACTIONS(1695),
    [sym_readonly] = ACTIONS(1695),
  },
  [471] = {
    [aux_sym_object_repeat1] = STATE(2924),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_declare] = ACTIONS(1680),
    [anon_sym_module] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(938),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_float_literal] = ACTIONS(1682),
    [sym_hex_literal] = ACTIONS(1680),
    [sym_int_literal] = ACTIONS(1680),
    [sym_binary_literal] = ACTIONS(1680),
    [sym_octal_literal] = ACTIONS(1680),
    [sym_bigint_literal] = ACTIONS(1682),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_symbol] = ACTIONS(1680),
    [sym_readonly] = ACTIONS(1680),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1590),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1592),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_interface] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_DOT] = ACTIONS(1678),
    [anon_sym_import] = ACTIONS(1592),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_enum] = ACTIONS(1592),
    [anon_sym_var] = ACTIONS(1592),
    [anon_sym_let] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1590),
    [anon_sym_else] = ACTIONS(1592),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_switch] = ACTIONS(1592),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_await] = ACTIONS(1592),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1592),
    [anon_sym_try] = ACTIONS(1592),
    [anon_sym_with] = ACTIONS(1592),
    [anon_sym_break] = ACTIONS(1592),
    [anon_sym_continue] = ACTIONS(1592),
    [anon_sym_debugger] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_throw] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_class] = ACTIONS(1592),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1592),
    [anon_sym_abstract] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_extends] = ACTIONS(1592),
    [anon_sym_new] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_void] = ACTIONS(1592),
    [anon_sym_delete] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_float_literal] = ACTIONS(1590),
    [sym_hex_literal] = ACTIONS(1592),
    [sym_int_literal] = ACTIONS(1592),
    [sym_binary_literal] = ACTIONS(1592),
    [sym_octal_literal] = ACTIONS(1592),
    [sym_bigint_literal] = ACTIONS(1590),
    [sym_this] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
    [sym_readonly] = ACTIONS(1592),
  },
  [473] = {
    [sym_type_arguments] = STATE(416),
    [ts_builtin_sym_end] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1699),
    [anon_sym_export] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_typeof] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1699),
    [anon_sym_interface] = ACTIONS(1699),
    [anon_sym_declare] = ACTIONS(1699),
    [anon_sym_module] = ACTIONS(1699),
    [anon_sym_import] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [anon_sym_var] = ACTIONS(1699),
    [anon_sym_let] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1697),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_with] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_debugger] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_throw] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_yield] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_class] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1699),
    [anon_sym_function] = ACTIONS(1699),
    [anon_sym_abstract] = ACTIONS(1699),
    [anon_sym_get] = ACTIONS(1699),
    [anon_sym_set] = ACTIONS(1699),
    [anon_sym_extends] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_TILDE] = ACTIONS(1697),
    [anon_sym_void] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_DASH_DASH] = ACTIONS(1697),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1697),
    [sym_float_literal] = ACTIONS(1697),
    [sym_hex_literal] = ACTIONS(1699),
    [sym_int_literal] = ACTIONS(1699),
    [sym_binary_literal] = ACTIONS(1699),
    [sym_octal_literal] = ACTIONS(1699),
    [sym_bigint_literal] = ACTIONS(1697),
    [sym_this] = ACTIONS(1699),
    [sym_super] = ACTIONS(1699),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [anon_sym_AT] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_public] = ACTIONS(1699),
    [anon_sym_private] = ACTIONS(1699),
    [anon_sym_protected] = ACTIONS(1699),
    [anon_sym_boolean] = ACTIONS(1699),
    [anon_sym_string] = ACTIONS(1699),
    [anon_sym_symbol] = ACTIONS(1699),
    [sym_readonly] = ACTIONS(1699),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1074),
    [anon_sym_type] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_declare] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1074),
    [anon_sym_import] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_debugger] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_throw] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_abstract] = ACTIONS(1074),
    [anon_sym_get] = ACTIONS(1074),
    [anon_sym_set] = ACTIONS(1074),
    [anon_sym_extends] = ACTIONS(1074),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1074),
    [anon_sym_delete] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
    [sym_hex_literal] = ACTIONS(1074),
    [sym_int_literal] = ACTIONS(1074),
    [sym_binary_literal] = ACTIONS(1074),
    [sym_octal_literal] = ACTIONS(1074),
    [sym_bigint_literal] = ACTIONS(1072),
    [sym_this] = ACTIONS(1074),
    [sym_super] = ACTIONS(1074),
    [sym_true] = ACTIONS(1074),
    [sym_false] = ACTIONS(1074),
    [sym_null] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1074),
    [anon_sym_public] = ACTIONS(1074),
    [anon_sym_private] = ACTIONS(1074),
    [anon_sym_protected] = ACTIONS(1074),
    [anon_sym_boolean] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [anon_sym_symbol] = ACTIONS(1074),
    [sym_readonly] = ACTIONS(1074),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_export] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_declare] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_var] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_debugger] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_catch] = ACTIONS(970),
    [anon_sym_finally] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_function] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(970),
    [anon_sym_set] = ACTIONS(970),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(970),
    [anon_sym_LT] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_void] = ACTIONS(970),
    [anon_sym_delete] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(968),
    [sym_float_literal] = ACTIONS(968),
    [sym_hex_literal] = ACTIONS(970),
    [sym_int_literal] = ACTIONS(970),
    [sym_binary_literal] = ACTIONS(970),
    [sym_octal_literal] = ACTIONS(970),
    [sym_bigint_literal] = ACTIONS(968),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [sym_readonly] = ACTIONS(970),
    [sym__automatic_semicolon] = ACTIONS(1707),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_export] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_COMMA] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_typeof] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(948),
    [anon_sym_declare] = ACTIONS(948),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(948),
    [anon_sym_let] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_await] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_with] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_debugger] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_throw] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_catch] = ACTIONS(948),
    [anon_sym_finally] = ACTIONS(948),
    [anon_sym_yield] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_function] = ACTIONS(948),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_get] = ACTIONS(948),
    [anon_sym_set] = ACTIONS(948),
    [anon_sym_new] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(948),
    [anon_sym_delete] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(946),
    [sym_float_literal] = ACTIONS(946),
    [sym_hex_literal] = ACTIONS(948),
    [sym_int_literal] = ACTIONS(948),
    [sym_binary_literal] = ACTIONS(948),
    [sym_octal_literal] = ACTIONS(948),
    [sym_bigint_literal] = ACTIONS(946),
    [sym_this] = ACTIONS(948),
    [sym_super] = ACTIONS(948),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_public] = ACTIONS(948),
    [anon_sym_private] = ACTIONS(948),
    [anon_sym_protected] = ACTIONS(948),
    [anon_sym_boolean] = ACTIONS(948),
    [anon_sym_string] = ACTIONS(948),
    [anon_sym_symbol] = ACTIONS(948),
    [sym_readonly] = ACTIONS(948),
    [sym__automatic_semicolon] = ACTIONS(954),
  },
  [477] = {
    [sym_catch_clause] = STATE(492),
    [sym_finally_clause] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(1709),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_export] = ACTIONS(1711),
    [anon_sym_default] = ACTIONS(1711),
    [anon_sym_namespace] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1709),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1711),
    [anon_sym_type] = ACTIONS(1711),
    [anon_sym_interface] = ACTIONS(1711),
    [anon_sym_declare] = ACTIONS(1711),
    [anon_sym_module] = ACTIONS(1711),
    [anon_sym_import] = ACTIONS(1711),
    [anon_sym_const] = ACTIONS(1711),
    [anon_sym_enum] = ACTIONS(1711),
    [anon_sym_var] = ACTIONS(1711),
    [anon_sym_let] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1709),
    [anon_sym_else] = ACTIONS(1711),
    [anon_sym_if] = ACTIONS(1711),
    [anon_sym_switch] = ACTIONS(1711),
    [anon_sym_for] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [anon_sym_await] = ACTIONS(1711),
    [anon_sym_while] = ACTIONS(1711),
    [anon_sym_do] = ACTIONS(1711),
    [anon_sym_try] = ACTIONS(1711),
    [anon_sym_with] = ACTIONS(1711),
    [anon_sym_break] = ACTIONS(1711),
    [anon_sym_continue] = ACTIONS(1711),
    [anon_sym_debugger] = ACTIONS(1711),
    [anon_sym_return] = ACTIONS(1711),
    [anon_sym_throw] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1709),
    [anon_sym_case] = ACTIONS(1711),
    [anon_sym_catch] = ACTIONS(1713),
    [anon_sym_finally] = ACTIONS(1715),
    [anon_sym_yield] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_class] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1711),
    [anon_sym_function] = ACTIONS(1711),
    [anon_sym_abstract] = ACTIONS(1711),
    [anon_sym_get] = ACTIONS(1711),
    [anon_sym_set] = ACTIONS(1711),
    [anon_sym_new] = ACTIONS(1711),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_void] = ACTIONS(1711),
    [anon_sym_delete] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1709),
    [anon_sym_DASH_DASH] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_SQUOTE] = ACTIONS(1709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [sym_float_literal] = ACTIONS(1709),
    [sym_hex_literal] = ACTIONS(1711),
    [sym_int_literal] = ACTIONS(1711),
    [sym_binary_literal] = ACTIONS(1711),
    [sym_octal_literal] = ACTIONS(1711),
    [sym_bigint_literal] = ACTIONS(1709),
    [sym_this] = ACTIONS(1711),
    [sym_super] = ACTIONS(1711),
    [sym_true] = ACTIONS(1711),
    [sym_false] = ACTIONS(1711),
    [sym_null] = ACTIONS(1711),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_static] = ACTIONS(1711),
    [anon_sym_public] = ACTIONS(1711),
    [anon_sym_private] = ACTIONS(1711),
    [anon_sym_protected] = ACTIONS(1711),
    [anon_sym_boolean] = ACTIONS(1711),
    [anon_sym_string] = ACTIONS(1711),
    [anon_sym_symbol] = ACTIONS(1711),
    [sym_readonly] = ACTIONS(1711),
  },
  [478] = {
    [sym_type_arguments] = STATE(416),
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_extends] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_float_literal] = ACTIONS(1586),
    [sym_hex_literal] = ACTIONS(1588),
    [sym_int_literal] = ACTIONS(1588),
    [sym_binary_literal] = ACTIONS(1588),
    [sym_octal_literal] = ACTIONS(1588),
    [sym_bigint_literal] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [sym_readonly] = ACTIONS(1588),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(994),
    [sym_identifier] = ACTIONS(996),
    [anon_sym_export] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_namespace] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_typeof] = ACTIONS(996),
    [anon_sym_type] = ACTIONS(996),
    [anon_sym_interface] = ACTIONS(996),
    [anon_sym_declare] = ACTIONS(996),
    [anon_sym_module] = ACTIONS(996),
    [anon_sym_import] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_var] = ACTIONS(996),
    [anon_sym_let] = ACTIONS(996),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_await] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_try] = ACTIONS(996),
    [anon_sym_with] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_debugger] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_throw] = ACTIONS(996),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_yield] = ACTIONS(996),
    [anon_sym_LBRACK] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(996),
    [anon_sym_function] = ACTIONS(996),
    [anon_sym_abstract] = ACTIONS(996),
    [anon_sym_get] = ACTIONS(996),
    [anon_sym_set] = ACTIONS(996),
    [anon_sym_new] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_void] = ACTIONS(996),
    [anon_sym_delete] = ACTIONS(996),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(994),
    [sym_float_literal] = ACTIONS(994),
    [sym_hex_literal] = ACTIONS(996),
    [sym_int_literal] = ACTIONS(996),
    [sym_binary_literal] = ACTIONS(996),
    [sym_octal_literal] = ACTIONS(996),
    [sym_bigint_literal] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(996),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_public] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym_protected] = ACTIONS(996),
    [anon_sym_boolean] = ACTIONS(996),
    [anon_sym_string] = ACTIONS(996),
    [anon_sym_symbol] = ACTIONS(996),
    [anon_sym_PIPE_RBRACE] = ACTIONS(994),
    [sym_readonly] = ACTIONS(996),
    [sym__automatic_semicolon] = ACTIONS(994),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_export] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_COMMA] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_typeof] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(948),
    [anon_sym_declare] = ACTIONS(948),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(948),
    [anon_sym_let] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_await] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_with] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_debugger] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_throw] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_yield] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_function] = ACTIONS(948),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_get] = ACTIONS(948),
    [anon_sym_set] = ACTIONS(948),
    [anon_sym_new] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(948),
    [anon_sym_delete] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(946),
    [sym_float_literal] = ACTIONS(946),
    [sym_hex_literal] = ACTIONS(948),
    [sym_int_literal] = ACTIONS(948),
    [sym_binary_literal] = ACTIONS(948),
    [sym_octal_literal] = ACTIONS(948),
    [sym_bigint_literal] = ACTIONS(946),
    [sym_this] = ACTIONS(948),
    [sym_super] = ACTIONS(948),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_public] = ACTIONS(948),
    [anon_sym_private] = ACTIONS(948),
    [anon_sym_protected] = ACTIONS(948),
    [anon_sym_boolean] = ACTIONS(948),
    [anon_sym_string] = ACTIONS(948),
    [anon_sym_symbol] = ACTIONS(948),
    [anon_sym_PIPE_RBRACE] = ACTIONS(946),
    [sym_readonly] = ACTIONS(948),
    [sym__automatic_semicolon] = ACTIONS(1717),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_export] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_declare] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_var] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_debugger] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_catch] = ACTIONS(970),
    [anon_sym_finally] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_function] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(970),
    [anon_sym_set] = ACTIONS(970),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(970),
    [anon_sym_LT] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_void] = ACTIONS(970),
    [anon_sym_delete] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(968),
    [sym_float_literal] = ACTIONS(968),
    [sym_hex_literal] = ACTIONS(970),
    [sym_int_literal] = ACTIONS(970),
    [sym_binary_literal] = ACTIONS(970),
    [sym_octal_literal] = ACTIONS(970),
    [sym_bigint_literal] = ACTIONS(968),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [sym_readonly] = ACTIONS(970),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1140),
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_export] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_namespace] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RBRACE] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1142),
    [anon_sym_interface] = ACTIONS(1142),
    [anon_sym_declare] = ACTIONS(1142),
    [anon_sym_module] = ACTIONS(1142),
    [anon_sym_import] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_enum] = ACTIONS(1142),
    [anon_sym_var] = ACTIONS(1142),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(1142),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_await] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_do] = ACTIONS(1142),
    [anon_sym_try] = ACTIONS(1142),
    [anon_sym_with] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_debugger] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_throw] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_yield] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1142),
    [anon_sym_async] = ACTIONS(1142),
    [anon_sym_function] = ACTIONS(1142),
    [anon_sym_abstract] = ACTIONS(1142),
    [anon_sym_get] = ACTIONS(1142),
    [anon_sym_set] = ACTIONS(1142),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_void] = ACTIONS(1142),
    [anon_sym_delete] = ACTIONS(1142),
    [anon_sym_PLUS_PLUS] = ACTIONS(1140),
    [anon_sym_DASH_DASH] = ACTIONS(1140),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_SQUOTE] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1140),
    [sym_float_literal] = ACTIONS(1140),
    [sym_hex_literal] = ACTIONS(1142),
    [sym_int_literal] = ACTIONS(1142),
    [sym_binary_literal] = ACTIONS(1142),
    [sym_octal_literal] = ACTIONS(1142),
    [sym_bigint_literal] = ACTIONS(1140),
    [sym_this] = ACTIONS(1142),
    [sym_super] = ACTIONS(1142),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [anon_sym_AT] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_public] = ACTIONS(1142),
    [anon_sym_private] = ACTIONS(1142),
    [anon_sym_protected] = ACTIONS(1142),
    [anon_sym_boolean] = ACTIONS(1142),
    [anon_sym_string] = ACTIONS(1142),
    [anon_sym_symbol] = ACTIONS(1142),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1140),
    [sym_readonly] = ACTIONS(1142),
    [sym__automatic_semicolon] = ACTIONS(1140),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1144),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_export] = ACTIONS(1146),
    [anon_sym_default] = ACTIONS(1146),
    [anon_sym_namespace] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_COMMA] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1146),
    [anon_sym_type] = ACTIONS(1146),
    [anon_sym_interface] = ACTIONS(1146),
    [anon_sym_declare] = ACTIONS(1146),
    [anon_sym_module] = ACTIONS(1146),
    [anon_sym_import] = ACTIONS(1146),
    [anon_sym_const] = ACTIONS(1146),
    [anon_sym_enum] = ACTIONS(1146),
    [anon_sym_var] = ACTIONS(1146),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1146),
    [anon_sym_switch] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [anon_sym_await] = ACTIONS(1146),
    [anon_sym_while] = ACTIONS(1146),
    [anon_sym_do] = ACTIONS(1146),
    [anon_sym_try] = ACTIONS(1146),
    [anon_sym_with] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [anon_sym_debugger] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_throw] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1144),
    [anon_sym_case] = ACTIONS(1146),
    [anon_sym_yield] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1146),
    [anon_sym_async] = ACTIONS(1146),
    [anon_sym_function] = ACTIONS(1146),
    [anon_sym_abstract] = ACTIONS(1146),
    [anon_sym_get] = ACTIONS(1146),
    [anon_sym_set] = ACTIONS(1146),
    [anon_sym_new] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_SLASH] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1146),
    [anon_sym_delete] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1144),
    [anon_sym_DASH_DASH] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1144),
    [sym_float_literal] = ACTIONS(1144),
    [sym_hex_literal] = ACTIONS(1146),
    [sym_int_literal] = ACTIONS(1146),
    [sym_binary_literal] = ACTIONS(1146),
    [sym_octal_literal] = ACTIONS(1146),
    [sym_bigint_literal] = ACTIONS(1144),
    [sym_this] = ACTIONS(1146),
    [sym_super] = ACTIONS(1146),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_null] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1144),
    [anon_sym_static] = ACTIONS(1146),
    [anon_sym_public] = ACTIONS(1146),
    [anon_sym_private] = ACTIONS(1146),
    [anon_sym_protected] = ACTIONS(1146),
    [anon_sym_boolean] = ACTIONS(1146),
    [anon_sym_string] = ACTIONS(1146),
    [anon_sym_symbol] = ACTIONS(1146),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1144),
    [sym_readonly] = ACTIONS(1146),
    [sym__automatic_semicolon] = ACTIONS(1144),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(1140),
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_export] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_namespace] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RBRACE] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1142),
    [anon_sym_interface] = ACTIONS(1142),
    [anon_sym_declare] = ACTIONS(1142),
    [anon_sym_module] = ACTIONS(1142),
    [anon_sym_import] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_enum] = ACTIONS(1142),
    [anon_sym_var] = ACTIONS(1142),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(1142),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_await] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_do] = ACTIONS(1142),
    [anon_sym_try] = ACTIONS(1142),
    [anon_sym_with] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_debugger] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_throw] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_catch] = ACTIONS(1142),
    [anon_sym_finally] = ACTIONS(1142),
    [anon_sym_yield] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1142),
    [anon_sym_async] = ACTIONS(1142),
    [anon_sym_function] = ACTIONS(1142),
    [anon_sym_abstract] = ACTIONS(1142),
    [anon_sym_get] = ACTIONS(1142),
    [anon_sym_set] = ACTIONS(1142),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_void] = ACTIONS(1142),
    [anon_sym_delete] = ACTIONS(1142),
    [anon_sym_PLUS_PLUS] = ACTIONS(1140),
    [anon_sym_DASH_DASH] = ACTIONS(1140),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_SQUOTE] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1140),
    [sym_float_literal] = ACTIONS(1140),
    [sym_hex_literal] = ACTIONS(1142),
    [sym_int_literal] = ACTIONS(1142),
    [sym_binary_literal] = ACTIONS(1142),
    [sym_octal_literal] = ACTIONS(1142),
    [sym_bigint_literal] = ACTIONS(1140),
    [sym_this] = ACTIONS(1142),
    [sym_super] = ACTIONS(1142),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [anon_sym_AT] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_public] = ACTIONS(1142),
    [anon_sym_private] = ACTIONS(1142),
    [anon_sym_protected] = ACTIONS(1142),
    [anon_sym_boolean] = ACTIONS(1142),
    [anon_sym_string] = ACTIONS(1142),
    [anon_sym_symbol] = ACTIONS(1142),
    [sym_readonly] = ACTIONS(1142),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(1719),
    [sym_identifier] = ACTIONS(1721),
    [anon_sym_export] = ACTIONS(1721),
    [anon_sym_default] = ACTIONS(1721),
    [anon_sym_namespace] = ACTIONS(1721),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_typeof] = ACTIONS(1721),
    [anon_sym_type] = ACTIONS(1721),
    [anon_sym_interface] = ACTIONS(1721),
    [anon_sym_declare] = ACTIONS(1721),
    [anon_sym_module] = ACTIONS(1721),
    [anon_sym_import] = ACTIONS(1721),
    [anon_sym_const] = ACTIONS(1721),
    [anon_sym_enum] = ACTIONS(1721),
    [anon_sym_var] = ACTIONS(1721),
    [anon_sym_let] = ACTIONS(1721),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_else] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1721),
    [anon_sym_switch] = ACTIONS(1721),
    [anon_sym_for] = ACTIONS(1721),
    [anon_sym_LPAREN] = ACTIONS(1719),
    [anon_sym_await] = ACTIONS(1721),
    [anon_sym_while] = ACTIONS(1721),
    [anon_sym_do] = ACTIONS(1721),
    [anon_sym_try] = ACTIONS(1721),
    [anon_sym_with] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_continue] = ACTIONS(1721),
    [anon_sym_debugger] = ACTIONS(1721),
    [anon_sym_return] = ACTIONS(1721),
    [anon_sym_throw] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_case] = ACTIONS(1721),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_class] = ACTIONS(1721),
    [anon_sym_async] = ACTIONS(1721),
    [anon_sym_function] = ACTIONS(1721),
    [anon_sym_abstract] = ACTIONS(1721),
    [anon_sym_get] = ACTIONS(1721),
    [anon_sym_set] = ACTIONS(1721),
    [anon_sym_extends] = ACTIONS(1721),
    [anon_sym_new] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_DASH] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_TILDE] = ACTIONS(1719),
    [anon_sym_void] = ACTIONS(1721),
    [anon_sym_delete] = ACTIONS(1721),
    [anon_sym_PLUS_PLUS] = ACTIONS(1719),
    [anon_sym_DASH_DASH] = ACTIONS(1719),
    [anon_sym_DQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1719),
    [sym_float_literal] = ACTIONS(1719),
    [sym_hex_literal] = ACTIONS(1721),
    [sym_int_literal] = ACTIONS(1721),
    [sym_binary_literal] = ACTIONS(1721),
    [sym_octal_literal] = ACTIONS(1721),
    [sym_bigint_literal] = ACTIONS(1719),
    [sym_this] = ACTIONS(1721),
    [sym_super] = ACTIONS(1721),
    [sym_true] = ACTIONS(1721),
    [sym_false] = ACTIONS(1721),
    [sym_null] = ACTIONS(1721),
    [anon_sym_AT] = ACTIONS(1719),
    [anon_sym_static] = ACTIONS(1721),
    [anon_sym_public] = ACTIONS(1721),
    [anon_sym_private] = ACTIONS(1721),
    [anon_sym_protected] = ACTIONS(1721),
    [anon_sym_boolean] = ACTIONS(1721),
    [anon_sym_string] = ACTIONS(1721),
    [anon_sym_symbol] = ACTIONS(1721),
    [sym_readonly] = ACTIONS(1721),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_export] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_declare] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_var] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_debugger] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_function] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(970),
    [anon_sym_set] = ACTIONS(970),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(970),
    [anon_sym_LT] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_void] = ACTIONS(970),
    [anon_sym_delete] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(968),
    [sym_float_literal] = ACTIONS(968),
    [sym_hex_literal] = ACTIONS(970),
    [sym_int_literal] = ACTIONS(970),
    [sym_binary_literal] = ACTIONS(970),
    [sym_octal_literal] = ACTIONS(970),
    [sym_bigint_literal] = ACTIONS(968),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [anon_sym_PIPE_RBRACE] = ACTIONS(968),
    [sym_readonly] = ACTIONS(970),
    [sym__automatic_semicolon] = ACTIONS(1727),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1729),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_default] = ACTIONS(1731),
    [anon_sym_namespace] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym_type] = ACTIONS(1731),
    [anon_sym_interface] = ACTIONS(1731),
    [anon_sym_declare] = ACTIONS(1731),
    [anon_sym_module] = ACTIONS(1731),
    [anon_sym_import] = ACTIONS(1731),
    [anon_sym_const] = ACTIONS(1731),
    [anon_sym_enum] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1731),
    [anon_sym_let] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_else] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(1731),
    [anon_sym_switch] = ACTIONS(1731),
    [anon_sym_for] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_while] = ACTIONS(1731),
    [anon_sym_do] = ACTIONS(1731),
    [anon_sym_try] = ACTIONS(1731),
    [anon_sym_with] = ACTIONS(1731),
    [anon_sym_break] = ACTIONS(1731),
    [anon_sym_continue] = ACTIONS(1731),
    [anon_sym_debugger] = ACTIONS(1731),
    [anon_sym_return] = ACTIONS(1731),
    [anon_sym_throw] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_yield] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_class] = ACTIONS(1731),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(1731),
    [anon_sym_abstract] = ACTIONS(1731),
    [anon_sym_get] = ACTIONS(1731),
    [anon_sym_set] = ACTIONS(1731),
    [anon_sym_extends] = ACTIONS(1733),
    [anon_sym_new] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_void] = ACTIONS(1731),
    [anon_sym_delete] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [sym_float_literal] = ACTIONS(1729),
    [sym_hex_literal] = ACTIONS(1731),
    [sym_int_literal] = ACTIONS(1731),
    [sym_binary_literal] = ACTIONS(1731),
    [sym_octal_literal] = ACTIONS(1731),
    [sym_bigint_literal] = ACTIONS(1729),
    [sym_this] = ACTIONS(1731),
    [sym_super] = ACTIONS(1731),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1731),
    [anon_sym_public] = ACTIONS(1731),
    [anon_sym_private] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1731),
    [anon_sym_boolean] = ACTIONS(1731),
    [anon_sym_string] = ACTIONS(1731),
    [anon_sym_symbol] = ACTIONS(1731),
    [sym_readonly] = ACTIONS(1731),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_export] = ACTIONS(1737),
    [anon_sym_default] = ACTIONS(1737),
    [anon_sym_namespace] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_typeof] = ACTIONS(1737),
    [anon_sym_type] = ACTIONS(1737),
    [anon_sym_interface] = ACTIONS(1737),
    [anon_sym_declare] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1737),
    [anon_sym_import] = ACTIONS(1737),
    [anon_sym_const] = ACTIONS(1737),
    [anon_sym_enum] = ACTIONS(1737),
    [anon_sym_var] = ACTIONS(1737),
    [anon_sym_let] = ACTIONS(1737),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_else] = ACTIONS(1737),
    [anon_sym_if] = ACTIONS(1737),
    [anon_sym_switch] = ACTIONS(1737),
    [anon_sym_for] = ACTIONS(1737),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_await] = ACTIONS(1737),
    [anon_sym_while] = ACTIONS(1737),
    [anon_sym_do] = ACTIONS(1737),
    [anon_sym_try] = ACTIONS(1737),
    [anon_sym_with] = ACTIONS(1737),
    [anon_sym_break] = ACTIONS(1737),
    [anon_sym_continue] = ACTIONS(1737),
    [anon_sym_debugger] = ACTIONS(1737),
    [anon_sym_return] = ACTIONS(1737),
    [anon_sym_throw] = ACTIONS(1737),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_case] = ACTIONS(1737),
    [anon_sym_yield] = ACTIONS(1737),
    [anon_sym_LBRACK] = ACTIONS(1735),
    [anon_sym_class] = ACTIONS(1737),
    [anon_sym_async] = ACTIONS(1737),
    [anon_sym_function] = ACTIONS(1737),
    [anon_sym_abstract] = ACTIONS(1737),
    [anon_sym_get] = ACTIONS(1737),
    [anon_sym_set] = ACTIONS(1737),
    [anon_sym_extends] = ACTIONS(1733),
    [anon_sym_new] = ACTIONS(1737),
    [anon_sym_AMP] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1737),
    [anon_sym_DASH] = ACTIONS(1737),
    [anon_sym_SLASH] = ACTIONS(1737),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(1735),
    [anon_sym_void] = ACTIONS(1737),
    [anon_sym_delete] = ACTIONS(1737),
    [anon_sym_PLUS_PLUS] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1735),
    [anon_sym_DQUOTE] = ACTIONS(1735),
    [anon_sym_SQUOTE] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1735),
    [sym_float_literal] = ACTIONS(1735),
    [sym_hex_literal] = ACTIONS(1737),
    [sym_int_literal] = ACTIONS(1737),
    [sym_binary_literal] = ACTIONS(1737),
    [sym_octal_literal] = ACTIONS(1737),
    [sym_bigint_literal] = ACTIONS(1735),
    [sym_this] = ACTIONS(1737),
    [sym_super] = ACTIONS(1737),
    [sym_true] = ACTIONS(1737),
    [sym_false] = ACTIONS(1737),
    [sym_null] = ACTIONS(1737),
    [anon_sym_AT] = ACTIONS(1735),
    [anon_sym_static] = ACTIONS(1737),
    [anon_sym_public] = ACTIONS(1737),
    [anon_sym_private] = ACTIONS(1737),
    [anon_sym_protected] = ACTIONS(1737),
    [anon_sym_boolean] = ACTIONS(1737),
    [anon_sym_string] = ACTIONS(1737),
    [anon_sym_symbol] = ACTIONS(1737),
    [sym_readonly] = ACTIONS(1737),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1741),
    [anon_sym_export] = ACTIONS(1741),
    [anon_sym_default] = ACTIONS(1741),
    [anon_sym_namespace] = ACTIONS(1741),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_typeof] = ACTIONS(1741),
    [anon_sym_type] = ACTIONS(1741),
    [anon_sym_interface] = ACTIONS(1741),
    [anon_sym_declare] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1741),
    [anon_sym_import] = ACTIONS(1741),
    [anon_sym_const] = ACTIONS(1741),
    [anon_sym_enum] = ACTIONS(1741),
    [anon_sym_var] = ACTIONS(1741),
    [anon_sym_let] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_else] = ACTIONS(1741),
    [anon_sym_if] = ACTIONS(1741),
    [anon_sym_switch] = ACTIONS(1741),
    [anon_sym_for] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1739),
    [anon_sym_await] = ACTIONS(1741),
    [anon_sym_while] = ACTIONS(1741),
    [anon_sym_do] = ACTIONS(1741),
    [anon_sym_try] = ACTIONS(1741),
    [anon_sym_with] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1741),
    [anon_sym_continue] = ACTIONS(1741),
    [anon_sym_debugger] = ACTIONS(1741),
    [anon_sym_return] = ACTIONS(1741),
    [anon_sym_throw] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_case] = ACTIONS(1741),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(1739),
    [anon_sym_class] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(1741),
    [anon_sym_function] = ACTIONS(1741),
    [anon_sym_abstract] = ACTIONS(1741),
    [anon_sym_get] = ACTIONS(1741),
    [anon_sym_set] = ACTIONS(1741),
    [anon_sym_extends] = ACTIONS(1733),
    [anon_sym_new] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1741),
    [anon_sym_SLASH] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1739),
    [anon_sym_void] = ACTIONS(1741),
    [anon_sym_delete] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1739),
    [anon_sym_DASH_DASH] = ACTIONS(1739),
    [anon_sym_DQUOTE] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1739),
    [sym_float_literal] = ACTIONS(1739),
    [sym_hex_literal] = ACTIONS(1741),
    [sym_int_literal] = ACTIONS(1741),
    [sym_binary_literal] = ACTIONS(1741),
    [sym_octal_literal] = ACTIONS(1741),
    [sym_bigint_literal] = ACTIONS(1739),
    [sym_this] = ACTIONS(1741),
    [sym_super] = ACTIONS(1741),
    [sym_true] = ACTIONS(1741),
    [sym_false] = ACTIONS(1741),
    [sym_null] = ACTIONS(1741),
    [anon_sym_AT] = ACTIONS(1739),
    [anon_sym_static] = ACTIONS(1741),
    [anon_sym_public] = ACTIONS(1741),
    [anon_sym_private] = ACTIONS(1741),
    [anon_sym_protected] = ACTIONS(1741),
    [anon_sym_boolean] = ACTIONS(1741),
    [anon_sym_string] = ACTIONS(1741),
    [anon_sym_symbol] = ACTIONS(1741),
    [sym_readonly] = ACTIONS(1741),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_export] = ACTIONS(970),
    [anon_sym_default] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_declare] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_var] = ACTIONS(970),
    [anon_sym_let] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_do] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_debugger] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_throw] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_function] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(970),
    [anon_sym_set] = ACTIONS(970),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_PLUS] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(970),
    [anon_sym_LT] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_void] = ACTIONS(970),
    [anon_sym_delete] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(968),
    [sym_float_literal] = ACTIONS(968),
    [sym_hex_literal] = ACTIONS(970),
    [sym_int_literal] = ACTIONS(970),
    [sym_binary_literal] = ACTIONS(970),
    [sym_octal_literal] = ACTIONS(970),
    [sym_bigint_literal] = ACTIONS(968),
    [sym_this] = ACTIONS(970),
    [sym_super] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_null] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_boolean] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_symbol] = ACTIONS(970),
    [anon_sym_PIPE_RBRACE] = ACTIONS(968),
    [sym_readonly] = ACTIONS(970),
    [sym__automatic_semicolon] = ACTIONS(968),
  },
  [491] = {
    [sym__call_signature] = STATE(3187),
    [sym_arguments] = STATE(1218),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_arguments] = STATE(1089),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_export] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(1749),
    [anon_sym_RBRACE] = ACTIONS(1749),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_declare] = ACTIONS(1745),
    [anon_sym_module] = ACTIONS(1745),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_RPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_of] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(1749),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1745),
    [anon_sym_set] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_public] = ACTIONS(1745),
    [anon_sym_private] = ACTIONS(1745),
    [anon_sym_protected] = ACTIONS(1745),
    [anon_sym_boolean] = ACTIONS(1745),
    [anon_sym_string] = ACTIONS(1745),
    [anon_sym_symbol] = ACTIONS(1745),
    [sym_readonly] = ACTIONS(1745),
  },
  [492] = {
    [sym_finally_clause] = STATE(623),
    [ts_builtin_sym_end] = ACTIONS(1757),
    [sym_identifier] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(1759),
    [anon_sym_default] = ACTIONS(1759),
    [anon_sym_namespace] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1757),
    [anon_sym_RBRACE] = ACTIONS(1757),
    [anon_sym_typeof] = ACTIONS(1759),
    [anon_sym_type] = ACTIONS(1759),
    [anon_sym_interface] = ACTIONS(1759),
    [anon_sym_declare] = ACTIONS(1759),
    [anon_sym_module] = ACTIONS(1759),
    [anon_sym_import] = ACTIONS(1759),
    [anon_sym_const] = ACTIONS(1759),
    [anon_sym_enum] = ACTIONS(1759),
    [anon_sym_var] = ACTIONS(1759),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1759),
    [anon_sym_switch] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(1757),
    [anon_sym_await] = ACTIONS(1759),
    [anon_sym_while] = ACTIONS(1759),
    [anon_sym_do] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(1759),
    [anon_sym_with] = ACTIONS(1759),
    [anon_sym_break] = ACTIONS(1759),
    [anon_sym_continue] = ACTIONS(1759),
    [anon_sym_debugger] = ACTIONS(1759),
    [anon_sym_return] = ACTIONS(1759),
    [anon_sym_throw] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1757),
    [anon_sym_case] = ACTIONS(1759),
    [anon_sym_finally] = ACTIONS(1715),
    [anon_sym_yield] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1757),
    [anon_sym_class] = ACTIONS(1759),
    [anon_sym_async] = ACTIONS(1759),
    [anon_sym_function] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(1759),
    [anon_sym_get] = ACTIONS(1759),
    [anon_sym_set] = ACTIONS(1759),
    [anon_sym_new] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_void] = ACTIONS(1759),
    [anon_sym_delete] = ACTIONS(1759),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_SQUOTE] = ACTIONS(1757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1757),
    [sym_float_literal] = ACTIONS(1757),
    [sym_hex_literal] = ACTIONS(1759),
    [sym_int_literal] = ACTIONS(1759),
    [sym_binary_literal] = ACTIONS(1759),
    [sym_octal_literal] = ACTIONS(1759),
    [sym_bigint_literal] = ACTIONS(1757),
    [sym_this] = ACTIONS(1759),
    [sym_super] = ACTIONS(1759),
    [sym_true] = ACTIONS(1759),
    [sym_false] = ACTIONS(1759),
    [sym_null] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(1757),
    [anon_sym_static] = ACTIONS(1759),
    [anon_sym_public] = ACTIONS(1759),
    [anon_sym_private] = ACTIONS(1759),
    [anon_sym_protected] = ACTIONS(1759),
    [anon_sym_boolean] = ACTIONS(1759),
    [anon_sym_string] = ACTIONS(1759),
    [anon_sym_symbol] = ACTIONS(1759),
    [sym_readonly] = ACTIONS(1759),
  },
  [493] = {
    [sym_statement_block] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_namespace] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(1761),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_interface] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_DOT] = ACTIONS(1763),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_var] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_await] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_with] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_debugger] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_throw] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_function] = ACTIONS(958),
    [anon_sym_abstract] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_new] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(958),
    [anon_sym_LT] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
    [sym_hex_literal] = ACTIONS(958),
    [sym_int_literal] = ACTIONS(958),
    [sym_binary_literal] = ACTIONS(958),
    [sym_octal_literal] = ACTIONS(958),
    [sym_bigint_literal] = ACTIONS(956),
    [sym_this] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [sym_readonly] = ACTIONS(958),
  },
  [494] = {
    [sym__call_signature] = STATE(3296),
    [sym_arguments] = STATE(1693),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_arguments] = STATE(1411),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_export] = ACTIONS(1767),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(1767),
    [anon_sym_COMMA] = ACTIONS(1749),
    [anon_sym_RBRACE] = ACTIONS(1749),
    [anon_sym_type] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1767),
    [anon_sym_module] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_of] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(1769),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1767),
    [anon_sym_set] = ACTIONS(1767),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1767),
    [anon_sym_public] = ACTIONS(1767),
    [anon_sym_private] = ACTIONS(1767),
    [anon_sym_protected] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [sym_readonly] = ACTIONS(1767),
    [sym__automatic_semicolon] = ACTIONS(1749),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(1771),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_export] = ACTIONS(1773),
    [anon_sym_default] = ACTIONS(1773),
    [anon_sym_namespace] = ACTIONS(1773),
    [anon_sym_LBRACE] = ACTIONS(1771),
    [anon_sym_RBRACE] = ACTIONS(1771),
    [anon_sym_typeof] = ACTIONS(1773),
    [anon_sym_type] = ACTIONS(1773),
    [anon_sym_interface] = ACTIONS(1773),
    [anon_sym_declare] = ACTIONS(1773),
    [anon_sym_module] = ACTIONS(1773),
    [anon_sym_import] = ACTIONS(1773),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_enum] = ACTIONS(1773),
    [anon_sym_var] = ACTIONS(1773),
    [anon_sym_let] = ACTIONS(1773),
    [anon_sym_BANG] = ACTIONS(1771),
    [anon_sym_else] = ACTIONS(1773),
    [anon_sym_if] = ACTIONS(1773),
    [anon_sym_switch] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(1773),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_RPAREN] = ACTIONS(1771),
    [anon_sym_await] = ACTIONS(1773),
    [anon_sym_while] = ACTIONS(1773),
    [anon_sym_do] = ACTIONS(1773),
    [anon_sym_try] = ACTIONS(1773),
    [anon_sym_with] = ACTIONS(1773),
    [anon_sym_break] = ACTIONS(1773),
    [anon_sym_continue] = ACTIONS(1773),
    [anon_sym_debugger] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(1773),
    [anon_sym_throw] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1771),
    [anon_sym_case] = ACTIONS(1773),
    [anon_sym_yield] = ACTIONS(1773),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_async] = ACTIONS(1773),
    [anon_sym_function] = ACTIONS(1773),
    [anon_sym_abstract] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(1773),
    [anon_sym_set] = ACTIONS(1773),
    [anon_sym_new] = ACTIONS(1773),
    [anon_sym_PLUS] = ACTIONS(1773),
    [anon_sym_DASH] = ACTIONS(1773),
    [anon_sym_SLASH] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_TILDE] = ACTIONS(1771),
    [anon_sym_void] = ACTIONS(1773),
    [anon_sym_delete] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1771),
    [anon_sym_DASH_DASH] = ACTIONS(1771),
    [anon_sym_DQUOTE] = ACTIONS(1771),
    [anon_sym_SQUOTE] = ACTIONS(1771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1771),
    [sym_float_literal] = ACTIONS(1771),
    [sym_hex_literal] = ACTIONS(1773),
    [sym_int_literal] = ACTIONS(1773),
    [sym_binary_literal] = ACTIONS(1773),
    [sym_octal_literal] = ACTIONS(1773),
    [sym_bigint_literal] = ACTIONS(1771),
    [sym_this] = ACTIONS(1773),
    [sym_super] = ACTIONS(1773),
    [sym_true] = ACTIONS(1773),
    [sym_false] = ACTIONS(1773),
    [sym_null] = ACTIONS(1773),
    [anon_sym_AT] = ACTIONS(1771),
    [anon_sym_static] = ACTIONS(1773),
    [anon_sym_public] = ACTIONS(1773),
    [anon_sym_private] = ACTIONS(1773),
    [anon_sym_protected] = ACTIONS(1773),
    [anon_sym_boolean] = ACTIONS(1773),
    [anon_sym_string] = ACTIONS(1773),
    [anon_sym_symbol] = ACTIONS(1773),
    [sym_readonly] = ACTIONS(1773),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_identifier] = ACTIONS(1777),
    [anon_sym_export] = ACTIONS(1777),
    [anon_sym_default] = ACTIONS(1777),
    [anon_sym_namespace] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1775),
    [anon_sym_RBRACE] = ACTIONS(1775),
    [anon_sym_typeof] = ACTIONS(1777),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_interface] = ACTIONS(1777),
    [anon_sym_declare] = ACTIONS(1777),
    [anon_sym_module] = ACTIONS(1777),
    [anon_sym_import] = ACTIONS(1777),
    [anon_sym_const] = ACTIONS(1777),
    [anon_sym_enum] = ACTIONS(1777),
    [anon_sym_var] = ACTIONS(1777),
    [anon_sym_let] = ACTIONS(1777),
    [anon_sym_BANG] = ACTIONS(1775),
    [anon_sym_else] = ACTIONS(1777),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_switch] = ACTIONS(1777),
    [anon_sym_for] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_while] = ACTIONS(1777),
    [anon_sym_do] = ACTIONS(1777),
    [anon_sym_try] = ACTIONS(1777),
    [anon_sym_with] = ACTIONS(1777),
    [anon_sym_break] = ACTIONS(1777),
    [anon_sym_continue] = ACTIONS(1777),
    [anon_sym_debugger] = ACTIONS(1777),
    [anon_sym_return] = ACTIONS(1777),
    [anon_sym_throw] = ACTIONS(1777),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_case] = ACTIONS(1777),
    [anon_sym_finally] = ACTIONS(1777),
    [anon_sym_yield] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(1775),
    [anon_sym_class] = ACTIONS(1777),
    [anon_sym_async] = ACTIONS(1777),
    [anon_sym_function] = ACTIONS(1777),
    [anon_sym_abstract] = ACTIONS(1777),
    [anon_sym_get] = ACTIONS(1777),
    [anon_sym_set] = ACTIONS(1777),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_PLUS] = ACTIONS(1777),
    [anon_sym_DASH] = ACTIONS(1777),
    [anon_sym_SLASH] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(1775),
    [anon_sym_void] = ACTIONS(1777),
    [anon_sym_delete] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1775),
    [anon_sym_DASH_DASH] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(1775),
    [anon_sym_SQUOTE] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1775),
    [sym_float_literal] = ACTIONS(1775),
    [sym_hex_literal] = ACTIONS(1777),
    [sym_int_literal] = ACTIONS(1777),
    [sym_binary_literal] = ACTIONS(1777),
    [sym_octal_literal] = ACTIONS(1777),
    [sym_bigint_literal] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_super] = ACTIONS(1777),
    [sym_true] = ACTIONS(1777),
    [sym_false] = ACTIONS(1777),
    [sym_null] = ACTIONS(1777),
    [anon_sym_AT] = ACTIONS(1775),
    [anon_sym_static] = ACTIONS(1777),
    [anon_sym_public] = ACTIONS(1777),
    [anon_sym_private] = ACTIONS(1777),
    [anon_sym_protected] = ACTIONS(1777),
    [anon_sym_boolean] = ACTIONS(1777),
    [anon_sym_string] = ACTIONS(1777),
    [anon_sym_symbol] = ACTIONS(1777),
    [sym_readonly] = ACTIONS(1777),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(1078),
    [anon_sym_default] = ACTIONS(1078),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_typeof] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_interface] = ACTIONS(1078),
    [anon_sym_declare] = ACTIONS(1078),
    [anon_sym_module] = ACTIONS(1078),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_const] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1076),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_await] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_debugger] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_throw] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1078),
    [anon_sym_yield] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_function] = ACTIONS(1078),
    [anon_sym_abstract] = ACTIONS(1078),
    [anon_sym_get] = ACTIONS(1078),
    [anon_sym_set] = ACTIONS(1078),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1078),
    [anon_sym_SLASH] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1076),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1078),
    [anon_sym_delete] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1076),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_float_literal] = ACTIONS(1076),
    [sym_hex_literal] = ACTIONS(1078),
    [sym_int_literal] = ACTIONS(1078),
    [sym_binary_literal] = ACTIONS(1078),
    [sym_octal_literal] = ACTIONS(1078),
    [sym_bigint_literal] = ACTIONS(1076),
    [sym_this] = ACTIONS(1078),
    [sym_super] = ACTIONS(1078),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_null] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_static] = ACTIONS(1078),
    [anon_sym_public] = ACTIONS(1078),
    [anon_sym_private] = ACTIONS(1078),
    [anon_sym_protected] = ACTIONS(1078),
    [anon_sym_boolean] = ACTIONS(1078),
    [anon_sym_string] = ACTIONS(1078),
    [anon_sym_symbol] = ACTIONS(1078),
    [sym_readonly] = ACTIONS(1078),
    [sym__automatic_semicolon] = ACTIONS(1084),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_interface] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_var] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_debugger] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_throw] = ACTIONS(1064),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_SLASH] = ACTIONS(1064),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_float_literal] = ACTIONS(1062),
    [sym_hex_literal] = ACTIONS(1064),
    [sym_int_literal] = ACTIONS(1064),
    [sym_binary_literal] = ACTIONS(1064),
    [sym_octal_literal] = ACTIONS(1064),
    [sym_bigint_literal] = ACTIONS(1062),
    [sym_this] = ACTIONS(1064),
    [sym_super] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [sym_readonly] = ACTIONS(1064),
    [sym__automatic_semicolon] = ACTIONS(1070),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_export] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_namespace] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_typeof] = ACTIONS(1088),
    [anon_sym_type] = ACTIONS(1088),
    [anon_sym_interface] = ACTIONS(1088),
    [anon_sym_declare] = ACTIONS(1088),
    [anon_sym_module] = ACTIONS(1088),
    [anon_sym_import] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_var] = ACTIONS(1088),
    [anon_sym_let] = ACTIONS(1088),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_await] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_try] = ACTIONS(1088),
    [anon_sym_with] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_debugger] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_throw] = ACTIONS(1088),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_yield] = ACTIONS(1088),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1088),
    [anon_sym_async] = ACTIONS(1088),
    [anon_sym_function] = ACTIONS(1088),
    [anon_sym_abstract] = ACTIONS(1088),
    [anon_sym_get] = ACTIONS(1088),
    [anon_sym_set] = ACTIONS(1088),
    [anon_sym_new] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_LT] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_void] = ACTIONS(1088),
    [anon_sym_delete] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1086),
    [sym_float_literal] = ACTIONS(1086),
    [sym_hex_literal] = ACTIONS(1088),
    [sym_int_literal] = ACTIONS(1088),
    [sym_binary_literal] = ACTIONS(1088),
    [sym_octal_literal] = ACTIONS(1088),
    [sym_bigint_literal] = ACTIONS(1086),
    [sym_this] = ACTIONS(1088),
    [sym_super] = ACTIONS(1088),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [anon_sym_AT] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_public] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym_protected] = ACTIONS(1088),
    [anon_sym_boolean] = ACTIONS(1088),
    [anon_sym_string] = ACTIONS(1088),
    [anon_sym_symbol] = ACTIONS(1088),
    [sym_readonly] = ACTIONS(1088),
    [sym__automatic_semicolon] = ACTIONS(1094),
  },
  [500] = {
    [sym__call_signature] = STATE(3187),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_export] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(926),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_declare] = ACTIONS(1745),
    [anon_sym_module] = ACTIONS(1745),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1745),
    [anon_sym_set] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_public] = ACTIONS(1745),
    [anon_sym_private] = ACTIONS(1745),
    [anon_sym_protected] = ACTIONS(1745),
    [anon_sym_boolean] = ACTIONS(1745),
    [anon_sym_string] = ACTIONS(1745),
    [anon_sym_symbol] = ACTIONS(1745),
    [sym_readonly] = ACTIONS(1745),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1785),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1787),
    [anon_sym_default] = ACTIONS(1787),
    [anon_sym_namespace] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1785),
    [anon_sym_RBRACE] = ACTIONS(1785),
    [anon_sym_typeof] = ACTIONS(1787),
    [anon_sym_type] = ACTIONS(1787),
    [anon_sym_interface] = ACTIONS(1787),
    [anon_sym_declare] = ACTIONS(1787),
    [anon_sym_module] = ACTIONS(1787),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_const] = ACTIONS(1787),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_var] = ACTIONS(1787),
    [anon_sym_let] = ACTIONS(1787),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_if] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(1787),
    [anon_sym_for] = ACTIONS(1787),
    [anon_sym_LPAREN] = ACTIONS(1785),
    [anon_sym_await] = ACTIONS(1787),
    [anon_sym_while] = ACTIONS(1787),
    [anon_sym_do] = ACTIONS(1787),
    [anon_sym_try] = ACTIONS(1787),
    [anon_sym_with] = ACTIONS(1787),
    [anon_sym_break] = ACTIONS(1787),
    [anon_sym_continue] = ACTIONS(1787),
    [anon_sym_debugger] = ACTIONS(1787),
    [anon_sym_return] = ACTIONS(1787),
    [anon_sym_throw] = ACTIONS(1787),
    [anon_sym_SEMI] = ACTIONS(1785),
    [anon_sym_case] = ACTIONS(1787),
    [anon_sym_finally] = ACTIONS(1787),
    [anon_sym_yield] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1785),
    [anon_sym_class] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(1787),
    [anon_sym_function] = ACTIONS(1787),
    [anon_sym_abstract] = ACTIONS(1787),
    [anon_sym_get] = ACTIONS(1787),
    [anon_sym_set] = ACTIONS(1787),
    [anon_sym_new] = ACTIONS(1787),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_SLASH] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1787),
    [anon_sym_delete] = ACTIONS(1787),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_DQUOTE] = ACTIONS(1785),
    [anon_sym_SQUOTE] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1785),
    [sym_float_literal] = ACTIONS(1785),
    [sym_hex_literal] = ACTIONS(1787),
    [sym_int_literal] = ACTIONS(1787),
    [sym_binary_literal] = ACTIONS(1787),
    [sym_octal_literal] = ACTIONS(1787),
    [sym_bigint_literal] = ACTIONS(1785),
    [sym_this] = ACTIONS(1787),
    [sym_super] = ACTIONS(1787),
    [sym_true] = ACTIONS(1787),
    [sym_false] = ACTIONS(1787),
    [sym_null] = ACTIONS(1787),
    [anon_sym_AT] = ACTIONS(1785),
    [anon_sym_static] = ACTIONS(1787),
    [anon_sym_public] = ACTIONS(1787),
    [anon_sym_private] = ACTIONS(1787),
    [anon_sym_protected] = ACTIONS(1787),
    [anon_sym_boolean] = ACTIONS(1787),
    [anon_sym_string] = ACTIONS(1787),
    [anon_sym_symbol] = ACTIONS(1787),
    [sym_readonly] = ACTIONS(1787),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1052),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1054),
    [anon_sym_default] = ACTIONS(1054),
    [anon_sym_namespace] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_RBRACE] = ACTIONS(1052),
    [anon_sym_typeof] = ACTIONS(1054),
    [anon_sym_type] = ACTIONS(1054),
    [anon_sym_interface] = ACTIONS(1054),
    [anon_sym_declare] = ACTIONS(1054),
    [anon_sym_module] = ACTIONS(1054),
    [anon_sym_import] = ACTIONS(1054),
    [anon_sym_const] = ACTIONS(1054),
    [anon_sym_enum] = ACTIONS(1054),
    [anon_sym_var] = ACTIONS(1054),
    [anon_sym_let] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1052),
    [anon_sym_else] = ACTIONS(1054),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_switch] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1052),
    [anon_sym_await] = ACTIONS(1054),
    [anon_sym_while] = ACTIONS(1054),
    [anon_sym_do] = ACTIONS(1054),
    [anon_sym_try] = ACTIONS(1054),
    [anon_sym_with] = ACTIONS(1054),
    [anon_sym_break] = ACTIONS(1054),
    [anon_sym_continue] = ACTIONS(1054),
    [anon_sym_debugger] = ACTIONS(1054),
    [anon_sym_return] = ACTIONS(1054),
    [anon_sym_throw] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1054),
    [anon_sym_yield] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_class] = ACTIONS(1054),
    [anon_sym_async] = ACTIONS(1054),
    [anon_sym_function] = ACTIONS(1054),
    [anon_sym_abstract] = ACTIONS(1054),
    [anon_sym_get] = ACTIONS(1054),
    [anon_sym_set] = ACTIONS(1054),
    [anon_sym_new] = ACTIONS(1054),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_LT] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_void] = ACTIONS(1054),
    [anon_sym_delete] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1052),
    [anon_sym_DQUOTE] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [sym_float_literal] = ACTIONS(1052),
    [sym_hex_literal] = ACTIONS(1054),
    [sym_int_literal] = ACTIONS(1054),
    [sym_binary_literal] = ACTIONS(1054),
    [sym_octal_literal] = ACTIONS(1054),
    [sym_bigint_literal] = ACTIONS(1052),
    [sym_this] = ACTIONS(1054),
    [sym_super] = ACTIONS(1054),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_null] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_static] = ACTIONS(1054),
    [anon_sym_public] = ACTIONS(1054),
    [anon_sym_private] = ACTIONS(1054),
    [anon_sym_protected] = ACTIONS(1054),
    [anon_sym_boolean] = ACTIONS(1054),
    [anon_sym_string] = ACTIONS(1054),
    [anon_sym_symbol] = ACTIONS(1054),
    [sym_readonly] = ACTIONS(1054),
    [sym__automatic_semicolon] = ACTIONS(1060),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1100),
    [sym_identifier] = ACTIONS(1102),
    [anon_sym_export] = ACTIONS(1102),
    [anon_sym_default] = ACTIONS(1102),
    [anon_sym_namespace] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1102),
    [anon_sym_interface] = ACTIONS(1102),
    [anon_sym_declare] = ACTIONS(1102),
    [anon_sym_module] = ACTIONS(1102),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_const] = ACTIONS(1102),
    [anon_sym_enum] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_switch] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_await] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_debugger] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_throw] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1102),
    [anon_sym_yield] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_async] = ACTIONS(1102),
    [anon_sym_function] = ACTIONS(1102),
    [anon_sym_abstract] = ACTIONS(1102),
    [anon_sym_get] = ACTIONS(1102),
    [anon_sym_set] = ACTIONS(1102),
    [anon_sym_new] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1102),
    [anon_sym_delete] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_SQUOTE] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_float_literal] = ACTIONS(1100),
    [sym_hex_literal] = ACTIONS(1102),
    [sym_int_literal] = ACTIONS(1102),
    [sym_binary_literal] = ACTIONS(1102),
    [sym_octal_literal] = ACTIONS(1102),
    [sym_bigint_literal] = ACTIONS(1100),
    [sym_this] = ACTIONS(1102),
    [sym_super] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_null] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1102),
    [anon_sym_public] = ACTIONS(1102),
    [anon_sym_private] = ACTIONS(1102),
    [anon_sym_protected] = ACTIONS(1102),
    [anon_sym_boolean] = ACTIONS(1102),
    [anon_sym_string] = ACTIONS(1102),
    [anon_sym_symbol] = ACTIONS(1102),
    [sym_readonly] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1108),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_export] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_namespace] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_typeof] = ACTIONS(976),
    [anon_sym_type] = ACTIONS(976),
    [anon_sym_interface] = ACTIONS(976),
    [anon_sym_declare] = ACTIONS(976),
    [anon_sym_module] = ACTIONS(976),
    [anon_sym_import] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_var] = ACTIONS(976),
    [anon_sym_let] = ACTIONS(976),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_LPAREN] = ACTIONS(974),
    [anon_sym_await] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_try] = ACTIONS(976),
    [anon_sym_with] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_debugger] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_throw] = ACTIONS(976),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_yield] = ACTIONS(976),
    [anon_sym_LBRACK] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(976),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_function] = ACTIONS(976),
    [anon_sym_abstract] = ACTIONS(976),
    [anon_sym_get] = ACTIONS(976),
    [anon_sym_set] = ACTIONS(976),
    [anon_sym_new] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_SLASH] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_void] = ACTIONS(976),
    [anon_sym_delete] = ACTIONS(976),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(974),
    [sym_float_literal] = ACTIONS(974),
    [sym_hex_literal] = ACTIONS(976),
    [sym_int_literal] = ACTIONS(976),
    [sym_binary_literal] = ACTIONS(976),
    [sym_octal_literal] = ACTIONS(976),
    [sym_bigint_literal] = ACTIONS(974),
    [sym_this] = ACTIONS(976),
    [sym_super] = ACTIONS(976),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [anon_sym_AT] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_public] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym_protected] = ACTIONS(976),
    [anon_sym_boolean] = ACTIONS(976),
    [anon_sym_string] = ACTIONS(976),
    [anon_sym_symbol] = ACTIONS(976),
    [sym_readonly] = ACTIONS(976),
    [sym__automatic_semicolon] = ACTIONS(982),
  },
  [505] = {
    [sym_else_clause] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(1789),
    [sym_identifier] = ACTIONS(1791),
    [anon_sym_export] = ACTIONS(1791),
    [anon_sym_default] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1789),
    [anon_sym_RBRACE] = ACTIONS(1789),
    [anon_sym_typeof] = ACTIONS(1791),
    [anon_sym_type] = ACTIONS(1791),
    [anon_sym_interface] = ACTIONS(1791),
    [anon_sym_declare] = ACTIONS(1791),
    [anon_sym_module] = ACTIONS(1791),
    [anon_sym_import] = ACTIONS(1791),
    [anon_sym_const] = ACTIONS(1791),
    [anon_sym_enum] = ACTIONS(1791),
    [anon_sym_var] = ACTIONS(1791),
    [anon_sym_let] = ACTIONS(1791),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_else] = ACTIONS(1793),
    [anon_sym_if] = ACTIONS(1791),
    [anon_sym_switch] = ACTIONS(1791),
    [anon_sym_for] = ACTIONS(1791),
    [anon_sym_LPAREN] = ACTIONS(1789),
    [anon_sym_await] = ACTIONS(1791),
    [anon_sym_while] = ACTIONS(1791),
    [anon_sym_do] = ACTIONS(1791),
    [anon_sym_try] = ACTIONS(1791),
    [anon_sym_with] = ACTIONS(1791),
    [anon_sym_break] = ACTIONS(1791),
    [anon_sym_continue] = ACTIONS(1791),
    [anon_sym_debugger] = ACTIONS(1791),
    [anon_sym_return] = ACTIONS(1791),
    [anon_sym_throw] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_case] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1791),
    [anon_sym_LBRACK] = ACTIONS(1789),
    [anon_sym_class] = ACTIONS(1791),
    [anon_sym_async] = ACTIONS(1791),
    [anon_sym_function] = ACTIONS(1791),
    [anon_sym_abstract] = ACTIONS(1791),
    [anon_sym_get] = ACTIONS(1791),
    [anon_sym_set] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_SLASH] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_void] = ACTIONS(1791),
    [anon_sym_delete] = ACTIONS(1791),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_SQUOTE] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [sym_float_literal] = ACTIONS(1789),
    [sym_hex_literal] = ACTIONS(1791),
    [sym_int_literal] = ACTIONS(1791),
    [sym_binary_literal] = ACTIONS(1791),
    [sym_octal_literal] = ACTIONS(1791),
    [sym_bigint_literal] = ACTIONS(1789),
    [sym_this] = ACTIONS(1791),
    [sym_super] = ACTIONS(1791),
    [sym_true] = ACTIONS(1791),
    [sym_false] = ACTIONS(1791),
    [sym_null] = ACTIONS(1791),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_static] = ACTIONS(1791),
    [anon_sym_public] = ACTIONS(1791),
    [anon_sym_private] = ACTIONS(1791),
    [anon_sym_protected] = ACTIONS(1791),
    [anon_sym_boolean] = ACTIONS(1791),
    [anon_sym_string] = ACTIONS(1791),
    [anon_sym_symbol] = ACTIONS(1791),
    [sym_readonly] = ACTIONS(1791),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1795),
    [sym_identifier] = ACTIONS(1797),
    [anon_sym_export] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_namespace] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(1795),
    [anon_sym_typeof] = ACTIONS(1797),
    [anon_sym_type] = ACTIONS(1797),
    [anon_sym_interface] = ACTIONS(1797),
    [anon_sym_declare] = ACTIONS(1797),
    [anon_sym_module] = ACTIONS(1797),
    [anon_sym_import] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_var] = ACTIONS(1797),
    [anon_sym_let] = ACTIONS(1797),
    [anon_sym_BANG] = ACTIONS(1795),
    [anon_sym_else] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_RPAREN] = ACTIONS(1795),
    [anon_sym_await] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_try] = ACTIONS(1797),
    [anon_sym_with] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_debugger] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_throw] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_class] = ACTIONS(1797),
    [anon_sym_async] = ACTIONS(1797),
    [anon_sym_function] = ACTIONS(1797),
    [anon_sym_abstract] = ACTIONS(1797),
    [anon_sym_get] = ACTIONS(1797),
    [anon_sym_set] = ACTIONS(1797),
    [anon_sym_new] = ACTIONS(1797),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_SLASH] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(1795),
    [anon_sym_TILDE] = ACTIONS(1795),
    [anon_sym_void] = ACTIONS(1797),
    [anon_sym_delete] = ACTIONS(1797),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [anon_sym_SQUOTE] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1795),
    [sym_float_literal] = ACTIONS(1795),
    [sym_hex_literal] = ACTIONS(1797),
    [sym_int_literal] = ACTIONS(1797),
    [sym_binary_literal] = ACTIONS(1797),
    [sym_octal_literal] = ACTIONS(1797),
    [sym_bigint_literal] = ACTIONS(1795),
    [sym_this] = ACTIONS(1797),
    [sym_super] = ACTIONS(1797),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [anon_sym_AT] = ACTIONS(1795),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_public] = ACTIONS(1797),
    [anon_sym_private] = ACTIONS(1797),
    [anon_sym_protected] = ACTIONS(1797),
    [anon_sym_boolean] = ACTIONS(1797),
    [anon_sym_string] = ACTIONS(1797),
    [anon_sym_symbol] = ACTIONS(1797),
    [sym_readonly] = ACTIONS(1797),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_default] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_typeof] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_interface] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_const] = ACTIONS(1026),
    [anon_sym_enum] = ACTIONS(1026),
    [anon_sym_var] = ACTIONS(1026),
    [anon_sym_let] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_switch] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1024),
    [anon_sym_await] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_with] = ACTIONS(1026),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_debugger] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_throw] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1026),
    [anon_sym_yield] = ACTIONS(1026),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_async] = ACTIONS(1026),
    [anon_sym_function] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_new] = ACTIONS(1026),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(1026),
    [anon_sym_delete] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1024),
    [sym_float_literal] = ACTIONS(1024),
    [sym_hex_literal] = ACTIONS(1026),
    [sym_int_literal] = ACTIONS(1026),
    [sym_binary_literal] = ACTIONS(1026),
    [sym_octal_literal] = ACTIONS(1026),
    [sym_bigint_literal] = ACTIONS(1024),
    [sym_this] = ACTIONS(1026),
    [sym_super] = ACTIONS(1026),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_null] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [sym_readonly] = ACTIONS(1026),
    [sym__automatic_semicolon] = ACTIONS(1032),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_namespace] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [anon_sym_typeof] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1128),
    [anon_sym_interface] = ACTIONS(1128),
    [anon_sym_declare] = ACTIONS(1128),
    [anon_sym_module] = ACTIONS(1128),
    [anon_sym_import] = ACTIONS(1128),
    [anon_sym_const] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_var] = ACTIONS(1128),
    [anon_sym_let] = ACTIONS(1128),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_else] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [anon_sym_await] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_try] = ACTIONS(1128),
    [anon_sym_with] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_debugger] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_throw] = ACTIONS(1128),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_yield] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_class] = ACTIONS(1128),
    [anon_sym_async] = ACTIONS(1128),
    [anon_sym_function] = ACTIONS(1128),
    [anon_sym_abstract] = ACTIONS(1128),
    [anon_sym_get] = ACTIONS(1128),
    [anon_sym_set] = ACTIONS(1128),
    [anon_sym_new] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_void] = ACTIONS(1128),
    [anon_sym_delete] = ACTIONS(1128),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1126),
    [sym_float_literal] = ACTIONS(1126),
    [sym_hex_literal] = ACTIONS(1128),
    [sym_int_literal] = ACTIONS(1128),
    [sym_binary_literal] = ACTIONS(1128),
    [sym_octal_literal] = ACTIONS(1128),
    [sym_bigint_literal] = ACTIONS(1126),
    [sym_this] = ACTIONS(1128),
    [sym_super] = ACTIONS(1128),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_public] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym_protected] = ACTIONS(1128),
    [anon_sym_boolean] = ACTIONS(1128),
    [anon_sym_string] = ACTIONS(1128),
    [anon_sym_symbol] = ACTIONS(1128),
    [sym_readonly] = ACTIONS(1128),
    [sym__automatic_semicolon] = ACTIONS(1134),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(1008),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_export] = ACTIONS(1010),
    [anon_sym_default] = ACTIONS(1010),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(1008),
    [anon_sym_typeof] = ACTIONS(1010),
    [anon_sym_type] = ACTIONS(1010),
    [anon_sym_interface] = ACTIONS(1010),
    [anon_sym_declare] = ACTIONS(1010),
    [anon_sym_module] = ACTIONS(1010),
    [anon_sym_import] = ACTIONS(1010),
    [anon_sym_const] = ACTIONS(1010),
    [anon_sym_enum] = ACTIONS(1010),
    [anon_sym_var] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1010),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_await] = ACTIONS(1010),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_do] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_with] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_debugger] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_throw] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1010),
    [anon_sym_yield] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_class] = ACTIONS(1010),
    [anon_sym_async] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_abstract] = ACTIONS(1010),
    [anon_sym_get] = ACTIONS(1010),
    [anon_sym_set] = ACTIONS(1010),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1010),
    [anon_sym_SLASH] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1010),
    [anon_sym_delete] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_SQUOTE] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1008),
    [sym_float_literal] = ACTIONS(1008),
    [sym_hex_literal] = ACTIONS(1010),
    [sym_int_literal] = ACTIONS(1010),
    [sym_binary_literal] = ACTIONS(1010),
    [sym_octal_literal] = ACTIONS(1010),
    [sym_bigint_literal] = ACTIONS(1008),
    [sym_this] = ACTIONS(1010),
    [sym_super] = ACTIONS(1010),
    [sym_true] = ACTIONS(1010),
    [sym_false] = ACTIONS(1010),
    [sym_null] = ACTIONS(1010),
    [anon_sym_AT] = ACTIONS(1008),
    [anon_sym_static] = ACTIONS(1010),
    [anon_sym_public] = ACTIONS(1010),
    [anon_sym_private] = ACTIONS(1010),
    [anon_sym_protected] = ACTIONS(1010),
    [anon_sym_boolean] = ACTIONS(1010),
    [anon_sym_string] = ACTIONS(1010),
    [anon_sym_symbol] = ACTIONS(1010),
    [sym_readonly] = ACTIONS(1010),
    [sym__automatic_semicolon] = ACTIONS(1016),
  },
  [510] = {
    [sym_statement_block] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(958),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_namespace] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(1761),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_interface] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_var] = ACTIONS(958),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_await] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_try] = ACTIONS(958),
    [anon_sym_with] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_debugger] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_throw] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_yield] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_class] = ACTIONS(958),
    [anon_sym_async] = ACTIONS(958),
    [anon_sym_function] = ACTIONS(958),
    [anon_sym_abstract] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_new] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(958),
    [anon_sym_LT] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [sym_float_literal] = ACTIONS(956),
    [sym_hex_literal] = ACTIONS(958),
    [sym_int_literal] = ACTIONS(958),
    [sym_binary_literal] = ACTIONS(958),
    [sym_octal_literal] = ACTIONS(958),
    [sym_bigint_literal] = ACTIONS(956),
    [sym_this] = ACTIONS(958),
    [sym_super] = ACTIONS(958),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [sym_readonly] = ACTIONS(958),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1799),
    [sym_identifier] = ACTIONS(1801),
    [anon_sym_export] = ACTIONS(1801),
    [anon_sym_default] = ACTIONS(1801),
    [anon_sym_namespace] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_RBRACE] = ACTIONS(1799),
    [anon_sym_typeof] = ACTIONS(1801),
    [anon_sym_type] = ACTIONS(1801),
    [anon_sym_interface] = ACTIONS(1801),
    [anon_sym_declare] = ACTIONS(1801),
    [anon_sym_module] = ACTIONS(1801),
    [anon_sym_import] = ACTIONS(1801),
    [anon_sym_const] = ACTIONS(1801),
    [anon_sym_enum] = ACTIONS(1801),
    [anon_sym_var] = ACTIONS(1801),
    [anon_sym_let] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_else] = ACTIONS(1801),
    [anon_sym_if] = ACTIONS(1801),
    [anon_sym_switch] = ACTIONS(1801),
    [anon_sym_for] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_await] = ACTIONS(1801),
    [anon_sym_while] = ACTIONS(1801),
    [anon_sym_do] = ACTIONS(1801),
    [anon_sym_try] = ACTIONS(1801),
    [anon_sym_with] = ACTIONS(1801),
    [anon_sym_break] = ACTIONS(1801),
    [anon_sym_continue] = ACTIONS(1801),
    [anon_sym_debugger] = ACTIONS(1801),
    [anon_sym_return] = ACTIONS(1801),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_case] = ACTIONS(1801),
    [anon_sym_finally] = ACTIONS(1801),
    [anon_sym_yield] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_class] = ACTIONS(1801),
    [anon_sym_async] = ACTIONS(1801),
    [anon_sym_function] = ACTIONS(1801),
    [anon_sym_abstract] = ACTIONS(1801),
    [anon_sym_get] = ACTIONS(1801),
    [anon_sym_set] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_SLASH] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_delete] = ACTIONS(1801),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_DQUOTE] = ACTIONS(1799),
    [anon_sym_SQUOTE] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [sym_float_literal] = ACTIONS(1799),
    [sym_hex_literal] = ACTIONS(1801),
    [sym_int_literal] = ACTIONS(1801),
    [sym_binary_literal] = ACTIONS(1801),
    [sym_octal_literal] = ACTIONS(1801),
    [sym_bigint_literal] = ACTIONS(1799),
    [sym_this] = ACTIONS(1801),
    [sym_super] = ACTIONS(1801),
    [sym_true] = ACTIONS(1801),
    [sym_false] = ACTIONS(1801),
    [sym_null] = ACTIONS(1801),
    [anon_sym_AT] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1801),
    [anon_sym_public] = ACTIONS(1801),
    [anon_sym_private] = ACTIONS(1801),
    [anon_sym_protected] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_symbol] = ACTIONS(1801),
    [sym_readonly] = ACTIONS(1801),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1805),
    [anon_sym_export] = ACTIONS(1805),
    [anon_sym_default] = ACTIONS(1805),
    [anon_sym_namespace] = ACTIONS(1805),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_RBRACE] = ACTIONS(1803),
    [anon_sym_typeof] = ACTIONS(1805),
    [anon_sym_type] = ACTIONS(1805),
    [anon_sym_interface] = ACTIONS(1805),
    [anon_sym_declare] = ACTIONS(1805),
    [anon_sym_module] = ACTIONS(1805),
    [anon_sym_import] = ACTIONS(1805),
    [anon_sym_const] = ACTIONS(1805),
    [anon_sym_enum] = ACTIONS(1805),
    [anon_sym_var] = ACTIONS(1805),
    [anon_sym_let] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_else] = ACTIONS(1805),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1805),
    [anon_sym_for] = ACTIONS(1805),
    [anon_sym_LPAREN] = ACTIONS(1803),
    [anon_sym_await] = ACTIONS(1805),
    [anon_sym_while] = ACTIONS(1805),
    [anon_sym_do] = ACTIONS(1805),
    [anon_sym_try] = ACTIONS(1805),
    [anon_sym_with] = ACTIONS(1805),
    [anon_sym_break] = ACTIONS(1805),
    [anon_sym_continue] = ACTIONS(1805),
    [anon_sym_debugger] = ACTIONS(1805),
    [anon_sym_return] = ACTIONS(1805),
    [anon_sym_throw] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1805),
    [anon_sym_finally] = ACTIONS(1805),
    [anon_sym_yield] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(1803),
    [anon_sym_class] = ACTIONS(1805),
    [anon_sym_async] = ACTIONS(1805),
    [anon_sym_function] = ACTIONS(1805),
    [anon_sym_abstract] = ACTIONS(1805),
    [anon_sym_get] = ACTIONS(1805),
    [anon_sym_set] = ACTIONS(1805),
    [anon_sym_new] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_TILDE] = ACTIONS(1803),
    [anon_sym_void] = ACTIONS(1805),
    [anon_sym_delete] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1803),
    [anon_sym_DQUOTE] = ACTIONS(1803),
    [anon_sym_SQUOTE] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1803),
    [sym_float_literal] = ACTIONS(1803),
    [sym_hex_literal] = ACTIONS(1805),
    [sym_int_literal] = ACTIONS(1805),
    [sym_binary_literal] = ACTIONS(1805),
    [sym_octal_literal] = ACTIONS(1805),
    [sym_bigint_literal] = ACTIONS(1803),
    [sym_this] = ACTIONS(1805),
    [sym_super] = ACTIONS(1805),
    [sym_true] = ACTIONS(1805),
    [sym_false] = ACTIONS(1805),
    [sym_null] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(1803),
    [anon_sym_static] = ACTIONS(1805),
    [anon_sym_public] = ACTIONS(1805),
    [anon_sym_private] = ACTIONS(1805),
    [anon_sym_protected] = ACTIONS(1805),
    [anon_sym_boolean] = ACTIONS(1805),
    [anon_sym_string] = ACTIONS(1805),
    [anon_sym_symbol] = ACTIONS(1805),
    [sym_readonly] = ACTIONS(1805),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1074),
    [anon_sym_type] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_declare] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1074),
    [anon_sym_import] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_debugger] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_throw] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_abstract] = ACTIONS(1074),
    [anon_sym_get] = ACTIONS(1074),
    [anon_sym_set] = ACTIONS(1074),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1074),
    [anon_sym_delete] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_float_literal] = ACTIONS(1072),
    [sym_hex_literal] = ACTIONS(1074),
    [sym_int_literal] = ACTIONS(1074),
    [sym_binary_literal] = ACTIONS(1074),
    [sym_octal_literal] = ACTIONS(1074),
    [sym_bigint_literal] = ACTIONS(1072),
    [sym_this] = ACTIONS(1074),
    [sym_super] = ACTIONS(1074),
    [sym_true] = ACTIONS(1074),
    [sym_false] = ACTIONS(1074),
    [sym_null] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1074),
    [anon_sym_public] = ACTIONS(1074),
    [anon_sym_private] = ACTIONS(1074),
    [anon_sym_protected] = ACTIONS(1074),
    [anon_sym_boolean] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [anon_sym_symbol] = ACTIONS(1074),
    [sym_readonly] = ACTIONS(1074),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1034),
    [sym_identifier] = ACTIONS(1036),
    [anon_sym_export] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_namespace] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(1036),
    [anon_sym_type] = ACTIONS(1036),
    [anon_sym_interface] = ACTIONS(1036),
    [anon_sym_declare] = ACTIONS(1036),
    [anon_sym_module] = ACTIONS(1036),
    [anon_sym_import] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_var] = ACTIONS(1036),
    [anon_sym_let] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [anon_sym_await] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_with] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_debugger] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_throw] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_yield] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1034),
    [anon_sym_class] = ACTIONS(1036),
    [anon_sym_async] = ACTIONS(1036),
    [anon_sym_function] = ACTIONS(1036),
    [anon_sym_abstract] = ACTIONS(1036),
    [anon_sym_get] = ACTIONS(1036),
    [anon_sym_set] = ACTIONS(1036),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_SLASH] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_void] = ACTIONS(1036),
    [anon_sym_delete] = ACTIONS(1036),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1034),
    [sym_float_literal] = ACTIONS(1034),
    [sym_hex_literal] = ACTIONS(1036),
    [sym_int_literal] = ACTIONS(1036),
    [sym_binary_literal] = ACTIONS(1036),
    [sym_octal_literal] = ACTIONS(1036),
    [sym_bigint_literal] = ACTIONS(1034),
    [sym_this] = ACTIONS(1036),
    [sym_super] = ACTIONS(1036),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_public] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym_protected] = ACTIONS(1036),
    [anon_sym_boolean] = ACTIONS(1036),
    [anon_sym_string] = ACTIONS(1036),
    [anon_sym_symbol] = ACTIONS(1036),
    [sym_readonly] = ACTIONS(1036),
    [sym__automatic_semicolon] = ACTIONS(1042),
  },
  [515] = {
    [sym__call_signature] = STATE(3366),
    [sym_arguments] = STATE(1801),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_arguments] = STATE(1671),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1747),
    [anon_sym_COMMA] = ACTIONS(1749),
    [anon_sym_type] = ACTIONS(1809),
    [anon_sym_declare] = ACTIONS(1809),
    [anon_sym_module] = ACTIONS(1809),
    [anon_sym_DOT] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_of] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [anon_sym_async] = ACTIONS(1809),
    [anon_sym_function] = ACTIONS(1815),
    [anon_sym_EQ_GT] = ACTIONS(1162),
    [anon_sym_get] = ACTIONS(1809),
    [anon_sym_set] = ACTIONS(1809),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(1164),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1809),
    [anon_sym_public] = ACTIONS(1809),
    [anon_sym_private] = ACTIONS(1809),
    [anon_sym_protected] = ACTIONS(1809),
    [anon_sym_boolean] = ACTIONS(1809),
    [anon_sym_string] = ACTIONS(1809),
    [anon_sym_symbol] = ACTIONS(1809),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1749),
    [sym_readonly] = ACTIONS(1809),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(998),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_export] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_namespace] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_typeof] = ACTIONS(1000),
    [anon_sym_type] = ACTIONS(1000),
    [anon_sym_interface] = ACTIONS(1000),
    [anon_sym_declare] = ACTIONS(1000),
    [anon_sym_module] = ACTIONS(1000),
    [anon_sym_import] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_var] = ACTIONS(1000),
    [anon_sym_let] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_LPAREN] = ACTIONS(998),
    [anon_sym_await] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_try] = ACTIONS(1000),
    [anon_sym_with] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_debugger] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_throw] = ACTIONS(1000),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_yield] = ACTIONS(1000),
    [anon_sym_LBRACK] = ACTIONS(998),
    [anon_sym_class] = ACTIONS(1000),
    [anon_sym_async] = ACTIONS(1000),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_abstract] = ACTIONS(1000),
    [anon_sym_get] = ACTIONS(1000),
    [anon_sym_set] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_void] = ACTIONS(1000),
    [anon_sym_delete] = ACTIONS(1000),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(998),
    [sym_float_literal] = ACTIONS(998),
    [sym_hex_literal] = ACTIONS(1000),
    [sym_int_literal] = ACTIONS(1000),
    [sym_binary_literal] = ACTIONS(1000),
    [sym_octal_literal] = ACTIONS(1000),
    [sym_bigint_literal] = ACTIONS(998),
    [sym_this] = ACTIONS(1000),
    [sym_super] = ACTIONS(1000),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_public] = ACTIONS(1000),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym_protected] = ACTIONS(1000),
    [anon_sym_boolean] = ACTIONS(1000),
    [anon_sym_string] = ACTIONS(1000),
    [anon_sym_symbol] = ACTIONS(1000),
    [sym_readonly] = ACTIONS(1000),
    [sym__automatic_semicolon] = ACTIONS(1006),
  },
  [517] = {
    [sym__call_signature] = STATE(3357),
    [sym_arguments] = STATE(1218),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_arguments] = STATE(1089),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_export] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1749),
    [anon_sym_COMMA] = ACTIONS(1749),
    [anon_sym_type] = ACTIONS(1819),
    [anon_sym_declare] = ACTIONS(1819),
    [anon_sym_module] = ACTIONS(1819),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_of] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_get] = ACTIONS(1819),
    [anon_sym_set] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_implements] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1819),
    [anon_sym_public] = ACTIONS(1819),
    [anon_sym_private] = ACTIONS(1819),
    [anon_sym_protected] = ACTIONS(1819),
    [anon_sym_boolean] = ACTIONS(1819),
    [anon_sym_string] = ACTIONS(1819),
    [anon_sym_symbol] = ACTIONS(1819),
    [sym_readonly] = ACTIONS(1819),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(984),
    [sym_identifier] = ACTIONS(986),
    [anon_sym_export] = ACTIONS(986),
    [anon_sym_default] = ACTIONS(986),
    [anon_sym_namespace] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_RBRACE] = ACTIONS(984),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(986),
    [anon_sym_const] = ACTIONS(986),
    [anon_sym_enum] = ACTIONS(986),
    [anon_sym_var] = ACTIONS(986),
    [anon_sym_let] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_switch] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_await] = ACTIONS(986),
    [anon_sym_while] = ACTIONS(986),
    [anon_sym_do] = ACTIONS(986),
    [anon_sym_try] = ACTIONS(986),
    [anon_sym_with] = ACTIONS(986),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(986),
    [anon_sym_debugger] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_throw] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(986),
    [anon_sym_yield] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(984),
    [anon_sym_class] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(986),
    [anon_sym_abstract] = ACTIONS(986),
    [anon_sym_get] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(986),
    [anon_sym_new] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_SLASH] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(984),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(984),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(984),
    [sym_float_literal] = ACTIONS(984),
    [sym_hex_literal] = ACTIONS(986),
    [sym_int_literal] = ACTIONS(986),
    [sym_binary_literal] = ACTIONS(986),
    [sym_octal_literal] = ACTIONS(986),
    [sym_bigint_literal] = ACTIONS(984),
    [sym_this] = ACTIONS(986),
    [sym_super] = ACTIONS(986),
    [sym_true] = ACTIONS(986),
    [sym_false] = ACTIONS(986),
    [sym_null] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_static] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(986),
    [anon_sym_private] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(986),
    [anon_sym_boolean] = ACTIONS(986),
    [anon_sym_string] = ACTIONS(986),
    [anon_sym_symbol] = ACTIONS(986),
    [sym_readonly] = ACTIONS(986),
    [sym__automatic_semicolon] = ACTIONS(992),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1821),
    [sym_identifier] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(1823),
    [anon_sym_default] = ACTIONS(1823),
    [anon_sym_namespace] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_typeof] = ACTIONS(1823),
    [anon_sym_type] = ACTIONS(1823),
    [anon_sym_interface] = ACTIONS(1823),
    [anon_sym_declare] = ACTIONS(1823),
    [anon_sym_module] = ACTIONS(1823),
    [anon_sym_import] = ACTIONS(1823),
    [anon_sym_const] = ACTIONS(1823),
    [anon_sym_enum] = ACTIONS(1823),
    [anon_sym_var] = ACTIONS(1823),
    [anon_sym_let] = ACTIONS(1823),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_else] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1823),
    [anon_sym_switch] = ACTIONS(1823),
    [anon_sym_for] = ACTIONS(1823),
    [anon_sym_LPAREN] = ACTIONS(1821),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_while] = ACTIONS(1823),
    [anon_sym_do] = ACTIONS(1823),
    [anon_sym_try] = ACTIONS(1823),
    [anon_sym_with] = ACTIONS(1823),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_continue] = ACTIONS(1823),
    [anon_sym_debugger] = ACTIONS(1823),
    [anon_sym_return] = ACTIONS(1823),
    [anon_sym_throw] = ACTIONS(1823),
    [anon_sym_SEMI] = ACTIONS(1821),
    [anon_sym_case] = ACTIONS(1823),
    [anon_sym_yield] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1821),
    [anon_sym_class] = ACTIONS(1823),
    [anon_sym_async] = ACTIONS(1823),
    [anon_sym_function] = ACTIONS(1823),
    [anon_sym_abstract] = ACTIONS(1823),
    [anon_sym_get] = ACTIONS(1823),
    [anon_sym_set] = ACTIONS(1823),
    [anon_sym_new] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1823),
    [anon_sym_LT] = ACTIONS(1821),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_void] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1823),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_DQUOTE] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1821),
    [sym_float_literal] = ACTIONS(1821),
    [sym_hex_literal] = ACTIONS(1823),
    [sym_int_literal] = ACTIONS(1823),
    [sym_binary_literal] = ACTIONS(1823),
    [sym_octal_literal] = ACTIONS(1823),
    [sym_bigint_literal] = ACTIONS(1821),
    [sym_this] = ACTIONS(1823),
    [sym_super] = ACTIONS(1823),
    [sym_true] = ACTIONS(1823),
    [sym_false] = ACTIONS(1823),
    [sym_null] = ACTIONS(1823),
    [anon_sym_AT] = ACTIONS(1821),
    [anon_sym_static] = ACTIONS(1823),
    [anon_sym_public] = ACTIONS(1823),
    [anon_sym_private] = ACTIONS(1823),
    [anon_sym_protected] = ACTIONS(1823),
    [anon_sym_boolean] = ACTIONS(1823),
    [anon_sym_string] = ACTIONS(1823),
    [anon_sym_symbol] = ACTIONS(1823),
    [sym_readonly] = ACTIONS(1823),
  },
  [520] = {
    [sym__call_signature] = STATE(3296),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_export] = ACTIONS(1767),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1767),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1767),
    [anon_sym_module] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(1825),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1767),
    [anon_sym_set] = ACTIONS(1767),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1767),
    [anon_sym_public] = ACTIONS(1767),
    [anon_sym_private] = ACTIONS(1767),
    [anon_sym_protected] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [sym_readonly] = ACTIONS(1767),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1827),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_default] = ACTIONS(1829),
    [anon_sym_namespace] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1827),
    [anon_sym_RBRACE] = ACTIONS(1827),
    [anon_sym_typeof] = ACTIONS(1829),
    [anon_sym_type] = ACTIONS(1829),
    [anon_sym_interface] = ACTIONS(1829),
    [anon_sym_declare] = ACTIONS(1829),
    [anon_sym_module] = ACTIONS(1829),
    [anon_sym_import] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(1829),
    [anon_sym_enum] = ACTIONS(1829),
    [anon_sym_var] = ACTIONS(1829),
    [anon_sym_let] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_else] = ACTIONS(1829),
    [anon_sym_if] = ACTIONS(1829),
    [anon_sym_switch] = ACTIONS(1829),
    [anon_sym_for] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_await] = ACTIONS(1829),
    [anon_sym_while] = ACTIONS(1829),
    [anon_sym_do] = ACTIONS(1829),
    [anon_sym_try] = ACTIONS(1829),
    [anon_sym_with] = ACTIONS(1829),
    [anon_sym_break] = ACTIONS(1829),
    [anon_sym_continue] = ACTIONS(1829),
    [anon_sym_debugger] = ACTIONS(1829),
    [anon_sym_return] = ACTIONS(1829),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_SEMI] = ACTIONS(1827),
    [anon_sym_case] = ACTIONS(1829),
    [anon_sym_yield] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(1827),
    [anon_sym_class] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(1829),
    [anon_sym_function] = ACTIONS(1829),
    [anon_sym_abstract] = ACTIONS(1829),
    [anon_sym_get] = ACTIONS(1829),
    [anon_sym_set] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1829),
    [anon_sym_PLUS] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1829),
    [anon_sym_SLASH] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_void] = ACTIONS(1829),
    [anon_sym_delete] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1827),
    [anon_sym_DASH_DASH] = ACTIONS(1827),
    [anon_sym_DQUOTE] = ACTIONS(1827),
    [anon_sym_SQUOTE] = ACTIONS(1827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1827),
    [sym_float_literal] = ACTIONS(1827),
    [sym_hex_literal] = ACTIONS(1829),
    [sym_int_literal] = ACTIONS(1829),
    [sym_binary_literal] = ACTIONS(1829),
    [sym_octal_literal] = ACTIONS(1829),
    [sym_bigint_literal] = ACTIONS(1827),
    [sym_this] = ACTIONS(1829),
    [sym_super] = ACTIONS(1829),
    [sym_true] = ACTIONS(1829),
    [sym_false] = ACTIONS(1829),
    [sym_null] = ACTIONS(1829),
    [anon_sym_AT] = ACTIONS(1827),
    [anon_sym_static] = ACTIONS(1829),
    [anon_sym_public] = ACTIONS(1829),
    [anon_sym_private] = ACTIONS(1829),
    [anon_sym_protected] = ACTIONS(1829),
    [anon_sym_boolean] = ACTIONS(1829),
    [anon_sym_string] = ACTIONS(1829),
    [anon_sym_symbol] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1829),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1831),
    [sym_identifier] = ACTIONS(1833),
    [anon_sym_export] = ACTIONS(1833),
    [anon_sym_default] = ACTIONS(1833),
    [anon_sym_namespace] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1831),
    [anon_sym_RBRACE] = ACTIONS(1831),
    [anon_sym_typeof] = ACTIONS(1833),
    [anon_sym_type] = ACTIONS(1833),
    [anon_sym_interface] = ACTIONS(1833),
    [anon_sym_declare] = ACTIONS(1833),
    [anon_sym_module] = ACTIONS(1833),
    [anon_sym_import] = ACTIONS(1833),
    [anon_sym_const] = ACTIONS(1833),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_var] = ACTIONS(1833),
    [anon_sym_let] = ACTIONS(1833),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_else] = ACTIONS(1833),
    [anon_sym_if] = ACTIONS(1833),
    [anon_sym_switch] = ACTIONS(1833),
    [anon_sym_for] = ACTIONS(1833),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_await] = ACTIONS(1833),
    [anon_sym_while] = ACTIONS(1833),
    [anon_sym_do] = ACTIONS(1833),
    [anon_sym_try] = ACTIONS(1833),
    [anon_sym_with] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1833),
    [anon_sym_continue] = ACTIONS(1833),
    [anon_sym_debugger] = ACTIONS(1833),
    [anon_sym_return] = ACTIONS(1833),
    [anon_sym_throw] = ACTIONS(1833),
    [anon_sym_SEMI] = ACTIONS(1831),
    [anon_sym_case] = ACTIONS(1833),
    [anon_sym_yield] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1831),
    [anon_sym_class] = ACTIONS(1833),
    [anon_sym_async] = ACTIONS(1833),
    [anon_sym_function] = ACTIONS(1833),
    [anon_sym_abstract] = ACTIONS(1833),
    [anon_sym_get] = ACTIONS(1833),
    [anon_sym_set] = ACTIONS(1833),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_PLUS] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1833),
    [anon_sym_SLASH] = ACTIONS(1833),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1831),
    [anon_sym_void] = ACTIONS(1833),
    [anon_sym_delete] = ACTIONS(1833),
    [anon_sym_PLUS_PLUS] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(1831),
    [anon_sym_SQUOTE] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1831),
    [sym_float_literal] = ACTIONS(1831),
    [sym_hex_literal] = ACTIONS(1833),
    [sym_int_literal] = ACTIONS(1833),
    [sym_binary_literal] = ACTIONS(1833),
    [sym_octal_literal] = ACTIONS(1833),
    [sym_bigint_literal] = ACTIONS(1831),
    [sym_this] = ACTIONS(1833),
    [sym_super] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_null] = ACTIONS(1833),
    [anon_sym_AT] = ACTIONS(1831),
    [anon_sym_static] = ACTIONS(1833),
    [anon_sym_public] = ACTIONS(1833),
    [anon_sym_private] = ACTIONS(1833),
    [anon_sym_protected] = ACTIONS(1833),
    [anon_sym_boolean] = ACTIONS(1833),
    [anon_sym_string] = ACTIONS(1833),
    [anon_sym_symbol] = ACTIONS(1833),
    [sym_readonly] = ACTIONS(1833),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1837),
    [anon_sym_default] = ACTIONS(1837),
    [anon_sym_namespace] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_typeof] = ACTIONS(1837),
    [anon_sym_type] = ACTIONS(1837),
    [anon_sym_interface] = ACTIONS(1837),
    [anon_sym_declare] = ACTIONS(1837),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_import] = ACTIONS(1837),
    [anon_sym_const] = ACTIONS(1837),
    [anon_sym_enum] = ACTIONS(1837),
    [anon_sym_var] = ACTIONS(1837),
    [anon_sym_let] = ACTIONS(1837),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_else] = ACTIONS(1837),
    [anon_sym_if] = ACTIONS(1837),
    [anon_sym_switch] = ACTIONS(1837),
    [anon_sym_for] = ACTIONS(1837),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_await] = ACTIONS(1837),
    [anon_sym_while] = ACTIONS(1837),
    [anon_sym_do] = ACTIONS(1837),
    [anon_sym_try] = ACTIONS(1837),
    [anon_sym_with] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1837),
    [anon_sym_continue] = ACTIONS(1837),
    [anon_sym_debugger] = ACTIONS(1837),
    [anon_sym_return] = ACTIONS(1837),
    [anon_sym_throw] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_case] = ACTIONS(1837),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_class] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(1837),
    [anon_sym_function] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1837),
    [anon_sym_get] = ACTIONS(1837),
    [anon_sym_set] = ACTIONS(1837),
    [anon_sym_new] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_SLASH] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_void] = ACTIONS(1837),
    [anon_sym_delete] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_DQUOTE] = ACTIONS(1835),
    [anon_sym_SQUOTE] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [sym_float_literal] = ACTIONS(1835),
    [sym_hex_literal] = ACTIONS(1837),
    [sym_int_literal] = ACTIONS(1837),
    [sym_binary_literal] = ACTIONS(1837),
    [sym_octal_literal] = ACTIONS(1837),
    [sym_bigint_literal] = ACTIONS(1835),
    [sym_this] = ACTIONS(1837),
    [sym_super] = ACTIONS(1837),
    [sym_true] = ACTIONS(1837),
    [sym_false] = ACTIONS(1837),
    [sym_null] = ACTIONS(1837),
    [anon_sym_AT] = ACTIONS(1835),
    [anon_sym_static] = ACTIONS(1837),
    [anon_sym_public] = ACTIONS(1837),
    [anon_sym_private] = ACTIONS(1837),
    [anon_sym_protected] = ACTIONS(1837),
    [anon_sym_boolean] = ACTIONS(1837),
    [anon_sym_string] = ACTIONS(1837),
    [anon_sym_symbol] = ACTIONS(1837),
    [sym_readonly] = ACTIONS(1837),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1841),
    [anon_sym_export] = ACTIONS(1841),
    [anon_sym_default] = ACTIONS(1841),
    [anon_sym_namespace] = ACTIONS(1841),
    [anon_sym_LBRACE] = ACTIONS(1839),
    [anon_sym_RBRACE] = ACTIONS(1839),
    [anon_sym_typeof] = ACTIONS(1841),
    [anon_sym_type] = ACTIONS(1841),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_declare] = ACTIONS(1841),
    [anon_sym_module] = ACTIONS(1841),
    [anon_sym_import] = ACTIONS(1841),
    [anon_sym_const] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1841),
    [anon_sym_var] = ACTIONS(1841),
    [anon_sym_let] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_else] = ACTIONS(1841),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(1841),
    [anon_sym_for] = ACTIONS(1841),
    [anon_sym_LPAREN] = ACTIONS(1839),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_while] = ACTIONS(1841),
    [anon_sym_do] = ACTIONS(1841),
    [anon_sym_try] = ACTIONS(1841),
    [anon_sym_with] = ACTIONS(1841),
    [anon_sym_break] = ACTIONS(1841),
    [anon_sym_continue] = ACTIONS(1841),
    [anon_sym_debugger] = ACTIONS(1841),
    [anon_sym_return] = ACTIONS(1841),
    [anon_sym_throw] = ACTIONS(1841),
    [anon_sym_SEMI] = ACTIONS(1839),
    [anon_sym_case] = ACTIONS(1841),
    [anon_sym_yield] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1839),
    [anon_sym_class] = ACTIONS(1841),
    [anon_sym_async] = ACTIONS(1841),
    [anon_sym_function] = ACTIONS(1841),
    [anon_sym_abstract] = ACTIONS(1841),
    [anon_sym_get] = ACTIONS(1841),
    [anon_sym_set] = ACTIONS(1841),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_void] = ACTIONS(1841),
    [anon_sym_delete] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_DQUOTE] = ACTIONS(1839),
    [anon_sym_SQUOTE] = ACTIONS(1839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1839),
    [sym_float_literal] = ACTIONS(1839),
    [sym_hex_literal] = ACTIONS(1841),
    [sym_int_literal] = ACTIONS(1841),
    [sym_binary_literal] = ACTIONS(1841),
    [sym_octal_literal] = ACTIONS(1841),
    [sym_bigint_literal] = ACTIONS(1839),
    [sym_this] = ACTIONS(1841),
    [sym_super] = ACTIONS(1841),
    [sym_true] = ACTIONS(1841),
    [sym_false] = ACTIONS(1841),
    [sym_null] = ACTIONS(1841),
    [anon_sym_AT] = ACTIONS(1839),
    [anon_sym_static] = ACTIONS(1841),
    [anon_sym_public] = ACTIONS(1841),
    [anon_sym_private] = ACTIONS(1841),
    [anon_sym_protected] = ACTIONS(1841),
    [anon_sym_boolean] = ACTIONS(1841),
    [anon_sym_string] = ACTIONS(1841),
    [anon_sym_symbol] = ACTIONS(1841),
    [sym_readonly] = ACTIONS(1841),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1843),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1845),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_namespace] = ACTIONS(1845),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_RBRACE] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1845),
    [anon_sym_type] = ACTIONS(1845),
    [anon_sym_interface] = ACTIONS(1845),
    [anon_sym_declare] = ACTIONS(1845),
    [anon_sym_module] = ACTIONS(1845),
    [anon_sym_import] = ACTIONS(1845),
    [anon_sym_const] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1845),
    [anon_sym_var] = ACTIONS(1845),
    [anon_sym_let] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_else] = ACTIONS(1845),
    [anon_sym_if] = ACTIONS(1845),
    [anon_sym_switch] = ACTIONS(1845),
    [anon_sym_for] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(1843),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1845),
    [anon_sym_do] = ACTIONS(1845),
    [anon_sym_try] = ACTIONS(1845),
    [anon_sym_with] = ACTIONS(1845),
    [anon_sym_break] = ACTIONS(1845),
    [anon_sym_continue] = ACTIONS(1845),
    [anon_sym_debugger] = ACTIONS(1845),
    [anon_sym_return] = ACTIONS(1845),
    [anon_sym_throw] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1843),
    [anon_sym_case] = ACTIONS(1845),
    [anon_sym_yield] = ACTIONS(1845),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(1845),
    [anon_sym_function] = ACTIONS(1845),
    [anon_sym_abstract] = ACTIONS(1845),
    [anon_sym_get] = ACTIONS(1845),
    [anon_sym_set] = ACTIONS(1845),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1845),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_void] = ACTIONS(1845),
    [anon_sym_delete] = ACTIONS(1845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_DQUOTE] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1843),
    [sym_float_literal] = ACTIONS(1843),
    [sym_hex_literal] = ACTIONS(1845),
    [sym_int_literal] = ACTIONS(1845),
    [sym_binary_literal] = ACTIONS(1845),
    [sym_octal_literal] = ACTIONS(1845),
    [sym_bigint_literal] = ACTIONS(1843),
    [sym_this] = ACTIONS(1845),
    [sym_super] = ACTIONS(1845),
    [sym_true] = ACTIONS(1845),
    [sym_false] = ACTIONS(1845),
    [sym_null] = ACTIONS(1845),
    [anon_sym_AT] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1845),
    [anon_sym_public] = ACTIONS(1845),
    [anon_sym_private] = ACTIONS(1845),
    [anon_sym_protected] = ACTIONS(1845),
    [anon_sym_boolean] = ACTIONS(1845),
    [anon_sym_string] = ACTIONS(1845),
    [anon_sym_symbol] = ACTIONS(1845),
    [sym_readonly] = ACTIONS(1845),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_export] = ACTIONS(1050),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_namespace] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [anon_sym_typeof] = ACTIONS(1050),
    [anon_sym_type] = ACTIONS(1050),
    [anon_sym_interface] = ACTIONS(1050),
    [anon_sym_declare] = ACTIONS(1050),
    [anon_sym_module] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1050),
    [anon_sym_const] = ACTIONS(1050),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_var] = ACTIONS(1050),
    [anon_sym_let] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_else] = ACTIONS(1050),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_switch] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1050),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_while] = ACTIONS(1050),
    [anon_sym_do] = ACTIONS(1050),
    [anon_sym_try] = ACTIONS(1050),
    [anon_sym_with] = ACTIONS(1050),
    [anon_sym_break] = ACTIONS(1050),
    [anon_sym_continue] = ACTIONS(1050),
    [anon_sym_debugger] = ACTIONS(1050),
    [anon_sym_return] = ACTIONS(1050),
    [anon_sym_throw] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1050),
    [anon_sym_yield] = ACTIONS(1050),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_class] = ACTIONS(1050),
    [anon_sym_async] = ACTIONS(1050),
    [anon_sym_function] = ACTIONS(1050),
    [anon_sym_abstract] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(1050),
    [anon_sym_set] = ACTIONS(1050),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(1050),
    [anon_sym_LT] = ACTIONS(1048),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1050),
    [anon_sym_delete] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [anon_sym_SQUOTE] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1048),
    [sym_float_literal] = ACTIONS(1048),
    [sym_hex_literal] = ACTIONS(1050),
    [sym_int_literal] = ACTIONS(1050),
    [sym_binary_literal] = ACTIONS(1050),
    [sym_octal_literal] = ACTIONS(1050),
    [sym_bigint_literal] = ACTIONS(1048),
    [sym_this] = ACTIONS(1050),
    [sym_super] = ACTIONS(1050),
    [sym_true] = ACTIONS(1050),
    [sym_false] = ACTIONS(1050),
    [sym_null] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_static] = ACTIONS(1050),
    [anon_sym_public] = ACTIONS(1050),
    [anon_sym_private] = ACTIONS(1050),
    [anon_sym_protected] = ACTIONS(1050),
    [anon_sym_boolean] = ACTIONS(1050),
    [anon_sym_string] = ACTIONS(1050),
    [anon_sym_symbol] = ACTIONS(1050),
    [sym_readonly] = ACTIONS(1050),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1849),
    [anon_sym_export] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_namespace] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1847),
    [anon_sym_RBRACE] = ACTIONS(1847),
    [anon_sym_typeof] = ACTIONS(1849),
    [anon_sym_type] = ACTIONS(1849),
    [anon_sym_interface] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1849),
    [anon_sym_module] = ACTIONS(1849),
    [anon_sym_import] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_var] = ACTIONS(1849),
    [anon_sym_let] = ACTIONS(1849),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_else] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1847),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_try] = ACTIONS(1849),
    [anon_sym_with] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_debugger] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_throw] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_yield] = ACTIONS(1849),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1849),
    [anon_sym_function] = ACTIONS(1849),
    [anon_sym_abstract] = ACTIONS(1849),
    [anon_sym_get] = ACTIONS(1849),
    [anon_sym_set] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_SLASH] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1847),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_delete] = ACTIONS(1849),
    [anon_sym_PLUS_PLUS] = ACTIONS(1847),
    [anon_sym_DASH_DASH] = ACTIONS(1847),
    [anon_sym_DQUOTE] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1847),
    [sym_float_literal] = ACTIONS(1847),
    [sym_hex_literal] = ACTIONS(1849),
    [sym_int_literal] = ACTIONS(1849),
    [sym_binary_literal] = ACTIONS(1849),
    [sym_octal_literal] = ACTIONS(1849),
    [sym_bigint_literal] = ACTIONS(1847),
    [sym_this] = ACTIONS(1849),
    [sym_super] = ACTIONS(1849),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(1847),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_public] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1849),
    [anon_sym_protected] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_symbol] = ACTIONS(1849),
    [sym_readonly] = ACTIONS(1849),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1853),
    [anon_sym_default] = ACTIONS(1853),
    [anon_sym_namespace] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_typeof] = ACTIONS(1853),
    [anon_sym_type] = ACTIONS(1853),
    [anon_sym_interface] = ACTIONS(1853),
    [anon_sym_declare] = ACTIONS(1853),
    [anon_sym_module] = ACTIONS(1853),
    [anon_sym_import] = ACTIONS(1853),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1853),
    [anon_sym_var] = ACTIONS(1853),
    [anon_sym_let] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_else] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_switch] = ACTIONS(1853),
    [anon_sym_for] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [anon_sym_await] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_try] = ACTIONS(1853),
    [anon_sym_with] = ACTIONS(1853),
    [anon_sym_break] = ACTIONS(1853),
    [anon_sym_continue] = ACTIONS(1853),
    [anon_sym_debugger] = ACTIONS(1853),
    [anon_sym_return] = ACTIONS(1853),
    [anon_sym_throw] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_case] = ACTIONS(1853),
    [anon_sym_yield] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1851),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1853),
    [anon_sym_function] = ACTIONS(1853),
    [anon_sym_abstract] = ACTIONS(1853),
    [anon_sym_get] = ACTIONS(1853),
    [anon_sym_set] = ACTIONS(1853),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(1853),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_void] = ACTIONS(1853),
    [anon_sym_delete] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_DQUOTE] = ACTIONS(1851),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1851),
    [sym_float_literal] = ACTIONS(1851),
    [sym_hex_literal] = ACTIONS(1853),
    [sym_int_literal] = ACTIONS(1853),
    [sym_binary_literal] = ACTIONS(1853),
    [sym_octal_literal] = ACTIONS(1853),
    [sym_bigint_literal] = ACTIONS(1851),
    [sym_this] = ACTIONS(1853),
    [sym_super] = ACTIONS(1853),
    [sym_true] = ACTIONS(1853),
    [sym_false] = ACTIONS(1853),
    [sym_null] = ACTIONS(1853),
    [anon_sym_AT] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1853),
    [anon_sym_public] = ACTIONS(1853),
    [anon_sym_private] = ACTIONS(1853),
    [anon_sym_protected] = ACTIONS(1853),
    [anon_sym_boolean] = ACTIONS(1853),
    [anon_sym_string] = ACTIONS(1853),
    [anon_sym_symbol] = ACTIONS(1853),
    [sym_readonly] = ACTIONS(1853),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1857),
    [anon_sym_export] = ACTIONS(1857),
    [anon_sym_default] = ACTIONS(1857),
    [anon_sym_namespace] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_typeof] = ACTIONS(1857),
    [anon_sym_type] = ACTIONS(1857),
    [anon_sym_interface] = ACTIONS(1857),
    [anon_sym_declare] = ACTIONS(1857),
    [anon_sym_module] = ACTIONS(1857),
    [anon_sym_import] = ACTIONS(1857),
    [anon_sym_const] = ACTIONS(1857),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_var] = ACTIONS(1857),
    [anon_sym_let] = ACTIONS(1857),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_else] = ACTIONS(1857),
    [anon_sym_if] = ACTIONS(1857),
    [anon_sym_switch] = ACTIONS(1857),
    [anon_sym_for] = ACTIONS(1857),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_await] = ACTIONS(1857),
    [anon_sym_while] = ACTIONS(1857),
    [anon_sym_do] = ACTIONS(1857),
    [anon_sym_try] = ACTIONS(1857),
    [anon_sym_with] = ACTIONS(1857),
    [anon_sym_break] = ACTIONS(1857),
    [anon_sym_continue] = ACTIONS(1857),
    [anon_sym_debugger] = ACTIONS(1857),
    [anon_sym_return] = ACTIONS(1857),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_SEMI] = ACTIONS(1855),
    [anon_sym_case] = ACTIONS(1857),
    [anon_sym_yield] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1855),
    [anon_sym_class] = ACTIONS(1857),
    [anon_sym_async] = ACTIONS(1857),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_abstract] = ACTIONS(1857),
    [anon_sym_get] = ACTIONS(1857),
    [anon_sym_set] = ACTIONS(1857),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_PLUS] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1857),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1855),
    [anon_sym_void] = ACTIONS(1857),
    [anon_sym_delete] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_DQUOTE] = ACTIONS(1855),
    [anon_sym_SQUOTE] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1855),
    [sym_float_literal] = ACTIONS(1855),
    [sym_hex_literal] = ACTIONS(1857),
    [sym_int_literal] = ACTIONS(1857),
    [sym_binary_literal] = ACTIONS(1857),
    [sym_octal_literal] = ACTIONS(1857),
    [sym_bigint_literal] = ACTIONS(1855),
    [sym_this] = ACTIONS(1857),
    [sym_super] = ACTIONS(1857),
    [sym_true] = ACTIONS(1857),
    [sym_false] = ACTIONS(1857),
    [sym_null] = ACTIONS(1857),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_static] = ACTIONS(1857),
    [anon_sym_public] = ACTIONS(1857),
    [anon_sym_private] = ACTIONS(1857),
    [anon_sym_protected] = ACTIONS(1857),
    [anon_sym_boolean] = ACTIONS(1857),
    [anon_sym_string] = ACTIONS(1857),
    [anon_sym_symbol] = ACTIONS(1857),
    [sym_readonly] = ACTIONS(1857),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_export] = ACTIONS(1861),
    [anon_sym_default] = ACTIONS(1861),
    [anon_sym_namespace] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_typeof] = ACTIONS(1861),
    [anon_sym_type] = ACTIONS(1861),
    [anon_sym_interface] = ACTIONS(1861),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1861),
    [anon_sym_import] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_enum] = ACTIONS(1861),
    [anon_sym_var] = ACTIONS(1861),
    [anon_sym_let] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_else] = ACTIONS(1861),
    [anon_sym_if] = ACTIONS(1861),
    [anon_sym_switch] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_await] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1861),
    [anon_sym_do] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1861),
    [anon_sym_with] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1861),
    [anon_sym_continue] = ACTIONS(1861),
    [anon_sym_debugger] = ACTIONS(1861),
    [anon_sym_return] = ACTIONS(1861),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_case] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_class] = ACTIONS(1861),
    [anon_sym_async] = ACTIONS(1861),
    [anon_sym_function] = ACTIONS(1861),
    [anon_sym_abstract] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(1861),
    [anon_sym_set] = ACTIONS(1861),
    [anon_sym_new] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_void] = ACTIONS(1861),
    [anon_sym_delete] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [anon_sym_SQUOTE] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1859),
    [sym_float_literal] = ACTIONS(1859),
    [sym_hex_literal] = ACTIONS(1861),
    [sym_int_literal] = ACTIONS(1861),
    [sym_binary_literal] = ACTIONS(1861),
    [sym_octal_literal] = ACTIONS(1861),
    [sym_bigint_literal] = ACTIONS(1859),
    [sym_this] = ACTIONS(1861),
    [sym_super] = ACTIONS(1861),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [anon_sym_AT] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_public] = ACTIONS(1861),
    [anon_sym_private] = ACTIONS(1861),
    [anon_sym_protected] = ACTIONS(1861),
    [anon_sym_boolean] = ACTIONS(1861),
    [anon_sym_string] = ACTIONS(1861),
    [anon_sym_symbol] = ACTIONS(1861),
    [sym_readonly] = ACTIONS(1861),
  },
  [531] = {
    [sym__call_signature] = STATE(3296),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_export] = ACTIONS(1767),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1767),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1767),
    [anon_sym_module] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1437),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(1490),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1767),
    [anon_sym_set] = ACTIONS(1767),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1767),
    [anon_sym_public] = ACTIONS(1767),
    [anon_sym_private] = ACTIONS(1767),
    [anon_sym_protected] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [sym_readonly] = ACTIONS(1767),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1863),
    [sym_identifier] = ACTIONS(1865),
    [anon_sym_export] = ACTIONS(1865),
    [anon_sym_default] = ACTIONS(1865),
    [anon_sym_namespace] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1863),
    [anon_sym_typeof] = ACTIONS(1865),
    [anon_sym_type] = ACTIONS(1865),
    [anon_sym_interface] = ACTIONS(1865),
    [anon_sym_declare] = ACTIONS(1865),
    [anon_sym_module] = ACTIONS(1865),
    [anon_sym_import] = ACTIONS(1865),
    [anon_sym_const] = ACTIONS(1865),
    [anon_sym_enum] = ACTIONS(1865),
    [anon_sym_var] = ACTIONS(1865),
    [anon_sym_let] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_else] = ACTIONS(1865),
    [anon_sym_if] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_await] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_do] = ACTIONS(1865),
    [anon_sym_try] = ACTIONS(1865),
    [anon_sym_with] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1865),
    [anon_sym_continue] = ACTIONS(1865),
    [anon_sym_debugger] = ACTIONS(1865),
    [anon_sym_return] = ACTIONS(1865),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1863),
    [anon_sym_case] = ACTIONS(1865),
    [anon_sym_yield] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_class] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(1865),
    [anon_sym_function] = ACTIONS(1865),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_get] = ACTIONS(1865),
    [anon_sym_set] = ACTIONS(1865),
    [anon_sym_new] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1865),
    [anon_sym_SLASH] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_TILDE] = ACTIONS(1863),
    [anon_sym_void] = ACTIONS(1865),
    [anon_sym_delete] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1863),
    [anon_sym_DASH_DASH] = ACTIONS(1863),
    [anon_sym_DQUOTE] = ACTIONS(1863),
    [anon_sym_SQUOTE] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1863),
    [sym_float_literal] = ACTIONS(1863),
    [sym_hex_literal] = ACTIONS(1865),
    [sym_int_literal] = ACTIONS(1865),
    [sym_binary_literal] = ACTIONS(1865),
    [sym_octal_literal] = ACTIONS(1865),
    [sym_bigint_literal] = ACTIONS(1863),
    [sym_this] = ACTIONS(1865),
    [sym_super] = ACTIONS(1865),
    [sym_true] = ACTIONS(1865),
    [sym_false] = ACTIONS(1865),
    [sym_null] = ACTIONS(1865),
    [anon_sym_AT] = ACTIONS(1863),
    [anon_sym_static] = ACTIONS(1865),
    [anon_sym_public] = ACTIONS(1865),
    [anon_sym_private] = ACTIONS(1865),
    [anon_sym_protected] = ACTIONS(1865),
    [anon_sym_boolean] = ACTIONS(1865),
    [anon_sym_string] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1865),
    [sym_readonly] = ACTIONS(1865),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1869),
    [anon_sym_export] = ACTIONS(1869),
    [anon_sym_default] = ACTIONS(1869),
    [anon_sym_namespace] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_typeof] = ACTIONS(1869),
    [anon_sym_type] = ACTIONS(1869),
    [anon_sym_interface] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1869),
    [anon_sym_module] = ACTIONS(1869),
    [anon_sym_import] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(1869),
    [anon_sym_enum] = ACTIONS(1869),
    [anon_sym_var] = ACTIONS(1869),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_else] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1869),
    [anon_sym_switch] = ACTIONS(1869),
    [anon_sym_for] = ACTIONS(1869),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_await] = ACTIONS(1869),
    [anon_sym_while] = ACTIONS(1869),
    [anon_sym_do] = ACTIONS(1869),
    [anon_sym_try] = ACTIONS(1869),
    [anon_sym_with] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1869),
    [anon_sym_continue] = ACTIONS(1869),
    [anon_sym_debugger] = ACTIONS(1869),
    [anon_sym_return] = ACTIONS(1869),
    [anon_sym_throw] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_case] = ACTIONS(1869),
    [anon_sym_yield] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_class] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(1869),
    [anon_sym_function] = ACTIONS(1869),
    [anon_sym_abstract] = ACTIONS(1869),
    [anon_sym_get] = ACTIONS(1869),
    [anon_sym_set] = ACTIONS(1869),
    [anon_sym_new] = ACTIONS(1869),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_SLASH] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1869),
    [anon_sym_delete] = ACTIONS(1869),
    [anon_sym_PLUS_PLUS] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1867),
    [sym_float_literal] = ACTIONS(1867),
    [sym_hex_literal] = ACTIONS(1869),
    [sym_int_literal] = ACTIONS(1869),
    [sym_binary_literal] = ACTIONS(1869),
    [sym_octal_literal] = ACTIONS(1869),
    [sym_bigint_literal] = ACTIONS(1867),
    [sym_this] = ACTIONS(1869),
    [sym_super] = ACTIONS(1869),
    [sym_true] = ACTIONS(1869),
    [sym_false] = ACTIONS(1869),
    [sym_null] = ACTIONS(1869),
    [anon_sym_AT] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1869),
    [anon_sym_public] = ACTIONS(1869),
    [anon_sym_private] = ACTIONS(1869),
    [anon_sym_protected] = ACTIONS(1869),
    [anon_sym_boolean] = ACTIONS(1869),
    [anon_sym_string] = ACTIONS(1869),
    [anon_sym_symbol] = ACTIONS(1869),
    [sym_readonly] = ACTIONS(1869),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(1873),
    [anon_sym_export] = ACTIONS(1873),
    [anon_sym_default] = ACTIONS(1873),
    [anon_sym_namespace] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1871),
    [anon_sym_RBRACE] = ACTIONS(1871),
    [anon_sym_typeof] = ACTIONS(1873),
    [anon_sym_type] = ACTIONS(1873),
    [anon_sym_interface] = ACTIONS(1873),
    [anon_sym_declare] = ACTIONS(1873),
    [anon_sym_module] = ACTIONS(1873),
    [anon_sym_import] = ACTIONS(1873),
    [anon_sym_const] = ACTIONS(1873),
    [anon_sym_enum] = ACTIONS(1873),
    [anon_sym_var] = ACTIONS(1873),
    [anon_sym_let] = ACTIONS(1873),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_else] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1873),
    [anon_sym_switch] = ACTIONS(1873),
    [anon_sym_for] = ACTIONS(1873),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_await] = ACTIONS(1873),
    [anon_sym_while] = ACTIONS(1873),
    [anon_sym_do] = ACTIONS(1873),
    [anon_sym_try] = ACTIONS(1873),
    [anon_sym_with] = ACTIONS(1873),
    [anon_sym_break] = ACTIONS(1873),
    [anon_sym_continue] = ACTIONS(1873),
    [anon_sym_debugger] = ACTIONS(1873),
    [anon_sym_return] = ACTIONS(1873),
    [anon_sym_throw] = ACTIONS(1873),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_case] = ACTIONS(1873),
    [anon_sym_yield] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_class] = ACTIONS(1873),
    [anon_sym_async] = ACTIONS(1873),
    [anon_sym_function] = ACTIONS(1873),
    [anon_sym_abstract] = ACTIONS(1873),
    [anon_sym_get] = ACTIONS(1873),
    [anon_sym_set] = ACTIONS(1873),
    [anon_sym_new] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_SLASH] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_void] = ACTIONS(1873),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1871),
    [sym_float_literal] = ACTIONS(1871),
    [sym_hex_literal] = ACTIONS(1873),
    [sym_int_literal] = ACTIONS(1873),
    [sym_binary_literal] = ACTIONS(1873),
    [sym_octal_literal] = ACTIONS(1873),
    [sym_bigint_literal] = ACTIONS(1871),
    [sym_this] = ACTIONS(1873),
    [sym_super] = ACTIONS(1873),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [sym_null] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1873),
    [anon_sym_private] = ACTIONS(1873),
    [anon_sym_protected] = ACTIONS(1873),
    [anon_sym_boolean] = ACTIONS(1873),
    [anon_sym_string] = ACTIONS(1873),
    [anon_sym_symbol] = ACTIONS(1873),
    [sym_readonly] = ACTIONS(1873),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1877),
    [anon_sym_export] = ACTIONS(1877),
    [anon_sym_default] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_RBRACE] = ACTIONS(1875),
    [anon_sym_typeof] = ACTIONS(1877),
    [anon_sym_type] = ACTIONS(1877),
    [anon_sym_interface] = ACTIONS(1877),
    [anon_sym_declare] = ACTIONS(1877),
    [anon_sym_module] = ACTIONS(1877),
    [anon_sym_import] = ACTIONS(1877),
    [anon_sym_const] = ACTIONS(1877),
    [anon_sym_enum] = ACTIONS(1877),
    [anon_sym_var] = ACTIONS(1877),
    [anon_sym_let] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_else] = ACTIONS(1877),
    [anon_sym_if] = ACTIONS(1877),
    [anon_sym_switch] = ACTIONS(1877),
    [anon_sym_for] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1875),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_while] = ACTIONS(1877),
    [anon_sym_do] = ACTIONS(1877),
    [anon_sym_try] = ACTIONS(1877),
    [anon_sym_with] = ACTIONS(1877),
    [anon_sym_break] = ACTIONS(1877),
    [anon_sym_continue] = ACTIONS(1877),
    [anon_sym_debugger] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(1877),
    [anon_sym_throw] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1875),
    [anon_sym_case] = ACTIONS(1877),
    [anon_sym_yield] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1875),
    [anon_sym_class] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(1877),
    [anon_sym_function] = ACTIONS(1877),
    [anon_sym_abstract] = ACTIONS(1877),
    [anon_sym_get] = ACTIONS(1877),
    [anon_sym_set] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_SLASH] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_void] = ACTIONS(1877),
    [anon_sym_delete] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_SQUOTE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1875),
    [sym_float_literal] = ACTIONS(1875),
    [sym_hex_literal] = ACTIONS(1877),
    [sym_int_literal] = ACTIONS(1877),
    [sym_binary_literal] = ACTIONS(1877),
    [sym_octal_literal] = ACTIONS(1877),
    [sym_bigint_literal] = ACTIONS(1875),
    [sym_this] = ACTIONS(1877),
    [sym_super] = ACTIONS(1877),
    [sym_true] = ACTIONS(1877),
    [sym_false] = ACTIONS(1877),
    [sym_null] = ACTIONS(1877),
    [anon_sym_AT] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1877),
    [anon_sym_public] = ACTIONS(1877),
    [anon_sym_private] = ACTIONS(1877),
    [anon_sym_protected] = ACTIONS(1877),
    [anon_sym_boolean] = ACTIONS(1877),
    [anon_sym_string] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1877),
    [sym_readonly] = ACTIONS(1877),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1881),
    [anon_sym_export] = ACTIONS(1881),
    [anon_sym_default] = ACTIONS(1881),
    [anon_sym_namespace] = ACTIONS(1881),
    [anon_sym_LBRACE] = ACTIONS(1879),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_interface] = ACTIONS(1881),
    [anon_sym_declare] = ACTIONS(1881),
    [anon_sym_module] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1881),
    [anon_sym_const] = ACTIONS(1881),
    [anon_sym_enum] = ACTIONS(1881),
    [anon_sym_var] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_else] = ACTIONS(1881),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_switch] = ACTIONS(1881),
    [anon_sym_for] = ACTIONS(1881),
    [anon_sym_LPAREN] = ACTIONS(1879),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_while] = ACTIONS(1881),
    [anon_sym_do] = ACTIONS(1881),
    [anon_sym_try] = ACTIONS(1881),
    [anon_sym_with] = ACTIONS(1881),
    [anon_sym_break] = ACTIONS(1881),
    [anon_sym_continue] = ACTIONS(1881),
    [anon_sym_debugger] = ACTIONS(1881),
    [anon_sym_return] = ACTIONS(1881),
    [anon_sym_throw] = ACTIONS(1881),
    [anon_sym_SEMI] = ACTIONS(1879),
    [anon_sym_case] = ACTIONS(1881),
    [anon_sym_yield] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1879),
    [anon_sym_class] = ACTIONS(1881),
    [anon_sym_async] = ACTIONS(1881),
    [anon_sym_function] = ACTIONS(1881),
    [anon_sym_abstract] = ACTIONS(1881),
    [anon_sym_get] = ACTIONS(1881),
    [anon_sym_set] = ACTIONS(1881),
    [anon_sym_new] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_void] = ACTIONS(1881),
    [anon_sym_delete] = ACTIONS(1881),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1879),
    [sym_float_literal] = ACTIONS(1879),
    [sym_hex_literal] = ACTIONS(1881),
    [sym_int_literal] = ACTIONS(1881),
    [sym_binary_literal] = ACTIONS(1881),
    [sym_octal_literal] = ACTIONS(1881),
    [sym_bigint_literal] = ACTIONS(1879),
    [sym_this] = ACTIONS(1881),
    [sym_super] = ACTIONS(1881),
    [sym_true] = ACTIONS(1881),
    [sym_false] = ACTIONS(1881),
    [sym_null] = ACTIONS(1881),
    [anon_sym_AT] = ACTIONS(1879),
    [anon_sym_static] = ACTIONS(1881),
    [anon_sym_public] = ACTIONS(1881),
    [anon_sym_private] = ACTIONS(1881),
    [anon_sym_protected] = ACTIONS(1881),
    [anon_sym_boolean] = ACTIONS(1881),
    [anon_sym_string] = ACTIONS(1881),
    [anon_sym_symbol] = ACTIONS(1881),
    [sym_readonly] = ACTIONS(1881),
  },
  [537] = {
    [sym__call_signature] = STATE(3182),
    [sym_arguments] = STATE(1218),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_arguments] = STATE(1089),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_of] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(1749),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1887),
    [sym_identifier] = ACTIONS(1889),
    [anon_sym_export] = ACTIONS(1889),
    [anon_sym_default] = ACTIONS(1889),
    [anon_sym_namespace] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(1887),
    [anon_sym_RBRACE] = ACTIONS(1887),
    [anon_sym_typeof] = ACTIONS(1889),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_interface] = ACTIONS(1889),
    [anon_sym_declare] = ACTIONS(1889),
    [anon_sym_module] = ACTIONS(1889),
    [anon_sym_import] = ACTIONS(1889),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_enum] = ACTIONS(1889),
    [anon_sym_var] = ACTIONS(1889),
    [anon_sym_let] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(1887),
    [anon_sym_else] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1889),
    [anon_sym_switch] = ACTIONS(1889),
    [anon_sym_for] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1889),
    [anon_sym_while] = ACTIONS(1889),
    [anon_sym_do] = ACTIONS(1889),
    [anon_sym_try] = ACTIONS(1889),
    [anon_sym_with] = ACTIONS(1889),
    [anon_sym_break] = ACTIONS(1889),
    [anon_sym_continue] = ACTIONS(1889),
    [anon_sym_debugger] = ACTIONS(1889),
    [anon_sym_return] = ACTIONS(1889),
    [anon_sym_throw] = ACTIONS(1889),
    [anon_sym_SEMI] = ACTIONS(1887),
    [anon_sym_case] = ACTIONS(1889),
    [anon_sym_yield] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(1887),
    [anon_sym_class] = ACTIONS(1889),
    [anon_sym_async] = ACTIONS(1889),
    [anon_sym_function] = ACTIONS(1889),
    [anon_sym_abstract] = ACTIONS(1889),
    [anon_sym_get] = ACTIONS(1889),
    [anon_sym_set] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_PLUS] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1887),
    [anon_sym_TILDE] = ACTIONS(1887),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(1887),
    [anon_sym_DQUOTE] = ACTIONS(1887),
    [anon_sym_SQUOTE] = ACTIONS(1887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1887),
    [sym_float_literal] = ACTIONS(1887),
    [sym_hex_literal] = ACTIONS(1889),
    [sym_int_literal] = ACTIONS(1889),
    [sym_binary_literal] = ACTIONS(1889),
    [sym_octal_literal] = ACTIONS(1889),
    [sym_bigint_literal] = ACTIONS(1887),
    [sym_this] = ACTIONS(1889),
    [sym_super] = ACTIONS(1889),
    [sym_true] = ACTIONS(1889),
    [sym_false] = ACTIONS(1889),
    [sym_null] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_static] = ACTIONS(1889),
    [anon_sym_public] = ACTIONS(1889),
    [anon_sym_private] = ACTIONS(1889),
    [anon_sym_protected] = ACTIONS(1889),
    [anon_sym_boolean] = ACTIONS(1889),
    [anon_sym_string] = ACTIONS(1889),
    [anon_sym_symbol] = ACTIONS(1889),
    [sym_readonly] = ACTIONS(1889),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1877),
    [anon_sym_export] = ACTIONS(1877),
    [anon_sym_default] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_RBRACE] = ACTIONS(1875),
    [anon_sym_typeof] = ACTIONS(1877),
    [anon_sym_type] = ACTIONS(1877),
    [anon_sym_interface] = ACTIONS(1877),
    [anon_sym_declare] = ACTIONS(1877),
    [anon_sym_module] = ACTIONS(1877),
    [anon_sym_import] = ACTIONS(1877),
    [anon_sym_const] = ACTIONS(1877),
    [anon_sym_enum] = ACTIONS(1877),
    [anon_sym_var] = ACTIONS(1877),
    [anon_sym_let] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_else] = ACTIONS(1877),
    [anon_sym_if] = ACTIONS(1877),
    [anon_sym_switch] = ACTIONS(1877),
    [anon_sym_for] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1875),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_while] = ACTIONS(1877),
    [anon_sym_do] = ACTIONS(1877),
    [anon_sym_try] = ACTIONS(1877),
    [anon_sym_with] = ACTIONS(1877),
    [anon_sym_break] = ACTIONS(1877),
    [anon_sym_continue] = ACTIONS(1877),
    [anon_sym_debugger] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(1877),
    [anon_sym_throw] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1875),
    [anon_sym_case] = ACTIONS(1877),
    [anon_sym_yield] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1875),
    [anon_sym_class] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(1877),
    [anon_sym_function] = ACTIONS(1877),
    [anon_sym_abstract] = ACTIONS(1877),
    [anon_sym_get] = ACTIONS(1877),
    [anon_sym_set] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_SLASH] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_void] = ACTIONS(1877),
    [anon_sym_delete] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_SQUOTE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1875),
    [sym_float_literal] = ACTIONS(1875),
    [sym_hex_literal] = ACTIONS(1877),
    [sym_int_literal] = ACTIONS(1877),
    [sym_binary_literal] = ACTIONS(1877),
    [sym_octal_literal] = ACTIONS(1877),
    [sym_bigint_literal] = ACTIONS(1875),
    [sym_this] = ACTIONS(1877),
    [sym_super] = ACTIONS(1877),
    [sym_true] = ACTIONS(1877),
    [sym_false] = ACTIONS(1877),
    [sym_null] = ACTIONS(1877),
    [anon_sym_AT] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1877),
    [anon_sym_public] = ACTIONS(1877),
    [anon_sym_private] = ACTIONS(1877),
    [anon_sym_protected] = ACTIONS(1877),
    [anon_sym_boolean] = ACTIONS(1877),
    [anon_sym_string] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1877),
    [sym_readonly] = ACTIONS(1877),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_export] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_typeof] = ACTIONS(1897),
    [anon_sym_type] = ACTIONS(1897),
    [anon_sym_interface] = ACTIONS(1897),
    [anon_sym_declare] = ACTIONS(1897),
    [anon_sym_module] = ACTIONS(1897),
    [anon_sym_import] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_var] = ACTIONS(1897),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_await] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_with] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_debugger] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1895),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_async] = ACTIONS(1897),
    [anon_sym_function] = ACTIONS(1897),
    [anon_sym_abstract] = ACTIONS(1897),
    [anon_sym_get] = ACTIONS(1897),
    [anon_sym_set] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_void] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1895),
    [sym_float_literal] = ACTIONS(1895),
    [sym_hex_literal] = ACTIONS(1897),
    [sym_int_literal] = ACTIONS(1897),
    [sym_binary_literal] = ACTIONS(1897),
    [sym_octal_literal] = ACTIONS(1897),
    [sym_bigint_literal] = ACTIONS(1895),
    [sym_this] = ACTIONS(1897),
    [sym_super] = ACTIONS(1897),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [sym_null] = ACTIONS(1897),
    [anon_sym_AT] = ACTIONS(1895),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_boolean] = ACTIONS(1897),
    [anon_sym_string] = ACTIONS(1897),
    [anon_sym_symbol] = ACTIONS(1897),
    [sym_readonly] = ACTIONS(1897),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1901),
    [anon_sym_export] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_typeof] = ACTIONS(1901),
    [anon_sym_type] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1901),
    [anon_sym_declare] = ACTIONS(1901),
    [anon_sym_module] = ACTIONS(1901),
    [anon_sym_import] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_var] = ACTIONS(1901),
    [anon_sym_let] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1899),
    [anon_sym_await] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_with] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_debugger] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_yield] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1899),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(1901),
    [anon_sym_function] = ACTIONS(1901),
    [anon_sym_abstract] = ACTIONS(1901),
    [anon_sym_get] = ACTIONS(1901),
    [anon_sym_set] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1901),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_void] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1899),
    [sym_float_literal] = ACTIONS(1899),
    [sym_hex_literal] = ACTIONS(1901),
    [sym_int_literal] = ACTIONS(1901),
    [sym_binary_literal] = ACTIONS(1901),
    [sym_octal_literal] = ACTIONS(1901),
    [sym_bigint_literal] = ACTIONS(1899),
    [sym_this] = ACTIONS(1901),
    [sym_super] = ACTIONS(1901),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [sym_null] = ACTIONS(1901),
    [anon_sym_AT] = ACTIONS(1899),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_boolean] = ACTIONS(1901),
    [anon_sym_string] = ACTIONS(1901),
    [anon_sym_symbol] = ACTIONS(1901),
    [sym_readonly] = ACTIONS(1901),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_float_literal] = ACTIONS(1114),
    [sym_hex_literal] = ACTIONS(1116),
    [sym_int_literal] = ACTIONS(1116),
    [sym_binary_literal] = ACTIONS(1116),
    [sym_octal_literal] = ACTIONS(1116),
    [sym_bigint_literal] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(1903),
    [sym_identifier] = ACTIONS(1905),
    [anon_sym_export] = ACTIONS(1905),
    [anon_sym_default] = ACTIONS(1905),
    [anon_sym_namespace] = ACTIONS(1905),
    [anon_sym_LBRACE] = ACTIONS(1903),
    [anon_sym_RBRACE] = ACTIONS(1903),
    [anon_sym_typeof] = ACTIONS(1905),
    [anon_sym_type] = ACTIONS(1905),
    [anon_sym_interface] = ACTIONS(1905),
    [anon_sym_declare] = ACTIONS(1905),
    [anon_sym_module] = ACTIONS(1905),
    [anon_sym_import] = ACTIONS(1905),
    [anon_sym_const] = ACTIONS(1905),
    [anon_sym_enum] = ACTIONS(1905),
    [anon_sym_var] = ACTIONS(1905),
    [anon_sym_let] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1905),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_switch] = ACTIONS(1905),
    [anon_sym_for] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1905),
    [anon_sym_try] = ACTIONS(1905),
    [anon_sym_with] = ACTIONS(1905),
    [anon_sym_break] = ACTIONS(1905),
    [anon_sym_continue] = ACTIONS(1905),
    [anon_sym_debugger] = ACTIONS(1905),
    [anon_sym_return] = ACTIONS(1905),
    [anon_sym_throw] = ACTIONS(1905),
    [anon_sym_SEMI] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(1905),
    [anon_sym_yield] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1905),
    [anon_sym_async] = ACTIONS(1905),
    [anon_sym_function] = ACTIONS(1905),
    [anon_sym_abstract] = ACTIONS(1905),
    [anon_sym_get] = ACTIONS(1905),
    [anon_sym_set] = ACTIONS(1905),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1905),
    [anon_sym_SLASH] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1903),
    [anon_sym_TILDE] = ACTIONS(1903),
    [anon_sym_void] = ACTIONS(1905),
    [anon_sym_delete] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(1903),
    [anon_sym_SQUOTE] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1903),
    [sym_float_literal] = ACTIONS(1903),
    [sym_hex_literal] = ACTIONS(1905),
    [sym_int_literal] = ACTIONS(1905),
    [sym_binary_literal] = ACTIONS(1905),
    [sym_octal_literal] = ACTIONS(1905),
    [sym_bigint_literal] = ACTIONS(1903),
    [sym_this] = ACTIONS(1905),
    [sym_super] = ACTIONS(1905),
    [sym_true] = ACTIONS(1905),
    [sym_false] = ACTIONS(1905),
    [sym_null] = ACTIONS(1905),
    [anon_sym_AT] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1905),
    [anon_sym_public] = ACTIONS(1905),
    [anon_sym_private] = ACTIONS(1905),
    [anon_sym_protected] = ACTIONS(1905),
    [anon_sym_boolean] = ACTIONS(1905),
    [anon_sym_string] = ACTIONS(1905),
    [anon_sym_symbol] = ACTIONS(1905),
    [sym_readonly] = ACTIONS(1905),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_float_literal] = ACTIONS(1891),
    [sym_hex_literal] = ACTIONS(1893),
    [sym_int_literal] = ACTIONS(1893),
    [sym_binary_literal] = ACTIONS(1893),
    [sym_octal_literal] = ACTIONS(1893),
    [sym_bigint_literal] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(1907),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_export] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_typeof] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1909),
    [anon_sym_interface] = ACTIONS(1909),
    [anon_sym_declare] = ACTIONS(1909),
    [anon_sym_module] = ACTIONS(1909),
    [anon_sym_import] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_await] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_with] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_debugger] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_yield] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(1909),
    [anon_sym_function] = ACTIONS(1909),
    [anon_sym_abstract] = ACTIONS(1909),
    [anon_sym_get] = ACTIONS(1909),
    [anon_sym_set] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_SLASH] = ACTIONS(1909),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [sym_float_literal] = ACTIONS(1907),
    [sym_hex_literal] = ACTIONS(1909),
    [sym_int_literal] = ACTIONS(1909),
    [sym_binary_literal] = ACTIONS(1909),
    [sym_octal_literal] = ACTIONS(1909),
    [sym_bigint_literal] = ACTIONS(1907),
    [sym_this] = ACTIONS(1909),
    [sym_super] = ACTIONS(1909),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [sym_null] = ACTIONS(1909),
    [anon_sym_AT] = ACTIONS(1907),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_boolean] = ACTIONS(1909),
    [anon_sym_string] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1909),
    [sym_readonly] = ACTIONS(1909),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1913),
    [anon_sym_export] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_type] = ACTIONS(1913),
    [anon_sym_interface] = ACTIONS(1913),
    [anon_sym_declare] = ACTIONS(1913),
    [anon_sym_module] = ACTIONS(1913),
    [anon_sym_import] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_var] = ACTIONS(1913),
    [anon_sym_let] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [anon_sym_await] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_with] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_debugger] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_yield] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1911),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_async] = ACTIONS(1913),
    [anon_sym_function] = ACTIONS(1913),
    [anon_sym_abstract] = ACTIONS(1913),
    [anon_sym_get] = ACTIONS(1913),
    [anon_sym_set] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_void] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1911),
    [sym_float_literal] = ACTIONS(1911),
    [sym_hex_literal] = ACTIONS(1913),
    [sym_int_literal] = ACTIONS(1913),
    [sym_binary_literal] = ACTIONS(1913),
    [sym_octal_literal] = ACTIONS(1913),
    [sym_bigint_literal] = ACTIONS(1911),
    [sym_this] = ACTIONS(1913),
    [sym_super] = ACTIONS(1913),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [anon_sym_AT] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_boolean] = ACTIONS(1913),
    [anon_sym_string] = ACTIONS(1913),
    [anon_sym_symbol] = ACTIONS(1913),
    [sym_readonly] = ACTIONS(1913),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(1915),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_export] = ACTIONS(1917),
    [anon_sym_default] = ACTIONS(1917),
    [anon_sym_namespace] = ACTIONS(1917),
    [anon_sym_LBRACE] = ACTIONS(1915),
    [anon_sym_RBRACE] = ACTIONS(1915),
    [anon_sym_typeof] = ACTIONS(1917),
    [anon_sym_type] = ACTIONS(1917),
    [anon_sym_interface] = ACTIONS(1917),
    [anon_sym_declare] = ACTIONS(1917),
    [anon_sym_module] = ACTIONS(1917),
    [anon_sym_import] = ACTIONS(1917),
    [anon_sym_const] = ACTIONS(1917),
    [anon_sym_enum] = ACTIONS(1917),
    [anon_sym_var] = ACTIONS(1917),
    [anon_sym_let] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_else] = ACTIONS(1917),
    [anon_sym_if] = ACTIONS(1917),
    [anon_sym_switch] = ACTIONS(1917),
    [anon_sym_for] = ACTIONS(1917),
    [anon_sym_LPAREN] = ACTIONS(1915),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_while] = ACTIONS(1917),
    [anon_sym_do] = ACTIONS(1917),
    [anon_sym_try] = ACTIONS(1917),
    [anon_sym_with] = ACTIONS(1917),
    [anon_sym_break] = ACTIONS(1917),
    [anon_sym_continue] = ACTIONS(1917),
    [anon_sym_debugger] = ACTIONS(1917),
    [anon_sym_return] = ACTIONS(1917),
    [anon_sym_throw] = ACTIONS(1917),
    [anon_sym_SEMI] = ACTIONS(1915),
    [anon_sym_case] = ACTIONS(1917),
    [anon_sym_yield] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1915),
    [anon_sym_class] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(1917),
    [anon_sym_function] = ACTIONS(1917),
    [anon_sym_abstract] = ACTIONS(1917),
    [anon_sym_get] = ACTIONS(1917),
    [anon_sym_set] = ACTIONS(1917),
    [anon_sym_new] = ACTIONS(1917),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1917),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1915),
    [anon_sym_void] = ACTIONS(1917),
    [anon_sym_delete] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1915),
    [sym_float_literal] = ACTIONS(1915),
    [sym_hex_literal] = ACTIONS(1917),
    [sym_int_literal] = ACTIONS(1917),
    [sym_binary_literal] = ACTIONS(1917),
    [sym_octal_literal] = ACTIONS(1917),
    [sym_bigint_literal] = ACTIONS(1915),
    [sym_this] = ACTIONS(1917),
    [sym_super] = ACTIONS(1917),
    [sym_true] = ACTIONS(1917),
    [sym_false] = ACTIONS(1917),
    [sym_null] = ACTIONS(1917),
    [anon_sym_AT] = ACTIONS(1915),
    [anon_sym_static] = ACTIONS(1917),
    [anon_sym_public] = ACTIONS(1917),
    [anon_sym_private] = ACTIONS(1917),
    [anon_sym_protected] = ACTIONS(1917),
    [anon_sym_boolean] = ACTIONS(1917),
    [anon_sym_string] = ACTIONS(1917),
    [anon_sym_symbol] = ACTIONS(1917),
    [sym_readonly] = ACTIONS(1917),
  },
  [567] = {
    [sym_object] = STATE(2477),
    [sym_array] = STATE(2478),
    [sym_nested_identifier] = STATE(3285),
    [sym_string] = STATE(441),
    [sym__number] = STATE(420),
    [sym_formal_parameters] = STATE(3284),
    [sym__type] = STATE(2870),
    [sym__primary_type] = STATE(2648),
    [sym_parenthesized_type] = STATE(2648),
    [sym_predefined_type] = STATE(2648),
    [sym_nested_type_identifier] = STATE(1999),
    [sym_generic_type] = STATE(2648),
    [sym_object_type] = STATE(2648),
    [sym_array_type] = STATE(2648),
    [sym_tuple_type] = STATE(2648),
    [sym__tuple_type_body] = STATE(450),
    [sym_flow_maybe_type] = STATE(2648),
    [sym_type_query] = STATE(2648),
    [sym_index_type_query] = STATE(2648),
    [sym_existential_type] = STATE(2648),
    [sym_literal_type] = STATE(2648),
    [sym_lookup_type] = STATE(2648),
    [sym_conditional_type] = STATE(2648),
    [sym_union_type] = STATE(2870),
    [sym_intersection_type] = STATE(2870),
    [sym_function_type] = STATE(2870),
    [sym_type_parameters] = STATE(2944),
    [sym_constructor_type] = STATE(2870),
    [sym_identifier] = ACTIONS(804),
    [anon_sym_export] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_EQ] = ACTIONS(1919),
    [anon_sym_namespace] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1919),
    [anon_sym_typeof] = ACTIONS(820),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_declare] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_get] = ACTIONS(806),
    [anon_sym_set] = ACTIONS(806),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(500),
    [anon_sym_DQUOTE] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym_float_literal] = ACTIONS(850),
    [sym_hex_literal] = ACTIONS(852),
    [sym_int_literal] = ACTIONS(852),
    [sym_binary_literal] = ACTIONS(852),
    [sym_octal_literal] = ACTIONS(852),
    [sym_bigint_literal] = ACTIONS(850),
    [sym_this] = ACTIONS(854),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_boolean] = ACTIONS(856),
    [anon_sym_string] = ACTIONS(856),
    [anon_sym_symbol] = ACTIONS(856),
    [anon_sym_int] = ACTIONS(500),
    [anon_sym_float] = ACTIONS(500),
    [anon_sym_LBRACE_PIPE] = ACTIONS(502),
    [sym_readonly] = ACTIONS(858),
    [anon_sym_keyof] = ACTIONS(506),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_export] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_namespace] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_typeof] = ACTIONS(1124),
    [anon_sym_type] = ACTIONS(1124),
    [anon_sym_interface] = ACTIONS(1124),
    [anon_sym_declare] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(1124),
    [anon_sym_import] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_var] = ACTIONS(1124),
    [anon_sym_let] = ACTIONS(1124),
    [anon_sym_BANG] = ACTIONS(1122),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_await] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_try] = ACTIONS(1124),
    [anon_sym_with] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_debugger] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_throw] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(1124),
    [anon_sym_abstract] = ACTIONS(1124),
    [anon_sym_get] = ACTIONS(1124),
    [anon_sym_set] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_void] = ACTIONS(1124),
    [anon_sym_delete] = ACTIONS(1124),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1122),
    [sym_float_literal] = ACTIONS(1122),
    [sym_hex_literal] = ACTIONS(1124),
    [sym_int_literal] = ACTIONS(1124),
    [sym_binary_literal] = ACTIONS(1124),
    [sym_octal_literal] = ACTIONS(1124),
    [sym_bigint_literal] = ACTIONS(1122),
    [sym_this] = ACTIONS(1124),
    [sym_super] = ACTIONS(1124),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_null] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_public] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(1124),
    [anon_sym_boolean] = ACTIONS(1124),
    [anon_sym_string] = ACTIONS(1124),
    [anon_sym_symbol] = ACTIONS(1124),
    [sym_readonly] = ACTIONS(1124),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(1144),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_export] = ACTIONS(1146),
    [anon_sym_default] = ACTIONS(1146),
    [anon_sym_namespace] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1146),
    [anon_sym_type] = ACTIONS(1146),
    [anon_sym_interface] = ACTIONS(1146),
    [anon_sym_declare] = ACTIONS(1146),
    [anon_sym_module] = ACTIONS(1146),
    [anon_sym_import] = ACTIONS(1146),
    [anon_sym_const] = ACTIONS(1146),
    [anon_sym_enum] = ACTIONS(1146),
    [anon_sym_var] = ACTIONS(1146),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1146),
    [anon_sym_switch] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [anon_sym_await] = ACTIONS(1146),
    [anon_sym_while] = ACTIONS(1146),
    [anon_sym_do] = ACTIONS(1146),
    [anon_sym_try] = ACTIONS(1146),
    [anon_sym_with] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [anon_sym_debugger] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_throw] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1144),
    [anon_sym_case] = ACTIONS(1146),
    [anon_sym_yield] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1146),
    [anon_sym_async] = ACTIONS(1146),
    [anon_sym_function] = ACTIONS(1146),
    [anon_sym_abstract] = ACTIONS(1146),
    [anon_sym_get] = ACTIONS(1146),
    [anon_sym_set] = ACTIONS(1146),
    [anon_sym_new] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_SLASH] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1146),
    [anon_sym_delete] = ACTIONS(1146),
    [anon_sym_PLUS_PLUS] = ACTIONS(1144),
    [anon_sym_DASH_DASH] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1144),
    [sym_float_literal] = ACTIONS(1144),
    [sym_hex_literal] = ACTIONS(1146),
    [sym_int_literal] = ACTIONS(1146),
    [sym_binary_literal] = ACTIONS(1146),
    [sym_octal_literal] = ACTIONS(1146),
    [sym_bigint_literal] = ACTIONS(1144),
    [sym_this] = ACTIONS(1146),
    [sym_super] = ACTIONS(1146),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_null] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1144),
    [anon_sym_static] = ACTIONS(1146),
    [anon_sym_public] = ACTIONS(1146),
    [anon_sym_private] = ACTIONS(1146),
    [anon_sym_protected] = ACTIONS(1146),
    [anon_sym_boolean] = ACTIONS(1146),
    [anon_sym_string] = ACTIONS(1146),
    [anon_sym_symbol] = ACTIONS(1146),
    [sym_readonly] = ACTIONS(1146),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_typeof] = ACTIONS(1923),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_interface] = ACTIONS(1923),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_import] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [anon_sym_var] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_switch] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_do] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_with] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_debugger] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_throw] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_case] = ACTIONS(1923),
    [anon_sym_yield] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_class] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1923),
    [anon_sym_abstract] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1923),
    [anon_sym_set] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_SLASH] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_void] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(1923),
    [anon_sym_PLUS_PLUS] = ACTIONS(1921),
    [anon_sym_DASH_DASH] = ACTIONS(1921),
    [anon_sym_DQUOTE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1921),
    [sym_float_literal] = ACTIONS(1921),
    [sym_hex_literal] = ACTIONS(1923),
    [sym_int_literal] = ACTIONS(1923),
    [sym_binary_literal] = ACTIONS(1923),
    [sym_octal_literal] = ACTIONS(1923),
    [sym_bigint_literal] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(1921),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [sym_readonly] = ACTIONS(1923),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1927),
    [anon_sym_export] = ACTIONS(1927),
    [anon_sym_default] = ACTIONS(1927),
    [anon_sym_namespace] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1925),
    [anon_sym_RBRACE] = ACTIONS(1925),
    [anon_sym_typeof] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1927),
    [anon_sym_interface] = ACTIONS(1927),
    [anon_sym_declare] = ACTIONS(1927),
    [anon_sym_module] = ACTIONS(1927),
    [anon_sym_import] = ACTIONS(1927),
    [anon_sym_const] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1927),
    [anon_sym_var] = ACTIONS(1927),
    [anon_sym_let] = ACTIONS(1927),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(1927),
    [anon_sym_if] = ACTIONS(1927),
    [anon_sym_switch] = ACTIONS(1927),
    [anon_sym_for] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_await] = ACTIONS(1927),
    [anon_sym_while] = ACTIONS(1927),
    [anon_sym_do] = ACTIONS(1927),
    [anon_sym_try] = ACTIONS(1927),
    [anon_sym_with] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1927),
    [anon_sym_continue] = ACTIONS(1927),
    [anon_sym_debugger] = ACTIONS(1927),
    [anon_sym_return] = ACTIONS(1927),
    [anon_sym_throw] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1925),
    [anon_sym_case] = ACTIONS(1927),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_class] = ACTIONS(1927),
    [anon_sym_async] = ACTIONS(1927),
    [anon_sym_function] = ACTIONS(1927),
    [anon_sym_abstract] = ACTIONS(1927),
    [anon_sym_get] = ACTIONS(1927),
    [anon_sym_set] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1927),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_SLASH] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1925),
    [anon_sym_TILDE] = ACTIONS(1925),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_delete] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1925),
    [anon_sym_DASH_DASH] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1925),
    [sym_float_literal] = ACTIONS(1925),
    [sym_hex_literal] = ACTIONS(1927),
    [sym_int_literal] = ACTIONS(1927),
    [sym_binary_literal] = ACTIONS(1927),
    [sym_octal_literal] = ACTIONS(1927),
    [sym_bigint_literal] = ACTIONS(1925),
    [sym_this] = ACTIONS(1927),
    [sym_super] = ACTIONS(1927),
    [sym_true] = ACTIONS(1927),
    [sym_false] = ACTIONS(1927),
    [sym_null] = ACTIONS(1927),
    [anon_sym_AT] = ACTIONS(1925),
    [anon_sym_static] = ACTIONS(1927),
    [anon_sym_public] = ACTIONS(1927),
    [anon_sym_private] = ACTIONS(1927),
    [anon_sym_protected] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_symbol] = ACTIONS(1927),
    [sym_readonly] = ACTIONS(1927),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(1929),
    [sym_identifier] = ACTIONS(1931),
    [anon_sym_export] = ACTIONS(1931),
    [anon_sym_default] = ACTIONS(1931),
    [anon_sym_namespace] = ACTIONS(1931),
    [anon_sym_LBRACE] = ACTIONS(1929),
    [anon_sym_RBRACE] = ACTIONS(1929),
    [anon_sym_typeof] = ACTIONS(1931),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_interface] = ACTIONS(1931),
    [anon_sym_declare] = ACTIONS(1931),
    [anon_sym_module] = ACTIONS(1931),
    [anon_sym_import] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(1931),
    [anon_sym_enum] = ACTIONS(1931),
    [anon_sym_var] = ACTIONS(1931),
    [anon_sym_let] = ACTIONS(1931),
    [anon_sym_BANG] = ACTIONS(1929),
    [anon_sym_else] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1931),
    [anon_sym_switch] = ACTIONS(1931),
    [anon_sym_for] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_await] = ACTIONS(1931),
    [anon_sym_while] = ACTIONS(1931),
    [anon_sym_do] = ACTIONS(1931),
    [anon_sym_try] = ACTIONS(1931),
    [anon_sym_with] = ACTIONS(1931),
    [anon_sym_break] = ACTIONS(1931),
    [anon_sym_continue] = ACTIONS(1931),
    [anon_sym_debugger] = ACTIONS(1931),
    [anon_sym_return] = ACTIONS(1931),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym_case] = ACTIONS(1931),
    [anon_sym_yield] = ACTIONS(1931),
    [anon_sym_LBRACK] = ACTIONS(1929),
    [anon_sym_class] = ACTIONS(1931),
    [anon_sym_async] = ACTIONS(1931),
    [anon_sym_function] = ACTIONS(1931),
    [anon_sym_abstract] = ACTIONS(1931),
    [anon_sym_get] = ACTIONS(1931),
    [anon_sym_set] = ACTIONS(1931),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_SLASH] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_TILDE] = ACTIONS(1929),
    [anon_sym_void] = ACTIONS(1931),
    [anon_sym_delete] = ACTIONS(1931),
    [anon_sym_PLUS_PLUS] = ACTIONS(1929),
    [anon_sym_DASH_DASH] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(1929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1929),
    [sym_float_literal] = ACTIONS(1929),
    [sym_hex_literal] = ACTIONS(1931),
    [sym_int_literal] = ACTIONS(1931),
    [sym_binary_literal] = ACTIONS(1931),
    [sym_octal_literal] = ACTIONS(1931),
    [sym_bigint_literal] = ACTIONS(1929),
    [sym_this] = ACTIONS(1931),
    [sym_super] = ACTIONS(1931),
    [sym_true] = ACTIONS(1931),
    [sym_false] = ACTIONS(1931),
    [sym_null] = ACTIONS(1931),
    [anon_sym_AT] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1931),
    [anon_sym_public] = ACTIONS(1931),
    [anon_sym_private] = ACTIONS(1931),
    [anon_sym_protected] = ACTIONS(1931),
    [anon_sym_boolean] = ACTIONS(1931),
    [anon_sym_string] = ACTIONS(1931),
    [anon_sym_symbol] = ACTIONS(1931),
    [sym_readonly] = ACTIONS(1931),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(1933),
    [sym_identifier] = ACTIONS(1935),
    [anon_sym_export] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1935),
    [anon_sym_namespace] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1935),
    [anon_sym_type] = ACTIONS(1935),
    [anon_sym_interface] = ACTIONS(1935),
    [anon_sym_declare] = ACTIONS(1935),
    [anon_sym_module] = ACTIONS(1935),
    [anon_sym_import] = ACTIONS(1935),
    [anon_sym_const] = ACTIONS(1935),
    [anon_sym_enum] = ACTIONS(1935),
    [anon_sym_var] = ACTIONS(1935),
    [anon_sym_let] = ACTIONS(1935),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_else] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1935),
    [anon_sym_switch] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1935),
    [anon_sym_LPAREN] = ACTIONS(1933),
    [anon_sym_await] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1935),
    [anon_sym_do] = ACTIONS(1935),
    [anon_sym_try] = ACTIONS(1935),
    [anon_sym_with] = ACTIONS(1935),
    [anon_sym_break] = ACTIONS(1935),
    [anon_sym_continue] = ACTIONS(1935),
    [anon_sym_debugger] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(1935),
    [anon_sym_throw] = ACTIONS(1935),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_case] = ACTIONS(1935),
    [anon_sym_yield] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(1933),
    [anon_sym_class] = ACTIONS(1935),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_function] = ACTIONS(1935),
    [anon_sym_abstract] = ACTIONS(1935),
    [anon_sym_get] = ACTIONS(1935),
    [anon_sym_set] = ACTIONS(1935),
    [anon_sym_new] = ACTIONS(1935),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_DASH] = ACTIONS(1935),
    [anon_sym_SLASH] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_void] = ACTIONS(1935),
    [anon_sym_delete] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1933),
    [anon_sym_DASH_DASH] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(1933),
    [anon_sym_SQUOTE] = ACTIONS(1933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1933),
    [sym_float_literal] = ACTIONS(1933),
    [sym_hex_literal] = ACTIONS(1935),
    [sym_int_literal] = ACTIONS(1935),
    [sym_binary_literal] = ACTIONS(1935),
    [sym_octal_literal] = ACTIONS(1935),
    [sym_bigint_literal] = ACTIONS(1933),
    [sym_this] = ACTIONS(1935),
    [sym_super] = ACTIONS(1935),
    [sym_true] = ACTIONS(1935),
    [sym_false] = ACTIONS(1935),
    [sym_null] = ACTIONS(1935),
    [anon_sym_AT] = ACTIONS(1933),
    [anon_sym_static] = ACTIONS(1935),
    [anon_sym_public] = ACTIONS(1935),
    [anon_sym_private] = ACTIONS(1935),
    [anon_sym_protected] = ACTIONS(1935),
    [anon_sym_boolean] = ACTIONS(1935),
    [anon_sym_string] = ACTIONS(1935),
    [anon_sym_symbol] = ACTIONS(1935),
    [sym_readonly] = ACTIONS(1935),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1927),
    [anon_sym_export] = ACTIONS(1927),
    [anon_sym_default] = ACTIONS(1927),
    [anon_sym_namespace] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1925),
    [anon_sym_RBRACE] = ACTIONS(1925),
    [anon_sym_typeof] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1927),
    [anon_sym_interface] = ACTIONS(1927),
    [anon_sym_declare] = ACTIONS(1927),
    [anon_sym_module] = ACTIONS(1927),
    [anon_sym_import] = ACTIONS(1927),
    [anon_sym_const] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1927),
    [anon_sym_var] = ACTIONS(1927),
    [anon_sym_let] = ACTIONS(1927),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(1927),
    [anon_sym_if] = ACTIONS(1927),
    [anon_sym_switch] = ACTIONS(1927),
    [anon_sym_for] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_await] = ACTIONS(1927),
    [anon_sym_while] = ACTIONS(1927),
    [anon_sym_do] = ACTIONS(1927),
    [anon_sym_try] = ACTIONS(1927),
    [anon_sym_with] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1927),
    [anon_sym_continue] = ACTIONS(1927),
    [anon_sym_debugger] = ACTIONS(1927),
    [anon_sym_return] = ACTIONS(1927),
    [anon_sym_throw] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1925),
    [anon_sym_case] = ACTIONS(1927),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_class] = ACTIONS(1927),
    [anon_sym_async] = ACTIONS(1927),
    [anon_sym_function] = ACTIONS(1927),
    [anon_sym_abstract] = ACTIONS(1927),
    [anon_sym_get] = ACTIONS(1927),
    [anon_sym_set] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1927),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_SLASH] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1925),
    [anon_sym_TILDE] = ACTIONS(1925),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_delete] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1925),
    [anon_sym_DASH_DASH] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1925),
    [sym_float_literal] = ACTIONS(1925),
    [sym_hex_literal] = ACTIONS(1927),
    [sym_int_literal] = ACTIONS(1927),
    [sym_binary_literal] = ACTIONS(1927),
    [sym_octal_literal] = ACTIONS(1927),
    [sym_bigint_literal] = ACTIONS(1925),
    [sym_this] = ACTIONS(1927),
    [sym_super] = ACTIONS(1927),
    [sym_true] = ACTIONS(1927),
    [sym_false] = ACTIONS(1927),
    [sym_null] = ACTIONS(1927),
    [anon_sym_AT] = ACTIONS(1925),
    [anon_sym_static] = ACTIONS(1927),
    [anon_sym_public] = ACTIONS(1927),
    [anon_sym_private] = ACTIONS(1927),
    [anon_sym_protected] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_symbol] = ACTIONS(1927),
    [sym_readonly] = ACTIONS(1927),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1937),
    [sym_identifier] = ACTIONS(1939),
    [anon_sym_export] = ACTIONS(1939),
    [anon_sym_default] = ACTIONS(1939),
    [anon_sym_namespace] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_RBRACE] = ACTIONS(1937),
    [anon_sym_typeof] = ACTIONS(1939),
    [anon_sym_type] = ACTIONS(1939),
    [anon_sym_interface] = ACTIONS(1939),
    [anon_sym_declare] = ACTIONS(1939),
    [anon_sym_module] = ACTIONS(1939),
    [anon_sym_import] = ACTIONS(1939),
    [anon_sym_const] = ACTIONS(1939),
    [anon_sym_enum] = ACTIONS(1939),
    [anon_sym_var] = ACTIONS(1939),
    [anon_sym_let] = ACTIONS(1939),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_else] = ACTIONS(1939),
    [anon_sym_if] = ACTIONS(1939),
    [anon_sym_switch] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(1939),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_await] = ACTIONS(1939),
    [anon_sym_while] = ACTIONS(1939),
    [anon_sym_do] = ACTIONS(1939),
    [anon_sym_try] = ACTIONS(1939),
    [anon_sym_with] = ACTIONS(1939),
    [anon_sym_break] = ACTIONS(1939),
    [anon_sym_continue] = ACTIONS(1939),
    [anon_sym_debugger] = ACTIONS(1939),
    [anon_sym_return] = ACTIONS(1939),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym_case] = ACTIONS(1939),
    [anon_sym_yield] = ACTIONS(1939),
    [anon_sym_LBRACK] = ACTIONS(1937),
    [anon_sym_class] = ACTIONS(1939),
    [anon_sym_async] = ACTIONS(1939),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_abstract] = ACTIONS(1939),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_new] = ACTIONS(1939),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1939),
    [anon_sym_LT] = ACTIONS(1937),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_void] = ACTIONS(1939),
    [anon_sym_delete] = ACTIONS(1939),
    [anon_sym_PLUS_PLUS] = ACTIONS(1937),
    [anon_sym_DASH_DASH] = ACTIONS(1937),
    [anon_sym_DQUOTE] = ACTIONS(1937),
    [anon_sym_SQUOTE] = ACTIONS(1937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1937),
    [sym_float_literal] = ACTIONS(1937),
    [sym_hex_literal] = ACTIONS(1939),
    [sym_int_literal] = ACTIONS(1939),
    [sym_binary_literal] = ACTIONS(1939),
    [sym_octal_literal] = ACTIONS(1939),
    [sym_bigint_literal] = ACTIONS(1937),
    [sym_this] = ACTIONS(1939),
    [sym_super] = ACTIONS(1939),
    [sym_true] = ACTIONS(1939),
    [sym_false] = ACTIONS(1939),
    [sym_null] = ACTIONS(1939),
    [anon_sym_AT] = ACTIONS(1937),
    [anon_sym_static] = ACTIONS(1939),
    [anon_sym_public] = ACTIONS(1939),
    [anon_sym_private] = ACTIONS(1939),
    [anon_sym_protected] = ACTIONS(1939),
    [anon_sym_boolean] = ACTIONS(1939),
    [anon_sym_string] = ACTIONS(1939),
    [anon_sym_symbol] = ACTIONS(1939),
    [sym_readonly] = ACTIONS(1939),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1941),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_export] = ACTIONS(1943),
    [anon_sym_default] = ACTIONS(1943),
    [anon_sym_namespace] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_RBRACE] = ACTIONS(1941),
    [anon_sym_typeof] = ACTIONS(1943),
    [anon_sym_type] = ACTIONS(1943),
    [anon_sym_interface] = ACTIONS(1943),
    [anon_sym_declare] = ACTIONS(1943),
    [anon_sym_module] = ACTIONS(1943),
    [anon_sym_import] = ACTIONS(1943),
    [anon_sym_const] = ACTIONS(1943),
    [anon_sym_enum] = ACTIONS(1943),
    [anon_sym_var] = ACTIONS(1943),
    [anon_sym_let] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_else] = ACTIONS(1943),
    [anon_sym_if] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1943),
    [anon_sym_for] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_await] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1943),
    [anon_sym_do] = ACTIONS(1943),
    [anon_sym_try] = ACTIONS(1943),
    [anon_sym_with] = ACTIONS(1943),
    [anon_sym_break] = ACTIONS(1943),
    [anon_sym_continue] = ACTIONS(1943),
    [anon_sym_debugger] = ACTIONS(1943),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_throw] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_case] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(1943),
    [anon_sym_async] = ACTIONS(1943),
    [anon_sym_function] = ACTIONS(1943),
    [anon_sym_abstract] = ACTIONS(1943),
    [anon_sym_get] = ACTIONS(1943),
    [anon_sym_set] = ACTIONS(1943),
    [anon_sym_new] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1941),
    [anon_sym_void] = ACTIONS(1943),
    [anon_sym_delete] = ACTIONS(1943),
    [anon_sym_PLUS_PLUS] = ACTIONS(1941),
    [anon_sym_DASH_DASH] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1941),
    [sym_float_literal] = ACTIONS(1941),
    [sym_hex_literal] = ACTIONS(1943),
    [sym_int_literal] = ACTIONS(1943),
    [sym_binary_literal] = ACTIONS(1943),
    [sym_octal_literal] = ACTIONS(1943),
    [sym_bigint_literal] = ACTIONS(1941),
    [sym_this] = ACTIONS(1943),
    [sym_super] = ACTIONS(1943),
    [sym_true] = ACTIONS(1943),
    [sym_false] = ACTIONS(1943),
    [sym_null] = ACTIONS(1943),
    [anon_sym_AT] = ACTIONS(1941),
    [anon_sym_static] = ACTIONS(1943),
    [anon_sym_public] = ACTIONS(1943),
    [anon_sym_private] = ACTIONS(1943),
    [anon_sym_protected] = ACTIONS(1943),
    [anon_sym_boolean] = ACTIONS(1943),
    [anon_sym_string] = ACTIONS(1943),
    [anon_sym_symbol] = ACTIONS(1943),
    [sym_readonly] = ACTIONS(1943),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_float_literal] = ACTIONS(1945),
    [sym_hex_literal] = ACTIONS(1947),
    [sym_int_literal] = ACTIONS(1947),
    [sym_binary_literal] = ACTIONS(1947),
    [sym_octal_literal] = ACTIONS(1947),
    [sym_bigint_literal] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [sym_readonly] = ACTIONS(1947),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_typeof] = ACTIONS(1951),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_interface] = ACTIONS(1951),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_import] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_var] = ACTIONS(1951),
    [anon_sym_let] = ACTIONS(1951),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_LPAREN] = ACTIONS(1949),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_with] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_debugger] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1949),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_function] = ACTIONS(1951),
    [anon_sym_abstract] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1951),
    [anon_sym_set] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_SLASH] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_void] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1949),
    [sym_float_literal] = ACTIONS(1949),
    [sym_hex_literal] = ACTIONS(1951),
    [sym_int_literal] = ACTIONS(1951),
    [sym_binary_literal] = ACTIONS(1951),
    [sym_octal_literal] = ACTIONS(1951),
    [sym_bigint_literal] = ACTIONS(1949),
    [sym_this] = ACTIONS(1951),
    [sym_super] = ACTIONS(1951),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [sym_null] = ACTIONS(1951),
    [anon_sym_AT] = ACTIONS(1949),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [sym_readonly] = ACTIONS(1951),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1955),
    [anon_sym_export] = ACTIONS(1955),
    [anon_sym_default] = ACTIONS(1955),
    [anon_sym_namespace] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [anon_sym_typeof] = ACTIONS(1955),
    [anon_sym_type] = ACTIONS(1955),
    [anon_sym_interface] = ACTIONS(1955),
    [anon_sym_declare] = ACTIONS(1955),
    [anon_sym_module] = ACTIONS(1955),
    [anon_sym_import] = ACTIONS(1955),
    [anon_sym_const] = ACTIONS(1955),
    [anon_sym_enum] = ACTIONS(1955),
    [anon_sym_var] = ACTIONS(1955),
    [anon_sym_let] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1955),
    [anon_sym_if] = ACTIONS(1955),
    [anon_sym_switch] = ACTIONS(1955),
    [anon_sym_for] = ACTIONS(1955),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_await] = ACTIONS(1955),
    [anon_sym_while] = ACTIONS(1955),
    [anon_sym_do] = ACTIONS(1955),
    [anon_sym_try] = ACTIONS(1955),
    [anon_sym_with] = ACTIONS(1955),
    [anon_sym_break] = ACTIONS(1955),
    [anon_sym_continue] = ACTIONS(1955),
    [anon_sym_debugger] = ACTIONS(1955),
    [anon_sym_return] = ACTIONS(1955),
    [anon_sym_throw] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1955),
    [anon_sym_yield] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1955),
    [anon_sym_async] = ACTIONS(1955),
    [anon_sym_function] = ACTIONS(1955),
    [anon_sym_abstract] = ACTIONS(1955),
    [anon_sym_get] = ACTIONS(1955),
    [anon_sym_set] = ACTIONS(1955),
    [anon_sym_new] = ACTIONS(1955),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1955),
    [anon_sym_SLASH] = ACTIONS(1955),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_TILDE] = ACTIONS(1953),
    [anon_sym_void] = ACTIONS(1955),
    [anon_sym_delete] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1953),
    [anon_sym_DQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1953),
    [sym_float_literal] = ACTIONS(1953),
    [sym_hex_literal] = ACTIONS(1955),
    [sym_int_literal] = ACTIONS(1955),
    [sym_binary_literal] = ACTIONS(1955),
    [sym_octal_literal] = ACTIONS(1955),
    [sym_bigint_literal] = ACTIONS(1953),
    [sym_this] = ACTIONS(1955),
    [sym_super] = ACTIONS(1955),
    [sym_true] = ACTIONS(1955),
    [sym_false] = ACTIONS(1955),
    [sym_null] = ACTIONS(1955),
    [anon_sym_AT] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1955),
    [anon_sym_public] = ACTIONS(1955),
    [anon_sym_private] = ACTIONS(1955),
    [anon_sym_protected] = ACTIONS(1955),
    [anon_sym_boolean] = ACTIONS(1955),
    [anon_sym_string] = ACTIONS(1955),
    [anon_sym_symbol] = ACTIONS(1955),
    [sym_readonly] = ACTIONS(1955),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1957),
    [sym_identifier] = ACTIONS(1959),
    [anon_sym_export] = ACTIONS(1959),
    [anon_sym_default] = ACTIONS(1959),
    [anon_sym_namespace] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_type] = ACTIONS(1959),
    [anon_sym_interface] = ACTIONS(1959),
    [anon_sym_declare] = ACTIONS(1959),
    [anon_sym_module] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1959),
    [anon_sym_var] = ACTIONS(1959),
    [anon_sym_let] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1959),
    [anon_sym_if] = ACTIONS(1959),
    [anon_sym_switch] = ACTIONS(1959),
    [anon_sym_for] = ACTIONS(1959),
    [anon_sym_LPAREN] = ACTIONS(1957),
    [anon_sym_await] = ACTIONS(1959),
    [anon_sym_while] = ACTIONS(1959),
    [anon_sym_do] = ACTIONS(1959),
    [anon_sym_try] = ACTIONS(1959),
    [anon_sym_with] = ACTIONS(1959),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_continue] = ACTIONS(1959),
    [anon_sym_debugger] = ACTIONS(1959),
    [anon_sym_return] = ACTIONS(1959),
    [anon_sym_throw] = ACTIONS(1959),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1959),
    [anon_sym_yield] = ACTIONS(1959),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1959),
    [anon_sym_async] = ACTIONS(1959),
    [anon_sym_function] = ACTIONS(1959),
    [anon_sym_abstract] = ACTIONS(1959),
    [anon_sym_get] = ACTIONS(1959),
    [anon_sym_set] = ACTIONS(1959),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_SLASH] = ACTIONS(1959),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1957),
    [anon_sym_void] = ACTIONS(1959),
    [anon_sym_delete] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1957),
    [anon_sym_DQUOTE] = ACTIONS(1957),
    [anon_sym_SQUOTE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1957),
    [sym_float_literal] = ACTIONS(1957),
    [sym_hex_literal] = ACTIONS(1959),
    [sym_int_literal] = ACTIONS(1959),
    [sym_binary_literal] = ACTIONS(1959),
    [sym_octal_literal] = ACTIONS(1959),
    [sym_bigint_literal] = ACTIONS(1957),
    [sym_this] = ACTIONS(1959),
    [sym_super] = ACTIONS(1959),
    [sym_true] = ACTIONS(1959),
    [sym_false] = ACTIONS(1959),
    [sym_null] = ACTIONS(1959),
    [anon_sym_AT] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1959),
    [anon_sym_public] = ACTIONS(1959),
    [anon_sym_private] = ACTIONS(1959),
    [anon_sym_protected] = ACTIONS(1959),
    [anon_sym_boolean] = ACTIONS(1959),
    [anon_sym_string] = ACTIONS(1959),
    [anon_sym_symbol] = ACTIONS(1959),
    [sym_readonly] = ACTIONS(1959),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1961),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_export] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(1963),
    [anon_sym_namespace] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_typeof] = ACTIONS(1963),
    [anon_sym_type] = ACTIONS(1963),
    [anon_sym_interface] = ACTIONS(1963),
    [anon_sym_declare] = ACTIONS(1963),
    [anon_sym_module] = ACTIONS(1963),
    [anon_sym_import] = ACTIONS(1963),
    [anon_sym_const] = ACTIONS(1963),
    [anon_sym_enum] = ACTIONS(1963),
    [anon_sym_var] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1963),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_await] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(1963),
    [anon_sym_do] = ACTIONS(1963),
    [anon_sym_try] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_break] = ACTIONS(1963),
    [anon_sym_continue] = ACTIONS(1963),
    [anon_sym_debugger] = ACTIONS(1963),
    [anon_sym_return] = ACTIONS(1963),
    [anon_sym_throw] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1963),
    [anon_sym_yield] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(1963),
    [anon_sym_function] = ACTIONS(1963),
    [anon_sym_abstract] = ACTIONS(1963),
    [anon_sym_get] = ACTIONS(1963),
    [anon_sym_set] = ACTIONS(1963),
    [anon_sym_new] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_void] = ACTIONS(1963),
    [anon_sym_delete] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1961),
    [anon_sym_DQUOTE] = ACTIONS(1961),
    [anon_sym_SQUOTE] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1961),
    [sym_float_literal] = ACTIONS(1961),
    [sym_hex_literal] = ACTIONS(1963),
    [sym_int_literal] = ACTIONS(1963),
    [sym_binary_literal] = ACTIONS(1963),
    [sym_octal_literal] = ACTIONS(1963),
    [sym_bigint_literal] = ACTIONS(1961),
    [sym_this] = ACTIONS(1963),
    [sym_super] = ACTIONS(1963),
    [sym_true] = ACTIONS(1963),
    [sym_false] = ACTIONS(1963),
    [sym_null] = ACTIONS(1963),
    [anon_sym_AT] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1963),
    [anon_sym_public] = ACTIONS(1963),
    [anon_sym_private] = ACTIONS(1963),
    [anon_sym_protected] = ACTIONS(1963),
    [anon_sym_boolean] = ACTIONS(1963),
    [anon_sym_string] = ACTIONS(1963),
    [anon_sym_symbol] = ACTIONS(1963),
    [sym_readonly] = ACTIONS(1963),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1965),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_export] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_typeof] = ACTIONS(1967),
    [anon_sym_type] = ACTIONS(1967),
    [anon_sym_interface] = ACTIONS(1967),
    [anon_sym_declare] = ACTIONS(1967),
    [anon_sym_module] = ACTIONS(1967),
    [anon_sym_import] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_var] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_await] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_debugger] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_yield] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(1967),
    [anon_sym_function] = ACTIONS(1967),
    [anon_sym_abstract] = ACTIONS(1967),
    [anon_sym_get] = ACTIONS(1967),
    [anon_sym_set] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_TILDE] = ACTIONS(1965),
    [anon_sym_void] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1965),
    [sym_float_literal] = ACTIONS(1965),
    [sym_hex_literal] = ACTIONS(1967),
    [sym_int_literal] = ACTIONS(1967),
    [sym_binary_literal] = ACTIONS(1967),
    [sym_octal_literal] = ACTIONS(1967),
    [sym_bigint_literal] = ACTIONS(1965),
    [sym_this] = ACTIONS(1967),
    [sym_super] = ACTIONS(1967),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [sym_null] = ACTIONS(1967),
    [anon_sym_AT] = ACTIONS(1965),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_public] = ACTIONS(1967),
    [anon_sym_private] = ACTIONS(1967),
    [anon_sym_protected] = ACTIONS(1967),
    [anon_sym_boolean] = ACTIONS(1967),
    [anon_sym_string] = ACTIONS(1967),
    [anon_sym_symbol] = ACTIONS(1967),
    [sym_readonly] = ACTIONS(1967),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(1969),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_typeof] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_interface] = ACTIONS(1971),
    [anon_sym_declare] = ACTIONS(1971),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_import] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_var] = ACTIONS(1971),
    [anon_sym_let] = ACTIONS(1971),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_with] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_debugger] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_yield] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1969),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(1971),
    [anon_sym_abstract] = ACTIONS(1971),
    [anon_sym_get] = ACTIONS(1971),
    [anon_sym_set] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_void] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1969),
    [sym_float_literal] = ACTIONS(1969),
    [sym_hex_literal] = ACTIONS(1971),
    [sym_int_literal] = ACTIONS(1971),
    [sym_binary_literal] = ACTIONS(1971),
    [sym_octal_literal] = ACTIONS(1971),
    [sym_bigint_literal] = ACTIONS(1969),
    [sym_this] = ACTIONS(1971),
    [sym_super] = ACTIONS(1971),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [sym_null] = ACTIONS(1971),
    [anon_sym_AT] = ACTIONS(1969),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_public] = ACTIONS(1971),
    [anon_sym_private] = ACTIONS(1971),
    [anon_sym_protected] = ACTIONS(1971),
    [anon_sym_boolean] = ACTIONS(1971),
    [anon_sym_string] = ACTIONS(1971),
    [anon_sym_symbol] = ACTIONS(1971),
    [sym_readonly] = ACTIONS(1971),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_export] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_typeof] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1975),
    [anon_sym_interface] = ACTIONS(1975),
    [anon_sym_declare] = ACTIONS(1975),
    [anon_sym_module] = ACTIONS(1975),
    [anon_sym_import] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_var] = ACTIONS(1975),
    [anon_sym_let] = ACTIONS(1975),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1973),
    [anon_sym_await] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_with] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_debugger] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_function] = ACTIONS(1975),
    [anon_sym_abstract] = ACTIONS(1975),
    [anon_sym_get] = ACTIONS(1975),
    [anon_sym_set] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1973),
    [sym_float_literal] = ACTIONS(1973),
    [sym_hex_literal] = ACTIONS(1975),
    [sym_int_literal] = ACTIONS(1975),
    [sym_binary_literal] = ACTIONS(1975),
    [sym_octal_literal] = ACTIONS(1975),
    [sym_bigint_literal] = ACTIONS(1973),
    [sym_this] = ACTIONS(1975),
    [sym_super] = ACTIONS(1975),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [sym_null] = ACTIONS(1975),
    [anon_sym_AT] = ACTIONS(1973),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_public] = ACTIONS(1975),
    [anon_sym_private] = ACTIONS(1975),
    [anon_sym_protected] = ACTIONS(1975),
    [anon_sym_boolean] = ACTIONS(1975),
    [anon_sym_string] = ACTIONS(1975),
    [anon_sym_symbol] = ACTIONS(1975),
    [sym_readonly] = ACTIONS(1975),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_float_literal] = ACTIONS(1114),
    [sym_hex_literal] = ACTIONS(1116),
    [sym_int_literal] = ACTIONS(1116),
    [sym_binary_literal] = ACTIONS(1116),
    [sym_octal_literal] = ACTIONS(1116),
    [sym_bigint_literal] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_debugger] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_void] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1977),
    [sym_float_literal] = ACTIONS(1977),
    [sym_hex_literal] = ACTIONS(1979),
    [sym_int_literal] = ACTIONS(1979),
    [sym_binary_literal] = ACTIONS(1979),
    [sym_octal_literal] = ACTIONS(1979),
    [sym_bigint_literal] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [sym_null] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_boolean] = ACTIONS(1979),
    [anon_sym_string] = ACTIONS(1979),
    [anon_sym_symbol] = ACTIONS(1979),
    [sym_readonly] = ACTIONS(1979),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(1969),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_typeof] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_interface] = ACTIONS(1971),
    [anon_sym_declare] = ACTIONS(1971),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_import] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_var] = ACTIONS(1971),
    [anon_sym_let] = ACTIONS(1971),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_with] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_debugger] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_yield] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1969),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(1971),
    [anon_sym_abstract] = ACTIONS(1971),
    [anon_sym_get] = ACTIONS(1971),
    [anon_sym_set] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_void] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1969),
    [sym_float_literal] = ACTIONS(1969),
    [sym_hex_literal] = ACTIONS(1971),
    [sym_int_literal] = ACTIONS(1971),
    [sym_binary_literal] = ACTIONS(1971),
    [sym_octal_literal] = ACTIONS(1971),
    [sym_bigint_literal] = ACTIONS(1969),
    [sym_this] = ACTIONS(1971),
    [sym_super] = ACTIONS(1971),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [sym_null] = ACTIONS(1971),
    [anon_sym_AT] = ACTIONS(1969),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_public] = ACTIONS(1971),
    [anon_sym_private] = ACTIONS(1971),
    [anon_sym_protected] = ACTIONS(1971),
    [anon_sym_boolean] = ACTIONS(1971),
    [anon_sym_string] = ACTIONS(1971),
    [anon_sym_symbol] = ACTIONS(1971),
    [sym_readonly] = ACTIONS(1971),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_export] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_typeof] = ACTIONS(1983),
    [anon_sym_type] = ACTIONS(1983),
    [anon_sym_interface] = ACTIONS(1983),
    [anon_sym_declare] = ACTIONS(1983),
    [anon_sym_module] = ACTIONS(1983),
    [anon_sym_import] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_var] = ACTIONS(1983),
    [anon_sym_let] = ACTIONS(1983),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_await] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_with] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_debugger] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_async] = ACTIONS(1983),
    [anon_sym_function] = ACTIONS(1983),
    [anon_sym_abstract] = ACTIONS(1983),
    [anon_sym_get] = ACTIONS(1983),
    [anon_sym_set] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_void] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1981),
    [sym_float_literal] = ACTIONS(1981),
    [sym_hex_literal] = ACTIONS(1983),
    [sym_int_literal] = ACTIONS(1983),
    [sym_binary_literal] = ACTIONS(1983),
    [sym_octal_literal] = ACTIONS(1983),
    [sym_bigint_literal] = ACTIONS(1981),
    [sym_this] = ACTIONS(1983),
    [sym_super] = ACTIONS(1983),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [sym_null] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_public] = ACTIONS(1983),
    [anon_sym_private] = ACTIONS(1983),
    [anon_sym_protected] = ACTIONS(1983),
    [anon_sym_boolean] = ACTIONS(1983),
    [anon_sym_string] = ACTIONS(1983),
    [anon_sym_symbol] = ACTIONS(1983),
    [sym_readonly] = ACTIONS(1983),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_export] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_typeof] = ACTIONS(1987),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_interface] = ACTIONS(1987),
    [anon_sym_declare] = ACTIONS(1987),
    [anon_sym_module] = ACTIONS(1987),
    [anon_sym_import] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_var] = ACTIONS(1987),
    [anon_sym_let] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_await] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_with] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_debugger] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_yield] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(1987),
    [anon_sym_abstract] = ACTIONS(1987),
    [anon_sym_get] = ACTIONS(1987),
    [anon_sym_set] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_void] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1985),
    [sym_float_literal] = ACTIONS(1985),
    [sym_hex_literal] = ACTIONS(1987),
    [sym_int_literal] = ACTIONS(1987),
    [sym_binary_literal] = ACTIONS(1987),
    [sym_octal_literal] = ACTIONS(1987),
    [sym_bigint_literal] = ACTIONS(1985),
    [sym_this] = ACTIONS(1987),
    [sym_super] = ACTIONS(1987),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [sym_null] = ACTIONS(1987),
    [anon_sym_AT] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_public] = ACTIONS(1987),
    [anon_sym_private] = ACTIONS(1987),
    [anon_sym_protected] = ACTIONS(1987),
    [anon_sym_boolean] = ACTIONS(1987),
    [anon_sym_string] = ACTIONS(1987),
    [anon_sym_symbol] = ACTIONS(1987),
    [sym_readonly] = ACTIONS(1987),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(1989),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_typeof] = ACTIONS(1991),
    [anon_sym_type] = ACTIONS(1991),
    [anon_sym_interface] = ACTIONS(1991),
    [anon_sym_declare] = ACTIONS(1991),
    [anon_sym_module] = ACTIONS(1991),
    [anon_sym_import] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_var] = ACTIONS(1991),
    [anon_sym_let] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_with] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_debugger] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_yield] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_async] = ACTIONS(1991),
    [anon_sym_function] = ACTIONS(1991),
    [anon_sym_abstract] = ACTIONS(1991),
    [anon_sym_get] = ACTIONS(1991),
    [anon_sym_set] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_void] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1989),
    [sym_float_literal] = ACTIONS(1989),
    [sym_hex_literal] = ACTIONS(1991),
    [sym_int_literal] = ACTIONS(1991),
    [sym_binary_literal] = ACTIONS(1991),
    [sym_octal_literal] = ACTIONS(1991),
    [sym_bigint_literal] = ACTIONS(1989),
    [sym_this] = ACTIONS(1991),
    [sym_super] = ACTIONS(1991),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [sym_null] = ACTIONS(1991),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_public] = ACTIONS(1991),
    [anon_sym_private] = ACTIONS(1991),
    [anon_sym_protected] = ACTIONS(1991),
    [anon_sym_boolean] = ACTIONS(1991),
    [anon_sym_string] = ACTIONS(1991),
    [anon_sym_symbol] = ACTIONS(1991),
    [sym_readonly] = ACTIONS(1991),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(1995),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_typeof] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_interface] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_import] = ACTIONS(1995),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [anon_sym_var] = ACTIONS(1995),
    [anon_sym_let] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_await] = ACTIONS(1995),
    [anon_sym_while] = ACTIONS(1995),
    [anon_sym_do] = ACTIONS(1995),
    [anon_sym_try] = ACTIONS(1995),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_debugger] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_throw] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym_case] = ACTIONS(1995),
    [anon_sym_yield] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(1995),
    [anon_sym_abstract] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_void] = ACTIONS(1995),
    [anon_sym_delete] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1993),
    [sym_float_literal] = ACTIONS(1993),
    [sym_hex_literal] = ACTIONS(1995),
    [sym_int_literal] = ACTIONS(1995),
    [sym_binary_literal] = ACTIONS(1995),
    [sym_octal_literal] = ACTIONS(1995),
    [sym_bigint_literal] = ACTIONS(1993),
    [sym_this] = ACTIONS(1995),
    [sym_super] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_null] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1993),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [sym_readonly] = ACTIONS(1995),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(1995),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_typeof] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_interface] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_import] = ACTIONS(1995),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [anon_sym_var] = ACTIONS(1995),
    [anon_sym_let] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_await] = ACTIONS(1995),
    [anon_sym_while] = ACTIONS(1995),
    [anon_sym_do] = ACTIONS(1995),
    [anon_sym_try] = ACTIONS(1995),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_debugger] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_throw] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym_case] = ACTIONS(1995),
    [anon_sym_yield] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(1995),
    [anon_sym_abstract] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_void] = ACTIONS(1995),
    [anon_sym_delete] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1993),
    [sym_float_literal] = ACTIONS(1993),
    [sym_hex_literal] = ACTIONS(1995),
    [sym_int_literal] = ACTIONS(1995),
    [sym_binary_literal] = ACTIONS(1995),
    [sym_octal_literal] = ACTIONS(1995),
    [sym_bigint_literal] = ACTIONS(1993),
    [sym_this] = ACTIONS(1995),
    [sym_super] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_null] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1993),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [sym_readonly] = ACTIONS(1995),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_debugger] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_void] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1977),
    [sym_float_literal] = ACTIONS(1977),
    [sym_hex_literal] = ACTIONS(1979),
    [sym_int_literal] = ACTIONS(1979),
    [sym_binary_literal] = ACTIONS(1979),
    [sym_octal_literal] = ACTIONS(1979),
    [sym_bigint_literal] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [sym_null] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_boolean] = ACTIONS(1979),
    [anon_sym_string] = ACTIONS(1979),
    [anon_sym_symbol] = ACTIONS(1979),
    [sym_readonly] = ACTIONS(1979),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1999),
    [anon_sym_export] = ACTIONS(1999),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_namespace] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_typeof] = ACTIONS(1999),
    [anon_sym_type] = ACTIONS(1999),
    [anon_sym_interface] = ACTIONS(1999),
    [anon_sym_declare] = ACTIONS(1999),
    [anon_sym_module] = ACTIONS(1999),
    [anon_sym_import] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
    [anon_sym_var] = ACTIONS(1999),
    [anon_sym_let] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_switch] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_await] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_do] = ACTIONS(1999),
    [anon_sym_try] = ACTIONS(1999),
    [anon_sym_with] = ACTIONS(1999),
    [anon_sym_break] = ACTIONS(1999),
    [anon_sym_continue] = ACTIONS(1999),
    [anon_sym_debugger] = ACTIONS(1999),
    [anon_sym_return] = ACTIONS(1999),
    [anon_sym_throw] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1999),
    [anon_sym_yield] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_function] = ACTIONS(1999),
    [anon_sym_abstract] = ACTIONS(1999),
    [anon_sym_get] = ACTIONS(1999),
    [anon_sym_set] = ACTIONS(1999),
    [anon_sym_new] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_TILDE] = ACTIONS(1997),
    [anon_sym_void] = ACTIONS(1999),
    [anon_sym_delete] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_DQUOTE] = ACTIONS(1997),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1997),
    [sym_float_literal] = ACTIONS(1997),
    [sym_hex_literal] = ACTIONS(1999),
    [sym_int_literal] = ACTIONS(1999),
    [sym_binary_literal] = ACTIONS(1999),
    [sym_octal_literal] = ACTIONS(1999),
    [sym_bigint_literal] = ACTIONS(1997),
    [sym_this] = ACTIONS(1999),
    [sym_super] = ACTIONS(1999),
    [sym_true] = ACTIONS(1999),
    [sym_false] = ACTIONS(1999),
    [sym_null] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_public] = ACTIONS(1999),
    [anon_sym_private] = ACTIONS(1999),
    [anon_sym_protected] = ACTIONS(1999),
    [anon_sym_boolean] = ACTIONS(1999),
    [anon_sym_string] = ACTIONS(1999),
    [anon_sym_symbol] = ACTIONS(1999),
    [sym_readonly] = ACTIONS(1999),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_export] = ACTIONS(2003),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_namespace] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_typeof] = ACTIONS(2003),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_interface] = ACTIONS(2003),
    [anon_sym_declare] = ACTIONS(2003),
    [anon_sym_module] = ACTIONS(2003),
    [anon_sym_import] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [anon_sym_var] = ACTIONS(2003),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_else] = ACTIONS(2003),
    [anon_sym_if] = ACTIONS(2003),
    [anon_sym_switch] = ACTIONS(2003),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_await] = ACTIONS(2003),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_do] = ACTIONS(2003),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_with] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_debugger] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_throw] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_case] = ACTIONS(2003),
    [anon_sym_yield] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [anon_sym_class] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_function] = ACTIONS(2003),
    [anon_sym_abstract] = ACTIONS(2003),
    [anon_sym_get] = ACTIONS(2003),
    [anon_sym_set] = ACTIONS(2003),
    [anon_sym_new] = ACTIONS(2003),
    [anon_sym_PLUS] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_void] = ACTIONS(2003),
    [anon_sym_delete] = ACTIONS(2003),
    [anon_sym_PLUS_PLUS] = ACTIONS(2001),
    [anon_sym_DASH_DASH] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_hex_literal] = ACTIONS(2003),
    [sym_int_literal] = ACTIONS(2003),
    [sym_binary_literal] = ACTIONS(2003),
    [sym_octal_literal] = ACTIONS(2003),
    [sym_bigint_literal] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [sym_true] = ACTIONS(2003),
    [sym_false] = ACTIONS(2003),
    [sym_null] = ACTIONS(2003),
    [anon_sym_AT] = ACTIONS(2001),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_public] = ACTIONS(2003),
    [anon_sym_private] = ACTIONS(2003),
    [anon_sym_protected] = ACTIONS(2003),
    [anon_sym_boolean] = ACTIONS(2003),
    [anon_sym_string] = ACTIONS(2003),
    [anon_sym_symbol] = ACTIONS(2003),
    [sym_readonly] = ACTIONS(2003),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2005),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2007),
    [anon_sym_default] = ACTIONS(2007),
    [anon_sym_namespace] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_typeof] = ACTIONS(2007),
    [anon_sym_type] = ACTIONS(2007),
    [anon_sym_interface] = ACTIONS(2007),
    [anon_sym_declare] = ACTIONS(2007),
    [anon_sym_module] = ACTIONS(2007),
    [anon_sym_import] = ACTIONS(2007),
    [anon_sym_const] = ACTIONS(2007),
    [anon_sym_enum] = ACTIONS(2007),
    [anon_sym_var] = ACTIONS(2007),
    [anon_sym_let] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2007),
    [anon_sym_if] = ACTIONS(2007),
    [anon_sym_switch] = ACTIONS(2007),
    [anon_sym_for] = ACTIONS(2007),
    [anon_sym_LPAREN] = ACTIONS(2005),
    [anon_sym_await] = ACTIONS(2007),
    [anon_sym_while] = ACTIONS(2007),
    [anon_sym_do] = ACTIONS(2007),
    [anon_sym_try] = ACTIONS(2007),
    [anon_sym_with] = ACTIONS(2007),
    [anon_sym_break] = ACTIONS(2007),
    [anon_sym_continue] = ACTIONS(2007),
    [anon_sym_debugger] = ACTIONS(2007),
    [anon_sym_return] = ACTIONS(2007),
    [anon_sym_throw] = ACTIONS(2007),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2007),
    [anon_sym_yield] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2007),
    [anon_sym_async] = ACTIONS(2007),
    [anon_sym_function] = ACTIONS(2007),
    [anon_sym_abstract] = ACTIONS(2007),
    [anon_sym_get] = ACTIONS(2007),
    [anon_sym_set] = ACTIONS(2007),
    [anon_sym_new] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_TILDE] = ACTIONS(2005),
    [anon_sym_void] = ACTIONS(2007),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2005),
    [sym_float_literal] = ACTIONS(2005),
    [sym_hex_literal] = ACTIONS(2007),
    [sym_int_literal] = ACTIONS(2007),
    [sym_binary_literal] = ACTIONS(2007),
    [sym_octal_literal] = ACTIONS(2007),
    [sym_bigint_literal] = ACTIONS(2005),
    [sym_this] = ACTIONS(2007),
    [sym_super] = ACTIONS(2007),
    [sym_true] = ACTIONS(2007),
    [sym_false] = ACTIONS(2007),
    [sym_null] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2007),
    [anon_sym_public] = ACTIONS(2007),
    [anon_sym_private] = ACTIONS(2007),
    [anon_sym_protected] = ACTIONS(2007),
    [anon_sym_boolean] = ACTIONS(2007),
    [anon_sym_string] = ACTIONS(2007),
    [anon_sym_symbol] = ACTIONS(2007),
    [sym_readonly] = ACTIONS(2007),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2009),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_namespace] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_RBRACE] = ACTIONS(2009),
    [anon_sym_typeof] = ACTIONS(2011),
    [anon_sym_type] = ACTIONS(2011),
    [anon_sym_interface] = ACTIONS(2011),
    [anon_sym_declare] = ACTIONS(2011),
    [anon_sym_module] = ACTIONS(2011),
    [anon_sym_import] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_var] = ACTIONS(2011),
    [anon_sym_let] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_await] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_with] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_debugger] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2009),
    [anon_sym_case] = ACTIONS(2011),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2009),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_async] = ACTIONS(2011),
    [anon_sym_function] = ACTIONS(2011),
    [anon_sym_abstract] = ACTIONS(2011),
    [anon_sym_get] = ACTIONS(2011),
    [anon_sym_set] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_void] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_DQUOTE] = ACTIONS(2009),
    [anon_sym_SQUOTE] = ACTIONS(2009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2009),
    [sym_float_literal] = ACTIONS(2009),
    [sym_hex_literal] = ACTIONS(2011),
    [sym_int_literal] = ACTIONS(2011),
    [sym_binary_literal] = ACTIONS(2011),
    [sym_octal_literal] = ACTIONS(2011),
    [sym_bigint_literal] = ACTIONS(2009),
    [sym_this] = ACTIONS(2011),
    [sym_super] = ACTIONS(2011),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [sym_null] = ACTIONS(2011),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_public] = ACTIONS(2011),
    [anon_sym_private] = ACTIONS(2011),
    [anon_sym_protected] = ACTIONS(2011),
    [anon_sym_boolean] = ACTIONS(2011),
    [anon_sym_string] = ACTIONS(2011),
    [anon_sym_symbol] = ACTIONS(2011),
    [sym_readonly] = ACTIONS(2011),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2013),
    [sym_identifier] = ACTIONS(2015),
    [anon_sym_export] = ACTIONS(2015),
    [anon_sym_default] = ACTIONS(2015),
    [anon_sym_namespace] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_typeof] = ACTIONS(2015),
    [anon_sym_type] = ACTIONS(2015),
    [anon_sym_interface] = ACTIONS(2015),
    [anon_sym_declare] = ACTIONS(2015),
    [anon_sym_module] = ACTIONS(2015),
    [anon_sym_import] = ACTIONS(2015),
    [anon_sym_const] = ACTIONS(2015),
    [anon_sym_enum] = ACTIONS(2015),
    [anon_sym_var] = ACTIONS(2015),
    [anon_sym_let] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_else] = ACTIONS(2015),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2015),
    [anon_sym_for] = ACTIONS(2015),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_await] = ACTIONS(2015),
    [anon_sym_while] = ACTIONS(2015),
    [anon_sym_do] = ACTIONS(2015),
    [anon_sym_try] = ACTIONS(2015),
    [anon_sym_with] = ACTIONS(2015),
    [anon_sym_break] = ACTIONS(2015),
    [anon_sym_continue] = ACTIONS(2015),
    [anon_sym_debugger] = ACTIONS(2015),
    [anon_sym_return] = ACTIONS(2015),
    [anon_sym_throw] = ACTIONS(2015),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym_case] = ACTIONS(2015),
    [anon_sym_yield] = ACTIONS(2015),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [anon_sym_class] = ACTIONS(2015),
    [anon_sym_async] = ACTIONS(2015),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_abstract] = ACTIONS(2015),
    [anon_sym_get] = ACTIONS(2015),
    [anon_sym_set] = ACTIONS(2015),
    [anon_sym_new] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_SLASH] = ACTIONS(2015),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_void] = ACTIONS(2015),
    [anon_sym_delete] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2013),
    [sym_float_literal] = ACTIONS(2013),
    [sym_hex_literal] = ACTIONS(2015),
    [sym_int_literal] = ACTIONS(2015),
    [sym_binary_literal] = ACTIONS(2015),
    [sym_octal_literal] = ACTIONS(2015),
    [sym_bigint_literal] = ACTIONS(2013),
    [sym_this] = ACTIONS(2015),
    [sym_super] = ACTIONS(2015),
    [sym_true] = ACTIONS(2015),
    [sym_false] = ACTIONS(2015),
    [sym_null] = ACTIONS(2015),
    [anon_sym_AT] = ACTIONS(2013),
    [anon_sym_static] = ACTIONS(2015),
    [anon_sym_public] = ACTIONS(2015),
    [anon_sym_private] = ACTIONS(2015),
    [anon_sym_protected] = ACTIONS(2015),
    [anon_sym_boolean] = ACTIONS(2015),
    [anon_sym_string] = ACTIONS(2015),
    [anon_sym_symbol] = ACTIONS(2015),
    [sym_readonly] = ACTIONS(2015),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_debugger] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_void] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1977),
    [sym_float_literal] = ACTIONS(1977),
    [sym_hex_literal] = ACTIONS(1979),
    [sym_int_literal] = ACTIONS(1979),
    [sym_binary_literal] = ACTIONS(1979),
    [sym_octal_literal] = ACTIONS(1979),
    [sym_bigint_literal] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [sym_null] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_boolean] = ACTIONS(1979),
    [anon_sym_string] = ACTIONS(1979),
    [anon_sym_symbol] = ACTIONS(1979),
    [sym_readonly] = ACTIONS(1979),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_default] = ACTIONS(2019),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2017),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [anon_sym_typeof] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_interface] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_import] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2019),
    [anon_sym_enum] = ACTIONS(2019),
    [anon_sym_var] = ACTIONS(2019),
    [anon_sym_let] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2019),
    [anon_sym_if] = ACTIONS(2019),
    [anon_sym_switch] = ACTIONS(2019),
    [anon_sym_for] = ACTIONS(2019),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_await] = ACTIONS(2019),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2019),
    [anon_sym_try] = ACTIONS(2019),
    [anon_sym_with] = ACTIONS(2019),
    [anon_sym_break] = ACTIONS(2019),
    [anon_sym_continue] = ACTIONS(2019),
    [anon_sym_debugger] = ACTIONS(2019),
    [anon_sym_return] = ACTIONS(2019),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2019),
    [anon_sym_yield] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2019),
    [anon_sym_abstract] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_new] = ACTIONS(2019),
    [anon_sym_PLUS] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2019),
    [anon_sym_SLASH] = ACTIONS(2019),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_TILDE] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(2019),
    [anon_sym_delete] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2017),
    [anon_sym_DQUOTE] = ACTIONS(2017),
    [anon_sym_SQUOTE] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2017),
    [sym_float_literal] = ACTIONS(2017),
    [sym_hex_literal] = ACTIONS(2019),
    [sym_int_literal] = ACTIONS(2019),
    [sym_binary_literal] = ACTIONS(2019),
    [sym_octal_literal] = ACTIONS(2019),
    [sym_bigint_literal] = ACTIONS(2017),
    [sym_this] = ACTIONS(2019),
    [sym_super] = ACTIONS(2019),
    [sym_true] = ACTIONS(2019),
    [sym_false] = ACTIONS(2019),
    [sym_null] = ACTIONS(2019),
    [anon_sym_AT] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [sym_readonly] = ACTIONS(2019),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_default] = ACTIONS(2019),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2017),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [anon_sym_typeof] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_interface] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_import] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2019),
    [anon_sym_enum] = ACTIONS(2019),
    [anon_sym_var] = ACTIONS(2019),
    [anon_sym_let] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2019),
    [anon_sym_if] = ACTIONS(2019),
    [anon_sym_switch] = ACTIONS(2019),
    [anon_sym_for] = ACTIONS(2019),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_await] = ACTIONS(2019),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2019),
    [anon_sym_try] = ACTIONS(2019),
    [anon_sym_with] = ACTIONS(2019),
    [anon_sym_break] = ACTIONS(2019),
    [anon_sym_continue] = ACTIONS(2019),
    [anon_sym_debugger] = ACTIONS(2019),
    [anon_sym_return] = ACTIONS(2019),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2019),
    [anon_sym_yield] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2019),
    [anon_sym_abstract] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_new] = ACTIONS(2019),
    [anon_sym_PLUS] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2019),
    [anon_sym_SLASH] = ACTIONS(2019),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_TILDE] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(2019),
    [anon_sym_delete] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2017),
    [anon_sym_DQUOTE] = ACTIONS(2017),
    [anon_sym_SQUOTE] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2017),
    [sym_float_literal] = ACTIONS(2017),
    [sym_hex_literal] = ACTIONS(2019),
    [sym_int_literal] = ACTIONS(2019),
    [sym_binary_literal] = ACTIONS(2019),
    [sym_octal_literal] = ACTIONS(2019),
    [sym_bigint_literal] = ACTIONS(2017),
    [sym_this] = ACTIONS(2019),
    [sym_super] = ACTIONS(2019),
    [sym_true] = ACTIONS(2019),
    [sym_false] = ACTIONS(2019),
    [sym_null] = ACTIONS(2019),
    [anon_sym_AT] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [sym_readonly] = ACTIONS(2019),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2021),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(2023),
    [anon_sym_namespace] = ACTIONS(2023),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2021),
    [anon_sym_typeof] = ACTIONS(2023),
    [anon_sym_type] = ACTIONS(2023),
    [anon_sym_interface] = ACTIONS(2023),
    [anon_sym_declare] = ACTIONS(2023),
    [anon_sym_module] = ACTIONS(2023),
    [anon_sym_import] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2023),
    [anon_sym_enum] = ACTIONS(2023),
    [anon_sym_var] = ACTIONS(2023),
    [anon_sym_let] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(2023),
    [anon_sym_switch] = ACTIONS(2023),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_LPAREN] = ACTIONS(2021),
    [anon_sym_await] = ACTIONS(2023),
    [anon_sym_while] = ACTIONS(2023),
    [anon_sym_do] = ACTIONS(2023),
    [anon_sym_try] = ACTIONS(2023),
    [anon_sym_with] = ACTIONS(2023),
    [anon_sym_break] = ACTIONS(2023),
    [anon_sym_continue] = ACTIONS(2023),
    [anon_sym_debugger] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2023),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_case] = ACTIONS(2023),
    [anon_sym_yield] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_function] = ACTIONS(2023),
    [anon_sym_abstract] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(2023),
    [anon_sym_set] = ACTIONS(2023),
    [anon_sym_new] = ACTIONS(2023),
    [anon_sym_PLUS] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2023),
    [anon_sym_SLASH] = ACTIONS(2023),
    [anon_sym_LT] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2021),
    [anon_sym_void] = ACTIONS(2023),
    [anon_sym_delete] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2021),
    [anon_sym_DQUOTE] = ACTIONS(2021),
    [anon_sym_SQUOTE] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2021),
    [sym_float_literal] = ACTIONS(2021),
    [sym_hex_literal] = ACTIONS(2023),
    [sym_int_literal] = ACTIONS(2023),
    [sym_binary_literal] = ACTIONS(2023),
    [sym_octal_literal] = ACTIONS(2023),
    [sym_bigint_literal] = ACTIONS(2021),
    [sym_this] = ACTIONS(2023),
    [sym_super] = ACTIONS(2023),
    [sym_true] = ACTIONS(2023),
    [sym_false] = ACTIONS(2023),
    [sym_null] = ACTIONS(2023),
    [anon_sym_AT] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_public] = ACTIONS(2023),
    [anon_sym_private] = ACTIONS(2023),
    [anon_sym_protected] = ACTIONS(2023),
    [anon_sym_boolean] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(2023),
    [anon_sym_symbol] = ACTIONS(2023),
    [sym_readonly] = ACTIONS(2023),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_export] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_typeof] = ACTIONS(2027),
    [anon_sym_type] = ACTIONS(2027),
    [anon_sym_interface] = ACTIONS(2027),
    [anon_sym_declare] = ACTIONS(2027),
    [anon_sym_module] = ACTIONS(2027),
    [anon_sym_import] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_var] = ACTIONS(2027),
    [anon_sym_let] = ACTIONS(2027),
    [anon_sym_BANG] = ACTIONS(2025),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_await] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_with] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_debugger] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_yield] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2025),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_async] = ACTIONS(2027),
    [anon_sym_function] = ACTIONS(2027),
    [anon_sym_abstract] = ACTIONS(2027),
    [anon_sym_get] = ACTIONS(2027),
    [anon_sym_set] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_SLASH] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2025),
    [anon_sym_TILDE] = ACTIONS(2025),
    [anon_sym_void] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_PLUS_PLUS] = ACTIONS(2025),
    [anon_sym_DASH_DASH] = ACTIONS(2025),
    [anon_sym_DQUOTE] = ACTIONS(2025),
    [anon_sym_SQUOTE] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2025),
    [sym_float_literal] = ACTIONS(2025),
    [sym_hex_literal] = ACTIONS(2027),
    [sym_int_literal] = ACTIONS(2027),
    [sym_binary_literal] = ACTIONS(2027),
    [sym_octal_literal] = ACTIONS(2027),
    [sym_bigint_literal] = ACTIONS(2025),
    [sym_this] = ACTIONS(2027),
    [sym_super] = ACTIONS(2027),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [sym_null] = ACTIONS(2027),
    [anon_sym_AT] = ACTIONS(2025),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_public] = ACTIONS(2027),
    [anon_sym_private] = ACTIONS(2027),
    [anon_sym_protected] = ACTIONS(2027),
    [anon_sym_boolean] = ACTIONS(2027),
    [anon_sym_string] = ACTIONS(2027),
    [anon_sym_symbol] = ACTIONS(2027),
    [sym_readonly] = ACTIONS(2027),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2033),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_export] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2035),
    [anon_sym_namespace] = ACTIONS(2035),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_type] = ACTIONS(2035),
    [anon_sym_interface] = ACTIONS(2035),
    [anon_sym_declare] = ACTIONS(2035),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_import] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_enum] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
    [anon_sym_let] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_else] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_for] = ACTIONS(2035),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [anon_sym_await] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_with] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_debugger] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_case] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_class] = ACTIONS(2035),
    [anon_sym_async] = ACTIONS(2035),
    [anon_sym_function] = ACTIONS(2035),
    [anon_sym_abstract] = ACTIONS(2035),
    [anon_sym_get] = ACTIONS(2035),
    [anon_sym_set] = ACTIONS(2035),
    [anon_sym_new] = ACTIONS(2035),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_void] = ACTIONS(2035),
    [anon_sym_delete] = ACTIONS(2035),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2033),
    [sym_float_literal] = ACTIONS(2033),
    [sym_hex_literal] = ACTIONS(2035),
    [sym_int_literal] = ACTIONS(2035),
    [sym_binary_literal] = ACTIONS(2035),
    [sym_octal_literal] = ACTIONS(2035),
    [sym_bigint_literal] = ACTIONS(2033),
    [sym_this] = ACTIONS(2035),
    [sym_super] = ACTIONS(2035),
    [sym_true] = ACTIONS(2035),
    [sym_false] = ACTIONS(2035),
    [sym_null] = ACTIONS(2035),
    [anon_sym_AT] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2035),
    [anon_sym_public] = ACTIONS(2035),
    [anon_sym_private] = ACTIONS(2035),
    [anon_sym_protected] = ACTIONS(2035),
    [anon_sym_boolean] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_symbol] = ACTIONS(2035),
    [sym_readonly] = ACTIONS(2035),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(2037),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2039),
    [anon_sym_default] = ACTIONS(2039),
    [anon_sym_namespace] = ACTIONS(2039),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_typeof] = ACTIONS(2039),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_interface] = ACTIONS(2039),
    [anon_sym_declare] = ACTIONS(2039),
    [anon_sym_module] = ACTIONS(2039),
    [anon_sym_import] = ACTIONS(2039),
    [anon_sym_const] = ACTIONS(2039),
    [anon_sym_enum] = ACTIONS(2039),
    [anon_sym_var] = ACTIONS(2039),
    [anon_sym_let] = ACTIONS(2039),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_else] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(2039),
    [anon_sym_switch] = ACTIONS(2039),
    [anon_sym_for] = ACTIONS(2039),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_await] = ACTIONS(2039),
    [anon_sym_while] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2039),
    [anon_sym_try] = ACTIONS(2039),
    [anon_sym_with] = ACTIONS(2039),
    [anon_sym_break] = ACTIONS(2039),
    [anon_sym_continue] = ACTIONS(2039),
    [anon_sym_debugger] = ACTIONS(2039),
    [anon_sym_return] = ACTIONS(2039),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_case] = ACTIONS(2039),
    [anon_sym_yield] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(2037),
    [anon_sym_class] = ACTIONS(2039),
    [anon_sym_async] = ACTIONS(2039),
    [anon_sym_function] = ACTIONS(2039),
    [anon_sym_abstract] = ACTIONS(2039),
    [anon_sym_get] = ACTIONS(2039),
    [anon_sym_set] = ACTIONS(2039),
    [anon_sym_new] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_LT] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_void] = ACTIONS(2039),
    [anon_sym_delete] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2037),
    [sym_float_literal] = ACTIONS(2037),
    [sym_hex_literal] = ACTIONS(2039),
    [sym_int_literal] = ACTIONS(2039),
    [sym_binary_literal] = ACTIONS(2039),
    [sym_octal_literal] = ACTIONS(2039),
    [sym_bigint_literal] = ACTIONS(2037),
    [sym_this] = ACTIONS(2039),
    [sym_super] = ACTIONS(2039),
    [sym_true] = ACTIONS(2039),
    [sym_false] = ACTIONS(2039),
    [sym_null] = ACTIONS(2039),
    [anon_sym_AT] = ACTIONS(2037),
    [anon_sym_static] = ACTIONS(2039),
    [anon_sym_public] = ACTIONS(2039),
    [anon_sym_private] = ACTIONS(2039),
    [anon_sym_protected] = ACTIONS(2039),
    [anon_sym_boolean] = ACTIONS(2039),
    [anon_sym_string] = ACTIONS(2039),
    [anon_sym_symbol] = ACTIONS(2039),
    [sym_readonly] = ACTIONS(2039),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2041),
    [sym_identifier] = ACTIONS(2043),
    [anon_sym_export] = ACTIONS(2043),
    [anon_sym_default] = ACTIONS(2043),
    [anon_sym_namespace] = ACTIONS(2043),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(2043),
    [anon_sym_type] = ACTIONS(2043),
    [anon_sym_interface] = ACTIONS(2043),
    [anon_sym_declare] = ACTIONS(2043),
    [anon_sym_module] = ACTIONS(2043),
    [anon_sym_import] = ACTIONS(2043),
    [anon_sym_const] = ACTIONS(2043),
    [anon_sym_enum] = ACTIONS(2043),
    [anon_sym_var] = ACTIONS(2043),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_else] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2043),
    [anon_sym_switch] = ACTIONS(2043),
    [anon_sym_for] = ACTIONS(2043),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2043),
    [anon_sym_do] = ACTIONS(2043),
    [anon_sym_try] = ACTIONS(2043),
    [anon_sym_with] = ACTIONS(2043),
    [anon_sym_break] = ACTIONS(2043),
    [anon_sym_continue] = ACTIONS(2043),
    [anon_sym_debugger] = ACTIONS(2043),
    [anon_sym_return] = ACTIONS(2043),
    [anon_sym_throw] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_case] = ACTIONS(2043),
    [anon_sym_yield] = ACTIONS(2043),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_class] = ACTIONS(2043),
    [anon_sym_async] = ACTIONS(2043),
    [anon_sym_function] = ACTIONS(2043),
    [anon_sym_abstract] = ACTIONS(2043),
    [anon_sym_get] = ACTIONS(2043),
    [anon_sym_set] = ACTIONS(2043),
    [anon_sym_new] = ACTIONS(2043),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_void] = ACTIONS(2043),
    [anon_sym_delete] = ACTIONS(2043),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_DQUOTE] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [sym_float_literal] = ACTIONS(2041),
    [sym_hex_literal] = ACTIONS(2043),
    [sym_int_literal] = ACTIONS(2043),
    [sym_binary_literal] = ACTIONS(2043),
    [sym_octal_literal] = ACTIONS(2043),
    [sym_bigint_literal] = ACTIONS(2041),
    [sym_this] = ACTIONS(2043),
    [sym_super] = ACTIONS(2043),
    [sym_true] = ACTIONS(2043),
    [sym_false] = ACTIONS(2043),
    [sym_null] = ACTIONS(2043),
    [anon_sym_AT] = ACTIONS(2041),
    [anon_sym_static] = ACTIONS(2043),
    [anon_sym_public] = ACTIONS(2043),
    [anon_sym_private] = ACTIONS(2043),
    [anon_sym_protected] = ACTIONS(2043),
    [anon_sym_boolean] = ACTIONS(2043),
    [anon_sym_string] = ACTIONS(2043),
    [anon_sym_symbol] = ACTIONS(2043),
    [sym_readonly] = ACTIONS(2043),
  },
  [611] = {
    [sym__call_signature] = STATE(3296),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_export] = ACTIONS(1767),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1767),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1767),
    [anon_sym_module] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(1769),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1767),
    [anon_sym_set] = ACTIONS(1767),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1767),
    [anon_sym_public] = ACTIONS(1767),
    [anon_sym_private] = ACTIONS(1767),
    [anon_sym_protected] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [sym_readonly] = ACTIONS(1767),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(2045),
    [sym_identifier] = ACTIONS(2047),
    [anon_sym_export] = ACTIONS(2047),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_namespace] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_typeof] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2047),
    [anon_sym_interface] = ACTIONS(2047),
    [anon_sym_declare] = ACTIONS(2047),
    [anon_sym_module] = ACTIONS(2047),
    [anon_sym_import] = ACTIONS(2047),
    [anon_sym_const] = ACTIONS(2047),
    [anon_sym_enum] = ACTIONS(2047),
    [anon_sym_var] = ACTIONS(2047),
    [anon_sym_let] = ACTIONS(2047),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_else] = ACTIONS(2047),
    [anon_sym_if] = ACTIONS(2047),
    [anon_sym_switch] = ACTIONS(2047),
    [anon_sym_for] = ACTIONS(2047),
    [anon_sym_LPAREN] = ACTIONS(2045),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_while] = ACTIONS(2047),
    [anon_sym_do] = ACTIONS(2047),
    [anon_sym_try] = ACTIONS(2047),
    [anon_sym_with] = ACTIONS(2047),
    [anon_sym_break] = ACTIONS(2047),
    [anon_sym_continue] = ACTIONS(2047),
    [anon_sym_debugger] = ACTIONS(2047),
    [anon_sym_return] = ACTIONS(2047),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_case] = ACTIONS(2047),
    [anon_sym_yield] = ACTIONS(2047),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_class] = ACTIONS(2047),
    [anon_sym_async] = ACTIONS(2047),
    [anon_sym_function] = ACTIONS(2047),
    [anon_sym_abstract] = ACTIONS(2047),
    [anon_sym_get] = ACTIONS(2047),
    [anon_sym_set] = ACTIONS(2047),
    [anon_sym_new] = ACTIONS(2047),
    [anon_sym_PLUS] = ACTIONS(2047),
    [anon_sym_DASH] = ACTIONS(2047),
    [anon_sym_SLASH] = ACTIONS(2047),
    [anon_sym_LT] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_void] = ACTIONS(2047),
    [anon_sym_delete] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_DQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2045),
    [sym_float_literal] = ACTIONS(2045),
    [sym_hex_literal] = ACTIONS(2047),
    [sym_int_literal] = ACTIONS(2047),
    [sym_binary_literal] = ACTIONS(2047),
    [sym_octal_literal] = ACTIONS(2047),
    [sym_bigint_literal] = ACTIONS(2045),
    [sym_this] = ACTIONS(2047),
    [sym_super] = ACTIONS(2047),
    [sym_true] = ACTIONS(2047),
    [sym_false] = ACTIONS(2047),
    [sym_null] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(2045),
    [anon_sym_static] = ACTIONS(2047),
    [anon_sym_public] = ACTIONS(2047),
    [anon_sym_private] = ACTIONS(2047),
    [anon_sym_protected] = ACTIONS(2047),
    [anon_sym_boolean] = ACTIONS(2047),
    [anon_sym_string] = ACTIONS(2047),
    [anon_sym_symbol] = ACTIONS(2047),
    [sym_readonly] = ACTIONS(2047),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2049),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2051),
    [anon_sym_default] = ACTIONS(2051),
    [anon_sym_namespace] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_typeof] = ACTIONS(2051),
    [anon_sym_type] = ACTIONS(2051),
    [anon_sym_interface] = ACTIONS(2051),
    [anon_sym_declare] = ACTIONS(2051),
    [anon_sym_module] = ACTIONS(2051),
    [anon_sym_import] = ACTIONS(2051),
    [anon_sym_const] = ACTIONS(2051),
    [anon_sym_enum] = ACTIONS(2051),
    [anon_sym_var] = ACTIONS(2051),
    [anon_sym_let] = ACTIONS(2051),
    [anon_sym_BANG] = ACTIONS(2049),
    [anon_sym_else] = ACTIONS(2051),
    [anon_sym_if] = ACTIONS(2051),
    [anon_sym_switch] = ACTIONS(2051),
    [anon_sym_for] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(2049),
    [anon_sym_await] = ACTIONS(2051),
    [anon_sym_while] = ACTIONS(2051),
    [anon_sym_do] = ACTIONS(2051),
    [anon_sym_try] = ACTIONS(2051),
    [anon_sym_with] = ACTIONS(2051),
    [anon_sym_break] = ACTIONS(2051),
    [anon_sym_continue] = ACTIONS(2051),
    [anon_sym_debugger] = ACTIONS(2051),
    [anon_sym_return] = ACTIONS(2051),
    [anon_sym_throw] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_case] = ACTIONS(2051),
    [anon_sym_yield] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(2049),
    [anon_sym_class] = ACTIONS(2051),
    [anon_sym_async] = ACTIONS(2051),
    [anon_sym_function] = ACTIONS(2051),
    [anon_sym_abstract] = ACTIONS(2051),
    [anon_sym_get] = ACTIONS(2051),
    [anon_sym_set] = ACTIONS(2051),
    [anon_sym_new] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_SLASH] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_void] = ACTIONS(2051),
    [anon_sym_delete] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2049),
    [sym_float_literal] = ACTIONS(2049),
    [sym_hex_literal] = ACTIONS(2051),
    [sym_int_literal] = ACTIONS(2051),
    [sym_binary_literal] = ACTIONS(2051),
    [sym_octal_literal] = ACTIONS(2051),
    [sym_bigint_literal] = ACTIONS(2049),
    [sym_this] = ACTIONS(2051),
    [sym_super] = ACTIONS(2051),
    [sym_true] = ACTIONS(2051),
    [sym_false] = ACTIONS(2051),
    [sym_null] = ACTIONS(2051),
    [anon_sym_AT] = ACTIONS(2049),
    [anon_sym_static] = ACTIONS(2051),
    [anon_sym_public] = ACTIONS(2051),
    [anon_sym_private] = ACTIONS(2051),
    [anon_sym_protected] = ACTIONS(2051),
    [anon_sym_boolean] = ACTIONS(2051),
    [anon_sym_string] = ACTIONS(2051),
    [anon_sym_symbol] = ACTIONS(2051),
    [sym_readonly] = ACTIONS(2051),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2055),
    [anon_sym_export] = ACTIONS(2055),
    [anon_sym_default] = ACTIONS(2055),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_typeof] = ACTIONS(2055),
    [anon_sym_type] = ACTIONS(2055),
    [anon_sym_interface] = ACTIONS(2055),
    [anon_sym_declare] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2055),
    [anon_sym_import] = ACTIONS(2055),
    [anon_sym_const] = ACTIONS(2055),
    [anon_sym_enum] = ACTIONS(2055),
    [anon_sym_var] = ACTIONS(2055),
    [anon_sym_let] = ACTIONS(2055),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_else] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2055),
    [anon_sym_switch] = ACTIONS(2055),
    [anon_sym_for] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_await] = ACTIONS(2055),
    [anon_sym_while] = ACTIONS(2055),
    [anon_sym_do] = ACTIONS(2055),
    [anon_sym_try] = ACTIONS(2055),
    [anon_sym_with] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2055),
    [anon_sym_continue] = ACTIONS(2055),
    [anon_sym_debugger] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2055),
    [anon_sym_LBRACK] = ACTIONS(2053),
    [anon_sym_class] = ACTIONS(2055),
    [anon_sym_async] = ACTIONS(2055),
    [anon_sym_function] = ACTIONS(2055),
    [anon_sym_abstract] = ACTIONS(2055),
    [anon_sym_get] = ACTIONS(2055),
    [anon_sym_set] = ACTIONS(2055),
    [anon_sym_new] = ACTIONS(2055),
    [anon_sym_PLUS] = ACTIONS(2055),
    [anon_sym_DASH] = ACTIONS(2055),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_void] = ACTIONS(2055),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2053),
    [sym_float_literal] = ACTIONS(2053),
    [sym_hex_literal] = ACTIONS(2055),
    [sym_int_literal] = ACTIONS(2055),
    [sym_binary_literal] = ACTIONS(2055),
    [sym_octal_literal] = ACTIONS(2055),
    [sym_bigint_literal] = ACTIONS(2053),
    [sym_this] = ACTIONS(2055),
    [sym_super] = ACTIONS(2055),
    [sym_true] = ACTIONS(2055),
    [sym_false] = ACTIONS(2055),
    [sym_null] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2053),
    [anon_sym_static] = ACTIONS(2055),
    [anon_sym_public] = ACTIONS(2055),
    [anon_sym_private] = ACTIONS(2055),
    [anon_sym_protected] = ACTIONS(2055),
    [anon_sym_boolean] = ACTIONS(2055),
    [anon_sym_string] = ACTIONS(2055),
    [anon_sym_symbol] = ACTIONS(2055),
    [sym_readonly] = ACTIONS(2055),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2057),
    [sym_identifier] = ACTIONS(2059),
    [anon_sym_export] = ACTIONS(2059),
    [anon_sym_default] = ACTIONS(2059),
    [anon_sym_namespace] = ACTIONS(2059),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2059),
    [anon_sym_type] = ACTIONS(2059),
    [anon_sym_interface] = ACTIONS(2059),
    [anon_sym_declare] = ACTIONS(2059),
    [anon_sym_module] = ACTIONS(2059),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_const] = ACTIONS(2059),
    [anon_sym_enum] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2059),
    [anon_sym_let] = ACTIONS(2059),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2059),
    [anon_sym_if] = ACTIONS(2059),
    [anon_sym_switch] = ACTIONS(2059),
    [anon_sym_for] = ACTIONS(2059),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2059),
    [anon_sym_while] = ACTIONS(2059),
    [anon_sym_do] = ACTIONS(2059),
    [anon_sym_try] = ACTIONS(2059),
    [anon_sym_with] = ACTIONS(2059),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_continue] = ACTIONS(2059),
    [anon_sym_debugger] = ACTIONS(2059),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_throw] = ACTIONS(2059),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2059),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2059),
    [anon_sym_async] = ACTIONS(2059),
    [anon_sym_function] = ACTIONS(2059),
    [anon_sym_abstract] = ACTIONS(2059),
    [anon_sym_get] = ACTIONS(2059),
    [anon_sym_set] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2059),
    [anon_sym_SLASH] = ACTIONS(2059),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2059),
    [anon_sym_delete] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_float_literal] = ACTIONS(2057),
    [sym_hex_literal] = ACTIONS(2059),
    [sym_int_literal] = ACTIONS(2059),
    [sym_binary_literal] = ACTIONS(2059),
    [sym_octal_literal] = ACTIONS(2059),
    [sym_bigint_literal] = ACTIONS(2057),
    [sym_this] = ACTIONS(2059),
    [sym_super] = ACTIONS(2059),
    [sym_true] = ACTIONS(2059),
    [sym_false] = ACTIONS(2059),
    [sym_null] = ACTIONS(2059),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2059),
    [anon_sym_public] = ACTIONS(2059),
    [anon_sym_private] = ACTIONS(2059),
    [anon_sym_protected] = ACTIONS(2059),
    [anon_sym_boolean] = ACTIONS(2059),
    [anon_sym_string] = ACTIONS(2059),
    [anon_sym_symbol] = ACTIONS(2059),
    [sym_readonly] = ACTIONS(2059),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2063),
    [anon_sym_export] = ACTIONS(2063),
    [anon_sym_default] = ACTIONS(2063),
    [anon_sym_namespace] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(2063),
    [anon_sym_type] = ACTIONS(2063),
    [anon_sym_interface] = ACTIONS(2063),
    [anon_sym_declare] = ACTIONS(2063),
    [anon_sym_module] = ACTIONS(2063),
    [anon_sym_import] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2063),
    [anon_sym_enum] = ACTIONS(2063),
    [anon_sym_var] = ACTIONS(2063),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_BANG] = ACTIONS(2061),
    [anon_sym_else] = ACTIONS(2063),
    [anon_sym_if] = ACTIONS(2063),
    [anon_sym_switch] = ACTIONS(2063),
    [anon_sym_for] = ACTIONS(2063),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_while] = ACTIONS(2063),
    [anon_sym_do] = ACTIONS(2063),
    [anon_sym_try] = ACTIONS(2063),
    [anon_sym_with] = ACTIONS(2063),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_continue] = ACTIONS(2063),
    [anon_sym_debugger] = ACTIONS(2063),
    [anon_sym_return] = ACTIONS(2063),
    [anon_sym_throw] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_case] = ACTIONS(2063),
    [anon_sym_yield] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_class] = ACTIONS(2063),
    [anon_sym_async] = ACTIONS(2063),
    [anon_sym_function] = ACTIONS(2063),
    [anon_sym_abstract] = ACTIONS(2063),
    [anon_sym_get] = ACTIONS(2063),
    [anon_sym_set] = ACTIONS(2063),
    [anon_sym_new] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_void] = ACTIONS(2063),
    [anon_sym_delete] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym_float_literal] = ACTIONS(2061),
    [sym_hex_literal] = ACTIONS(2063),
    [sym_int_literal] = ACTIONS(2063),
    [sym_binary_literal] = ACTIONS(2063),
    [sym_octal_literal] = ACTIONS(2063),
    [sym_bigint_literal] = ACTIONS(2061),
    [sym_this] = ACTIONS(2063),
    [sym_super] = ACTIONS(2063),
    [sym_true] = ACTIONS(2063),
    [sym_false] = ACTIONS(2063),
    [sym_null] = ACTIONS(2063),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_static] = ACTIONS(2063),
    [anon_sym_public] = ACTIONS(2063),
    [anon_sym_private] = ACTIONS(2063),
    [anon_sym_protected] = ACTIONS(2063),
    [anon_sym_boolean] = ACTIONS(2063),
    [anon_sym_string] = ACTIONS(2063),
    [anon_sym_symbol] = ACTIONS(2063),
    [sym_readonly] = ACTIONS(2063),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2065),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2065),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [sym_float_literal] = ACTIONS(2065),
    [sym_hex_literal] = ACTIONS(2067),
    [sym_int_literal] = ACTIONS(2067),
    [sym_binary_literal] = ACTIONS(2067),
    [sym_octal_literal] = ACTIONS(2067),
    [sym_bigint_literal] = ACTIONS(2065),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2065),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [sym_readonly] = ACTIONS(2067),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2069),
    [sym_identifier] = ACTIONS(2071),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_default] = ACTIONS(2071),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_typeof] = ACTIONS(2071),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_interface] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_import] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2071),
    [anon_sym_enum] = ACTIONS(2071),
    [anon_sym_var] = ACTIONS(2071),
    [anon_sym_let] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_else] = ACTIONS(2071),
    [anon_sym_if] = ACTIONS(2071),
    [anon_sym_switch] = ACTIONS(2071),
    [anon_sym_for] = ACTIONS(2071),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_await] = ACTIONS(2071),
    [anon_sym_while] = ACTIONS(2071),
    [anon_sym_do] = ACTIONS(2071),
    [anon_sym_try] = ACTIONS(2071),
    [anon_sym_with] = ACTIONS(2071),
    [anon_sym_break] = ACTIONS(2071),
    [anon_sym_continue] = ACTIONS(2071),
    [anon_sym_debugger] = ACTIONS(2071),
    [anon_sym_return] = ACTIONS(2071),
    [anon_sym_throw] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_case] = ACTIONS(2071),
    [anon_sym_yield] = ACTIONS(2071),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [anon_sym_class] = ACTIONS(2071),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2071),
    [anon_sym_abstract] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_new] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_SLASH] = ACTIONS(2071),
    [anon_sym_LT] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_void] = ACTIONS(2071),
    [anon_sym_delete] = ACTIONS(2071),
    [anon_sym_PLUS_PLUS] = ACTIONS(2069),
    [anon_sym_DASH_DASH] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2069),
    [sym_float_literal] = ACTIONS(2069),
    [sym_hex_literal] = ACTIONS(2071),
    [sym_int_literal] = ACTIONS(2071),
    [sym_binary_literal] = ACTIONS(2071),
    [sym_octal_literal] = ACTIONS(2071),
    [sym_bigint_literal] = ACTIONS(2069),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(2071),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(2069),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [sym_readonly] = ACTIONS(2071),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_export] = ACTIONS(2075),
    [anon_sym_default] = ACTIONS(2075),
    [anon_sym_namespace] = ACTIONS(2075),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_typeof] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_interface] = ACTIONS(2075),
    [anon_sym_declare] = ACTIONS(2075),
    [anon_sym_module] = ACTIONS(2075),
    [anon_sym_import] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
    [anon_sym_var] = ACTIONS(2075),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(2075),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_switch] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_await] = ACTIONS(2075),
    [anon_sym_while] = ACTIONS(2075),
    [anon_sym_do] = ACTIONS(2075),
    [anon_sym_try] = ACTIONS(2075),
    [anon_sym_with] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_debugger] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_throw] = ACTIONS(2075),
    [anon_sym_SEMI] = ACTIONS(2073),
    [anon_sym_case] = ACTIONS(2075),
    [anon_sym_yield] = ACTIONS(2075),
    [anon_sym_LBRACK] = ACTIONS(2073),
    [anon_sym_class] = ACTIONS(2075),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2075),
    [anon_sym_abstract] = ACTIONS(2075),
    [anon_sym_get] = ACTIONS(2075),
    [anon_sym_set] = ACTIONS(2075),
    [anon_sym_new] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(2075),
    [anon_sym_SLASH] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_void] = ACTIONS(2075),
    [anon_sym_delete] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_DQUOTE] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2073),
    [sym_float_literal] = ACTIONS(2073),
    [sym_hex_literal] = ACTIONS(2075),
    [sym_int_literal] = ACTIONS(2075),
    [sym_binary_literal] = ACTIONS(2075),
    [sym_octal_literal] = ACTIONS(2075),
    [sym_bigint_literal] = ACTIONS(2073),
    [sym_this] = ACTIONS(2075),
    [sym_super] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [anon_sym_AT] = ACTIONS(2073),
    [anon_sym_static] = ACTIONS(2075),
    [anon_sym_public] = ACTIONS(2075),
    [anon_sym_private] = ACTIONS(2075),
    [anon_sym_protected] = ACTIONS(2075),
    [anon_sym_boolean] = ACTIONS(2075),
    [anon_sym_string] = ACTIONS(2075),
    [anon_sym_symbol] = ACTIONS(2075),
    [sym_readonly] = ACTIONS(2075),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(2077),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_export] = ACTIONS(2079),
    [anon_sym_default] = ACTIONS(2079),
    [anon_sym_namespace] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(2079),
    [anon_sym_type] = ACTIONS(2079),
    [anon_sym_interface] = ACTIONS(2079),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2079),
    [anon_sym_import] = ACTIONS(2079),
    [anon_sym_const] = ACTIONS(2079),
    [anon_sym_enum] = ACTIONS(2079),
    [anon_sym_var] = ACTIONS(2079),
    [anon_sym_let] = ACTIONS(2079),
    [anon_sym_BANG] = ACTIONS(2077),
    [anon_sym_else] = ACTIONS(2079),
    [anon_sym_if] = ACTIONS(2079),
    [anon_sym_switch] = ACTIONS(2079),
    [anon_sym_for] = ACTIONS(2079),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(2079),
    [anon_sym_do] = ACTIONS(2079),
    [anon_sym_try] = ACTIONS(2079),
    [anon_sym_with] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2079),
    [anon_sym_continue] = ACTIONS(2079),
    [anon_sym_debugger] = ACTIONS(2079),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_throw] = ACTIONS(2079),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_case] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(2079),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_class] = ACTIONS(2079),
    [anon_sym_async] = ACTIONS(2079),
    [anon_sym_function] = ACTIONS(2079),
    [anon_sym_abstract] = ACTIONS(2079),
    [anon_sym_get] = ACTIONS(2079),
    [anon_sym_set] = ACTIONS(2079),
    [anon_sym_new] = ACTIONS(2079),
    [anon_sym_PLUS] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2079),
    [anon_sym_LT] = ACTIONS(2077),
    [anon_sym_TILDE] = ACTIONS(2077),
    [anon_sym_void] = ACTIONS(2079),
    [anon_sym_delete] = ACTIONS(2079),
    [anon_sym_PLUS_PLUS] = ACTIONS(2077),
    [anon_sym_DASH_DASH] = ACTIONS(2077),
    [anon_sym_DQUOTE] = ACTIONS(2077),
    [anon_sym_SQUOTE] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2077),
    [sym_float_literal] = ACTIONS(2077),
    [sym_hex_literal] = ACTIONS(2079),
    [sym_int_literal] = ACTIONS(2079),
    [sym_binary_literal] = ACTIONS(2079),
    [sym_octal_literal] = ACTIONS(2079),
    [sym_bigint_literal] = ACTIONS(2077),
    [sym_this] = ACTIONS(2079),
    [sym_super] = ACTIONS(2079),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(2077),
    [anon_sym_static] = ACTIONS(2079),
    [anon_sym_public] = ACTIONS(2079),
    [anon_sym_private] = ACTIONS(2079),
    [anon_sym_protected] = ACTIONS(2079),
    [anon_sym_boolean] = ACTIONS(2079),
    [anon_sym_string] = ACTIONS(2079),
    [anon_sym_symbol] = ACTIONS(2079),
    [sym_readonly] = ACTIONS(2079),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2081),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [sym_float_literal] = ACTIONS(2081),
    [sym_hex_literal] = ACTIONS(2083),
    [sym_int_literal] = ACTIONS(2083),
    [sym_binary_literal] = ACTIONS(2083),
    [sym_octal_literal] = ACTIONS(2083),
    [sym_bigint_literal] = ACTIONS(2081),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2081),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [sym_readonly] = ACTIONS(2083),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2085),
    [sym_identifier] = ACTIONS(2087),
    [anon_sym_export] = ACTIONS(2087),
    [anon_sym_default] = ACTIONS(2087),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2085),
    [anon_sym_typeof] = ACTIONS(2087),
    [anon_sym_type] = ACTIONS(2087),
    [anon_sym_interface] = ACTIONS(2087),
    [anon_sym_declare] = ACTIONS(2087),
    [anon_sym_module] = ACTIONS(2087),
    [anon_sym_import] = ACTIONS(2087),
    [anon_sym_const] = ACTIONS(2087),
    [anon_sym_enum] = ACTIONS(2087),
    [anon_sym_var] = ACTIONS(2087),
    [anon_sym_let] = ACTIONS(2087),
    [anon_sym_BANG] = ACTIONS(2085),
    [anon_sym_else] = ACTIONS(2087),
    [anon_sym_if] = ACTIONS(2087),
    [anon_sym_switch] = ACTIONS(2087),
    [anon_sym_for] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(2085),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_while] = ACTIONS(2087),
    [anon_sym_do] = ACTIONS(2087),
    [anon_sym_try] = ACTIONS(2087),
    [anon_sym_with] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_continue] = ACTIONS(2087),
    [anon_sym_debugger] = ACTIONS(2087),
    [anon_sym_return] = ACTIONS(2087),
    [anon_sym_throw] = ACTIONS(2087),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_case] = ACTIONS(2087),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(2085),
    [anon_sym_class] = ACTIONS(2087),
    [anon_sym_async] = ACTIONS(2087),
    [anon_sym_function] = ACTIONS(2087),
    [anon_sym_abstract] = ACTIONS(2087),
    [anon_sym_get] = ACTIONS(2087),
    [anon_sym_set] = ACTIONS(2087),
    [anon_sym_new] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2087),
    [anon_sym_DASH] = ACTIONS(2087),
    [anon_sym_SLASH] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_TILDE] = ACTIONS(2085),
    [anon_sym_void] = ACTIONS(2087),
    [anon_sym_delete] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(2085),
    [anon_sym_DASH_DASH] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2085),
    [anon_sym_SQUOTE] = ACTIONS(2085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2085),
    [sym_float_literal] = ACTIONS(2085),
    [sym_hex_literal] = ACTIONS(2087),
    [sym_int_literal] = ACTIONS(2087),
    [sym_binary_literal] = ACTIONS(2087),
    [sym_octal_literal] = ACTIONS(2087),
    [sym_bigint_literal] = ACTIONS(2085),
    [sym_this] = ACTIONS(2087),
    [sym_super] = ACTIONS(2087),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(2085),
    [anon_sym_static] = ACTIONS(2087),
    [anon_sym_public] = ACTIONS(2087),
    [anon_sym_private] = ACTIONS(2087),
    [anon_sym_protected] = ACTIONS(2087),
    [anon_sym_boolean] = ACTIONS(2087),
    [anon_sym_string] = ACTIONS(2087),
    [anon_sym_symbol] = ACTIONS(2087),
    [sym_readonly] = ACTIONS(2087),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2089),
    [sym_identifier] = ACTIONS(2091),
    [anon_sym_export] = ACTIONS(2091),
    [anon_sym_default] = ACTIONS(2091),
    [anon_sym_namespace] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_typeof] = ACTIONS(2091),
    [anon_sym_type] = ACTIONS(2091),
    [anon_sym_interface] = ACTIONS(2091),
    [anon_sym_declare] = ACTIONS(2091),
    [anon_sym_module] = ACTIONS(2091),
    [anon_sym_import] = ACTIONS(2091),
    [anon_sym_const] = ACTIONS(2091),
    [anon_sym_enum] = ACTIONS(2091),
    [anon_sym_var] = ACTIONS(2091),
    [anon_sym_let] = ACTIONS(2091),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(2091),
    [anon_sym_if] = ACTIONS(2091),
    [anon_sym_switch] = ACTIONS(2091),
    [anon_sym_for] = ACTIONS(2091),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_await] = ACTIONS(2091),
    [anon_sym_while] = ACTIONS(2091),
    [anon_sym_do] = ACTIONS(2091),
    [anon_sym_try] = ACTIONS(2091),
    [anon_sym_with] = ACTIONS(2091),
    [anon_sym_break] = ACTIONS(2091),
    [anon_sym_continue] = ACTIONS(2091),
    [anon_sym_debugger] = ACTIONS(2091),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_throw] = ACTIONS(2091),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_case] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(2089),
    [anon_sym_class] = ACTIONS(2091),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_function] = ACTIONS(2091),
    [anon_sym_abstract] = ACTIONS(2091),
    [anon_sym_get] = ACTIONS(2091),
    [anon_sym_set] = ACTIONS(2091),
    [anon_sym_new] = ACTIONS(2091),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_SLASH] = ACTIONS(2091),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_void] = ACTIONS(2091),
    [anon_sym_delete] = ACTIONS(2091),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2089),
    [sym_float_literal] = ACTIONS(2089),
    [sym_hex_literal] = ACTIONS(2091),
    [sym_int_literal] = ACTIONS(2091),
    [sym_binary_literal] = ACTIONS(2091),
    [sym_octal_literal] = ACTIONS(2091),
    [sym_bigint_literal] = ACTIONS(2089),
    [sym_this] = ACTIONS(2091),
    [sym_super] = ACTIONS(2091),
    [sym_true] = ACTIONS(2091),
    [sym_false] = ACTIONS(2091),
    [sym_null] = ACTIONS(2091),
    [anon_sym_AT] = ACTIONS(2089),
    [anon_sym_static] = ACTIONS(2091),
    [anon_sym_public] = ACTIONS(2091),
    [anon_sym_private] = ACTIONS(2091),
    [anon_sym_protected] = ACTIONS(2091),
    [anon_sym_boolean] = ACTIONS(2091),
    [anon_sym_string] = ACTIONS(2091),
    [anon_sym_symbol] = ACTIONS(2091),
    [sym_readonly] = ACTIONS(2091),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2095),
    [anon_sym_export] = ACTIONS(2095),
    [anon_sym_default] = ACTIONS(2095),
    [anon_sym_namespace] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_typeof] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2095),
    [anon_sym_interface] = ACTIONS(2095),
    [anon_sym_declare] = ACTIONS(2095),
    [anon_sym_module] = ACTIONS(2095),
    [anon_sym_import] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(2095),
    [anon_sym_enum] = ACTIONS(2095),
    [anon_sym_var] = ACTIONS(2095),
    [anon_sym_let] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_else] = ACTIONS(2095),
    [anon_sym_if] = ACTIONS(2095),
    [anon_sym_switch] = ACTIONS(2095),
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_await] = ACTIONS(2095),
    [anon_sym_while] = ACTIONS(2095),
    [anon_sym_do] = ACTIONS(2095),
    [anon_sym_try] = ACTIONS(2095),
    [anon_sym_with] = ACTIONS(2095),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_debugger] = ACTIONS(2095),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_throw] = ACTIONS(2095),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_case] = ACTIONS(2095),
    [anon_sym_yield] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [anon_sym_class] = ACTIONS(2095),
    [anon_sym_async] = ACTIONS(2095),
    [anon_sym_function] = ACTIONS(2095),
    [anon_sym_abstract] = ACTIONS(2095),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_new] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_SLASH] = ACTIONS(2095),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_void] = ACTIONS(2095),
    [anon_sym_delete] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [sym_float_literal] = ACTIONS(2093),
    [sym_hex_literal] = ACTIONS(2095),
    [sym_int_literal] = ACTIONS(2095),
    [sym_binary_literal] = ACTIONS(2095),
    [sym_octal_literal] = ACTIONS(2095),
    [sym_bigint_literal] = ACTIONS(2093),
    [sym_this] = ACTIONS(2095),
    [sym_super] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [sym_false] = ACTIONS(2095),
    [sym_null] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2093),
    [anon_sym_static] = ACTIONS(2095),
    [anon_sym_public] = ACTIONS(2095),
    [anon_sym_private] = ACTIONS(2095),
    [anon_sym_protected] = ACTIONS(2095),
    [anon_sym_boolean] = ACTIONS(2095),
    [anon_sym_string] = ACTIONS(2095),
    [anon_sym_symbol] = ACTIONS(2095),
    [sym_readonly] = ACTIONS(2095),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2097),
    [sym_identifier] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_default] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_interface] = ACTIONS(2099),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_const] = ACTIONS(2099),
    [anon_sym_enum] = ACTIONS(2099),
    [anon_sym_var] = ACTIONS(2099),
    [anon_sym_let] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2097),
    [anon_sym_else] = ACTIONS(2099),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_switch] = ACTIONS(2099),
    [anon_sym_for] = ACTIONS(2099),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_while] = ACTIONS(2099),
    [anon_sym_do] = ACTIONS(2099),
    [anon_sym_try] = ACTIONS(2099),
    [anon_sym_with] = ACTIONS(2099),
    [anon_sym_break] = ACTIONS(2099),
    [anon_sym_continue] = ACTIONS(2099),
    [anon_sym_debugger] = ACTIONS(2099),
    [anon_sym_return] = ACTIONS(2099),
    [anon_sym_throw] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(2097),
    [anon_sym_case] = ACTIONS(2099),
    [anon_sym_yield] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_class] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(2099),
    [anon_sym_abstract] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2099),
    [anon_sym_SLASH] = ACTIONS(2099),
    [anon_sym_LT] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(2097),
    [anon_sym_void] = ACTIONS(2099),
    [anon_sym_delete] = ACTIONS(2099),
    [anon_sym_PLUS_PLUS] = ACTIONS(2097),
    [anon_sym_DASH_DASH] = ACTIONS(2097),
    [anon_sym_DQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2097),
    [sym_float_literal] = ACTIONS(2097),
    [sym_hex_literal] = ACTIONS(2099),
    [sym_int_literal] = ACTIONS(2099),
    [sym_binary_literal] = ACTIONS(2099),
    [sym_octal_literal] = ACTIONS(2099),
    [sym_bigint_literal] = ACTIONS(2097),
    [sym_this] = ACTIONS(2099),
    [sym_super] = ACTIONS(2099),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [anon_sym_AT] = ACTIONS(2097),
    [anon_sym_static] = ACTIONS(2099),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [sym_readonly] = ACTIONS(2099),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(2101),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2101),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2101),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2101),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2101),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2101),
    [anon_sym_DASH_DASH] = ACTIONS(2101),
    [anon_sym_DQUOTE] = ACTIONS(2101),
    [anon_sym_SQUOTE] = ACTIONS(2101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2101),
    [sym_float_literal] = ACTIONS(2101),
    [sym_hex_literal] = ACTIONS(2103),
    [sym_int_literal] = ACTIONS(2103),
    [sym_binary_literal] = ACTIONS(2103),
    [sym_octal_literal] = ACTIONS(2103),
    [sym_bigint_literal] = ACTIONS(2101),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2101),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [sym_readonly] = ACTIONS(2103),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2107),
    [anon_sym_export] = ACTIONS(2107),
    [anon_sym_default] = ACTIONS(2107),
    [anon_sym_namespace] = ACTIONS(2107),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_typeof] = ACTIONS(2107),
    [anon_sym_type] = ACTIONS(2107),
    [anon_sym_interface] = ACTIONS(2107),
    [anon_sym_declare] = ACTIONS(2107),
    [anon_sym_module] = ACTIONS(2107),
    [anon_sym_import] = ACTIONS(2107),
    [anon_sym_const] = ACTIONS(2107),
    [anon_sym_enum] = ACTIONS(2107),
    [anon_sym_var] = ACTIONS(2107),
    [anon_sym_let] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_else] = ACTIONS(2107),
    [anon_sym_if] = ACTIONS(2107),
    [anon_sym_switch] = ACTIONS(2107),
    [anon_sym_for] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_await] = ACTIONS(2107),
    [anon_sym_while] = ACTIONS(2107),
    [anon_sym_do] = ACTIONS(2107),
    [anon_sym_try] = ACTIONS(2107),
    [anon_sym_with] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2107),
    [anon_sym_continue] = ACTIONS(2107),
    [anon_sym_debugger] = ACTIONS(2107),
    [anon_sym_return] = ACTIONS(2107),
    [anon_sym_throw] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_case] = ACTIONS(2107),
    [anon_sym_yield] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_class] = ACTIONS(2107),
    [anon_sym_async] = ACTIONS(2107),
    [anon_sym_function] = ACTIONS(2107),
    [anon_sym_abstract] = ACTIONS(2107),
    [anon_sym_get] = ACTIONS(2107),
    [anon_sym_set] = ACTIONS(2107),
    [anon_sym_new] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_void] = ACTIONS(2107),
    [anon_sym_delete] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2105),
    [sym_float_literal] = ACTIONS(2105),
    [sym_hex_literal] = ACTIONS(2107),
    [sym_int_literal] = ACTIONS(2107),
    [sym_binary_literal] = ACTIONS(2107),
    [sym_octal_literal] = ACTIONS(2107),
    [sym_bigint_literal] = ACTIONS(2105),
    [sym_this] = ACTIONS(2107),
    [sym_super] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(2105),
    [anon_sym_static] = ACTIONS(2107),
    [anon_sym_public] = ACTIONS(2107),
    [anon_sym_private] = ACTIONS(2107),
    [anon_sym_protected] = ACTIONS(2107),
    [anon_sym_boolean] = ACTIONS(2107),
    [anon_sym_string] = ACTIONS(2107),
    [anon_sym_symbol] = ACTIONS(2107),
    [sym_readonly] = ACTIONS(2107),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2109),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2109),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2109),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2109),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2109),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_SQUOTE] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [sym_float_literal] = ACTIONS(2109),
    [sym_hex_literal] = ACTIONS(2111),
    [sym_int_literal] = ACTIONS(2111),
    [sym_binary_literal] = ACTIONS(2111),
    [sym_octal_literal] = ACTIONS(2111),
    [sym_bigint_literal] = ACTIONS(2109),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2109),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [sym_readonly] = ACTIONS(2111),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2113),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_export] = ACTIONS(2115),
    [anon_sym_default] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_RBRACE] = ACTIONS(2113),
    [anon_sym_typeof] = ACTIONS(2115),
    [anon_sym_type] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2115),
    [anon_sym_declare] = ACTIONS(2115),
    [anon_sym_module] = ACTIONS(2115),
    [anon_sym_import] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_enum] = ACTIONS(2115),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_else] = ACTIONS(2115),
    [anon_sym_if] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2115),
    [anon_sym_for] = ACTIONS(2115),
    [anon_sym_LPAREN] = ACTIONS(2113),
    [anon_sym_await] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2115),
    [anon_sym_do] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_with] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2115),
    [anon_sym_continue] = ACTIONS(2115),
    [anon_sym_debugger] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2115),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_case] = ACTIONS(2115),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_LBRACK] = ACTIONS(2113),
    [anon_sym_class] = ACTIONS(2115),
    [anon_sym_async] = ACTIONS(2115),
    [anon_sym_function] = ACTIONS(2115),
    [anon_sym_abstract] = ACTIONS(2115),
    [anon_sym_get] = ACTIONS(2115),
    [anon_sym_set] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_void] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2115),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_DQUOTE] = ACTIONS(2113),
    [anon_sym_SQUOTE] = ACTIONS(2113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2113),
    [sym_float_literal] = ACTIONS(2113),
    [sym_hex_literal] = ACTIONS(2115),
    [sym_int_literal] = ACTIONS(2115),
    [sym_binary_literal] = ACTIONS(2115),
    [sym_octal_literal] = ACTIONS(2115),
    [sym_bigint_literal] = ACTIONS(2113),
    [sym_this] = ACTIONS(2115),
    [sym_super] = ACTIONS(2115),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [sym_null] = ACTIONS(2115),
    [anon_sym_AT] = ACTIONS(2113),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_public] = ACTIONS(2115),
    [anon_sym_private] = ACTIONS(2115),
    [anon_sym_protected] = ACTIONS(2115),
    [anon_sym_boolean] = ACTIONS(2115),
    [anon_sym_string] = ACTIONS(2115),
    [anon_sym_symbol] = ACTIONS(2115),
    [sym_readonly] = ACTIONS(2115),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2117),
    [sym_identifier] = ACTIONS(2119),
    [anon_sym_export] = ACTIONS(2119),
    [anon_sym_default] = ACTIONS(2119),
    [anon_sym_namespace] = ACTIONS(2119),
    [anon_sym_LBRACE] = ACTIONS(2117),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_typeof] = ACTIONS(2119),
    [anon_sym_type] = ACTIONS(2119),
    [anon_sym_interface] = ACTIONS(2119),
    [anon_sym_declare] = ACTIONS(2119),
    [anon_sym_module] = ACTIONS(2119),
    [anon_sym_import] = ACTIONS(2119),
    [anon_sym_const] = ACTIONS(2119),
    [anon_sym_enum] = ACTIONS(2119),
    [anon_sym_var] = ACTIONS(2119),
    [anon_sym_let] = ACTIONS(2119),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_else] = ACTIONS(2119),
    [anon_sym_if] = ACTIONS(2119),
    [anon_sym_switch] = ACTIONS(2119),
    [anon_sym_for] = ACTIONS(2119),
    [anon_sym_LPAREN] = ACTIONS(2117),
    [anon_sym_await] = ACTIONS(2119),
    [anon_sym_while] = ACTIONS(2119),
    [anon_sym_do] = ACTIONS(2119),
    [anon_sym_try] = ACTIONS(2119),
    [anon_sym_with] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2119),
    [anon_sym_continue] = ACTIONS(2119),
    [anon_sym_debugger] = ACTIONS(2119),
    [anon_sym_return] = ACTIONS(2119),
    [anon_sym_throw] = ACTIONS(2119),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_case] = ACTIONS(2119),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_class] = ACTIONS(2119),
    [anon_sym_async] = ACTIONS(2119),
    [anon_sym_function] = ACTIONS(2119),
    [anon_sym_abstract] = ACTIONS(2119),
    [anon_sym_get] = ACTIONS(2119),
    [anon_sym_set] = ACTIONS(2119),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_void] = ACTIONS(2119),
    [anon_sym_delete] = ACTIONS(2119),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_DQUOTE] = ACTIONS(2117),
    [anon_sym_SQUOTE] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2117),
    [sym_float_literal] = ACTIONS(2117),
    [sym_hex_literal] = ACTIONS(2119),
    [sym_int_literal] = ACTIONS(2119),
    [sym_binary_literal] = ACTIONS(2119),
    [sym_octal_literal] = ACTIONS(2119),
    [sym_bigint_literal] = ACTIONS(2117),
    [sym_this] = ACTIONS(2119),
    [sym_super] = ACTIONS(2119),
    [sym_true] = ACTIONS(2119),
    [sym_false] = ACTIONS(2119),
    [sym_null] = ACTIONS(2119),
    [anon_sym_AT] = ACTIONS(2117),
    [anon_sym_static] = ACTIONS(2119),
    [anon_sym_public] = ACTIONS(2119),
    [anon_sym_private] = ACTIONS(2119),
    [anon_sym_protected] = ACTIONS(2119),
    [anon_sym_boolean] = ACTIONS(2119),
    [anon_sym_string] = ACTIONS(2119),
    [anon_sym_symbol] = ACTIONS(2119),
    [sym_readonly] = ACTIONS(2119),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2121),
    [sym_identifier] = ACTIONS(2123),
    [anon_sym_export] = ACTIONS(2123),
    [anon_sym_default] = ACTIONS(2123),
    [anon_sym_namespace] = ACTIONS(2123),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [anon_sym_typeof] = ACTIONS(2123),
    [anon_sym_type] = ACTIONS(2123),
    [anon_sym_interface] = ACTIONS(2123),
    [anon_sym_declare] = ACTIONS(2123),
    [anon_sym_module] = ACTIONS(2123),
    [anon_sym_import] = ACTIONS(2123),
    [anon_sym_const] = ACTIONS(2123),
    [anon_sym_enum] = ACTIONS(2123),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_else] = ACTIONS(2123),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2121),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_do] = ACTIONS(2123),
    [anon_sym_try] = ACTIONS(2123),
    [anon_sym_with] = ACTIONS(2123),
    [anon_sym_break] = ACTIONS(2123),
    [anon_sym_continue] = ACTIONS(2123),
    [anon_sym_debugger] = ACTIONS(2123),
    [anon_sym_return] = ACTIONS(2123),
    [anon_sym_throw] = ACTIONS(2123),
    [anon_sym_SEMI] = ACTIONS(2121),
    [anon_sym_case] = ACTIONS(2123),
    [anon_sym_yield] = ACTIONS(2123),
    [anon_sym_LBRACK] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2123),
    [anon_sym_async] = ACTIONS(2123),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_abstract] = ACTIONS(2123),
    [anon_sym_get] = ACTIONS(2123),
    [anon_sym_set] = ACTIONS(2123),
    [anon_sym_new] = ACTIONS(2123),
    [anon_sym_PLUS] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2123),
    [anon_sym_SLASH] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2121),
    [anon_sym_void] = ACTIONS(2123),
    [anon_sym_delete] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2121),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [sym_float_literal] = ACTIONS(2121),
    [sym_hex_literal] = ACTIONS(2123),
    [sym_int_literal] = ACTIONS(2123),
    [sym_binary_literal] = ACTIONS(2123),
    [sym_octal_literal] = ACTIONS(2123),
    [sym_bigint_literal] = ACTIONS(2121),
    [sym_this] = ACTIONS(2123),
    [sym_super] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [anon_sym_AT] = ACTIONS(2121),
    [anon_sym_static] = ACTIONS(2123),
    [anon_sym_public] = ACTIONS(2123),
    [anon_sym_private] = ACTIONS(2123),
    [anon_sym_protected] = ACTIONS(2123),
    [anon_sym_boolean] = ACTIONS(2123),
    [anon_sym_string] = ACTIONS(2123),
    [anon_sym_symbol] = ACTIONS(2123),
    [sym_readonly] = ACTIONS(2123),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2125),
    [sym_identifier] = ACTIONS(2127),
    [anon_sym_export] = ACTIONS(2127),
    [anon_sym_default] = ACTIONS(2127),
    [anon_sym_namespace] = ACTIONS(2127),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2127),
    [anon_sym_type] = ACTIONS(2127),
    [anon_sym_interface] = ACTIONS(2127),
    [anon_sym_declare] = ACTIONS(2127),
    [anon_sym_module] = ACTIONS(2127),
    [anon_sym_import] = ACTIONS(2127),
    [anon_sym_const] = ACTIONS(2127),
    [anon_sym_enum] = ACTIONS(2127),
    [anon_sym_var] = ACTIONS(2127),
    [anon_sym_let] = ACTIONS(2127),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2127),
    [anon_sym_if] = ACTIONS(2127),
    [anon_sym_switch] = ACTIONS(2127),
    [anon_sym_for] = ACTIONS(2127),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2127),
    [anon_sym_while] = ACTIONS(2127),
    [anon_sym_do] = ACTIONS(2127),
    [anon_sym_try] = ACTIONS(2127),
    [anon_sym_with] = ACTIONS(2127),
    [anon_sym_break] = ACTIONS(2127),
    [anon_sym_continue] = ACTIONS(2127),
    [anon_sym_debugger] = ACTIONS(2127),
    [anon_sym_return] = ACTIONS(2127),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2127),
    [anon_sym_yield] = ACTIONS(2127),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2127),
    [anon_sym_async] = ACTIONS(2127),
    [anon_sym_function] = ACTIONS(2127),
    [anon_sym_abstract] = ACTIONS(2127),
    [anon_sym_get] = ACTIONS(2127),
    [anon_sym_set] = ACTIONS(2127),
    [anon_sym_new] = ACTIONS(2127),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_SLASH] = ACTIONS(2127),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2127),
    [anon_sym_delete] = ACTIONS(2127),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_float_literal] = ACTIONS(2125),
    [sym_hex_literal] = ACTIONS(2127),
    [sym_int_literal] = ACTIONS(2127),
    [sym_binary_literal] = ACTIONS(2127),
    [sym_octal_literal] = ACTIONS(2127),
    [sym_bigint_literal] = ACTIONS(2125),
    [sym_this] = ACTIONS(2127),
    [sym_super] = ACTIONS(2127),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [sym_null] = ACTIONS(2127),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2127),
    [anon_sym_public] = ACTIONS(2127),
    [anon_sym_private] = ACTIONS(2127),
    [anon_sym_protected] = ACTIONS(2127),
    [anon_sym_boolean] = ACTIONS(2127),
    [anon_sym_string] = ACTIONS(2127),
    [anon_sym_symbol] = ACTIONS(2127),
    [sym_readonly] = ACTIONS(2127),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2131),
    [anon_sym_export] = ACTIONS(2131),
    [anon_sym_default] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2131),
    [anon_sym_interface] = ACTIONS(2131),
    [anon_sym_declare] = ACTIONS(2131),
    [anon_sym_module] = ACTIONS(2131),
    [anon_sym_import] = ACTIONS(2131),
    [anon_sym_const] = ACTIONS(2131),
    [anon_sym_enum] = ACTIONS(2131),
    [anon_sym_var] = ACTIONS(2131),
    [anon_sym_let] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_do] = ACTIONS(2131),
    [anon_sym_try] = ACTIONS(2131),
    [anon_sym_with] = ACTIONS(2131),
    [anon_sym_break] = ACTIONS(2131),
    [anon_sym_continue] = ACTIONS(2131),
    [anon_sym_debugger] = ACTIONS(2131),
    [anon_sym_return] = ACTIONS(2131),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_case] = ACTIONS(2131),
    [anon_sym_yield] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2131),
    [anon_sym_async] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_abstract] = ACTIONS(2131),
    [anon_sym_get] = ACTIONS(2131),
    [anon_sym_set] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_SLASH] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2131),
    [anon_sym_delete] = ACTIONS(2131),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_float_literal] = ACTIONS(2129),
    [sym_hex_literal] = ACTIONS(2131),
    [sym_int_literal] = ACTIONS(2131),
    [sym_binary_literal] = ACTIONS(2131),
    [sym_octal_literal] = ACTIONS(2131),
    [sym_bigint_literal] = ACTIONS(2129),
    [sym_this] = ACTIONS(2131),
    [sym_super] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2131),
    [anon_sym_public] = ACTIONS(2131),
    [anon_sym_private] = ACTIONS(2131),
    [anon_sym_protected] = ACTIONS(2131),
    [anon_sym_boolean] = ACTIONS(2131),
    [anon_sym_string] = ACTIONS(2131),
    [anon_sym_symbol] = ACTIONS(2131),
    [sym_readonly] = ACTIONS(2131),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(994),
    [sym_identifier] = ACTIONS(996),
    [anon_sym_export] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_namespace] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_typeof] = ACTIONS(996),
    [anon_sym_type] = ACTIONS(996),
    [anon_sym_interface] = ACTIONS(996),
    [anon_sym_declare] = ACTIONS(996),
    [anon_sym_module] = ACTIONS(996),
    [anon_sym_import] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_var] = ACTIONS(996),
    [anon_sym_let] = ACTIONS(996),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_await] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_try] = ACTIONS(996),
    [anon_sym_with] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_debugger] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_throw] = ACTIONS(996),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_yield] = ACTIONS(996),
    [anon_sym_LBRACK] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(996),
    [anon_sym_function] = ACTIONS(996),
    [anon_sym_abstract] = ACTIONS(996),
    [anon_sym_get] = ACTIONS(996),
    [anon_sym_set] = ACTIONS(996),
    [anon_sym_new] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_SLASH] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_void] = ACTIONS(996),
    [anon_sym_delete] = ACTIONS(996),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(994),
    [sym_float_literal] = ACTIONS(994),
    [sym_hex_literal] = ACTIONS(996),
    [sym_int_literal] = ACTIONS(996),
    [sym_binary_literal] = ACTIONS(996),
    [sym_octal_literal] = ACTIONS(996),
    [sym_bigint_literal] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(996),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_public] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym_protected] = ACTIONS(996),
    [anon_sym_boolean] = ACTIONS(996),
    [anon_sym_string] = ACTIONS(996),
    [anon_sym_symbol] = ACTIONS(996),
    [sym_readonly] = ACTIONS(996),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2135),
    [anon_sym_export] = ACTIONS(2135),
    [anon_sym_default] = ACTIONS(2135),
    [anon_sym_namespace] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(2133),
    [anon_sym_RBRACE] = ACTIONS(2133),
    [anon_sym_typeof] = ACTIONS(2135),
    [anon_sym_type] = ACTIONS(2135),
    [anon_sym_interface] = ACTIONS(2135),
    [anon_sym_declare] = ACTIONS(2135),
    [anon_sym_module] = ACTIONS(2135),
    [anon_sym_import] = ACTIONS(2135),
    [anon_sym_const] = ACTIONS(2135),
    [anon_sym_enum] = ACTIONS(2135),
    [anon_sym_var] = ACTIONS(2135),
    [anon_sym_let] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2135),
    [anon_sym_if] = ACTIONS(2135),
    [anon_sym_switch] = ACTIONS(2135),
    [anon_sym_for] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(2133),
    [anon_sym_await] = ACTIONS(2135),
    [anon_sym_while] = ACTIONS(2135),
    [anon_sym_do] = ACTIONS(2135),
    [anon_sym_try] = ACTIONS(2135),
    [anon_sym_with] = ACTIONS(2135),
    [anon_sym_break] = ACTIONS(2135),
    [anon_sym_continue] = ACTIONS(2135),
    [anon_sym_debugger] = ACTIONS(2135),
    [anon_sym_return] = ACTIONS(2135),
    [anon_sym_throw] = ACTIONS(2135),
    [anon_sym_SEMI] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2135),
    [anon_sym_yield] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2135),
    [anon_sym_async] = ACTIONS(2135),
    [anon_sym_function] = ACTIONS(2135),
    [anon_sym_abstract] = ACTIONS(2135),
    [anon_sym_get] = ACTIONS(2135),
    [anon_sym_set] = ACTIONS(2135),
    [anon_sym_new] = ACTIONS(2135),
    [anon_sym_PLUS] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2135),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2133),
    [anon_sym_void] = ACTIONS(2135),
    [anon_sym_delete] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2133),
    [anon_sym_SQUOTE] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2133),
    [sym_float_literal] = ACTIONS(2133),
    [sym_hex_literal] = ACTIONS(2135),
    [sym_int_literal] = ACTIONS(2135),
    [sym_binary_literal] = ACTIONS(2135),
    [sym_octal_literal] = ACTIONS(2135),
    [sym_bigint_literal] = ACTIONS(2133),
    [sym_this] = ACTIONS(2135),
    [sym_super] = ACTIONS(2135),
    [sym_true] = ACTIONS(2135),
    [sym_false] = ACTIONS(2135),
    [sym_null] = ACTIONS(2135),
    [anon_sym_AT] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2135),
    [anon_sym_public] = ACTIONS(2135),
    [anon_sym_private] = ACTIONS(2135),
    [anon_sym_protected] = ACTIONS(2135),
    [anon_sym_boolean] = ACTIONS(2135),
    [anon_sym_string] = ACTIONS(2135),
    [anon_sym_symbol] = ACTIONS(2135),
    [sym_readonly] = ACTIONS(2135),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_export] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2139),
    [anon_sym_type] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2139),
    [anon_sym_declare] = ACTIONS(2139),
    [anon_sym_module] = ACTIONS(2139),
    [anon_sym_import] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2139),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_else] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_with] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_debugger] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_async] = ACTIONS(2139),
    [anon_sym_function] = ACTIONS(2139),
    [anon_sym_abstract] = ACTIONS(2139),
    [anon_sym_get] = ACTIONS(2139),
    [anon_sym_set] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_SLASH] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_float_literal] = ACTIONS(2137),
    [sym_hex_literal] = ACTIONS(2139),
    [sym_int_literal] = ACTIONS(2139),
    [sym_binary_literal] = ACTIONS(2139),
    [sym_octal_literal] = ACTIONS(2139),
    [sym_bigint_literal] = ACTIONS(2137),
    [sym_this] = ACTIONS(2139),
    [sym_super] = ACTIONS(2139),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [sym_null] = ACTIONS(2139),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_public] = ACTIONS(2139),
    [anon_sym_private] = ACTIONS(2139),
    [anon_sym_protected] = ACTIONS(2139),
    [anon_sym_boolean] = ACTIONS(2139),
    [anon_sym_string] = ACTIONS(2139),
    [anon_sym_symbol] = ACTIONS(2139),
    [sym_readonly] = ACTIONS(2139),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [650] = {
    [sym__call_signature] = STATE(3256),
    [sym_arguments] = STATE(1693),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_arguments] = STATE(1411),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_export] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_type] = ACTIONS(2143),
    [anon_sym_declare] = ACTIONS(2143),
    [anon_sym_module] = ACTIONS(2143),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1747),
    [anon_sym_of] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_function] = ACTIONS(1769),
    [anon_sym_EQ_GT] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(2143),
    [anon_sym_set] = ACTIONS(2143),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1747),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1747),
    [anon_sym_QMARK_QMARK] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_boolean] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_symbol] = ACTIONS(2143),
    [sym_readonly] = ACTIONS(2143),
    [sym__automatic_semicolon] = ACTIONS(1749),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_float_literal] = ACTIONS(2029),
    [sym_hex_literal] = ACTIONS(2031),
    [sym_int_literal] = ACTIONS(2031),
    [sym_binary_literal] = ACTIONS(2031),
    [sym_octal_literal] = ACTIONS(2031),
    [sym_bigint_literal] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_debugger] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_void] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1977),
    [sym_float_literal] = ACTIONS(1977),
    [sym_hex_literal] = ACTIONS(1979),
    [sym_int_literal] = ACTIONS(1979),
    [sym_binary_literal] = ACTIONS(1979),
    [sym_octal_literal] = ACTIONS(1979),
    [sym_bigint_literal] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [sym_null] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_boolean] = ACTIONS(1979),
    [anon_sym_string] = ACTIONS(1979),
    [anon_sym_symbol] = ACTIONS(1979),
    [sym_readonly] = ACTIONS(1979),
  },
  [655] = {
    [sym__call_signature] = STATE(3357),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_export] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1136),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1819),
    [anon_sym_declare] = ACTIONS(1819),
    [anon_sym_module] = ACTIONS(1819),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_get] = ACTIONS(1819),
    [anon_sym_set] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_implements] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1819),
    [anon_sym_public] = ACTIONS(1819),
    [anon_sym_private] = ACTIONS(1819),
    [anon_sym_protected] = ACTIONS(1819),
    [anon_sym_boolean] = ACTIONS(1819),
    [anon_sym_string] = ACTIONS(1819),
    [anon_sym_symbol] = ACTIONS(1819),
    [sym_readonly] = ACTIONS(1819),
  },
  [656] = {
    [sym__call_signature] = STATE(3187),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_export] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_declare] = ACTIONS(1745),
    [anon_sym_module] = ACTIONS(1745),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1745),
    [anon_sym_set] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_public] = ACTIONS(1745),
    [anon_sym_private] = ACTIONS(1745),
    [anon_sym_protected] = ACTIONS(1745),
    [anon_sym_boolean] = ACTIONS(1745),
    [anon_sym_string] = ACTIONS(1745),
    [anon_sym_symbol] = ACTIONS(1745),
    [sym_readonly] = ACTIONS(1745),
  },
  [657] = {
    [sym__call_signature] = STATE(3187),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_export] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(926),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_declare] = ACTIONS(1745),
    [anon_sym_module] = ACTIONS(1745),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1745),
    [anon_sym_set] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_public] = ACTIONS(1745),
    [anon_sym_private] = ACTIONS(1745),
    [anon_sym_protected] = ACTIONS(1745),
    [anon_sym_boolean] = ACTIONS(1745),
    [anon_sym_string] = ACTIONS(1745),
    [anon_sym_symbol] = ACTIONS(1745),
    [sym_readonly] = ACTIONS(1745),
  },
  [658] = {
    [sym_object] = STATE(2477),
    [sym_array] = STATE(2478),
    [sym_identifier] = ACTIONS(2150),
    [anon_sym_export] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_declare] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(806),
    [anon_sym_set] = ACTIONS(806),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_this] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_boolean] = ACTIONS(806),
    [anon_sym_string] = ACTIONS(806),
    [anon_sym_symbol] = ACTIONS(806),
    [sym_readonly] = ACTIONS(806),
  },
  [659] = {
    [sym__call_signature] = STATE(3366),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1156),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1809),
    [anon_sym_declare] = ACTIONS(1809),
    [anon_sym_module] = ACTIONS(1809),
    [anon_sym_DOT] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [anon_sym_async] = ACTIONS(1809),
    [anon_sym_function] = ACTIONS(1815),
    [anon_sym_EQ_GT] = ACTIONS(1162),
    [anon_sym_get] = ACTIONS(1809),
    [anon_sym_set] = ACTIONS(1809),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(1164),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1809),
    [anon_sym_public] = ACTIONS(1809),
    [anon_sym_private] = ACTIONS(1809),
    [anon_sym_protected] = ACTIONS(1809),
    [anon_sym_boolean] = ACTIONS(1809),
    [anon_sym_string] = ACTIONS(1809),
    [anon_sym_symbol] = ACTIONS(1809),
    [anon_sym_LBRACE_PIPE] = ACTIONS(846),
    [sym_readonly] = ACTIONS(1809),
  },
  [660] = {
    [sym__call_signature] = STATE(3187),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1743),
    [anon_sym_export] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_declare] = ACTIONS(1745),
    [anon_sym_module] = ACTIONS(1745),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1745),
    [anon_sym_set] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_public] = ACTIONS(1745),
    [anon_sym_private] = ACTIONS(1745),
    [anon_sym_protected] = ACTIONS(1745),
    [anon_sym_boolean] = ACTIONS(1745),
    [anon_sym_string] = ACTIONS(1745),
    [anon_sym_symbol] = ACTIONS(1745),
    [sym_readonly] = ACTIONS(1745),
  },
  [661] = {
    [sym__call_signature] = STATE(3296),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_export] = ACTIONS(1767),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(936),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1767),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1767),
    [anon_sym_module] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(2156),
    [anon_sym_of] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(1769),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(1767),
    [anon_sym_set] = ACTIONS(1767),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1767),
    [anon_sym_public] = ACTIONS(1767),
    [anon_sym_private] = ACTIONS(1767),
    [anon_sym_protected] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [sym_readonly] = ACTIONS(1767),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [662] = {
    [sym_object] = STATE(2477),
    [sym_array] = STATE(2478),
    [sym_identifier] = ACTIONS(2150),
    [anon_sym_export] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_declare] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(806),
    [anon_sym_set] = ACTIONS(806),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_this] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(806),
    [anon_sym_public] = ACTIONS(806),
    [anon_sym_private] = ACTIONS(806),
    [anon_sym_protected] = ACTIONS(806),
    [anon_sym_boolean] = ACTIONS(806),
    [anon_sym_string] = ACTIONS(806),
    [anon_sym_symbol] = ACTIONS(806),
    [sym_readonly] = ACTIONS(806),
  },
  [663] = {
    [sym__call_signature] = STATE(3256),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_export] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(1044),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_type] = ACTIONS(2143),
    [anon_sym_declare] = ACTIONS(2143),
    [anon_sym_module] = ACTIONS(2143),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_function] = ACTIONS(1769),
    [anon_sym_EQ_GT] = ACTIONS(1046),
    [anon_sym_get] = ACTIONS(2143),
    [anon_sym_set] = ACTIONS(2143),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_boolean] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_symbol] = ACTIONS(2143),
    [sym_readonly] = ACTIONS(2143),
    [sym__automatic_semicolon] = ACTIONS(846),
  },
  [664] = {
    [sym__call_signature] = STATE(3182),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [665] = {
    [sym__call_signature] = STATE(3182),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [666] = {
    [sym__call_signature] = STATE(3182),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [667] = {
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_declare] = ACTIONS(1680),
    [anon_sym_module] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_this] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_symbol] = ACTIONS(1680),
    [sym_readonly] = ACTIONS(1680),
  },
  [668] = {
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_declare] = ACTIONS(1680),
    [anon_sym_module] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_COLON] = ACTIONS(1919),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_of] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_EQ_GT] = ACTIONS(828),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [sym_this] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_symbol] = ACTIONS(1680),
    [sym_readonly] = ACTIONS(1680),
  },
  [669] = {
    [sym__call_signature] = STATE(3182),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_of] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [670] = {
    [sym__call_signature] = STATE(3182),
    [sym_formal_parameters] = STATE(2305),
    [sym_type_parameters] = STATE(2972),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1751),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_in] = ACTIONS(2156),
    [anon_sym_of] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_QMARK_DOT] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(836),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(846),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [671] = {
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2168),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2168),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2168),
    [anon_sym_DASH_DASH] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [anon_sym_SQUOTE] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_hex_literal] = ACTIONS(2166),
    [sym_int_literal] = ACTIONS(2166),
    [sym_binary_literal] = ACTIONS(2166),
    [sym_octal_literal] = ACTIONS(2166),
    [sym_bigint_literal] = ACTIONS(2168),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [sym_readonly] = ACTIONS(2166),
  },
  [672] = {
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_export] = ACTIONS(2170),
    [anon_sym_namespace] = ACTIONS(2170),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2170),
    [anon_sym_type] = ACTIONS(2170),
    [anon_sym_interface] = ACTIONS(2170),
    [anon_sym_declare] = ACTIONS(2170),
    [anon_sym_module] = ACTIONS(2170),
    [anon_sym_import] = ACTIONS(2170),
    [anon_sym_const] = ACTIONS(2170),
    [anon_sym_enum] = ACTIONS(2170),
    [anon_sym_var] = ACTIONS(2170),
    [anon_sym_let] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2170),
    [anon_sym_switch] = ACTIONS(2170),
    [anon_sym_for] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2170),
    [anon_sym_while] = ACTIONS(2170),
    [anon_sym_do] = ACTIONS(2170),
    [anon_sym_try] = ACTIONS(2170),
    [anon_sym_with] = ACTIONS(2170),
    [anon_sym_break] = ACTIONS(2170),
    [anon_sym_continue] = ACTIONS(2170),
    [anon_sym_debugger] = ACTIONS(2170),
    [anon_sym_return] = ACTIONS(2170),
    [anon_sym_throw] = ACTIONS(2170),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2170),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_function] = ACTIONS(2170),
    [anon_sym_abstract] = ACTIONS(2170),
    [anon_sym_get] = ACTIONS(2170),
    [anon_sym_set] = ACTIONS(2170),
    [anon_sym_new] = ACTIONS(2170),
    [anon_sym_PLUS] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2170),
    [anon_sym_SLASH] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2170),
    [anon_sym_delete] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_float_literal] = ACTIONS(2172),
    [sym_hex_literal] = ACTIONS(2170),
    [sym_int_literal] = ACTIONS(2170),
    [sym_binary_literal] = ACTIONS(2170),
    [sym_octal_literal] = ACTIONS(2170),
    [sym_bigint_literal] = ACTIONS(2172),
    [sym_this] = ACTIONS(2170),
    [sym_super] = ACTIONS(2170),
    [sym_true] = ACTIONS(2170),
    [sym_false] = ACTIONS(2170),
    [sym_null] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2170),
    [anon_sym_public] = ACTIONS(2170),
    [anon_sym_private] = ACTIONS(2170),
    [anon_sym_protected] = ACTIONS(2170),
    [anon_sym_boolean] = ACTIONS(2170),
    [anon_sym_string] = ACTIONS(2170),
    [anon_sym_symbol] = ACTIONS(2170),
    [sym_readonly] = ACTIONS(2170),
  },
  [673] = {
    [sym_identifier] = ACTIONS(2174),
    [anon_sym_export] = ACTIONS(2174),
    [anon_sym_namespace] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_typeof] = ACTIONS(2174),
    [anon_sym_type] = ACTIONS(2174),
    [anon_sym_interface] = ACTIONS(2174),
    [anon_sym_declare] = ACTIONS(2174),
    [anon_sym_module] = ACTIONS(2174),
    [anon_sym_import] = ACTIONS(2174),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_enum] = ACTIONS(2174),
    [anon_sym_var] = ACTIONS(2174),
    [anon_sym_let] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2174),
    [anon_sym_switch] = ACTIONS(2174),
    [anon_sym_for] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2176),
    [anon_sym_await] = ACTIONS(2174),
    [anon_sym_while] = ACTIONS(2174),
    [anon_sym_do] = ACTIONS(2174),
    [anon_sym_try] = ACTIONS(2174),
    [anon_sym_with] = ACTIONS(2174),
    [anon_sym_break] = ACTIONS(2174),
    [anon_sym_continue] = ACTIONS(2174),
    [anon_sym_debugger] = ACTIONS(2174),
    [anon_sym_return] = ACTIONS(2174),
    [anon_sym_throw] = ACTIONS(2174),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2174),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2174),
    [anon_sym_async] = ACTIONS(2174),
    [anon_sym_function] = ACTIONS(2174),
    [anon_sym_abstract] = ACTIONS(2174),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_void] = ACTIONS(2174),
    [anon_sym_delete] = ACTIONS(2174),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2176),
    [sym_float_literal] = ACTIONS(2176),
    [sym_hex_literal] = ACTIONS(2174),
    [sym_int_literal] = ACTIONS(2174),
    [sym_binary_literal] = ACTIONS(2174),
    [sym_octal_literal] = ACTIONS(2174),
    [sym_bigint_literal] = ACTIONS(2176),
    [sym_this] = ACTIONS(2174),
    [sym_super] = ACTIONS(2174),
    [sym_true] = ACTIONS(2174),
    [sym_false] = ACTIONS(2174),
    [sym_null] = ACTIONS(2174),
    [anon_sym_AT] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2174),
    [anon_sym_public] = ACTIONS(2174),
    [anon_sym_private] = ACTIONS(2174),
    [anon_sym_protected] = ACTIONS(2174),
    [anon_sym_boolean] = ACTIONS(2174),
    [anon_sym_string] = ACTIONS(2174),
    [anon_sym_symbol] = ACTIONS(2174),
    [sym_readonly] = ACTIONS(2174),
  },
  [674] = {
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2180),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2180),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2180),
    [anon_sym_TILDE] = ACTIONS(2180),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2180),
    [anon_sym_DASH_DASH] = ACTIONS(2180),
    [anon_sym_DQUOTE] = ACTIONS(2180),
    [anon_sym_SQUOTE] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2180),
    [sym_float_literal] = ACTIONS(2180),
    [sym_hex_literal] = ACTIONS(2178),
    [sym_int_literal] = ACTIONS(2178),
    [sym_binary_literal] = ACTIONS(2178),
    [sym_octal_literal] = ACTIONS(2178),
    [sym_bigint_literal] = ACTIONS(2180),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [sym_readonly] = ACTIONS(2178),
  },
  [675] = {
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2184),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2184),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2184),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2184),
    [anon_sym_DASH_DASH] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2184),
    [anon_sym_SQUOTE] = ACTIONS(2184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2184),
    [sym_float_literal] = ACTIONS(2184),
    [sym_hex_literal] = ACTIONS(2182),
    [sym_int_literal] = ACTIONS(2182),
    [sym_binary_literal] = ACTIONS(2182),
    [sym_octal_literal] = ACTIONS(2182),
    [sym_bigint_literal] = ACTIONS(2184),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2184),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [sym_readonly] = ACTIONS(2182),
  },
  [676] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_namespace] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2186),
    [anon_sym_type] = ACTIONS(2186),
    [anon_sym_interface] = ACTIONS(2186),
    [anon_sym_declare] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_var] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_switch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_do] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_with] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_debugger] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_throw] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2186),
    [anon_sym_async] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_get] = ACTIONS(2186),
    [anon_sym_set] = ACTIONS(2186),
    [anon_sym_new] = ACTIONS(2186),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2186),
    [anon_sym_delete] = ACTIONS(2186),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_float_literal] = ACTIONS(2188),
    [sym_hex_literal] = ACTIONS(2186),
    [sym_int_literal] = ACTIONS(2186),
    [sym_binary_literal] = ACTIONS(2186),
    [sym_octal_literal] = ACTIONS(2186),
    [sym_bigint_literal] = ACTIONS(2188),
    [sym_this] = ACTIONS(2186),
    [sym_super] = ACTIONS(2186),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [sym_null] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_public] = ACTIONS(2186),
    [anon_sym_private] = ACTIONS(2186),
    [anon_sym_protected] = ACTIONS(2186),
    [anon_sym_boolean] = ACTIONS(2186),
    [anon_sym_string] = ACTIONS(2186),
    [anon_sym_symbol] = ACTIONS(2186),
    [sym_readonly] = ACTIONS(2186),
  },
  [677] = {
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_export] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2190),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_typeof] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2190),
    [anon_sym_declare] = ACTIONS(2190),
    [anon_sym_module] = ACTIONS(2190),
    [anon_sym_import] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_var] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_switch] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_await] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_do] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [anon_sym_with] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_debugger] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_throw] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2190),
    [anon_sym_async] = ACTIONS(2190),
    [anon_sym_function] = ACTIONS(2190),
    [anon_sym_abstract] = ACTIONS(2190),
    [anon_sym_get] = ACTIONS(2190),
    [anon_sym_set] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2190),
    [anon_sym_DASH] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [anon_sym_void] = ACTIONS(2190),
    [anon_sym_delete] = ACTIONS(2190),
    [anon_sym_PLUS_PLUS] = ACTIONS(2192),
    [anon_sym_DASH_DASH] = ACTIONS(2192),
    [anon_sym_DQUOTE] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2192),
    [sym_float_literal] = ACTIONS(2192),
    [sym_hex_literal] = ACTIONS(2190),
    [sym_int_literal] = ACTIONS(2190),
    [sym_binary_literal] = ACTIONS(2190),
    [sym_octal_literal] = ACTIONS(2190),
    [sym_bigint_literal] = ACTIONS(2192),
    [sym_this] = ACTIONS(2190),
    [sym_super] = ACTIONS(2190),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [sym_null] = ACTIONS(2190),
    [anon_sym_AT] = ACTIONS(2192),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_public] = ACTIONS(2190),
    [anon_sym_private] = ACTIONS(2190),
    [anon_sym_protected] = ACTIONS(2190),
    [anon_sym_boolean] = ACTIONS(2190),
    [anon_sym_string] = ACTIONS(2190),
    [anon_sym_symbol] = ACTIONS(2190),
    [sym_readonly] = ACTIONS(2190),
  },
  [678] = {
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_export] = ACTIONS(2194),
    [anon_sym_namespace] = ACTIONS(2194),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2194),
    [anon_sym_type] = ACTIONS(2194),
    [anon_sym_interface] = ACTIONS(2194),
    [anon_sym_declare] = ACTIONS(2194),
    [anon_sym_module] = ACTIONS(2194),
    [anon_sym_import] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_var] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_switch] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_do] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [anon_sym_with] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_debugger] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_throw] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2194),
    [anon_sym_async] = ACTIONS(2194),
    [anon_sym_function] = ACTIONS(2194),
    [anon_sym_abstract] = ACTIONS(2194),
    [anon_sym_get] = ACTIONS(2194),
    [anon_sym_set] = ACTIONS(2194),
    [anon_sym_new] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2194),
    [anon_sym_delete] = ACTIONS(2194),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_float_literal] = ACTIONS(2196),
    [sym_hex_literal] = ACTIONS(2194),
    [sym_int_literal] = ACTIONS(2194),
    [sym_binary_literal] = ACTIONS(2194),
    [sym_octal_literal] = ACTIONS(2194),
    [sym_bigint_literal] = ACTIONS(2196),
    [sym_this] = ACTIONS(2194),
    [sym_super] = ACTIONS(2194),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [sym_null] = ACTIONS(2194),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_public] = ACTIONS(2194),
    [anon_sym_private] = ACTIONS(2194),
    [anon_sym_protected] = ACTIONS(2194),
    [anon_sym_boolean] = ACTIONS(2194),
    [anon_sym_string] = ACTIONS(2194),
    [anon_sym_symbol] = ACTIONS(2194),
    [sym_readonly] = ACTIONS(2194),
  },
  [679] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_export] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_typeof] = ACTIONS(2198),
    [anon_sym_type] = ACTIONS(2198),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_declare] = ACTIONS(2198),
    [anon_sym_module] = ACTIONS(2198),
    [anon_sym_import] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [anon_sym_await] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_with] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_debugger] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_async] = ACTIONS(2198),
    [anon_sym_function] = ACTIONS(2198),
    [anon_sym_abstract] = ACTIONS(2198),
    [anon_sym_get] = ACTIONS(2198),
    [anon_sym_set] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_void] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2200),
    [sym_float_literal] = ACTIONS(2200),
    [sym_hex_literal] = ACTIONS(2198),
    [sym_int_literal] = ACTIONS(2198),
    [sym_binary_literal] = ACTIONS(2198),
    [sym_octal_literal] = ACTIONS(2198),
    [sym_bigint_literal] = ACTIONS(2200),
    [sym_this] = ACTIONS(2198),
    [sym_super] = ACTIONS(2198),
    [sym_true] = ACTIONS(2198),
    [sym_false] = ACTIONS(2198),
    [sym_null] = ACTIONS(2198),
    [anon_sym_AT] = ACTIONS(2200),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_public] = ACTIONS(2198),
    [anon_sym_private] = ACTIONS(2198),
    [anon_sym_protected] = ACTIONS(2198),
    [anon_sym_boolean] = ACTIONS(2198),
    [anon_sym_string] = ACTIONS(2198),
    [anon_sym_symbol] = ACTIONS(2198),
    [sym_readonly] = ACTIONS(2198),
  },
  [680] = {
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_export] = ACTIONS(2202),
    [anon_sym_namespace] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2202),
    [anon_sym_type] = ACTIONS(2202),
    [anon_sym_interface] = ACTIONS(2202),
    [anon_sym_declare] = ACTIONS(2202),
    [anon_sym_module] = ACTIONS(2202),
    [anon_sym_import] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_var] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_with] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_debugger] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_throw] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2202),
    [anon_sym_async] = ACTIONS(2202),
    [anon_sym_function] = ACTIONS(2202),
    [anon_sym_abstract] = ACTIONS(2202),
    [anon_sym_get] = ACTIONS(2202),
    [anon_sym_set] = ACTIONS(2202),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2202),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_float_literal] = ACTIONS(2204),
    [sym_hex_literal] = ACTIONS(2202),
    [sym_int_literal] = ACTIONS(2202),
    [sym_binary_literal] = ACTIONS(2202),
    [sym_octal_literal] = ACTIONS(2202),
    [sym_bigint_literal] = ACTIONS(2204),
    [sym_this] = ACTIONS(2202),
    [sym_super] = ACTIONS(2202),
    [sym_true] = ACTIONS(2202),
    [sym_false] = ACTIONS(2202),
    [sym_null] = ACTIONS(2202),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_public] = ACTIONS(2202),
    [anon_sym_private] = ACTIONS(2202),
    [anon_sym_protected] = ACTIONS(2202),
    [anon_sym_boolean] = ACTIONS(2202),
    [anon_sym_string] = ACTIONS(2202),
    [anon_sym_symbol] = ACTIONS(2202),
    [sym_readonly] = ACTIONS(2202),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(1089), 1,
      sym_type_arguments,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1218), 1,
      sym_arguments,
    STATE(1276), 1,
      sym__module,
    ACTIONS(1749), 12,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [101] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2212), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [203] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2214), 1,
      sym_identifier,
    ACTIONS(2216), 1,
      anon_sym_DQUOTE,
    STATE(69), 1,
      sym_string,
    STATE(70), 1,
      sym_nested_identifier,
    STATE(94), 1,
      sym__module,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [305] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2212), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [407] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2214), 1,
      sym_identifier,
    ACTIONS(2216), 1,
      anon_sym_DQUOTE,
    STATE(69), 1,
      sym_string,
    STATE(70), 1,
      sym_nested_identifier,
    STATE(94), 1,
      sym__module,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [509] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2212), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [611] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(932), 1,
      sym_this,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    STATE(420), 1,
      sym__number,
    STATE(441), 1,
      sym_string,
    STATE(450), 1,
      sym__tuple_type_body,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2218), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2648), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [737] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    STATE(1411), 1,
      sym_type_arguments,
    STATE(1693), 1,
      sym_arguments,
    ACTIONS(1749), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [837] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2214), 1,
      sym_identifier,
    ACTIONS(2216), 1,
      anon_sym_DQUOTE,
    STATE(69), 1,
      sym_string,
    STATE(70), 1,
      sym_nested_identifier,
    STATE(94), 1,
      sym__module,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [939] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_EQ_GT,
    ACTIONS(1164), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    STATE(1671), 1,
      sym_type_arguments,
    STATE(1801), 1,
      sym_arguments,
    ACTIONS(1749), 9,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1038] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1138), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(1089), 1,
      sym_type_arguments,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1218), 1,
      sym_arguments,
    STATE(1276), 1,
      sym__module,
    ACTIONS(1749), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1137] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(926), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(846), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1228] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1435), 1,
      anon_sym_COLON,
    ACTIONS(2230), 1,
      sym_identifier,
    STATE(1155), 1,
      sym_string,
    STATE(1162), 1,
      sym_nested_identifier,
    STATE(1295), 1,
      sym__module,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1320] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2234), 1,
      anon_sym_export,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2240), 1,
      anon_sym_RBRACE,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_async,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2262), 1,
      anon_sym_static,
    ACTIONS(2266), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2268), 1,
      sym_readonly,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2904), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2250), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2264), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2902), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2232), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1456] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2270), 1,
      sym_identifier,
    ACTIONS(2272), 1,
      sym_this,
    ACTIONS(2274), 1,
      anon_sym_asserts,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3046), 1,
      sym_type_predicate,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2129), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [1582] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1437), 1,
      anon_sym_COLON,
    ACTIONS(2212), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1674] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1437), 1,
      anon_sym_COLON,
    ACTIONS(2214), 1,
      sym_identifier,
    ACTIONS(2216), 1,
      anon_sym_DQUOTE,
    STATE(69), 1,
      sym_string,
    STATE(70), 1,
      sym_nested_identifier,
    STATE(94), 1,
      sym__module,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1766] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1046), 1,
      anon_sym_EQ_GT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    STATE(1411), 1,
      sym_type_arguments,
    STATE(1693), 1,
      sym_arguments,
    ACTIONS(1749), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1864] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2230), 1,
      sym_identifier,
    STATE(1155), 1,
      sym_string,
    STATE(1162), 1,
      sym_nested_identifier,
    STATE(1295), 1,
      sym__module,
    ACTIONS(846), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1954] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(1835), 1,
      sym_template_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1662), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [2080] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2314), 1,
      anon_sym_export,
    ACTIONS(2316), 1,
      anon_sym_COMMA,
    ACTIONS(2318), 1,
      anon_sym_RBRACE,
    ACTIONS(2320), 1,
      anon_sym_SEMI,
    ACTIONS(2322), 1,
      anon_sym_async,
    ACTIONS(2326), 1,
      anon_sym_static,
    ACTIONS(2330), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2332), 1,
      sym_readonly,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2736), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2324), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2328), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2734), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2331), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2312), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2216] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(1708), 1,
      sym_template_string,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1549), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [2342] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2266), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2314), 1,
      anon_sym_export,
    ACTIONS(2322), 1,
      anon_sym_async,
    ACTIONS(2326), 1,
      anon_sym_static,
    ACTIONS(2332), 1,
      sym_readonly,
    ACTIONS(2370), 1,
      anon_sym_RBRACE,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2736), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2324), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2328), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2734), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2312), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2478] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2372), 1,
      sym_identifier,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2390), 1,
      sym_this,
    ACTIONS(2392), 1,
      anon_sym_asserts,
    ACTIONS(2394), 1,
      sym_readonly,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(2263), 1,
      sym_type_predicate,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2112), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [2604] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2266), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2314), 1,
      anon_sym_export,
    ACTIONS(2322), 1,
      anon_sym_async,
    ACTIONS(2326), 1,
      anon_sym_static,
    ACTIONS(2332), 1,
      sym_readonly,
    ACTIONS(2396), 1,
      anon_sym_RBRACE,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2736), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2324), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2328), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2734), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2312), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2740] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2266), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2400), 1,
      anon_sym_export,
    ACTIONS(2402), 1,
      anon_sym_RBRACE,
    ACTIONS(2404), 1,
      anon_sym_async,
    ACTIONS(2408), 1,
      anon_sym_static,
    ACTIONS(2412), 1,
      sym_readonly,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2842), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2406), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2410), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2840), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2398), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2876] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(1249), 1,
      sym_template_string,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1147), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [3002] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1435), 1,
      anon_sym_COLON,
    ACTIONS(2212), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3094] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2266), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 1,
      anon_sym_export,
    ACTIONS(2454), 1,
      anon_sym_RBRACE,
    ACTIONS(2456), 1,
      anon_sym_async,
    ACTIONS(2460), 1,
      anon_sym_static,
    ACTIONS(2464), 1,
      sym_readonly,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2759), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2458), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2462), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2755), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2450), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3230] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2266), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2400), 1,
      anon_sym_export,
    ACTIONS(2404), 1,
      anon_sym_async,
    ACTIONS(2408), 1,
      anon_sym_static,
    ACTIONS(2412), 1,
      sym_readonly,
    ACTIONS(2466), 1,
      anon_sym_RBRACE,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(2842), 1,
      aux_sym_object_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2406), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2410), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2840), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2398), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3366] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(1089), 1,
      sym_type_arguments,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1218), 1,
      sym_arguments,
    STATE(1276), 1,
      sym__module,
    ACTIONS(1749), 9,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3464] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2468), 1,
      anon_sym_GT,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [3587] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1136), 1,
      anon_sym_EQ,
    ACTIONS(1138), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(846), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3676] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [3799] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2474), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [3922] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2476), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [4045] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2478), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [4168] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(2145), 1,
      anon_sym_QMARK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(817), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(846), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4263] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2484), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4348] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2494), 1,
      sym_identifier,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2786), 1,
      sym_type_parameter,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2369), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [4471] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2496), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2707), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [4594] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2498), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [4717] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2500), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2707), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [4840] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2230), 1,
      sym_identifier,
    STATE(1155), 1,
      sym_string,
    STATE(1162), 1,
      sym_nested_identifier,
    STATE(1295), 1,
      sym__module,
    ACTIONS(2156), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4931] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2502), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2686), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5054] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2504), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5177] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2506), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5300] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2508), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2636), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5423] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2510), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2707), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5546] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2512), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5669] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2514), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5792] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2516), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [5915] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2518), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2707), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [6038] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_EQ_GT,
    ACTIONS(1164), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      sym_identifier,
    STATE(1597), 1,
      sym_nested_identifier,
    STATE(1776), 1,
      sym_string,
    STATE(1851), 1,
      sym__module,
    ACTIONS(846), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6127] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2522), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2707), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [6250] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2524), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [6373] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2526), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2707), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [6496] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2528), 1,
      anon_sym_RBRACK,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2618), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [6619] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2145), 1,
      anon_sym_QMARK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(817), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(846), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6712] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2530), 1,
      anon_sym_GT,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [6835] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(926), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2148), 1,
      anon_sym_COLON,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(846), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6926] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2079), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7046] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2688), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7166] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1472), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7286] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2700), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_extends,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_COMMA,
    ACTIONS(2541), 1,
      anon_sym_DOT,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(2545), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 15,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [7494] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1088), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7614] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2694), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7734] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1663), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7854] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2671), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7974] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2443), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8094] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(446), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8214] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2565), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 15,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [8300] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2717), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8420] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2275), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8540] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    ACTIONS(2567), 1,
      sym_this,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3284), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2733), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1678), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8660] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(441), 1,
      sym_string,
    STATE(1615), 1,
      sym__tuple_type_body,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2710), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2633), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [8900] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2622), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9020] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2261), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9140] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2145), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9260] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1112), 1,
      sym_this,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    STATE(420), 1,
      sym__number,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2095), 1,
      sym__tuple_type_body,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2692), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9380] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2643), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9500] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(489), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9620] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(446), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9740] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2358), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9860] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2632), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [9980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2012), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10100] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2369), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10220] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(846), 10,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10308] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2660), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10428] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(432), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10548] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(432), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10668] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1507), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10788] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1627), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10908] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2007), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11028] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1628), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11148] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2129), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1629), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11388] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2571), 1,
      anon_sym_DOT,
    ACTIONS(2573), 1,
      anon_sym_LT,
    STATE(2096), 1,
      sym_type_arguments,
    ACTIONS(2538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2545), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1684), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11476] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1132), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11596] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(425), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11716] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(423), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11836] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(488), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11956] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1650), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12076] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2097), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12196] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1044), 1,
      anon_sym_EQ,
    ACTIONS(1046), 1,
      anon_sym_EQ_GT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2230), 1,
      sym_identifier,
    STATE(1155), 1,
      sym_string,
    STATE(1162), 1,
      sym_nested_identifier,
    STATE(1295), 1,
      sym__module,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12284] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1521), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12404] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2318), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12524] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1520), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12644] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2161), 1,
      anon_sym_COLON,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(846), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12734] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1469), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12854] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1643), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12974] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1641), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13094] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(485), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13214] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2090), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13334] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2453), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13454] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2539), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13574] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2576), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(441), 1,
      sym_string,
    STATE(1449), 1,
      sym__tuple_type_body,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2651), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13694] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(427), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13814] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(444), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13934] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    ACTIONS(2578), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2731), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(438), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14054] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2580), 1,
      sym_identifier,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14144] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2573), 1,
      anon_sym_LT,
    ACTIONS(2582), 1,
      anon_sym_DOT,
    STATE(2096), 1,
      sym_type_arguments,
    ACTIONS(1592), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1590), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [14230] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1637), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14350] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2720), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14470] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2685), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14590] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2693), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14710] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2684), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14830] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2695), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14950] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2152), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15070] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1108), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15190] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2159), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15310] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2588), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15430] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2276), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_STAR,
    ACTIONS(2280), 1,
      anon_sym_LBRACE,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_new,
    ACTIONS(2292), 1,
      anon_sym_AMP,
    ACTIONS(2294), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym_this,
    ACTIONS(2306), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2308), 1,
      sym_readonly,
    ACTIONS(2310), 1,
      anon_sym_keyof,
    STATE(1442), 1,
      sym_nested_type_identifier,
    STATE(1721), 1,
      sym__tuple_type_body,
    STATE(1726), 1,
      sym__number,
    STATE(1738), 1,
      sym_string,
    STATE(3137), 1,
      sym_type_parameters,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(3272), 1,
      sym_formal_parameters,
    ACTIONS(2296), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2300), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1634), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2298), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2302), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1725), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15550] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_extends,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(2588), 3,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2591), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 33,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_extends,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2597), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2594), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 33,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15698] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2154), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15818] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2580), 1,
      sym_identifier,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15908] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(932), 1,
      sym_this,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    STATE(420), 1,
      sym__number,
    STATE(441), 1,
      sym_string,
    STATE(450), 1,
      sym__tuple_type_body,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2648), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16028] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1452), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16148] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1453), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    ACTIONS(2600), 1,
      sym_this,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2738), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1454), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16388] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2428), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16508] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2083), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16628] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(427), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16748] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(444), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16868] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2578), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(438), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16988] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2325), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17108] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2298), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17228] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2679), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17348] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2148), 1,
      anon_sym_COLON,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(846), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17438] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2484), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [17524] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2568), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17644] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2089), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17764] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2725), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17884] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2056), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18004] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2080), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18124] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2586), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18244] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(1089), 1,
      sym_type_arguments,
    STATE(1218), 1,
      sym_arguments,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1749), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1747), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [18330] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2726), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18450] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2602), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(441), 1,
      sym_string,
    STATE(1130), 1,
      sym__tuple_type_body,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2870), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2704), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18570] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2580), 1,
      sym_identifier,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18660] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1135), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18780] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1525), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18900] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2072), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19020] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1105), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19140] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2077), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19260] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(648), 1,
      anon_sym_AMP,
    ACTIONS(650), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_new,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(3170), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3350), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2112), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2064), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19380] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1163), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19500] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1100), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19620] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    ACTIONS(2551), 1,
      sym_identifier,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(2555), 1,
      anon_sym_QMARK,
    ACTIONS(2557), 1,
      anon_sym_new,
    ACTIONS(2559), 1,
      anon_sym_AMP,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2563), 1,
      anon_sym_keyof,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(473), 1,
      sym_nested_type_identifier,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(3381), 1,
      sym_formal_parameters,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(487), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19740] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2326), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19860] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2310), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    ACTIONS(2604), 1,
      sym_this,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3284), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2735), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1094), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20100] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1095), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20220] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2424), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_QMARK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2430), 1,
      anon_sym_AMP,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      sym_this,
    ACTIONS(2444), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2446), 1,
      sym_readonly,
    ACTIONS(2448), 1,
      anon_sym_keyof,
    STATE(1056), 1,
      sym_nested_type_identifier,
    STATE(1078), 1,
      sym_string,
    STATE(1150), 1,
      sym__number,
    STATE(1161), 1,
      sym__tuple_type_body,
    STATE(3149), 1,
      sym_type_parameters,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(3237), 1,
      sym_formal_parameters,
    ACTIONS(2434), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2438), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1101), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2436), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2440), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1153), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20340] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2334), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      anon_sym_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(2342), 1,
      anon_sym_LPAREN,
    ACTIONS(2344), 1,
      anon_sym_LBRACK,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    ACTIONS(2348), 1,
      anon_sym_new,
    ACTIONS(2350), 1,
      anon_sym_AMP,
    ACTIONS(2352), 1,
      anon_sym_PIPE,
    ACTIONS(2362), 1,
      sym_this,
    ACTIONS(2364), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2366), 1,
      sym_readonly,
    ACTIONS(2368), 1,
      anon_sym_keyof,
    STATE(1333), 1,
      sym_nested_type_identifier,
    STATE(1537), 1,
      sym_string,
    STATE(1538), 1,
      sym__number,
    STATE(1541), 1,
      sym__tuple_type_body,
    STATE(3045), 1,
      sym_type_parameters,
    STATE(3177), 1,
      sym_formal_parameters,
    STATE(3295), 1,
      sym_nested_identifier,
    ACTIONS(2354), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1487), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(2356), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2360), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(1539), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20460] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(644), 1,
      anon_sym_QMARK,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(670), 1,
      anon_sym_keyof,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(2378), 1,
      anon_sym_LPAREN,
    ACTIONS(2380), 1,
      anon_sym_LBRACK,
    ACTIONS(2394), 1,
      sym_readonly,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2606), 1,
      sym_this,
    STATE(2036), 1,
      sym_nested_type_identifier,
    STATE(2061), 1,
      sym_string,
    STATE(2062), 1,
      sym__number,
    STATE(2065), 1,
      sym__tuple_type_body,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(3284), 1,
      sym_formal_parameters,
    ACTIONS(2384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2386), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2737), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(664), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(2388), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(2088), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20580] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(425), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20700] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(423), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20820] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2702), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20940] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(462), 1,
      anon_sym_QMARK,
    ACTIONS(468), 1,
      anon_sym_AMP,
    ACTIONS(470), 1,
      anon_sym_PIPE,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(506), 1,
      anon_sym_keyof,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_new,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(924), 1,
      sym_identifier,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      sym_readonly,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2220), 1,
      anon_sym_LBRACK,
    ACTIONS(2470), 1,
      sym_this,
    STATE(420), 1,
      sym__number,
    STATE(440), 1,
      sym__tuple_type_body,
    STATE(441), 1,
      sym_string,
    STATE(1999), 1,
      sym_nested_type_identifier,
    STATE(2944), 1,
      sym_type_parameters,
    STATE(3284), 1,
      sym_formal_parameters,
    STATE(3285), 1,
      sym_nested_identifier,
    ACTIONS(842), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(850), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2013), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    ACTIONS(500), 6,
      anon_sym_void,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_int,
      anon_sym_float,
    ACTIONS(852), 6,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_true,
      sym_false,
    STATE(445), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21060] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21147] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(2608), 1,
      anon_sym_EQ,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2619), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21234] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2626), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [21319] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2628), 1,
      anon_sym_EQ,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(2634), 1,
      anon_sym_BANG,
    ACTIONS(2636), 1,
      anon_sym_in,
    ACTIONS(2639), 1,
      anon_sym_of,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    STATE(2461), 1,
      sym_type_annotation,
    STATE(2825), 1,
      sym__initializer,
    ACTIONS(2630), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1120), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 18,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21410] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    STATE(1411), 1,
      sym_type_arguments,
    STATE(1693), 1,
      sym_arguments,
    ACTIONS(1749), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2180), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21560] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(926), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2647), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1202), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(846), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2652), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21708] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(1720), 1,
      sym_arguments,
    ACTIONS(2484), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2184), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2656), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2660), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22053] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2664), 1,
      anon_sym_export,
    ACTIONS(2668), 1,
      anon_sym_async,
    ACTIONS(2672), 1,
      anon_sym_static,
    ACTIONS(2676), 1,
      sym_readonly,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2666), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2670), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(3130), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2321), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2662), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [22178] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_STAR,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2246), 1,
      anon_sym_LBRACK,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2664), 1,
      anon_sym_export,
    ACTIONS(2668), 1,
      anon_sym_async,
    ACTIONS(2672), 1,
      anon_sym_static,
    ACTIONS(2676), 1,
      sym_readonly,
    STATE(1959), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2666), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2670), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(3130), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2324), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2662), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [22303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2680), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2684), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22433] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(926), 1,
      anon_sym_EQ,
    ACTIONS(1202), 1,
      anon_sym_extends,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 1,
      anon_sym_COMMA,
    ACTIONS(2647), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(846), 15,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(813), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_QMARK_QMARK,
  [22516] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(2608), 1,
      anon_sym_EQ,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2619), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [22603] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [22690] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(2608), 1,
      anon_sym_EQ,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2619), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [22777] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1268), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1294), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(846), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [22864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2688), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22929] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_extends,
    ACTIONS(2538), 1,
      anon_sym_COMMA,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2690), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(2545), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [23016] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    STATE(1670), 1,
      sym_type_arguments,
    STATE(1793), 1,
      sym_arguments,
    ACTIONS(2484), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [23100] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(2702), 1,
      anon_sym_LBRACE,
    ACTIONS(2704), 1,
      anon_sym_COMMA,
    ACTIONS(2706), 1,
      anon_sym_DOT,
    ACTIONS(2708), 1,
      anon_sym_LT,
    ACTIONS(2711), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2637), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2750), 1,
      sym_type_arguments,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [23188] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1138), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(1089), 1,
      sym_type_arguments,
    STATE(1218), 1,
      sym_arguments,
    ACTIONS(1749), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [23272] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(2713), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [23356] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_extends,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2715), 1,
      anon_sym_EQ,
    ACTIONS(2721), 1,
      anon_sym_DOT,
    ACTIONS(2723), 1,
      anon_sym_RPAREN,
    ACTIONS(2727), 1,
      anon_sym_QMARK,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(2545), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2718), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [23446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(2591), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1072), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2588), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2584), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23518] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1435), 1,
      anon_sym_COLON,
    ACTIONS(2580), 1,
      sym_identifier,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [23598] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2730), 1,
      anon_sym_EQ,
    ACTIONS(2732), 1,
      anon_sym_DOT,
    ACTIONS(2734), 1,
      anon_sym_EQ_GT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1684), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2545), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [23682] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1437), 1,
      anon_sym_COLON,
    ACTIONS(2580), 1,
      sym_identifier,
    ACTIONS(846), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [23762] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(2163), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(846), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [23850] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2594), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(2597), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1506), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2584), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23922] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [23998] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1202), 1,
      anon_sym_extends,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 1,
      anon_sym_COMMA,
    ACTIONS(2647), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(846), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_QMARK_QMARK,
  [24080] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_extends,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2538), 1,
      anon_sym_COMMA,
    ACTIONS(2541), 1,
      anon_sym_DOT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(2738), 1,
      anon_sym_EQ_GT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(2545), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [24166] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_EQ_GT,
    ACTIONS(1164), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_LBRACK,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    STATE(1671), 1,
      sym_type_arguments,
    STATE(1801), 1,
      sym_arguments,
    ACTIONS(1749), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [24250] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(1720), 1,
      sym_arguments,
    ACTIONS(2484), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [24332] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(2738), 1,
      anon_sym_EQ_GT,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2742), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    STATE(2664), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(2711), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [24418] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_DQUOTE,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      sym_identifier,
    STATE(1115), 1,
      sym_nested_identifier,
    STATE(1133), 1,
      sym_string,
    STATE(1276), 1,
      sym__module,
    ACTIONS(2156), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(846), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [24506] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2744), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1592), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [24590] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2738), 1,
      anon_sym_EQ_GT,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2484), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [24674] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(2746), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [24758] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2730), 1,
      anon_sym_EQ,
    ACTIONS(2734), 1,
      anon_sym_EQ_GT,
    ACTIONS(2748), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [24842] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(2750), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1684), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2545), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [24926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(926), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(846), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25002] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2565), 1,
      anon_sym_DOT,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(2738), 1,
      anon_sym_EQ_GT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1592), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 16,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [25086] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_extends,
    ACTIONS(2538), 1,
      anon_sym_COMMA,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(2752), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(2545), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1120), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
  [25172] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(2706), 1,
      anon_sym_DOT,
    ACTIONS(2708), 1,
      anon_sym_LT,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    STATE(2750), 1,
      sym_type_arguments,
    ACTIONS(2756), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25255] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 1,
      anon_sym_COLON,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(1120), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25332] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    STATE(1670), 1,
      sym_type_arguments,
    STATE(1793), 1,
      sym_arguments,
    ACTIONS(2484), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1435), 1,
      anon_sym_COLON,
    ACTIONS(846), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25490] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_EQ_GT,
    ACTIONS(1164), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1202), 1,
      anon_sym_extends,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 1,
      anon_sym_COMMA,
    ACTIONS(2647), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(846), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 18,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_QMARK_QMARK,
  [25571] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2484), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25654] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2548), 1,
      anon_sym_LT,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(2738), 1,
      anon_sym_EQ_GT,
    ACTIONS(2742), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(2756), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25735] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    STATE(1089), 1,
      sym_type_arguments,
    STATE(1218), 1,
      sym_arguments,
    ACTIONS(1749), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25818] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2758), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25895] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 1,
      anon_sym_COLON,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(1120), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [25972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26039] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1437), 1,
      anon_sym_COLON,
    ACTIONS(846), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26116] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(1046), 1,
      anon_sym_EQ_GT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    STATE(1411), 1,
      sym_type_arguments,
    STATE(1693), 1,
      sym_arguments,
    ACTIONS(1749), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1747), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26199] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1044), 1,
      anon_sym_EQ,
    ACTIONS(1046), 1,
      anon_sym_EQ_GT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2647), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(846), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_QMARK_QMARK,
  [26278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(846), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26353] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1136), 1,
      anon_sym_EQ,
    ACTIONS(1138), 1,
      anon_sym_EQ_GT,
    ACTIONS(1202), 1,
      anon_sym_extends,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2644), 1,
      anon_sym_COMMA,
    ACTIONS(2647), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(846), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_QMARK_QMARK,
  [26434] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(1202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2647), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(846), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_QMARK_QMARK,
  [26513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_extends,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(2588), 3,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2591), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26584] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(1120), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26659] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2763), 1,
      anon_sym_COLON,
    ACTIONS(2760), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26738] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2734), 1,
      anon_sym_EQ_GT,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(1720), 1,
      sym_arguments,
    ACTIONS(2484), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2480), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [26894] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_extends,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2597), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2594), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 30,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26965] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2765), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27042] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1202), 1,
      anon_sym_extends,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2145), 1,
      anon_sym_QMARK,
    ACTIONS(2767), 1,
      anon_sym_RPAREN,
    ACTIONS(817), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2647), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(846), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27127] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2715), 1,
      anon_sym_EQ,
    ACTIONS(2727), 1,
      anon_sym_QMARK,
    ACTIONS(2771), 1,
      anon_sym_COLON,
    ACTIONS(2718), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27207] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(2738), 1,
      anon_sym_EQ_GT,
    ACTIONS(1120), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2688), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27343] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_COLON,
    ACTIONS(2145), 1,
      anon_sym_QMARK,
    ACTIONS(817), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(846), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2660), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27613] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_EQ,
    ACTIONS(942), 1,
      anon_sym_EQ_GT,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(2156), 1,
      anon_sym_in,
    ACTIONS(2773), 1,
      anon_sym_of,
    ACTIONS(846), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27691] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2617), 1,
      anon_sym_EQ_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      anon_sym_in,
    ACTIONS(2779), 1,
      anon_sym_of,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_extends,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(2588), 3,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2591), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2584), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 28,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [27839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2715), 1,
      anon_sym_EQ,
    ACTIONS(2727), 1,
      anon_sym_QMARK,
    ACTIONS(2718), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(1120), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2184), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_extends,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2597), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2594), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2584), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 28,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [28121] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1136), 1,
      anon_sym_EQ,
    ACTIONS(1138), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(846), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [28195] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(1072), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2588), 2,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2591), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2684), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_extends,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(2591), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2588), 3,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2584), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28397] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2145), 1,
      anon_sym_QMARK,
    ACTIONS(817), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(846), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [28475] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_EQ_GT,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(926), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2148), 1,
      anon_sym_COLON,
    ACTIONS(846), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [28551] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      anon_sym_COLON,
    ACTIONS(2784), 1,
      anon_sym_in,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [28629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2656), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28691] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_EQ_GT,
    ACTIONS(1164), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_LBRACK,
    ACTIONS(846), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 21,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [28765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 21,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [28839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2652), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28901] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(1072), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2588), 2,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2591), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 29,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2680), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29033] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2543), 1,
      anon_sym_EQ_GT,
    ACTIONS(2789), 1,
      anon_sym_COLON,
    ACTIONS(2791), 1,
      anon_sym_QMARK,
    ACTIONS(2786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1120), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [29113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2597), 1,
      anon_sym_LBRACK,
    ACTIONS(1506), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2594), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29183] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2597), 1,
      anon_sym_LBRACK,
    ACTIONS(1506), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2594), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2584), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 29,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2180), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_extends,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2597), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2594), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(2584), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      anon_sym_COLON,
    ACTIONS(2784), 1,
      anon_sym_in,
    ACTIONS(1120), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [29462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2594), 1,
      anon_sym_LT,
    ACTIONS(2597), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(2584), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 28,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29529] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(2784), 1,
      anon_sym_in,
    ACTIONS(2794), 1,
      anon_sym_COLON,
    ACTIONS(1120), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [29606] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2161), 1,
      anon_sym_COLON,
    ACTIONS(846), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [29681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [29746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2180), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [29807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2184), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [29868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2684), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [29929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2656), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [29990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_COLON,
    ACTIONS(2650), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2652), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2736), 1,
      anon_sym_EQ,
    ACTIONS(1120), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2660), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30258] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      anon_sym_in,
    ACTIONS(2779), 1,
      anon_sym_of,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30333] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2730), 1,
      anon_sym_EQ,
    ACTIONS(2734), 1,
      anon_sym_EQ_GT,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2680), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1118), 21,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2688), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2652), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30654] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      anon_sym_in,
    ACTIONS(2779), 1,
      anon_sym_of,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30723] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 1,
      anon_sym_EQ,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 21,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2652), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30916] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2148), 1,
      anon_sym_COLON,
    ACTIONS(846), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30991] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(846), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1044), 1,
      anon_sym_EQ,
    ACTIONS(1046), 1,
      anon_sym_EQ_GT,
    ACTIONS(1266), 1,
      anon_sym_DOT,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(846), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31137] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_DOT,
    ACTIONS(2594), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2597), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2584), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2586), 28,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2652), 32,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31265] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2730), 1,
      anon_sym_EQ,
    ACTIONS(1120), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 16,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_EQ,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1120), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31533] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2244), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2266), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2296), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2636), 1,
      anon_sym_in,
    ACTIONS(2639), 1,
      anon_sym_of,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(1120), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31719] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2156), 1,
      anon_sym_in,
    ACTIONS(2773), 1,
      anon_sym_of,
    ACTIONS(846), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31794] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2320), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2330), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2331), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31905] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
    ACTIONS(2776), 1,
      anon_sym_in,
    ACTIONS(2779), 1,
      anon_sym_of,
    ACTIONS(1120), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [31980] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2816), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2818), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2288), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32091] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2820), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2822), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2294), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(964), 1,
      anon_sym_EQ,
    ACTIONS(966), 1,
      anon_sym_EQ_GT,
    ACTIONS(1751), 1,
      anon_sym_DOT,
    ACTIONS(1753), 1,
      anon_sym_LBRACK,
    ACTIONS(2163), 1,
      anon_sym_in,
    ACTIONS(2824), 1,
      anon_sym_of,
    ACTIONS(846), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(836), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [32277] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2827), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2829), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2274), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32388] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2636), 1,
      anon_sym_in,
    ACTIONS(2639), 1,
      anon_sym_of,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [32454] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2636), 1,
      anon_sym_in,
    ACTIONS(2639), 1,
      anon_sym_of,
    ACTIONS(1120), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [32526] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2776), 1,
      anon_sym_in,
    ACTIONS(2779), 1,
      anon_sym_of,
    ACTIONS(1120), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [32598] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      anon_sym_in,
    ACTIONS(2779), 1,
      anon_sym_of,
    ACTIONS(1120), 13,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [32664] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2831), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32771] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2833), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32878] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2835), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32985] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2837), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33092] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2839), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33199] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2841), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33306] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2843), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33413] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2845), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33520] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2847), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33627] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2849), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33734] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2851), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33841] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2853), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33948] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2855), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34055] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2857), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34162] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2859), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34269] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_LBRACE,
    ACTIONS(2861), 1,
      anon_sym_STAR,
    ACTIONS(2863), 1,
      anon_sym_default,
    ACTIONS(2865), 1,
      anon_sym_EQ,
    ACTIONS(2867), 1,
      anon_sym_as,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym__declaration,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2713), 1,
      sym_export_clause,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [34377] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_LBRACE,
    ACTIONS(2861), 1,
      anon_sym_STAR,
    ACTIONS(2863), 1,
      anon_sym_default,
    ACTIONS(2865), 1,
      anon_sym_EQ,
    ACTIONS(2867), 1,
      anon_sym_as,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym__declaration,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2713), 1,
      sym_export_clause,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [34485] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_LBRACE,
    ACTIONS(2861), 1,
      anon_sym_STAR,
    ACTIONS(2863), 1,
      anon_sym_default,
    ACTIONS(2865), 1,
      anon_sym_EQ,
    ACTIONS(2867), 1,
      anon_sym_as,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym__declaration,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2713), 1,
      sym_export_clause,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [34593] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_LBRACE,
    ACTIONS(2861), 1,
      anon_sym_STAR,
    ACTIONS(2863), 1,
      anon_sym_default,
    ACTIONS(2865), 1,
      anon_sym_EQ,
    ACTIONS(2867), 1,
      anon_sym_as,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym__declaration,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2713), 1,
      sym_export_clause,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [34701] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2899), 1,
      sym_identifier,
    ACTIONS(2901), 1,
      anon_sym_STAR,
    ACTIONS(2905), 1,
      anon_sym_LBRACE,
    STATE(2990), 1,
      sym_import_clause,
    ACTIONS(2909), 2,
      anon_sym_typeof,
      anon_sym_type,
    STATE(2991), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3327), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(2903), 14,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(2907), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34772] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2321), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34875] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_LBRACE,
    ACTIONS(2861), 1,
      anon_sym_STAR,
    ACTIONS(2863), 1,
      anon_sym_default,
    ACTIONS(2867), 1,
      anon_sym_as,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    ACTIONS(2911), 1,
      anon_sym_EQ,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym__declaration,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2713), 1,
      sym_export_clause,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [34980] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1254), 1,
      anon_sym_LBRACE,
    ACTIONS(2861), 1,
      anon_sym_STAR,
    ACTIONS(2863), 1,
      anon_sym_default,
    ACTIONS(2865), 1,
      anon_sym_EQ,
    ACTIONS(2867), 1,
      anon_sym_as,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym__declaration,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2713), 1,
      sym_export_clause,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [35087] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2267), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35190] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2258), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35293] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2549), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35396] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2286), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35499] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2252), 1,
      anon_sym_new,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2800), 1,
      anon_sym_export,
    ACTIONS(2802), 1,
      anon_sym_STAR,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(2806), 1,
      anon_sym_async,
    ACTIONS(2810), 1,
      anon_sym_static,
    ACTIONS(2814), 1,
      sym_readonly,
    STATE(1963), 1,
      sym_accessibility_modifier,
    STATE(1993), 1,
      sym_decorator,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2512), 1,
      sym__call_signature,
    STATE(2656), 1,
      aux_sym_export_statement_repeat1,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2808), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2324), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2798), 8,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35602] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2480), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2918), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2920), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [35778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2922), 1,
      anon_sym_EQ,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2480), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35846] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2924), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2926), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1096), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [35960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_extends,
    ACTIONS(2934), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2937), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2930), 10,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(2932), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_EQ,
    ACTIONS(2940), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_DOT,
    STATE(1107), 1,
      sym_type_arguments,
    ACTIONS(1592), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36127] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2210), 1,
      anon_sym_LT,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    STATE(1109), 1,
      sym_type_arguments,
    STATE(1223), 1,
      sym_arguments,
    ACTIONS(2480), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_DOT,
    ACTIONS(2946), 1,
      anon_sym_LT,
    STATE(1107), 1,
      sym_type_arguments,
    ACTIONS(1686), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1684), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1634), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(950), 10,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(952), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_LT,
    STATE(1068), 1,
      sym_type_arguments,
    ACTIONS(1699), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1697), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1068), 1,
      sym_type_arguments,
    ACTIONS(1588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1586), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_DOT,
    STATE(1107), 1,
      sym_type_arguments,
    ACTIONS(1695), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1693), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36467] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2956), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36559] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2984), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36651] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2986), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1586), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36893] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2988), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36985] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2994), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1520), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1512), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37257] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(2999), 1,
      anon_sym_RBRACE,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_static,
    ACTIONS(3011), 1,
      sym_readonly,
    STATE(1960), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3005), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3009), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2805), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(2997), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3015), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37397] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3019), 1,
      anon_sym_RBRACE,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1516), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1202), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3031), 1,
      sym__automatic_semicolon,
    ACTIONS(970), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37637] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3037), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1612), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37755] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3037), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37825] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3040), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37917] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3042), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1550), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38059] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1131), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38147] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3050), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1604), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1574), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1578), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    STATE(1232), 1,
      sym_arguments,
    ACTIONS(3052), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3054), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_LT,
    ACTIONS(1074), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1072), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1560), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1584), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1582), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1538), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_DOT,
    ACTIONS(1508), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1506), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 1,
      anon_sym_LBRACK,
    ACTIONS(1600), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1598), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38803] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(3063), 1,
      anon_sym_RBRACE,
    ACTIONS(3065), 1,
      anon_sym_async,
    ACTIONS(3069), 1,
      anon_sym_static,
    ACTIONS(3073), 1,
      sym_readonly,
    STATE(1960), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2904), 1,
      aux_sym_object_repeat1,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3067), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3071), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2902), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3061), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2932), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38943] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3037), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39013] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_extends,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_extends,
    ACTIONS(3083), 1,
      anon_sym_AMP,
    ACTIONS(3085), 1,
      anon_sym_PIPE,
    ACTIONS(1741), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1739), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1562), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39181] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(3089), 1,
      anon_sym_RBRACE,
    ACTIONS(3091), 1,
      anon_sym_async,
    ACTIONS(3095), 1,
      anon_sym_static,
    ACTIONS(3099), 1,
      sym_readonly,
    STATE(1960), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2736), 1,
      aux_sym_object_repeat1,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3093), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3097), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2734), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3087), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39271] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3101), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1570), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1546), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1594), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1528), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    STATE(1231), 1,
      sym_arguments,
    ACTIONS(3103), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3105), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1566), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39717] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2990), 1,
      anon_sym_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [39805] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3107), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1073), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_extends,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3109), 1,
      anon_sym_COMMA,
    ACTIONS(3112), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39955] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3115), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1166), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    ACTIONS(3119), 1,
      anon_sym_DOT,
    STATE(1228), 1,
      sym_statement_block,
    ACTIONS(958), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1524), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40149] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3121), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_DOT,
    ACTIONS(1592), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40341] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3123), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40433] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3125), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40525] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3127), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2796), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40667] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3134), 1,
      anon_sym_STAR,
    ACTIONS(3137), 1,
      anon_sym_RBRACE,
    ACTIONS(3139), 1,
      anon_sym_LBRACK,
    ACTIONS(3142), 1,
      anon_sym_async,
    ACTIONS(3145), 1,
      anon_sym_abstract,
    ACTIONS(3151), 1,
      anon_sym_DASH,
    ACTIONS(3154), 1,
      anon_sym_DQUOTE,
    ACTIONS(3163), 1,
      anon_sym_AT,
    ACTIONS(3166), 1,
      anon_sym_static,
    ACTIONS(3172), 1,
      sym_readonly,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(3148), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3157), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3169), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3160), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(3131), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40805] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2994), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40875] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2990), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [40959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3175), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1096), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41111] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3181), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_AMP,
    ACTIONS(3085), 1,
      anon_sym_PIPE,
    ACTIONS(1721), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1719), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1228), 1,
      sym_statement_block,
    ACTIONS(958), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41307] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3183), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_extends,
    ACTIONS(3083), 1,
      anon_sym_AMP,
    ACTIONS(3085), 1,
      anon_sym_PIPE,
    ACTIONS(1737), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1735), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41455] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [41535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3187), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41585] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 7,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41661] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3189), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41803] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1117), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41891] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3037), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42061] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_extends,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3197), 1,
      anon_sym_COMMA,
    ACTIONS(3200), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42123] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3205), 4,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_extends,
    ACTIONS(3083), 1,
      anon_sym_AMP,
    ACTIONS(3085), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3209), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42273] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(3213), 1,
      anon_sym_RBRACE,
    ACTIONS(3215), 1,
      anon_sym_async,
    ACTIONS(3219), 1,
      anon_sym_static,
    ACTIONS(3223), 1,
      sym_readonly,
    STATE(1960), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2842), 1,
      aux_sym_object_repeat1,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3217), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3221), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2840), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3211), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42363] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3225), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1157), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1534), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42551] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3227), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1154), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1624), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42691] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3229), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1373), 1,
      sym_statement_block,
    ACTIONS(958), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1558), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42883] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3233), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [42971] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(3237), 1,
      anon_sym_RBRACE,
    ACTIONS(3239), 1,
      anon_sym_async,
    ACTIONS(3243), 1,
      anon_sym_static,
    ACTIONS(3247), 1,
      sym_readonly,
    STATE(1960), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2759), 1,
      aux_sym_object_repeat1,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3241), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3245), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2755), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3235), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3251), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1616), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1608), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    ACTIONS(3253), 1,
      anon_sym_DOT,
    STATE(1373), 1,
      sym_statement_block,
    ACTIONS(958), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1554), 30,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43317] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3255), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43409] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3257), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43501] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2254), 1,
      anon_sym_DASH,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2804), 1,
      anon_sym_LBRACK,
    ACTIONS(3017), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_async,
    ACTIONS(3023), 1,
      anon_sym_abstract,
    ACTIONS(3027), 1,
      anon_sym_static,
    ACTIONS(3029), 1,
      sym_readonly,
    ACTIONS(3259), 1,
      anon_sym_RBRACE,
    STATE(1912), 1,
      sym_method_definition,
    STATE(1957), 1,
      sym_accessibility_modifier,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3025), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1124), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2812), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(2844), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2798), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2934), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1542), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2930), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2932), 21,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3046), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43742] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3267), 1,
      anon_sym_COMMA,
    ACTIONS(3270), 1,
      anon_sym_RBRACE,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3101), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43837] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3300), 1,
      anon_sym_COMMA,
    ACTIONS(3303), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2956), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43932] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3305), 1,
      anon_sym_COMMA,
    ACTIONS(3308), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3257), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44027] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(3310), 1,
      anon_sym_EQ,
    ACTIONS(3314), 1,
      anon_sym_in,
    ACTIONS(3317), 1,
      anon_sym_of,
    STATE(2467), 1,
      sym_type_annotation,
    STATE(2827), 1,
      sym__initializer,
    ACTIONS(3312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44096] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(3320), 1,
      anon_sym_EQ,
    ACTIONS(3324), 1,
      anon_sym_in,
    ACTIONS(3327), 1,
      anon_sym_of,
    STATE(2469), 1,
      sym_type_annotation,
    STATE(2828), 1,
      sym__initializer,
    ACTIONS(3322), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44165] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2990), 1,
      anon_sym_QMARK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44252] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3308), 1,
      anon_sym_RBRACE,
    ACTIONS(3330), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3335), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3339), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3343), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3349), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3351), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3353), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44641] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44732] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3042), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44823] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2956), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44914] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3127), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45005] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3101), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45096] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(3357), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(3397), 1,
      sym_type_annotation,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3361), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3365), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45291] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3367), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45360] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2990), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [45443] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [45522] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 7,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45597] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3367), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1072), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3189), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45808] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3257), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3372), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45948] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2704), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3378), 1,
      anon_sym_LBRACE,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3408), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2638), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3412), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46094] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3183), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3416), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46234] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(3265), 1,
      sym_type_annotation,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1068), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3125), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46471] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3046), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2907), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46611] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2984), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46702] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3123), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46793] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(3422), 1,
      anon_sym_async,
    ACTIONS(3426), 1,
      anon_sym_static,
    ACTIONS(3430), 1,
      sym_readonly,
    STATE(1960), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym__number_lit,
    STATE(3216), 1,
      sym_array,
    STATE(3223), 1,
      sym_object,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2666), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3424), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3428), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    STATE(3130), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3420), 9,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3432), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3434), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46976] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3436), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2719), 1,
      sym_type_arguments,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2918), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2920), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3440), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3442), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3444), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3448), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3452), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3456), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1072), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1140), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47616] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3464), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [47685] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3464), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [47754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3468), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3472), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3476), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3480), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3484), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3488), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1082), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1056), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1058), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3492), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1130), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1132), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48293] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3500), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [48366] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [48437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1106), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1090), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1092), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3504), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48682] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2986), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3209), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48969] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3500), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1632), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(950), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 21,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49095] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [49166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3510), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49215] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2672), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3408), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3538), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49359] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3540), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49428] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(3543), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(3314), 1,
      sym_type_annotation,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49525] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3464), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [49594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3547), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3042), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    STATE(2719), 1,
      sym_type_arguments,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2924), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2926), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3553), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49849] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3540), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49918] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3540), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49987] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3500), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50060] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [50131] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(3555), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(3212), 1,
      sym_type_annotation,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50228] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3255), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3559), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2984), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50417] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2988), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3565), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1122), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50655] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3464), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [50724] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2922), 1,
      anon_sym_EQ,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(1720), 1,
      sym_arguments,
    ACTIONS(2480), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50789] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3500), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50862] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [50933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1144), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50982] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(1720), 1,
      sym_arguments,
    ACTIONS(2480), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51047] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3540), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51114] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(3567), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(3236), 1,
      sym_type_annotation,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3571), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3575), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51309] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3577), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [51379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_extends,
    ACTIONS(2934), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2937), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2930), 10,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(2932), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51433] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(2990), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2992), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51519] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3580), 1,
      anon_sym_COMMA,
    ACTIONS(3582), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2867), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51661] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3584), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51751] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3101), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51843] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3588), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(2956), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1122), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3050), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3251), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52079] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3590), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52147] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3593), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [52215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3596), 1,
      sym__automatic_semicolon,
    ACTIONS(970), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52265] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3598), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3257), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52405] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3600), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2861), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52499] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52591] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [52655] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3112), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1697), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52715] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3590), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52781] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3593), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [52849] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3606), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(2986), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52941] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2224), 1,
      anon_sym_LT,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    STATE(1412), 1,
      sym_type_arguments,
    STATE(1720), 1,
      sym_arguments,
    ACTIONS(2480), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53003] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2988), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53093] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3608), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53185] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3504), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3189), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53277] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2986), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53367] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3590), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_DOT,
    ACTIONS(3612), 1,
      anon_sym_LT,
    STATE(1450), 1,
      sym_type_arguments,
    ACTIONS(1686), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1684), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53489] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3590), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53557] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(2988), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53649] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3549), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3042), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53741] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3617), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3255), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53833] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3580), 1,
      anon_sym_COMMA,
    ACTIONS(3619), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2867), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53927] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3584), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54017] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3621), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2927), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54111] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3464), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54179] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3500), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1140), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54349] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54419] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3625), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2841), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2932), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54561] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3627), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2893), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54655] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3629), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3040), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3631), 1,
      anon_sym_LT,
    STATE(1439), 1,
      sym_type_arguments,
    ACTIONS(1699), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1697), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54799] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3634), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2753), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54893] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3636), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3638), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55033] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3636), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3205), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55125] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3636), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3640), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55217] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3642), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3187), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55333] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3636), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3645), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55425] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2922), 1,
      anon_sym_EQ,
    STATE(1670), 1,
      sym_type_arguments,
    STATE(1793), 1,
      sym_arguments,
    ACTIONS(2480), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [55489] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3647), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2929), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55583] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3649), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_async,
    ACTIONS(3653), 1,
      anon_sym_abstract,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3655), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2018), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [55651] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 8,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [55725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1144), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55773] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3657), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2867), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55867] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    STATE(1670), 1,
      sym_type_arguments,
    STATE(1793), 1,
      sym_arguments,
    ACTIONS(2480), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [55931] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3593), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [55997] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3183), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 1,
      sym__automatic_semicolon,
    ACTIONS(946), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(950), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56139] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56229] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2984), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56319] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3046), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56409] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3125), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56499] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [56577] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3127), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56667] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [56731] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3255), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56821] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56911] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3257), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57001] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3189), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57091] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3642), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [57161] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 7,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [57235] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [57313] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3659), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57403] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2990), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 7,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [57485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2796), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57533] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3042), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57623] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3604), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3661), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57865] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3663), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57921] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3261), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3046), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3175), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58063] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3345), 1,
      anon_sym_LBRACE,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3127), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58155] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_STAR,
    ACTIONS(3667), 1,
      anon_sym_async,
    ACTIONS(3669), 1,
      anon_sym_abstract,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3671), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3015), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58271] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3561), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(2984), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58363] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3593), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [58431] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    STATE(2711), 1,
      sym_type_arguments,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2924), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2926), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [58489] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3506), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3123), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58581] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3673), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2841), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58675] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3376), 1,
      anon_sym_as,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    ACTIONS(3404), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3675), 1,
      anon_sym_LBRACE,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3125), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      sym_regex_flags,
    ACTIONS(3677), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3679), 24,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_DOT,
    STATE(1450), 1,
      sym_type_arguments,
    ACTIONS(1592), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      sym_type_arguments,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2918), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2920), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [58921] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3078), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1604), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58981] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3400), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3402), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3374), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3382), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3384), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3685), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2774), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59157] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2956), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_DOT,
    STATE(1450), 1,
      sym_type_arguments,
    ACTIONS(1695), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1693), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1439), 1,
      sym_type_arguments,
    ACTIONS(1588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1586), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1634), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(950), 10,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(952), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59401] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59465] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3584), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59555] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3687), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2867), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59649] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(3380), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3577), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(3406), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [59717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3689), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2867), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3197), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3200), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1612), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59871] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3518), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    ACTIONS(3534), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3101), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59961] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3584), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60051] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3691), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    STATE(2820), 1,
      aux_sym_array_repeat1,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60145] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60209] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2990), 1,
      anon_sym_QMARK,
    ACTIONS(3520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3526), 1,
      anon_sym_AMP,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3532), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3512), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3524), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3514), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 5,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_QMARK_QMARK,
    ACTIONS(3516), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60295] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3278), 1,
      anon_sym_QMARK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3294), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3284), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3263), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3286), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3584), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3274), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3276), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60385] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3189), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60474] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3717), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60565] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3719), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    STATE(1740), 1,
      sym_arguments,
    ACTIONS(3052), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3054), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    STATE(1748), 1,
      sym_arguments,
    ACTIONS(3103), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3105), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60758] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3721), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60849] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3723), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60940] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3725), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 1,
      sym_regex_flags,
    ACTIONS(3677), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3679), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_LBRACK,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2937), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2930), 10,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(2932), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_LBRACK,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2937), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2930), 10,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(2932), 23,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_LT,
    ACTIONS(1074), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1072), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61235] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3729), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3731), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2311), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [61298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_EQ,
    ACTIONS(3623), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1108), 1,
      sym__automatic_semicolon,
    ACTIONS(1100), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1104), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1106), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61400] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3733), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61491] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3123), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61580] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3735), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3737), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2299), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [61643] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2984), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61732] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3127), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61821] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3046), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1659), 1,
      sym_type_arguments,
    ACTIONS(1588), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1586), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_DOT,
    STATE(1657), 1,
      sym_type_arguments,
    ACTIONS(1695), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1693), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62010] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3741), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_DOT,
    STATE(1657), 1,
      sym_type_arguments,
    ACTIONS(1592), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_DOT,
    ACTIONS(3745), 1,
      anon_sym_LT,
    STATE(1657), 1,
      sym_type_arguments,
    ACTIONS(1686), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1684), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62205] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3748), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62272] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3751), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      sym__automatic_semicolon,
    ACTIONS(1126), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1130), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1132), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62414] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3757), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2017), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1616), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1520), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1516), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 1,
      sym__automatic_semicolon,
    ACTIONS(1086), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1090), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1092), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 1,
      anon_sym_LT,
    STATE(1659), 1,
      sym_type_arguments,
    ACTIONS(1699), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1697), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62722] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3127), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3175), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1586), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62907] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_extends,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2727), 1,
      anon_sym_QMARK,
    ACTIONS(3786), 1,
      anon_sym_EQ,
    ACTIONS(3788), 1,
      anon_sym_RPAREN,
    ACTIONS(2718), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3112), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62972] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3748), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63039] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3792), 1,
      anon_sym_STAR,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2030), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1528), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1570), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1562), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_LBRACK,
    ACTIONS(1600), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1598), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63437] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3802), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63528] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3804), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_DOT,
    ACTIONS(1592), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63715] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3806), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3808), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2301), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63778] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3729), 1,
      anon_sym_STAR,
    ACTIONS(3810), 1,
      anon_sym_async,
    ACTIONS(3814), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3812), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2033), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63892] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3729), 1,
      anon_sym_STAR,
    ACTIONS(3810), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3812), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2033), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64004] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3816), 1,
      anon_sym_SEMI,
    ACTIONS(3818), 1,
      sym__automatic_semicolon,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64095] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3046), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64231] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3820), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2366), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [64294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_extends,
    ACTIONS(3824), 1,
      anon_sym_AMP,
    ACTIONS(3826), 1,
      anon_sym_PIPE,
    ACTIONS(1737), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1735), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64347] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3792), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2278), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [64410] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3830), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64501] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_extends,
    ACTIONS(3824), 1,
      anon_sym_AMP,
    ACTIONS(3826), 1,
      anon_sym_PIPE,
    ACTIONS(1741), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1739), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_extends,
    ACTIONS(2934), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2937), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2930), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2932), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1634), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(950), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(952), 22,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 1,
      sym__automatic_semicolon,
    ACTIONS(984), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(988), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1538), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1512), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64803] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2986), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1632), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(950), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64943] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3659), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65032] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_extends,
    ACTIONS(2934), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2937), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2930), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(2932), 22,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65085] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_STAR,
    ACTIONS(3667), 1,
      anon_sym_async,
    ACTIONS(3832), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3671), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3834), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2297), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1594), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 1,
      sym__automatic_semicolon,
    ACTIONS(1034), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1038), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1604), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_DOT,
    ACTIONS(1508), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1506), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65505] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2988), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65594] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3792), 1,
      anon_sym_STAR,
    ACTIONS(3794), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2030), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1560), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1584), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1582), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65710] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3748), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65775] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3748), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65842] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3308), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65931] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_extends,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym__automatic_semicolon,
    ACTIONS(1062), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1066), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1068), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66041] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3836), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66132] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66221] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3649), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_async,
    ACTIONS(3838), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3655), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2018), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66288] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66377] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3840), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1524), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66513] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3303), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66602] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3842), 1,
      anon_sym_RBRACE,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66693] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3844), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1578), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1574), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1550), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66903] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3183), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66992] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3257), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67081] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3123), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67280] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 7,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 1,
      sym__automatic_semicolon,
    ACTIONS(1024), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1028), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1566), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67451] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3851), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67542] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2984), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1546), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1554), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67725] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3649), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3655), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2018), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67790] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3649), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2279), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 1,
      sym__automatic_semicolon,
    ACTIONS(1008), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1012), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 1,
      anon_sym_AMP,
    ACTIONS(3826), 1,
      anon_sym_PIPE,
    ACTIONS(1721), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1719), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67955] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [68032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1558), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68079] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3855), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68170] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3255), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68259] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2228), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    STATE(1670), 1,
      sym_type_arguments,
    STATE(1793), 1,
      sym_arguments,
    ACTIONS(2480), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2484), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68320] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3806), 1,
      anon_sym_STAR,
    ACTIONS(3857), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1006), 1,
      sym__automatic_semicolon,
    ACTIONS(998), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1002), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68483] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2990), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68564] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3844), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [68631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1202), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1612), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1534), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1624), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68821] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3863), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2347), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1608), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68931] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3735), 1,
      anon_sym_STAR,
    ACTIONS(3865), 1,
      anon_sym_async,
    ACTIONS(3869), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3867), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2032), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68998] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3040), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69087] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3871), 1,
      anon_sym_SEMI,
    ACTIONS(3873), 1,
      sym__automatic_semicolon,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69178] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3735), 1,
      anon_sym_STAR,
    ACTIONS(3865), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3867), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2032), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69243] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3042), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69332] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_extends,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3197), 1,
      anon_sym_COMMA,
    ACTIONS(3200), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_extends,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3109), 1,
      anon_sym_COMMA,
    ACTIONS(3112), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_extends,
    ACTIONS(3824), 1,
      anon_sym_AMP,
    ACTIONS(3826), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3209), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_EQ,
    ACTIONS(3875), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69554] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69617] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2956), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69706] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3101), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69795] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2990), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2992), 4,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69880] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3877), 1,
      anon_sym_STAR,
    ACTIONS(3879), 1,
      anon_sym_async,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3881), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69945] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3883), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70034] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3885), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 17,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70101] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2990), 1,
      anon_sym_QMARK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2992), 4,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70186] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3101), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70275] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2990), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 6,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70356] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3888), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70447] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 7,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [70524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3890), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2365), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70587] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3894), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70654] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3894), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70719] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2990), 7,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2992), 13,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70792] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3897), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70883] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2988), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70972] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2956), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71061] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2986), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71150] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3042), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71239] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3894), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71306] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3885), 1,
      anon_sym_LT,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2990), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2992), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71375] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3899), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3901), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2302), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71438] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71527] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3894), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(3035), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71594] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3125), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71683] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3903), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71774] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3905), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71865] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3907), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3877), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3909), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2367), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72019] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3189), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1084), 1,
      sym__automatic_semicolon,
    ACTIONS(1076), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1080), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1082), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1060), 1,
      sym__automatic_semicolon,
    ACTIONS(1052), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1056), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1058), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72210] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(3265), 1,
      anon_sym_as,
    ACTIONS(3272), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3699), 1,
      anon_sym_QMARK,
    ACTIONS(3701), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3707), 1,
      anon_sym_AMP,
    ACTIONS(3709), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(3040), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3298), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3703), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3693), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3705), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3695), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3697), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72299] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3911), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72390] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3913), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72481] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3915), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72572] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_COLON,
    ACTIONS(3919), 1,
      anon_sym_LPAREN,
    ACTIONS(3922), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(3129), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(2796), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72625] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3925), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72714] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3257), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72803] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3927), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72894] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(2964), 1,
      anon_sym_QMARK,
    ACTIONS(2966), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2972), 1,
      anon_sym_AMP,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2978), 1,
      anon_sym_LT,
    ACTIONS(2980), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3203), 1,
      anon_sym_COMMA,
    ACTIONS(3929), 1,
      anon_sym_RPAREN,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2968), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2952), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2970), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2960), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(2962), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72985] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3255), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(982), 1,
      sym__automatic_semicolon,
    ACTIONS(974), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3442), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3444), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3931), 1,
      anon_sym_LBRACE,
    ACTIONS(3933), 1,
      anon_sym_DOT,
    STATE(1850), 1,
      sym_statement_block,
    ACTIONS(958), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3935), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1612), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3200), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73333] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2843), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73455] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2843), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73575] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73663] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_COLON,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3078), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73721] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2843), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73793] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73865] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73939] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3251), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74109] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3947), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74163] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3949), 1,
      anon_sym_COLON,
    ACTIONS(3951), 1,
      anon_sym_LPAREN,
    ACTIONS(3954), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2907), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1570), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74405] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(3963), 1,
      anon_sym_COLON,
    ACTIONS(3965), 1,
      anon_sym_QMARK,
    ACTIONS(3960), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74465] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3968), 1,
      anon_sym_EQ,
    ACTIONS(3974), 1,
      anon_sym_COLON,
    ACTIONS(3976), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74525] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2727), 1,
      anon_sym_QMARK,
    ACTIONS(2771), 1,
      anon_sym_COLON,
    ACTIONS(3786), 1,
      anon_sym_EQ,
    ACTIONS(2718), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3187), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3979), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1616), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74731] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3968), 1,
      anon_sym_EQ,
    ACTIONS(3976), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74881] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3981), 1,
      anon_sym_extends,
    ACTIONS(3983), 1,
      anon_sym_AMP,
    ACTIONS(3985), 1,
      anon_sym_PIPE,
    ACTIONS(1737), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1735), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1546), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1554), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75025] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(3965), 1,
      anon_sym_QMARK,
    ACTIONS(3960), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1558), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1550), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1574), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1578), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1560), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1584), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1582), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1538), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3981), 1,
      anon_sym_extends,
    ACTIONS(3983), 1,
      anon_sym_AMP,
    ACTIONS(3985), 1,
      anon_sym_PIPE,
    ACTIONS(1741), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1739), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75415] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3372), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1594), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1566), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_AMP,
    ACTIONS(3985), 1,
      anon_sym_PIPE,
    ACTIONS(1721), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1719), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3365), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3361), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2727), 1,
      anon_sym_QMARK,
    ACTIONS(3786), 1,
      anon_sym_EQ,
    ACTIONS(2718), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3349), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1562), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76049] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3987), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3339), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76229] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1697), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3112), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3351), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3353), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1612), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3200), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1528), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1516), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1520), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1096), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76571] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3981), 1,
      anon_sym_extends,
    ACTIONS(3983), 1,
      anon_sym_AMP,
    ACTIONS(3985), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3209), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76739] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 1,
      anon_sym_extends,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3109), 1,
      anon_sym_COMMA,
    ACTIONS(3112), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76797] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1586), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76917] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76989] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3989), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      sym_regex_flags,
    ACTIONS(3677), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_implements,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3679), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    STATE(1856), 1,
      sym_arguments,
    ACTIONS(3103), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3105), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    STATE(1848), 1,
      sym_arguments,
    ACTIONS(3052), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3054), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2302), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77283] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2299), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1524), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1512), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77433] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    ACTIONS(3991), 1,
      anon_sym_in,
    ACTIONS(3994), 1,
      anon_sym_of,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77491] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_in,
    ACTIONS(4000), 1,
      anon_sym_of,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_LBRACK,
    ACTIONS(1600), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1598), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77597] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3875), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_extends,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3197), 1,
      anon_sym_COMMA,
    ACTIONS(3200), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77775] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77849] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77919] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_extends,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2297), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1680), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3412), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3416), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_DOT,
    ACTIONS(1592), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3432), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3434), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3440), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_DOT,
    ACTIONS(1508), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1506), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1068), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2796), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_LT,
    ACTIONS(1074), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT,
    ACTIONS(1072), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78687] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2301), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78745] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2311), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3468), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78849] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3484), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78967] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3488), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3504), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3209), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79225] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(952), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79341] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4005), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3547), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 1,
      sym__automatic_semicolon,
    ACTIONS(970), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3015), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3042), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3553), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1604), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3050), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3456), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1608), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79845] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4009), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79933] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2279), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3559), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1624), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1534), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4011), 1,
      anon_sym_EQ,
    ACTIONS(1118), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4013), 1,
      anon_sym_EQ,
    ACTIONS(1118), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80285] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2271), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2140), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3575), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3046), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3565), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2984), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3492), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1612), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1202), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3480), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1106), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2347), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3175), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1090), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1092), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81059] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2278), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3476), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81255] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_extends,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3197), 1,
      anon_sym_RPAREN,
    ACTIONS(3200), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3472), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81359] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1697), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3112), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1118), 9,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2365), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81473] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3343), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3510), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3538), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81699] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4017), 1,
      anon_sym_COLON,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3335), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3448), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3452), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81925] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2367), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1082), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1056), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1058), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym_regex_flags,
    ACTIONS(3677), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3679), 21,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82123] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2366), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82181] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2121), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2798), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82285] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4021), 1,
      anon_sym_RBRACK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2932), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82419] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_extends,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_RPAREN,
    ACTIONS(3078), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1118), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82477] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2356), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3571), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1130), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1132), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3931), 1,
      anon_sym_LBRACE,
    STATE(1850), 1,
      sym_statement_block,
    ACTIONS(958), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(956), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3504), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2984), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82813] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2843), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3468), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3372), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3339), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2907), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83148] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4023), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1144), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3547), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83305] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4023), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3042), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3456), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83560] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3538), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3349), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3351), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3353), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83760] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4023), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3442), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3444), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3553), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3440), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3559), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84005] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2622), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4027), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3575), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3432), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3434), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3046), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84291] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3565), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3484), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3335), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84477] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2616), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1181), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84658] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3416), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84756] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2922), 1,
      anon_sym_EQ,
    ACTIONS(1118), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 21,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1072), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3412), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1068), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1106), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1090), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1092), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1002), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85265] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(2692), 1,
      anon_sym_DOT,
    ACTIONS(2694), 1,
      anon_sym_LBRACK,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3388), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2711), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1796), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3510), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85395] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_DOT,
    ACTIONS(2615), 1,
      anon_sym_LBRACK,
    ACTIONS(2954), 1,
      anon_sym_as,
    ACTIONS(2958), 1,
      anon_sym_BANG,
    ACTIONS(3280), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3768), 1,
      anon_sym_QMARK,
    ACTIONS(3770), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3776), 1,
      anon_sym_AMP,
    ACTIONS(3778), 1,
      anon_sym_PIPE,
    ACTIONS(3780), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3782), 1,
      anon_sym_LT,
    ACTIONS(3784), 1,
      anon_sym_QMARK_QMARK,
    STATE(2719), 1,
      sym_type_arguments,
    ACTIONS(2982), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3772), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1649), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3774), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(3766), 6,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85480] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3492), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3177), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3209), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3571), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1040), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1130), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1132), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1056), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1058), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1082), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3361), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3365), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(968), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3488), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3452), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3448), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1140), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3480), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3343), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1122), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86400] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86465] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 1,
      anon_sym_DOT,
    ACTIONS(4035), 1,
      anon_sym_LPAREN,
    STATE(1870), 1,
      sym_arguments,
    ACTIONS(4031), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4029), 25,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86516] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3476), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3472), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4037), 26,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86766] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4023), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(3324), 1,
      anon_sym_in,
    ACTIONS(3327), 1,
      anon_sym_of,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86931] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2922), 1,
      anon_sym_EQ,
    ACTIONS(3991), 1,
      anon_sym_in,
    ACTIONS(3994), 1,
      anon_sym_of,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86986] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_in,
    ACTIONS(4000), 1,
      anon_sym_of,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87041] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2490), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2922), 1,
      anon_sym_EQ,
    ACTIONS(3314), 1,
      anon_sym_in,
    ACTIONS(3317), 1,
      anon_sym_of,
    ACTIONS(1118), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1120), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4029), 25,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87190] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(3333), 25,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(3175), 25,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4041), 25,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(3536), 25,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87410] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    STATE(2843), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87566] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2879), 1,
      anon_sym_module,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    ACTIONS(4045), 1,
      anon_sym_default,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2592), 1,
      sym__declaration,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [87645] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      anon_sym_EQ_GT,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87700] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4051), 1,
      anon_sym_RPAREN,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87771] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4057), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87842] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4059), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87913] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4061), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87984] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4063), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88055] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4065), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88126] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4067), 1,
      anon_sym_class,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    STATE(2835), 1,
      sym_rest_parameter,
    STATE(2836), 1,
      sym_required_parameter,
    STATE(2851), 1,
      sym_optional_parameter,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88201] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4069), 1,
      anon_sym_RPAREN,
    STATE(1931), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2811), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88272] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 1,
      anon_sym_STAR,
    ACTIONS(4073), 1,
      anon_sym_async,
    ACTIONS(4077), 1,
      sym_readonly,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4075), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 13,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88333] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4079), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88404] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1252), 1,
      anon_sym_namespace,
    ACTIONS(1258), 1,
      anon_sym_type,
    ACTIONS(1260), 1,
      anon_sym_interface,
    ACTIONS(1262), 1,
      anon_sym_declare,
    ACTIONS(1264), 1,
      anon_sym_module,
    ACTIONS(1271), 1,
      anon_sym_import,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1275), 1,
      anon_sym_enum,
    ACTIONS(1277), 1,
      anon_sym_var,
    ACTIONS(1279), 1,
      anon_sym_let,
    ACTIONS(1286), 1,
      anon_sym_class,
    ACTIONS(1288), 1,
      anon_sym_async,
    ACTIONS(1290), 1,
      anon_sym_function,
    ACTIONS(1292), 1,
      anon_sym_abstract,
    ACTIONS(4081), 1,
      anon_sym_default,
    STATE(585), 1,
      sym_internal_module,
    STATE(648), 1,
      sym__declaration,
    STATE(1993), 1,
      sym_decorator,
    STATE(2515), 1,
      aux_sym_export_statement_repeat1,
    STATE(553), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [88483] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1252), 1,
      anon_sym_namespace,
    ACTIONS(1258), 1,
      anon_sym_type,
    ACTIONS(1260), 1,
      anon_sym_interface,
    ACTIONS(1262), 1,
      anon_sym_declare,
    ACTIONS(1271), 1,
      anon_sym_import,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1275), 1,
      anon_sym_enum,
    ACTIONS(1277), 1,
      anon_sym_var,
    ACTIONS(1279), 1,
      anon_sym_let,
    ACTIONS(1286), 1,
      anon_sym_class,
    ACTIONS(1288), 1,
      anon_sym_async,
    ACTIONS(1290), 1,
      anon_sym_function,
    ACTIONS(1292), 1,
      anon_sym_abstract,
    ACTIONS(1349), 1,
      anon_sym_global,
    ACTIONS(1351), 1,
      anon_sym_module,
    STATE(585), 1,
      sym_internal_module,
    STATE(615), 1,
      sym__declaration,
    STATE(1993), 1,
      sym_decorator,
    STATE(2515), 1,
      aux_sym_export_statement_repeat1,
    STATE(553), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [88562] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4083), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88633] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88704] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4087), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88775] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(448), 1,
      anon_sym_RPAREN,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    STATE(1938), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2772), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88846] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4089), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88917] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4091), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4093), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2339), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88974] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(4023), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1682), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1680), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89021] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4095), 1,
      anon_sym_STAR,
    ACTIONS(4097), 1,
      anon_sym_async,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4099), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2330), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89080] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4095), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4099), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2330), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89137] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4101), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89208] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1252), 1,
      anon_sym_namespace,
    ACTIONS(1258), 1,
      anon_sym_type,
    ACTIONS(1260), 1,
      anon_sym_interface,
    ACTIONS(1271), 1,
      anon_sym_import,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1275), 1,
      anon_sym_enum,
    ACTIONS(1277), 1,
      anon_sym_var,
    ACTIONS(1279), 1,
      anon_sym_let,
    ACTIONS(1286), 1,
      anon_sym_class,
    ACTIONS(1288), 1,
      anon_sym_async,
    ACTIONS(1290), 1,
      anon_sym_function,
    ACTIONS(1292), 1,
      anon_sym_abstract,
    ACTIONS(1349), 1,
      anon_sym_global,
    ACTIONS(1433), 1,
      anon_sym_declare,
    ACTIONS(1532), 1,
      anon_sym_module,
    STATE(585), 1,
      sym_internal_module,
    STATE(615), 1,
      sym__declaration,
    STATE(1993), 1,
      sym_decorator,
    STATE(2515), 1,
      aux_sym_export_statement_repeat1,
    STATE(553), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [89287] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4103), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89358] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 1,
      anon_sym_STAR,
    ACTIONS(4073), 1,
      anon_sym_async,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4075), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89417] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4105), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89488] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89559] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4075), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89616] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    ACTIONS(4109), 1,
      anon_sym_RPAREN,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89687] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2869), 1,
      anon_sym_namespace,
    ACTIONS(2873), 1,
      anon_sym_type,
    ACTIONS(2875), 1,
      anon_sym_interface,
    ACTIONS(2877), 1,
      anon_sym_declare,
    ACTIONS(2881), 1,
      anon_sym_import,
    ACTIONS(2883), 1,
      anon_sym_const,
    ACTIONS(2885), 1,
      anon_sym_enum,
    ACTIONS(2887), 1,
      anon_sym_var,
    ACTIONS(2889), 1,
      anon_sym_let,
    ACTIONS(2891), 1,
      anon_sym_class,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_function,
    ACTIONS(2897), 1,
      anon_sym_abstract,
    ACTIONS(4111), 1,
      anon_sym_global,
    ACTIONS(4113), 1,
      anon_sym_module,
    STATE(1993), 1,
      sym_decorator,
    STATE(2410), 1,
      aux_sym_export_statement_repeat1,
    STATE(2543), 1,
      sym_internal_module,
    STATE(2544), 1,
      sym__declaration,
    STATE(2534), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [89766] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1252), 1,
      anon_sym_namespace,
    ACTIONS(1258), 1,
      anon_sym_type,
    ACTIONS(1260), 1,
      anon_sym_interface,
    ACTIONS(1264), 1,
      anon_sym_module,
    ACTIONS(1271), 1,
      anon_sym_import,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1275), 1,
      anon_sym_enum,
    ACTIONS(1277), 1,
      anon_sym_var,
    ACTIONS(1279), 1,
      anon_sym_let,
    ACTIONS(1286), 1,
      anon_sym_class,
    ACTIONS(1288), 1,
      anon_sym_async,
    ACTIONS(1290), 1,
      anon_sym_function,
    ACTIONS(1292), 1,
      anon_sym_abstract,
    ACTIONS(1433), 1,
      anon_sym_declare,
    ACTIONS(4081), 1,
      anon_sym_default,
    STATE(585), 1,
      sym_internal_module,
    STATE(648), 1,
      sym__declaration,
    STATE(1993), 1,
      sym_decorator,
    STATE(2515), 1,
      aux_sym_export_statement_repeat1,
    STATE(553), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [89845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4115), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2301), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4119), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2365), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4125), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4123), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90071] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2279), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90123] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4129), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90215] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2330), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4133), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4137), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4141), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4145), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 1,
      sym__automatic_semicolon,
    ACTIONS(946), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(948), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(1142), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2347), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4141), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4151), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4155), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90681] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2366), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90733] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2315), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90837] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2278), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90889] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    STATE(2858), 1,
      sym_optional_parameter,
    STATE(2859), 1,
      sym_rest_parameter,
    STATE(2860), 1,
      sym_required_parameter,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90961] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2299), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4159), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4115), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4163), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4167), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91173] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    STATE(2981), 1,
      sym_optional_parameter,
    STATE(3131), 1,
      sym_required_parameter,
    STATE(3133), 1,
      sym_rest_parameter,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91245] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    STATE(2835), 1,
      sym_rest_parameter,
    STATE(2836), 1,
      sym_required_parameter,
    STATE(2851), 1,
      sym_optional_parameter,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91317] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2302), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4163), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4167), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2304), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91501] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2339), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91553] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2367), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4145), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 1,
      sym__automatic_semicolon,
    ACTIONS(968), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(970), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91687] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4055), 1,
      sym_readonly,
    STATE(1937), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    STATE(1994), 1,
      sym_accessibility_modifier,
    STATE(2179), 1,
      sym__parameter_name,
    STATE(2483), 1,
      sym_object,
    STATE(2484), 1,
      sym_array,
    STATE(2701), 1,
      sym__rest_identifier,
    ACTIONS(4049), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1672), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3024), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1662), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(970), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2322), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4159), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4173), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(3128), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2668), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91940] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4175), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(3128), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2668), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91993] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4177), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(3128), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2668), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92046] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4179), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2922), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2608), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92099] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4181), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(2885), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2573), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92152] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(4183), 1,
      anon_sym_RBRACE,
    STATE(2226), 1,
      sym__number_lit,
    STATE(3128), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2668), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92205] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_STAR,
    ACTIONS(3667), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_abstract,
    ACTIONS(4187), 1,
      anon_sym_static,
    ACTIONS(4189), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3671), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(4191), 1,
      anon_sym_STAR,
    ACTIONS(4195), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4193), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2021), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92320] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3458), 1,
      anon_sym_STAR,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3496), 1,
      anon_sym_async,
    ACTIONS(3500), 1,
      sym_readonly,
    ACTIONS(4197), 1,
      anon_sym_static,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2028), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92378] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(1654), 1,
      anon_sym_async,
    ACTIONS(1658), 1,
      sym_readonly,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(4199), 1,
      anon_sym_static,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1656), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92436] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    STATE(3128), 1,
      sym_enum_assignment,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2668), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92486] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(4201), 1,
      anon_sym_STAR,
    ACTIONS(4205), 1,
      sym_readonly,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4203), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92540] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    ACTIONS(3729), 1,
      anon_sym_STAR,
    ACTIONS(3810), 1,
      anon_sym_async,
    ACTIONS(3814), 1,
      sym_readonly,
    ACTIONS(4207), 1,
      anon_sym_static,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(3812), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2033), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      sym_float_literal,
      sym_bigint_literal,
      anon_sym_AT,
    ACTIONS(4209), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_DASH,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2366), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92683] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2295), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2347), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2279), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92824] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2356), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2365), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92918] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2330), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93012] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2370), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93059] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2299), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93153] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2278), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93200] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2297), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93247] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2301), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93294] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2315), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2140), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93388] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2302), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93435] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2304), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93482] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2271), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2367), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93576] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2339), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93623] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2322), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93670] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(3462), 1,
      anon_sym_LBRACK,
    STATE(2226), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2311), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(1652), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3494), 1,
      anon_sym_LBRACK,
    STATE(2068), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    STATE(2121), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
    ACTIONS(2798), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93764] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    STATE(2578), 1,
      sym_array,
    STATE(2585), 1,
      sym_object,
    ACTIONS(4211), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(4213), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    STATE(2477), 1,
      sym_object,
    STATE(2478), 1,
      sym_array,
    ACTIONS(2150), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1919), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(806), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4219), 1,
      anon_sym_AT,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
    ACTIONS(4217), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4215), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1682), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1919), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(1680), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(4222), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      sym_readonly,
    STATE(2477), 1,
      sym_object,
    STATE(2478), 1,
      sym_array,
    ACTIONS(2150), 2,
      sym_identifier,
      sym_this,
    ACTIONS(806), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_EQ,
    ACTIONS(4228), 1,
      anon_sym_DOT,
    ACTIONS(4230), 1,
      anon_sym_LT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1590), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94033] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_EQ,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4232), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1684), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 1,
      anon_sym_EQ,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4232), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1693), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4234), 1,
      sym_identifier,
    STATE(3229), 1,
      sym_mapped_type_clause,
    ACTIONS(4236), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      anon_sym_EQ,
    ACTIONS(4230), 1,
      anon_sym_LT,
    STATE(416), 1,
      sym_type_arguments,
    ACTIONS(1697), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(4230), 1,
      anon_sym_LT,
    STATE(416), 1,
      sym_type_arguments,
    ACTIONS(1586), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LT,
    ACTIONS(1072), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 1,
      anon_sym_PIPE,
    ACTIONS(1018), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [94234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 1,
      anon_sym_PIPE,
    ACTIONS(1096), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [94258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 1,
      anon_sym_PIPE,
    ACTIONS(1604), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [94282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_EQ,
    ACTIONS(4228), 1,
      anon_sym_DOT,
    ACTIONS(1590), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [94308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_EQ,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(1719), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_GT,
  [94356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4244), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 1,
      anon_sym_EQ,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(1739), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_GT,
  [94469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_EQ,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(1735), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_GT,
  [94498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_PIPE,
    ACTIONS(4256), 1,
      anon_sym_DOT,
    ACTIONS(4258), 1,
      anon_sym_LT,
    STATE(2096), 1,
      sym_type_arguments,
    ACTIONS(1590), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [94547] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4264), 1,
      anon_sym_BANG,
    ACTIONS(4266), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2508), 1,
      sym_type_annotation,
    STATE(2524), 1,
      sym__call_signature,
    STATE(2854), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4262), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94589] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4270), 1,
      anon_sym_BANG,
    ACTIONS(4272), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2380), 1,
      sym__call_signature,
    STATE(2383), 1,
      sym_type_annotation,
    STATE(2777), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4268), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94631] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4276), 1,
      anon_sym_BANG,
    ACTIONS(4278), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2416), 1,
      sym__call_signature,
    STATE(2434), 1,
      sym_type_annotation,
    STATE(2804), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4274), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94673] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_LT,
    ACTIONS(4280), 1,
      anon_sym_DOT,
    STATE(2096), 1,
      sym_type_arguments,
    ACTIONS(1684), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [94701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_LT,
    ACTIONS(4280), 1,
      anon_sym_DOT,
    ACTIONS(4282), 1,
      anon_sym_is,
    STATE(2096), 1,
      sym_type_arguments,
    ACTIONS(1684), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [94731] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4276), 1,
      anon_sym_BANG,
    ACTIONS(4284), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2434), 1,
      sym_type_annotation,
    STATE(2793), 1,
      sym__initializer,
    STATE(2794), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4274), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1695), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_LT,
    ACTIONS(4280), 1,
      anon_sym_DOT,
    STATE(2096), 1,
      sym_type_arguments,
    ACTIONS(1693), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [94801] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_BANG,
    ACTIONS(4290), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2602), 1,
      sym_type_annotation,
    STATE(2932), 1,
      sym__initializer,
    STATE(2942), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4286), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94843] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_BANG,
    ACTIONS(4292), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2601), 1,
      sym__call_signature,
    STATE(2602), 1,
      sym_type_annotation,
    STATE(2936), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4286), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94885] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2449), 1,
      sym_type_annotation,
    STATE(2452), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4294), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_LT,
    STATE(2087), 1,
      sym_type_arguments,
    ACTIONS(1586), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [94945] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4298), 1,
      anon_sym_COLON,
    ACTIONS(4300), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2255), 1,
      sym__call_signature,
    STATE(2449), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4294), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94980] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4304), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2235), 1,
      sym__call_signature,
    STATE(2372), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4302), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95015] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4308), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2206), 1,
      sym__call_signature,
    STATE(2373), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4306), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95050] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4312), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2403), 1,
      sym_type_annotation,
    STATE(2404), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_PIPE,
    ACTIONS(1506), 1,
      anon_sym_LT,
    ACTIONS(1072), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95108] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4314), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2219), 1,
      sym__call_signature,
    STATE(2403), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95143] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4316), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2372), 1,
      sym_type_annotation,
    STATE(2500), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4302), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95178] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4232), 1,
      anon_sym_DOT,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    ACTIONS(4323), 1,
      anon_sym_COLON,
    ACTIONS(4325), 1,
      anon_sym_extends,
    STATE(418), 1,
      sym_type_arguments,
    STATE(2649), 1,
      sym_constraint,
    STATE(3074), 1,
      sym_default_type,
    ACTIONS(4320), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(1684), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [95215] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4328), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2373), 1,
      sym_type_annotation,
    STATE(2374), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4306), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_LT,
    STATE(2087), 1,
      sym_type_arguments,
    ACTIONS(1697), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_DOT,
    ACTIONS(1508), 1,
      anon_sym_PIPE,
    ACTIONS(1506), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [95298] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2218), 1,
      sym__call_signature,
    STATE(2401), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95330] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2389), 1,
      sym__call_signature,
    STATE(2550), 1,
      sym_type_annotation,
    STATE(2782), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4332), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95366] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2234), 1,
      sym__call_signature,
    STATE(2545), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95398] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2401), 1,
      sym_type_annotation,
    STATE(2402), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2415), 1,
      sym__call_signature,
    STATE(2430), 1,
      sym_type_annotation,
    STATE(2802), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95466] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2458), 1,
      sym_type_annotation,
    STATE(2460), 1,
      sym__call_signature,
    STATE(2761), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95502] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2550), 1,
      sym_type_annotation,
    STATE(2778), 1,
      sym__initializer,
    STATE(2779), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4332), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95538] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2545), 1,
      sym_type_annotation,
    STATE(2547), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95570] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2375), 1,
      sym_type_annotation,
    STATE(2376), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4340), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95602] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2203), 1,
      sym__call_signature,
    STATE(2422), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95634] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2591), 1,
      sym__call_signature,
    STATE(2596), 1,
      sym_type_annotation,
    STATE(2941), 1,
      sym__initializer,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4344), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2207), 1,
      sym__call_signature,
    STATE(2375), 1,
      sym_type_annotation,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4340), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95702] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2422), 1,
      sym_type_annotation,
    STATE(2471), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95734] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2430), 1,
      sym_type_annotation,
    STATE(2787), 1,
      sym__initializer,
    STATE(2808), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
    ACTIONS(4336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95770] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4232), 1,
      anon_sym_DOT,
    ACTIONS(4346), 1,
      anon_sym_RPAREN,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1684), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2771), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_PIPE,
    ACTIONS(4256), 1,
      anon_sym_DOT,
    ACTIONS(1590), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4232), 1,
      anon_sym_DOT,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1684), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4349), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [95846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [95867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_PIPE,
    ACTIONS(1620), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [95903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [95924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 1,
      anon_sym_PIPE,
    ACTIONS(1636), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 1,
      anon_sym_PIPE,
    ACTIONS(1202), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 1,
      anon_sym_PIPE,
    ACTIONS(1612), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [95981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_PIPE,
    ACTIONS(1534), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 1,
      anon_sym_PIPE,
    ACTIONS(1516), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 1,
      anon_sym_PIPE,
    ACTIONS(4351), 1,
      anon_sym_LBRACK,
    ACTIONS(1624), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_PIPE,
    ACTIONS(1608), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [96076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 1,
      anon_sym_PIPE,
    ACTIONS(1512), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [96112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 1,
      anon_sym_PIPE,
    ACTIONS(4282), 1,
      anon_sym_is,
    ACTIONS(1697), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 1,
      anon_sym_PIPE,
    ACTIONS(1616), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [96173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(1719), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 1,
      anon_sym_PIPE,
    ACTIONS(1640), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      anon_sym_PIPE,
    ACTIONS(1648), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_PIPE,
    ACTIONS(1632), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      anon_sym_PIPE,
    ACTIONS(1566), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(1735), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [96293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_PIPE,
    ACTIONS(1590), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_PIPE,
    ACTIONS(1546), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 1,
      anon_sym_PIPE,
    ACTIONS(1554), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 1,
      anon_sym_PIPE,
    ACTIONS(1558), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [96390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 1,
      anon_sym_PIPE,
    ACTIONS(1628), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 1,
      anon_sym_PIPE,
    ACTIONS(1594), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1542), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 1,
      anon_sym_PIPE,
    ACTIONS(1524), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 1,
      anon_sym_PIPE,
    ACTIONS(1520), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 1,
      anon_sym_PIPE,
    ACTIONS(4351), 1,
      anon_sym_LBRACK,
    ACTIONS(1598), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_PIPE,
    ACTIONS(1562), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(1739), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [96548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 1,
      anon_sym_PIPE,
    ACTIONS(1538), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      anon_sym_PIPE,
    ACTIONS(1570), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 1,
      anon_sym_PIPE,
    ACTIONS(1558), 3,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
    ACTIONS(1582), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_PIPE,
    ACTIONS(1586), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_PIPE,
    ACTIONS(1644), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 1,
      anon_sym_PIPE,
    ACTIONS(1528), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_PIPE,
    ACTIONS(1578), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_PIPE,
    ACTIONS(1550), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_PIPE,
    ACTIONS(1574), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [96721] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4361), 1,
      sym_identifier,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    STATE(1639), 1,
      sym_class_body,
    STATE(2175), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3028), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [96755] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4369), 1,
      sym_identifier,
    STATE(1639), 1,
      sym_class_body,
    STATE(2175), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3028), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [96789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_EQ,
    ACTIONS(3917), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [96807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4232), 1,
      anon_sym_DOT,
    ACTIONS(4371), 1,
      anon_sym_is,
    STATE(418), 1,
      sym_type_arguments,
    ACTIONS(1684), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [96831] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4373), 1,
      sym_identifier,
    STATE(1717), 1,
      sym_class_body,
    STATE(2233), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3041), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [96865] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4375), 1,
      sym_identifier,
    STATE(1717), 1,
      sym_class_body,
    STATE(2233), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3041), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [96899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2871), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [96919] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4377), 1,
      sym_identifier,
    STATE(1717), 1,
      sym_class_body,
    STATE(2233), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3041), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [96953] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4379), 1,
      sym_identifier,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1800), 1,
      sym_class_body,
    STATE(2186), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3107), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [96987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4385), 1,
      anon_sym_COLON,
    STATE(2262), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
    ACTIONS(4383), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97007] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4387), 1,
      sym_identifier,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1199), 1,
      sym_class_body,
    STATE(2181), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3161), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97041] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4391), 1,
      sym_identifier,
    STATE(1781), 1,
      sym_class_body,
    STATE(2168), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2961), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4393), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97097] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4395), 1,
      sym_identifier,
    STATE(1264), 1,
      sym_class_body,
    STATE(2247), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3040), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97131] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4397), 1,
      sym_identifier,
    STATE(1639), 1,
      sym_class_body,
    STATE(2175), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3028), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4385), 1,
      anon_sym_COLON,
    STATE(2264), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
    ACTIONS(4399), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    ACTIONS(1697), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2771), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97204] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1275), 1,
      sym_class_body,
    STATE(2251), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3025), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97235] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1837), 1,
      sym_class_body,
    STATE(2196), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3164), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97266] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_class_body,
    STATE(2228), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3067), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97297] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2256), 1,
      sym_type_parameters,
    STATE(2557), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2964), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2383), 1,
      sym_type_annotation,
    STATE(2780), 1,
      sym__initializer,
    ACTIONS(4270), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4268), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97353] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1486), 1,
      sym_class_body,
    STATE(2246), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2946), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97384] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_class_body,
    STATE(2177), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2989), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97415] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1775), 1,
      sym_class_body,
    STATE(2187), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3120), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97446] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2243), 1,
      sym_type_parameters,
    STATE(2520), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3001), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97477] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(80), 1,
      sym_class_body,
    STATE(2230), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3124), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1260), 1,
      sym_class_body,
    STATE(2238), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3047), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [97556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4414), 1,
      anon_sym_EQ,
    ACTIONS(4393), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [97579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4416), 1,
      sym_identifier,
    ACTIONS(4418), 1,
      anon_sym_RBRACK,
    STATE(2866), 1,
      sym__rest_identifier,
    STATE(2934), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2652), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [97604] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2225), 1,
      sym_type_parameters,
    STATE(2462), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3085), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97635] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1805), 1,
      sym_class_body,
    STATE(2189), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3115), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(952), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [97683] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(2905), 1,
      anon_sym_LBRACE,
    ACTIONS(4420), 1,
      sym_identifier,
    ACTIONS(4422), 1,
      anon_sym_STAR,
    STATE(3060), 1,
      sym_import_clause,
    STATE(3173), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3327), 2,
      sym_namespace_import,
      sym_named_imports,
  [97710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4349), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [97727] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1186), 1,
      anon_sym_RBRACK,
    ACTIONS(4416), 1,
      sym_identifier,
    STATE(2866), 1,
      sym__rest_identifier,
    STATE(2868), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2652), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [97752] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1727), 1,
      sym_class_body,
    STATE(2254), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2999), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97783] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(81), 1,
      sym_class_body,
    STATE(2182), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2949), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1632), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [97831] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2434), 1,
      sym_type_annotation,
    STATE(2814), 1,
      sym__initializer,
    ACTIONS(4276), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4274), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_RPAREN,
    ACTIONS(1542), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2932), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97875] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(566), 1,
      sym_class_body,
    STATE(2199), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3140), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [97906] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4416), 1,
      sym_identifier,
    ACTIONS(4424), 1,
      anon_sym_RBRACK,
    STATE(2866), 1,
      sym__rest_identifier,
    STATE(2874), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2652), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [97931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1200), 1,
      anon_sym_RBRACK,
    ACTIONS(4416), 1,
      sym_identifier,
    STATE(2866), 1,
      sym__rest_identifier,
    STATE(2784), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2652), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [97956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4426), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4428), 1,
      anon_sym_RPAREN,
    ACTIONS(1202), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1919), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97996] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2248), 1,
      sym_type_parameters,
    STATE(2533), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3029), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98027] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1516), 1,
      sym_class_body,
    STATE(2224), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3104), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4416), 1,
      sym_identifier,
    ACTIONS(4431), 1,
      anon_sym_RBRACK,
    STATE(2866), 1,
      sym__rest_identifier,
    STATE(2862), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2652), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [98083] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_class_body,
    STATE(2250), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3022), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    STATE(2864), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [98136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4433), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1305), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2803), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [98178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(1729), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1256), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2924), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [98220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4416), 1,
      sym_identifier,
    STATE(2866), 1,
      sym__rest_identifier,
    STATE(3049), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2652), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [98242] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    ACTIONS(4435), 1,
      anon_sym_BANG,
    STATE(2461), 1,
      sym_type_annotation,
    STATE(2825), 1,
      sym__initializer,
    ACTIONS(2630), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1325), 1,
      anon_sym_RBRACE,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    STATE(2768), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [98288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4437), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    ACTIONS(4441), 1,
      anon_sym_DOT,
    STATE(2589), 1,
      sym_statement_block,
    ACTIONS(956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
    STATE(2843), 1,
      aux_sym_object_repeat1,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [98350] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2596), 1,
      sym_type_annotation,
    STATE(2921), 1,
      sym__initializer,
    ACTIONS(4344), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98371] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      sym_identifier,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4447), 1,
      anon_sym_enum,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2698), 1,
      sym_variable_declarator,
  [98396] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4451), 1,
      sym_identifier,
    ACTIONS(4453), 1,
      anon_sym_STAR,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3052), 1,
      sym__call_signature,
  [98421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      sym_identifier,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    ACTIONS(4457), 1,
      anon_sym_enum,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2681), 1,
      sym_variable_declarator,
  [98446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(429), 1,
      sym__number_lit,
    ACTIONS(1498), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(1500), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
  [98463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2092), 1,
      sym__number_lit,
    ACTIONS(2258), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(2260), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
  [98480] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1817), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3026), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98518] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2458), 1,
      sym_type_annotation,
    STATE(2766), 1,
      sym__initializer,
    ACTIONS(4338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(4023), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2871), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [98556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4461), 1,
      sym_identifier,
    ACTIONS(4463), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3052), 1,
      sym__call_signature,
  [98581] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4465), 1,
      sym_identifier,
    ACTIONS(4467), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3105), 1,
      sym__call_signature,
  [98606] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4469), 1,
      sym_identifier,
    ACTIONS(4471), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3105), 1,
      sym__call_signature,
  [98631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1688), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3121), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98656] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(4473), 1,
      anon_sym_extends,
    ACTIONS(4475), 1,
      anon_sym_LT,
    STATE(2493), 1,
      sym_type_parameters,
    STATE(2563), 1,
      sym_object_type,
    STATE(2852), 1,
      sym_extends_clause,
  [98681] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3094), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4477), 1,
      sym_identifier,
    ACTIONS(4479), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3105), 1,
      sym__call_signature,
  [98731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    STATE(2669), 1,
      sym_type_annotation,
    STATE(3145), 1,
      sym__initializer,
    ACTIONS(4483), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [98754] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2550), 1,
      sym_type_annotation,
    STATE(2789), 1,
      sym__initializer,
    ACTIONS(4332), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98775] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1203), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3102), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98800] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(91), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2943), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98825] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4487), 1,
      sym_identifier,
    ACTIONS(4489), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3030), 1,
      sym__call_signature,
  [98850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2469), 1,
      sym_type_annotation,
    STATE(2828), 1,
      sym__initializer,
    ACTIONS(3322), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1845), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3160), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1741), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3117), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1839), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3168), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [98972] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4493), 1,
      sym_identifier,
    ACTIONS(4495), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(2973), 1,
      sym__call_signature,
  [98997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99010] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym_type_annotation,
    STATE(2827), 1,
      sym__initializer,
    ACTIONS(3312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2560), 1,
      sym_type_annotation,
    ACTIONS(4497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1451), 1,
      sym__number_lit,
    ACTIONS(4499), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4501), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
  [99065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    STATE(2589), 1,
      sym_statement_block,
    ACTIONS(956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1824), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3155), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(4473), 1,
      anon_sym_extends,
    ACTIONS(4475), 1,
      anon_sym_LT,
    STATE(582), 1,
      sym_object_type,
    STATE(2437), 1,
      sym_type_parameters,
    STATE(2817), 1,
      sym_extends_clause,
  [99132] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4503), 1,
      sym_identifier,
    ACTIONS(4505), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3052), 1,
      sym__call_signature,
  [99157] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(596), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3004), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3077), 1,
      sym_statement_block,
    ACTIONS(4507), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2984), 1,
      sym_statement_block,
    ACTIONS(4509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2987), 1,
      sym_statement_block,
    ACTIONS(4511), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2951), 1,
      sym_statement_block,
    ACTIONS(4513), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3006), 1,
      sym_statement_block,
    ACTIONS(4515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2979), 1,
      sym_statement_block,
    ACTIONS(4513), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2952), 1,
      sym_statement_block,
    ACTIONS(4517), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2953), 1,
      sym_statement_block,
    ACTIONS(4519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_statement_block,
    ACTIONS(4517), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    STATE(2649), 1,
      sym_constraint,
    STATE(3074), 1,
      sym_default_type,
    ACTIONS(4323), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(4521), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [99356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3076), 1,
      sym_statement_block,
    ACTIONS(4519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4527), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2963), 1,
      sym_statement_block,
    ACTIONS(4529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2965), 1,
      sym_statement_block,
    ACTIONS(4531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3101), 1,
      sym_statement_block,
    ACTIONS(4531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3096), 1,
      sym_statement_block,
    ACTIONS(4529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1104), 1,
      sym__number_lit,
    ACTIONS(4533), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4535), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
  [99549] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4537), 1,
      anon_sym_COLON,
    ACTIONS(4539), 1,
      anon_sym_QMARK,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3151), 1,
      sym__call_signature,
  [99574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1584), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2977), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2417), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3119), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [99637] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4541), 1,
      sym_identifier,
    ACTIONS(4543), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3100), 1,
      sym__call_signature,
  [99662] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(639), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3139), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4282), 1,
      anon_sym_is,
    ACTIONS(4545), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99702] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(85), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3132), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_is,
    ACTIONS(1697), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [99742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1761), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2948), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3059), 1,
      sym_statement_block,
    ACTIONS(4547), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2969), 1,
      sym_statement_block,
    ACTIONS(4549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3054), 1,
      sym_statement_block,
    ACTIONS(4549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2406), 1,
      sym_type_annotation,
    ACTIONS(4551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99848] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1241), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3016), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99925] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2455), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3086), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [99950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1616), 1,
      sym__number_lit,
    ACTIONS(4557), 2,
      sym_float_literal,
      sym_bigint_literal,
    ACTIONS(4559), 4,
      sym_hex_literal,
      sym_int_literal,
      sym_binary_literal,
      sym_octal_literal,
  [99980] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1422), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3083), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1222), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3058), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100030] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2523), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2997), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4561), 1,
      sym_identifier,
    ACTIONS(4563), 1,
      anon_sym_STAR,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym__call_signature,
  [100080] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(502), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(2982), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100105] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1236), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3012), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2430), 1,
      sym_type_annotation,
    STATE(2809), 1,
      sym__initializer,
    ACTIONS(4336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100164] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    STATE(1764), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3063), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3000), 1,
      sym_statement_block,
    ACTIONS(4567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100206] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(4406), 1,
      anon_sym_extends,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2474), 1,
      sym_class_body,
    STATE(2776), 1,
      sym_extends_clause,
    STATE(3064), 1,
      sym_class_heritage,
    STATE(3302), 1,
      sym_implements_clause,
  [100231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2849), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4569), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2287), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2849), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4569), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2855), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 1,
      anon_sym_typeof,
    ACTIONS(4573), 1,
      sym_identifier,
    STATE(478), 1,
      sym_nested_type_identifier,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(434), 2,
      sym_generic_type,
      sym_type_query,
  [100299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4575), 1,
      anon_sym_COMMA,
    ACTIONS(4577), 1,
      anon_sym_GT,
    STATE(2920), 1,
      aux_sym_implements_clause_repeat1,
  [100321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4581), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2851), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4587), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3135), 1,
      sym__call_signature,
  [100395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2259), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2851), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100411] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(4589), 1,
      sym_identifier,
    ACTIONS(4591), 1,
      anon_sym_DOT,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
  [100433] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_COMMA,
    ACTIONS(3378), 1,
      anon_sym_LBRACE,
    ACTIONS(3408), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4593), 1,
      anon_sym_LT,
    STATE(2638), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2752), 1,
      sym_type_arguments,
  [100455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    ACTIONS(4595), 1,
      sym_identifier,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2696), 1,
      sym_variable_declarator,
  [100477] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4597), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2816), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [100499] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    ACTIONS(4595), 1,
      sym_identifier,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2698), 1,
      sym_variable_declarator,
  [100521] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4599), 1,
      anon_sym_QMARK,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3056), 1,
      sym__call_signature,
  [100543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2265), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4603), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100559] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4605), 1,
      anon_sym_COMMA,
    ACTIONS(4607), 1,
      anon_sym_GT,
    STATE(2938), 1,
      aux_sym_implements_clause_repeat1,
  [100581] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4609), 1,
      sym_identifier,
    ACTIONS(4611), 1,
      anon_sym_LBRACK,
    STATE(1653), 1,
      sym_arguments,
    STATE(3112), 1,
      sym_type_arguments,
  [100603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2845), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100619] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4615), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2408), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [100641] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4617), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2441), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [100663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2450), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [100681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 1,
      anon_sym_typeof,
    ACTIONS(4623), 1,
      sym_identifier,
    STATE(1429), 1,
      sym_nested_type_identifier,
    STATE(3225), 1,
      sym_nested_identifier,
    STATE(1666), 2,
      sym_generic_type,
      sym_type_query,
  [100701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_default,
    ACTIONS(4627), 1,
      anon_sym_RBRACE,
    ACTIONS(4629), 1,
      anon_sym_case,
    STATE(2319), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [100719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2837), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4631), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2833), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4633), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4638), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4635), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2283), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2833), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4633), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2831), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4640), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2284), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4644), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4642), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4649), 1,
      anon_sym_BQUOTE,
    ACTIONS(4651), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4646), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2289), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [100833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4654), 1,
      anon_sym_export,
    ACTIONS(4656), 1,
      anon_sym_class,
    ACTIONS(4658), 1,
      anon_sym_abstract,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [100855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4660), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3099), 1,
      sym__call_signature,
  [100889] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4662), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2967), 1,
      sym__call_signature,
    STATE(2972), 1,
      sym_type_parameters,
  [100911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2257), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4666), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4664), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4668), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2236), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [100949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2340), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4672), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4670), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100965] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4674), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2606), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [100987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4676), 1,
      anon_sym_COMMA,
    ACTIONS(4678), 1,
      anon_sym_GT,
    STATE(2878), 1,
      aux_sym_implements_clause_repeat1,
  [101009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4680), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2220), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101031] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4682), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3135), 1,
      sym__call_signature,
  [101053] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2208), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4686), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2204), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_typeof,
    ACTIONS(4688), 1,
      sym_identifier,
    STATE(1057), 1,
      sym_nested_type_identifier,
    STATE(3218), 1,
      sym_nested_identifier,
    STATE(1064), 2,
      sym_generic_type,
      sym_type_query,
  [101117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4690), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2201), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4399), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3073), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [101155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    ACTIONS(4230), 1,
      anon_sym_LT,
    STATE(416), 1,
      sym_type_arguments,
    STATE(2672), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3408), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [101175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2521), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [101193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2516), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [101211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2843), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4694), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101227] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4696), 1,
      anon_sym_LBRACE,
    ACTIONS(4698), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_implements_clause_repeat1,
  [101249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4700), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2567), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    STATE(2626), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym__initializer,
    ACTIONS(4702), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_default,
    ACTIONS(4629), 1,
      anon_sym_case,
    ACTIONS(4704), 1,
      anon_sym_RBRACE,
    STATE(2282), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [101309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4706), 1,
      sym_identifier,
    ACTIONS(4708), 1,
      anon_sym_LBRACK,
    STATE(1234), 1,
      sym_arguments,
    STATE(3069), 1,
      sym_type_arguments,
  [101331] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4710), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2511), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4714), 1,
      anon_sym_BQUOTE,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4712), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2289), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101371] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    ACTIONS(4595), 1,
      sym_identifier,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2937), 1,
      sym_variable_declarator,
  [101393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_COMMA,
    ACTIONS(4720), 1,
      anon_sym_GT,
    STATE(2863), 1,
      aux_sym_implements_clause_repeat1,
  [101415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4722), 1,
      anon_sym_default,
    ACTIONS(4725), 1,
      anon_sym_RBRACE,
    ACTIONS(4727), 1,
      anon_sym_case,
    STATE(2319), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [101433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2340), 1,
      anon_sym_typeof,
    ACTIONS(4730), 1,
      sym_identifier,
    STATE(1394), 1,
      sym_nested_type_identifier,
    STATE(3295), 1,
      sym_nested_identifier,
    STATE(1445), 2,
      sym_generic_type,
      sym_type_query,
  [101453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2277), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2853), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4732), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4734), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2501), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2857), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4736), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2309), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2857), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4736), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4738), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [101541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4740), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [101559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2494), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [101577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2491), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [101595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4742), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym__call_signature,
  [101617] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4744), 1,
      anon_sym_QMARK,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3108), 1,
      sym__call_signature,
  [101639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2323), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4748), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4746), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4750), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3150), 1,
      sym__call_signature,
  [101677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4754), 1,
      anon_sym_BQUOTE,
    ACTIONS(4752), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2344), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4756), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym__call_signature,
  [101717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [101729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4758), 1,
      sym_identifier,
    ACTIONS(4760), 1,
      anon_sym_LBRACK,
    STATE(1782), 1,
      sym_arguments,
    STATE(2992), 1,
      sym_type_arguments,
  [101751] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4764), 1,
      anon_sym_DOT,
    STATE(2160), 1,
      sym_nested_identifier,
    STATE(2195), 1,
      sym_string,
    STATE(2548), 1,
      sym__module,
  [101773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4768), 1,
      anon_sym_BQUOTE,
    ACTIONS(4766), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2355), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4770), 1,
      anon_sym_QMARK,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3070), 1,
      sym__call_signature,
  [101813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2285), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2853), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4732), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101829] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4772), 1,
      sym_identifier,
    ACTIONS(4774), 1,
      anon_sym_LBRACK,
    STATE(1844), 1,
      sym_arguments,
    STATE(3091), 1,
      sym_type_arguments,
  [101851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4776), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym__call_signature,
  [101873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4780), 1,
      anon_sym_BQUOTE,
    ACTIONS(4778), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2316), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4782), 1,
      anon_sym_BQUOTE,
    ACTIONS(4712), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2289), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101909] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4658), 1,
      anon_sym_abstract,
    ACTIONS(4784), 1,
      anon_sym_export,
    ACTIONS(4786), 1,
      anon_sym_class,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [101931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2432), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [101949] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4788), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2468), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [101971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2431), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [101989] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4790), 1,
      sym_identifier,
    ACTIONS(4792), 1,
      anon_sym_LBRACK,
    STATE(1706), 1,
      sym_arguments,
    STATE(3055), 1,
      sym_type_arguments,
  [102011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4794), 1,
      anon_sym_QMARK,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3002), 1,
      sym__call_signature,
  [102033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4796), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym__call_signature,
  [102055] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(4589), 1,
      sym_identifier,
    ACTIONS(4798), 1,
      anon_sym_DOT,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
  [102077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    ACTIONS(4595), 1,
      sym_identifier,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2681), 1,
      sym_variable_declarator,
  [102099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4383), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3042), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [102115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4800), 1,
      anon_sym_BQUOTE,
    ACTIONS(4712), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2289), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [102133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4802), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2781), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_LBRACE,
    ACTIONS(4449), 1,
      anon_sym_LBRACK,
    ACTIONS(4595), 1,
      sym_identifier,
    STATE(2184), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2683), 1,
      sym_variable_declarator,
  [102177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4804), 1,
      anon_sym_COMMA,
    ACTIONS(4806), 1,
      anon_sym_GT,
    STATE(2788), 1,
      aux_sym_implements_clause_repeat1,
  [102199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3135), 1,
      sym__call_signature,
  [102221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2376), 1,
      anon_sym_typeof,
    ACTIONS(4810), 1,
      sym_identifier,
    STATE(2026), 1,
      sym_nested_type_identifier,
    STATE(3180), 1,
      sym_nested_identifier,
    STATE(2094), 2,
      sym_generic_type,
      sym_type_query,
  [102241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2386), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [102259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [102271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 1,
      anon_sym_typeof,
    ACTIONS(4812), 1,
      sym_identifier,
    STATE(2000), 1,
      sym_nested_type_identifier,
    STATE(3285), 1,
      sym_nested_identifier,
    STATE(434), 2,
      sym_generic_type,
      sym_type_query,
  [102291] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    ACTIONS(4230), 1,
      anon_sym_LT,
    ACTIONS(4814), 1,
      sym_identifier,
    ACTIONS(4816), 1,
      anon_sym_LBRACK,
    STATE(1178), 1,
      sym_arguments,
    STATE(3142), 1,
      sym_type_arguments,
  [102313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4818), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2448), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102335] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4820), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2390), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102357] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    ACTIONS(4822), 1,
      anon_sym_QMARK,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2377), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4621), 1,
      anon_sym_QMARK_COLON,
    STATE(2444), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [102397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4824), 1,
      anon_sym_COMMA,
    ACTIONS(4826), 1,
      anon_sym_GT,
    STATE(2880), 1,
      aux_sym_implements_clause_repeat1,
  [102419] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    ACTIONS(4828), 1,
      anon_sym_QMARK,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3019), 1,
      sym__call_signature,
  [102441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3122), 1,
      sym__call_signature,
  [102460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4832), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4517), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4517), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2463), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1934), 1,
      sym_statement_block,
    ACTIONS(4517), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2661), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [102601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2764), 1,
      sym__initializer,
    ACTIONS(4838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4840), 1,
      anon_sym_EQ_GT,
    STATE(3042), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [102631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2767), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4842), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [102672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [102683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1919), 1,
      sym_statement_block,
    ACTIONS(4519), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1908), 1,
      sym_statement_block,
    ACTIONS(4517), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2446), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [102732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4844), 1,
      anon_sym_EQ_GT,
    STATE(3073), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [102747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3113), 1,
      sym__call_signature,
  [102766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1924), 1,
      sym_statement_block,
    ACTIONS(4519), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_DOT,
    ACTIONS(1508), 1,
      anon_sym_LBRACE,
    ACTIONS(1506), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [102807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3037), 1,
      sym__call_signature,
  [102837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3106), 1,
      sym__call_signature,
  [102856] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3088), 1,
      sym__call_signature,
  [102875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(2160), 1,
      sym_nested_identifier,
    STATE(2195), 1,
      sym_string,
    STATE(2525), 1,
      sym__module,
  [102960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(2160), 1,
      sym_nested_identifier,
    STATE(2195), 1,
      sym_string,
    STATE(2548), 1,
      sym__module,
  [102990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4852), 1,
      anon_sym_class,
    ACTIONS(4854), 1,
      anon_sym_abstract,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [103009] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2379), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [103028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103050] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2639), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [103069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1936), 1,
      sym_statement_block,
    ACTIONS(4529), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_statement_block,
    ACTIONS(4531), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4856), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [103132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2101), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(2985), 1,
      sym__call_signature,
  [103184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3098), 1,
      sym__call_signature,
  [103203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3116), 1,
      sym__call_signature,
  [103233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3251), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4860), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [103261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3007), 1,
      sym__call_signature,
  [103280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2783), 1,
      sym__initializer,
    ACTIONS(4862), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4864), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4866), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3157), 1,
      sym__call_signature,
  [103336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2785), 1,
      sym__initializer,
    ACTIONS(4868), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(2978), 1,
      sym__call_signature,
  [103370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    ACTIONS(4473), 1,
      anon_sym_extends,
    STATE(552), 1,
      sym_object_type,
    STATE(2940), 1,
      sym_extends_clause,
  [103400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3172), 1,
      sym__call_signature,
  [103419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym__call_signature,
  [103438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2790), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [103457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1940), 1,
      sym_statement_block,
    ACTIONS(4531), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2395), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [103491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4872), 1,
      anon_sym_PIPE,
    ACTIONS(4870), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4874), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1933), 1,
      sym_statement_block,
    ACTIONS(4513), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2489), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [103564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1917), 1,
      sym_statement_block,
    ACTIONS(4515), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4876), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(1729), 2,
      anon_sym_else,
      anon_sym_while,
  [103640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1941), 1,
      sym_statement_block,
    ACTIONS(4529), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1086), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2756), 1,
      sym__initializer,
    ACTIONS(4880), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1950), 1,
      sym_statement_block,
    ACTIONS(4513), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2939), 1,
      sym__initializer,
    ACTIONS(4882), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2502), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [103807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2931), 1,
      sym__initializer,
    ACTIONS(4884), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2928), 1,
      sym__initializer,
    ACTIONS(4886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3003), 1,
      sym__call_signature,
  [103867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4888), 1,
      anon_sym_EQ_GT,
    STATE(3042), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [103904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4892), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1919), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [103992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3974), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [104014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3963), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [104025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4896), 1,
      anon_sym_COMMA,
    ACTIONS(4898), 1,
      anon_sym_RBRACE,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    STATE(2822), 1,
      sym__import_export_specifier,
  [104055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(4593), 1,
      anon_sym_LT,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [104083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1910), 1,
      sym_statement_block,
    ACTIONS(4511), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104098] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2200), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4902), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2202), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    ACTIONS(4473), 1,
      anon_sym_extends,
    STATE(2615), 1,
      sym_object_type,
    STATE(2909), 1,
      sym_extends_clause,
  [104166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2205), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      sym__automatic_semicolon,
    ACTIONS(984), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2532), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2210), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1915), 1,
      sym_statement_block,
    ACTIONS(4509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4511), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2221), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2677), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3111), 1,
      sym__call_signature,
  [104352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3138), 1,
      sym__call_signature,
  [104371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3075), 1,
      sym__call_signature,
  [104390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2935), 1,
      sym__initializer,
    ACTIONS(4908), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2479), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104457] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3061), 1,
      sym__call_signature,
  [104476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104487] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4658), 1,
      anon_sym_abstract,
    ACTIONS(4912), 1,
      anon_sym_class,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [104506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3033), 1,
      sym__call_signature,
  [104547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(2996), 1,
      sym__call_signature,
  [104566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4916), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2621), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1925), 1,
      sym_statement_block,
    ACTIONS(4567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2966), 1,
      sym__call_signature,
    STATE(2972), 1,
      sym_type_parameters,
  [104674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 1,
      sym__automatic_semicolon,
    ACTIONS(1008), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2629), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__automatic_semicolon,
    ACTIONS(998), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3021), 1,
      sym__call_signature,
  [104738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1918), 1,
      sym_statement_block,
    ACTIONS(4507), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104775] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2640), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [104794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [104805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4426), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [104844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4924), 1,
      anon_sym_EQ_GT,
    STATE(3042), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [104859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4926), 1,
      anon_sym_EQ_GT,
    STATE(3073), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [104874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [104885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4932), 1,
      anon_sym_EQ_GT,
    STATE(3042), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [104933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2053), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4638), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2769), 1,
      sym__initializer,
    ACTIONS(4934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2456), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [105000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4936), 1,
      anon_sym_EQ_GT,
    STATE(3073), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [105026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2657), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [105045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105056] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_LBRACE,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
    ACTIONS(4938), 1,
      sym_identifier,
    STATE(3288), 1,
      sym_object,
    STATE(3294), 1,
      sym_array,
  [105075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(4589), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(614), 1,
      sym__module,
  [105182] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2716), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [105201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4872), 1,
      anon_sym_PIPE,
    ACTIONS(4940), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(2983), 1,
      sym__call_signature,
  [105248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3043), 1,
      sym__call_signature,
  [105278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    ACTIONS(4944), 1,
      anon_sym_RBRACE,
    STATE(2898), 1,
      aux_sym_enum_body_repeat1,
    STATE(3158), 1,
      sym__initializer,
  [105308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2413), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_parameters,
  [105327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4946), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [105371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    ACTIONS(4948), 1,
      anon_sym_COMMA,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    STATE(2799), 1,
      sym__import_export_specifier,
  [105401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3144), 1,
      sym__call_signature,
  [105420] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_formal_parameters,
    STATE(2972), 1,
      sym_type_parameters,
    STATE(3109), 1,
      sym__call_signature,
  [105439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    ACTIONS(4589), 1,
      sym_identifier,
    STATE(493), 1,
      sym_nested_identifier,
    STATE(510), 1,
      sym_string,
    STATE(568), 1,
      sym__module,
  [105458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LT,
    STATE(416), 1,
      sym_type_arguments,
    ACTIONS(3604), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [105473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4952), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [105484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4872), 1,
      anon_sym_PIPE,
    ACTIONS(4954), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4956), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [105512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4872), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4960), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [105551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1926), 1,
      sym_statement_block,
    ACTIONS(4547), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COLON,
    ACTIONS(4962), 1,
      anon_sym_EQ_GT,
    STATE(3073), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [105592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2800), 1,
      sym__initializer,
    ACTIONS(4964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4966), 1,
      sym__automatic_semicolon,
    ACTIONS(1126), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2077), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1945), 1,
      sym_statement_block,
    ACTIONS(4549), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_EQ,
    STATE(2834), 1,
      sym__initializer,
    ACTIONS(4968), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1851), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [105727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LBRACE,
    STATE(1920), 1,
      sym_statement_block,
    ACTIONS(4549), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    ACTIONS(4970), 1,
      anon_sym_COMMA,
    ACTIONS(4972), 1,
      anon_sym_RBRACE,
    STATE(2818), 1,
      aux_sym_enum_body_repeat1,
    STATE(3158), 1,
      sym__initializer,
  [105783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3251), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_EQ,
    ACTIONS(3917), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [105818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [105840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_BQUOTE,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    STATE(1261), 2,
      sym_template_string,
      sym_arguments,
  [105876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    STATE(2672), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3408), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [105890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4974), 1,
      anon_sym_RBRACK,
  [105906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4976), 1,
      anon_sym_RPAREN,
  [105922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4978), 1,
      anon_sym_RBRACK,
  [105938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    ACTIONS(4980), 1,
      anon_sym_SEMI,
    ACTIONS(4982), 1,
      sym__automatic_semicolon,
    STATE(2530), 1,
      sym_statement_block,
  [105954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(4984), 1,
      anon_sym_COLON,
  [105970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4986), 1,
      sym_identifier,
    STATE(1690), 1,
      sym_generic_type,
    STATE(1691), 1,
      sym_nested_identifier,
    STATE(2950), 1,
      sym_nested_type_identifier,
  [105986] = 5,
    ACTIONS(4988), 1,
      anon_sym_DQUOTE,
    ACTIONS(4990), 1,
      aux_sym_string_token1,
    ACTIONS(4992), 1,
      sym_escape_sequence,
    ACTIONS(4994), 1,
      sym_comment,
    STATE(2630), 1,
      aux_sym_string_repeat1,
  [106002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(435), 1,
      sym_generic_type,
    STATE(472), 1,
      sym_nested_identifier,
    STATE(3095), 1,
      sym_nested_type_identifier,
  [106018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    STATE(3123), 1,
      sym__initializer,
    ACTIONS(4998), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106032] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5000), 1,
      anon_sym_DQUOTE,
    ACTIONS(5002), 1,
      aux_sym_string_token1,
    ACTIONS(5004), 1,
      sym_escape_sequence,
    STATE(2706), 1,
      aux_sym_string_repeat1,
  [106048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3205), 4,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [106058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_SEMI,
    ACTIONS(5008), 1,
      sym__automatic_semicolon,
    STATE(1533), 1,
      sym_statement_block,
  [106074] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5010), 1,
      anon_sym_DQUOTE,
    ACTIONS(5012), 1,
      aux_sym_string_token1,
    ACTIONS(5014), 1,
      sym_escape_sequence,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [106090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    ACTIONS(5016), 1,
      anon_sym_RBRACE,
    STATE(3051), 1,
      sym__import_export_specifier,
  [106106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5018), 1,
      anon_sym_COLON,
  [106122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5020), 1,
      anon_sym_COLON,
  [106138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5022), 1,
      anon_sym_COMMA,
    STATE(2634), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3604), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [106152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_COMMA,
    ACTIONS(3378), 1,
      anon_sym_LBRACE,
    ACTIONS(3408), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2638), 1,
      aux_sym_extends_clause_repeat1,
  [106168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5025), 1,
      anon_sym_RBRACK,
  [106184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_COMMA,
    ACTIONS(5027), 1,
      anon_sym_LBRACE,
    ACTIONS(5029), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2665), 1,
      aux_sym_extends_clause_repeat1,
  [106200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_COMMA,
    ACTIONS(5031), 1,
      anon_sym_LBRACE,
    ACTIONS(5033), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2665), 1,
      aux_sym_extends_clause_repeat1,
  [106216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    ACTIONS(5035), 1,
      anon_sym_SEMI,
    ACTIONS(5037), 1,
      sym__automatic_semicolon,
    STATE(508), 1,
      sym_statement_block,
  [106232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    ACTIONS(5039), 1,
      anon_sym_SEMI,
    ACTIONS(5041), 1,
      sym__automatic_semicolon,
    STATE(2599), 1,
      sym_statement_block,
  [106248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5043), 1,
      anon_sym_class,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [106264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5045), 1,
      anon_sym_RPAREN,
  [106280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5047), 1,
      anon_sym_QMARK,
  [106296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    ACTIONS(5049), 1,
      anon_sym_RBRACE,
    STATE(3065), 1,
      sym__import_export_specifier,
  [106312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_from,
    STATE(3114), 1,
      sym__from_clause,
    ACTIONS(5053), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3081), 1,
      sym_type_parameters,
    STATE(3251), 1,
      sym_formal_parameters,
  [106342] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5055), 1,
      anon_sym_DQUOTE,
    ACTIONS(5057), 1,
      aux_sym_string_token1,
    ACTIONS(5060), 1,
      sym_escape_sequence,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [106358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5063), 1,
      anon_sym_LBRACK,
    ACTIONS(1624), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [106370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    STATE(3062), 1,
      sym_default_type,
    ACTIONS(5065), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [106384] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5012), 1,
      aux_sym_string_token1,
    ACTIONS(5014), 1,
      sym_escape_sequence,
    ACTIONS(5067), 1,
      anon_sym_DQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [106400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_LBRACK,
    ACTIONS(1624), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [106412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    STATE(3093), 1,
      sym_type_annotation,
    ACTIONS(5071), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [106426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5073), 1,
      anon_sym_QMARK,
    ACTIONS(2789), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [106438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5075), 1,
      anon_sym_RPAREN,
  [106454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5077), 1,
      anon_sym_RPAREN,
  [106470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5079), 1,
      anon_sym_export,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [106486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    ACTIONS(5035), 1,
      anon_sym_SEMI,
    ACTIONS(5037), 1,
      sym__automatic_semicolon,
    STATE(1436), 1,
      sym_statement_block,
  [106502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2193), 1,
      sym_formal_parameters,
    STATE(3152), 1,
      sym_type_parameters,
  [106518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5081), 1,
      sym_identifier,
    STATE(1063), 1,
      sym_generic_type,
    STATE(1118), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_nested_type_identifier,
  [106534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5083), 1,
      anon_sym_COLON,
  [106550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LBRACE,
    ACTIONS(5035), 1,
      anon_sym_SEMI,
    ACTIONS(5037), 1,
      sym__automatic_semicolon,
    STATE(95), 1,
      sym_statement_block,
  [106566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2673), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5087), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2673), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5089), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    STATE(2634), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5029), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [106608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5091), 1,
      anon_sym_COMMA,
    STATE(2665), 1,
      aux_sym_extends_clause_repeat1,
  [106624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5094), 1,
      anon_sym_class,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [106640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_COMMA,
    STATE(2667), 1,
      aux_sym_array_repeat1,
    ACTIONS(3659), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [106654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    STATE(3158), 1,
      sym__initializer,
    ACTIONS(5099), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4481), 1,
      anon_sym_EQ,
    STATE(3050), 1,
      sym__initializer,
    ACTIONS(5101), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [106682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [106692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5103), 1,
      anon_sym_QMARK,
  [106708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_COMMA,
    STATE(2634), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5033), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [106722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_COMMA,
    STATE(2673), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5108), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106736] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5110), 1,
      anon_sym_DQUOTE,
    ACTIONS(5112), 1,
      aux_sym_string_token1,
    ACTIONS(5114), 1,
      sym_escape_sequence,
    STATE(2722), 1,
      aux_sym_string_repeat1,
  [106752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2673), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5116), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106766] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5118), 1,
      anon_sym_DQUOTE,
    ACTIONS(5120), 1,
      aux_sym_string_token1,
    ACTIONS(5122), 1,
      sym_escape_sequence,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [106782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_SEMI,
    ACTIONS(5008), 1,
      sym__automatic_semicolon,
    STATE(76), 1,
      sym_statement_block,
  [106798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2673), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5124), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5126), 1,
      anon_sym_COLON,
  [106828] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5012), 1,
      aux_sym_string_token1,
    ACTIONS(5014), 1,
      sym_escape_sequence,
    ACTIONS(5128), 1,
      anon_sym_DQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [106844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2678), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5130), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 1,
      anon_sym_LBRACE,
    ACTIONS(4422), 1,
      anon_sym_STAR,
    STATE(3387), 2,
      sym_namespace_import,
      sym_named_imports,
  [106872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2675), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5132), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5134), 1,
      anon_sym_RBRACK,
  [106902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5136), 1,
      anon_sym_RBRACK,
  [106918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5138), 1,
      anon_sym_RBRACK,
  [106934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5140), 1,
      sym_identifier,
    STATE(1458), 1,
      sym_generic_type,
    STATE(1459), 1,
      sym_nested_identifier,
    STATE(3097), 1,
      sym_nested_type_identifier,
  [106950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5142), 1,
      anon_sym_RBRACK,
  [106966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5144), 1,
      anon_sym_class,
    STATE(1991), 1,
      aux_sym_export_statement_repeat1,
    STATE(1993), 1,
      sym_decorator,
  [106982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    ACTIONS(5146), 1,
      anon_sym_RBRACE,
    STATE(3051), 1,
      sym__import_export_specifier,
  [106998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3162), 1,
      sym_type_parameters,
    STATE(3286), 1,
      sym_formal_parameters,
  [107014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      anon_sym_LBRACK,
    ACTIONS(1624), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [107026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5150), 1,
      anon_sym_RBRACK,
  [107042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5152), 1,
      anon_sym_QMARK,
  [107058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5154), 1,
      anon_sym_RBRACK,
  [107074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2662), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5156), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3147), 1,
      sym_type_parameters,
    STATE(3270), 1,
      sym_formal_parameters,
  [107104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2663), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5158), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5160), 1,
      anon_sym_RPAREN,
  [107134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5162), 1,
      anon_sym_QMARK,
  [107150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_COLON,
    STATE(3143), 1,
      sym_type_annotation,
    ACTIONS(5164), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5166), 1,
      anon_sym_QMARK,
  [107180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 1,
      anon_sym_EQ_GT,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [107192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 1,
      anon_sym_LBRACK,
    ACTIONS(1624), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [107204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(4740), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [107218] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5012), 1,
      aux_sym_string_token1,
    ACTIONS(5014), 1,
      sym_escape_sequence,
    ACTIONS(5175), 1,
      anon_sym_DQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [107234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5177), 1,
      anon_sym_RBRACK,
  [107250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_EQ_GT,
    ACTIONS(2871), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [107262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3129), 1,
      sym_type_parameters,
    STATE(3394), 1,
      sym_formal_parameters,
  [107278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 1,
      anon_sym_LBRACK,
    ACTIONS(1624), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [107290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_BQUOTE,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
  [107304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3126), 1,
      sym_type_parameters,
    STATE(3364), 1,
      sym_formal_parameters,
  [107320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_from,
    STATE(3141), 1,
      sym__from_clause,
    ACTIONS(5181), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [107344] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5185), 1,
      anon_sym_DQUOTE,
    ACTIONS(5187), 1,
      aux_sym_string_token1,
    ACTIONS(5189), 1,
      sym_escape_sequence,
    STATE(2680), 1,
      aux_sym_string_repeat1,
  [107360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_SEMI,
    ACTIONS(5008), 1,
      sym__automatic_semicolon,
    STATE(516), 1,
      sym_statement_block,
  [107376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5191), 1,
      anon_sym_COLON,
  [107392] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5193), 1,
      anon_sym_DQUOTE,
    ACTIONS(5195), 1,
      aux_sym_string_token1,
    ACTIONS(5197), 1,
      sym_escape_sequence,
    STATE(2724), 1,
      aux_sym_string_repeat1,
  [107408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    STATE(1713), 2,
      sym_template_string,
      sym_arguments,
  [107422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5199), 1,
      anon_sym_QMARK,
  [107438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    ACTIONS(5201), 1,
      anon_sym_RBRACE,
    STATE(3065), 1,
      sym__import_export_specifier,
  [107454] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5012), 1,
      aux_sym_string_token1,
    ACTIONS(5014), 1,
      sym_escape_sequence,
    ACTIONS(5203), 1,
      anon_sym_DQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [107470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5205), 1,
      sym_identifier,
    STATE(2053), 1,
      sym_nested_identifier,
    STATE(2078), 1,
      sym_generic_type,
    STATE(3044), 1,
      sym_nested_type_identifier,
  [107486] = 5,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5012), 1,
      aux_sym_string_token1,
    ACTIONS(5014), 1,
      sym_escape_sequence,
    ACTIONS(5207), 1,
      anon_sym_DQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat1,
  [107502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5209), 1,
      anon_sym_RBRACK,
  [107518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
    ACTIONS(5211), 1,
      anon_sym_RBRACK,
  [107534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3079), 1,
      sym_type_parameters,
    STATE(3267), 1,
      sym_formal_parameters,
  [107550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym_identifier,
    STATE(435), 1,
      sym_generic_type,
    STATE(2005), 1,
      sym_nested_identifier,
    STATE(3095), 1,
      sym_nested_type_identifier,
  [107566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [107575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5215), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(5217), 1,
      anon_sym_extends,
  [107597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [107606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3981), 1,
      anon_sym_extends,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
  [107619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5221), 1,
      anon_sym_RBRACE,
    STATE(2770), 1,
      aux_sym_object_repeat1,
  [107632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_extends,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
  [107645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5221), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [107658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
  [107671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_extends,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
  [107684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      anon_sym_LPAREN,
    ACTIONS(5225), 1,
      anon_sym_await,
    STATE(35), 1,
      sym__for_header,
  [107697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      sym_identifier,
    ACTIONS(5229), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(5233), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3685), 1,
      anon_sym_RBRACK,
    STATE(2774), 1,
      aux_sym_array_repeat1,
  [107732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3685), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [107745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_is,
    ACTIONS(4545), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [107756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      sym_identifier,
    STATE(1853), 1,
      sym_decorator_member_expression,
    STATE(1865), 1,
      sym_decorator_call_expression,
  [107769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_LBRACE,
    ACTIONS(4928), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [107780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5239), 1,
      anon_sym_LBRACE,
    ACTIONS(4856), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [107802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    ACTIONS(4922), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [107813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 1,
      anon_sym_LBRACE,
    ACTIONS(1528), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 1,
      anon_sym_LBRACE,
    ACTIONS(1516), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 1,
      anon_sym_LBRACE,
    ACTIONS(1520), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5243), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [107859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_RBRACE,
    STATE(2807), 1,
      aux_sym_object_repeat1,
  [107883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 1,
      anon_sym_LBRACE,
    ACTIONS(1512), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      anon_sym_COMMA,
    ACTIONS(5252), 1,
      anon_sym_RBRACE,
    STATE(2758), 1,
      aux_sym_export_clause_repeat1,
  [107916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5245), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [107929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(5254), 1,
      anon_sym_EQ,
    STATE(3199), 1,
      sym_type_parameters,
  [107942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5256), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5258), 1,
      anon_sym_EQ,
    ACTIONS(5260), 1,
      anon_sym_COMMA,
    ACTIONS(5262), 1,
      anon_sym_from,
  [107964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5264), 1,
      anon_sym_COMMA,
    ACTIONS(5267), 1,
      anon_sym_GT,
    STATE(2763), 1,
      aux_sym_type_parameters_repeat1,
  [107977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    ACTIONS(5273), 1,
      anon_sym_GT,
    STATE(2993), 1,
      sym_type_parameter,
  [107999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5256), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5275), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5277), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5279), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5281), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5283), 1,
      anon_sym_COMMA,
    ACTIONS(5285), 1,
      anon_sym_RPAREN,
    STATE(2832), 1,
      aux_sym_formal_parameters_repeat1,
  [108074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3625), 1,
      anon_sym_RBRACK,
    STATE(2841), 1,
      aux_sym_array_repeat1,
  [108087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5287), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3625), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_implements,
    ACTIONS(5289), 1,
      anon_sym_LBRACE,
    STATE(3231), 1,
      sym_implements_clause,
  [108126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5291), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5295), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5291), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5303), 1,
      anon_sym_RBRACK,
    STATE(2813), 1,
      aux_sym__tuple_type_body_repeat1,
  [108202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5307), 1,
      anon_sym_COMMA,
    ACTIONS(5309), 1,
      anon_sym_GT,
    STATE(2892), 1,
      aux_sym_type_parameters_repeat1,
  [108224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [108246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5295), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [108273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_EQ,
    STATE(3262), 1,
      sym_type_parameters,
  [108286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3691), 1,
      anon_sym_RPAREN,
    STATE(2820), 1,
      aux_sym_array_repeat1,
  [108317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3691), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_as,
    ACTIONS(5325), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5327), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      aux_sym__tuple_type_body_repeat1,
  [108354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5329), 1,
      anon_sym_COMMA,
    ACTIONS(5331), 1,
      anon_sym_RBRACE,
    STATE(2907), 1,
      aux_sym_export_clause_repeat1,
  [108367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5335), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [108385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5337), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5339), 1,
      anon_sym_RBRACE,
    STATE(2845), 1,
      aux_sym_object_repeat1,
  [108429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5339), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5341), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5345), 1,
      anon_sym_COMMA,
    ACTIONS(5348), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_COMMA,
    ACTIONS(5352), 1,
      anon_sym_RPAREN,
    STATE(2853), 1,
      aux_sym_formal_parameters_repeat1,
  [108499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 1,
      anon_sym_COMMA,
    ACTIONS(5357), 1,
      anon_sym_RBRACE,
    STATE(2812), 1,
      aux_sym_named_imports_repeat1,
  [108512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5359), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      aux_sym__tuple_type_body_repeat1,
  [108525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    STATE(562), 1,
      sym_object_type,
  [108565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4177), 1,
      anon_sym_RBRACE,
    ACTIONS(5361), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_enum_body_repeat1,
  [108578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3600), 1,
      anon_sym_RBRACK,
    STATE(2861), 1,
      aux_sym_array_repeat1,
  [108591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3600), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COMMA,
    ACTIONS(5367), 1,
      anon_sym_RBRACE,
    STATE(2918), 1,
      aux_sym_named_imports_repeat1,
  [108630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_COMMA,
    ACTIONS(5262), 1,
      anon_sym_from,
    ACTIONS(5369), 1,
      anon_sym_EQ,
  [108643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 1,
      sym_identifier,
    ACTIONS(5373), 1,
      anon_sym_require,
    STATE(2930), 1,
      sym_nested_identifier,
  [108656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5375), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5377), 1,
      anon_sym_COMMA,
    ACTIONS(5379), 1,
      anon_sym_GT,
    STATE(2872), 1,
      aux_sym_type_parameters_repeat1,
  [108678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      anon_sym_COMMA,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [108736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5099), 1,
      anon_sym_RBRACE,
    ACTIONS(5389), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_enum_body_repeat1,
  [108749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5392), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5394), 1,
      anon_sym_COMMA,
    ACTIONS(5396), 1,
      anon_sym_RPAREN,
    STATE(2881), 1,
      aux_sym_formal_parameters_repeat1,
  [108771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      anon_sym_COMMA,
    ACTIONS(5400), 1,
      anon_sym_RPAREN,
    STATE(2877), 1,
      aux_sym_formal_parameters_repeat1,
  [108784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    ACTIONS(5402), 1,
      anon_sym_LPAREN,
    STATE(496), 1,
      sym_statement_block,
  [108797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [108806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5404), 1,
      anon_sym_RBRACE,
    STATE(2865), 1,
      aux_sym_object_repeat1,
  [108828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5406), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5404), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5408), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5410), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [108889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4527), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    STATE(3051), 1,
      sym__import_export_specifier,
  [108911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3657), 1,
      anon_sym_RBRACK,
    STATE(2867), 1,
      aux_sym_array_repeat1,
  [108924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3657), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [108937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_COMMA,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [108950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      anon_sym_COMMA,
    ACTIONS(5416), 1,
      anon_sym_RPAREN,
    STATE(2890), 1,
      aux_sym_formal_parameters_repeat1,
  [108963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    STATE(2614), 1,
      sym_object_type,
  [108976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 1,
      anon_sym_COMMA,
    ACTIONS(5420), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [108989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5422), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5426), 1,
      anon_sym_RPAREN,
    STATE(2915), 1,
      aux_sym_formal_parameters_repeat1,
  [109038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    ACTIONS(5430), 1,
      anon_sym_RPAREN,
    STATE(2916), 1,
      aux_sym_formal_parameters_repeat1,
  [109051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      anon_sym_COMMA,
    ACTIONS(5434), 1,
      anon_sym_RPAREN,
    STATE(2923), 1,
      aux_sym_formal_parameters_repeat1,
  [109064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5436), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5438), 1,
      anon_sym_RBRACK,
    STATE(2926), 1,
      aux_sym__tuple_type_body_repeat1,
  [109090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      anon_sym_GT,
    ACTIONS(5440), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [109103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5442), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [109116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5444), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [109129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [109138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5448), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5450), 1,
      anon_sym_RBRACK,
    STATE(2798), 1,
      aux_sym__tuple_type_body_repeat1,
  [109164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_typeof,
    STATE(3065), 1,
      sym__import_export_specifier,
  [109177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_AMP,
    ACTIONS(4242), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_extends,
  [109190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    ACTIONS(5452), 1,
      anon_sym_GT,
    STATE(2993), 1,
      sym_type_parameter,
  [109203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5452), 1,
      anon_sym_GT,
    ACTIONS(5454), 1,
      anon_sym_COMMA,
    STATE(2763), 1,
      aux_sym_type_parameters_repeat1,
  [109216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5456), 1,
      anon_sym_RBRACK,
    STATE(2888), 1,
      aux_sym__tuple_type_body_repeat1,
  [109238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [109247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 1,
      anon_sym_while,
    ACTIONS(5460), 1,
      anon_sym_else,
    STATE(523), 1,
      sym_else_clause,
  [109260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      anon_sym_GT,
    ACTIONS(5466), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [109286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      anon_sym_GT,
    ACTIONS(5468), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [109308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_COMMA,
    ACTIONS(5472), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3627), 1,
      anon_sym_RPAREN,
    STATE(2893), 1,
      aux_sym_array_repeat1,
  [109334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3627), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    ACTIONS(5474), 1,
      anon_sym_GT,
    STATE(2993), 1,
      sym_type_parameter,
  [109360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    ACTIONS(4944), 1,
      anon_sym_RBRACE,
    STATE(2898), 1,
      aux_sym_enum_body_repeat1,
  [109373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [109391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5476), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      aux_sym__tuple_type_body_repeat1,
  [109404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3647), 1,
      anon_sym_RPAREN,
    STATE(2929), 1,
      aux_sym_array_repeat1,
  [109417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 1,
      anon_sym_COMMA,
    ACTIONS(5480), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_GT,
    ACTIONS(5482), 1,
      anon_sym_COMMA,
    STATE(2763), 1,
      aux_sym_type_parameters_repeat1,
  [109452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5484), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3647), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3634), 1,
      anon_sym_RPAREN,
    STATE(2753), 1,
      aux_sym_array_repeat1,
  [109500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3634), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 1,
      anon_sym_RBRACE,
    ACTIONS(5486), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_enum_body_repeat1,
  [109526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5488), 1,
      anon_sym_COMMA,
    ACTIONS(5491), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      aux_sym__tuple_type_body_repeat1,
  [109539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5493), 1,
      sym_identifier,
    ACTIONS(5495), 1,
      sym_this,
    STATE(2956), 1,
      sym_type_predicate,
  [109552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [109561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5499), 1,
      anon_sym_RBRACE,
    STATE(2925), 1,
      aux_sym_object_repeat1,
  [109574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_as,
    ACTIONS(5503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [109585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5499), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [109598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [109607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 1,
      anon_sym_COMMA,
    ACTIONS(5510), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_COMMA,
    ACTIONS(5514), 1,
      anon_sym_RBRACE,
    STATE(2758), 1,
      aux_sym_export_clause_repeat1,
  [109633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2374), 1,
      anon_sym_LBRACE,
    STATE(2514), 1,
      sym_object_type,
  [109655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3621), 1,
      anon_sym_RBRACK,
    STATE(2927), 1,
      aux_sym_array_repeat1,
  [109668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(3621), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_DOT,
    ACTIONS(5516), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 1,
      sym_identifier,
    ACTIONS(5520), 1,
      sym_this,
    STATE(2291), 1,
      sym_type_predicate,
  [109705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_await,
    STATE(41), 1,
      sym__for_header,
  [109718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5526), 1,
      anon_sym_COMMA,
    ACTIONS(5528), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_COMMA,
    ACTIONS(5532), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [109753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    ACTIONS(5536), 1,
      anon_sym_RBRACE,
    STATE(2812), 1,
      aux_sym_named_imports_repeat1,
  [109766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5538), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      aux_sym__tuple_type_body_repeat1,
  [109779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 1,
      anon_sym_GT,
    ACTIONS(5540), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [109792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4970), 1,
      anon_sym_COMMA,
    ACTIONS(4972), 1,
      anon_sym_RBRACE,
    STATE(2818), 1,
      aux_sym_enum_body_repeat1,
  [109814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 1,
      anon_sym_COMMA,
    ACTIONS(5546), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      aux_sym_formal_parameters_repeat1,
  [109827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5548), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [109840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5550), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym_object_repeat1,
  [109853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5552), 1,
      anon_sym_RBRACK,
    STATE(2899), 1,
      aux_sym__tuple_type_body_repeat1,
  [109866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5554), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5556), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(5558), 1,
      anon_sym_RPAREN,
    STATE(2667), 1,
      aux_sym_array_repeat1,
  [109901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_DOT,
    ACTIONS(5560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    ACTIONS(5566), 1,
      anon_sym_GT,
    STATE(2993), 1,
      sym_type_parameter,
  [109943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(5568), 1,
      anon_sym_RBRACK,
    STATE(2919), 1,
      aux_sym__tuple_type_body_repeat1,
  [109956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5570), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5108), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_GT,
    ACTIONS(5572), 1,
      anon_sym_COMMA,
    STATE(2705), 1,
      aux_sym_implements_clause_repeat1,
  [109996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(928), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_object_type,
  [110018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(86), 1,
      sym_class_body,
  [110046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3276), 1,
      sym_formal_parameters,
  [110056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1441), 1,
      sym_class_body,
  [110074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2473), 1,
      sym_formal_parameters,
  [110084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1756), 1,
      sym_class_body,
  [110094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(89), 1,
      sym_class_body,
  [110104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LT,
    STATE(1659), 1,
      sym_type_arguments,
  [110114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_parenthesized_expression,
  [110148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(2995), 1,
      sym_parenthesized_expression,
  [110158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [110166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym_parenthesized_expression,
  [110176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(477), 1,
      sym_statement_block,
  [110186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [110196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 1,
      anon_sym_SEMI,
    ACTIONS(5586), 1,
      sym__automatic_semicolon,
  [110206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1821), 1,
      sym_class_body,
  [110216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2480), 1,
      sym_class_body,
  [110242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1524), 1,
      sym_statement_block,
  [110260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1285), 1,
      sym_statement_block,
  [110270] = 3,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5590), 1,
      anon_sym_SQUOTE,
    ACTIONS(5592), 1,
      aux_sym_char_token1,
  [110280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3645), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2354), 1,
      sym_formal_parameters,
  [110314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1807), 1,
      sym_statement_block,
  [110324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_from,
    STATE(3080), 1,
      sym__from_clause,
  [110334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2540), 1,
      sym_formal_parameters,
  [110344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 1,
      sym_identifier,
    ACTIONS(5598), 1,
      anon_sym_STAR,
  [110354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1595), 1,
      sym_class_body,
  [110364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1774), 1,
      sym_statement_block,
  [110374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [110398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(504), 1,
      sym_class_body,
  [110408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_statement_block,
  [110418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3077), 1,
      sym_statement_block,
  [110436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4772), 1,
      sym_identifier,
    ACTIONS(4774), 1,
      anon_sym_LBRACK,
  [110446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(580), 1,
      sym_statement_block,
  [110464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_class_body,
  [110474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_from,
    STATE(3171), 1,
      sym__from_clause,
  [110484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5602), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    STATE(1802), 1,
      sym_arguments,
  [110502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5267), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [110510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5604), 1,
      anon_sym_LBRACE,
    STATE(573), 1,
      sym_enum_body,
  [110520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    STATE(570), 1,
      sym_switch_body,
  [110530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1247), 1,
      sym_statement_block,
  [110540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2459), 1,
      sym_class_body,
  [110550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym__for_header,
  [110560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1763), 1,
      sym_class_body,
  [110570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2457), 1,
      sym_class_body,
  [110588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2984), 1,
      sym_statement_block,
  [110598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LBRACE,
    STATE(74), 1,
      sym_statement_block,
  [110608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(632), 1,
      sym_class_body,
  [110618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
  [110628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3059), 1,
      sym_statement_block,
  [110646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [110656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
  [110666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2384), 1,
      sym_formal_parameters,
  [110684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1248), 1,
      sym_class_body,
  [110694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5610), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_from,
    STATE(3154), 1,
      sym__from_clause,
  [110720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1205), 1,
      sym_class_body,
  [110730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3054), 1,
      sym_statement_block,
  [110756] = 3,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5614), 1,
      anon_sym_SQUOTE,
    ACTIONS(5616), 1,
      aux_sym_char_token1,
  [110766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1238), 1,
      sym_statement_block,
  [110776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(497), 1,
      sym_class_body,
  [110786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      sym_identifier,
    STATE(2930), 1,
      sym_nested_identifier,
  [110796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5620), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [110804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1235), 1,
      sym_class_body,
  [110814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1806), 1,
      sym_class_body,
  [110824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    STATE(2786), 1,
      sym_type_parameter,
  [110834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1687), 1,
      sym_class_body,
  [110844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2526), 1,
      sym_class_body,
  [110854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1810), 1,
      sym_statement_block,
  [110864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym__for_header,
  [110874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [110882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1245), 1,
      sym_statement_block,
  [110892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    STATE(2826), 1,
      sym_type_parameter,
  [110910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2987), 1,
      sym_statement_block,
  [110928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1833), 1,
      sym_statement_block,
  [110946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1221), 1,
      sym_class_body,
  [110956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1760), 1,
      sym_class_body,
  [110966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [110974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3096), 1,
      sym_statement_block,
  [110984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4258), 1,
      anon_sym_LT,
    STATE(2087), 1,
      sym_type_arguments,
  [110994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3266), 1,
      sym_formal_parameters,
  [111004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4581), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [111012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1242), 1,
      sym_class_body,
  [111022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(2546), 1,
      sym_formal_parameters,
  [111032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [111040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [111048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1692), 1,
      sym_statement_block,
  [111066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3205), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    STATE(1755), 1,
      sym_arguments,
  [111092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3101), 1,
      sym_statement_block,
  [111102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_identifier,
    STATE(2993), 1,
      sym_type_parameter,
  [111112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1254), 1,
      sym_class_body,
  [111122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_from,
    STATE(2960), 1,
      sym__from_clause,
  [111140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1475), 1,
      sym_statement_block,
  [111150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [111158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_class_body,
  [111168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2420), 1,
      sym_class_body,
  [111178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5636), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_class_body,
  [111204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    STATE(1179), 1,
      sym_arguments,
  [111222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3006), 1,
      sym_statement_block,
  [111232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      sym_identifier,
    ACTIONS(4792), 1,
      anon_sym_LBRACK,
  [111242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [111258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [111266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(2979), 1,
      sym_statement_block,
  [111276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3249), 1,
      sym_formal_parameters,
  [111310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_SEMI,
    ACTIONS(5646), 1,
      sym__automatic_semicolon,
  [111320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3389), 1,
      sym_formal_parameters,
  [111330] = 3,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_SQUOTE,
    ACTIONS(5650), 1,
      aux_sym_char_token1,
  [111340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1497), 1,
      sym_class_body,
  [111350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    STATE(1068), 1,
      sym_type_arguments,
  [111360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2418), 1,
      sym_class_body,
  [111370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2412), 1,
      sym_class_body,
  [111380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym_identifier,
    ACTIONS(5656), 1,
      anon_sym_STAR,
  [111390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    STATE(518), 1,
      sym_statement_block,
  [111400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2109), 1,
      sym_formal_parameters,
  [111410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      sym_identifier,
    STATE(2912), 1,
      sym_nested_identifier,
  [111420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_LPAREN,
    STATE(1849), 1,
      sym_arguments,
  [111430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 1,
      sym_identifier,
    ACTIONS(5662), 1,
      anon_sym_STAR,
  [111440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [111448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(498), 1,
      sym_class_body,
  [111458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LT,
    STATE(416), 1,
      sym_type_arguments,
  [111468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_LT,
    STATE(1439), 1,
      sym_type_arguments,
  [111486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3076), 1,
      sym_statement_block,
  [111496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1237), 1,
      sym_statement_block,
  [111506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1274), 1,
      sym_statement_block,
  [111516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1286), 1,
      sym_class_body,
  [111534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1737), 1,
      sym_statement_block,
  [111544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1583), 1,
      sym_class_body,
  [111554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1734), 1,
      sym_statement_block,
  [111564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    STATE(2528), 1,
      sym_statement_block,
  [111574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1846), 1,
      sym_class_body,
  [111584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_statement_block,
  [111594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1745), 1,
      sym_statement_block,
  [111604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym_identifier,
    ACTIONS(5670), 1,
      anon_sym_STAR,
  [111614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1219), 1,
      sym_statement_block,
  [111624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    STATE(1724), 1,
      sym_arguments,
  [111634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    STATE(2497), 1,
      sym_statement_block,
  [111644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_SEMI,
    ACTIONS(5674), 1,
      sym__automatic_semicolon,
  [111654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1840), 1,
      sym_class_body,
  [111664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1697), 1,
      sym_statement_block,
  [111674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1696), 1,
      sym_class_body,
  [111684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_LBRACE,
    STATE(2612), 1,
      sym_enum_body,
  [111694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2394), 1,
      sym_class_body,
  [111704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1744), 1,
      sym_class_body,
  [111714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1732), 1,
      sym_class_body,
  [111724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1838), 1,
      sym_statement_block,
  [111734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [111742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym_class_body,
  [111752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_COLON,
    ACTIONS(5682), 1,
      anon_sym_in,
  [111762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3352), 1,
      sym_formal_parameters,
  [111772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3361), 1,
      sym_formal_parameters,
  [111782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5099), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3388), 1,
      sym_formal_parameters,
  [111800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5348), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [111816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(73), 1,
      sym_class_body,
  [111826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [111834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_statement_block,
  [111844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1773), 1,
      sym_statement_block,
  [111854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_LPAREN,
    STATE(3078), 1,
      sym_parenthesized_expression,
  [111864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3391), 1,
      sym_formal_parameters,
  [111874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LBRACE,
    STATE(77), 1,
      sym_statement_block,
  [111884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(588), 1,
      sym_class_body,
  [111894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_class_body,
  [111904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5686), 1,
      anon_sym_SEMI,
    ACTIONS(5688), 1,
      sym__automatic_semicolon,
  [111914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_LPAREN,
    STATE(1271), 1,
      sym_arguments,
  [111924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [111932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(1747), 1,
      sym_statement_block,
  [111942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [111950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_LBRACE,
    STATE(2564), 1,
      sym_statement_block,
  [111960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3281), 1,
      sym_formal_parameters,
  [111970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_LBRACE,
    STATE(2575), 1,
      sym_enum_body,
  [111980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3273), 1,
      sym_formal_parameters,
  [111990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1836), 1,
      sym_statement_block,
  [112000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(3000), 1,
      sym_statement_block,
  [112010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_LPAREN,
    STATE(2237), 1,
      sym_formal_parameters,
  [112020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DQUOTE,
    STATE(3228), 1,
      sym_string,
  [112030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_SEMI,
    ACTIONS(5696), 1,
      sym__automatic_semicolon,
  [112040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1822), 1,
      sym_class_body,
  [112050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4706), 1,
      sym_identifier,
    ACTIONS(4708), 1,
      anon_sym_LBRACK,
  [112060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1823), 1,
      sym_statement_block,
  [112070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(511), 1,
      sym_statement_block,
  [112088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1830), 1,
      sym_class_body,
  [112098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LBRACE,
    STATE(1201), 1,
      sym_class_body,
  [112108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3202), 1,
      sym_formal_parameters,
  [112118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    STATE(3038), 1,
      sym_string,
  [112128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1825), 1,
      sym_class_body,
  [112138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2730), 1,
      sym_type_annotation,
  [112148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_LBRACE,
    STATE(1212), 1,
      sym_statement_block,
  [112158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5604), 1,
      anon_sym_LBRACE,
    STATE(533), 1,
      sym_enum_body,
  [112168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1828), 1,
      sym_class_body,
  [112178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1827), 1,
      sym_statement_block,
  [112188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_LPAREN,
    STATE(3278), 1,
      sym_formal_parameters,
  [112198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_SEMI,
    ACTIONS(5702), 1,
      sym__automatic_semicolon,
  [112208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(1826), 1,
      sym_statement_block,
  [112218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_statement_block,
  [112236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_statement_block,
  [112246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 1,
      anon_sym_RBRACE,
  [112253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 1,
      anon_sym_EQ_GT,
  [112260] = 2,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_regex_pattern,
  [112267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_SLASH2,
  [112274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_DOT,
  [112281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_RBRACK,
  [112288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 1,
      anon_sym_EQ_GT,
  [112295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 1,
      anon_sym_EQ_GT,
  [112302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 1,
      anon_sym_from,
  [112309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_target,
  [112316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_EQ_GT,
  [112323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
  [112330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      sym_identifier,
  [112337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5726), 1,
      anon_sym_EQ_GT,
  [112344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 1,
      anon_sym_COLON,
  [112351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_EQ_GT,
  [112358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      sym_identifier,
  [112365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_EQ_GT,
  [112372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_SQUOTE,
  [112379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4706), 1,
      sym_identifier,
  [112386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      sym_identifier,
  [112393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3897), 1,
      anon_sym_RPAREN,
  [112400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 1,
      anon_sym_RBRACK,
  [112407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_EQ,
  [112414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 1,
      anon_sym_RPAREN,
  [112421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3802), 1,
      anon_sym_RPAREN,
  [112428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      anon_sym_EQ_GT,
  [112435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_RPAREN,
  [112442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      anon_sym_from,
  [112449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_RPAREN,
  [112456] = 2,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5742), 1,
      sym_regex_pattern,
  [112463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3751), 1,
      anon_sym_RBRACK,
  [112470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 1,
      anon_sym_RPAREN,
  [112477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_DOT,
  [112484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 1,
      anon_sym_RBRACK,
  [112491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 1,
      sym_identifier,
  [112498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5748), 1,
      anon_sym_RPAREN,
  [112505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      sym_identifier,
  [112512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3913), 1,
      anon_sym_RPAREN,
  [112519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      anon_sym_RPAREN,
  [112526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5752), 1,
      anon_sym_EQ,
  [112533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 1,
      anon_sym_COLON,
  [112540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_DOT,
  [112547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 1,
      anon_sym_RBRACE,
  [112554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3929), 1,
      anon_sym_RPAREN,
  [112561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      sym_readonly,
  [112568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_COLON,
  [112575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 1,
      anon_sym_EQ,
  [112582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      anon_sym_from,
  [112589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_DOT,
  [112596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
  [112603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5764), 1,
      sym_identifier,
  [112610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 1,
      anon_sym_RPAREN,
  [112617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5768), 1,
      anon_sym_RBRACK,
  [112624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 1,
      anon_sym_SLASH2,
  [112631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
  [112638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      sym_identifier,
  [112645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5776), 1,
      anon_sym_from,
  [112652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      anon_sym_class,
  [112659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 1,
      sym_identifier,
  [112666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_RPAREN,
  [112673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5784), 1,
      anon_sym_EQ_GT,
  [112680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_RBRACK,
  [112687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 1,
      sym_identifier,
  [112694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_RPAREN,
  [112701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3855), 1,
      anon_sym_RBRACK,
  [112708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_EQ,
  [112715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 1,
      anon_sym_EQ_GT,
  [112722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5792), 1,
      anon_sym_LBRACK,
  [112729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_RPAREN,
  [112736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 1,
      anon_sym_RBRACK,
  [112743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      anon_sym_namespace,
  [112750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 1,
      sym_identifier,
  [112757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_EQ_GT,
  [112764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
  [112771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      anon_sym_EQ_GT,
  [112778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 1,
      sym_identifier,
  [112785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5804), 1,
      anon_sym_EQ_GT,
  [112792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 1,
      sym_identifier,
  [112799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 1,
      anon_sym_EQ_GT,
  [112806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 1,
      anon_sym_EQ_GT,
  [112813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_EQ_GT,
  [112820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 1,
      anon_sym_RBRACK,
  [112827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5814), 1,
      anon_sym_class,
  [112834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_EQ,
  [112841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      sym_identifier,
  [112848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_EQ,
  [112855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5822), 1,
      anon_sym_RBRACE,
  [112862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5824), 1,
      sym_identifier,
  [112869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5826), 1,
      anon_sym_RPAREN,
  [112876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5828), 1,
      anon_sym_EQ_GT,
  [112883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4844), 1,
      anon_sym_EQ_GT,
  [112890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5830), 1,
      sym_identifier,
  [112897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5832), 1,
      anon_sym_class,
  [112904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5834), 1,
      anon_sym_EQ_GT,
  [112911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5836), 1,
      sym_identifier,
  [112918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5838), 1,
      anon_sym_EQ_GT,
  [112925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5840), 1,
      anon_sym_EQ_GT,
  [112932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5842), 1,
      sym_identifier,
  [112939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5844), 1,
      sym_identifier,
  [112946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4840), 1,
      anon_sym_EQ_GT,
  [112953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      sym_identifier,
  [112960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 1,
      anon_sym_EQ_GT,
  [112967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5846), 1,
      anon_sym_SQUOTE,
  [112974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5848), 1,
      sym_identifier,
  [112981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5850), 1,
      anon_sym_EQ_GT,
  [112988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5852), 1,
      sym_identifier,
  [112995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5854), 1,
      sym_identifier,
  [113002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4926), 1,
      anon_sym_EQ_GT,
  [113009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4232), 1,
      anon_sym_DOT,
  [113016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4936), 1,
      anon_sym_EQ_GT,
  [113023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5856), 1,
      anon_sym_RPAREN,
  [113030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 1,
      anon_sym_RPAREN,
  [113037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_RBRACK,
  [113044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5860), 1,
      anon_sym_SLASH2,
  [113051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5862), 1,
      anon_sym_target,
  [113058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5864), 1,
      sym_identifier,
  [113065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5866), 1,
      sym_identifier,
  [113072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5868), 1,
      anon_sym_RPAREN,
  [113079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_DOT,
  [113086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_EQ_GT,
  [113093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 1,
      anon_sym_EQ_GT,
  [113100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5872), 1,
      sym_identifier,
  [113107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_EQ_GT,
  [113114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      sym_identifier,
  [113121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5876), 1,
      sym_identifier,
  [113128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 1,
      anon_sym_LBRACE,
  [113135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      sym_identifier,
  [113142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5880), 1,
      sym_identifier,
  [113149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3911), 1,
      anon_sym_RBRACK,
  [113156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_RPAREN,
  [113163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym_identifier,
  [113170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5884), 1,
      sym_identifier,
  [113177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_COLON,
  [113184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_RBRACK,
  [113191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 1,
      anon_sym_while,
  [113198] = 2,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(5890), 1,
      sym_regex_pattern,
  [113205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_COLON,
  [113212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      anon_sym_RPAREN,
  [113219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_RPAREN,
  [113226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 1,
      sym_identifier,
  [113233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5898), 1,
      anon_sym_EQ_GT,
  [113240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5900), 1,
      sym_identifier,
  [113247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 1,
      sym_identifier,
  [113254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      sym_identifier,
  [113261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym_identifier,
  [113268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym_identifier,
  [113275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 1,
      sym_identifier,
  [113282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      sym_identifier,
  [113289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 1,
      sym_identifier,
  [113296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      sym_identifier,
  [113303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5262), 1,
      anon_sym_from,
  [113310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym_identifier,
  [113317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 1,
      anon_sym_RBRACK,
  [113324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5918), 1,
      sym_identifier,
  [113331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 1,
      anon_sym_as,
  [113338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5922), 1,
      sym_identifier,
  [113345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5924), 1,
      sym_identifier,
  [113352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      sym_identifier,
  [113359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      sym_identifier,
  [113366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 1,
      sym_identifier,
  [113373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5932), 1,
      sym_identifier,
  [113380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 1,
      sym_identifier,
  [113387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5936), 1,
      sym_identifier,
  [113394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4772), 1,
      sym_identifier,
  [113401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 1,
      sym_identifier,
  [113408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5940), 1,
      anon_sym_SQUOTE,
  [113415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      sym_identifier,
  [113422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5944), 1,
      sym_identifier,
  [113429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 1,
      sym_identifier,
  [113436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_function,
  [113443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 1,
      sym_identifier,
  [113450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5952), 1,
      sym_identifier,
  [113457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      sym_identifier,
  [113464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4962), 1,
      anon_sym_EQ_GT,
  [113471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 1,
      sym_identifier,
  [113478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_EQ_GT,
  [113485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_EQ_GT,
  [113492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_SLASH2,
  [113499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 1,
      anon_sym_EQ_GT,
  [113506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5964), 1,
      anon_sym_EQ_GT,
  [113513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym_EQ_GT,
  [113520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_namespace,
  [113527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 1,
      sym_identifier,
  [113534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 1,
      anon_sym_target,
  [113541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      anon_sym_EQ_GT,
  [113548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 1,
      sym_identifier,
  [113555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4282), 1,
      anon_sym_is,
  [113562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_EQ_GT,
  [113569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      anon_sym_EQ_GT,
  [113576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_EQ_GT,
  [113583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5984), 1,
      anon_sym_EQ_GT,
  [113590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_COLON,
  [113597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      sym_identifier,
  [113604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5990), 1,
      ts_builtin_sym_end,
  [113611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 1,
      sym_identifier,
  [113618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5994), 1,
      anon_sym_function,
  [113625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_EQ_GT,
  [113632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5998), 1,
      anon_sym_from,
  [113639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_from,
  [113646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      sym_identifier,
  [113653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      sym_identifier,
  [113660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym_identifier,
  [113667] = 2,
    ACTIONS(4994), 1,
      sym_comment,
    ACTIONS(6008), 1,
      sym_regex_pattern,
  [113674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_class,
  [113681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      anon_sym_EQ_GT,
  [113688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6014), 1,
      anon_sym_from,
  [113695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_require,
  [113702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_is,
  [113709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_RBRACK,
  [113716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 1,
      anon_sym_LPAREN,
  [113723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6022), 1,
      anon_sym_from,
  [113730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6024), 1,
      anon_sym_EQ_GT,
  [113737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6026), 1,
      anon_sym_EQ_GT,
  [113744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      sym_identifier,
  [113751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6030), 1,
      anon_sym_EQ_GT,
  [113758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 1,
      sym_identifier,
  [113765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6034), 1,
      sym_identifier,
  [113772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      anon_sym_EQ_GT,
  [113779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_RPAREN,
  [113786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_RBRACK,
  [113793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6038), 1,
      anon_sym_RPAREN,
  [113800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6040), 1,
      sym_identifier,
  [113807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      sym_identifier,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(681)] = 0,
  [SMALL_STATE(682)] = 101,
  [SMALL_STATE(683)] = 203,
  [SMALL_STATE(684)] = 305,
  [SMALL_STATE(685)] = 407,
  [SMALL_STATE(686)] = 509,
  [SMALL_STATE(687)] = 611,
  [SMALL_STATE(688)] = 737,
  [SMALL_STATE(689)] = 837,
  [SMALL_STATE(690)] = 939,
  [SMALL_STATE(691)] = 1038,
  [SMALL_STATE(692)] = 1137,
  [SMALL_STATE(693)] = 1228,
  [SMALL_STATE(694)] = 1320,
  [SMALL_STATE(695)] = 1456,
  [SMALL_STATE(696)] = 1582,
  [SMALL_STATE(697)] = 1674,
  [SMALL_STATE(698)] = 1766,
  [SMALL_STATE(699)] = 1864,
  [SMALL_STATE(700)] = 1954,
  [SMALL_STATE(701)] = 2080,
  [SMALL_STATE(702)] = 2216,
  [SMALL_STATE(703)] = 2342,
  [SMALL_STATE(704)] = 2478,
  [SMALL_STATE(705)] = 2604,
  [SMALL_STATE(706)] = 2740,
  [SMALL_STATE(707)] = 2876,
  [SMALL_STATE(708)] = 3002,
  [SMALL_STATE(709)] = 3094,
  [SMALL_STATE(710)] = 3230,
  [SMALL_STATE(711)] = 3366,
  [SMALL_STATE(712)] = 3464,
  [SMALL_STATE(713)] = 3587,
  [SMALL_STATE(714)] = 3676,
  [SMALL_STATE(715)] = 3799,
  [SMALL_STATE(716)] = 3922,
  [SMALL_STATE(717)] = 4045,
  [SMALL_STATE(718)] = 4168,
  [SMALL_STATE(719)] = 4263,
  [SMALL_STATE(720)] = 4348,
  [SMALL_STATE(721)] = 4471,
  [SMALL_STATE(722)] = 4594,
  [SMALL_STATE(723)] = 4717,
  [SMALL_STATE(724)] = 4840,
  [SMALL_STATE(725)] = 4931,
  [SMALL_STATE(726)] = 5054,
  [SMALL_STATE(727)] = 5177,
  [SMALL_STATE(728)] = 5300,
  [SMALL_STATE(729)] = 5423,
  [SMALL_STATE(730)] = 5546,
  [SMALL_STATE(731)] = 5669,
  [SMALL_STATE(732)] = 5792,
  [SMALL_STATE(733)] = 5915,
  [SMALL_STATE(734)] = 6038,
  [SMALL_STATE(735)] = 6127,
  [SMALL_STATE(736)] = 6250,
  [SMALL_STATE(737)] = 6373,
  [SMALL_STATE(738)] = 6496,
  [SMALL_STATE(739)] = 6619,
  [SMALL_STATE(740)] = 6712,
  [SMALL_STATE(741)] = 6835,
  [SMALL_STATE(742)] = 6926,
  [SMALL_STATE(743)] = 7046,
  [SMALL_STATE(744)] = 7166,
  [SMALL_STATE(745)] = 7286,
  [SMALL_STATE(746)] = 7406,
  [SMALL_STATE(747)] = 7494,
  [SMALL_STATE(748)] = 7614,
  [SMALL_STATE(749)] = 7734,
  [SMALL_STATE(750)] = 7854,
  [SMALL_STATE(751)] = 7974,
  [SMALL_STATE(752)] = 8094,
  [SMALL_STATE(753)] = 8214,
  [SMALL_STATE(754)] = 8300,
  [SMALL_STATE(755)] = 8420,
  [SMALL_STATE(756)] = 8540,
  [SMALL_STATE(757)] = 8660,
  [SMALL_STATE(758)] = 8780,
  [SMALL_STATE(759)] = 8900,
  [SMALL_STATE(760)] = 9020,
  [SMALL_STATE(761)] = 9140,
  [SMALL_STATE(762)] = 9260,
  [SMALL_STATE(763)] = 9380,
  [SMALL_STATE(764)] = 9500,
  [SMALL_STATE(765)] = 9620,
  [SMALL_STATE(766)] = 9740,
  [SMALL_STATE(767)] = 9860,
  [SMALL_STATE(768)] = 9980,
  [SMALL_STATE(769)] = 10100,
  [SMALL_STATE(770)] = 10220,
  [SMALL_STATE(771)] = 10308,
  [SMALL_STATE(772)] = 10428,
  [SMALL_STATE(773)] = 10548,
  [SMALL_STATE(774)] = 10668,
  [SMALL_STATE(775)] = 10788,
  [SMALL_STATE(776)] = 10908,
  [SMALL_STATE(777)] = 11028,
  [SMALL_STATE(778)] = 11148,
  [SMALL_STATE(779)] = 11268,
  [SMALL_STATE(780)] = 11388,
  [SMALL_STATE(781)] = 11476,
  [SMALL_STATE(782)] = 11596,
  [SMALL_STATE(783)] = 11716,
  [SMALL_STATE(784)] = 11836,
  [SMALL_STATE(785)] = 11956,
  [SMALL_STATE(786)] = 12076,
  [SMALL_STATE(787)] = 12196,
  [SMALL_STATE(788)] = 12284,
  [SMALL_STATE(789)] = 12404,
  [SMALL_STATE(790)] = 12524,
  [SMALL_STATE(791)] = 12644,
  [SMALL_STATE(792)] = 12734,
  [SMALL_STATE(793)] = 12854,
  [SMALL_STATE(794)] = 12974,
  [SMALL_STATE(795)] = 13094,
  [SMALL_STATE(796)] = 13214,
  [SMALL_STATE(797)] = 13334,
  [SMALL_STATE(798)] = 13454,
  [SMALL_STATE(799)] = 13574,
  [SMALL_STATE(800)] = 13694,
  [SMALL_STATE(801)] = 13814,
  [SMALL_STATE(802)] = 13934,
  [SMALL_STATE(803)] = 14054,
  [SMALL_STATE(804)] = 14144,
  [SMALL_STATE(805)] = 14230,
  [SMALL_STATE(806)] = 14350,
  [SMALL_STATE(807)] = 14470,
  [SMALL_STATE(808)] = 14590,
  [SMALL_STATE(809)] = 14710,
  [SMALL_STATE(810)] = 14830,
  [SMALL_STATE(811)] = 14950,
  [SMALL_STATE(812)] = 15070,
  [SMALL_STATE(813)] = 15190,
  [SMALL_STATE(814)] = 15310,
  [SMALL_STATE(815)] = 15430,
  [SMALL_STATE(816)] = 15550,
  [SMALL_STATE(817)] = 15624,
  [SMALL_STATE(818)] = 15698,
  [SMALL_STATE(819)] = 15818,
  [SMALL_STATE(820)] = 15908,
  [SMALL_STATE(821)] = 16028,
  [SMALL_STATE(822)] = 16148,
  [SMALL_STATE(823)] = 16268,
  [SMALL_STATE(824)] = 16388,
  [SMALL_STATE(825)] = 16508,
  [SMALL_STATE(826)] = 16628,
  [SMALL_STATE(827)] = 16748,
  [SMALL_STATE(828)] = 16868,
  [SMALL_STATE(829)] = 16988,
  [SMALL_STATE(830)] = 17108,
  [SMALL_STATE(831)] = 17228,
  [SMALL_STATE(832)] = 17348,
  [SMALL_STATE(833)] = 17438,
  [SMALL_STATE(834)] = 17524,
  [SMALL_STATE(835)] = 17644,
  [SMALL_STATE(836)] = 17764,
  [SMALL_STATE(837)] = 17884,
  [SMALL_STATE(838)] = 18004,
  [SMALL_STATE(839)] = 18124,
  [SMALL_STATE(840)] = 18244,
  [SMALL_STATE(841)] = 18330,
  [SMALL_STATE(842)] = 18450,
  [SMALL_STATE(843)] = 18570,
  [SMALL_STATE(844)] = 18660,
  [SMALL_STATE(845)] = 18780,
  [SMALL_STATE(846)] = 18900,
  [SMALL_STATE(847)] = 19020,
  [SMALL_STATE(848)] = 19140,
  [SMALL_STATE(849)] = 19260,
  [SMALL_STATE(850)] = 19380,
  [SMALL_STATE(851)] = 19500,
  [SMALL_STATE(852)] = 19620,
  [SMALL_STATE(853)] = 19740,
  [SMALL_STATE(854)] = 19860,
  [SMALL_STATE(855)] = 19980,
  [SMALL_STATE(856)] = 20100,
  [SMALL_STATE(857)] = 20220,
  [SMALL_STATE(858)] = 20340,
  [SMALL_STATE(859)] = 20460,
  [SMALL_STATE(860)] = 20580,
  [SMALL_STATE(861)] = 20700,
  [SMALL_STATE(862)] = 20820,
  [SMALL_STATE(863)] = 20940,
  [SMALL_STATE(864)] = 21060,
  [SMALL_STATE(865)] = 21147,
  [SMALL_STATE(866)] = 21234,
  [SMALL_STATE(867)] = 21319,
  [SMALL_STATE(868)] = 21410,
  [SMALL_STATE(869)] = 21495,
  [SMALL_STATE(870)] = 21560,
  [SMALL_STATE(871)] = 21643,
  [SMALL_STATE(872)] = 21708,
  [SMALL_STATE(873)] = 21793,
  [SMALL_STATE(874)] = 21858,
  [SMALL_STATE(875)] = 21923,
  [SMALL_STATE(876)] = 21988,
  [SMALL_STATE(877)] = 22053,
  [SMALL_STATE(878)] = 22178,
  [SMALL_STATE(879)] = 22303,
  [SMALL_STATE(880)] = 22368,
  [SMALL_STATE(881)] = 22433,
  [SMALL_STATE(882)] = 22516,
  [SMALL_STATE(883)] = 22603,
  [SMALL_STATE(884)] = 22690,
  [SMALL_STATE(885)] = 22777,
  [SMALL_STATE(886)] = 22864,
  [SMALL_STATE(887)] = 22929,
  [SMALL_STATE(888)] = 23016,
  [SMALL_STATE(889)] = 23100,
  [SMALL_STATE(890)] = 23188,
  [SMALL_STATE(891)] = 23272,
  [SMALL_STATE(892)] = 23356,
  [SMALL_STATE(893)] = 23446,
  [SMALL_STATE(894)] = 23518,
  [SMALL_STATE(895)] = 23598,
  [SMALL_STATE(896)] = 23682,
  [SMALL_STATE(897)] = 23762,
  [SMALL_STATE(898)] = 23850,
  [SMALL_STATE(899)] = 23922,
  [SMALL_STATE(900)] = 23998,
  [SMALL_STATE(901)] = 24080,
  [SMALL_STATE(902)] = 24166,
  [SMALL_STATE(903)] = 24250,
  [SMALL_STATE(904)] = 24332,
  [SMALL_STATE(905)] = 24418,
  [SMALL_STATE(906)] = 24506,
  [SMALL_STATE(907)] = 24590,
  [SMALL_STATE(908)] = 24674,
  [SMALL_STATE(909)] = 24758,
  [SMALL_STATE(910)] = 24842,
  [SMALL_STATE(911)] = 24926,
  [SMALL_STATE(912)] = 25002,
  [SMALL_STATE(913)] = 25086,
  [SMALL_STATE(914)] = 25172,
  [SMALL_STATE(915)] = 25255,
  [SMALL_STATE(916)] = 25332,
  [SMALL_STATE(917)] = 25413,
  [SMALL_STATE(918)] = 25490,
  [SMALL_STATE(919)] = 25571,
  [SMALL_STATE(920)] = 25654,
  [SMALL_STATE(921)] = 25735,
  [SMALL_STATE(922)] = 25818,
  [SMALL_STATE(923)] = 25895,
  [SMALL_STATE(924)] = 25972,
  [SMALL_STATE(925)] = 26039,
  [SMALL_STATE(926)] = 26116,
  [SMALL_STATE(927)] = 26199,
  [SMALL_STATE(928)] = 26278,
  [SMALL_STATE(929)] = 26353,
  [SMALL_STATE(930)] = 26434,
  [SMALL_STATE(931)] = 26513,
  [SMALL_STATE(932)] = 26584,
  [SMALL_STATE(933)] = 26659,
  [SMALL_STATE(934)] = 26738,
  [SMALL_STATE(935)] = 26821,
  [SMALL_STATE(936)] = 26894,
  [SMALL_STATE(937)] = 26965,
  [SMALL_STATE(938)] = 27042,
  [SMALL_STATE(939)] = 27127,
  [SMALL_STATE(940)] = 27207,
  [SMALL_STATE(941)] = 27281,
  [SMALL_STATE(942)] = 27343,
  [SMALL_STATE(943)] = 27423,
  [SMALL_STATE(944)] = 27485,
  [SMALL_STATE(945)] = 27551,
  [SMALL_STATE(946)] = 27613,
  [SMALL_STATE(947)] = 27691,
  [SMALL_STATE(948)] = 27769,
  [SMALL_STATE(949)] = 27839,
  [SMALL_STATE(950)] = 27917,
  [SMALL_STATE(951)] = 27989,
  [SMALL_STATE(952)] = 28051,
  [SMALL_STATE(953)] = 28121,
  [SMALL_STATE(954)] = 28195,
  [SMALL_STATE(955)] = 28265,
  [SMALL_STATE(956)] = 28327,
  [SMALL_STATE(957)] = 28397,
  [SMALL_STATE(958)] = 28475,
  [SMALL_STATE(959)] = 28551,
  [SMALL_STATE(960)] = 28629,
  [SMALL_STATE(961)] = 28691,
  [SMALL_STATE(962)] = 28765,
  [SMALL_STATE(963)] = 28839,
  [SMALL_STATE(964)] = 28901,
  [SMALL_STATE(965)] = 28971,
  [SMALL_STATE(966)] = 29033,
  [SMALL_STATE(967)] = 29113,
  [SMALL_STATE(968)] = 29183,
  [SMALL_STATE(969)] = 29253,
  [SMALL_STATE(970)] = 29315,
  [SMALL_STATE(971)] = 29385,
  [SMALL_STATE(972)] = 29462,
  [SMALL_STATE(973)] = 29529,
  [SMALL_STATE(974)] = 29606,
  [SMALL_STATE(975)] = 29681,
  [SMALL_STATE(976)] = 29746,
  [SMALL_STATE(977)] = 29807,
  [SMALL_STATE(978)] = 29868,
  [SMALL_STATE(979)] = 29929,
  [SMALL_STATE(980)] = 29990,
  [SMALL_STATE(981)] = 30053,
  [SMALL_STATE(982)] = 30124,
  [SMALL_STATE(983)] = 30185,
  [SMALL_STATE(984)] = 30258,
  [SMALL_STATE(985)] = 30333,
  [SMALL_STATE(986)] = 30406,
  [SMALL_STATE(987)] = 30467,
  [SMALL_STATE(988)] = 30532,
  [SMALL_STATE(989)] = 30593,
  [SMALL_STATE(990)] = 30654,
  [SMALL_STATE(991)] = 30723,
  [SMALL_STATE(992)] = 30794,
  [SMALL_STATE(993)] = 30855,
  [SMALL_STATE(994)] = 30916,
  [SMALL_STATE(995)] = 30991,
  [SMALL_STATE(996)] = 31064,
  [SMALL_STATE(997)] = 31137,
  [SMALL_STATE(998)] = 31204,
  [SMALL_STATE(999)] = 31265,
  [SMALL_STATE(1000)] = 31335,
  [SMALL_STATE(1001)] = 31405,
  [SMALL_STATE(1002)] = 31469,
  [SMALL_STATE(1003)] = 31533,
  [SMALL_STATE(1004)] = 31644,
  [SMALL_STATE(1005)] = 31719,
  [SMALL_STATE(1006)] = 31794,
  [SMALL_STATE(1007)] = 31905,
  [SMALL_STATE(1008)] = 31980,
  [SMALL_STATE(1009)] = 32091,
  [SMALL_STATE(1010)] = 32202,
  [SMALL_STATE(1011)] = 32277,
  [SMALL_STATE(1012)] = 32388,
  [SMALL_STATE(1013)] = 32454,
  [SMALL_STATE(1014)] = 32526,
  [SMALL_STATE(1015)] = 32598,
  [SMALL_STATE(1016)] = 32664,
  [SMALL_STATE(1017)] = 32771,
  [SMALL_STATE(1018)] = 32878,
  [SMALL_STATE(1019)] = 32985,
  [SMALL_STATE(1020)] = 33092,
  [SMALL_STATE(1021)] = 33199,
  [SMALL_STATE(1022)] = 33306,
  [SMALL_STATE(1023)] = 33413,
  [SMALL_STATE(1024)] = 33520,
  [SMALL_STATE(1025)] = 33627,
  [SMALL_STATE(1026)] = 33734,
  [SMALL_STATE(1027)] = 33841,
  [SMALL_STATE(1028)] = 33948,
  [SMALL_STATE(1029)] = 34055,
  [SMALL_STATE(1030)] = 34162,
  [SMALL_STATE(1031)] = 34269,
  [SMALL_STATE(1032)] = 34377,
  [SMALL_STATE(1033)] = 34485,
  [SMALL_STATE(1034)] = 34593,
  [SMALL_STATE(1035)] = 34701,
  [SMALL_STATE(1036)] = 34772,
  [SMALL_STATE(1037)] = 34875,
  [SMALL_STATE(1038)] = 34980,
  [SMALL_STATE(1039)] = 35087,
  [SMALL_STATE(1040)] = 35190,
  [SMALL_STATE(1041)] = 35293,
  [SMALL_STATE(1042)] = 35396,
  [SMALL_STATE(1043)] = 35499,
  [SMALL_STATE(1044)] = 35602,
  [SMALL_STATE(1045)] = 35670,
  [SMALL_STATE(1046)] = 35726,
  [SMALL_STATE(1047)] = 35778,
  [SMALL_STATE(1048)] = 35846,
  [SMALL_STATE(1049)] = 35908,
  [SMALL_STATE(1050)] = 35960,
  [SMALL_STATE(1051)] = 36017,
  [SMALL_STATE(1052)] = 36072,
  [SMALL_STATE(1053)] = 36127,
  [SMALL_STATE(1054)] = 36192,
  [SMALL_STATE(1055)] = 36249,
  [SMALL_STATE(1056)] = 36304,
  [SMALL_STATE(1057)] = 36359,
  [SMALL_STATE(1058)] = 36412,
  [SMALL_STATE(1059)] = 36467,
  [SMALL_STATE(1060)] = 36559,
  [SMALL_STATE(1061)] = 36651,
  [SMALL_STATE(1062)] = 36743,
  [SMALL_STATE(1063)] = 36793,
  [SMALL_STATE(1064)] = 36843,
  [SMALL_STATE(1065)] = 36893,
  [SMALL_STATE(1066)] = 36985,
  [SMALL_STATE(1067)] = 37057,
  [SMALL_STATE(1068)] = 37107,
  [SMALL_STATE(1069)] = 37157,
  [SMALL_STATE(1070)] = 37207,
  [SMALL_STATE(1071)] = 37257,
  [SMALL_STATE(1072)] = 37347,
  [SMALL_STATE(1073)] = 37397,
  [SMALL_STATE(1074)] = 37485,
  [SMALL_STATE(1075)] = 37535,
  [SMALL_STATE(1076)] = 37585,
  [SMALL_STATE(1077)] = 37637,
  [SMALL_STATE(1078)] = 37705,
  [SMALL_STATE(1079)] = 37755,
  [SMALL_STATE(1080)] = 37825,
  [SMALL_STATE(1081)] = 37917,
  [SMALL_STATE(1082)] = 38009,
  [SMALL_STATE(1083)] = 38059,
  [SMALL_STATE(1084)] = 38147,
  [SMALL_STATE(1085)] = 38239,
  [SMALL_STATE(1086)] = 38289,
  [SMALL_STATE(1087)] = 38339,
  [SMALL_STATE(1088)] = 38389,
  [SMALL_STATE(1089)] = 38439,
  [SMALL_STATE(1090)] = 38493,
  [SMALL_STATE(1091)] = 38545,
  [SMALL_STATE(1092)] = 38599,
  [SMALL_STATE(1093)] = 38649,
  [SMALL_STATE(1094)] = 38701,
  [SMALL_STATE(1095)] = 38753,
  [SMALL_STATE(1096)] = 38803,
  [SMALL_STATE(1097)] = 38893,
  [SMALL_STATE(1098)] = 38943,
  [SMALL_STATE(1099)] = 39013,
  [SMALL_STATE(1100)] = 39075,
  [SMALL_STATE(1101)] = 39131,
  [SMALL_STATE(1102)] = 39181,
  [SMALL_STATE(1103)] = 39271,
  [SMALL_STATE(1104)] = 39363,
  [SMALL_STATE(1105)] = 39413,
  [SMALL_STATE(1106)] = 39463,
  [SMALL_STATE(1107)] = 39513,
  [SMALL_STATE(1108)] = 39563,
  [SMALL_STATE(1109)] = 39613,
  [SMALL_STATE(1110)] = 39667,
  [SMALL_STATE(1111)] = 39717,
  [SMALL_STATE(1112)] = 39805,
  [SMALL_STATE(1113)] = 39893,
  [SMALL_STATE(1114)] = 39955,
  [SMALL_STATE(1115)] = 40043,
  [SMALL_STATE(1116)] = 40099,
  [SMALL_STATE(1117)] = 40149,
  [SMALL_STATE(1118)] = 40237,
  [SMALL_STATE(1119)] = 40289,
  [SMALL_STATE(1120)] = 40341,
  [SMALL_STATE(1121)] = 40433,
  [SMALL_STATE(1122)] = 40525,
  [SMALL_STATE(1123)] = 40617,
  [SMALL_STATE(1124)] = 40667,
  [SMALL_STATE(1125)] = 40755,
  [SMALL_STATE(1126)] = 40805,
  [SMALL_STATE(1127)] = 40875,
  [SMALL_STATE(1128)] = 40959,
  [SMALL_STATE(1129)] = 41011,
  [SMALL_STATE(1130)] = 41061,
  [SMALL_STATE(1131)] = 41111,
  [SMALL_STATE(1132)] = 41199,
  [SMALL_STATE(1133)] = 41253,
  [SMALL_STATE(1134)] = 41307,
  [SMALL_STATE(1135)] = 41399,
  [SMALL_STATE(1136)] = 41455,
  [SMALL_STATE(1137)] = 41535,
  [SMALL_STATE(1138)] = 41585,
  [SMALL_STATE(1139)] = 41661,
  [SMALL_STATE(1140)] = 41753,
  [SMALL_STATE(1141)] = 41803,
  [SMALL_STATE(1142)] = 41891,
  [SMALL_STATE(1143)] = 41961,
  [SMALL_STATE(1144)] = 42011,
  [SMALL_STATE(1145)] = 42061,
  [SMALL_STATE(1146)] = 42123,
  [SMALL_STATE(1147)] = 42217,
  [SMALL_STATE(1148)] = 42273,
  [SMALL_STATE(1149)] = 42363,
  [SMALL_STATE(1150)] = 42451,
  [SMALL_STATE(1151)] = 42501,
  [SMALL_STATE(1152)] = 42551,
  [SMALL_STATE(1153)] = 42639,
  [SMALL_STATE(1154)] = 42691,
  [SMALL_STATE(1155)] = 42779,
  [SMALL_STATE(1156)] = 42833,
  [SMALL_STATE(1157)] = 42883,
  [SMALL_STATE(1158)] = 42971,
  [SMALL_STATE(1159)] = 43061,
  [SMALL_STATE(1160)] = 43111,
  [SMALL_STATE(1161)] = 43161,
  [SMALL_STATE(1162)] = 43211,
  [SMALL_STATE(1163)] = 43267,
  [SMALL_STATE(1164)] = 43317,
  [SMALL_STATE(1165)] = 43409,
  [SMALL_STATE(1166)] = 43501,
  [SMALL_STATE(1167)] = 43589,
  [SMALL_STATE(1168)] = 43644,
  [SMALL_STATE(1169)] = 43693,
  [SMALL_STATE(1170)] = 43742,
  [SMALL_STATE(1171)] = 43837,
  [SMALL_STATE(1172)] = 43932,
  [SMALL_STATE(1173)] = 44027,
  [SMALL_STATE(1174)] = 44096,
  [SMALL_STATE(1175)] = 44165,
  [SMALL_STATE(1176)] = 44252,
  [SMALL_STATE(1177)] = 44347,
  [SMALL_STATE(1178)] = 44396,
  [SMALL_STATE(1179)] = 44445,
  [SMALL_STATE(1180)] = 44494,
  [SMALL_STATE(1181)] = 44543,
  [SMALL_STATE(1182)] = 44592,
  [SMALL_STATE(1183)] = 44641,
  [SMALL_STATE(1184)] = 44732,
  [SMALL_STATE(1185)] = 44823,
  [SMALL_STATE(1186)] = 44914,
  [SMALL_STATE(1187)] = 45005,
  [SMALL_STATE(1188)] = 45096,
  [SMALL_STATE(1189)] = 45193,
  [SMALL_STATE(1190)] = 45242,
  [SMALL_STATE(1191)] = 45291,
  [SMALL_STATE(1192)] = 45360,
  [SMALL_STATE(1193)] = 45443,
  [SMALL_STATE(1194)] = 45522,
  [SMALL_STATE(1195)] = 45597,
  [SMALL_STATE(1196)] = 45668,
  [SMALL_STATE(1197)] = 45717,
  [SMALL_STATE(1198)] = 45808,
  [SMALL_STATE(1199)] = 45899,
  [SMALL_STATE(1200)] = 45948,
  [SMALL_STATE(1201)] = 46045,
  [SMALL_STATE(1202)] = 46094,
  [SMALL_STATE(1203)] = 46185,
  [SMALL_STATE(1204)] = 46234,
  [SMALL_STATE(1205)] = 46331,
  [SMALL_STATE(1206)] = 46380,
  [SMALL_STATE(1207)] = 46471,
  [SMALL_STATE(1208)] = 46562,
  [SMALL_STATE(1209)] = 46611,
  [SMALL_STATE(1210)] = 46702,
  [SMALL_STATE(1211)] = 46793,
  [SMALL_STATE(1212)] = 46878,
  [SMALL_STATE(1213)] = 46927,
  [SMALL_STATE(1214)] = 46976,
  [SMALL_STATE(1215)] = 47067,
  [SMALL_STATE(1216)] = 47122,
  [SMALL_STATE(1217)] = 47175,
  [SMALL_STATE(1218)] = 47224,
  [SMALL_STATE(1219)] = 47273,
  [SMALL_STATE(1220)] = 47322,
  [SMALL_STATE(1221)] = 47371,
  [SMALL_STATE(1222)] = 47420,
  [SMALL_STATE(1223)] = 47469,
  [SMALL_STATE(1224)] = 47518,
  [SMALL_STATE(1225)] = 47567,
  [SMALL_STATE(1226)] = 47616,
  [SMALL_STATE(1227)] = 47685,
  [SMALL_STATE(1228)] = 47754,
  [SMALL_STATE(1229)] = 47803,
  [SMALL_STATE(1230)] = 47852,
  [SMALL_STATE(1231)] = 47901,
  [SMALL_STATE(1232)] = 47950,
  [SMALL_STATE(1233)] = 47999,
  [SMALL_STATE(1234)] = 48048,
  [SMALL_STATE(1235)] = 48097,
  [SMALL_STATE(1236)] = 48146,
  [SMALL_STATE(1237)] = 48195,
  [SMALL_STATE(1238)] = 48244,
  [SMALL_STATE(1239)] = 48293,
  [SMALL_STATE(1240)] = 48366,
  [SMALL_STATE(1241)] = 48437,
  [SMALL_STATE(1242)] = 48486,
  [SMALL_STATE(1243)] = 48535,
  [SMALL_STATE(1244)] = 48584,
  [SMALL_STATE(1245)] = 48633,
  [SMALL_STATE(1246)] = 48682,
  [SMALL_STATE(1247)] = 48773,
  [SMALL_STATE(1248)] = 48822,
  [SMALL_STATE(1249)] = 48871,
  [SMALL_STATE(1250)] = 48920,
  [SMALL_STATE(1251)] = 48969,
  [SMALL_STATE(1252)] = 49042,
  [SMALL_STATE(1253)] = 49095,
  [SMALL_STATE(1254)] = 49166,
  [SMALL_STATE(1255)] = 49215,
  [SMALL_STATE(1256)] = 49310,
  [SMALL_STATE(1257)] = 49359,
  [SMALL_STATE(1258)] = 49428,
  [SMALL_STATE(1259)] = 49525,
  [SMALL_STATE(1260)] = 49594,
  [SMALL_STATE(1261)] = 49643,
  [SMALL_STATE(1262)] = 49692,
  [SMALL_STATE(1263)] = 49741,
  [SMALL_STATE(1264)] = 49800,
  [SMALL_STATE(1265)] = 49849,
  [SMALL_STATE(1266)] = 49918,
  [SMALL_STATE(1267)] = 49987,
  [SMALL_STATE(1268)] = 50060,
  [SMALL_STATE(1269)] = 50131,
  [SMALL_STATE(1270)] = 50228,
  [SMALL_STATE(1271)] = 50319,
  [SMALL_STATE(1272)] = 50368,
  [SMALL_STATE(1273)] = 50417,
  [SMALL_STATE(1274)] = 50508,
  [SMALL_STATE(1275)] = 50557,
  [SMALL_STATE(1276)] = 50606,
  [SMALL_STATE(1277)] = 50655,
  [SMALL_STATE(1278)] = 50724,
  [SMALL_STATE(1279)] = 50789,
  [SMALL_STATE(1280)] = 50862,
  [SMALL_STATE(1281)] = 50933,
  [SMALL_STATE(1282)] = 50982,
  [SMALL_STATE(1283)] = 51047,
  [SMALL_STATE(1284)] = 51114,
  [SMALL_STATE(1285)] = 51211,
  [SMALL_STATE(1286)] = 51260,
  [SMALL_STATE(1287)] = 51309,
  [SMALL_STATE(1288)] = 51379,
  [SMALL_STATE(1289)] = 51433,
  [SMALL_STATE(1290)] = 51519,
  [SMALL_STATE(1291)] = 51613,
  [SMALL_STATE(1292)] = 51661,
  [SMALL_STATE(1293)] = 51751,
  [SMALL_STATE(1294)] = 51843,
  [SMALL_STATE(1295)] = 51935,
  [SMALL_STATE(1296)] = 51983,
  [SMALL_STATE(1297)] = 52031,
  [SMALL_STATE(1298)] = 52079,
  [SMALL_STATE(1299)] = 52147,
  [SMALL_STATE(1300)] = 52215,
  [SMALL_STATE(1301)] = 52265,
  [SMALL_STATE(1302)] = 52357,
  [SMALL_STATE(1303)] = 52405,
  [SMALL_STATE(1304)] = 52499,
  [SMALL_STATE(1305)] = 52591,
  [SMALL_STATE(1306)] = 52655,
  [SMALL_STATE(1307)] = 52715,
  [SMALL_STATE(1308)] = 52781,
  [SMALL_STATE(1309)] = 52849,
  [SMALL_STATE(1310)] = 52941,
  [SMALL_STATE(1311)] = 53003,
  [SMALL_STATE(1312)] = 53093,
  [SMALL_STATE(1313)] = 53185,
  [SMALL_STATE(1314)] = 53277,
  [SMALL_STATE(1315)] = 53367,
  [SMALL_STATE(1316)] = 53435,
  [SMALL_STATE(1317)] = 53489,
  [SMALL_STATE(1318)] = 53557,
  [SMALL_STATE(1319)] = 53649,
  [SMALL_STATE(1320)] = 53741,
  [SMALL_STATE(1321)] = 53833,
  [SMALL_STATE(1322)] = 53927,
  [SMALL_STATE(1323)] = 54017,
  [SMALL_STATE(1324)] = 54111,
  [SMALL_STATE(1325)] = 54179,
  [SMALL_STATE(1326)] = 54251,
  [SMALL_STATE(1327)] = 54299,
  [SMALL_STATE(1328)] = 54349,
  [SMALL_STATE(1329)] = 54419,
  [SMALL_STATE(1330)] = 54513,
  [SMALL_STATE(1331)] = 54561,
  [SMALL_STATE(1332)] = 54655,
  [SMALL_STATE(1333)] = 54747,
  [SMALL_STATE(1334)] = 54799,
  [SMALL_STATE(1335)] = 54893,
  [SMALL_STATE(1336)] = 54985,
  [SMALL_STATE(1337)] = 55033,
  [SMALL_STATE(1338)] = 55125,
  [SMALL_STATE(1339)] = 55217,
  [SMALL_STATE(1340)] = 55285,
  [SMALL_STATE(1341)] = 55333,
  [SMALL_STATE(1342)] = 55425,
  [SMALL_STATE(1343)] = 55489,
  [SMALL_STATE(1344)] = 55583,
  [SMALL_STATE(1345)] = 55651,
  [SMALL_STATE(1346)] = 55725,
  [SMALL_STATE(1347)] = 55773,
  [SMALL_STATE(1348)] = 55867,
  [SMALL_STATE(1349)] = 55931,
  [SMALL_STATE(1350)] = 55997,
  [SMALL_STATE(1351)] = 56087,
  [SMALL_STATE(1352)] = 56139,
  [SMALL_STATE(1353)] = 56229,
  [SMALL_STATE(1354)] = 56319,
  [SMALL_STATE(1355)] = 56409,
  [SMALL_STATE(1356)] = 56499,
  [SMALL_STATE(1357)] = 56577,
  [SMALL_STATE(1358)] = 56667,
  [SMALL_STATE(1359)] = 56731,
  [SMALL_STATE(1360)] = 56821,
  [SMALL_STATE(1361)] = 56911,
  [SMALL_STATE(1362)] = 57001,
  [SMALL_STATE(1363)] = 57091,
  [SMALL_STATE(1364)] = 57161,
  [SMALL_STATE(1365)] = 57235,
  [SMALL_STATE(1366)] = 57313,
  [SMALL_STATE(1367)] = 57403,
  [SMALL_STATE(1368)] = 57485,
  [SMALL_STATE(1369)] = 57533,
  [SMALL_STATE(1370)] = 57623,
  [SMALL_STATE(1371)] = 57713,
  [SMALL_STATE(1372)] = 57761,
  [SMALL_STATE(1373)] = 57817,
  [SMALL_STATE(1374)] = 57865,
  [SMALL_STATE(1375)] = 57921,
  [SMALL_STATE(1376)] = 58013,
  [SMALL_STATE(1377)] = 58063,
  [SMALL_STATE(1378)] = 58155,
  [SMALL_STATE(1379)] = 58223,
  [SMALL_STATE(1380)] = 58271,
  [SMALL_STATE(1381)] = 58363,
  [SMALL_STATE(1382)] = 58431,
  [SMALL_STATE(1383)] = 58489,
  [SMALL_STATE(1384)] = 58581,
  [SMALL_STATE(1385)] = 58675,
  [SMALL_STATE(1386)] = 58767,
  [SMALL_STATE(1387)] = 58817,
  [SMALL_STATE(1388)] = 58869,
  [SMALL_STATE(1389)] = 58921,
  [SMALL_STATE(1390)] = 58981,
  [SMALL_STATE(1391)] = 59063,
  [SMALL_STATE(1392)] = 59157,
  [SMALL_STATE(1393)] = 59247,
  [SMALL_STATE(1394)] = 59299,
  [SMALL_STATE(1395)] = 59349,
  [SMALL_STATE(1396)] = 59401,
  [SMALL_STATE(1397)] = 59465,
  [SMALL_STATE(1398)] = 59555,
  [SMALL_STATE(1399)] = 59649,
  [SMALL_STATE(1400)] = 59717,
  [SMALL_STATE(1401)] = 59811,
  [SMALL_STATE(1402)] = 59871,
  [SMALL_STATE(1403)] = 59961,
  [SMALL_STATE(1404)] = 60051,
  [SMALL_STATE(1405)] = 60145,
  [SMALL_STATE(1406)] = 60209,
  [SMALL_STATE(1407)] = 60295,
  [SMALL_STATE(1408)] = 60385,
  [SMALL_STATE(1409)] = 60474,
  [SMALL_STATE(1410)] = 60565,
  [SMALL_STATE(1411)] = 60656,
  [SMALL_STATE(1412)] = 60707,
  [SMALL_STATE(1413)] = 60758,
  [SMALL_STATE(1414)] = 60849,
  [SMALL_STATE(1415)] = 60940,
  [SMALL_STATE(1416)] = 61031,
  [SMALL_STATE(1417)] = 61080,
  [SMALL_STATE(1418)] = 61133,
  [SMALL_STATE(1419)] = 61186,
  [SMALL_STATE(1420)] = 61235,
  [SMALL_STATE(1421)] = 61298,
  [SMALL_STATE(1422)] = 61349,
  [SMALL_STATE(1423)] = 61400,
  [SMALL_STATE(1424)] = 61491,
  [SMALL_STATE(1425)] = 61580,
  [SMALL_STATE(1426)] = 61643,
  [SMALL_STATE(1427)] = 61732,
  [SMALL_STATE(1428)] = 61821,
  [SMALL_STATE(1429)] = 61910,
  [SMALL_STATE(1430)] = 61959,
  [SMALL_STATE(1431)] = 62010,
  [SMALL_STATE(1432)] = 62101,
  [SMALL_STATE(1433)] = 62152,
  [SMALL_STATE(1434)] = 62205,
  [SMALL_STATE(1435)] = 62272,
  [SMALL_STATE(1436)] = 62363,
  [SMALL_STATE(1437)] = 62414,
  [SMALL_STATE(1438)] = 62479,
  [SMALL_STATE(1439)] = 62526,
  [SMALL_STATE(1440)] = 62573,
  [SMALL_STATE(1441)] = 62620,
  [SMALL_STATE(1442)] = 62671,
  [SMALL_STATE(1443)] = 62722,
  [SMALL_STATE(1444)] = 62811,
  [SMALL_STATE(1445)] = 62860,
  [SMALL_STATE(1446)] = 62907,
  [SMALL_STATE(1447)] = 62972,
  [SMALL_STATE(1448)] = 63039,
  [SMALL_STATE(1449)] = 63106,
  [SMALL_STATE(1450)] = 63153,
  [SMALL_STATE(1451)] = 63200,
  [SMALL_STATE(1452)] = 63247,
  [SMALL_STATE(1453)] = 63294,
  [SMALL_STATE(1454)] = 63341,
  [SMALL_STATE(1455)] = 63390,
  [SMALL_STATE(1456)] = 63437,
  [SMALL_STATE(1457)] = 63528,
  [SMALL_STATE(1458)] = 63619,
  [SMALL_STATE(1459)] = 63666,
  [SMALL_STATE(1460)] = 63715,
  [SMALL_STATE(1461)] = 63778,
  [SMALL_STATE(1462)] = 63845,
  [SMALL_STATE(1463)] = 63892,
  [SMALL_STATE(1464)] = 63957,
  [SMALL_STATE(1465)] = 64004,
  [SMALL_STATE(1466)] = 64095,
  [SMALL_STATE(1467)] = 64184,
  [SMALL_STATE(1468)] = 64231,
  [SMALL_STATE(1469)] = 64294,
  [SMALL_STATE(1470)] = 64347,
  [SMALL_STATE(1471)] = 64410,
  [SMALL_STATE(1472)] = 64501,
  [SMALL_STATE(1473)] = 64554,
  [SMALL_STATE(1474)] = 64607,
  [SMALL_STATE(1475)] = 64658,
  [SMALL_STATE(1476)] = 64709,
  [SMALL_STATE(1477)] = 64756,
  [SMALL_STATE(1478)] = 64803,
  [SMALL_STATE(1479)] = 64892,
  [SMALL_STATE(1480)] = 64943,
  [SMALL_STATE(1481)] = 65032,
  [SMALL_STATE(1482)] = 65085,
  [SMALL_STATE(1483)] = 65152,
  [SMALL_STATE(1484)] = 65215,
  [SMALL_STATE(1485)] = 65262,
  [SMALL_STATE(1486)] = 65311,
  [SMALL_STATE(1487)] = 65362,
  [SMALL_STATE(1488)] = 65409,
  [SMALL_STATE(1489)] = 65456,
  [SMALL_STATE(1490)] = 65505,
  [SMALL_STATE(1491)] = 65594,
  [SMALL_STATE(1492)] = 65659,
  [SMALL_STATE(1493)] = 65710,
  [SMALL_STATE(1494)] = 65775,
  [SMALL_STATE(1495)] = 65842,
  [SMALL_STATE(1496)] = 65931,
  [SMALL_STATE(1497)] = 65990,
  [SMALL_STATE(1498)] = 66041,
  [SMALL_STATE(1499)] = 66132,
  [SMALL_STATE(1500)] = 66221,
  [SMALL_STATE(1501)] = 66288,
  [SMALL_STATE(1502)] = 66377,
  [SMALL_STATE(1503)] = 66466,
  [SMALL_STATE(1504)] = 66513,
  [SMALL_STATE(1505)] = 66602,
  [SMALL_STATE(1506)] = 66693,
  [SMALL_STATE(1507)] = 66762,
  [SMALL_STATE(1508)] = 66809,
  [SMALL_STATE(1509)] = 66856,
  [SMALL_STATE(1510)] = 66903,
  [SMALL_STATE(1511)] = 66992,
  [SMALL_STATE(1512)] = 67081,
  [SMALL_STATE(1513)] = 67170,
  [SMALL_STATE(1514)] = 67225,
  [SMALL_STATE(1515)] = 67280,
  [SMALL_STATE(1516)] = 67353,
  [SMALL_STATE(1517)] = 67404,
  [SMALL_STATE(1518)] = 67451,
  [SMALL_STATE(1519)] = 67542,
  [SMALL_STATE(1520)] = 67631,
  [SMALL_STATE(1521)] = 67678,
  [SMALL_STATE(1522)] = 67725,
  [SMALL_STATE(1523)] = 67790,
  [SMALL_STATE(1524)] = 67853,
  [SMALL_STATE(1525)] = 67904,
  [SMALL_STATE(1526)] = 67955,
  [SMALL_STATE(1527)] = 68032,
  [SMALL_STATE(1528)] = 68079,
  [SMALL_STATE(1529)] = 68170,
  [SMALL_STATE(1530)] = 68259,
  [SMALL_STATE(1531)] = 68320,
  [SMALL_STATE(1532)] = 68385,
  [SMALL_STATE(1533)] = 68432,
  [SMALL_STATE(1534)] = 68483,
  [SMALL_STATE(1535)] = 68564,
  [SMALL_STATE(1536)] = 68631,
  [SMALL_STATE(1537)] = 68678,
  [SMALL_STATE(1538)] = 68725,
  [SMALL_STATE(1539)] = 68772,
  [SMALL_STATE(1540)] = 68821,
  [SMALL_STATE(1541)] = 68884,
  [SMALL_STATE(1542)] = 68931,
  [SMALL_STATE(1543)] = 68998,
  [SMALL_STATE(1544)] = 69087,
  [SMALL_STATE(1545)] = 69178,
  [SMALL_STATE(1546)] = 69243,
  [SMALL_STATE(1547)] = 69332,
  [SMALL_STATE(1548)] = 69391,
  [SMALL_STATE(1549)] = 69450,
  [SMALL_STATE(1550)] = 69503,
  [SMALL_STATE(1551)] = 69554,
  [SMALL_STATE(1552)] = 69617,
  [SMALL_STATE(1553)] = 69706,
  [SMALL_STATE(1554)] = 69795,
  [SMALL_STATE(1555)] = 69880,
  [SMALL_STATE(1556)] = 69945,
  [SMALL_STATE(1557)] = 70034,
  [SMALL_STATE(1558)] = 70101,
  [SMALL_STATE(1559)] = 70186,
  [SMALL_STATE(1560)] = 70275,
  [SMALL_STATE(1561)] = 70356,
  [SMALL_STATE(1562)] = 70447,
  [SMALL_STATE(1563)] = 70524,
  [SMALL_STATE(1564)] = 70587,
  [SMALL_STATE(1565)] = 70654,
  [SMALL_STATE(1566)] = 70719,
  [SMALL_STATE(1567)] = 70792,
  [SMALL_STATE(1568)] = 70883,
  [SMALL_STATE(1569)] = 70972,
  [SMALL_STATE(1570)] = 71061,
  [SMALL_STATE(1571)] = 71150,
  [SMALL_STATE(1572)] = 71239,
  [SMALL_STATE(1573)] = 71306,
  [SMALL_STATE(1574)] = 71375,
  [SMALL_STATE(1575)] = 71438,
  [SMALL_STATE(1576)] = 71527,
  [SMALL_STATE(1577)] = 71594,
  [SMALL_STATE(1578)] = 71683,
  [SMALL_STATE(1579)] = 71774,
  [SMALL_STATE(1580)] = 71865,
  [SMALL_STATE(1581)] = 71956,
  [SMALL_STATE(1582)] = 72019,
  [SMALL_STATE(1583)] = 72108,
  [SMALL_STATE(1584)] = 72159,
  [SMALL_STATE(1585)] = 72210,
  [SMALL_STATE(1586)] = 72299,
  [SMALL_STATE(1587)] = 72390,
  [SMALL_STATE(1588)] = 72481,
  [SMALL_STATE(1589)] = 72572,
  [SMALL_STATE(1590)] = 72625,
  [SMALL_STATE(1591)] = 72714,
  [SMALL_STATE(1592)] = 72803,
  [SMALL_STATE(1593)] = 72894,
  [SMALL_STATE(1594)] = 72985,
  [SMALL_STATE(1595)] = 73074,
  [SMALL_STATE(1596)] = 73125,
  [SMALL_STATE(1597)] = 73171,
  [SMALL_STATE(1598)] = 73223,
  [SMALL_STATE(1599)] = 73277,
  [SMALL_STATE(1600)] = 73333,
  [SMALL_STATE(1601)] = 73403,
  [SMALL_STATE(1602)] = 73455,
  [SMALL_STATE(1603)] = 73529,
  [SMALL_STATE(1604)] = 73575,
  [SMALL_STATE(1605)] = 73663,
  [SMALL_STATE(1606)] = 73721,
  [SMALL_STATE(1607)] = 73793,
  [SMALL_STATE(1608)] = 73865,
  [SMALL_STATE(1609)] = 73939,
  [SMALL_STATE(1610)] = 74009,
  [SMALL_STATE(1611)] = 74063,
  [SMALL_STATE(1612)] = 74109,
  [SMALL_STATE(1613)] = 74163,
  [SMALL_STATE(1614)] = 74221,
  [SMALL_STATE(1615)] = 74267,
  [SMALL_STATE(1616)] = 74313,
  [SMALL_STATE(1617)] = 74359,
  [SMALL_STATE(1618)] = 74405,
  [SMALL_STATE(1619)] = 74465,
  [SMALL_STATE(1620)] = 74525,
  [SMALL_STATE(1621)] = 74585,
  [SMALL_STATE(1622)] = 74631,
  [SMALL_STATE(1623)] = 74685,
  [SMALL_STATE(1624)] = 74731,
  [SMALL_STATE(1625)] = 74789,
  [SMALL_STATE(1626)] = 74835,
  [SMALL_STATE(1627)] = 74881,
  [SMALL_STATE(1628)] = 74933,
  [SMALL_STATE(1629)] = 74979,
  [SMALL_STATE(1630)] = 75025,
  [SMALL_STATE(1631)] = 75083,
  [SMALL_STATE(1632)] = 75129,
  [SMALL_STATE(1633)] = 75175,
  [SMALL_STATE(1634)] = 75221,
  [SMALL_STATE(1635)] = 75267,
  [SMALL_STATE(1636)] = 75317,
  [SMALL_STATE(1637)] = 75363,
  [SMALL_STATE(1638)] = 75415,
  [SMALL_STATE(1639)] = 75471,
  [SMALL_STATE(1640)] = 75517,
  [SMALL_STATE(1641)] = 75563,
  [SMALL_STATE(1642)] = 75609,
  [SMALL_STATE(1643)] = 75655,
  [SMALL_STATE(1644)] = 75705,
  [SMALL_STATE(1645)] = 75751,
  [SMALL_STATE(1646)] = 75797,
  [SMALL_STATE(1647)] = 75855,
  [SMALL_STATE(1648)] = 75911,
  [SMALL_STATE(1649)] = 75957,
  [SMALL_STATE(1650)] = 76003,
  [SMALL_STATE(1651)] = 76049,
  [SMALL_STATE(1652)] = 76137,
  [SMALL_STATE(1653)] = 76183,
  [SMALL_STATE(1654)] = 76229,
  [SMALL_STATE(1655)] = 76285,
  [SMALL_STATE(1656)] = 76331,
  [SMALL_STATE(1657)] = 76387,
  [SMALL_STATE(1658)] = 76433,
  [SMALL_STATE(1659)] = 76479,
  [SMALL_STATE(1660)] = 76525,
  [SMALL_STATE(1661)] = 76571,
  [SMALL_STATE(1662)] = 76641,
  [SMALL_STATE(1663)] = 76693,
  [SMALL_STATE(1664)] = 76739,
  [SMALL_STATE(1665)] = 76797,
  [SMALL_STATE(1666)] = 76871,
  [SMALL_STATE(1667)] = 76917,
  [SMALL_STATE(1668)] = 76989,
  [SMALL_STATE(1669)] = 77077,
  [SMALL_STATE(1670)] = 77125,
  [SMALL_STATE(1671)] = 77175,
  [SMALL_STATE(1672)] = 77225,
  [SMALL_STATE(1673)] = 77283,
  [SMALL_STATE(1674)] = 77341,
  [SMALL_STATE(1675)] = 77387,
  [SMALL_STATE(1676)] = 77433,
  [SMALL_STATE(1677)] = 77491,
  [SMALL_STATE(1678)] = 77549,
  [SMALL_STATE(1679)] = 77597,
  [SMALL_STATE(1680)] = 77669,
  [SMALL_STATE(1681)] = 77717,
  [SMALL_STATE(1682)] = 77775,
  [SMALL_STATE(1683)] = 77849,
  [SMALL_STATE(1684)] = 77919,
  [SMALL_STATE(1685)] = 77977,
  [SMALL_STATE(1686)] = 78035,
  [SMALL_STATE(1687)] = 78083,
  [SMALL_STATE(1688)] = 78129,
  [SMALL_STATE(1689)] = 78175,
  [SMALL_STATE(1690)] = 78221,
  [SMALL_STATE(1691)] = 78267,
  [SMALL_STATE(1692)] = 78315,
  [SMALL_STATE(1693)] = 78361,
  [SMALL_STATE(1694)] = 78407,
  [SMALL_STATE(1695)] = 78453,
  [SMALL_STATE(1696)] = 78501,
  [SMALL_STATE(1697)] = 78547,
  [SMALL_STATE(1698)] = 78593,
  [SMALL_STATE(1699)] = 78639,
  [SMALL_STATE(1700)] = 78687,
  [SMALL_STATE(1701)] = 78745,
  [SMALL_STATE(1702)] = 78803,
  [SMALL_STATE(1703)] = 78849,
  [SMALL_STATE(1704)] = 78921,
  [SMALL_STATE(1705)] = 78967,
  [SMALL_STATE(1706)] = 79041,
  [SMALL_STATE(1707)] = 79087,
  [SMALL_STATE(1708)] = 79133,
  [SMALL_STATE(1709)] = 79179,
  [SMALL_STATE(1710)] = 79225,
  [SMALL_STATE(1711)] = 79295,
  [SMALL_STATE(1712)] = 79341,
  [SMALL_STATE(1713)] = 79429,
  [SMALL_STATE(1714)] = 79475,
  [SMALL_STATE(1715)] = 79523,
  [SMALL_STATE(1716)] = 79569,
  [SMALL_STATE(1717)] = 79615,
  [SMALL_STATE(1718)] = 79661,
  [SMALL_STATE(1719)] = 79707,
  [SMALL_STATE(1720)] = 79753,
  [SMALL_STATE(1721)] = 79799,
  [SMALL_STATE(1722)] = 79845,
  [SMALL_STATE(1723)] = 79933,
  [SMALL_STATE(1724)] = 79991,
  [SMALL_STATE(1725)] = 80037,
  [SMALL_STATE(1726)] = 80085,
  [SMALL_STATE(1727)] = 80131,
  [SMALL_STATE(1728)] = 80177,
  [SMALL_STATE(1729)] = 80231,
  [SMALL_STATE(1730)] = 80285,
  [SMALL_STATE(1731)] = 80343,
  [SMALL_STATE(1732)] = 80401,
  [SMALL_STATE(1733)] = 80447,
  [SMALL_STATE(1734)] = 80493,
  [SMALL_STATE(1735)] = 80539,
  [SMALL_STATE(1736)] = 80585,
  [SMALL_STATE(1737)] = 80631,
  [SMALL_STATE(1738)] = 80677,
  [SMALL_STATE(1739)] = 80723,
  [SMALL_STATE(1740)] = 80769,
  [SMALL_STATE(1741)] = 80815,
  [SMALL_STATE(1742)] = 80861,
  [SMALL_STATE(1743)] = 80919,
  [SMALL_STATE(1744)] = 80967,
  [SMALL_STATE(1745)] = 81013,
  [SMALL_STATE(1746)] = 81059,
  [SMALL_STATE(1747)] = 81117,
  [SMALL_STATE(1748)] = 81163,
  [SMALL_STATE(1749)] = 81209,
  [SMALL_STATE(1750)] = 81255,
  [SMALL_STATE(1751)] = 81313,
  [SMALL_STATE(1752)] = 81359,
  [SMALL_STATE(1753)] = 81415,
  [SMALL_STATE(1754)] = 81473,
  [SMALL_STATE(1755)] = 81561,
  [SMALL_STATE(1756)] = 81607,
  [SMALL_STATE(1757)] = 81653,
  [SMALL_STATE(1758)] = 81699,
  [SMALL_STATE(1759)] = 81787,
  [SMALL_STATE(1760)] = 81833,
  [SMALL_STATE(1761)] = 81879,
  [SMALL_STATE(1762)] = 81925,
  [SMALL_STATE(1763)] = 81983,
  [SMALL_STATE(1764)] = 82029,
  [SMALL_STATE(1765)] = 82075,
  [SMALL_STATE(1766)] = 82123,
  [SMALL_STATE(1767)] = 82181,
  [SMALL_STATE(1768)] = 82239,
  [SMALL_STATE(1769)] = 82285,
  [SMALL_STATE(1770)] = 82373,
  [SMALL_STATE(1771)] = 82419,
  [SMALL_STATE(1772)] = 82477,
  [SMALL_STATE(1773)] = 82535,
  [SMALL_STATE(1774)] = 82581,
  [SMALL_STATE(1775)] = 82627,
  [SMALL_STATE(1776)] = 82673,
  [SMALL_STATE(1777)] = 82723,
  [SMALL_STATE(1778)] = 82768,
  [SMALL_STATE(1779)] = 82813,
  [SMALL_STATE(1780)] = 82878,
  [SMALL_STATE(1781)] = 82923,
  [SMALL_STATE(1782)] = 82968,
  [SMALL_STATE(1783)] = 83013,
  [SMALL_STATE(1784)] = 83058,
  [SMALL_STATE(1785)] = 83103,
  [SMALL_STATE(1786)] = 83148,
  [SMALL_STATE(1787)] = 83215,
  [SMALL_STATE(1788)] = 83260,
  [SMALL_STATE(1789)] = 83305,
  [SMALL_STATE(1790)] = 83374,
  [SMALL_STATE(1791)] = 83419,
  [SMALL_STATE(1792)] = 83464,
  [SMALL_STATE(1793)] = 83515,
  [SMALL_STATE(1794)] = 83560,
  [SMALL_STATE(1795)] = 83625,
  [SMALL_STATE(1796)] = 83670,
  [SMALL_STATE(1797)] = 83715,
  [SMALL_STATE(1798)] = 83760,
  [SMALL_STATE(1799)] = 83825,
  [SMALL_STATE(1800)] = 83870,
  [SMALL_STATE(1801)] = 83915,
  [SMALL_STATE(1802)] = 83960,
  [SMALL_STATE(1803)] = 84005,
  [SMALL_STATE(1804)] = 84058,
  [SMALL_STATE(1805)] = 84111,
  [SMALL_STATE(1806)] = 84156,
  [SMALL_STATE(1807)] = 84201,
  [SMALL_STATE(1808)] = 84246,
  [SMALL_STATE(1809)] = 84291,
  [SMALL_STATE(1810)] = 84342,
  [SMALL_STATE(1811)] = 84387,
  [SMALL_STATE(1812)] = 84432,
  [SMALL_STATE(1813)] = 84477,
  [SMALL_STATE(1814)] = 84562,
  [SMALL_STATE(1815)] = 84613,
  [SMALL_STATE(1816)] = 84658,
  [SMALL_STATE(1817)] = 84711,
  [SMALL_STATE(1818)] = 84756,
  [SMALL_STATE(1819)] = 84809,
  [SMALL_STATE(1820)] = 84854,
  [SMALL_STATE(1821)] = 84905,
  [SMALL_STATE(1822)] = 84950,
  [SMALL_STATE(1823)] = 84995,
  [SMALL_STATE(1824)] = 85040,
  [SMALL_STATE(1825)] = 85085,
  [SMALL_STATE(1826)] = 85130,
  [SMALL_STATE(1827)] = 85175,
  [SMALL_STATE(1828)] = 85220,
  [SMALL_STATE(1829)] = 85265,
  [SMALL_STATE(1830)] = 85350,
  [SMALL_STATE(1831)] = 85395,
  [SMALL_STATE(1832)] = 85480,
  [SMALL_STATE(1833)] = 85545,
  [SMALL_STATE(1834)] = 85590,
  [SMALL_STATE(1835)] = 85635,
  [SMALL_STATE(1836)] = 85680,
  [SMALL_STATE(1837)] = 85725,
  [SMALL_STATE(1838)] = 85770,
  [SMALL_STATE(1839)] = 85815,
  [SMALL_STATE(1840)] = 85860,
  [SMALL_STATE(1841)] = 85905,
  [SMALL_STATE(1842)] = 85950,
  [SMALL_STATE(1843)] = 85995,
  [SMALL_STATE(1844)] = 86040,
  [SMALL_STATE(1845)] = 86085,
  [SMALL_STATE(1846)] = 86130,
  [SMALL_STATE(1847)] = 86175,
  [SMALL_STATE(1848)] = 86220,
  [SMALL_STATE(1849)] = 86265,
  [SMALL_STATE(1850)] = 86310,
  [SMALL_STATE(1851)] = 86355,
  [SMALL_STATE(1852)] = 86400,
  [SMALL_STATE(1853)] = 86465,
  [SMALL_STATE(1854)] = 86516,
  [SMALL_STATE(1855)] = 86581,
  [SMALL_STATE(1856)] = 86632,
  [SMALL_STATE(1857)] = 86677,
  [SMALL_STATE(1858)] = 86722,
  [SMALL_STATE(1859)] = 86766,
  [SMALL_STATE(1860)] = 86826,
  [SMALL_STATE(1861)] = 86876,
  [SMALL_STATE(1862)] = 86931,
  [SMALL_STATE(1863)] = 86986,
  [SMALL_STATE(1864)] = 87041,
  [SMALL_STATE(1865)] = 87096,
  [SMALL_STATE(1866)] = 87138,
  [SMALL_STATE(1867)] = 87190,
  [SMALL_STATE(1868)] = 87242,
  [SMALL_STATE(1869)] = 87284,
  [SMALL_STATE(1870)] = 87326,
  [SMALL_STATE(1871)] = 87368,
  [SMALL_STATE(1872)] = 87410,
  [SMALL_STATE(1873)] = 87462,
  [SMALL_STATE(1874)] = 87514,
  [SMALL_STATE(1875)] = 87566,
  [SMALL_STATE(1876)] = 87645,
  [SMALL_STATE(1877)] = 87700,
  [SMALL_STATE(1878)] = 87771,
  [SMALL_STATE(1879)] = 87842,
  [SMALL_STATE(1880)] = 87913,
  [SMALL_STATE(1881)] = 87984,
  [SMALL_STATE(1882)] = 88055,
  [SMALL_STATE(1883)] = 88126,
  [SMALL_STATE(1884)] = 88201,
  [SMALL_STATE(1885)] = 88272,
  [SMALL_STATE(1886)] = 88333,
  [SMALL_STATE(1887)] = 88404,
  [SMALL_STATE(1888)] = 88483,
  [SMALL_STATE(1889)] = 88562,
  [SMALL_STATE(1890)] = 88633,
  [SMALL_STATE(1891)] = 88704,
  [SMALL_STATE(1892)] = 88775,
  [SMALL_STATE(1893)] = 88846,
  [SMALL_STATE(1894)] = 88917,
  [SMALL_STATE(1895)] = 88974,
  [SMALL_STATE(1896)] = 89021,
  [SMALL_STATE(1897)] = 89080,
  [SMALL_STATE(1898)] = 89137,
  [SMALL_STATE(1899)] = 89208,
  [SMALL_STATE(1900)] = 89287,
  [SMALL_STATE(1901)] = 89358,
  [SMALL_STATE(1902)] = 89417,
  [SMALL_STATE(1903)] = 89488,
  [SMALL_STATE(1904)] = 89559,
  [SMALL_STATE(1905)] = 89616,
  [SMALL_STATE(1906)] = 89687,
  [SMALL_STATE(1907)] = 89766,
  [SMALL_STATE(1908)] = 89845,
  [SMALL_STATE(1909)] = 89885,
  [SMALL_STATE(1910)] = 89937,
  [SMALL_STATE(1911)] = 89977,
  [SMALL_STATE(1912)] = 90029,
  [SMALL_STATE(1913)] = 90071,
  [SMALL_STATE(1914)] = 90123,
  [SMALL_STATE(1915)] = 90175,
  [SMALL_STATE(1916)] = 90215,
  [SMALL_STATE(1917)] = 90267,
  [SMALL_STATE(1918)] = 90307,
  [SMALL_STATE(1919)] = 90347,
  [SMALL_STATE(1920)] = 90387,
  [SMALL_STATE(1921)] = 90427,
  [SMALL_STATE(1922)] = 90469,
  [SMALL_STATE(1923)] = 90509,
  [SMALL_STATE(1924)] = 90561,
  [SMALL_STATE(1925)] = 90601,
  [SMALL_STATE(1926)] = 90641,
  [SMALL_STATE(1927)] = 90681,
  [SMALL_STATE(1928)] = 90733,
  [SMALL_STATE(1929)] = 90785,
  [SMALL_STATE(1930)] = 90837,
  [SMALL_STATE(1931)] = 90889,
  [SMALL_STATE(1932)] = 90961,
  [SMALL_STATE(1933)] = 91013,
  [SMALL_STATE(1934)] = 91053,
  [SMALL_STATE(1935)] = 91093,
  [SMALL_STATE(1936)] = 91133,
  [SMALL_STATE(1937)] = 91173,
  [SMALL_STATE(1938)] = 91245,
  [SMALL_STATE(1939)] = 91317,
  [SMALL_STATE(1940)] = 91369,
  [SMALL_STATE(1941)] = 91409,
  [SMALL_STATE(1942)] = 91449,
  [SMALL_STATE(1943)] = 91501,
  [SMALL_STATE(1944)] = 91553,
  [SMALL_STATE(1945)] = 91605,
  [SMALL_STATE(1946)] = 91645,
  [SMALL_STATE(1947)] = 91687,
  [SMALL_STATE(1948)] = 91755,
  [SMALL_STATE(1949)] = 91795,
  [SMALL_STATE(1950)] = 91847,
  [SMALL_STATE(1951)] = 91887,
  [SMALL_STATE(1952)] = 91940,
  [SMALL_STATE(1953)] = 91993,
  [SMALL_STATE(1954)] = 92046,
  [SMALL_STATE(1955)] = 92099,
  [SMALL_STATE(1956)] = 92152,
  [SMALL_STATE(1957)] = 92205,
  [SMALL_STATE(1958)] = 92266,
  [SMALL_STATE(1959)] = 92320,
  [SMALL_STATE(1960)] = 92378,
  [SMALL_STATE(1961)] = 92436,
  [SMALL_STATE(1962)] = 92486,
  [SMALL_STATE(1963)] = 92540,
  [SMALL_STATE(1964)] = 92598,
  [SMALL_STATE(1965)] = 92636,
  [SMALL_STATE(1966)] = 92683,
  [SMALL_STATE(1967)] = 92730,
  [SMALL_STATE(1968)] = 92777,
  [SMALL_STATE(1969)] = 92824,
  [SMALL_STATE(1970)] = 92871,
  [SMALL_STATE(1971)] = 92918,
  [SMALL_STATE(1972)] = 92965,
  [SMALL_STATE(1973)] = 93012,
  [SMALL_STATE(1974)] = 93059,
  [SMALL_STATE(1975)] = 93106,
  [SMALL_STATE(1976)] = 93153,
  [SMALL_STATE(1977)] = 93200,
  [SMALL_STATE(1978)] = 93247,
  [SMALL_STATE(1979)] = 93294,
  [SMALL_STATE(1980)] = 93341,
  [SMALL_STATE(1981)] = 93388,
  [SMALL_STATE(1982)] = 93435,
  [SMALL_STATE(1983)] = 93482,
  [SMALL_STATE(1984)] = 93529,
  [SMALL_STATE(1985)] = 93576,
  [SMALL_STATE(1986)] = 93623,
  [SMALL_STATE(1987)] = 93670,
  [SMALL_STATE(1988)] = 93717,
  [SMALL_STATE(1989)] = 93764,
  [SMALL_STATE(1990)] = 93809,
  [SMALL_STATE(1991)] = 93854,
  [SMALL_STATE(1992)] = 93894,
  [SMALL_STATE(1993)] = 93929,
  [SMALL_STATE(1994)] = 93961,
  [SMALL_STATE(1995)] = 94001,
  [SMALL_STATE(1996)] = 94033,
  [SMALL_STATE(1997)] = 94065,
  [SMALL_STATE(1998)] = 94097,
  [SMALL_STATE(1999)] = 94125,
  [SMALL_STATE(2000)] = 94154,
  [SMALL_STATE(2001)] = 94183,
  [SMALL_STATE(2002)] = 94210,
  [SMALL_STATE(2003)] = 94234,
  [SMALL_STATE(2004)] = 94258,
  [SMALL_STATE(2005)] = 94282,
  [SMALL_STATE(2006)] = 94308,
  [SMALL_STATE(2007)] = 94329,
  [SMALL_STATE(2008)] = 94356,
  [SMALL_STATE(2009)] = 94377,
  [SMALL_STATE(2010)] = 94398,
  [SMALL_STATE(2011)] = 94419,
  [SMALL_STATE(2012)] = 94440,
  [SMALL_STATE(2013)] = 94469,
  [SMALL_STATE(2014)] = 94498,
  [SMALL_STATE(2015)] = 94519,
  [SMALL_STATE(2016)] = 94547,
  [SMALL_STATE(2017)] = 94589,
  [SMALL_STATE(2018)] = 94631,
  [SMALL_STATE(2019)] = 94673,
  [SMALL_STATE(2020)] = 94701,
  [SMALL_STATE(2021)] = 94731,
  [SMALL_STATE(2022)] = 94773,
  [SMALL_STATE(2023)] = 94801,
  [SMALL_STATE(2024)] = 94843,
  [SMALL_STATE(2025)] = 94885,
  [SMALL_STATE(2026)] = 94920,
  [SMALL_STATE(2027)] = 94945,
  [SMALL_STATE(2028)] = 94980,
  [SMALL_STATE(2029)] = 95015,
  [SMALL_STATE(2030)] = 95050,
  [SMALL_STATE(2031)] = 95085,
  [SMALL_STATE(2032)] = 95108,
  [SMALL_STATE(2033)] = 95143,
  [SMALL_STATE(2034)] = 95178,
  [SMALL_STATE(2035)] = 95215,
  [SMALL_STATE(2036)] = 95250,
  [SMALL_STATE(2037)] = 95275,
  [SMALL_STATE(2038)] = 95298,
  [SMALL_STATE(2039)] = 95330,
  [SMALL_STATE(2040)] = 95366,
  [SMALL_STATE(2041)] = 95398,
  [SMALL_STATE(2042)] = 95430,
  [SMALL_STATE(2043)] = 95466,
  [SMALL_STATE(2044)] = 95502,
  [SMALL_STATE(2045)] = 95538,
  [SMALL_STATE(2046)] = 95570,
  [SMALL_STATE(2047)] = 95602,
  [SMALL_STATE(2048)] = 95634,
  [SMALL_STATE(2049)] = 95670,
  [SMALL_STATE(2050)] = 95702,
  [SMALL_STATE(2051)] = 95734,
  [SMALL_STATE(2052)] = 95770,
  [SMALL_STATE(2053)] = 95798,
  [SMALL_STATE(2054)] = 95820,
  [SMALL_STATE(2055)] = 95846,
  [SMALL_STATE(2056)] = 95867,
  [SMALL_STATE(2057)] = 95886,
  [SMALL_STATE(2058)] = 95903,
  [SMALL_STATE(2059)] = 95924,
  [SMALL_STATE(2060)] = 95943,
  [SMALL_STATE(2061)] = 95962,
  [SMALL_STATE(2062)] = 95981,
  [SMALL_STATE(2063)] = 96000,
  [SMALL_STATE(2064)] = 96019,
  [SMALL_STATE(2065)] = 96040,
  [SMALL_STATE(2066)] = 96059,
  [SMALL_STATE(2067)] = 96076,
  [SMALL_STATE(2068)] = 96095,
  [SMALL_STATE(2069)] = 96112,
  [SMALL_STATE(2070)] = 96133,
  [SMALL_STATE(2071)] = 96152,
  [SMALL_STATE(2072)] = 96173,
  [SMALL_STATE(2073)] = 96194,
  [SMALL_STATE(2074)] = 96213,
  [SMALL_STATE(2075)] = 96232,
  [SMALL_STATE(2076)] = 96251,
  [SMALL_STATE(2077)] = 96270,
  [SMALL_STATE(2078)] = 96293,
  [SMALL_STATE(2079)] = 96312,
  [SMALL_STATE(2080)] = 96331,
  [SMALL_STATE(2081)] = 96350,
  [SMALL_STATE(2082)] = 96369,
  [SMALL_STATE(2083)] = 96390,
  [SMALL_STATE(2084)] = 96409,
  [SMALL_STATE(2085)] = 96428,
  [SMALL_STATE(2086)] = 96447,
  [SMALL_STATE(2087)] = 96466,
  [SMALL_STATE(2088)] = 96485,
  [SMALL_STATE(2089)] = 96506,
  [SMALL_STATE(2090)] = 96525,
  [SMALL_STATE(2091)] = 96548,
  [SMALL_STATE(2092)] = 96567,
  [SMALL_STATE(2093)] = 96586,
  [SMALL_STATE(2094)] = 96607,
  [SMALL_STATE(2095)] = 96626,
  [SMALL_STATE(2096)] = 96645,
  [SMALL_STATE(2097)] = 96664,
  [SMALL_STATE(2098)] = 96683,
  [SMALL_STATE(2099)] = 96702,
  [SMALL_STATE(2100)] = 96721,
  [SMALL_STATE(2101)] = 96755,
  [SMALL_STATE(2102)] = 96789,
  [SMALL_STATE(2103)] = 96807,
  [SMALL_STATE(2104)] = 96831,
  [SMALL_STATE(2105)] = 96865,
  [SMALL_STATE(2106)] = 96899,
  [SMALL_STATE(2107)] = 96919,
  [SMALL_STATE(2108)] = 96953,
  [SMALL_STATE(2109)] = 96987,
  [SMALL_STATE(2110)] = 97007,
  [SMALL_STATE(2111)] = 97041,
  [SMALL_STATE(2112)] = 97075,
  [SMALL_STATE(2113)] = 97097,
  [SMALL_STATE(2114)] = 97131,
  [SMALL_STATE(2115)] = 97165,
  [SMALL_STATE(2116)] = 97185,
  [SMALL_STATE(2117)] = 97204,
  [SMALL_STATE(2118)] = 97235,
  [SMALL_STATE(2119)] = 97266,
  [SMALL_STATE(2120)] = 97297,
  [SMALL_STATE(2121)] = 97328,
  [SMALL_STATE(2122)] = 97353,
  [SMALL_STATE(2123)] = 97384,
  [SMALL_STATE(2124)] = 97415,
  [SMALL_STATE(2125)] = 97446,
  [SMALL_STATE(2126)] = 97477,
  [SMALL_STATE(2127)] = 97508,
  [SMALL_STATE(2128)] = 97539,
  [SMALL_STATE(2129)] = 97556,
  [SMALL_STATE(2130)] = 97579,
  [SMALL_STATE(2131)] = 97604,
  [SMALL_STATE(2132)] = 97635,
  [SMALL_STATE(2133)] = 97666,
  [SMALL_STATE(2134)] = 97683,
  [SMALL_STATE(2135)] = 97710,
  [SMALL_STATE(2136)] = 97727,
  [SMALL_STATE(2137)] = 97752,
  [SMALL_STATE(2138)] = 97783,
  [SMALL_STATE(2139)] = 97814,
  [SMALL_STATE(2140)] = 97831,
  [SMALL_STATE(2141)] = 97856,
  [SMALL_STATE(2142)] = 97875,
  [SMALL_STATE(2143)] = 97906,
  [SMALL_STATE(2144)] = 97931,
  [SMALL_STATE(2145)] = 97956,
  [SMALL_STATE(2146)] = 97977,
  [SMALL_STATE(2147)] = 97996,
  [SMALL_STATE(2148)] = 98027,
  [SMALL_STATE(2149)] = 98058,
  [SMALL_STATE(2150)] = 98083,
  [SMALL_STATE(2151)] = 98114,
  [SMALL_STATE(2152)] = 98136,
  [SMALL_STATE(2153)] = 98156,
  [SMALL_STATE(2154)] = 98178,
  [SMALL_STATE(2155)] = 98198,
  [SMALL_STATE(2156)] = 98220,
  [SMALL_STATE(2157)] = 98242,
  [SMALL_STATE(2158)] = 98266,
  [SMALL_STATE(2159)] = 98288,
  [SMALL_STATE(2160)] = 98308,
  [SMALL_STATE(2161)] = 98328,
  [SMALL_STATE(2162)] = 98350,
  [SMALL_STATE(2163)] = 98371,
  [SMALL_STATE(2164)] = 98396,
  [SMALL_STATE(2165)] = 98421,
  [SMALL_STATE(2166)] = 98446,
  [SMALL_STATE(2167)] = 98463,
  [SMALL_STATE(2168)] = 98480,
  [SMALL_STATE(2169)] = 98505,
  [SMALL_STATE(2170)] = 98518,
  [SMALL_STATE(2171)] = 98539,
  [SMALL_STATE(2172)] = 98556,
  [SMALL_STATE(2173)] = 98581,
  [SMALL_STATE(2174)] = 98606,
  [SMALL_STATE(2175)] = 98631,
  [SMALL_STATE(2176)] = 98656,
  [SMALL_STATE(2177)] = 98681,
  [SMALL_STATE(2178)] = 98706,
  [SMALL_STATE(2179)] = 98731,
  [SMALL_STATE(2180)] = 98754,
  [SMALL_STATE(2181)] = 98775,
  [SMALL_STATE(2182)] = 98800,
  [SMALL_STATE(2183)] = 98825,
  [SMALL_STATE(2184)] = 98850,
  [SMALL_STATE(2185)] = 98871,
  [SMALL_STATE(2186)] = 98884,
  [SMALL_STATE(2187)] = 98909,
  [SMALL_STATE(2188)] = 98934,
  [SMALL_STATE(2189)] = 98947,
  [SMALL_STATE(2190)] = 98972,
  [SMALL_STATE(2191)] = 98997,
  [SMALL_STATE(2192)] = 99010,
  [SMALL_STATE(2193)] = 99031,
  [SMALL_STATE(2194)] = 99048,
  [SMALL_STATE(2195)] = 99065,
  [SMALL_STATE(2196)] = 99082,
  [SMALL_STATE(2197)] = 99107,
  [SMALL_STATE(2198)] = 99132,
  [SMALL_STATE(2199)] = 99157,
  [SMALL_STATE(2200)] = 99182,
  [SMALL_STATE(2201)] = 99199,
  [SMALL_STATE(2202)] = 99216,
  [SMALL_STATE(2203)] = 99233,
  [SMALL_STATE(2204)] = 99250,
  [SMALL_STATE(2205)] = 99267,
  [SMALL_STATE(2206)] = 99284,
  [SMALL_STATE(2207)] = 99301,
  [SMALL_STATE(2208)] = 99318,
  [SMALL_STATE(2209)] = 99335,
  [SMALL_STATE(2210)] = 99356,
  [SMALL_STATE(2211)] = 99373,
  [SMALL_STATE(2212)] = 99386,
  [SMALL_STATE(2213)] = 99399,
  [SMALL_STATE(2214)] = 99412,
  [SMALL_STATE(2215)] = 99425,
  [SMALL_STATE(2216)] = 99438,
  [SMALL_STATE(2217)] = 99451,
  [SMALL_STATE(2218)] = 99464,
  [SMALL_STATE(2219)] = 99481,
  [SMALL_STATE(2220)] = 99498,
  [SMALL_STATE(2221)] = 99515,
  [SMALL_STATE(2222)] = 99532,
  [SMALL_STATE(2223)] = 99549,
  [SMALL_STATE(2224)] = 99574,
  [SMALL_STATE(2225)] = 99599,
  [SMALL_STATE(2226)] = 99624,
  [SMALL_STATE(2227)] = 99637,
  [SMALL_STATE(2228)] = 99662,
  [SMALL_STATE(2229)] = 99687,
  [SMALL_STATE(2230)] = 99702,
  [SMALL_STATE(2231)] = 99727,
  [SMALL_STATE(2232)] = 99742,
  [SMALL_STATE(2233)] = 99755,
  [SMALL_STATE(2234)] = 99780,
  [SMALL_STATE(2235)] = 99797,
  [SMALL_STATE(2236)] = 99814,
  [SMALL_STATE(2237)] = 99831,
  [SMALL_STATE(2238)] = 99848,
  [SMALL_STATE(2239)] = 99873,
  [SMALL_STATE(2240)] = 99886,
  [SMALL_STATE(2241)] = 99899,
  [SMALL_STATE(2242)] = 99912,
  [SMALL_STATE(2243)] = 99925,
  [SMALL_STATE(2244)] = 99950,
  [SMALL_STATE(2245)] = 99963,
  [SMALL_STATE(2246)] = 99980,
  [SMALL_STATE(2247)] = 100005,
  [SMALL_STATE(2248)] = 100030,
  [SMALL_STATE(2249)] = 100055,
  [SMALL_STATE(2250)] = 100080,
  [SMALL_STATE(2251)] = 100105,
  [SMALL_STATE(2252)] = 100130,
  [SMALL_STATE(2253)] = 100143,
  [SMALL_STATE(2254)] = 100164,
  [SMALL_STATE(2255)] = 100189,
  [SMALL_STATE(2256)] = 100206,
  [SMALL_STATE(2257)] = 100231,
  [SMALL_STATE(2258)] = 100247,
  [SMALL_STATE(2259)] = 100263,
  [SMALL_STATE(2260)] = 100279,
  [SMALL_STATE(2261)] = 100299,
  [SMALL_STATE(2262)] = 100321,
  [SMALL_STATE(2263)] = 100333,
  [SMALL_STATE(2264)] = 100345,
  [SMALL_STATE(2265)] = 100357,
  [SMALL_STATE(2266)] = 100373,
  [SMALL_STATE(2267)] = 100395,
  [SMALL_STATE(2268)] = 100411,
  [SMALL_STATE(2269)] = 100433,
  [SMALL_STATE(2270)] = 100455,
  [SMALL_STATE(2271)] = 100477,
  [SMALL_STATE(2272)] = 100499,
  [SMALL_STATE(2273)] = 100521,
  [SMALL_STATE(2274)] = 100543,
  [SMALL_STATE(2275)] = 100559,
  [SMALL_STATE(2276)] = 100581,
  [SMALL_STATE(2277)] = 100603,
  [SMALL_STATE(2278)] = 100619,
  [SMALL_STATE(2279)] = 100641,
  [SMALL_STATE(2280)] = 100663,
  [SMALL_STATE(2281)] = 100681,
  [SMALL_STATE(2282)] = 100701,
  [SMALL_STATE(2283)] = 100719,
  [SMALL_STATE(2284)] = 100735,
  [SMALL_STATE(2285)] = 100751,
  [SMALL_STATE(2286)] = 100767,
  [SMALL_STATE(2287)] = 100783,
  [SMALL_STATE(2288)] = 100799,
  [SMALL_STATE(2289)] = 100815,
  [SMALL_STATE(2290)] = 100833,
  [SMALL_STATE(2291)] = 100855,
  [SMALL_STATE(2292)] = 100867,
  [SMALL_STATE(2293)] = 100889,
  [SMALL_STATE(2294)] = 100911,
  [SMALL_STATE(2295)] = 100927,
  [SMALL_STATE(2296)] = 100949,
  [SMALL_STATE(2297)] = 100965,
  [SMALL_STATE(2298)] = 100987,
  [SMALL_STATE(2299)] = 101009,
  [SMALL_STATE(2300)] = 101031,
  [SMALL_STATE(2301)] = 101053,
  [SMALL_STATE(2302)] = 101075,
  [SMALL_STATE(2303)] = 101097,
  [SMALL_STATE(2304)] = 101117,
  [SMALL_STATE(2305)] = 101139,
  [SMALL_STATE(2306)] = 101155,
  [SMALL_STATE(2307)] = 101175,
  [SMALL_STATE(2308)] = 101193,
  [SMALL_STATE(2309)] = 101211,
  [SMALL_STATE(2310)] = 101227,
  [SMALL_STATE(2311)] = 101249,
  [SMALL_STATE(2312)] = 101271,
  [SMALL_STATE(2313)] = 101291,
  [SMALL_STATE(2314)] = 101309,
  [SMALL_STATE(2315)] = 101331,
  [SMALL_STATE(2316)] = 101353,
  [SMALL_STATE(2317)] = 101371,
  [SMALL_STATE(2318)] = 101393,
  [SMALL_STATE(2319)] = 101415,
  [SMALL_STATE(2320)] = 101433,
  [SMALL_STATE(2321)] = 101453,
  [SMALL_STATE(2322)] = 101469,
  [SMALL_STATE(2323)] = 101491,
  [SMALL_STATE(2324)] = 101507,
  [SMALL_STATE(2325)] = 101523,
  [SMALL_STATE(2326)] = 101541,
  [SMALL_STATE(2327)] = 101559,
  [SMALL_STATE(2328)] = 101577,
  [SMALL_STATE(2329)] = 101595,
  [SMALL_STATE(2330)] = 101617,
  [SMALL_STATE(2331)] = 101639,
  [SMALL_STATE(2332)] = 101655,
  [SMALL_STATE(2333)] = 101677,
  [SMALL_STATE(2334)] = 101695,
  [SMALL_STATE(2335)] = 101717,
  [SMALL_STATE(2336)] = 101729,
  [SMALL_STATE(2337)] = 101751,
  [SMALL_STATE(2338)] = 101773,
  [SMALL_STATE(2339)] = 101791,
  [SMALL_STATE(2340)] = 101813,
  [SMALL_STATE(2341)] = 101829,
  [SMALL_STATE(2342)] = 101851,
  [SMALL_STATE(2343)] = 101873,
  [SMALL_STATE(2344)] = 101891,
  [SMALL_STATE(2345)] = 101909,
  [SMALL_STATE(2346)] = 101931,
  [SMALL_STATE(2347)] = 101949,
  [SMALL_STATE(2348)] = 101971,
  [SMALL_STATE(2349)] = 101989,
  [SMALL_STATE(2350)] = 102011,
  [SMALL_STATE(2351)] = 102033,
  [SMALL_STATE(2352)] = 102055,
  [SMALL_STATE(2353)] = 102077,
  [SMALL_STATE(2354)] = 102099,
  [SMALL_STATE(2355)] = 102115,
  [SMALL_STATE(2356)] = 102133,
  [SMALL_STATE(2357)] = 102155,
  [SMALL_STATE(2358)] = 102177,
  [SMALL_STATE(2359)] = 102199,
  [SMALL_STATE(2360)] = 102221,
  [SMALL_STATE(2361)] = 102241,
  [SMALL_STATE(2362)] = 102259,
  [SMALL_STATE(2363)] = 102271,
  [SMALL_STATE(2364)] = 102291,
  [SMALL_STATE(2365)] = 102313,
  [SMALL_STATE(2366)] = 102335,
  [SMALL_STATE(2367)] = 102357,
  [SMALL_STATE(2368)] = 102379,
  [SMALL_STATE(2369)] = 102397,
  [SMALL_STATE(2370)] = 102419,
  [SMALL_STATE(2371)] = 102441,
  [SMALL_STATE(2372)] = 102460,
  [SMALL_STATE(2373)] = 102471,
  [SMALL_STATE(2374)] = 102482,
  [SMALL_STATE(2375)] = 102493,
  [SMALL_STATE(2376)] = 102504,
  [SMALL_STATE(2377)] = 102515,
  [SMALL_STATE(2378)] = 102526,
  [SMALL_STATE(2379)] = 102545,
  [SMALL_STATE(2380)] = 102556,
  [SMALL_STATE(2381)] = 102571,
  [SMALL_STATE(2382)] = 102590,
  [SMALL_STATE(2383)] = 102601,
  [SMALL_STATE(2384)] = 102616,
  [SMALL_STATE(2385)] = 102631,
  [SMALL_STATE(2386)] = 102650,
  [SMALL_STATE(2387)] = 102661,
  [SMALL_STATE(2388)] = 102672,
  [SMALL_STATE(2389)] = 102683,
  [SMALL_STATE(2390)] = 102698,
  [SMALL_STATE(2391)] = 102713,
  [SMALL_STATE(2392)] = 102732,
  [SMALL_STATE(2393)] = 102747,
  [SMALL_STATE(2394)] = 102766,
  [SMALL_STATE(2395)] = 102777,
  [SMALL_STATE(2396)] = 102792,
  [SMALL_STATE(2397)] = 102807,
  [SMALL_STATE(2398)] = 102818,
  [SMALL_STATE(2399)] = 102837,
  [SMALL_STATE(2400)] = 102856,
  [SMALL_STATE(2401)] = 102875,
  [SMALL_STATE(2402)] = 102886,
  [SMALL_STATE(2403)] = 102897,
  [SMALL_STATE(2404)] = 102908,
  [SMALL_STATE(2405)] = 102919,
  [SMALL_STATE(2406)] = 102930,
  [SMALL_STATE(2407)] = 102941,
  [SMALL_STATE(2408)] = 102960,
  [SMALL_STATE(2409)] = 102971,
  [SMALL_STATE(2410)] = 102990,
  [SMALL_STATE(2411)] = 103009,
  [SMALL_STATE(2412)] = 103028,
  [SMALL_STATE(2413)] = 103039,
  [SMALL_STATE(2414)] = 103050,
  [SMALL_STATE(2415)] = 103069,
  [SMALL_STATE(2416)] = 103084,
  [SMALL_STATE(2417)] = 103099,
  [SMALL_STATE(2418)] = 103110,
  [SMALL_STATE(2419)] = 103121,
  [SMALL_STATE(2420)] = 103132,
  [SMALL_STATE(2421)] = 103143,
  [SMALL_STATE(2422)] = 103154,
  [SMALL_STATE(2423)] = 103165,
  [SMALL_STATE(2424)] = 103184,
  [SMALL_STATE(2425)] = 103203,
  [SMALL_STATE(2426)] = 103214,
  [SMALL_STATE(2427)] = 103233,
  [SMALL_STATE(2428)] = 103244,
  [SMALL_STATE(2429)] = 103261,
  [SMALL_STATE(2430)] = 103280,
  [SMALL_STATE(2431)] = 103295,
  [SMALL_STATE(2432)] = 103306,
  [SMALL_STATE(2433)] = 103317,
  [SMALL_STATE(2434)] = 103336,
  [SMALL_STATE(2435)] = 103351,
  [SMALL_STATE(2436)] = 103370,
  [SMALL_STATE(2437)] = 103381,
  [SMALL_STATE(2438)] = 103400,
  [SMALL_STATE(2439)] = 103419,
  [SMALL_STATE(2440)] = 103438,
  [SMALL_STATE(2441)] = 103457,
  [SMALL_STATE(2442)] = 103472,
  [SMALL_STATE(2443)] = 103491,
  [SMALL_STATE(2444)] = 103508,
  [SMALL_STATE(2445)] = 103519,
  [SMALL_STATE(2446)] = 103530,
  [SMALL_STATE(2447)] = 103545,
  [SMALL_STATE(2448)] = 103564,
  [SMALL_STATE(2449)] = 103579,
  [SMALL_STATE(2450)] = 103590,
  [SMALL_STATE(2451)] = 103601,
  [SMALL_STATE(2452)] = 103612,
  [SMALL_STATE(2453)] = 103623,
  [SMALL_STATE(2454)] = 103640,
  [SMALL_STATE(2455)] = 103651,
  [SMALL_STATE(2456)] = 103662,
  [SMALL_STATE(2457)] = 103677,
  [SMALL_STATE(2458)] = 103688,
  [SMALL_STATE(2459)] = 103703,
  [SMALL_STATE(2460)] = 103714,
  [SMALL_STATE(2461)] = 103729,
  [SMALL_STATE(2462)] = 103744,
  [SMALL_STATE(2463)] = 103755,
  [SMALL_STATE(2464)] = 103766,
  [SMALL_STATE(2465)] = 103777,
  [SMALL_STATE(2466)] = 103788,
  [SMALL_STATE(2467)] = 103807,
  [SMALL_STATE(2468)] = 103822,
  [SMALL_STATE(2469)] = 103833,
  [SMALL_STATE(2470)] = 103848,
  [SMALL_STATE(2471)] = 103867,
  [SMALL_STATE(2472)] = 103878,
  [SMALL_STATE(2473)] = 103889,
  [SMALL_STATE(2474)] = 103904,
  [SMALL_STATE(2475)] = 103915,
  [SMALL_STATE(2476)] = 103926,
  [SMALL_STATE(2477)] = 103937,
  [SMALL_STATE(2478)] = 103948,
  [SMALL_STATE(2479)] = 103959,
  [SMALL_STATE(2480)] = 103970,
  [SMALL_STATE(2481)] = 103981,
  [SMALL_STATE(2482)] = 103992,
  [SMALL_STATE(2483)] = 104003,
  [SMALL_STATE(2484)] = 104014,
  [SMALL_STATE(2485)] = 104025,
  [SMALL_STATE(2486)] = 104036,
  [SMALL_STATE(2487)] = 104055,
  [SMALL_STATE(2488)] = 104066,
  [SMALL_STATE(2489)] = 104083,
  [SMALL_STATE(2490)] = 104098,
  [SMALL_STATE(2491)] = 104117,
  [SMALL_STATE(2492)] = 104128,
  [SMALL_STATE(2493)] = 104147,
  [SMALL_STATE(2494)] = 104166,
  [SMALL_STATE(2495)] = 104177,
  [SMALL_STATE(2496)] = 104188,
  [SMALL_STATE(2497)] = 104207,
  [SMALL_STATE(2498)] = 104220,
  [SMALL_STATE(2499)] = 104239,
  [SMALL_STATE(2500)] = 104258,
  [SMALL_STATE(2501)] = 104269,
  [SMALL_STATE(2502)] = 104284,
  [SMALL_STATE(2503)] = 104295,
  [SMALL_STATE(2504)] = 104314,
  [SMALL_STATE(2505)] = 104333,
  [SMALL_STATE(2506)] = 104352,
  [SMALL_STATE(2507)] = 104371,
  [SMALL_STATE(2508)] = 104390,
  [SMALL_STATE(2509)] = 104405,
  [SMALL_STATE(2510)] = 104424,
  [SMALL_STATE(2511)] = 104435,
  [SMALL_STATE(2512)] = 104446,
  [SMALL_STATE(2513)] = 104457,
  [SMALL_STATE(2514)] = 104476,
  [SMALL_STATE(2515)] = 104487,
  [SMALL_STATE(2516)] = 104506,
  [SMALL_STATE(2517)] = 104517,
  [SMALL_STATE(2518)] = 104528,
  [SMALL_STATE(2519)] = 104547,
  [SMALL_STATE(2520)] = 104566,
  [SMALL_STATE(2521)] = 104577,
  [SMALL_STATE(2522)] = 104588,
  [SMALL_STATE(2523)] = 104607,
  [SMALL_STATE(2524)] = 104618,
  [SMALL_STATE(2525)] = 104633,
  [SMALL_STATE(2526)] = 104644,
  [SMALL_STATE(2527)] = 104655,
  [SMALL_STATE(2528)] = 104674,
  [SMALL_STATE(2529)] = 104687,
  [SMALL_STATE(2530)] = 104706,
  [SMALL_STATE(2531)] = 104719,
  [SMALL_STATE(2532)] = 104738,
  [SMALL_STATE(2533)] = 104753,
  [SMALL_STATE(2534)] = 104764,
  [SMALL_STATE(2535)] = 104775,
  [SMALL_STATE(2536)] = 104794,
  [SMALL_STATE(2537)] = 104805,
  [SMALL_STATE(2538)] = 104816,
  [SMALL_STATE(2539)] = 104827,
  [SMALL_STATE(2540)] = 104844,
  [SMALL_STATE(2541)] = 104859,
  [SMALL_STATE(2542)] = 104874,
  [SMALL_STATE(2543)] = 104885,
  [SMALL_STATE(2544)] = 104896,
  [SMALL_STATE(2545)] = 104907,
  [SMALL_STATE(2546)] = 104918,
  [SMALL_STATE(2547)] = 104933,
  [SMALL_STATE(2548)] = 104944,
  [SMALL_STATE(2549)] = 104955,
  [SMALL_STATE(2550)] = 104966,
  [SMALL_STATE(2551)] = 104981,
  [SMALL_STATE(2552)] = 105000,
  [SMALL_STATE(2553)] = 105011,
  [SMALL_STATE(2554)] = 105026,
  [SMALL_STATE(2555)] = 105045,
  [SMALL_STATE(2556)] = 105056,
  [SMALL_STATE(2557)] = 105075,
  [SMALL_STATE(2558)] = 105086,
  [SMALL_STATE(2559)] = 105097,
  [SMALL_STATE(2560)] = 105108,
  [SMALL_STATE(2561)] = 105119,
  [SMALL_STATE(2562)] = 105130,
  [SMALL_STATE(2563)] = 105141,
  [SMALL_STATE(2564)] = 105152,
  [SMALL_STATE(2565)] = 105163,
  [SMALL_STATE(2566)] = 105182,
  [SMALL_STATE(2567)] = 105201,
  [SMALL_STATE(2568)] = 105212,
  [SMALL_STATE(2569)] = 105229,
  [SMALL_STATE(2570)] = 105248,
  [SMALL_STATE(2571)] = 105259,
  [SMALL_STATE(2572)] = 105278,
  [SMALL_STATE(2573)] = 105289,
  [SMALL_STATE(2574)] = 105308,
  [SMALL_STATE(2575)] = 105327,
  [SMALL_STATE(2576)] = 105338,
  [SMALL_STATE(2577)] = 105349,
  [SMALL_STATE(2578)] = 105360,
  [SMALL_STATE(2579)] = 105371,
  [SMALL_STATE(2580)] = 105382,
  [SMALL_STATE(2581)] = 105401,
  [SMALL_STATE(2582)] = 105420,
  [SMALL_STATE(2583)] = 105439,
  [SMALL_STATE(2584)] = 105458,
  [SMALL_STATE(2585)] = 105473,
  [SMALL_STATE(2586)] = 105484,
  [SMALL_STATE(2587)] = 105501,
  [SMALL_STATE(2588)] = 105512,
  [SMALL_STATE(2589)] = 105529,
  [SMALL_STATE(2590)] = 105540,
  [SMALL_STATE(2591)] = 105551,
  [SMALL_STATE(2592)] = 105566,
  [SMALL_STATE(2593)] = 105577,
  [SMALL_STATE(2594)] = 105592,
  [SMALL_STATE(2595)] = 105603,
  [SMALL_STATE(2596)] = 105614,
  [SMALL_STATE(2597)] = 105629,
  [SMALL_STATE(2598)] = 105640,
  [SMALL_STATE(2599)] = 105651,
  [SMALL_STATE(2600)] = 105664,
  [SMALL_STATE(2601)] = 105675,
  [SMALL_STATE(2602)] = 105690,
  [SMALL_STATE(2603)] = 105705,
  [SMALL_STATE(2604)] = 105716,
  [SMALL_STATE(2605)] = 105727,
  [SMALL_STATE(2606)] = 105738,
  [SMALL_STATE(2607)] = 105753,
  [SMALL_STATE(2608)] = 105764,
  [SMALL_STATE(2609)] = 105783,
  [SMALL_STATE(2610)] = 105794,
  [SMALL_STATE(2611)] = 105805,
  [SMALL_STATE(2612)] = 105818,
  [SMALL_STATE(2613)] = 105829,
  [SMALL_STATE(2614)] = 105840,
  [SMALL_STATE(2615)] = 105851,
  [SMALL_STATE(2616)] = 105862,
  [SMALL_STATE(2617)] = 105876,
  [SMALL_STATE(2618)] = 105890,
  [SMALL_STATE(2619)] = 105906,
  [SMALL_STATE(2620)] = 105922,
  [SMALL_STATE(2621)] = 105938,
  [SMALL_STATE(2622)] = 105954,
  [SMALL_STATE(2623)] = 105970,
  [SMALL_STATE(2624)] = 105986,
  [SMALL_STATE(2625)] = 106002,
  [SMALL_STATE(2626)] = 106018,
  [SMALL_STATE(2627)] = 106032,
  [SMALL_STATE(2628)] = 106048,
  [SMALL_STATE(2629)] = 106058,
  [SMALL_STATE(2630)] = 106074,
  [SMALL_STATE(2631)] = 106090,
  [SMALL_STATE(2632)] = 106106,
  [SMALL_STATE(2633)] = 106122,
  [SMALL_STATE(2634)] = 106138,
  [SMALL_STATE(2635)] = 106152,
  [SMALL_STATE(2636)] = 106168,
  [SMALL_STATE(2637)] = 106184,
  [SMALL_STATE(2638)] = 106200,
  [SMALL_STATE(2639)] = 106216,
  [SMALL_STATE(2640)] = 106232,
  [SMALL_STATE(2641)] = 106248,
  [SMALL_STATE(2642)] = 106264,
  [SMALL_STATE(2643)] = 106280,
  [SMALL_STATE(2644)] = 106296,
  [SMALL_STATE(2645)] = 106312,
  [SMALL_STATE(2646)] = 106326,
  [SMALL_STATE(2647)] = 106342,
  [SMALL_STATE(2648)] = 106358,
  [SMALL_STATE(2649)] = 106370,
  [SMALL_STATE(2650)] = 106384,
  [SMALL_STATE(2651)] = 106400,
  [SMALL_STATE(2652)] = 106412,
  [SMALL_STATE(2653)] = 106426,
  [SMALL_STATE(2654)] = 106438,
  [SMALL_STATE(2655)] = 106454,
  [SMALL_STATE(2656)] = 106470,
  [SMALL_STATE(2657)] = 106486,
  [SMALL_STATE(2658)] = 106502,
  [SMALL_STATE(2659)] = 106518,
  [SMALL_STATE(2660)] = 106534,
  [SMALL_STATE(2661)] = 106550,
  [SMALL_STATE(2662)] = 106566,
  [SMALL_STATE(2663)] = 106580,
  [SMALL_STATE(2664)] = 106594,
  [SMALL_STATE(2665)] = 106608,
  [SMALL_STATE(2666)] = 106624,
  [SMALL_STATE(2667)] = 106640,
  [SMALL_STATE(2668)] = 106654,
  [SMALL_STATE(2669)] = 106668,
  [SMALL_STATE(2670)] = 106682,
  [SMALL_STATE(2671)] = 106692,
  [SMALL_STATE(2672)] = 106708,
  [SMALL_STATE(2673)] = 106722,
  [SMALL_STATE(2674)] = 106736,
  [SMALL_STATE(2675)] = 106752,
  [SMALL_STATE(2676)] = 106766,
  [SMALL_STATE(2677)] = 106782,
  [SMALL_STATE(2678)] = 106798,
  [SMALL_STATE(2679)] = 106812,
  [SMALL_STATE(2680)] = 106828,
  [SMALL_STATE(2681)] = 106844,
  [SMALL_STATE(2682)] = 106858,
  [SMALL_STATE(2683)] = 106872,
  [SMALL_STATE(2684)] = 106886,
  [SMALL_STATE(2685)] = 106902,
  [SMALL_STATE(2686)] = 106918,
  [SMALL_STATE(2687)] = 106934,
  [SMALL_STATE(2688)] = 106950,
  [SMALL_STATE(2689)] = 106966,
  [SMALL_STATE(2690)] = 106982,
  [SMALL_STATE(2691)] = 106998,
  [SMALL_STATE(2692)] = 107014,
  [SMALL_STATE(2693)] = 107026,
  [SMALL_STATE(2694)] = 107042,
  [SMALL_STATE(2695)] = 107058,
  [SMALL_STATE(2696)] = 107074,
  [SMALL_STATE(2697)] = 107088,
  [SMALL_STATE(2698)] = 107104,
  [SMALL_STATE(2699)] = 107118,
  [SMALL_STATE(2700)] = 107134,
  [SMALL_STATE(2701)] = 107150,
  [SMALL_STATE(2702)] = 107164,
  [SMALL_STATE(2703)] = 107180,
  [SMALL_STATE(2704)] = 107192,
  [SMALL_STATE(2705)] = 107204,
  [SMALL_STATE(2706)] = 107218,
  [SMALL_STATE(2707)] = 107234,
  [SMALL_STATE(2708)] = 107250,
  [SMALL_STATE(2709)] = 107262,
  [SMALL_STATE(2710)] = 107278,
  [SMALL_STATE(2711)] = 107290,
  [SMALL_STATE(2712)] = 107304,
  [SMALL_STATE(2713)] = 107320,
  [SMALL_STATE(2714)] = 107334,
  [SMALL_STATE(2715)] = 107344,
  [SMALL_STATE(2716)] = 107360,
  [SMALL_STATE(2717)] = 107376,
  [SMALL_STATE(2718)] = 107392,
  [SMALL_STATE(2719)] = 107408,
  [SMALL_STATE(2720)] = 107422,
  [SMALL_STATE(2721)] = 107438,
  [SMALL_STATE(2722)] = 107454,
  [SMALL_STATE(2723)] = 107470,
  [SMALL_STATE(2724)] = 107486,
  [SMALL_STATE(2725)] = 107502,
  [SMALL_STATE(2726)] = 107518,
  [SMALL_STATE(2727)] = 107534,
  [SMALL_STATE(2728)] = 107550,
  [SMALL_STATE(2729)] = 107566,
  [SMALL_STATE(2730)] = 107575,
  [SMALL_STATE(2731)] = 107584,
  [SMALL_STATE(2732)] = 107597,
  [SMALL_STATE(2733)] = 107606,
  [SMALL_STATE(2734)] = 107619,
  [SMALL_STATE(2735)] = 107632,
  [SMALL_STATE(2736)] = 107645,
  [SMALL_STATE(2737)] = 107658,
  [SMALL_STATE(2738)] = 107671,
  [SMALL_STATE(2739)] = 107684,
  [SMALL_STATE(2740)] = 107697,
  [SMALL_STATE(2741)] = 107708,
  [SMALL_STATE(2742)] = 107719,
  [SMALL_STATE(2743)] = 107732,
  [SMALL_STATE(2744)] = 107745,
  [SMALL_STATE(2745)] = 107756,
  [SMALL_STATE(2746)] = 107769,
  [SMALL_STATE(2747)] = 107780,
  [SMALL_STATE(2748)] = 107791,
  [SMALL_STATE(2749)] = 107802,
  [SMALL_STATE(2750)] = 107813,
  [SMALL_STATE(2751)] = 107824,
  [SMALL_STATE(2752)] = 107835,
  [SMALL_STATE(2753)] = 107846,
  [SMALL_STATE(2754)] = 107859,
  [SMALL_STATE(2755)] = 107870,
  [SMALL_STATE(2756)] = 107883,
  [SMALL_STATE(2757)] = 107892,
  [SMALL_STATE(2758)] = 107903,
  [SMALL_STATE(2759)] = 107916,
  [SMALL_STATE(2760)] = 107929,
  [SMALL_STATE(2761)] = 107942,
  [SMALL_STATE(2762)] = 107951,
  [SMALL_STATE(2763)] = 107964,
  [SMALL_STATE(2764)] = 107977,
  [SMALL_STATE(2765)] = 107986,
  [SMALL_STATE(2766)] = 107999,
  [SMALL_STATE(2767)] = 108008,
  [SMALL_STATE(2768)] = 108017,
  [SMALL_STATE(2769)] = 108030,
  [SMALL_STATE(2770)] = 108039,
  [SMALL_STATE(2771)] = 108052,
  [SMALL_STATE(2772)] = 108061,
  [SMALL_STATE(2773)] = 108074,
  [SMALL_STATE(2774)] = 108087,
  [SMALL_STATE(2775)] = 108100,
  [SMALL_STATE(2776)] = 108113,
  [SMALL_STATE(2777)] = 108126,
  [SMALL_STATE(2778)] = 108135,
  [SMALL_STATE(2779)] = 108144,
  [SMALL_STATE(2780)] = 108153,
  [SMALL_STATE(2781)] = 108162,
  [SMALL_STATE(2782)] = 108171,
  [SMALL_STATE(2783)] = 108180,
  [SMALL_STATE(2784)] = 108189,
  [SMALL_STATE(2785)] = 108202,
  [SMALL_STATE(2786)] = 108211,
  [SMALL_STATE(2787)] = 108224,
  [SMALL_STATE(2788)] = 108233,
  [SMALL_STATE(2789)] = 108246,
  [SMALL_STATE(2790)] = 108255,
  [SMALL_STATE(2791)] = 108264,
  [SMALL_STATE(2792)] = 108273,
  [SMALL_STATE(2793)] = 108286,
  [SMALL_STATE(2794)] = 108295,
  [SMALL_STATE(2795)] = 108304,
  [SMALL_STATE(2796)] = 108317,
  [SMALL_STATE(2797)] = 108330,
  [SMALL_STATE(2798)] = 108341,
  [SMALL_STATE(2799)] = 108354,
  [SMALL_STATE(2800)] = 108367,
  [SMALL_STATE(2801)] = 108376,
  [SMALL_STATE(2802)] = 108385,
  [SMALL_STATE(2803)] = 108394,
  [SMALL_STATE(2804)] = 108407,
  [SMALL_STATE(2805)] = 108416,
  [SMALL_STATE(2806)] = 108429,
  [SMALL_STATE(2807)] = 108442,
  [SMALL_STATE(2808)] = 108455,
  [SMALL_STATE(2809)] = 108464,
  [SMALL_STATE(2810)] = 108473,
  [SMALL_STATE(2811)] = 108486,
  [SMALL_STATE(2812)] = 108499,
  [SMALL_STATE(2813)] = 108512,
  [SMALL_STATE(2814)] = 108525,
  [SMALL_STATE(2815)] = 108534,
  [SMALL_STATE(2816)] = 108543,
  [SMALL_STATE(2817)] = 108552,
  [SMALL_STATE(2818)] = 108565,
  [SMALL_STATE(2819)] = 108578,
  [SMALL_STATE(2820)] = 108591,
  [SMALL_STATE(2821)] = 108604,
  [SMALL_STATE(2822)] = 108617,
  [SMALL_STATE(2823)] = 108630,
  [SMALL_STATE(2824)] = 108643,
  [SMALL_STATE(2825)] = 108656,
  [SMALL_STATE(2826)] = 108665,
  [SMALL_STATE(2827)] = 108678,
  [SMALL_STATE(2828)] = 108687,
  [SMALL_STATE(2829)] = 108696,
  [SMALL_STATE(2830)] = 108705,
  [SMALL_STATE(2831)] = 108714,
  [SMALL_STATE(2832)] = 108723,
  [SMALL_STATE(2833)] = 108736,
  [SMALL_STATE(2834)] = 108749,
  [SMALL_STATE(2835)] = 108758,
  [SMALL_STATE(2836)] = 108771,
  [SMALL_STATE(2837)] = 108784,
  [SMALL_STATE(2838)] = 108797,
  [SMALL_STATE(2839)] = 108806,
  [SMALL_STATE(2840)] = 108815,
  [SMALL_STATE(2841)] = 108828,
  [SMALL_STATE(2842)] = 108841,
  [SMALL_STATE(2843)] = 108854,
  [SMALL_STATE(2844)] = 108867,
  [SMALL_STATE(2845)] = 108876,
  [SMALL_STATE(2846)] = 108889,
  [SMALL_STATE(2847)] = 108898,
  [SMALL_STATE(2848)] = 108911,
  [SMALL_STATE(2849)] = 108924,
  [SMALL_STATE(2850)] = 108937,
  [SMALL_STATE(2851)] = 108950,
  [SMALL_STATE(2852)] = 108963,
  [SMALL_STATE(2853)] = 108976,
  [SMALL_STATE(2854)] = 108989,
  [SMALL_STATE(2855)] = 108998,
  [SMALL_STATE(2856)] = 109007,
  [SMALL_STATE(2857)] = 109016,
  [SMALL_STATE(2858)] = 109025,
  [SMALL_STATE(2859)] = 109038,
  [SMALL_STATE(2860)] = 109051,
  [SMALL_STATE(2861)] = 109064,
  [SMALL_STATE(2862)] = 109077,
  [SMALL_STATE(2863)] = 109090,
  [SMALL_STATE(2864)] = 109103,
  [SMALL_STATE(2865)] = 109116,
  [SMALL_STATE(2866)] = 109129,
  [SMALL_STATE(2867)] = 109138,
  [SMALL_STATE(2868)] = 109151,
  [SMALL_STATE(2869)] = 109164,
  [SMALL_STATE(2870)] = 109177,
  [SMALL_STATE(2871)] = 109190,
  [SMALL_STATE(2872)] = 109203,
  [SMALL_STATE(2873)] = 109216,
  [SMALL_STATE(2874)] = 109225,
  [SMALL_STATE(2875)] = 109238,
  [SMALL_STATE(2876)] = 109247,
  [SMALL_STATE(2877)] = 109260,
  [SMALL_STATE(2878)] = 109273,
  [SMALL_STATE(2879)] = 109286,
  [SMALL_STATE(2880)] = 109295,
  [SMALL_STATE(2881)] = 109308,
  [SMALL_STATE(2882)] = 109321,
  [SMALL_STATE(2883)] = 109334,
  [SMALL_STATE(2884)] = 109347,
  [SMALL_STATE(2885)] = 109360,
  [SMALL_STATE(2886)] = 109373,
  [SMALL_STATE(2887)] = 109382,
  [SMALL_STATE(2888)] = 109391,
  [SMALL_STATE(2889)] = 109404,
  [SMALL_STATE(2890)] = 109417,
  [SMALL_STATE(2891)] = 109430,
  [SMALL_STATE(2892)] = 109439,
  [SMALL_STATE(2893)] = 109452,
  [SMALL_STATE(2894)] = 109465,
  [SMALL_STATE(2895)] = 109474,
  [SMALL_STATE(2896)] = 109487,
  [SMALL_STATE(2897)] = 109500,
  [SMALL_STATE(2898)] = 109513,
  [SMALL_STATE(2899)] = 109526,
  [SMALL_STATE(2900)] = 109539,
  [SMALL_STATE(2901)] = 109552,
  [SMALL_STATE(2902)] = 109561,
  [SMALL_STATE(2903)] = 109574,
  [SMALL_STATE(2904)] = 109585,
  [SMALL_STATE(2905)] = 109598,
  [SMALL_STATE(2906)] = 109607,
  [SMALL_STATE(2907)] = 109620,
  [SMALL_STATE(2908)] = 109633,
  [SMALL_STATE(2909)] = 109642,
  [SMALL_STATE(2910)] = 109655,
  [SMALL_STATE(2911)] = 109668,
  [SMALL_STATE(2912)] = 109681,
  [SMALL_STATE(2913)] = 109692,
  [SMALL_STATE(2914)] = 109705,
  [SMALL_STATE(2915)] = 109718,
  [SMALL_STATE(2916)] = 109731,
  [SMALL_STATE(2917)] = 109744,
  [SMALL_STATE(2918)] = 109753,
  [SMALL_STATE(2919)] = 109766,
  [SMALL_STATE(2920)] = 109779,
  [SMALL_STATE(2921)] = 109792,
  [SMALL_STATE(2922)] = 109801,
  [SMALL_STATE(2923)] = 109814,
  [SMALL_STATE(2924)] = 109827,
  [SMALL_STATE(2925)] = 109840,
  [SMALL_STATE(2926)] = 109853,
  [SMALL_STATE(2927)] = 109866,
  [SMALL_STATE(2928)] = 109879,
  [SMALL_STATE(2929)] = 109888,
  [SMALL_STATE(2930)] = 109901,
  [SMALL_STATE(2931)] = 109912,
  [SMALL_STATE(2932)] = 109921,
  [SMALL_STATE(2933)] = 109930,
  [SMALL_STATE(2934)] = 109943,
  [SMALL_STATE(2935)] = 109956,
  [SMALL_STATE(2936)] = 109965,
  [SMALL_STATE(2937)] = 109974,
  [SMALL_STATE(2938)] = 109983,
  [SMALL_STATE(2939)] = 109996,
  [SMALL_STATE(2940)] = 110005,
  [SMALL_STATE(2941)] = 110018,
  [SMALL_STATE(2942)] = 110027,
  [SMALL_STATE(2943)] = 110036,
  [SMALL_STATE(2944)] = 110046,
  [SMALL_STATE(2945)] = 110056,
  [SMALL_STATE(2946)] = 110064,
  [SMALL_STATE(2947)] = 110074,
  [SMALL_STATE(2948)] = 110084,
  [SMALL_STATE(2949)] = 110094,
  [SMALL_STATE(2950)] = 110104,
  [SMALL_STATE(2951)] = 110114,
  [SMALL_STATE(2952)] = 110122,
  [SMALL_STATE(2953)] = 110130,
  [SMALL_STATE(2954)] = 110138,
  [SMALL_STATE(2955)] = 110148,
  [SMALL_STATE(2956)] = 110158,
  [SMALL_STATE(2957)] = 110166,
  [SMALL_STATE(2958)] = 110176,
  [SMALL_STATE(2959)] = 110186,
  [SMALL_STATE(2960)] = 110196,
  [SMALL_STATE(2961)] = 110206,
  [SMALL_STATE(2962)] = 110216,
  [SMALL_STATE(2963)] = 110224,
  [SMALL_STATE(2964)] = 110232,
  [SMALL_STATE(2965)] = 110242,
  [SMALL_STATE(2966)] = 110250,
  [SMALL_STATE(2967)] = 110260,
  [SMALL_STATE(2968)] = 110270,
  [SMALL_STATE(2969)] = 110280,
  [SMALL_STATE(2970)] = 110288,
  [SMALL_STATE(2971)] = 110296,
  [SMALL_STATE(2972)] = 110304,
  [SMALL_STATE(2973)] = 110314,
  [SMALL_STATE(2974)] = 110324,
  [SMALL_STATE(2975)] = 110334,
  [SMALL_STATE(2976)] = 110344,
  [SMALL_STATE(2977)] = 110354,
  [SMALL_STATE(2978)] = 110364,
  [SMALL_STATE(2979)] = 110374,
  [SMALL_STATE(2980)] = 110382,
  [SMALL_STATE(2981)] = 110390,
  [SMALL_STATE(2982)] = 110398,
  [SMALL_STATE(2983)] = 110408,
  [SMALL_STATE(2984)] = 110418,
  [SMALL_STATE(2985)] = 110426,
  [SMALL_STATE(2986)] = 110436,
  [SMALL_STATE(2987)] = 110446,
  [SMALL_STATE(2988)] = 110454,
  [SMALL_STATE(2989)] = 110464,
  [SMALL_STATE(2990)] = 110474,
  [SMALL_STATE(2991)] = 110484,
  [SMALL_STATE(2992)] = 110492,
  [SMALL_STATE(2993)] = 110502,
  [SMALL_STATE(2994)] = 110510,
  [SMALL_STATE(2995)] = 110520,
  [SMALL_STATE(2996)] = 110530,
  [SMALL_STATE(2997)] = 110540,
  [SMALL_STATE(2998)] = 110550,
  [SMALL_STATE(2999)] = 110560,
  [SMALL_STATE(3000)] = 110570,
  [SMALL_STATE(3001)] = 110578,
  [SMALL_STATE(3002)] = 110588,
  [SMALL_STATE(3003)] = 110598,
  [SMALL_STATE(3004)] = 110608,
  [SMALL_STATE(3005)] = 110618,
  [SMALL_STATE(3006)] = 110628,
  [SMALL_STATE(3007)] = 110636,
  [SMALL_STATE(3008)] = 110646,
  [SMALL_STATE(3009)] = 110656,
  [SMALL_STATE(3010)] = 110666,
  [SMALL_STATE(3011)] = 110674,
  [SMALL_STATE(3012)] = 110684,
  [SMALL_STATE(3013)] = 110694,
  [SMALL_STATE(3014)] = 110702,
  [SMALL_STATE(3015)] = 110710,
  [SMALL_STATE(3016)] = 110720,
  [SMALL_STATE(3017)] = 110730,
  [SMALL_STATE(3018)] = 110738,
  [SMALL_STATE(3019)] = 110746,
  [SMALL_STATE(3020)] = 110756,
  [SMALL_STATE(3021)] = 110766,
  [SMALL_STATE(3022)] = 110776,
  [SMALL_STATE(3023)] = 110786,
  [SMALL_STATE(3024)] = 110796,
  [SMALL_STATE(3025)] = 110804,
  [SMALL_STATE(3026)] = 110814,
  [SMALL_STATE(3027)] = 110824,
  [SMALL_STATE(3028)] = 110834,
  [SMALL_STATE(3029)] = 110844,
  [SMALL_STATE(3030)] = 110854,
  [SMALL_STATE(3031)] = 110864,
  [SMALL_STATE(3032)] = 110874,
  [SMALL_STATE(3033)] = 110882,
  [SMALL_STATE(3034)] = 110892,
  [SMALL_STATE(3035)] = 110900,
  [SMALL_STATE(3036)] = 110910,
  [SMALL_STATE(3037)] = 110918,
  [SMALL_STATE(3038)] = 110928,
  [SMALL_STATE(3039)] = 110936,
  [SMALL_STATE(3040)] = 110946,
  [SMALL_STATE(3041)] = 110956,
  [SMALL_STATE(3042)] = 110966,
  [SMALL_STATE(3043)] = 110974,
  [SMALL_STATE(3044)] = 110984,
  [SMALL_STATE(3045)] = 110994,
  [SMALL_STATE(3046)] = 111004,
  [SMALL_STATE(3047)] = 111012,
  [SMALL_STATE(3048)] = 111022,
  [SMALL_STATE(3049)] = 111032,
  [SMALL_STATE(3050)] = 111040,
  [SMALL_STATE(3051)] = 111048,
  [SMALL_STATE(3052)] = 111056,
  [SMALL_STATE(3053)] = 111066,
  [SMALL_STATE(3054)] = 111074,
  [SMALL_STATE(3055)] = 111082,
  [SMALL_STATE(3056)] = 111092,
  [SMALL_STATE(3057)] = 111102,
  [SMALL_STATE(3058)] = 111112,
  [SMALL_STATE(3059)] = 111122,
  [SMALL_STATE(3060)] = 111130,
  [SMALL_STATE(3061)] = 111140,
  [SMALL_STATE(3062)] = 111150,
  [SMALL_STATE(3063)] = 111158,
  [SMALL_STATE(3064)] = 111168,
  [SMALL_STATE(3065)] = 111178,
  [SMALL_STATE(3066)] = 111186,
  [SMALL_STATE(3067)] = 111194,
  [SMALL_STATE(3068)] = 111204,
  [SMALL_STATE(3069)] = 111212,
  [SMALL_STATE(3070)] = 111222,
  [SMALL_STATE(3071)] = 111232,
  [SMALL_STATE(3072)] = 111242,
  [SMALL_STATE(3073)] = 111250,
  [SMALL_STATE(3074)] = 111258,
  [SMALL_STATE(3075)] = 111266,
  [SMALL_STATE(3076)] = 111276,
  [SMALL_STATE(3077)] = 111284,
  [SMALL_STATE(3078)] = 111292,
  [SMALL_STATE(3079)] = 111300,
  [SMALL_STATE(3080)] = 111310,
  [SMALL_STATE(3081)] = 111320,
  [SMALL_STATE(3082)] = 111330,
  [SMALL_STATE(3083)] = 111340,
  [SMALL_STATE(3084)] = 111350,
  [SMALL_STATE(3085)] = 111360,
  [SMALL_STATE(3086)] = 111370,
  [SMALL_STATE(3087)] = 111380,
  [SMALL_STATE(3088)] = 111390,
  [SMALL_STATE(3089)] = 111400,
  [SMALL_STATE(3090)] = 111410,
  [SMALL_STATE(3091)] = 111420,
  [SMALL_STATE(3092)] = 111430,
  [SMALL_STATE(3093)] = 111440,
  [SMALL_STATE(3094)] = 111448,
  [SMALL_STATE(3095)] = 111458,
  [SMALL_STATE(3096)] = 111468,
  [SMALL_STATE(3097)] = 111476,
  [SMALL_STATE(3098)] = 111486,
  [SMALL_STATE(3099)] = 111496,
  [SMALL_STATE(3100)] = 111506,
  [SMALL_STATE(3101)] = 111516,
  [SMALL_STATE(3102)] = 111524,
  [SMALL_STATE(3103)] = 111534,
  [SMALL_STATE(3104)] = 111544,
  [SMALL_STATE(3105)] = 111554,
  [SMALL_STATE(3106)] = 111564,
  [SMALL_STATE(3107)] = 111574,
  [SMALL_STATE(3108)] = 111584,
  [SMALL_STATE(3109)] = 111594,
  [SMALL_STATE(3110)] = 111604,
  [SMALL_STATE(3111)] = 111614,
  [SMALL_STATE(3112)] = 111624,
  [SMALL_STATE(3113)] = 111634,
  [SMALL_STATE(3114)] = 111644,
  [SMALL_STATE(3115)] = 111654,
  [SMALL_STATE(3116)] = 111664,
  [SMALL_STATE(3117)] = 111674,
  [SMALL_STATE(3118)] = 111684,
  [SMALL_STATE(3119)] = 111694,
  [SMALL_STATE(3120)] = 111704,
  [SMALL_STATE(3121)] = 111714,
  [SMALL_STATE(3122)] = 111724,
  [SMALL_STATE(3123)] = 111734,
  [SMALL_STATE(3124)] = 111742,
  [SMALL_STATE(3125)] = 111752,
  [SMALL_STATE(3126)] = 111762,
  [SMALL_STATE(3127)] = 111772,
  [SMALL_STATE(3128)] = 111782,
  [SMALL_STATE(3129)] = 111790,
  [SMALL_STATE(3130)] = 111800,
  [SMALL_STATE(3131)] = 111808,
  [SMALL_STATE(3132)] = 111816,
  [SMALL_STATE(3133)] = 111826,
  [SMALL_STATE(3134)] = 111834,
  [SMALL_STATE(3135)] = 111844,
  [SMALL_STATE(3136)] = 111854,
  [SMALL_STATE(3137)] = 111864,
  [SMALL_STATE(3138)] = 111874,
  [SMALL_STATE(3139)] = 111884,
  [SMALL_STATE(3140)] = 111894,
  [SMALL_STATE(3141)] = 111904,
  [SMALL_STATE(3142)] = 111914,
  [SMALL_STATE(3143)] = 111924,
  [SMALL_STATE(3144)] = 111932,
  [SMALL_STATE(3145)] = 111942,
  [SMALL_STATE(3146)] = 111950,
  [SMALL_STATE(3147)] = 111960,
  [SMALL_STATE(3148)] = 111970,
  [SMALL_STATE(3149)] = 111980,
  [SMALL_STATE(3150)] = 111990,
  [SMALL_STATE(3151)] = 112000,
  [SMALL_STATE(3152)] = 112010,
  [SMALL_STATE(3153)] = 112020,
  [SMALL_STATE(3154)] = 112030,
  [SMALL_STATE(3155)] = 112040,
  [SMALL_STATE(3156)] = 112050,
  [SMALL_STATE(3157)] = 112060,
  [SMALL_STATE(3158)] = 112070,
  [SMALL_STATE(3159)] = 112078,
  [SMALL_STATE(3160)] = 112088,
  [SMALL_STATE(3161)] = 112098,
  [SMALL_STATE(3162)] = 112108,
  [SMALL_STATE(3163)] = 112118,
  [SMALL_STATE(3164)] = 112128,
  [SMALL_STATE(3165)] = 112138,
  [SMALL_STATE(3166)] = 112148,
  [SMALL_STATE(3167)] = 112158,
  [SMALL_STATE(3168)] = 112168,
  [SMALL_STATE(3169)] = 112178,
  [SMALL_STATE(3170)] = 112188,
  [SMALL_STATE(3171)] = 112198,
  [SMALL_STATE(3172)] = 112208,
  [SMALL_STATE(3173)] = 112218,
  [SMALL_STATE(3174)] = 112226,
  [SMALL_STATE(3175)] = 112236,
  [SMALL_STATE(3176)] = 112246,
  [SMALL_STATE(3177)] = 112253,
  [SMALL_STATE(3178)] = 112260,
  [SMALL_STATE(3179)] = 112267,
  [SMALL_STATE(3180)] = 112274,
  [SMALL_STATE(3181)] = 112281,
  [SMALL_STATE(3182)] = 112288,
  [SMALL_STATE(3183)] = 112295,
  [SMALL_STATE(3184)] = 112302,
  [SMALL_STATE(3185)] = 112309,
  [SMALL_STATE(3186)] = 112316,
  [SMALL_STATE(3187)] = 112323,
  [SMALL_STATE(3188)] = 112330,
  [SMALL_STATE(3189)] = 112337,
  [SMALL_STATE(3190)] = 112344,
  [SMALL_STATE(3191)] = 112351,
  [SMALL_STATE(3192)] = 112358,
  [SMALL_STATE(3193)] = 112365,
  [SMALL_STATE(3194)] = 112372,
  [SMALL_STATE(3195)] = 112379,
  [SMALL_STATE(3196)] = 112386,
  [SMALL_STATE(3197)] = 112393,
  [SMALL_STATE(3198)] = 112400,
  [SMALL_STATE(3199)] = 112407,
  [SMALL_STATE(3200)] = 112414,
  [SMALL_STATE(3201)] = 112421,
  [SMALL_STATE(3202)] = 112428,
  [SMALL_STATE(3203)] = 112435,
  [SMALL_STATE(3204)] = 112442,
  [SMALL_STATE(3205)] = 112449,
  [SMALL_STATE(3206)] = 112456,
  [SMALL_STATE(3207)] = 112463,
  [SMALL_STATE(3208)] = 112470,
  [SMALL_STATE(3209)] = 112477,
  [SMALL_STATE(3210)] = 112484,
  [SMALL_STATE(3211)] = 112491,
  [SMALL_STATE(3212)] = 112498,
  [SMALL_STATE(3213)] = 112505,
  [SMALL_STATE(3214)] = 112512,
  [SMALL_STATE(3215)] = 112519,
  [SMALL_STATE(3216)] = 112526,
  [SMALL_STATE(3217)] = 112533,
  [SMALL_STATE(3218)] = 112540,
  [SMALL_STATE(3219)] = 112547,
  [SMALL_STATE(3220)] = 112554,
  [SMALL_STATE(3221)] = 112561,
  [SMALL_STATE(3222)] = 112568,
  [SMALL_STATE(3223)] = 112575,
  [SMALL_STATE(3224)] = 112582,
  [SMALL_STATE(3225)] = 112589,
  [SMALL_STATE(3226)] = 112596,
  [SMALL_STATE(3227)] = 112603,
  [SMALL_STATE(3228)] = 112610,
  [SMALL_STATE(3229)] = 112617,
  [SMALL_STATE(3230)] = 112624,
  [SMALL_STATE(3231)] = 112631,
  [SMALL_STATE(3232)] = 112638,
  [SMALL_STATE(3233)] = 112645,
  [SMALL_STATE(3234)] = 112652,
  [SMALL_STATE(3235)] = 112659,
  [SMALL_STATE(3236)] = 112666,
  [SMALL_STATE(3237)] = 112673,
  [SMALL_STATE(3238)] = 112680,
  [SMALL_STATE(3239)] = 112687,
  [SMALL_STATE(3240)] = 112694,
  [SMALL_STATE(3241)] = 112701,
  [SMALL_STATE(3242)] = 112708,
  [SMALL_STATE(3243)] = 112715,
  [SMALL_STATE(3244)] = 112722,
  [SMALL_STATE(3245)] = 112729,
  [SMALL_STATE(3246)] = 112736,
  [SMALL_STATE(3247)] = 112743,
  [SMALL_STATE(3248)] = 112750,
  [SMALL_STATE(3249)] = 112757,
  [SMALL_STATE(3250)] = 112764,
  [SMALL_STATE(3251)] = 112771,
  [SMALL_STATE(3252)] = 112778,
  [SMALL_STATE(3253)] = 112785,
  [SMALL_STATE(3254)] = 112792,
  [SMALL_STATE(3255)] = 112799,
  [SMALL_STATE(3256)] = 112806,
  [SMALL_STATE(3257)] = 112813,
  [SMALL_STATE(3258)] = 112820,
  [SMALL_STATE(3259)] = 112827,
  [SMALL_STATE(3260)] = 112834,
  [SMALL_STATE(3261)] = 112841,
  [SMALL_STATE(3262)] = 112848,
  [SMALL_STATE(3263)] = 112855,
  [SMALL_STATE(3264)] = 112862,
  [SMALL_STATE(3265)] = 112869,
  [SMALL_STATE(3266)] = 112876,
  [SMALL_STATE(3267)] = 112883,
  [SMALL_STATE(3268)] = 112890,
  [SMALL_STATE(3269)] = 112897,
  [SMALL_STATE(3270)] = 112904,
  [SMALL_STATE(3271)] = 112911,
  [SMALL_STATE(3272)] = 112918,
  [SMALL_STATE(3273)] = 112925,
  [SMALL_STATE(3274)] = 112932,
  [SMALL_STATE(3275)] = 112939,
  [SMALL_STATE(3276)] = 112946,
  [SMALL_STATE(3277)] = 112953,
  [SMALL_STATE(3278)] = 112960,
  [SMALL_STATE(3279)] = 112967,
  [SMALL_STATE(3280)] = 112974,
  [SMALL_STATE(3281)] = 112981,
  [SMALL_STATE(3282)] = 112988,
  [SMALL_STATE(3283)] = 112995,
  [SMALL_STATE(3284)] = 113002,
  [SMALL_STATE(3285)] = 113009,
  [SMALL_STATE(3286)] = 113016,
  [SMALL_STATE(3287)] = 113023,
  [SMALL_STATE(3288)] = 113030,
  [SMALL_STATE(3289)] = 113037,
  [SMALL_STATE(3290)] = 113044,
  [SMALL_STATE(3291)] = 113051,
  [SMALL_STATE(3292)] = 113058,
  [SMALL_STATE(3293)] = 113065,
  [SMALL_STATE(3294)] = 113072,
  [SMALL_STATE(3295)] = 113079,
  [SMALL_STATE(3296)] = 113086,
  [SMALL_STATE(3297)] = 113093,
  [SMALL_STATE(3298)] = 113100,
  [SMALL_STATE(3299)] = 113107,
  [SMALL_STATE(3300)] = 113114,
  [SMALL_STATE(3301)] = 113121,
  [SMALL_STATE(3302)] = 113128,
  [SMALL_STATE(3303)] = 113135,
  [SMALL_STATE(3304)] = 113142,
  [SMALL_STATE(3305)] = 113149,
  [SMALL_STATE(3306)] = 113156,
  [SMALL_STATE(3307)] = 113163,
  [SMALL_STATE(3308)] = 113170,
  [SMALL_STATE(3309)] = 113177,
  [SMALL_STATE(3310)] = 113184,
  [SMALL_STATE(3311)] = 113191,
  [SMALL_STATE(3312)] = 113198,
  [SMALL_STATE(3313)] = 113205,
  [SMALL_STATE(3314)] = 113212,
  [SMALL_STATE(3315)] = 113219,
  [SMALL_STATE(3316)] = 113226,
  [SMALL_STATE(3317)] = 113233,
  [SMALL_STATE(3318)] = 113240,
  [SMALL_STATE(3319)] = 113247,
  [SMALL_STATE(3320)] = 113254,
  [SMALL_STATE(3321)] = 113261,
  [SMALL_STATE(3322)] = 113268,
  [SMALL_STATE(3323)] = 113275,
  [SMALL_STATE(3324)] = 113282,
  [SMALL_STATE(3325)] = 113289,
  [SMALL_STATE(3326)] = 113296,
  [SMALL_STATE(3327)] = 113303,
  [SMALL_STATE(3328)] = 113310,
  [SMALL_STATE(3329)] = 113317,
  [SMALL_STATE(3330)] = 113324,
  [SMALL_STATE(3331)] = 113331,
  [SMALL_STATE(3332)] = 113338,
  [SMALL_STATE(3333)] = 113345,
  [SMALL_STATE(3334)] = 113352,
  [SMALL_STATE(3335)] = 113359,
  [SMALL_STATE(3336)] = 113366,
  [SMALL_STATE(3337)] = 113373,
  [SMALL_STATE(3338)] = 113380,
  [SMALL_STATE(3339)] = 113387,
  [SMALL_STATE(3340)] = 113394,
  [SMALL_STATE(3341)] = 113401,
  [SMALL_STATE(3342)] = 113408,
  [SMALL_STATE(3343)] = 113415,
  [SMALL_STATE(3344)] = 113422,
  [SMALL_STATE(3345)] = 113429,
  [SMALL_STATE(3346)] = 113436,
  [SMALL_STATE(3347)] = 113443,
  [SMALL_STATE(3348)] = 113450,
  [SMALL_STATE(3349)] = 113457,
  [SMALL_STATE(3350)] = 113464,
  [SMALL_STATE(3351)] = 113471,
  [SMALL_STATE(3352)] = 113478,
  [SMALL_STATE(3353)] = 113485,
  [SMALL_STATE(3354)] = 113492,
  [SMALL_STATE(3355)] = 113499,
  [SMALL_STATE(3356)] = 113506,
  [SMALL_STATE(3357)] = 113513,
  [SMALL_STATE(3358)] = 113520,
  [SMALL_STATE(3359)] = 113527,
  [SMALL_STATE(3360)] = 113534,
  [SMALL_STATE(3361)] = 113541,
  [SMALL_STATE(3362)] = 113548,
  [SMALL_STATE(3363)] = 113555,
  [SMALL_STATE(3364)] = 113562,
  [SMALL_STATE(3365)] = 113569,
  [SMALL_STATE(3366)] = 113576,
  [SMALL_STATE(3367)] = 113583,
  [SMALL_STATE(3368)] = 113590,
  [SMALL_STATE(3369)] = 113597,
  [SMALL_STATE(3370)] = 113604,
  [SMALL_STATE(3371)] = 113611,
  [SMALL_STATE(3372)] = 113618,
  [SMALL_STATE(3373)] = 113625,
  [SMALL_STATE(3374)] = 113632,
  [SMALL_STATE(3375)] = 113639,
  [SMALL_STATE(3376)] = 113646,
  [SMALL_STATE(3377)] = 113653,
  [SMALL_STATE(3378)] = 113660,
  [SMALL_STATE(3379)] = 113667,
  [SMALL_STATE(3380)] = 113674,
  [SMALL_STATE(3381)] = 113681,
  [SMALL_STATE(3382)] = 113688,
  [SMALL_STATE(3383)] = 113695,
  [SMALL_STATE(3384)] = 113702,
  [SMALL_STATE(3385)] = 113709,
  [SMALL_STATE(3386)] = 113716,
  [SMALL_STATE(3387)] = 113723,
  [SMALL_STATE(3388)] = 113730,
  [SMALL_STATE(3389)] = 113737,
  [SMALL_STATE(3390)] = 113744,
  [SMALL_STATE(3391)] = 113751,
  [SMALL_STATE(3392)] = 113758,
  [SMALL_STATE(3393)] = 113765,
  [SMALL_STATE(3394)] = 113772,
  [SMALL_STATE(3395)] = 113779,
  [SMALL_STATE(3396)] = 113786,
  [SMALL_STATE(3397)] = 113793,
  [SMALL_STATE(3398)] = 113800,
  [SMALL_STATE(3399)] = 113807,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(923),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(218),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(697),
  [214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(274),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(896),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3332),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(413),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(696),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1035),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2165),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3393),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2357),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2353),
  [247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(308),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2954),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2955),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2739),
  [259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(109),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(325),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2957),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2958),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2959),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2740),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2741),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2962),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(151),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(190),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(506),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(61),
  [298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(129),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2101),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(531),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2172),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3380),
  [313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(925),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(194),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(388),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3379),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(720),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(397),
  [331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(399),
  [334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2718),
  [337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2968),
  [340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2338),
  [343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1601),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1601),
  [349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2745),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 87),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 87),
  [364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 87),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 87),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(323),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3252),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 123),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 123),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 162),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 162),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 162),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 162),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 135),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 135),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 135),
  [1004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 135),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 135),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 135),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 135),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 135),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 31),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 31),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 31),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 31),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 116),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 116),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 116),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 116),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 29),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 29),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 84),
  [1054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 84),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 84),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 84),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 164),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 164),
  [1066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 164),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 164),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 83),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 83),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 83),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 83),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 141),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 141),
  [1090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 141),
  [1092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 141),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 142),
  [1102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 142),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 142),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 142),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1),
  [1118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 108),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 108),
  [1130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 108),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 108),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [1268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(44),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [1281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [1294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3360),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [1481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1975),
  [1484] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1892),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [1494] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3027),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 113),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 113),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 17),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 17),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 18),
  [1536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 18),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 2),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 2),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [1548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [1550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [1562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 9),
  [1572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 9),
  [1574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 4),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 4),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4),
  [1582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4),
  [1586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number_lit, 1),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number_lit, 1),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 1),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 1),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 3),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 3),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 17),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 17),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 17), SHIFT(769),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [1699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [1701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1), SHIFT(769),
  [1704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 113),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 14),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 14),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 194),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 194),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 6, .production_id = 148),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 6, .production_id = 148),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [1747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 47),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 47),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [1771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 14),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 14),
  [1779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1892),
  [1782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(3027),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 174),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 174),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 39),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 39),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 173),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 173),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 175),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 175),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 50),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 50),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 92),
  [1837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 92),
  [1839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 50),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 50),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 86),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 86),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 48),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 48),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3186),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 46),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 46),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 41),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 41),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 84),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 84),
  [1903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 83),
  [1905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 83),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 122),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 122),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 123),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 123),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 109),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 109),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 40),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 40),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 124),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 124),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 38),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 38),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 31),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 31),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 107),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 107),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 127),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 127),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 184),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 184),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 83),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 83),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 84),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 84),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 134),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 134),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 108),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 108),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 136),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 136),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 137),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 137),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 26),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 26),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 140),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 140),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 116),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 116),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 144),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 144),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 93),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 93),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 31),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 31),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 164),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 164),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 162),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 162),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 147),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 147),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 151),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 151),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 172),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 172),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 100),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 100),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 14),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 14),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 123),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 123),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 135),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 135),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 135),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 135),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 49),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 49),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 163),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 163),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 141),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 141),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 142),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 142),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 165),
  [2127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 165),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 166),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 166),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 71),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 71),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3255),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3253),
  [2145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(170),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(162),
  [2166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 170),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 170),
  [2170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 149),
  [2172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 149),
  [2174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 171),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 171),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4),
  [2182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 153),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 153),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 152),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 152),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 169),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 169),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 168),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 168),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 150),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 150),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 42),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 17),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 17),
  [2548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(769),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [2573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(830),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 61),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 61),
  [2588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 61),
  [2591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 61),
  [2594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 61), REDUCE(sym_nested_type_identifier, 3, .production_id = 113),
  [2597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 61), REDUCE(sym_nested_type_identifier, 3, .production_id = 113),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [2612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(220),
  [2639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(220),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 78),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 78),
  [2654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 120),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 120),
  [2658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [2666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 114),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 114),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 138),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 138),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [2708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(755),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [2715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1), SHIFT(404),
  [2718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [2723] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 17),
  [2727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [2754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [2756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [2760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__rest_identifier, 2),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rest_identifier, 2),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2767] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1),
  [2773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(170),
  [2776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(169),
  [2779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(169),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [2786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__tuple_type_identifier, 1),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_identifier, 1),
  [2791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(2801),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [2824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(162),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [2903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [2913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 30),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [2924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 9),
  [2926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 9),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [2930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [2934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [2937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [2946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 17), SHIFT(766),
  [2949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(766),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [2960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 105),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [2994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(57),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9),
  [3035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 9),
  [3037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9), SHIFT(57),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 63),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 69),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 103),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 30),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 30),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 113),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [3075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__number_lit, 1),
  [3078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__number_lit, 1),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 67),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 58),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 58),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 106),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2066),
  [3134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1977),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(172),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1483),
  [3145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1962),
  [3148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1685),
  [3151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3221),
  [3154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2676),
  [3157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2004),
  [3160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2004),
  [3163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2745),
  [3166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1482),
  [3169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1686),
  [3172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1378),
  [3175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 139),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 63),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 30),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 30),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 103),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 67), REDUCE(sym_assignment_expression, 3, .production_id = 67),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 67),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [3274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [3300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 68), REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 68),
  [3305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 80), REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 80),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(221),
  [3317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(221),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [3322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 11),
  [3324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(222),
  [3327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(222),
  [3330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 80), REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 28),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 28),
  [3341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 115),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 115),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 20),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 20),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 2),
  [3365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 2),
  [3367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(53),
  [3370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 14),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 14),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [3378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2),
  [3410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 52),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 52),
  [3414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 53),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 53),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [3424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 54),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 54),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 117),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 117),
  [3450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 118),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 118),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [3466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 3),
  [3468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 3),
  [3470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 112),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 112),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 111),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 111),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 110),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 110),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 62),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 62),
  [3490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 104),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 104),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [3506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 106),
  [3508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 143),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 143),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [3526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [3528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9), SHIFT(53),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 66),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 66),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 69),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 72),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 72),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 79),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 79),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 105),
  [3563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 104),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 104),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 133),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 133),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 102),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 102),
  [3577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(58),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 87),
  [3586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 67),
  [3588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9), SHIFT(54),
  [3593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9), SHIFT(58),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 139),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [3612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 17), SHIFT(789),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 63),
  [3631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(789),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(54),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [3651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [3661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [3663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [3669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 59),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 59),
  [3681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [3693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [3709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [3727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [3745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 17), SHIFT(760),
  [3748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9), SHIFT(56),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [3759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(760),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1),
  [3788] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [3844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(52),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(56),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [3894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 9), SHIFT(52),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [3917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [3919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 81),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [3951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 13), SHIFT(348),
  [3960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 13),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 13),
  [3965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 13),
  [3968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(349),
  [3971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(241),
  [3994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(241),
  [3997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(247),
  [4000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(247),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [4023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 30),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [4029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 61),
  [4039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 61),
  [4041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 20),
  [4043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 20),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [4115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 162),
  [4117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 162),
  [4119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 195),
  [4121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 195),
  [4123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [4129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 196),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 196),
  [4133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 186),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 186),
  [4137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 200),
  [4139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 200),
  [4141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 167),
  [4143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 167),
  [4145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 108),
  [4147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 108),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [4151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 82),
  [4153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 82),
  [4155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 121),
  [4157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 121),
  [4159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 185),
  [4161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 185),
  [4163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 135),
  [4165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 135),
  [4167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 146),
  [4169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 146),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [4209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [4215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [4219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2745),
  [4222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [4268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 161),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [4274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 128),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [4286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 76),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 76),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [4306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 161),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 128),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 17), REDUCE(sym_type_parameter, 1, .production_id = 17),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [4325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 17), SHIFT(829),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 76),
  [4332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 128),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [4336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 76),
  [4338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 161),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 128),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 161),
  [4344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [4346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 17),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [4353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 8),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [4367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [4383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 22),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [4393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [4399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [4401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [4414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3),
  [4428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [4437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [4443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 126),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [4491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 6, .production_id = 126),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [4497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [4501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [4507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 202),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 199),
  [4511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 197),
  [4513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 189),
  [4515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 190),
  [4517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 181),
  [4519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 176),
  [4521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 17),
  [4523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 94),
  [4525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 99),
  [4527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 94),
  [4529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 154),
  [4531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 134),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [4535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [4545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [4547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 132),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 107),
  [4551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3),
  [4553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 99),
  [4555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [4565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [4567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 101),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [4579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 70),
  [4581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [4583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1041),
  [4638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [4646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2289),
  [4649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [4651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(255),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [4702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [4722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3313),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [4727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(171),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [4738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [4740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 130),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 183),
  [4834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 178),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 183),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [4842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 158),
  [4848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 156),
  [4850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [4858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 192),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [4862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 158),
  [4864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 42),
  [4866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6),
  [4868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 156),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 188),
  [4876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 33),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4),
  [4880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 192),
  [4882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [4884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 37),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 43),
  [4892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 44),
  [4894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [4900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [4902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 96),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [4908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 33),
  [4910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 60),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 201),
  [4916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 188),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 88),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 178),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [4946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 98),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 97),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 96),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 88),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [4968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 130),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(157),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [5027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [5029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [5031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [5057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2647),
  [5060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2647),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 17),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [5091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(146),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [5096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(131),
  [5099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [5105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2317),
  [5108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [5142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 17),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 1),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(853),
  [5175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [5183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [5197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [5215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 88),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [5219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 77),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [5237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [5239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [5241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [5247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 198),
  [5249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2869),
  [5252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [5256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 191),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [5262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [5264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3057),
  [5267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 193),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [5275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 189),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 187),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [5291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 182),
  [5293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 177),
  [5295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 176),
  [5297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 181),
  [5299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 180),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [5305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 179),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [5311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 157),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [5315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [5319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 155),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 134),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [5325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 160),
  [5335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_identifier, 2),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [5343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 154),
  [5345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1211),
  [5348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [5354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2847),
  [5357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3386),
  [5375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [5381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [5383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 36),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [5389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1961),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 159),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 32),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_identifier, 1),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 77),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [5488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2), SHIFT_REPEAT(2156),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2),
  [5493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [5497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 76),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 77),
  [5507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1947),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 131),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 91),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 90),
  [5564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 129),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 89),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 89),
  [5576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 107),
  [5578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 119),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 99),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [5614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [5622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 95),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 73),
  [5630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 95),
  [5632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 85),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 17),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 77),
  [5638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 145),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [5664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_tuple_type_member, 2),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 125),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [5690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 45),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 45),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [5740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 85),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3230),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [5776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 85),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [5960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [5990] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [5998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [6000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [6014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 85),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [6022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_ekscript_external_scanner_create(void);
void tree_sitter_ekscript_external_scanner_destroy(void *);
bool tree_sitter_ekscript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ekscript_external_scanner_serialize(void *, char *);
void tree_sitter_ekscript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ekscript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ekscript_external_scanner_create,
      tree_sitter_ekscript_external_scanner_destroy,
      tree_sitter_ekscript_external_scanner_scan,
      tree_sitter_ekscript_external_scanner_serialize,
      tree_sitter_ekscript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
